#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 2968
#define LARGE_STATE_COUNT 965
#define SYMBOL_COUNT 277
#define ALIAS_COUNT 6
#define TOKEN_COUNT 144
#define EXTERNAL_TOKEN_COUNT 22
#define FIELD_COUNT 22
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_identifier = 1,
  anon_sym___END__ = 2,
  sym_uninterpreted = 3,
  anon_sym_BEGIN = 4,
  anon_sym_LBRACE = 5,
  anon_sym_RBRACE = 6,
  anon_sym_END = 7,
  anon_sym_def = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_DOT = 11,
  anon_sym_COLON_COLON = 12,
  anon_sym_COMMA = 13,
  anon_sym_PIPE = 14,
  anon_sym_SEMI = 15,
  anon_sym_STAR = 16,
  anon_sym_STAR_STAR = 17,
  anon_sym_AMP = 18,
  anon_sym_COLON = 19,
  anon_sym_EQ = 20,
  anon_sym_class = 21,
  anon_sym_LT = 22,
  anon_sym_module = 23,
  anon_sym_end = 24,
  anon_sym_return = 25,
  anon_sym_yield = 26,
  anon_sym_break = 27,
  anon_sym_next = 28,
  anon_sym_redo = 29,
  anon_sym_retry = 30,
  anon_sym_if = 31,
  anon_sym_unless = 32,
  anon_sym_while = 33,
  anon_sym_until = 34,
  anon_sym_rescue = 35,
  anon_sym_for = 36,
  anon_sym_in = 37,
  anon_sym_do = 38,
  anon_sym_case = 39,
  anon_sym_when = 40,
  anon_sym_elsif = 41,
  anon_sym_else = 42,
  anon_sym_then = 43,
  anon_sym_begin = 44,
  anon_sym_ensure = 45,
  anon_sym_EQ_GT = 46,
  anon_sym_LBRACK = 47,
  anon_sym_RBRACK = 48,
  anon_sym_COLON_COLON2 = 49,
  anon_sym_AMP_DOT = 50,
  anon_sym_LPAREN2 = 51,
  anon_sym_PLUS_EQ = 52,
  anon_sym_DASH_EQ = 53,
  anon_sym_STAR_EQ = 54,
  anon_sym_STAR_STAR_EQ = 55,
  anon_sym_SLASH_EQ = 56,
  anon_sym_PIPE_PIPE_EQ = 57,
  anon_sym_PIPE_EQ = 58,
  anon_sym_AMP_AMP_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PERCENT_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_LT_LT_EQ = 63,
  anon_sym_CARET_EQ = 64,
  anon_sym_QMARK = 65,
  anon_sym_COLON2 = 66,
  anon_sym_DOT_DOT = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_and = 69,
  anon_sym_or = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_AMP_AMP = 72,
  anon_sym_LT_LT = 73,
  anon_sym_GT_GT = 74,
  anon_sym_LT_EQ = 75,
  anon_sym_GT = 76,
  anon_sym_GT_EQ = 77,
  anon_sym_CARET = 78,
  anon_sym_PLUS = 79,
  anon_sym_SLASH = 80,
  anon_sym_PERCENT = 81,
  anon_sym_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_EQ_EQ_EQ = 84,
  anon_sym_LT_EQ_GT = 85,
  anon_sym_EQ_TILDE = 86,
  anon_sym_BANG_TILDE = 87,
  anon_sym_defined_QMARK = 88,
  anon_sym_not = 89,
  anon_sym_BANG = 90,
  anon_sym_TILDE = 91,
  sym_constant = 92,
  sym_instance_variable = 93,
  sym_class_variable = 94,
  sym_global_variable = 95,
  anon_sym_DASH = 96,
  anon_sym_PLUS_AT = 97,
  anon_sym_DASH_AT = 98,
  anon_sym_LBRACK_RBRACK = 99,
  anon_sym_LBRACK_RBRACK_EQ = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_undef = 102,
  anon_sym_alias = 103,
  sym_comment = 104,
  sym_integer = 105,
  sym_float = 106,
  sym_complex = 107,
  anon_sym_r = 108,
  sym_super = 109,
  anon_sym_true = 110,
  anon_sym_TRUE = 111,
  anon_sym_false = 112,
  anon_sym_FALSE = 113,
  sym_self = 114,
  anon_sym_nil = 115,
  anon_sym_NIL = 116,
  sym_character = 117,
  anon_sym_POUND_LBRACE = 118,
  aux_sym_string_array_token1 = 119,
  sym_escape_sequence = 120,
  anon_sym_LBRACK2 = 121,
  anon_sym_DASH_GT = 122,
  sym__line_break = 123,
  sym__simple_symbol = 124,
  sym__string_start = 125,
  sym__symbol_start = 126,
  sym__subshell_start = 127,
  sym__regex_start = 128,
  sym__string_array_start = 129,
  sym__symbol_array_start = 130,
  sym__heredoc_body_start = 131,
  sym__string_content = 132,
  sym__heredoc_content = 133,
  sym__string_end = 134,
  sym_heredoc_end = 135,
  sym_heredoc_beginning = 136,
  sym__block_ampersand = 137,
  sym__splat_star = 138,
  sym__unary_minus = 139,
  sym__binary_minus = 140,
  sym__binary_star = 141,
  sym__singleton_class_left_angle_left_langle = 142,
  sym__identifier_hash_key = 143,
  sym_program = 144,
  sym__statements = 145,
  sym_begin_block = 146,
  sym_end_block = 147,
  sym__statement = 148,
  sym_method = 149,
  sym_singleton_method = 150,
  sym__method_rest = 151,
  sym_parameters = 152,
  sym_bare_parameters = 153,
  sym_block_parameters = 154,
  sym__formal_parameter = 155,
  sym__simple_formal_parameter = 156,
  sym_splat_parameter = 157,
  sym_hash_splat_parameter = 158,
  sym_block_parameter = 159,
  sym_keyword_parameter = 160,
  sym_optional_parameter = 161,
  sym_class = 162,
  sym_superclass = 163,
  sym_singleton_class = 164,
  sym_module = 165,
  sym_return_command = 166,
  sym_yield_command = 167,
  sym_break_command = 168,
  sym_next_command = 169,
  sym_return = 170,
  sym_yield = 171,
  sym_break = 172,
  sym_next = 173,
  sym_redo = 174,
  sym_retry = 175,
  sym_if_modifier = 176,
  sym_unless_modifier = 177,
  sym_while_modifier = 178,
  sym_until_modifier = 179,
  sym_rescue_modifier = 180,
  sym_while = 181,
  sym_until = 182,
  sym_for = 183,
  sym_in = 184,
  sym__do = 185,
  sym_case = 186,
  sym_when = 187,
  sym_pattern = 188,
  sym_if = 189,
  sym_unless = 190,
  sym_elsif = 191,
  sym_else = 192,
  sym_then = 193,
  sym_begin = 194,
  sym_ensure = 195,
  sym_rescue = 196,
  sym_exceptions = 197,
  sym_exception_variable = 198,
  sym__body_statement = 199,
  sym__expression = 200,
  sym__arg = 201,
  sym__primary = 202,
  sym_parenthesized_statements = 203,
  sym_element_reference = 204,
  sym_scope_resolution = 205,
  sym_call = 206,
  sym_command_call = 207,
  sym_method_call = 208,
  sym_command_argument_list = 209,
  sym_argument_list = 210,
  sym__argument_list_with_trailing_comma = 211,
  sym__argument = 212,
  sym_splat_argument = 213,
  sym_hash_splat_argument = 214,
  sym_block_argument = 215,
  sym_do_block = 216,
  sym_block = 217,
  sym_assignment = 218,
  sym_command_assignment = 219,
  sym_operator_assignment = 220,
  sym_command_operator_assignment = 221,
  sym_conditional = 222,
  sym_range = 223,
  sym_binary = 224,
  sym_command_binary = 225,
  sym_unary = 226,
  sym_parenthesized_unary = 227,
  sym_unary_literal = 228,
  sym_right_assignment_list = 229,
  sym_left_assignment_list = 230,
  sym__mlhs = 231,
  sym_destructured_left_assignment = 232,
  sym_rest_assignment = 233,
  sym__lhs = 234,
  sym__variable = 235,
  sym_operator = 236,
  sym__method_name = 237,
  sym_setter = 238,
  sym_undef = 239,
  sym_alias = 240,
  sym_rational = 241,
  sym_true = 242,
  sym_false = 243,
  sym_nil = 244,
  sym_chained_string = 245,
  sym_interpolation = 246,
  sym_string = 247,
  sym_subshell = 248,
  sym_string_array = 249,
  sym_symbol_array = 250,
  sym_symbol = 251,
  sym_regex = 252,
  sym_heredoc_body = 253,
  aux_sym__literal_contents = 254,
  sym_array = 255,
  sym_hash = 256,
  sym_pair = 257,
  sym_lambda = 258,
  sym_empty_statement = 259,
  sym__terminator = 260,
  aux_sym__statements_repeat1 = 261,
  aux_sym_parameters_repeat1 = 262,
  aux_sym_block_parameters_repeat1 = 263,
  aux_sym_case_repeat1 = 264,
  aux_sym_case_repeat2 = 265,
  aux_sym_when_repeat1 = 266,
  aux_sym_exceptions_repeat1 = 267,
  aux_sym__body_statement_repeat1 = 268,
  aux_sym_command_argument_list_repeat1 = 269,
  aux_sym__mlhs_repeat1 = 270,
  aux_sym_undef_repeat1 = 271,
  aux_sym_chained_string_repeat1 = 272,
  aux_sym_string_array_repeat1 = 273,
  aux_sym_symbol_array_repeat1 = 274,
  aux_sym_heredoc_body_repeat1 = 275,
  aux_sym_hash_repeat1 = 276,
  anon_alias_sym_DQUOTE = 277,
  alias_sym_bare_string = 278,
  alias_sym_bare_symbol = 279,
  alias_sym_destructured_parameter = 280,
  alias_sym_lambda_parameters = 281,
  alias_sym_method_parameters = 282,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym___END__] = "__END__",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_end] = "end",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [anon_sym_redo] = "redo",
  [anon_sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_rescue] = "rescue",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "?",
  [anon_sym_COLON2] = ":",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_CARET] = "^",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_defined_QMARK] = "defined?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [sym_constant] = "constant",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_complex] = "complex",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [anon_sym_true] = "true",
  [anon_sym_TRUE] = "TRUE",
  [anon_sym_false] = "false",
  [anon_sym_FALSE] = "FALSE",
  [sym_self] = "self",
  [anon_sym_nil] = "nil",
  [anon_sym_NIL] = "NIL",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_string_array_token1] = "string_array_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_DASH_GT] = "->",
  [sym__line_break] = "_line_break",
  [sym__simple_symbol] = "_simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym__string_content] = "_string_content",
  [sym__heredoc_content] = "_heredoc_content",
  [sym__string_end] = "_string_end",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "&",
  [sym__splat_star] = "*",
  [sym__unary_minus] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym__identifier_hash_key] = "symbol",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_parameters] = "parameters",
  [sym_bare_parameters] = "bare_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return_command] = "return",
  [sym_yield_command] = "yield",
  [sym_break_command] = "break",
  [sym_next_command] = "next",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym__do] = "_do",
  [sym_case] = "case",
  [sym_when] = "when",
  [sym_pattern] = "pattern",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym_then] = "then",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym__body_statement] = "_body_statement",
  [sym__expression] = "_expression",
  [sym__arg] = "_arg",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym_call] = "call",
  [sym_command_call] = "method_call",
  [sym_method_call] = "method_call",
  [sym_command_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_command_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_command_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_command_binary] = "binary",
  [sym_unary] = "unary",
  [sym_parenthesized_unary] = "unary",
  [sym_unary_literal] = "unary",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym_rational] = "rational",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_nil] = "nil",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_symbol] = "symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [aux_sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_repeat2] = "case_repeat2",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym__body_statement_repeat1] = "_body_statement_repeat1",
  [aux_sym_command_argument_list_repeat1] = "command_argument_list_repeat1",
  [aux_sym__mlhs_repeat1] = "_mlhs_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_hash_repeat1] = "hash_repeat1",
  [anon_alias_sym_DQUOTE] = "\"",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_destructured_parameter] = "destructured_parameter",
  [alias_sym_lambda_parameters] = "lambda_parameters",
  [alias_sym_method_parameters] = "method_parameters",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym___END__] = anon_sym___END__,
  [sym_uninterpreted] = sym_uninterpreted,
  [anon_sym_BEGIN] = anon_sym_BEGIN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_END] = anon_sym_END,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_next] = anon_sym_next,
  [anon_sym_redo] = anon_sym_redo,
  [anon_sym_retry] = anon_sym_retry,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_rescue] = anon_sym_rescue,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_ensure] = anon_sym_ensure,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON_COLON2] = anon_sym_COLON_COLON2,
  [anon_sym_AMP_DOT] = anon_sym_AMP_DOT,
  [anon_sym_LPAREN2] = anon_sym_LPAREN2,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON2] = anon_sym_COLON2,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_defined_QMARK] = anon_sym_defined_QMARK,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_constant] = sym_constant,
  [sym_instance_variable] = sym_instance_variable,
  [sym_class_variable] = sym_class_variable,
  [sym_global_variable] = sym_global_variable,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_AT] = anon_sym_PLUS_AT,
  [anon_sym_DASH_AT] = anon_sym_DASH_AT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK_RBRACK_EQ] = anon_sym_LBRACK_RBRACK_EQ,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_alias] = anon_sym_alias,
  [sym_comment] = sym_comment,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_complex] = sym_complex,
  [anon_sym_r] = anon_sym_r,
  [sym_super] = sym_super,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_TRUE] = anon_sym_TRUE,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_FALSE] = anon_sym_FALSE,
  [sym_self] = sym_self,
  [anon_sym_nil] = anon_sym_nil,
  [anon_sym_NIL] = anon_sym_NIL,
  [sym_character] = sym_character,
  [anon_sym_POUND_LBRACE] = anon_sym_POUND_LBRACE,
  [aux_sym_string_array_token1] = aux_sym_string_array_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_LBRACK2] = anon_sym_LBRACK2,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym__line_break] = sym__line_break,
  [sym__simple_symbol] = sym__simple_symbol,
  [sym__string_start] = sym__string_start,
  [sym__symbol_start] = sym__symbol_start,
  [sym__subshell_start] = anon_sym_BQUOTE,
  [sym__regex_start] = anon_sym_SLASH,
  [sym__string_array_start] = sym__string_array_start,
  [sym__symbol_array_start] = sym__symbol_array_start,
  [sym__heredoc_body_start] = sym__heredoc_body_start,
  [sym__string_content] = sym__string_content,
  [sym__heredoc_content] = sym__heredoc_content,
  [sym__string_end] = sym__string_end,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_heredoc_beginning] = sym_heredoc_beginning,
  [sym__block_ampersand] = anon_sym_AMP,
  [sym__splat_star] = anon_sym_STAR,
  [sym__unary_minus] = anon_sym_DASH,
  [sym__binary_minus] = anon_sym_DASH,
  [sym__binary_star] = anon_sym_STAR,
  [sym__singleton_class_left_angle_left_langle] = anon_sym_LT_LT,
  [sym__identifier_hash_key] = sym_symbol,
  [sym_program] = sym_program,
  [sym__statements] = sym__statements,
  [sym_begin_block] = sym_begin_block,
  [sym_end_block] = sym_end_block,
  [sym__statement] = sym__statement,
  [sym_method] = sym_method,
  [sym_singleton_method] = sym_singleton_method,
  [sym__method_rest] = sym__method_rest,
  [sym_parameters] = sym_parameters,
  [sym_bare_parameters] = sym_bare_parameters,
  [sym_block_parameters] = sym_block_parameters,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym__simple_formal_parameter] = sym__simple_formal_parameter,
  [sym_splat_parameter] = sym_splat_parameter,
  [sym_hash_splat_parameter] = sym_hash_splat_parameter,
  [sym_block_parameter] = sym_block_parameter,
  [sym_keyword_parameter] = sym_keyword_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_class] = sym_class,
  [sym_superclass] = sym_superclass,
  [sym_singleton_class] = sym_singleton_class,
  [sym_module] = sym_module,
  [sym_return_command] = sym_return,
  [sym_yield_command] = sym_yield,
  [sym_break_command] = sym_break,
  [sym_next_command] = sym_next,
  [sym_return] = sym_return,
  [sym_yield] = sym_yield,
  [sym_break] = sym_break,
  [sym_next] = sym_next,
  [sym_redo] = sym_redo,
  [sym_retry] = sym_retry,
  [sym_if_modifier] = sym_if_modifier,
  [sym_unless_modifier] = sym_unless_modifier,
  [sym_while_modifier] = sym_while_modifier,
  [sym_until_modifier] = sym_until_modifier,
  [sym_rescue_modifier] = sym_rescue_modifier,
  [sym_while] = sym_while,
  [sym_until] = sym_until,
  [sym_for] = sym_for,
  [sym_in] = sym_in,
  [sym__do] = sym__do,
  [sym_case] = sym_case,
  [sym_when] = sym_when,
  [sym_pattern] = sym_pattern,
  [sym_if] = sym_if,
  [sym_unless] = sym_unless,
  [sym_elsif] = sym_elsif,
  [sym_else] = sym_else,
  [sym_then] = sym_then,
  [sym_begin] = sym_begin,
  [sym_ensure] = sym_ensure,
  [sym_rescue] = sym_rescue,
  [sym_exceptions] = sym_exceptions,
  [sym_exception_variable] = sym_exception_variable,
  [sym__body_statement] = sym__body_statement,
  [sym__expression] = sym__expression,
  [sym__arg] = sym__arg,
  [sym__primary] = sym__primary,
  [sym_parenthesized_statements] = sym_parenthesized_statements,
  [sym_element_reference] = sym_element_reference,
  [sym_scope_resolution] = sym_scope_resolution,
  [sym_call] = sym_call,
  [sym_command_call] = sym_method_call,
  [sym_method_call] = sym_method_call,
  [sym_command_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym__argument_list_with_trailing_comma] = sym__argument_list_with_trailing_comma,
  [sym__argument] = sym__argument,
  [sym_splat_argument] = sym_splat_argument,
  [sym_hash_splat_argument] = sym_hash_splat_argument,
  [sym_block_argument] = sym_block_argument,
  [sym_do_block] = sym_do_block,
  [sym_block] = sym_block,
  [sym_assignment] = sym_assignment,
  [sym_command_assignment] = sym_assignment,
  [sym_operator_assignment] = sym_operator_assignment,
  [sym_command_operator_assignment] = sym_operator_assignment,
  [sym_conditional] = sym_conditional,
  [sym_range] = sym_range,
  [sym_binary] = sym_binary,
  [sym_command_binary] = sym_binary,
  [sym_unary] = sym_unary,
  [sym_parenthesized_unary] = sym_unary,
  [sym_unary_literal] = sym_unary,
  [sym_right_assignment_list] = sym_right_assignment_list,
  [sym_left_assignment_list] = sym_left_assignment_list,
  [sym__mlhs] = sym__mlhs,
  [sym_destructured_left_assignment] = sym_destructured_left_assignment,
  [sym_rest_assignment] = sym_rest_assignment,
  [sym__lhs] = sym__lhs,
  [sym__variable] = sym__variable,
  [sym_operator] = sym_operator,
  [sym__method_name] = sym__method_name,
  [sym_setter] = sym_setter,
  [sym_undef] = sym_undef,
  [sym_alias] = sym_alias,
  [sym_rational] = sym_rational,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_nil] = sym_nil,
  [sym_chained_string] = sym_chained_string,
  [sym_interpolation] = sym_interpolation,
  [sym_string] = sym_string,
  [sym_subshell] = sym_subshell,
  [sym_string_array] = sym_string_array,
  [sym_symbol_array] = sym_symbol_array,
  [sym_symbol] = sym_symbol,
  [sym_regex] = sym_regex,
  [sym_heredoc_body] = sym_heredoc_body,
  [aux_sym__literal_contents] = aux_sym__literal_contents,
  [sym_array] = sym_array,
  [sym_hash] = sym_hash,
  [sym_pair] = sym_pair,
  [sym_lambda] = sym_lambda,
  [sym_empty_statement] = sym_empty_statement,
  [sym__terminator] = sym__terminator,
  [aux_sym__statements_repeat1] = aux_sym__statements_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_block_parameters_repeat1] = aux_sym_block_parameters_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_case_repeat2] = aux_sym_case_repeat2,
  [aux_sym_when_repeat1] = aux_sym_when_repeat1,
  [aux_sym_exceptions_repeat1] = aux_sym_exceptions_repeat1,
  [aux_sym__body_statement_repeat1] = aux_sym__body_statement_repeat1,
  [aux_sym_command_argument_list_repeat1] = aux_sym_command_argument_list_repeat1,
  [aux_sym__mlhs_repeat1] = aux_sym__mlhs_repeat1,
  [aux_sym_undef_repeat1] = aux_sym_undef_repeat1,
  [aux_sym_chained_string_repeat1] = aux_sym_chained_string_repeat1,
  [aux_sym_string_array_repeat1] = aux_sym_string_array_repeat1,
  [aux_sym_symbol_array_repeat1] = aux_sym_symbol_array_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_hash_repeat1] = aux_sym_hash_repeat1,
  [anon_alias_sym_DQUOTE] = anon_alias_sym_DQUOTE,
  [alias_sym_bare_string] = alias_sym_bare_string,
  [alias_sym_bare_symbol] = alias_sym_bare_symbol,
  [alias_sym_destructured_parameter] = alias_sym_destructured_parameter,
  [alias_sym_lambda_parameters] = alias_sym_lambda_parameters,
  [alias_sym_method_parameters] = alias_sym_method_parameters,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_redo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_retry] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TRUE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_FALSE] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NIL] = {
    .visible = true,
    .named = false,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_array_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_symbol] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = true,
    .named = false,
  },
  [sym__splat_star] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym__identifier_hash_key] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_bare_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return_command] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_command] = {
    .visible = true,
    .named = true,
  },
  [sym_break_command] = {
    .visible = true,
    .named = true,
  },
  [sym_next_command] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_then] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__literal_contents] = {
    .visible = false,
    .named = false,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__body_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mlhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hash_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_method_parameters] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_arguments = 3,
  field_block = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_exceptions = 8,
  field_handler = 9,
  field_key = 10,
  field_left = 11,
  field_method = 12,
  field_name = 13,
  field_object = 14,
  field_operator = 15,
  field_parameters = 16,
  field_pattern = 17,
  field_receiver = 18,
  field_right = 19,
  field_scope = 20,
  field_value = 21,
  field_variable = 22,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_block] = "block",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_exceptions] = "exceptions",
  [field_handler] = "handler",
  [field_key] = "key",
  [field_left] = "left",
  [field_method] = "method",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_receiver] = "receiver",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[64] = {
  [5] = {.index = 0, .length = 2},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 2},
  [9] = {.index = 6, .length = 2},
  [16] = {.index = 8, .length = 1},
  [17] = {.index = 9, .length = 2},
  [19] = {.index = 11, .length = 1},
  [20] = {.index = 12, .length = 2},
  [21] = {.index = 14, .length = 2},
  [22] = {.index = 16, .length = 2},
  [23] = {.index = 18, .length = 3},
  [24] = {.index = 21, .length = 2},
  [25] = {.index = 23, .length = 1},
  [26] = {.index = 24, .length = 2},
  [27] = {.index = 26, .length = 3},
  [28] = {.index = 29, .length = 2},
  [36] = {.index = 31, .length = 2},
  [37] = {.index = 31, .length = 2},
  [38] = {.index = 33, .length = 3},
  [39] = {.index = 36, .length = 2},
  [40] = {.index = 38, .length = 2},
  [41] = {.index = 40, .length = 1},
  [42] = {.index = 41, .length = 2},
  [43] = {.index = 43, .length = 1},
  [44] = {.index = 44, .length = 2},
  [45] = {.index = 46, .length = 1},
  [46] = {.index = 47, .length = 2},
  [51] = {.index = 49, .length = 1},
  [52] = {.index = 50, .length = 3},
  [53] = {.index = 53, .length = 2},
  [54] = {.index = 55, .length = 2},
  [55] = {.index = 57, .length = 1},
  [56] = {.index = 58, .length = 3},
  [57] = {.index = 61, .length = 2},
  [58] = {.index = 63, .length = 3},
  [61] = {.index = 66, .length = 3},
  [62] = {.index = 69, .length = 3},
  [63] = {.index = 72, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [2] =
    {field_name, 1},
  [3] =
    {field_body, 1},
  [4] =
    {field_arguments, 1},
    {field_method, 0},
  [6] =
    {field_block, 1},
    {field_method, 0},
  [8] =
    {field_condition, 1},
  [9] =
    {field_alias, 2},
    {field_name, 1},
  [11] =
    {field_name, 0},
  [12] =
    {field_body, 2},
    {field_parameters, 1},
  [14] =
    {field_body, 0},
    {field_condition, 2},
  [16] =
    {field_body, 0},
    {field_handler, 2},
  [18] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [21] =
    {field_method, 2},
    {field_receiver, 0},
  [23] =
    {field_object, 0},
  [24] =
    {field_name, 2},
    {field_scope, 0},
  [26] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0},
  [29] =
    {field_left, 0},
    {field_right, 2},
  [31] =
    {field_key, 0},
    {field_value, 2},
  [33] =
    {field_name, 3, .inherited = true},
    {field_object, 1},
    {field_parameters, 3, .inherited = true},
  [36] =
    {field_name, 0},
    {field_parameters, 1},
  [38] =
    {field_condition, 1},
    {field_consequence, 2},
  [40] =
    {field_value, 1},
  [41] =
    {field_body, 2},
    {field_exceptions, 1},
  [43] =
    {field_exceptions, 1},
  [44] =
    {field_body, 2},
    {field_variable, 1},
  [46] =
    {field_variable, 1},
  [47] =
    {field_name, 0},
    {field_value, 2},
  [49] =
    {field_value, 2},
  [50] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [53] =
    {field_pattern, 1},
    {field_value, 2},
  [55] =
    {field_body, 2},
    {field_pattern, 1},
  [57] =
    {field_pattern, 1},
  [58] =
    {field_body, 3},
    {field_exceptions, 1},
    {field_variable, 2},
  [61] =
    {field_exceptions, 1},
    {field_variable, 2},
  [63] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [66] =
    {field_name, 5, .inherited = true},
    {field_object, 2},
    {field_parameters, 5, .inherited = true},
  [69] =
    {field_body, 3},
    {field_pattern, 1},
    {field_pattern, 2},
  [72] =
    {field_pattern, 1},
    {field_pattern, 2},
};

static TSSymbol ts_alias_sequences[64][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = anon_alias_sym_DQUOTE,
  },
  [2] = {
    [1] = anon_sym_BQUOTE,
  },
  [3] = {
    [1] = anon_sym_SLASH,
  },
  [4] = {
    [1] = anon_sym_RPAREN,
  },
  [10] = {
    [2] = anon_alias_sym_DQUOTE,
  },
  [11] = {
    [2] = anon_sym_BQUOTE,
  },
  [12] = {
    [2] = anon_sym_SLASH,
  },
  [13] = {
    [2] = anon_sym_RPAREN,
  },
  [14] = {
    [1] = alias_sym_bare_string,
    [2] = anon_sym_RPAREN,
  },
  [15] = {
    [1] = alias_sym_bare_symbol,
    [2] = anon_sym_RPAREN,
  },
  [18] = {
    [0] = alias_sym_destructured_parameter,
  },
  [20] = {
    [1] = alias_sym_lambda_parameters,
  },
  [29] = {
    [3] = anon_sym_RPAREN,
  },
  [30] = {
    [2] = alias_sym_bare_string,
    [3] = anon_sym_RPAREN,
  },
  [31] = {
    [1] = alias_sym_bare_string,
    [3] = anon_sym_RPAREN,
  },
  [32] = {
    [1] = alias_sym_bare_string,
  },
  [33] = {
    [2] = alias_sym_bare_symbol,
    [3] = anon_sym_RPAREN,
  },
  [34] = {
    [1] = alias_sym_bare_symbol,
    [3] = anon_sym_RPAREN,
  },
  [35] = {
    [1] = alias_sym_bare_symbol,
  },
  [37] = {
    [0] = sym_symbol,
  },
  [39] = {
    [1] = alias_sym_method_parameters,
  },
  [47] = {
    [2] = alias_sym_bare_string,
    [4] = anon_sym_RPAREN,
  },
  [48] = {
    [1] = alias_sym_bare_string,
    [4] = anon_sym_RPAREN,
  },
  [49] = {
    [2] = alias_sym_bare_symbol,
    [4] = anon_sym_RPAREN,
  },
  [50] = {
    [1] = alias_sym_bare_symbol,
    [4] = anon_sym_RPAREN,
  },
  [59] = {
    [2] = alias_sym_bare_string,
    [5] = anon_sym_RPAREN,
  },
  [60] = {
    [2] = alias_sym_bare_symbol,
    [5] = anon_sym_RPAREN,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(199);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(82)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(93)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead)) ADVANCE(235);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(44);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0) ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(15)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(16)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(17)
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(21)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(19)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(22)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(24)
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(29)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(27)
      END_STATE();
    case 11:
      if (lookahead == '\n') ADVANCE(277);
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(280);
      if (lookahead != 0) ADVANCE(276);
      END_STATE();
    case 12:
      if (lookahead == '\n') ADVANCE(278);
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(280);
      if (lookahead != 0) ADVANCE(276);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(31)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(32)
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(47);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(3)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(235);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '|') ADVANCE(235);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(179);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 20:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(149);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 21:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 22:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 23:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 24:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 25:
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      END_STATE();
    case 26:
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      END_STATE();
    case 27:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 28:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 29:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 30:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == ':') ADVANCE(149);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 31:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 32:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') SKIP(14)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(275);
      END_STATE();
    case 33:
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 34:
      if (lookahead == '*') ADVANCE(143);
      END_STATE();
    case 35:
      if (lookahead == '-') ADVANCE(79);
      END_STATE();
    case 36:
      if (lookahead == '.') ADVANCE(161);
      END_STATE();
    case 37:
      if (lookahead == '.') ADVANCE(181);
      END_STATE();
    case 38:
      if (lookahead == '.') ADVANCE(180);
      END_STATE();
    case 39:
      if (lookahead == ':') ADVANCE(160);
      END_STATE();
    case 40:
      if (lookahead == ':') ADVANCE(134);
      END_STATE();
    case 41:
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '~') ADVANCE(212);
      END_STATE();
    case 42:
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == 'b') ADVANCE(54);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 43:
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == 'b') ADVANCE(54);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 44:
      if (lookahead == '=') ADVANCE(55);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 46:
      if (lookahead == '=') ADVANCE(164);
      if (lookahead == '>') ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 47:
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == 'b') ADVANCE(54);
      END_STATE();
    case 48:
      if (lookahead == '>') ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 49:
      if (lookahead == '@') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 50:
      if (lookahead == '\\') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(268);
      END_STATE();
    case 51:
      if (lookahead == ']') ADVANCE(246);
      END_STATE();
    case 52:
      if (lookahead == 'b') ADVANCE(54);
      END_STATE();
    case 53:
      if (lookahead == 'd') ADVANCE(249);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(60);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 56:
      if (lookahead == 'g') ADVANCE(58);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(264);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(1);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(53);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 61:
      if (lookahead == '{') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 62:
      if (lookahead == '}') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 63:
      if (lookahead == '}') ADVANCE(276);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 64:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      END_STATE();
    case 65:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(256);
      END_STATE();
    case 66:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(252);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(257);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(254);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(262);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(255);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(276);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(281);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      END_STATE();
    case 78:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 79:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(268);
      END_STATE();
    case 80:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(270);
      END_STATE();
    case 81:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(237);
      END_STATE();
    case 82:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(93)
      END_STATE();
    case 83:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(100)
      END_STATE();
    case 84:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(108)
      END_STATE();
    case 85:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(104)
      END_STATE();
    case 86:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(103)
      END_STATE();
    case 87:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(106)
      END_STATE();
    case 88:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(107)
      END_STATE();
    case 89:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(110)
      END_STATE();
    case 90:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(96)
      END_STATE();
    case 91:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(97)
      END_STATE();
    case 92:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(99)
      END_STATE();
    case 93:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(199);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(82)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(93)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead)) ADVANCE(235);
      END_STATE();
    case 94:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(90)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(96)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 95:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(91)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(97)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 96:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(90)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(96)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 97:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(91)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(97)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 98:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(92)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(99)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 99:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(92)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(99)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 100:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(47);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(83)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(100)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 101:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(85)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(104)
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 102:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ':') ADVANCE(179);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(86)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(103)
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 103:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(86)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(103)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 104:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(85)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(104)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 105:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(87)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(106)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '@' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 106:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(87)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(106)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 107:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(147);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(37);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(88)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(107)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 108:
      if (eof) ADVANCE(111);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(84)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(108)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 109:
      if (eof) ADVANCE(111);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(154);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(89)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(110)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 110:
      if (eof) ADVANCE(111);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(154);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') SKIP(89)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(110)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(115);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(116);
      if (lookahead != 0) ADVANCE(113);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(117);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead != 0) ADVANCE(114);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(115);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == '=') ADVANCE(118);
      if (lookahead == '\\') ADVANCE(112);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != '=') ADVANCE(117);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'b') ADVANCE(116);
      if (lookahead == 'b') ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'd') ADVANCE(117);
      if (lookahead == 'd') ADVANCE(116);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'e') ADVANCE(116);
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'e') ADVANCE(117);
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'g') ADVANCE(116);
      if (lookahead == 'g') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'i') ADVANCE(116);
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'n') ADVANCE(116);
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'n') ADVANCE(117);
      if (lookahead == 'n') ADVANCE(119);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(181);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(169);
      if (lookahead == '|') ADVANCE(184);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(183);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(166);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(186);
      if (lookahead == '.') ADVANCE(161);
      if (lookahead == '=') ADVANCE(171);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(185);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '.') ADVANCE(161);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(160);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(188);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(187);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(268);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(160);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(174);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(173);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(210);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(190);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(189);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(175);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(163);
      if (lookahead == '@') ADVANCE(244);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@') ADVANCE(244);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '~') ADVANCE(212);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~') ADVANCE(212);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_constant);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'A') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'D') ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'E') ADVANCE(223);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'E') ADVANCE(265);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'E') ADVANCE(266);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'G') ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'I') ADVANCE(229);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'I') ADVANCE(227);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'L') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'L') ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'N') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'N') ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'R') ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'S') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'U') ADVANCE(221);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_global_variable);
      if (lookahead == '-') ADVANCE(241);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~') ADVANCE(238);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(242);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= ',') ||
          ('.' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~') ADVANCE(238);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(242);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@') ADVANCE(245);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=') ADVANCE(247);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(251);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(251);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(254);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(252);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(73);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(65);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(70);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(252);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(254);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(255);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(257);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == 'i') ADVANCE(264);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(261);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(259);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'i') ADVANCE(264);
      if (lookahead == 'x') ADVANCE(73);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(261);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(65);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(70);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(259);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'i') ADVANCE(264);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(69);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(262);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_complex);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_TRUE);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_FALSE);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_NIL);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-') ADVANCE(80);
      if (lookahead == '{') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M') ADVANCE(35);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(269);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(275);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(12);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(276);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(279);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(276);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\\') SKIP(1)
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 2:
      if (lookahead == '_') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(20);
      if (lookahead == 'n') ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'l') ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      END_STATE();
    case 7:
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(29);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      END_STATE();
    case 12:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(42);
      if (lookahead == 'r') ADVANCE(43);
      END_STATE();
    case 16:
      if (lookahead == 'n') ADVANCE(44);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(45);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(46);
      END_STATE();
    case 19:
      if (lookahead == 'E') ADVANCE(47);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(48);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(49);
      END_STATE();
    case 22:
      if (lookahead == 'g') ADVANCE(50);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(52);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(54);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(55);
      END_STATE();
    case 29:
      if (lookahead == 'd') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(58);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 'x') ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 39:
      if (lookahead == 'd') ADVANCE(64);
      if (lookahead == 's') ADVANCE(65);
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(67);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(68);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 43:
      if (lookahead == 'u') ADVANCE(70);
      END_STATE();
    case 44:
      if (lookahead == 'd') ADVANCE(71);
      if (lookahead == 'l') ADVANCE(72);
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(74);
      if (lookahead == 'i') ADVANCE(75);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 47:
      if (lookahead == 'N') ADVANCE(77);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(79);
      END_STATE();
    case 51:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 53:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'i') ADVANCE(83);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(84);
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 57:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 58:
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(90);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(91);
      END_STATE();
    case 66:
      if (lookahead == 'r') ADVANCE(92);
      if (lookahead == 'u') ADVANCE(93);
      END_STATE();
    case 67:
      if (lookahead == 'f') ADVANCE(94);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(100);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(101);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(102);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(103);
      END_STATE();
    case 77:
      if (lookahead == 'D') ADVANCE(104);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 79:
      if (lookahead == 'n') ADVANCE(106);
      END_STATE();
    case 80:
      if (lookahead == 'k') ADVANCE(107);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 85:
      if (lookahead == 'f') ADVANCE(110);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 88:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_redo);
      END_STATE();
    case 91:
      if (lookahead == 'u') ADVANCE(114);
      END_STATE();
    case 92:
      if (lookahead == 'y') ADVANCE(115);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 95:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 98:
      if (lookahead == 'f') ADVANCE(118);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 103:
      if (lookahead == 'd') ADVANCE(122);
      END_STATE();
    case 104:
      if (lookahead == '_') ADVANCE(123);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_retry);
      END_STATE();
    case 116:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 119:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 123:
      if (lookahead == '_') ADVANCE(130);
      END_STATE();
    case 124:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym___END__);
      END_STATE();
    case 131:
      if (lookahead == '?') ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 100, .external_lex_state = 2},
  [2] = {.lex_state = 94, .external_lex_state = 3},
  [3] = {.lex_state = 94, .external_lex_state = 3},
  [4] = {.lex_state = 95, .external_lex_state = 3},
  [5] = {.lex_state = 94, .external_lex_state = 3},
  [6] = {.lex_state = 94, .external_lex_state = 3},
  [7] = {.lex_state = 95, .external_lex_state = 3},
  [8] = {.lex_state = 94, .external_lex_state = 4},
  [9] = {.lex_state = 94, .external_lex_state = 4},
  [10] = {.lex_state = 95, .external_lex_state = 4},
  [11] = {.lex_state = 98, .external_lex_state = 3},
  [12] = {.lex_state = 98, .external_lex_state = 3},
  [13] = {.lex_state = 98, .external_lex_state = 3},
  [14] = {.lex_state = 98, .external_lex_state = 3},
  [15] = {.lex_state = 98, .external_lex_state = 3},
  [16] = {.lex_state = 98, .external_lex_state = 3},
  [17] = {.lex_state = 98, .external_lex_state = 3},
  [18] = {.lex_state = 98, .external_lex_state = 3},
  [19] = {.lex_state = 98, .external_lex_state = 4},
  [20] = {.lex_state = 98, .external_lex_state = 4},
  [21] = {.lex_state = 98, .external_lex_state = 4},
  [22] = {.lex_state = 98, .external_lex_state = 4},
  [23] = {.lex_state = 100, .external_lex_state = 5},
  [24] = {.lex_state = 100, .external_lex_state = 5},
  [25] = {.lex_state = 100, .external_lex_state = 5},
  [26] = {.lex_state = 100, .external_lex_state = 5},
  [27] = {.lex_state = 100, .external_lex_state = 5},
  [28] = {.lex_state = 100, .external_lex_state = 5},
  [29] = {.lex_state = 100, .external_lex_state = 5},
  [30] = {.lex_state = 100, .external_lex_state = 5},
  [31] = {.lex_state = 100, .external_lex_state = 6},
  [32] = {.lex_state = 100, .external_lex_state = 6},
  [33] = {.lex_state = 100, .external_lex_state = 6},
  [34] = {.lex_state = 100, .external_lex_state = 6},
  [35] = {.lex_state = 100, .external_lex_state = 5},
  [36] = {.lex_state = 100, .external_lex_state = 5},
  [37] = {.lex_state = 100, .external_lex_state = 2},
  [38] = {.lex_state = 100, .external_lex_state = 5},
  [39] = {.lex_state = 100, .external_lex_state = 5},
  [40] = {.lex_state = 100, .external_lex_state = 5},
  [41] = {.lex_state = 100, .external_lex_state = 2},
  [42] = {.lex_state = 100, .external_lex_state = 5},
  [43] = {.lex_state = 100, .external_lex_state = 5},
  [44] = {.lex_state = 100, .external_lex_state = 5},
  [45] = {.lex_state = 100, .external_lex_state = 2},
  [46] = {.lex_state = 100, .external_lex_state = 5},
  [47] = {.lex_state = 100, .external_lex_state = 5},
  [48] = {.lex_state = 100, .external_lex_state = 2},
  [49] = {.lex_state = 100, .external_lex_state = 5},
  [50] = {.lex_state = 100, .external_lex_state = 5},
  [51] = {.lex_state = 100, .external_lex_state = 5},
  [52] = {.lex_state = 100, .external_lex_state = 5},
  [53] = {.lex_state = 100, .external_lex_state = 5},
  [54] = {.lex_state = 100, .external_lex_state = 5},
  [55] = {.lex_state = 100, .external_lex_state = 2},
  [56] = {.lex_state = 100, .external_lex_state = 5},
  [57] = {.lex_state = 100, .external_lex_state = 2},
  [58] = {.lex_state = 100, .external_lex_state = 5},
  [59] = {.lex_state = 100, .external_lex_state = 2},
  [60] = {.lex_state = 100, .external_lex_state = 5},
  [61] = {.lex_state = 100, .external_lex_state = 5},
  [62] = {.lex_state = 100, .external_lex_state = 2},
  [63] = {.lex_state = 100, .external_lex_state = 5},
  [64] = {.lex_state = 100, .external_lex_state = 5},
  [65] = {.lex_state = 100, .external_lex_state = 6},
  [66] = {.lex_state = 100, .external_lex_state = 7},
  [67] = {.lex_state = 100, .external_lex_state = 6},
  [68] = {.lex_state = 100, .external_lex_state = 6},
  [69] = {.lex_state = 100, .external_lex_state = 7},
  [70] = {.lex_state = 100, .external_lex_state = 6},
  [71] = {.lex_state = 100, .external_lex_state = 6},
  [72] = {.lex_state = 100, .external_lex_state = 6},
  [73] = {.lex_state = 100, .external_lex_state = 6},
  [74] = {.lex_state = 100, .external_lex_state = 6},
  [75] = {.lex_state = 100, .external_lex_state = 7},
  [76] = {.lex_state = 100, .external_lex_state = 6},
  [77] = {.lex_state = 100, .external_lex_state = 7},
  [78] = {.lex_state = 100, .external_lex_state = 6},
  [79] = {.lex_state = 100, .external_lex_state = 2},
  [80] = {.lex_state = 100, .external_lex_state = 2},
  [81] = {.lex_state = 100, .external_lex_state = 2},
  [82] = {.lex_state = 100, .external_lex_state = 2},
  [83] = {.lex_state = 100, .external_lex_state = 2},
  [84] = {.lex_state = 100, .external_lex_state = 2},
  [85] = {.lex_state = 100, .external_lex_state = 2},
  [86] = {.lex_state = 100, .external_lex_state = 2},
  [87] = {.lex_state = 100, .external_lex_state = 2},
  [88] = {.lex_state = 100, .external_lex_state = 2},
  [89] = {.lex_state = 100, .external_lex_state = 2},
  [90] = {.lex_state = 100, .external_lex_state = 2},
  [91] = {.lex_state = 100, .external_lex_state = 2},
  [92] = {.lex_state = 100, .external_lex_state = 2},
  [93] = {.lex_state = 100, .external_lex_state = 2},
  [94] = {.lex_state = 100, .external_lex_state = 2},
  [95] = {.lex_state = 100, .external_lex_state = 2},
  [96] = {.lex_state = 100, .external_lex_state = 2},
  [97] = {.lex_state = 100, .external_lex_state = 2},
  [98] = {.lex_state = 100, .external_lex_state = 2},
  [99] = {.lex_state = 100, .external_lex_state = 2},
  [100] = {.lex_state = 100, .external_lex_state = 2},
  [101] = {.lex_state = 100, .external_lex_state = 2},
  [102] = {.lex_state = 100, .external_lex_state = 2},
  [103] = {.lex_state = 100, .external_lex_state = 2},
  [104] = {.lex_state = 100, .external_lex_state = 2},
  [105] = {.lex_state = 100, .external_lex_state = 2},
  [106] = {.lex_state = 100, .external_lex_state = 2},
  [107] = {.lex_state = 100, .external_lex_state = 2},
  [108] = {.lex_state = 100, .external_lex_state = 2},
  [109] = {.lex_state = 100, .external_lex_state = 2},
  [110] = {.lex_state = 100, .external_lex_state = 2},
  [111] = {.lex_state = 100, .external_lex_state = 2},
  [112] = {.lex_state = 100, .external_lex_state = 2},
  [113] = {.lex_state = 100, .external_lex_state = 2},
  [114] = {.lex_state = 100, .external_lex_state = 2},
  [115] = {.lex_state = 100, .external_lex_state = 2},
  [116] = {.lex_state = 100, .external_lex_state = 7},
  [117] = {.lex_state = 100, .external_lex_state = 7},
  [118] = {.lex_state = 100, .external_lex_state = 7},
  [119] = {.lex_state = 100, .external_lex_state = 7},
  [120] = {.lex_state = 100, .external_lex_state = 7},
  [121] = {.lex_state = 100, .external_lex_state = 7},
  [122] = {.lex_state = 100, .external_lex_state = 7},
  [123] = {.lex_state = 100, .external_lex_state = 7},
  [124] = {.lex_state = 100, .external_lex_state = 7},
  [125] = {.lex_state = 100, .external_lex_state = 7},
  [126] = {.lex_state = 100, .external_lex_state = 7},
  [127] = {.lex_state = 100, .external_lex_state = 7},
  [128] = {.lex_state = 100, .external_lex_state = 7},
  [129] = {.lex_state = 100, .external_lex_state = 7},
  [130] = {.lex_state = 100, .external_lex_state = 7},
  [131] = {.lex_state = 15, .external_lex_state = 8},
  [132] = {.lex_state = 15, .external_lex_state = 8},
  [133] = {.lex_state = 100, .external_lex_state = 2},
  [134] = {.lex_state = 15, .external_lex_state = 8},
  [135] = {.lex_state = 100, .external_lex_state = 2},
  [136] = {.lex_state = 15, .external_lex_state = 9},
  [137] = {.lex_state = 100, .external_lex_state = 2},
  [138] = {.lex_state = 100, .external_lex_state = 2},
  [139] = {.lex_state = 100, .external_lex_state = 2},
  [140] = {.lex_state = 100, .external_lex_state = 2},
  [141] = {.lex_state = 100, .external_lex_state = 2},
  [142] = {.lex_state = 100, .external_lex_state = 2},
  [143] = {.lex_state = 15, .external_lex_state = 9},
  [144] = {.lex_state = 15, .external_lex_state = 9},
  [145] = {.lex_state = 100, .external_lex_state = 2},
  [146] = {.lex_state = 100, .external_lex_state = 2},
  [147] = {.lex_state = 100, .external_lex_state = 2},
  [148] = {.lex_state = 100, .external_lex_state = 5},
  [149] = {.lex_state = 100, .external_lex_state = 7},
  [150] = {.lex_state = 100, .external_lex_state = 2},
  [151] = {.lex_state = 100, .external_lex_state = 2},
  [152] = {.lex_state = 100, .external_lex_state = 2},
  [153] = {.lex_state = 100, .external_lex_state = 2},
  [154] = {.lex_state = 100, .external_lex_state = 7},
  [155] = {.lex_state = 100, .external_lex_state = 2},
  [156] = {.lex_state = 100, .external_lex_state = 2},
  [157] = {.lex_state = 100, .external_lex_state = 2},
  [158] = {.lex_state = 100, .external_lex_state = 2},
  [159] = {.lex_state = 100, .external_lex_state = 2},
  [160] = {.lex_state = 100, .external_lex_state = 2},
  [161] = {.lex_state = 100, .external_lex_state = 2},
  [162] = {.lex_state = 100, .external_lex_state = 2},
  [163] = {.lex_state = 100, .external_lex_state = 2},
  [164] = {.lex_state = 100, .external_lex_state = 2},
  [165] = {.lex_state = 100, .external_lex_state = 2},
  [166] = {.lex_state = 100, .external_lex_state = 2},
  [167] = {.lex_state = 100, .external_lex_state = 7},
  [168] = {.lex_state = 100, .external_lex_state = 7},
  [169] = {.lex_state = 100, .external_lex_state = 7},
  [170] = {.lex_state = 100, .external_lex_state = 7},
  [171] = {.lex_state = 100, .external_lex_state = 2},
  [172] = {.lex_state = 100, .external_lex_state = 2},
  [173] = {.lex_state = 100, .external_lex_state = 2},
  [174] = {.lex_state = 100, .external_lex_state = 2},
  [175] = {.lex_state = 100, .external_lex_state = 2},
  [176] = {.lex_state = 100, .external_lex_state = 2},
  [177] = {.lex_state = 100, .external_lex_state = 2},
  [178] = {.lex_state = 100, .external_lex_state = 2},
  [179] = {.lex_state = 100, .external_lex_state = 2},
  [180] = {.lex_state = 100, .external_lex_state = 2},
  [181] = {.lex_state = 100, .external_lex_state = 2},
  [182] = {.lex_state = 100, .external_lex_state = 2},
  [183] = {.lex_state = 100, .external_lex_state = 2},
  [184] = {.lex_state = 100, .external_lex_state = 2},
  [185] = {.lex_state = 100, .external_lex_state = 2},
  [186] = {.lex_state = 100, .external_lex_state = 2},
  [187] = {.lex_state = 100, .external_lex_state = 2},
  [188] = {.lex_state = 100, .external_lex_state = 2},
  [189] = {.lex_state = 100, .external_lex_state = 2},
  [190] = {.lex_state = 100, .external_lex_state = 2},
  [191] = {.lex_state = 100, .external_lex_state = 2},
  [192] = {.lex_state = 100, .external_lex_state = 2},
  [193] = {.lex_state = 100, .external_lex_state = 2},
  [194] = {.lex_state = 100, .external_lex_state = 2},
  [195] = {.lex_state = 100, .external_lex_state = 2},
  [196] = {.lex_state = 100, .external_lex_state = 7},
  [197] = {.lex_state = 100, .external_lex_state = 7},
  [198] = {.lex_state = 100, .external_lex_state = 7},
  [199] = {.lex_state = 100, .external_lex_state = 7},
  [200] = {.lex_state = 100, .external_lex_state = 7},
  [201] = {.lex_state = 100, .external_lex_state = 7},
  [202] = {.lex_state = 100, .external_lex_state = 7},
  [203] = {.lex_state = 100, .external_lex_state = 7},
  [204] = {.lex_state = 100, .external_lex_state = 7},
  [205] = {.lex_state = 100, .external_lex_state = 7},
  [206] = {.lex_state = 100, .external_lex_state = 2},
  [207] = {.lex_state = 100, .external_lex_state = 2},
  [208] = {.lex_state = 100, .external_lex_state = 2},
  [209] = {.lex_state = 100, .external_lex_state = 2},
  [210] = {.lex_state = 100, .external_lex_state = 2},
  [211] = {.lex_state = 100, .external_lex_state = 2},
  [212] = {.lex_state = 100, .external_lex_state = 2},
  [213] = {.lex_state = 100, .external_lex_state = 2},
  [214] = {.lex_state = 100, .external_lex_state = 2},
  [215] = {.lex_state = 100, .external_lex_state = 7},
  [216] = {.lex_state = 100, .external_lex_state = 7},
  [217] = {.lex_state = 100, .external_lex_state = 7},
  [218] = {.lex_state = 16, .external_lex_state = 10},
  [219] = {.lex_state = 16, .external_lex_state = 10},
  [220] = {.lex_state = 16, .external_lex_state = 10},
  [221] = {.lex_state = 16, .external_lex_state = 10},
  [222] = {.lex_state = 16, .external_lex_state = 10},
  [223] = {.lex_state = 16, .external_lex_state = 10},
  [224] = {.lex_state = 17, .external_lex_state = 11},
  [225] = {.lex_state = 17, .external_lex_state = 11},
  [226] = {.lex_state = 17, .external_lex_state = 11},
  [227] = {.lex_state = 17, .external_lex_state = 11},
  [228] = {.lex_state = 17, .external_lex_state = 11},
  [229] = {.lex_state = 17, .external_lex_state = 11},
  [230] = {.lex_state = 17, .external_lex_state = 11},
  [231] = {.lex_state = 17, .external_lex_state = 11},
  [232] = {.lex_state = 94, .external_lex_state = 3},
  [233] = {.lex_state = 17, .external_lex_state = 11},
  [234] = {.lex_state = 16, .external_lex_state = 12},
  [235] = {.lex_state = 17, .external_lex_state = 11},
  [236] = {.lex_state = 17, .external_lex_state = 11},
  [237] = {.lex_state = 94, .external_lex_state = 3},
  [238] = {.lex_state = 17, .external_lex_state = 11},
  [239] = {.lex_state = 17, .external_lex_state = 11},
  [240] = {.lex_state = 17, .external_lex_state = 11},
  [241] = {.lex_state = 17, .external_lex_state = 11},
  [242] = {.lex_state = 17, .external_lex_state = 11},
  [243] = {.lex_state = 17, .external_lex_state = 11},
  [244] = {.lex_state = 17, .external_lex_state = 11},
  [245] = {.lex_state = 17, .external_lex_state = 11},
  [246] = {.lex_state = 17, .external_lex_state = 11},
  [247] = {.lex_state = 17, .external_lex_state = 11},
  [248] = {.lex_state = 16, .external_lex_state = 12},
  [249] = {.lex_state = 17, .external_lex_state = 11},
  [250] = {.lex_state = 17, .external_lex_state = 11},
  [251] = {.lex_state = 17, .external_lex_state = 13},
  [252] = {.lex_state = 94, .external_lex_state = 3},
  [253] = {.lex_state = 17, .external_lex_state = 13},
  [254] = {.lex_state = 94, .external_lex_state = 3},
  [255] = {.lex_state = 94, .external_lex_state = 3},
  [256] = {.lex_state = 94, .external_lex_state = 3},
  [257] = {.lex_state = 94, .external_lex_state = 3},
  [258] = {.lex_state = 17, .external_lex_state = 13},
  [259] = {.lex_state = 17, .external_lex_state = 13},
  [260] = {.lex_state = 17, .external_lex_state = 13},
  [261] = {.lex_state = 94, .external_lex_state = 3},
  [262] = {.lex_state = 17, .external_lex_state = 13},
  [263] = {.lex_state = 16, .external_lex_state = 14},
  [264] = {.lex_state = 17, .external_lex_state = 13},
  [265] = {.lex_state = 94, .external_lex_state = 3},
  [266] = {.lex_state = 17, .external_lex_state = 13},
  [267] = {.lex_state = 16, .external_lex_state = 2},
  [268] = {.lex_state = 16, .external_lex_state = 2},
  [269] = {.lex_state = 95, .external_lex_state = 3},
  [270] = {.lex_state = 95, .external_lex_state = 3},
  [271] = {.lex_state = 95, .external_lex_state = 3},
  [272] = {.lex_state = 16, .external_lex_state = 2},
  [273] = {.lex_state = 17, .external_lex_state = 11},
  [274] = {.lex_state = 16, .external_lex_state = 2},
  [275] = {.lex_state = 17, .external_lex_state = 11},
  [276] = {.lex_state = 16, .external_lex_state = 2},
  [277] = {.lex_state = 16, .external_lex_state = 2},
  [278] = {.lex_state = 16, .external_lex_state = 2},
  [279] = {.lex_state = 16, .external_lex_state = 2},
  [280] = {.lex_state = 16, .external_lex_state = 2},
  [281] = {.lex_state = 16, .external_lex_state = 2},
  [282] = {.lex_state = 16, .external_lex_state = 2},
  [283] = {.lex_state = 17, .external_lex_state = 11},
  [284] = {.lex_state = 16, .external_lex_state = 2},
  [285] = {.lex_state = 16, .external_lex_state = 2},
  [286] = {.lex_state = 16, .external_lex_state = 2},
  [287] = {.lex_state = 16, .external_lex_state = 2},
  [288] = {.lex_state = 16, .external_lex_state = 2},
  [289] = {.lex_state = 95, .external_lex_state = 3},
  [290] = {.lex_state = 95, .external_lex_state = 3},
  [291] = {.lex_state = 16, .external_lex_state = 2},
  [292] = {.lex_state = 95, .external_lex_state = 3},
  [293] = {.lex_state = 16, .external_lex_state = 2},
  [294] = {.lex_state = 95, .external_lex_state = 3},
  [295] = {.lex_state = 17, .external_lex_state = 13},
  [296] = {.lex_state = 16, .external_lex_state = 7},
  [297] = {.lex_state = 16, .external_lex_state = 7},
  [298] = {.lex_state = 16, .external_lex_state = 7},
  [299] = {.lex_state = 16, .external_lex_state = 7},
  [300] = {.lex_state = 16, .external_lex_state = 7},
  [301] = {.lex_state = 16, .external_lex_state = 7},
  [302] = {.lex_state = 16, .external_lex_state = 7},
  [303] = {.lex_state = 16, .external_lex_state = 7},
  [304] = {.lex_state = 17, .external_lex_state = 13},
  [305] = {.lex_state = 94, .external_lex_state = 3},
  [306] = {.lex_state = 17, .external_lex_state = 8},
  [307] = {.lex_state = 17, .external_lex_state = 8},
  [308] = {.lex_state = 17, .external_lex_state = 8},
  [309] = {.lex_state = 17, .external_lex_state = 8},
  [310] = {.lex_state = 17, .external_lex_state = 8},
  [311] = {.lex_state = 17, .external_lex_state = 8},
  [312] = {.lex_state = 17, .external_lex_state = 8},
  [313] = {.lex_state = 17, .external_lex_state = 8},
  [314] = {.lex_state = 94, .external_lex_state = 3},
  [315] = {.lex_state = 17, .external_lex_state = 8},
  [316] = {.lex_state = 94, .external_lex_state = 3},
  [317] = {.lex_state = 17, .external_lex_state = 9},
  [318] = {.lex_state = 94, .external_lex_state = 3},
  [319] = {.lex_state = 94, .external_lex_state = 3},
  [320] = {.lex_state = 94, .external_lex_state = 3},
  [321] = {.lex_state = 17, .external_lex_state = 9},
  [322] = {.lex_state = 17, .external_lex_state = 8},
  [323] = {.lex_state = 94, .external_lex_state = 3},
  [324] = {.lex_state = 94, .external_lex_state = 3},
  [325] = {.lex_state = 94, .external_lex_state = 3},
  [326] = {.lex_state = 17, .external_lex_state = 9},
  [327] = {.lex_state = 94, .external_lex_state = 3},
  [328] = {.lex_state = 16, .external_lex_state = 10},
  [329] = {.lex_state = 95, .external_lex_state = 3},
  [330] = {.lex_state = 16, .external_lex_state = 5},
  [331] = {.lex_state = 16, .external_lex_state = 2},
  [332] = {.lex_state = 16, .external_lex_state = 10},
  [333] = {.lex_state = 16, .external_lex_state = 10},
  [334] = {.lex_state = 95, .external_lex_state = 3},
  [335] = {.lex_state = 16, .external_lex_state = 10},
  [336] = {.lex_state = 16, .external_lex_state = 10},
  [337] = {.lex_state = 16, .external_lex_state = 10},
  [338] = {.lex_state = 16, .external_lex_state = 10},
  [339] = {.lex_state = 16, .external_lex_state = 10},
  [340] = {.lex_state = 16, .external_lex_state = 10},
  [341] = {.lex_state = 16, .external_lex_state = 10},
  [342] = {.lex_state = 95, .external_lex_state = 3},
  [343] = {.lex_state = 16, .external_lex_state = 10},
  [344] = {.lex_state = 16, .external_lex_state = 5},
  [345] = {.lex_state = 16, .external_lex_state = 10},
  [346] = {.lex_state = 16, .external_lex_state = 10},
  [347] = {.lex_state = 16, .external_lex_state = 5},
  [348] = {.lex_state = 16, .external_lex_state = 10},
  [349] = {.lex_state = 95, .external_lex_state = 3},
  [350] = {.lex_state = 16, .external_lex_state = 10},
  [351] = {.lex_state = 16, .external_lex_state = 10},
  [352] = {.lex_state = 95, .external_lex_state = 3},
  [353] = {.lex_state = 16, .external_lex_state = 10},
  [354] = {.lex_state = 16, .external_lex_state = 10},
  [355] = {.lex_state = 16, .external_lex_state = 10},
  [356] = {.lex_state = 16, .external_lex_state = 5},
  [357] = {.lex_state = 16, .external_lex_state = 10},
  [358] = {.lex_state = 95, .external_lex_state = 3},
  [359] = {.lex_state = 95, .external_lex_state = 3},
  [360] = {.lex_state = 16, .external_lex_state = 10},
  [361] = {.lex_state = 16, .external_lex_state = 10},
  [362] = {.lex_state = 16, .external_lex_state = 12},
  [363] = {.lex_state = 16, .external_lex_state = 10},
  [364] = {.lex_state = 16, .external_lex_state = 10},
  [365] = {.lex_state = 16, .external_lex_state = 10},
  [366] = {.lex_state = 16, .external_lex_state = 12},
  [367] = {.lex_state = 16, .external_lex_state = 10},
  [368] = {.lex_state = 16, .external_lex_state = 2},
  [369] = {.lex_state = 16, .external_lex_state = 10},
  [370] = {.lex_state = 16, .external_lex_state = 6},
  [371] = {.lex_state = 16, .external_lex_state = 10},
  [372] = {.lex_state = 16, .external_lex_state = 10},
  [373] = {.lex_state = 16, .external_lex_state = 12},
  [374] = {.lex_state = 16, .external_lex_state = 12},
  [375] = {.lex_state = 16, .external_lex_state = 2},
  [376] = {.lex_state = 16, .external_lex_state = 10},
  [377] = {.lex_state = 16, .external_lex_state = 10},
  [378] = {.lex_state = 16, .external_lex_state = 10},
  [379] = {.lex_state = 16, .external_lex_state = 12},
  [380] = {.lex_state = 16, .external_lex_state = 12},
  [381] = {.lex_state = 16, .external_lex_state = 12},
  [382] = {.lex_state = 16, .external_lex_state = 12},
  [383] = {.lex_state = 94, .external_lex_state = 4},
  [384] = {.lex_state = 16, .external_lex_state = 12},
  [385] = {.lex_state = 94, .external_lex_state = 4},
  [386] = {.lex_state = 16, .external_lex_state = 2},
  [387] = {.lex_state = 16, .external_lex_state = 2},
  [388] = {.lex_state = 16, .external_lex_state = 2},
  [389] = {.lex_state = 16, .external_lex_state = 2},
  [390] = {.lex_state = 16, .external_lex_state = 2},
  [391] = {.lex_state = 16, .external_lex_state = 2},
  [392] = {.lex_state = 16, .external_lex_state = 2},
  [393] = {.lex_state = 16, .external_lex_state = 2},
  [394] = {.lex_state = 16, .external_lex_state = 2},
  [395] = {.lex_state = 16, .external_lex_state = 2},
  [396] = {.lex_state = 16, .external_lex_state = 2},
  [397] = {.lex_state = 16, .external_lex_state = 2},
  [398] = {.lex_state = 16, .external_lex_state = 2},
  [399] = {.lex_state = 16, .external_lex_state = 2},
  [400] = {.lex_state = 16, .external_lex_state = 2},
  [401] = {.lex_state = 16, .external_lex_state = 2},
  [402] = {.lex_state = 16, .external_lex_state = 2},
  [403] = {.lex_state = 16, .external_lex_state = 2},
  [404] = {.lex_state = 16, .external_lex_state = 2},
  [405] = {.lex_state = 16, .external_lex_state = 2},
  [406] = {.lex_state = 16, .external_lex_state = 2},
  [407] = {.lex_state = 16, .external_lex_state = 2},
  [408] = {.lex_state = 16, .external_lex_state = 2},
  [409] = {.lex_state = 16, .external_lex_state = 2},
  [410] = {.lex_state = 16, .external_lex_state = 2},
  [411] = {.lex_state = 16, .external_lex_state = 2},
  [412] = {.lex_state = 16, .external_lex_state = 2},
  [413] = {.lex_state = 16, .external_lex_state = 2},
  [414] = {.lex_state = 94, .external_lex_state = 4},
  [415] = {.lex_state = 94, .external_lex_state = 4},
  [416] = {.lex_state = 16, .external_lex_state = 2},
  [417] = {.lex_state = 16, .external_lex_state = 2},
  [418] = {.lex_state = 94, .external_lex_state = 4},
  [419] = {.lex_state = 16, .external_lex_state = 2},
  [420] = {.lex_state = 16, .external_lex_state = 2},
  [421] = {.lex_state = 16, .external_lex_state = 2},
  [422] = {.lex_state = 16, .external_lex_state = 2},
  [423] = {.lex_state = 16, .external_lex_state = 2},
  [424] = {.lex_state = 16, .external_lex_state = 2},
  [425] = {.lex_state = 16, .external_lex_state = 2},
  [426] = {.lex_state = 16, .external_lex_state = 2},
  [427] = {.lex_state = 16, .external_lex_state = 2},
  [428] = {.lex_state = 16, .external_lex_state = 2},
  [429] = {.lex_state = 16, .external_lex_state = 2},
  [430] = {.lex_state = 16, .external_lex_state = 2},
  [431] = {.lex_state = 16, .external_lex_state = 2},
  [432] = {.lex_state = 94, .external_lex_state = 4},
  [433] = {.lex_state = 16, .external_lex_state = 2},
  [434] = {.lex_state = 16, .external_lex_state = 2},
  [435] = {.lex_state = 16, .external_lex_state = 2},
  [436] = {.lex_state = 94, .external_lex_state = 4},
  [437] = {.lex_state = 16, .external_lex_state = 2},
  [438] = {.lex_state = 16, .external_lex_state = 2},
  [439] = {.lex_state = 16, .external_lex_state = 2},
  [440] = {.lex_state = 16, .external_lex_state = 2},
  [441] = {.lex_state = 16, .external_lex_state = 2},
  [442] = {.lex_state = 16, .external_lex_state = 2},
  [443] = {.lex_state = 16, .external_lex_state = 2},
  [444] = {.lex_state = 16, .external_lex_state = 2},
  [445] = {.lex_state = 16, .external_lex_state = 2},
  [446] = {.lex_state = 16, .external_lex_state = 2},
  [447] = {.lex_state = 16, .external_lex_state = 2},
  [448] = {.lex_state = 16, .external_lex_state = 2},
  [449] = {.lex_state = 94, .external_lex_state = 4},
  [450] = {.lex_state = 16, .external_lex_state = 2},
  [451] = {.lex_state = 16, .external_lex_state = 2},
  [452] = {.lex_state = 16, .external_lex_state = 2},
  [453] = {.lex_state = 16, .external_lex_state = 2},
  [454] = {.lex_state = 16, .external_lex_state = 2},
  [455] = {.lex_state = 16, .external_lex_state = 2},
  [456] = {.lex_state = 16, .external_lex_state = 2},
  [457] = {.lex_state = 16, .external_lex_state = 2},
  [458] = {.lex_state = 16, .external_lex_state = 2},
  [459] = {.lex_state = 16, .external_lex_state = 2},
  [460] = {.lex_state = 16, .external_lex_state = 2},
  [461] = {.lex_state = 16, .external_lex_state = 2},
  [462] = {.lex_state = 16, .external_lex_state = 2},
  [463] = {.lex_state = 16, .external_lex_state = 2},
  [464] = {.lex_state = 16, .external_lex_state = 2},
  [465] = {.lex_state = 16, .external_lex_state = 2},
  [466] = {.lex_state = 16, .external_lex_state = 2},
  [467] = {.lex_state = 16, .external_lex_state = 2},
  [468] = {.lex_state = 16, .external_lex_state = 2},
  [469] = {.lex_state = 16, .external_lex_state = 2},
  [470] = {.lex_state = 16, .external_lex_state = 2},
  [471] = {.lex_state = 16, .external_lex_state = 2},
  [472] = {.lex_state = 16, .external_lex_state = 2},
  [473] = {.lex_state = 16, .external_lex_state = 2},
  [474] = {.lex_state = 16, .external_lex_state = 2},
  [475] = {.lex_state = 16, .external_lex_state = 2},
  [476] = {.lex_state = 16, .external_lex_state = 2},
  [477] = {.lex_state = 16, .external_lex_state = 2},
  [478] = {.lex_state = 16, .external_lex_state = 2},
  [479] = {.lex_state = 16, .external_lex_state = 2},
  [480] = {.lex_state = 16, .external_lex_state = 2},
  [481] = {.lex_state = 16, .external_lex_state = 2},
  [482] = {.lex_state = 16, .external_lex_state = 2},
  [483] = {.lex_state = 16, .external_lex_state = 2},
  [484] = {.lex_state = 16, .external_lex_state = 2},
  [485] = {.lex_state = 16, .external_lex_state = 2},
  [486] = {.lex_state = 16, .external_lex_state = 2},
  [487] = {.lex_state = 16, .external_lex_state = 2},
  [488] = {.lex_state = 16, .external_lex_state = 2},
  [489] = {.lex_state = 16, .external_lex_state = 2},
  [490] = {.lex_state = 16, .external_lex_state = 2},
  [491] = {.lex_state = 16, .external_lex_state = 2},
  [492] = {.lex_state = 16, .external_lex_state = 2},
  [493] = {.lex_state = 16, .external_lex_state = 2},
  [494] = {.lex_state = 16, .external_lex_state = 2},
  [495] = {.lex_state = 16, .external_lex_state = 2},
  [496] = {.lex_state = 16, .external_lex_state = 2},
  [497] = {.lex_state = 16, .external_lex_state = 2},
  [498] = {.lex_state = 16, .external_lex_state = 2},
  [499] = {.lex_state = 16, .external_lex_state = 2},
  [500] = {.lex_state = 16, .external_lex_state = 2},
  [501] = {.lex_state = 16, .external_lex_state = 2},
  [502] = {.lex_state = 16, .external_lex_state = 2},
  [503] = {.lex_state = 16, .external_lex_state = 2},
  [504] = {.lex_state = 16, .external_lex_state = 2},
  [505] = {.lex_state = 16, .external_lex_state = 2},
  [506] = {.lex_state = 16, .external_lex_state = 2},
  [507] = {.lex_state = 16, .external_lex_state = 2},
  [508] = {.lex_state = 16, .external_lex_state = 2},
  [509] = {.lex_state = 16, .external_lex_state = 2},
  [510] = {.lex_state = 16, .external_lex_state = 2},
  [511] = {.lex_state = 16, .external_lex_state = 2},
  [512] = {.lex_state = 16, .external_lex_state = 2},
  [513] = {.lex_state = 16, .external_lex_state = 2},
  [514] = {.lex_state = 16, .external_lex_state = 2},
  [515] = {.lex_state = 16, .external_lex_state = 2},
  [516] = {.lex_state = 16, .external_lex_state = 2},
  [517] = {.lex_state = 16, .external_lex_state = 2},
  [518] = {.lex_state = 16, .external_lex_state = 2},
  [519] = {.lex_state = 16, .external_lex_state = 2},
  [520] = {.lex_state = 16, .external_lex_state = 2},
  [521] = {.lex_state = 16, .external_lex_state = 2},
  [522] = {.lex_state = 16, .external_lex_state = 2},
  [523] = {.lex_state = 16, .external_lex_state = 2},
  [524] = {.lex_state = 16, .external_lex_state = 2},
  [525] = {.lex_state = 16, .external_lex_state = 2},
  [526] = {.lex_state = 16, .external_lex_state = 2},
  [527] = {.lex_state = 16, .external_lex_state = 2},
  [528] = {.lex_state = 16, .external_lex_state = 2},
  [529] = {.lex_state = 16, .external_lex_state = 2},
  [530] = {.lex_state = 16, .external_lex_state = 2},
  [531] = {.lex_state = 16, .external_lex_state = 2},
  [532] = {.lex_state = 16, .external_lex_state = 2},
  [533] = {.lex_state = 16, .external_lex_state = 2},
  [534] = {.lex_state = 16, .external_lex_state = 2},
  [535] = {.lex_state = 16, .external_lex_state = 2},
  [536] = {.lex_state = 16, .external_lex_state = 2},
  [537] = {.lex_state = 16, .external_lex_state = 2},
  [538] = {.lex_state = 16, .external_lex_state = 2},
  [539] = {.lex_state = 16, .external_lex_state = 2},
  [540] = {.lex_state = 16, .external_lex_state = 2},
  [541] = {.lex_state = 16, .external_lex_state = 2},
  [542] = {.lex_state = 16, .external_lex_state = 2},
  [543] = {.lex_state = 16, .external_lex_state = 2},
  [544] = {.lex_state = 16, .external_lex_state = 2},
  [545] = {.lex_state = 16, .external_lex_state = 2},
  [546] = {.lex_state = 16, .external_lex_state = 2},
  [547] = {.lex_state = 16, .external_lex_state = 2},
  [548] = {.lex_state = 16, .external_lex_state = 2},
  [549] = {.lex_state = 16, .external_lex_state = 2},
  [550] = {.lex_state = 16, .external_lex_state = 2},
  [551] = {.lex_state = 16, .external_lex_state = 2},
  [552] = {.lex_state = 16, .external_lex_state = 2},
  [553] = {.lex_state = 16, .external_lex_state = 2},
  [554] = {.lex_state = 16, .external_lex_state = 2},
  [555] = {.lex_state = 16, .external_lex_state = 2},
  [556] = {.lex_state = 16, .external_lex_state = 2},
  [557] = {.lex_state = 16, .external_lex_state = 2},
  [558] = {.lex_state = 16, .external_lex_state = 2},
  [559] = {.lex_state = 16, .external_lex_state = 2},
  [560] = {.lex_state = 16, .external_lex_state = 2},
  [561] = {.lex_state = 16, .external_lex_state = 2},
  [562] = {.lex_state = 16, .external_lex_state = 2},
  [563] = {.lex_state = 16, .external_lex_state = 2},
  [564] = {.lex_state = 16, .external_lex_state = 2},
  [565] = {.lex_state = 16, .external_lex_state = 2},
  [566] = {.lex_state = 16, .external_lex_state = 2},
  [567] = {.lex_state = 16, .external_lex_state = 2},
  [568] = {.lex_state = 16, .external_lex_state = 2},
  [569] = {.lex_state = 16, .external_lex_state = 2},
  [570] = {.lex_state = 16, .external_lex_state = 2},
  [571] = {.lex_state = 16, .external_lex_state = 2},
  [572] = {.lex_state = 16, .external_lex_state = 2},
  [573] = {.lex_state = 16, .external_lex_state = 2},
  [574] = {.lex_state = 16, .external_lex_state = 2},
  [575] = {.lex_state = 16, .external_lex_state = 2},
  [576] = {.lex_state = 16, .external_lex_state = 2},
  [577] = {.lex_state = 16, .external_lex_state = 2},
  [578] = {.lex_state = 16, .external_lex_state = 2},
  [579] = {.lex_state = 16, .external_lex_state = 2},
  [580] = {.lex_state = 16, .external_lex_state = 2},
  [581] = {.lex_state = 16, .external_lex_state = 2},
  [582] = {.lex_state = 16, .external_lex_state = 2},
  [583] = {.lex_state = 16, .external_lex_state = 2},
  [584] = {.lex_state = 16, .external_lex_state = 2},
  [585] = {.lex_state = 16, .external_lex_state = 2},
  [586] = {.lex_state = 16, .external_lex_state = 2},
  [587] = {.lex_state = 16, .external_lex_state = 2},
  [588] = {.lex_state = 16, .external_lex_state = 2},
  [589] = {.lex_state = 16, .external_lex_state = 2},
  [590] = {.lex_state = 16, .external_lex_state = 2},
  [591] = {.lex_state = 16, .external_lex_state = 2},
  [592] = {.lex_state = 16, .external_lex_state = 2},
  [593] = {.lex_state = 16, .external_lex_state = 2},
  [594] = {.lex_state = 16, .external_lex_state = 2},
  [595] = {.lex_state = 16, .external_lex_state = 2},
  [596] = {.lex_state = 16, .external_lex_state = 2},
  [597] = {.lex_state = 16, .external_lex_state = 2},
  [598] = {.lex_state = 16, .external_lex_state = 2},
  [599] = {.lex_state = 16, .external_lex_state = 2},
  [600] = {.lex_state = 16, .external_lex_state = 2},
  [601] = {.lex_state = 16, .external_lex_state = 2},
  [602] = {.lex_state = 16, .external_lex_state = 2},
  [603] = {.lex_state = 16, .external_lex_state = 2},
  [604] = {.lex_state = 16, .external_lex_state = 2},
  [605] = {.lex_state = 16, .external_lex_state = 2},
  [606] = {.lex_state = 16, .external_lex_state = 2},
  [607] = {.lex_state = 16, .external_lex_state = 2},
  [608] = {.lex_state = 16, .external_lex_state = 2},
  [609] = {.lex_state = 16, .external_lex_state = 2},
  [610] = {.lex_state = 16, .external_lex_state = 2},
  [611] = {.lex_state = 16, .external_lex_state = 2},
  [612] = {.lex_state = 16, .external_lex_state = 2},
  [613] = {.lex_state = 16, .external_lex_state = 2},
  [614] = {.lex_state = 16, .external_lex_state = 2},
  [615] = {.lex_state = 16, .external_lex_state = 2},
  [616] = {.lex_state = 16, .external_lex_state = 2},
  [617] = {.lex_state = 16, .external_lex_state = 2},
  [618] = {.lex_state = 16, .external_lex_state = 2},
  [619] = {.lex_state = 16, .external_lex_state = 2},
  [620] = {.lex_state = 16, .external_lex_state = 2},
  [621] = {.lex_state = 16, .external_lex_state = 2},
  [622] = {.lex_state = 16, .external_lex_state = 2},
  [623] = {.lex_state = 16, .external_lex_state = 2},
  [624] = {.lex_state = 16, .external_lex_state = 2},
  [625] = {.lex_state = 16, .external_lex_state = 2},
  [626] = {.lex_state = 16, .external_lex_state = 2},
  [627] = {.lex_state = 16, .external_lex_state = 2},
  [628] = {.lex_state = 16, .external_lex_state = 2},
  [629] = {.lex_state = 16, .external_lex_state = 2},
  [630] = {.lex_state = 16, .external_lex_state = 2},
  [631] = {.lex_state = 16, .external_lex_state = 2},
  [632] = {.lex_state = 16, .external_lex_state = 2},
  [633] = {.lex_state = 16, .external_lex_state = 2},
  [634] = {.lex_state = 16, .external_lex_state = 2},
  [635] = {.lex_state = 16, .external_lex_state = 2},
  [636] = {.lex_state = 16, .external_lex_state = 2},
  [637] = {.lex_state = 16, .external_lex_state = 2},
  [638] = {.lex_state = 16, .external_lex_state = 2},
  [639] = {.lex_state = 16, .external_lex_state = 2},
  [640] = {.lex_state = 16, .external_lex_state = 2},
  [641] = {.lex_state = 16, .external_lex_state = 2},
  [642] = {.lex_state = 16, .external_lex_state = 2},
  [643] = {.lex_state = 16, .external_lex_state = 2},
  [644] = {.lex_state = 16, .external_lex_state = 2},
  [645] = {.lex_state = 16, .external_lex_state = 2},
  [646] = {.lex_state = 16, .external_lex_state = 2},
  [647] = {.lex_state = 16, .external_lex_state = 2},
  [648] = {.lex_state = 16, .external_lex_state = 2},
  [649] = {.lex_state = 16, .external_lex_state = 2},
  [650] = {.lex_state = 16, .external_lex_state = 2},
  [651] = {.lex_state = 16, .external_lex_state = 2},
  [652] = {.lex_state = 16, .external_lex_state = 2},
  [653] = {.lex_state = 16, .external_lex_state = 2},
  [654] = {.lex_state = 16, .external_lex_state = 2},
  [655] = {.lex_state = 16, .external_lex_state = 2},
  [656] = {.lex_state = 16, .external_lex_state = 2},
  [657] = {.lex_state = 16, .external_lex_state = 2},
  [658] = {.lex_state = 16, .external_lex_state = 2},
  [659] = {.lex_state = 16, .external_lex_state = 2},
  [660] = {.lex_state = 16, .external_lex_state = 2},
  [661] = {.lex_state = 16, .external_lex_state = 2},
  [662] = {.lex_state = 16, .external_lex_state = 2},
  [663] = {.lex_state = 16, .external_lex_state = 2},
  [664] = {.lex_state = 16, .external_lex_state = 2},
  [665] = {.lex_state = 16, .external_lex_state = 2},
  [666] = {.lex_state = 16, .external_lex_state = 2},
  [667] = {.lex_state = 16, .external_lex_state = 2},
  [668] = {.lex_state = 16, .external_lex_state = 2},
  [669] = {.lex_state = 16, .external_lex_state = 2},
  [670] = {.lex_state = 16, .external_lex_state = 2},
  [671] = {.lex_state = 16, .external_lex_state = 2},
  [672] = {.lex_state = 16, .external_lex_state = 2},
  [673] = {.lex_state = 16, .external_lex_state = 2},
  [674] = {.lex_state = 16, .external_lex_state = 2},
  [675] = {.lex_state = 16, .external_lex_state = 2},
  [676] = {.lex_state = 16, .external_lex_state = 2},
  [677] = {.lex_state = 16, .external_lex_state = 2},
  [678] = {.lex_state = 16, .external_lex_state = 2},
  [679] = {.lex_state = 16, .external_lex_state = 2},
  [680] = {.lex_state = 16, .external_lex_state = 2},
  [681] = {.lex_state = 16, .external_lex_state = 2},
  [682] = {.lex_state = 16, .external_lex_state = 2},
  [683] = {.lex_state = 16, .external_lex_state = 2},
  [684] = {.lex_state = 16, .external_lex_state = 2},
  [685] = {.lex_state = 16, .external_lex_state = 2},
  [686] = {.lex_state = 16, .external_lex_state = 2},
  [687] = {.lex_state = 16, .external_lex_state = 2},
  [688] = {.lex_state = 16, .external_lex_state = 2},
  [689] = {.lex_state = 16, .external_lex_state = 2},
  [690] = {.lex_state = 16, .external_lex_state = 2},
  [691] = {.lex_state = 16, .external_lex_state = 2},
  [692] = {.lex_state = 16, .external_lex_state = 2},
  [693] = {.lex_state = 16, .external_lex_state = 2},
  [694] = {.lex_state = 16, .external_lex_state = 2},
  [695] = {.lex_state = 16, .external_lex_state = 2},
  [696] = {.lex_state = 16, .external_lex_state = 2},
  [697] = {.lex_state = 16, .external_lex_state = 2},
  [698] = {.lex_state = 16, .external_lex_state = 2},
  [699] = {.lex_state = 16, .external_lex_state = 2},
  [700] = {.lex_state = 16, .external_lex_state = 2},
  [701] = {.lex_state = 16, .external_lex_state = 2},
  [702] = {.lex_state = 16, .external_lex_state = 2},
  [703] = {.lex_state = 16, .external_lex_state = 2},
  [704] = {.lex_state = 16, .external_lex_state = 2},
  [705] = {.lex_state = 16, .external_lex_state = 2},
  [706] = {.lex_state = 16, .external_lex_state = 2},
  [707] = {.lex_state = 16, .external_lex_state = 2},
  [708] = {.lex_state = 16, .external_lex_state = 2},
  [709] = {.lex_state = 16, .external_lex_state = 2},
  [710] = {.lex_state = 16, .external_lex_state = 2},
  [711] = {.lex_state = 16, .external_lex_state = 2},
  [712] = {.lex_state = 16, .external_lex_state = 2},
  [713] = {.lex_state = 16, .external_lex_state = 2},
  [714] = {.lex_state = 16, .external_lex_state = 2},
  [715] = {.lex_state = 16, .external_lex_state = 2},
  [716] = {.lex_state = 16, .external_lex_state = 2},
  [717] = {.lex_state = 16, .external_lex_state = 2},
  [718] = {.lex_state = 16, .external_lex_state = 2},
  [719] = {.lex_state = 16, .external_lex_state = 2},
  [720] = {.lex_state = 16, .external_lex_state = 2},
  [721] = {.lex_state = 16, .external_lex_state = 2},
  [722] = {.lex_state = 16, .external_lex_state = 2},
  [723] = {.lex_state = 16, .external_lex_state = 2},
  [724] = {.lex_state = 16, .external_lex_state = 2},
  [725] = {.lex_state = 16, .external_lex_state = 2},
  [726] = {.lex_state = 16, .external_lex_state = 2},
  [727] = {.lex_state = 16, .external_lex_state = 2},
  [728] = {.lex_state = 16, .external_lex_state = 2},
  [729] = {.lex_state = 16, .external_lex_state = 2},
  [730] = {.lex_state = 16, .external_lex_state = 2},
  [731] = {.lex_state = 16, .external_lex_state = 2},
  [732] = {.lex_state = 16, .external_lex_state = 2},
  [733] = {.lex_state = 16, .external_lex_state = 2},
  [734] = {.lex_state = 16, .external_lex_state = 2},
  [735] = {.lex_state = 16, .external_lex_state = 2},
  [736] = {.lex_state = 16, .external_lex_state = 2},
  [737] = {.lex_state = 16, .external_lex_state = 2},
  [738] = {.lex_state = 16, .external_lex_state = 2},
  [739] = {.lex_state = 16, .external_lex_state = 2},
  [740] = {.lex_state = 16, .external_lex_state = 2},
  [741] = {.lex_state = 16, .external_lex_state = 2},
  [742] = {.lex_state = 16, .external_lex_state = 2},
  [743] = {.lex_state = 16, .external_lex_state = 2},
  [744] = {.lex_state = 16, .external_lex_state = 2},
  [745] = {.lex_state = 16, .external_lex_state = 2},
  [746] = {.lex_state = 16, .external_lex_state = 2},
  [747] = {.lex_state = 16, .external_lex_state = 2},
  [748] = {.lex_state = 16, .external_lex_state = 2},
  [749] = {.lex_state = 16, .external_lex_state = 2},
  [750] = {.lex_state = 16, .external_lex_state = 2},
  [751] = {.lex_state = 16, .external_lex_state = 2},
  [752] = {.lex_state = 16, .external_lex_state = 7},
  [753] = {.lex_state = 16, .external_lex_state = 7},
  [754] = {.lex_state = 16, .external_lex_state = 7},
  [755] = {.lex_state = 16, .external_lex_state = 7},
  [756] = {.lex_state = 16, .external_lex_state = 7},
  [757] = {.lex_state = 16, .external_lex_state = 7},
  [758] = {.lex_state = 16, .external_lex_state = 7},
  [759] = {.lex_state = 16, .external_lex_state = 7},
  [760] = {.lex_state = 16, .external_lex_state = 7},
  [761] = {.lex_state = 16, .external_lex_state = 7},
  [762] = {.lex_state = 16, .external_lex_state = 7},
  [763] = {.lex_state = 16, .external_lex_state = 7},
  [764] = {.lex_state = 16, .external_lex_state = 7},
  [765] = {.lex_state = 16, .external_lex_state = 7},
  [766] = {.lex_state = 16, .external_lex_state = 7},
  [767] = {.lex_state = 16, .external_lex_state = 7},
  [768] = {.lex_state = 16, .external_lex_state = 7},
  [769] = {.lex_state = 16, .external_lex_state = 7},
  [770] = {.lex_state = 16, .external_lex_state = 7},
  [771] = {.lex_state = 16, .external_lex_state = 7},
  [772] = {.lex_state = 16, .external_lex_state = 7},
  [773] = {.lex_state = 16, .external_lex_state = 7},
  [774] = {.lex_state = 95, .external_lex_state = 4},
  [775] = {.lex_state = 16, .external_lex_state = 7},
  [776] = {.lex_state = 16, .external_lex_state = 7},
  [777] = {.lex_state = 16, .external_lex_state = 7},
  [778] = {.lex_state = 16, .external_lex_state = 7},
  [779] = {.lex_state = 16, .external_lex_state = 7},
  [780] = {.lex_state = 16, .external_lex_state = 7},
  [781] = {.lex_state = 16, .external_lex_state = 7},
  [782] = {.lex_state = 16, .external_lex_state = 7},
  [783] = {.lex_state = 16, .external_lex_state = 7},
  [784] = {.lex_state = 95, .external_lex_state = 4},
  [785] = {.lex_state = 16, .external_lex_state = 7},
  [786] = {.lex_state = 16, .external_lex_state = 7},
  [787] = {.lex_state = 16, .external_lex_state = 7},
  [788] = {.lex_state = 16, .external_lex_state = 7},
  [789] = {.lex_state = 16, .external_lex_state = 7},
  [790] = {.lex_state = 16, .external_lex_state = 7},
  [791] = {.lex_state = 16, .external_lex_state = 7},
  [792] = {.lex_state = 16, .external_lex_state = 7},
  [793] = {.lex_state = 16, .external_lex_state = 7},
  [794] = {.lex_state = 16, .external_lex_state = 7},
  [795] = {.lex_state = 16, .external_lex_state = 7},
  [796] = {.lex_state = 16, .external_lex_state = 7},
  [797] = {.lex_state = 16, .external_lex_state = 7},
  [798] = {.lex_state = 16, .external_lex_state = 7},
  [799] = {.lex_state = 16, .external_lex_state = 7},
  [800] = {.lex_state = 16, .external_lex_state = 7},
  [801] = {.lex_state = 16, .external_lex_state = 7},
  [802] = {.lex_state = 16, .external_lex_state = 7},
  [803] = {.lex_state = 95, .external_lex_state = 4},
  [804] = {.lex_state = 95, .external_lex_state = 4},
  [805] = {.lex_state = 16, .external_lex_state = 7},
  [806] = {.lex_state = 16, .external_lex_state = 7},
  [807] = {.lex_state = 95, .external_lex_state = 4},
  [808] = {.lex_state = 16, .external_lex_state = 7},
  [809] = {.lex_state = 16, .external_lex_state = 7},
  [810] = {.lex_state = 16, .external_lex_state = 7},
  [811] = {.lex_state = 16, .external_lex_state = 7},
  [812] = {.lex_state = 16, .external_lex_state = 7},
  [813] = {.lex_state = 16, .external_lex_state = 7},
  [814] = {.lex_state = 16, .external_lex_state = 7},
  [815] = {.lex_state = 16, .external_lex_state = 7},
  [816] = {.lex_state = 16, .external_lex_state = 7},
  [817] = {.lex_state = 16, .external_lex_state = 7},
  [818] = {.lex_state = 16, .external_lex_state = 7},
  [819] = {.lex_state = 16, .external_lex_state = 7},
  [820] = {.lex_state = 16, .external_lex_state = 7},
  [821] = {.lex_state = 16, .external_lex_state = 7},
  [822] = {.lex_state = 16, .external_lex_state = 7},
  [823] = {.lex_state = 16, .external_lex_state = 7},
  [824] = {.lex_state = 16, .external_lex_state = 7},
  [825] = {.lex_state = 16, .external_lex_state = 7},
  [826] = {.lex_state = 16, .external_lex_state = 7},
  [827] = {.lex_state = 16, .external_lex_state = 7},
  [828] = {.lex_state = 16, .external_lex_state = 7},
  [829] = {.lex_state = 16, .external_lex_state = 7},
  [830] = {.lex_state = 16, .external_lex_state = 7},
  [831] = {.lex_state = 16, .external_lex_state = 7},
  [832] = {.lex_state = 16, .external_lex_state = 7},
  [833] = {.lex_state = 16, .external_lex_state = 7},
  [834] = {.lex_state = 16, .external_lex_state = 7},
  [835] = {.lex_state = 16, .external_lex_state = 7},
  [836] = {.lex_state = 16, .external_lex_state = 7},
  [837] = {.lex_state = 16, .external_lex_state = 7},
  [838] = {.lex_state = 16, .external_lex_state = 7},
  [839] = {.lex_state = 16, .external_lex_state = 7},
  [840] = {.lex_state = 16, .external_lex_state = 7},
  [841] = {.lex_state = 16, .external_lex_state = 7},
  [842] = {.lex_state = 16, .external_lex_state = 7},
  [843] = {.lex_state = 16, .external_lex_state = 7},
  [844] = {.lex_state = 16, .external_lex_state = 7},
  [845] = {.lex_state = 16, .external_lex_state = 7},
  [846] = {.lex_state = 16, .external_lex_state = 7},
  [847] = {.lex_state = 16, .external_lex_state = 7},
  [848] = {.lex_state = 16, .external_lex_state = 7},
  [849] = {.lex_state = 16, .external_lex_state = 7},
  [850] = {.lex_state = 16, .external_lex_state = 7},
  [851] = {.lex_state = 16, .external_lex_state = 7},
  [852] = {.lex_state = 16, .external_lex_state = 7},
  [853] = {.lex_state = 95, .external_lex_state = 4},
  [854] = {.lex_state = 16, .external_lex_state = 7},
  [855] = {.lex_state = 16, .external_lex_state = 7},
  [856] = {.lex_state = 16, .external_lex_state = 7},
  [857] = {.lex_state = 16, .external_lex_state = 7},
  [858] = {.lex_state = 16, .external_lex_state = 7},
  [859] = {.lex_state = 108, .external_lex_state = 2},
  [860] = {.lex_state = 108, .external_lex_state = 2},
  [861] = {.lex_state = 16, .external_lex_state = 2},
  [862] = {.lex_state = 16, .external_lex_state = 2},
  [863] = {.lex_state = 108, .external_lex_state = 2},
  [864] = {.lex_state = 16, .external_lex_state = 2},
  [865] = {.lex_state = 16, .external_lex_state = 7},
  [866] = {.lex_state = 16, .external_lex_state = 2},
  [867] = {.lex_state = 16, .external_lex_state = 15},
  [868] = {.lex_state = 16, .external_lex_state = 15},
  [869] = {.lex_state = 16, .external_lex_state = 15},
  [870] = {.lex_state = 16, .external_lex_state = 2},
  [871] = {.lex_state = 16, .external_lex_state = 16},
  [872] = {.lex_state = 16, .external_lex_state = 2},
  [873] = {.lex_state = 16, .external_lex_state = 2},
  [874] = {.lex_state = 16, .external_lex_state = 2},
  [875] = {.lex_state = 16, .external_lex_state = 7},
  [876] = {.lex_state = 101, .external_lex_state = 17},
  [877] = {.lex_state = 101, .external_lex_state = 17},
  [878] = {.lex_state = 102, .external_lex_state = 17},
  [879] = {.lex_state = 102, .external_lex_state = 17},
  [880] = {.lex_state = 101, .external_lex_state = 17},
  [881] = {.lex_state = 101, .external_lex_state = 17},
  [882] = {.lex_state = 101, .external_lex_state = 17},
  [883] = {.lex_state = 101, .external_lex_state = 17},
  [884] = {.lex_state = 102, .external_lex_state = 17},
  [885] = {.lex_state = 102, .external_lex_state = 17},
  [886] = {.lex_state = 101, .external_lex_state = 17},
  [887] = {.lex_state = 101, .external_lex_state = 17},
  [888] = {.lex_state = 101, .external_lex_state = 17},
  [889] = {.lex_state = 101, .external_lex_state = 17},
  [890] = {.lex_state = 101, .external_lex_state = 17},
  [891] = {.lex_state = 101, .external_lex_state = 17},
  [892] = {.lex_state = 101, .external_lex_state = 17},
  [893] = {.lex_state = 101, .external_lex_state = 17},
  [894] = {.lex_state = 100, .external_lex_state = 2},
  [895] = {.lex_state = 101, .external_lex_state = 17},
  [896] = {.lex_state = 101, .external_lex_state = 17},
  [897] = {.lex_state = 101, .external_lex_state = 17},
  [898] = {.lex_state = 102, .external_lex_state = 17},
  [899] = {.lex_state = 101, .external_lex_state = 17},
  [900] = {.lex_state = 101, .external_lex_state = 17},
  [901] = {.lex_state = 101, .external_lex_state = 17},
  [902] = {.lex_state = 101, .external_lex_state = 17},
  [903] = {.lex_state = 102, .external_lex_state = 17},
  [904] = {.lex_state = 102, .external_lex_state = 17},
  [905] = {.lex_state = 102, .external_lex_state = 17},
  [906] = {.lex_state = 101, .external_lex_state = 17},
  [907] = {.lex_state = 102, .external_lex_state = 17},
  [908] = {.lex_state = 101, .external_lex_state = 17},
  [909] = {.lex_state = 101, .external_lex_state = 17},
  [910] = {.lex_state = 101, .external_lex_state = 17},
  [911] = {.lex_state = 101, .external_lex_state = 17},
  [912] = {.lex_state = 101, .external_lex_state = 17},
  [913] = {.lex_state = 101, .external_lex_state = 17},
  [914] = {.lex_state = 101, .external_lex_state = 17},
  [915] = {.lex_state = 101, .external_lex_state = 17},
  [916] = {.lex_state = 101, .external_lex_state = 17},
  [917] = {.lex_state = 101, .external_lex_state = 17},
  [918] = {.lex_state = 102, .external_lex_state = 17},
  [919] = {.lex_state = 101, .external_lex_state = 17},
  [920] = {.lex_state = 101, .external_lex_state = 17},
  [921] = {.lex_state = 101, .external_lex_state = 17},
  [922] = {.lex_state = 101, .external_lex_state = 17},
  [923] = {.lex_state = 102, .external_lex_state = 17},
  [924] = {.lex_state = 102, .external_lex_state = 17},
  [925] = {.lex_state = 101, .external_lex_state = 17},
  [926] = {.lex_state = 102, .external_lex_state = 17},
  [927] = {.lex_state = 100, .external_lex_state = 2},
  [928] = {.lex_state = 102, .external_lex_state = 17},
  [929] = {.lex_state = 101, .external_lex_state = 17},
  [930] = {.lex_state = 102, .external_lex_state = 17},
  [931] = {.lex_state = 102, .external_lex_state = 17},
  [932] = {.lex_state = 102, .external_lex_state = 17},
  [933] = {.lex_state = 102, .external_lex_state = 17},
  [934] = {.lex_state = 102, .external_lex_state = 17},
  [935] = {.lex_state = 102, .external_lex_state = 17},
  [936] = {.lex_state = 100, .external_lex_state = 2},
  [937] = {.lex_state = 102, .external_lex_state = 17},
  [938] = {.lex_state = 102, .external_lex_state = 17},
  [939] = {.lex_state = 102, .external_lex_state = 17},
  [940] = {.lex_state = 102, .external_lex_state = 17},
  [941] = {.lex_state = 102, .external_lex_state = 17},
  [942] = {.lex_state = 102, .external_lex_state = 17},
  [943] = {.lex_state = 102, .external_lex_state = 17},
  [944] = {.lex_state = 102, .external_lex_state = 17},
  [945] = {.lex_state = 102, .external_lex_state = 17},
  [946] = {.lex_state = 102, .external_lex_state = 17},
  [947] = {.lex_state = 100, .external_lex_state = 2},
  [948] = {.lex_state = 102, .external_lex_state = 17},
  [949] = {.lex_state = 102, .external_lex_state = 17},
  [950] = {.lex_state = 102, .external_lex_state = 17},
  [951] = {.lex_state = 102, .external_lex_state = 17},
  [952] = {.lex_state = 102, .external_lex_state = 17},
  [953] = {.lex_state = 100, .external_lex_state = 5},
  [954] = {.lex_state = 100, .external_lex_state = 5},
  [955] = {.lex_state = 100, .external_lex_state = 5},
  [956] = {.lex_state = 100, .external_lex_state = 2},
  [957] = {.lex_state = 100, .external_lex_state = 5},
  [958] = {.lex_state = 100, .external_lex_state = 5},
  [959] = {.lex_state = 102, .external_lex_state = 17},
  [960] = {.lex_state = 100, .external_lex_state = 5},
  [961] = {.lex_state = 100, .external_lex_state = 5},
  [962] = {.lex_state = 100, .external_lex_state = 5},
  [963] = {.lex_state = 100, .external_lex_state = 5},
  [964] = {.lex_state = 100, .external_lex_state = 5},
  [965] = {.lex_state = 100, .external_lex_state = 2},
  [966] = {.lex_state = 100, .external_lex_state = 2},
  [967] = {.lex_state = 100, .external_lex_state = 2},
  [968] = {.lex_state = 100, .external_lex_state = 2},
  [969] = {.lex_state = 100, .external_lex_state = 2},
  [970] = {.lex_state = 100, .external_lex_state = 2},
  [971] = {.lex_state = 100, .external_lex_state = 2},
  [972] = {.lex_state = 100, .external_lex_state = 2},
  [973] = {.lex_state = 100, .external_lex_state = 2},
  [974] = {.lex_state = 101, .external_lex_state = 18},
  [975] = {.lex_state = 100, .external_lex_state = 2},
  [976] = {.lex_state = 100, .external_lex_state = 2},
  [977] = {.lex_state = 101, .external_lex_state = 18},
  [978] = {.lex_state = 100, .external_lex_state = 2},
  [979] = {.lex_state = 102, .external_lex_state = 18},
  [980] = {.lex_state = 102, .external_lex_state = 18},
  [981] = {.lex_state = 102, .external_lex_state = 19},
  [982] = {.lex_state = 101, .external_lex_state = 18},
  [983] = {.lex_state = 101, .external_lex_state = 18},
  [984] = {.lex_state = 101, .external_lex_state = 17},
  [985] = {.lex_state = 101, .external_lex_state = 17},
  [986] = {.lex_state = 101, .external_lex_state = 18},
  [987] = {.lex_state = 101, .external_lex_state = 18},
  [988] = {.lex_state = 102, .external_lex_state = 17},
  [989] = {.lex_state = 101, .external_lex_state = 17},
  [990] = {.lex_state = 105, .external_lex_state = 20},
  [991] = {.lex_state = 102, .external_lex_state = 17},
  [992] = {.lex_state = 102, .external_lex_state = 18},
  [993] = {.lex_state = 105, .external_lex_state = 20},
  [994] = {.lex_state = 101, .external_lex_state = 18},
  [995] = {.lex_state = 101, .external_lex_state = 18},
  [996] = {.lex_state = 101, .external_lex_state = 18},
  [997] = {.lex_state = 101, .external_lex_state = 18},
  [998] = {.lex_state = 105, .external_lex_state = 20},
  [999] = {.lex_state = 101, .external_lex_state = 18},
  [1000] = {.lex_state = 101, .external_lex_state = 19},
  [1001] = {.lex_state = 102, .external_lex_state = 19},
  [1002] = {.lex_state = 105, .external_lex_state = 20},
  [1003] = {.lex_state = 101, .external_lex_state = 18},
  [1004] = {.lex_state = 102, .external_lex_state = 18},
  [1005] = {.lex_state = 101, .external_lex_state = 18},
  [1006] = {.lex_state = 101, .external_lex_state = 18},
  [1007] = {.lex_state = 101, .external_lex_state = 18},
  [1008] = {.lex_state = 105, .external_lex_state = 17},
  [1009] = {.lex_state = 101, .external_lex_state = 18},
  [1010] = {.lex_state = 102, .external_lex_state = 18},
  [1011] = {.lex_state = 102, .external_lex_state = 19},
  [1012] = {.lex_state = 105, .external_lex_state = 20},
  [1013] = {.lex_state = 101, .external_lex_state = 18},
  [1014] = {.lex_state = 101, .external_lex_state = 18},
  [1015] = {.lex_state = 102, .external_lex_state = 18},
  [1016] = {.lex_state = 102, .external_lex_state = 19},
  [1017] = {.lex_state = 102, .external_lex_state = 19},
  [1018] = {.lex_state = 101, .external_lex_state = 18},
  [1019] = {.lex_state = 101, .external_lex_state = 18},
  [1020] = {.lex_state = 102, .external_lex_state = 19},
  [1021] = {.lex_state = 102, .external_lex_state = 18},
  [1022] = {.lex_state = 102, .external_lex_state = 19},
  [1023] = {.lex_state = 102, .external_lex_state = 19},
  [1024] = {.lex_state = 101, .external_lex_state = 18},
  [1025] = {.lex_state = 101, .external_lex_state = 18},
  [1026] = {.lex_state = 101, .external_lex_state = 18},
  [1027] = {.lex_state = 105, .external_lex_state = 17},
  [1028] = {.lex_state = 102, .external_lex_state = 18},
  [1029] = {.lex_state = 101, .external_lex_state = 18},
  [1030] = {.lex_state = 101, .external_lex_state = 18},
  [1031] = {.lex_state = 101, .external_lex_state = 18},
  [1032] = {.lex_state = 101, .external_lex_state = 18},
  [1033] = {.lex_state = 101, .external_lex_state = 18},
  [1034] = {.lex_state = 101, .external_lex_state = 18},
  [1035] = {.lex_state = 101, .external_lex_state = 18},
  [1036] = {.lex_state = 105, .external_lex_state = 17},
  [1037] = {.lex_state = 105, .external_lex_state = 17},
  [1038] = {.lex_state = 102, .external_lex_state = 19},
  [1039] = {.lex_state = 102, .external_lex_state = 18},
  [1040] = {.lex_state = 101, .external_lex_state = 18},
  [1041] = {.lex_state = 105, .external_lex_state = 20},
  [1042] = {.lex_state = 102, .external_lex_state = 18},
  [1043] = {.lex_state = 101, .external_lex_state = 18},
  [1044] = {.lex_state = 105, .external_lex_state = 17},
  [1045] = {.lex_state = 105, .external_lex_state = 20},
  [1046] = {.lex_state = 101, .external_lex_state = 18},
  [1047] = {.lex_state = 101, .external_lex_state = 18},
  [1048] = {.lex_state = 102, .external_lex_state = 18},
  [1049] = {.lex_state = 105, .external_lex_state = 17},
  [1050] = {.lex_state = 102, .external_lex_state = 19},
  [1051] = {.lex_state = 102, .external_lex_state = 18},
  [1052] = {.lex_state = 101, .external_lex_state = 18},
  [1053] = {.lex_state = 102, .external_lex_state = 18},
  [1054] = {.lex_state = 102, .external_lex_state = 18},
  [1055] = {.lex_state = 102, .external_lex_state = 19},
  [1056] = {.lex_state = 102, .external_lex_state = 19},
  [1057] = {.lex_state = 102, .external_lex_state = 19},
  [1058] = {.lex_state = 102, .external_lex_state = 19},
  [1059] = {.lex_state = 101, .external_lex_state = 19},
  [1060] = {.lex_state = 102, .external_lex_state = 18},
  [1061] = {.lex_state = 102, .external_lex_state = 19},
  [1062] = {.lex_state = 102, .external_lex_state = 19},
  [1063] = {.lex_state = 102, .external_lex_state = 19},
  [1064] = {.lex_state = 102, .external_lex_state = 18},
  [1065] = {.lex_state = 102, .external_lex_state = 19},
  [1066] = {.lex_state = 102, .external_lex_state = 18},
  [1067] = {.lex_state = 105, .external_lex_state = 20},
  [1068] = {.lex_state = 102, .external_lex_state = 19},
  [1069] = {.lex_state = 102, .external_lex_state = 19},
  [1070] = {.lex_state = 102, .external_lex_state = 19},
  [1071] = {.lex_state = 102, .external_lex_state = 19},
  [1072] = {.lex_state = 102, .external_lex_state = 19},
  [1073] = {.lex_state = 101, .external_lex_state = 19},
  [1074] = {.lex_state = 102, .external_lex_state = 19},
  [1075] = {.lex_state = 105, .external_lex_state = 17},
  [1076] = {.lex_state = 102, .external_lex_state = 18},
  [1077] = {.lex_state = 102, .external_lex_state = 18},
  [1078] = {.lex_state = 102, .external_lex_state = 18},
  [1079] = {.lex_state = 102, .external_lex_state = 18},
  [1080] = {.lex_state = 102, .external_lex_state = 18},
  [1081] = {.lex_state = 102, .external_lex_state = 18},
  [1082] = {.lex_state = 102, .external_lex_state = 19},
  [1083] = {.lex_state = 102, .external_lex_state = 18},
  [1084] = {.lex_state = 102, .external_lex_state = 19},
  [1085] = {.lex_state = 102, .external_lex_state = 19},
  [1086] = {.lex_state = 102, .external_lex_state = 19},
  [1087] = {.lex_state = 102, .external_lex_state = 18},
  [1088] = {.lex_state = 102, .external_lex_state = 18},
  [1089] = {.lex_state = 102, .external_lex_state = 18},
  [1090] = {.lex_state = 105, .external_lex_state = 17},
  [1091] = {.lex_state = 102, .external_lex_state = 18},
  [1092] = {.lex_state = 102, .external_lex_state = 19},
  [1093] = {.lex_state = 102, .external_lex_state = 18},
  [1094] = {.lex_state = 105, .external_lex_state = 17},
  [1095] = {.lex_state = 105, .external_lex_state = 17},
  [1096] = {.lex_state = 105, .external_lex_state = 17},
  [1097] = {.lex_state = 102, .external_lex_state = 18},
  [1098] = {.lex_state = 105, .external_lex_state = 17},
  [1099] = {.lex_state = 102, .external_lex_state = 18},
  [1100] = {.lex_state = 105, .external_lex_state = 17},
  [1101] = {.lex_state = 105, .external_lex_state = 17},
  [1102] = {.lex_state = 105, .external_lex_state = 17},
  [1103] = {.lex_state = 105, .external_lex_state = 17},
  [1104] = {.lex_state = 105, .external_lex_state = 17},
  [1105] = {.lex_state = 105, .external_lex_state = 17},
  [1106] = {.lex_state = 102, .external_lex_state = 19},
  [1107] = {.lex_state = 101, .external_lex_state = 19},
  [1108] = {.lex_state = 105, .external_lex_state = 17},
  [1109] = {.lex_state = 105, .external_lex_state = 17},
  [1110] = {.lex_state = 105, .external_lex_state = 17},
  [1111] = {.lex_state = 105, .external_lex_state = 17},
  [1112] = {.lex_state = 105, .external_lex_state = 17},
  [1113] = {.lex_state = 105, .external_lex_state = 17},
  [1114] = {.lex_state = 105, .external_lex_state = 17},
  [1115] = {.lex_state = 101, .external_lex_state = 19},
  [1116] = {.lex_state = 105, .external_lex_state = 17},
  [1117] = {.lex_state = 101, .external_lex_state = 19},
  [1118] = {.lex_state = 105, .external_lex_state = 17},
  [1119] = {.lex_state = 105, .external_lex_state = 17},
  [1120] = {.lex_state = 105, .external_lex_state = 17},
  [1121] = {.lex_state = 105, .external_lex_state = 17},
  [1122] = {.lex_state = 105, .external_lex_state = 17},
  [1123] = {.lex_state = 101, .external_lex_state = 19},
  [1124] = {.lex_state = 105, .external_lex_state = 17},
  [1125] = {.lex_state = 105, .external_lex_state = 17},
  [1126] = {.lex_state = 105, .external_lex_state = 17},
  [1127] = {.lex_state = 105, .external_lex_state = 17},
  [1128] = {.lex_state = 105, .external_lex_state = 17},
  [1129] = {.lex_state = 105, .external_lex_state = 17},
  [1130] = {.lex_state = 105, .external_lex_state = 17},
  [1131] = {.lex_state = 105, .external_lex_state = 17},
  [1132] = {.lex_state = 105, .external_lex_state = 17},
  [1133] = {.lex_state = 105, .external_lex_state = 17},
  [1134] = {.lex_state = 105, .external_lex_state = 17},
  [1135] = {.lex_state = 105, .external_lex_state = 17},
  [1136] = {.lex_state = 105, .external_lex_state = 17},
  [1137] = {.lex_state = 105, .external_lex_state = 17},
  [1138] = {.lex_state = 105, .external_lex_state = 17},
  [1139] = {.lex_state = 101, .external_lex_state = 19},
  [1140] = {.lex_state = 105, .external_lex_state = 17},
  [1141] = {.lex_state = 105, .external_lex_state = 17},
  [1142] = {.lex_state = 105, .external_lex_state = 17},
  [1143] = {.lex_state = 105, .external_lex_state = 17},
  [1144] = {.lex_state = 105, .external_lex_state = 17},
  [1145] = {.lex_state = 105, .external_lex_state = 17},
  [1146] = {.lex_state = 105, .external_lex_state = 17},
  [1147] = {.lex_state = 105, .external_lex_state = 17},
  [1148] = {.lex_state = 105, .external_lex_state = 17},
  [1149] = {.lex_state = 105, .external_lex_state = 17},
  [1150] = {.lex_state = 105, .external_lex_state = 17},
  [1151] = {.lex_state = 105, .external_lex_state = 17},
  [1152] = {.lex_state = 105, .external_lex_state = 17},
  [1153] = {.lex_state = 105, .external_lex_state = 17},
  [1154] = {.lex_state = 105, .external_lex_state = 17},
  [1155] = {.lex_state = 105, .external_lex_state = 17},
  [1156] = {.lex_state = 105, .external_lex_state = 17},
  [1157] = {.lex_state = 105, .external_lex_state = 17},
  [1158] = {.lex_state = 105, .external_lex_state = 17},
  [1159] = {.lex_state = 105, .external_lex_state = 17},
  [1160] = {.lex_state = 105, .external_lex_state = 17},
  [1161] = {.lex_state = 105, .external_lex_state = 17},
  [1162] = {.lex_state = 105, .external_lex_state = 17},
  [1163] = {.lex_state = 101, .external_lex_state = 19},
  [1164] = {.lex_state = 105, .external_lex_state = 17},
  [1165] = {.lex_state = 105, .external_lex_state = 17},
  [1166] = {.lex_state = 105, .external_lex_state = 17},
  [1167] = {.lex_state = 102, .external_lex_state = 18},
  [1168] = {.lex_state = 105, .external_lex_state = 17},
  [1169] = {.lex_state = 105, .external_lex_state = 17},
  [1170] = {.lex_state = 105, .external_lex_state = 17},
  [1171] = {.lex_state = 105, .external_lex_state = 17},
  [1172] = {.lex_state = 105, .external_lex_state = 17},
  [1173] = {.lex_state = 105, .external_lex_state = 17},
  [1174] = {.lex_state = 105, .external_lex_state = 17},
  [1175] = {.lex_state = 105, .external_lex_state = 17},
  [1176] = {.lex_state = 105, .external_lex_state = 17},
  [1177] = {.lex_state = 105, .external_lex_state = 17},
  [1178] = {.lex_state = 105, .external_lex_state = 17},
  [1179] = {.lex_state = 105, .external_lex_state = 17},
  [1180] = {.lex_state = 102, .external_lex_state = 18},
  [1181] = {.lex_state = 105, .external_lex_state = 17},
  [1182] = {.lex_state = 105, .external_lex_state = 17},
  [1183] = {.lex_state = 105, .external_lex_state = 17},
  [1184] = {.lex_state = 105, .external_lex_state = 17},
  [1185] = {.lex_state = 105, .external_lex_state = 17},
  [1186] = {.lex_state = 105, .external_lex_state = 17},
  [1187] = {.lex_state = 101, .external_lex_state = 19},
  [1188] = {.lex_state = 105, .external_lex_state = 17},
  [1189] = {.lex_state = 105, .external_lex_state = 17},
  [1190] = {.lex_state = 105, .external_lex_state = 17},
  [1191] = {.lex_state = 105, .external_lex_state = 17},
  [1192] = {.lex_state = 105, .external_lex_state = 17},
  [1193] = {.lex_state = 105, .external_lex_state = 17},
  [1194] = {.lex_state = 105, .external_lex_state = 17},
  [1195] = {.lex_state = 105, .external_lex_state = 17},
  [1196] = {.lex_state = 101, .external_lex_state = 17},
  [1197] = {.lex_state = 102, .external_lex_state = 19},
  [1198] = {.lex_state = 102, .external_lex_state = 17},
  [1199] = {.lex_state = 102, .external_lex_state = 17},
  [1200] = {.lex_state = 102, .external_lex_state = 19},
  [1201] = {.lex_state = 105, .external_lex_state = 17},
  [1202] = {.lex_state = 101, .external_lex_state = 19},
  [1203] = {.lex_state = 102, .external_lex_state = 17},
  [1204] = {.lex_state = 101, .external_lex_state = 19},
  [1205] = {.lex_state = 101, .external_lex_state = 19},
  [1206] = {.lex_state = 101, .external_lex_state = 19},
  [1207] = {.lex_state = 101, .external_lex_state = 19},
  [1208] = {.lex_state = 101, .external_lex_state = 19},
  [1209] = {.lex_state = 101, .external_lex_state = 19},
  [1210] = {.lex_state = 101, .external_lex_state = 19},
  [1211] = {.lex_state = 107, .external_lex_state = 17},
  [1212] = {.lex_state = 101, .external_lex_state = 19},
  [1213] = {.lex_state = 101, .external_lex_state = 19},
  [1214] = {.lex_state = 107, .external_lex_state = 17},
  [1215] = {.lex_state = 101, .external_lex_state = 19},
  [1216] = {.lex_state = 101, .external_lex_state = 19},
  [1217] = {.lex_state = 101, .external_lex_state = 19},
  [1218] = {.lex_state = 101, .external_lex_state = 19},
  [1219] = {.lex_state = 102, .external_lex_state = 19},
  [1220] = {.lex_state = 101, .external_lex_state = 19},
  [1221] = {.lex_state = 101, .external_lex_state = 19},
  [1222] = {.lex_state = 101, .external_lex_state = 19},
  [1223] = {.lex_state = 107, .external_lex_state = 17},
  [1224] = {.lex_state = 102, .external_lex_state = 17},
  [1225] = {.lex_state = 101, .external_lex_state = 19},
  [1226] = {.lex_state = 107, .external_lex_state = 17},
  [1227] = {.lex_state = 101, .external_lex_state = 19},
  [1228] = {.lex_state = 101, .external_lex_state = 19},
  [1229] = {.lex_state = 101, .external_lex_state = 19},
  [1230] = {.lex_state = 107, .external_lex_state = 17},
  [1231] = {.lex_state = 107, .external_lex_state = 17},
  [1232] = {.lex_state = 107, .external_lex_state = 17},
  [1233] = {.lex_state = 107, .external_lex_state = 17},
  [1234] = {.lex_state = 107, .external_lex_state = 17},
  [1235] = {.lex_state = 107, .external_lex_state = 17},
  [1236] = {.lex_state = 107, .external_lex_state = 17},
  [1237] = {.lex_state = 107, .external_lex_state = 17},
  [1238] = {.lex_state = 107, .external_lex_state = 17},
  [1239] = {.lex_state = 107, .external_lex_state = 17},
  [1240] = {.lex_state = 107, .external_lex_state = 17},
  [1241] = {.lex_state = 107, .external_lex_state = 17},
  [1242] = {.lex_state = 107, .external_lex_state = 17},
  [1243] = {.lex_state = 107, .external_lex_state = 17},
  [1244] = {.lex_state = 107, .external_lex_state = 17},
  [1245] = {.lex_state = 107, .external_lex_state = 17},
  [1246] = {.lex_state = 102, .external_lex_state = 19},
  [1247] = {.lex_state = 107, .external_lex_state = 17},
  [1248] = {.lex_state = 107, .external_lex_state = 17},
  [1249] = {.lex_state = 102, .external_lex_state = 19},
  [1250] = {.lex_state = 107, .external_lex_state = 17},
  [1251] = {.lex_state = 107, .external_lex_state = 17},
  [1252] = {.lex_state = 107, .external_lex_state = 17},
  [1253] = {.lex_state = 102, .external_lex_state = 19},
  [1254] = {.lex_state = 107, .external_lex_state = 17},
  [1255] = {.lex_state = 107, .external_lex_state = 17},
  [1256] = {.lex_state = 107, .external_lex_state = 17},
  [1257] = {.lex_state = 107, .external_lex_state = 17},
  [1258] = {.lex_state = 107, .external_lex_state = 17},
  [1259] = {.lex_state = 107, .external_lex_state = 17},
  [1260] = {.lex_state = 101, .external_lex_state = 19},
  [1261] = {.lex_state = 107, .external_lex_state = 17},
  [1262] = {.lex_state = 107, .external_lex_state = 17},
  [1263] = {.lex_state = 107, .external_lex_state = 17},
  [1264] = {.lex_state = 107, .external_lex_state = 17},
  [1265] = {.lex_state = 107, .external_lex_state = 17},
  [1266] = {.lex_state = 107, .external_lex_state = 17},
  [1267] = {.lex_state = 107, .external_lex_state = 17},
  [1268] = {.lex_state = 107, .external_lex_state = 17},
  [1269] = {.lex_state = 107, .external_lex_state = 17},
  [1270] = {.lex_state = 107, .external_lex_state = 17},
  [1271] = {.lex_state = 107, .external_lex_state = 17},
  [1272] = {.lex_state = 107, .external_lex_state = 17},
  [1273] = {.lex_state = 107, .external_lex_state = 17},
  [1274] = {.lex_state = 107, .external_lex_state = 17},
  [1275] = {.lex_state = 107, .external_lex_state = 17},
  [1276] = {.lex_state = 107, .external_lex_state = 17},
  [1277] = {.lex_state = 107, .external_lex_state = 17},
  [1278] = {.lex_state = 107, .external_lex_state = 17},
  [1279] = {.lex_state = 107, .external_lex_state = 17},
  [1280] = {.lex_state = 107, .external_lex_state = 17},
  [1281] = {.lex_state = 107, .external_lex_state = 17},
  [1282] = {.lex_state = 107, .external_lex_state = 17},
  [1283] = {.lex_state = 107, .external_lex_state = 17},
  [1284] = {.lex_state = 107, .external_lex_state = 17},
  [1285] = {.lex_state = 105, .external_lex_state = 17},
  [1286] = {.lex_state = 107, .external_lex_state = 17},
  [1287] = {.lex_state = 107, .external_lex_state = 17},
  [1288] = {.lex_state = 107, .external_lex_state = 17},
  [1289] = {.lex_state = 107, .external_lex_state = 17},
  [1290] = {.lex_state = 107, .external_lex_state = 17},
  [1291] = {.lex_state = 107, .external_lex_state = 17},
  [1292] = {.lex_state = 107, .external_lex_state = 17},
  [1293] = {.lex_state = 107, .external_lex_state = 17},
  [1294] = {.lex_state = 107, .external_lex_state = 17},
  [1295] = {.lex_state = 107, .external_lex_state = 17},
  [1296] = {.lex_state = 107, .external_lex_state = 17},
  [1297] = {.lex_state = 107, .external_lex_state = 17},
  [1298] = {.lex_state = 107, .external_lex_state = 17},
  [1299] = {.lex_state = 107, .external_lex_state = 17},
  [1300] = {.lex_state = 107, .external_lex_state = 17},
  [1301] = {.lex_state = 107, .external_lex_state = 17},
  [1302] = {.lex_state = 107, .external_lex_state = 17},
  [1303] = {.lex_state = 107, .external_lex_state = 17},
  [1304] = {.lex_state = 107, .external_lex_state = 17},
  [1305] = {.lex_state = 107, .external_lex_state = 17},
  [1306] = {.lex_state = 107, .external_lex_state = 17},
  [1307] = {.lex_state = 107, .external_lex_state = 17},
  [1308] = {.lex_state = 107, .external_lex_state = 17},
  [1309] = {.lex_state = 107, .external_lex_state = 17},
  [1310] = {.lex_state = 107, .external_lex_state = 17},
  [1311] = {.lex_state = 107, .external_lex_state = 17},
  [1312] = {.lex_state = 107, .external_lex_state = 17},
  [1313] = {.lex_state = 107, .external_lex_state = 17},
  [1314] = {.lex_state = 107, .external_lex_state = 17},
  [1315] = {.lex_state = 107, .external_lex_state = 17},
  [1316] = {.lex_state = 107, .external_lex_state = 17},
  [1317] = {.lex_state = 107, .external_lex_state = 17},
  [1318] = {.lex_state = 107, .external_lex_state = 17},
  [1319] = {.lex_state = 107, .external_lex_state = 17},
  [1320] = {.lex_state = 107, .external_lex_state = 17},
  [1321] = {.lex_state = 107, .external_lex_state = 17},
  [1322] = {.lex_state = 107, .external_lex_state = 17},
  [1323] = {.lex_state = 107, .external_lex_state = 17},
  [1324] = {.lex_state = 107, .external_lex_state = 17},
  [1325] = {.lex_state = 107, .external_lex_state = 17},
  [1326] = {.lex_state = 107, .external_lex_state = 17},
  [1327] = {.lex_state = 107, .external_lex_state = 17},
  [1328] = {.lex_state = 107, .external_lex_state = 17},
  [1329] = {.lex_state = 107, .external_lex_state = 17},
  [1330] = {.lex_state = 107, .external_lex_state = 17},
  [1331] = {.lex_state = 107, .external_lex_state = 17},
  [1332] = {.lex_state = 107, .external_lex_state = 17},
  [1333] = {.lex_state = 107, .external_lex_state = 17},
  [1334] = {.lex_state = 107, .external_lex_state = 17},
  [1335] = {.lex_state = 107, .external_lex_state = 17},
  [1336] = {.lex_state = 107, .external_lex_state = 17},
  [1337] = {.lex_state = 107, .external_lex_state = 17},
  [1338] = {.lex_state = 107, .external_lex_state = 17},
  [1339] = {.lex_state = 107, .external_lex_state = 17},
  [1340] = {.lex_state = 107, .external_lex_state = 17},
  [1341] = {.lex_state = 105, .external_lex_state = 17},
  [1342] = {.lex_state = 105, .external_lex_state = 21},
  [1343] = {.lex_state = 107, .external_lex_state = 17},
  [1344] = {.lex_state = 107, .external_lex_state = 17},
  [1345] = {.lex_state = 105, .external_lex_state = 20},
  [1346] = {.lex_state = 107, .external_lex_state = 17},
  [1347] = {.lex_state = 107, .external_lex_state = 17},
  [1348] = {.lex_state = 107, .external_lex_state = 17},
  [1349] = {.lex_state = 107, .external_lex_state = 17},
  [1350] = {.lex_state = 107, .external_lex_state = 17},
  [1351] = {.lex_state = 107, .external_lex_state = 17},
  [1352] = {.lex_state = 107, .external_lex_state = 17},
  [1353] = {.lex_state = 107, .external_lex_state = 17},
  [1354] = {.lex_state = 107, .external_lex_state = 17},
  [1355] = {.lex_state = 107, .external_lex_state = 17},
  [1356] = {.lex_state = 107, .external_lex_state = 17},
  [1357] = {.lex_state = 107, .external_lex_state = 17},
  [1358] = {.lex_state = 107, .external_lex_state = 17},
  [1359] = {.lex_state = 20, .external_lex_state = 22},
  [1360] = {.lex_state = 105, .external_lex_state = 21},
  [1361] = {.lex_state = 20, .external_lex_state = 22},
  [1362] = {.lex_state = 105, .external_lex_state = 21},
  [1363] = {.lex_state = 105, .external_lex_state = 21},
  [1364] = {.lex_state = 20, .external_lex_state = 22},
  [1365] = {.lex_state = 18, .external_lex_state = 19},
  [1366] = {.lex_state = 18, .external_lex_state = 19},
  [1367] = {.lex_state = 105, .external_lex_state = 23},
  [1368] = {.lex_state = 105, .external_lex_state = 21},
  [1369] = {.lex_state = 105, .external_lex_state = 21},
  [1370] = {.lex_state = 105, .external_lex_state = 18},
  [1371] = {.lex_state = 105, .external_lex_state = 18},
  [1372] = {.lex_state = 105, .external_lex_state = 23},
  [1373] = {.lex_state = 20, .external_lex_state = 24},
  [1374] = {.lex_state = 105, .external_lex_state = 18},
  [1375] = {.lex_state = 105, .external_lex_state = 23},
  [1376] = {.lex_state = 18, .external_lex_state = 19},
  [1377] = {.lex_state = 18, .external_lex_state = 19},
  [1378] = {.lex_state = 105, .external_lex_state = 18},
  [1379] = {.lex_state = 105, .external_lex_state = 21},
  [1380] = {.lex_state = 105, .external_lex_state = 18},
  [1381] = {.lex_state = 18, .external_lex_state = 19},
  [1382] = {.lex_state = 105, .external_lex_state = 18},
  [1383] = {.lex_state = 18, .external_lex_state = 19},
  [1384] = {.lex_state = 105, .external_lex_state = 23},
  [1385] = {.lex_state = 18, .external_lex_state = 19},
  [1386] = {.lex_state = 105, .external_lex_state = 18},
  [1387] = {.lex_state = 18, .external_lex_state = 23},
  [1388] = {.lex_state = 105, .external_lex_state = 18},
  [1389] = {.lex_state = 105, .external_lex_state = 23},
  [1390] = {.lex_state = 18, .external_lex_state = 19},
  [1391] = {.lex_state = 105, .external_lex_state = 17},
  [1392] = {.lex_state = 105, .external_lex_state = 18},
  [1393] = {.lex_state = 105, .external_lex_state = 18},
  [1394] = {.lex_state = 18, .external_lex_state = 19},
  [1395] = {.lex_state = 18, .external_lex_state = 19},
  [1396] = {.lex_state = 105, .external_lex_state = 18},
  [1397] = {.lex_state = 105, .external_lex_state = 18},
  [1398] = {.lex_state = 105, .external_lex_state = 18},
  [1399] = {.lex_state = 18, .external_lex_state = 19},
  [1400] = {.lex_state = 18, .external_lex_state = 19},
  [1401] = {.lex_state = 105, .external_lex_state = 18},
  [1402] = {.lex_state = 18, .external_lex_state = 19},
  [1403] = {.lex_state = 18, .external_lex_state = 19},
  [1404] = {.lex_state = 105, .external_lex_state = 18},
  [1405] = {.lex_state = 105, .external_lex_state = 18},
  [1406] = {.lex_state = 105, .external_lex_state = 18},
  [1407] = {.lex_state = 105, .external_lex_state = 18},
  [1408] = {.lex_state = 105, .external_lex_state = 18},
  [1409] = {.lex_state = 18, .external_lex_state = 19},
  [1410] = {.lex_state = 105, .external_lex_state = 18},
  [1411] = {.lex_state = 105, .external_lex_state = 18},
  [1412] = {.lex_state = 105, .external_lex_state = 18},
  [1413] = {.lex_state = 105, .external_lex_state = 18},
  [1414] = {.lex_state = 105, .external_lex_state = 18},
  [1415] = {.lex_state = 18, .external_lex_state = 19},
  [1416] = {.lex_state = 18, .external_lex_state = 19},
  [1417] = {.lex_state = 105, .external_lex_state = 18},
  [1418] = {.lex_state = 18, .external_lex_state = 19},
  [1419] = {.lex_state = 105, .external_lex_state = 18},
  [1420] = {.lex_state = 18, .external_lex_state = 19},
  [1421] = {.lex_state = 105, .external_lex_state = 18},
  [1422] = {.lex_state = 105, .external_lex_state = 18},
  [1423] = {.lex_state = 105, .external_lex_state = 18},
  [1424] = {.lex_state = 18, .external_lex_state = 19},
  [1425] = {.lex_state = 105, .external_lex_state = 18},
  [1426] = {.lex_state = 105, .external_lex_state = 18},
  [1427] = {.lex_state = 105, .external_lex_state = 18},
  [1428] = {.lex_state = 105, .external_lex_state = 18},
  [1429] = {.lex_state = 105, .external_lex_state = 18},
  [1430] = {.lex_state = 105, .external_lex_state = 18},
  [1431] = {.lex_state = 105, .external_lex_state = 18},
  [1432] = {.lex_state = 18, .external_lex_state = 19},
  [1433] = {.lex_state = 105, .external_lex_state = 18},
  [1434] = {.lex_state = 105, .external_lex_state = 18},
  [1435] = {.lex_state = 18, .external_lex_state = 19},
  [1436] = {.lex_state = 105, .external_lex_state = 18},
  [1437] = {.lex_state = 105, .external_lex_state = 18},
  [1438] = {.lex_state = 105, .external_lex_state = 18},
  [1439] = {.lex_state = 105, .external_lex_state = 18},
  [1440] = {.lex_state = 105, .external_lex_state = 18},
  [1441] = {.lex_state = 105, .external_lex_state = 18},
  [1442] = {.lex_state = 105, .external_lex_state = 18},
  [1443] = {.lex_state = 105, .external_lex_state = 18},
  [1444] = {.lex_state = 105, .external_lex_state = 18},
  [1445] = {.lex_state = 18, .external_lex_state = 19},
  [1446] = {.lex_state = 18, .external_lex_state = 19},
  [1447] = {.lex_state = 18, .external_lex_state = 19},
  [1448] = {.lex_state = 18, .external_lex_state = 19},
  [1449] = {.lex_state = 18, .external_lex_state = 19},
  [1450] = {.lex_state = 18, .external_lex_state = 19},
  [1451] = {.lex_state = 18, .external_lex_state = 19},
  [1452] = {.lex_state = 105, .external_lex_state = 18},
  [1453] = {.lex_state = 18, .external_lex_state = 19},
  [1454] = {.lex_state = 105, .external_lex_state = 18},
  [1455] = {.lex_state = 105, .external_lex_state = 18},
  [1456] = {.lex_state = 105, .external_lex_state = 18},
  [1457] = {.lex_state = 105, .external_lex_state = 18},
  [1458] = {.lex_state = 105, .external_lex_state = 18},
  [1459] = {.lex_state = 105, .external_lex_state = 18},
  [1460] = {.lex_state = 105, .external_lex_state = 18},
  [1461] = {.lex_state = 18, .external_lex_state = 19},
  [1462] = {.lex_state = 105, .external_lex_state = 18},
  [1463] = {.lex_state = 18, .external_lex_state = 19},
  [1464] = {.lex_state = 105, .external_lex_state = 18},
  [1465] = {.lex_state = 18, .external_lex_state = 19},
  [1466] = {.lex_state = 18, .external_lex_state = 19},
  [1467] = {.lex_state = 18, .external_lex_state = 19},
  [1468] = {.lex_state = 18, .external_lex_state = 19},
  [1469] = {.lex_state = 105, .external_lex_state = 18},
  [1470] = {.lex_state = 18, .external_lex_state = 19},
  [1471] = {.lex_state = 105, .external_lex_state = 18},
  [1472] = {.lex_state = 18, .external_lex_state = 19},
  [1473] = {.lex_state = 18, .external_lex_state = 19},
  [1474] = {.lex_state = 18, .external_lex_state = 19},
  [1475] = {.lex_state = 18, .external_lex_state = 19},
  [1476] = {.lex_state = 18, .external_lex_state = 19},
  [1477] = {.lex_state = 18, .external_lex_state = 19},
  [1478] = {.lex_state = 18, .external_lex_state = 19},
  [1479] = {.lex_state = 18, .external_lex_state = 19},
  [1480] = {.lex_state = 18, .external_lex_state = 19},
  [1481] = {.lex_state = 105, .external_lex_state = 18},
  [1482] = {.lex_state = 18, .external_lex_state = 19},
  [1483] = {.lex_state = 105, .external_lex_state = 18},
  [1484] = {.lex_state = 18, .external_lex_state = 19},
  [1485] = {.lex_state = 105, .external_lex_state = 18},
  [1486] = {.lex_state = 105, .external_lex_state = 18},
  [1487] = {.lex_state = 18, .external_lex_state = 19},
  [1488] = {.lex_state = 18, .external_lex_state = 19},
  [1489] = {.lex_state = 105, .external_lex_state = 18},
  [1490] = {.lex_state = 18, .external_lex_state = 19},
  [1491] = {.lex_state = 105, .external_lex_state = 18},
  [1492] = {.lex_state = 105, .external_lex_state = 18},
  [1493] = {.lex_state = 105, .external_lex_state = 18},
  [1494] = {.lex_state = 105, .external_lex_state = 18},
  [1495] = {.lex_state = 18, .external_lex_state = 19},
  [1496] = {.lex_state = 105, .external_lex_state = 18},
  [1497] = {.lex_state = 18, .external_lex_state = 19},
  [1498] = {.lex_state = 18, .external_lex_state = 19},
  [1499] = {.lex_state = 105, .external_lex_state = 18},
  [1500] = {.lex_state = 18, .external_lex_state = 19},
  [1501] = {.lex_state = 18, .external_lex_state = 19},
  [1502] = {.lex_state = 105, .external_lex_state = 18},
  [1503] = {.lex_state = 18, .external_lex_state = 19},
  [1504] = {.lex_state = 18, .external_lex_state = 19},
  [1505] = {.lex_state = 105, .external_lex_state = 18},
  [1506] = {.lex_state = 18, .external_lex_state = 19},
  [1507] = {.lex_state = 18, .external_lex_state = 19},
  [1508] = {.lex_state = 18, .external_lex_state = 19},
  [1509] = {.lex_state = 18, .external_lex_state = 19},
  [1510] = {.lex_state = 18, .external_lex_state = 19},
  [1511] = {.lex_state = 18, .external_lex_state = 19},
  [1512] = {.lex_state = 18, .external_lex_state = 19},
  [1513] = {.lex_state = 18, .external_lex_state = 19},
  [1514] = {.lex_state = 18, .external_lex_state = 19},
  [1515] = {.lex_state = 105, .external_lex_state = 18},
  [1516] = {.lex_state = 18, .external_lex_state = 19},
  [1517] = {.lex_state = 105, .external_lex_state = 18},
  [1518] = {.lex_state = 18, .external_lex_state = 19},
  [1519] = {.lex_state = 18, .external_lex_state = 19},
  [1520] = {.lex_state = 18, .external_lex_state = 19},
  [1521] = {.lex_state = 18, .external_lex_state = 19},
  [1522] = {.lex_state = 18, .external_lex_state = 19},
  [1523] = {.lex_state = 105, .external_lex_state = 18},
  [1524] = {.lex_state = 105, .external_lex_state = 18},
  [1525] = {.lex_state = 105, .external_lex_state = 18},
  [1526] = {.lex_state = 105, .external_lex_state = 18},
  [1527] = {.lex_state = 105, .external_lex_state = 18},
  [1528] = {.lex_state = 18, .external_lex_state = 19},
  [1529] = {.lex_state = 105, .external_lex_state = 18},
  [1530] = {.lex_state = 105, .external_lex_state = 18},
  [1531] = {.lex_state = 105, .external_lex_state = 18},
  [1532] = {.lex_state = 18, .external_lex_state = 19},
  [1533] = {.lex_state = 18, .external_lex_state = 19},
  [1534] = {.lex_state = 18, .external_lex_state = 19},
  [1535] = {.lex_state = 105, .external_lex_state = 18},
  [1536] = {.lex_state = 18, .external_lex_state = 19},
  [1537] = {.lex_state = 105, .external_lex_state = 18},
  [1538] = {.lex_state = 18, .external_lex_state = 19},
  [1539] = {.lex_state = 18, .external_lex_state = 19},
  [1540] = {.lex_state = 18, .external_lex_state = 19},
  [1541] = {.lex_state = 105, .external_lex_state = 18},
  [1542] = {.lex_state = 18, .external_lex_state = 19},
  [1543] = {.lex_state = 18, .external_lex_state = 19},
  [1544] = {.lex_state = 18, .external_lex_state = 19},
  [1545] = {.lex_state = 105, .external_lex_state = 18},
  [1546] = {.lex_state = 105, .external_lex_state = 18},
  [1547] = {.lex_state = 18, .external_lex_state = 19},
  [1548] = {.lex_state = 18, .external_lex_state = 19},
  [1549] = {.lex_state = 18, .external_lex_state = 19},
  [1550] = {.lex_state = 105, .external_lex_state = 18},
  [1551] = {.lex_state = 105, .external_lex_state = 18},
  [1552] = {.lex_state = 105, .external_lex_state = 18},
  [1553] = {.lex_state = 105, .external_lex_state = 18},
  [1554] = {.lex_state = 105, .external_lex_state = 18},
  [1555] = {.lex_state = 105, .external_lex_state = 18},
  [1556] = {.lex_state = 105, .external_lex_state = 18},
  [1557] = {.lex_state = 18, .external_lex_state = 19},
  [1558] = {.lex_state = 18, .external_lex_state = 19},
  [1559] = {.lex_state = 105, .external_lex_state = 18},
  [1560] = {.lex_state = 18, .external_lex_state = 19},
  [1561] = {.lex_state = 18, .external_lex_state = 19},
  [1562] = {.lex_state = 105, .external_lex_state = 18},
  [1563] = {.lex_state = 18, .external_lex_state = 19},
  [1564] = {.lex_state = 18, .external_lex_state = 19},
  [1565] = {.lex_state = 18, .external_lex_state = 19},
  [1566] = {.lex_state = 18, .external_lex_state = 19},
  [1567] = {.lex_state = 18, .external_lex_state = 19},
  [1568] = {.lex_state = 20, .external_lex_state = 22},
  [1569] = {.lex_state = 20, .external_lex_state = 22},
  [1570] = {.lex_state = 20, .external_lex_state = 22},
  [1571] = {.lex_state = 18, .external_lex_state = 19},
  [1572] = {.lex_state = 20, .external_lex_state = 22},
  [1573] = {.lex_state = 105, .external_lex_state = 18},
  [1574] = {.lex_state = 20, .external_lex_state = 22},
  [1575] = {.lex_state = 105, .external_lex_state = 23},
  [1576] = {.lex_state = 20, .external_lex_state = 22},
  [1577] = {.lex_state = 107, .external_lex_state = 17},
  [1578] = {.lex_state = 107, .external_lex_state = 17},
  [1579] = {.lex_state = 20, .external_lex_state = 24},
  [1580] = {.lex_state = 20, .external_lex_state = 22},
  [1581] = {.lex_state = 20, .external_lex_state = 22},
  [1582] = {.lex_state = 20, .external_lex_state = 22},
  [1583] = {.lex_state = 20, .external_lex_state = 22},
  [1584] = {.lex_state = 20, .external_lex_state = 22},
  [1585] = {.lex_state = 20, .external_lex_state = 22},
  [1586] = {.lex_state = 107, .external_lex_state = 17},
  [1587] = {.lex_state = 105, .external_lex_state = 17},
  [1588] = {.lex_state = 20, .external_lex_state = 22},
  [1589] = {.lex_state = 105, .external_lex_state = 17},
  [1590] = {.lex_state = 107, .external_lex_state = 17},
  [1591] = {.lex_state = 20, .external_lex_state = 24},
  [1592] = {.lex_state = 20, .external_lex_state = 22},
  [1593] = {.lex_state = 105, .external_lex_state = 18},
  [1594] = {.lex_state = 107, .external_lex_state = 18},
  [1595] = {.lex_state = 20, .external_lex_state = 24},
  [1596] = {.lex_state = 20, .external_lex_state = 24},
  [1597] = {.lex_state = 107, .external_lex_state = 17},
  [1598] = {.lex_state = 20, .external_lex_state = 24},
  [1599] = {.lex_state = 107, .external_lex_state = 18},
  [1600] = {.lex_state = 107, .external_lex_state = 18},
  [1601] = {.lex_state = 107, .external_lex_state = 18},
  [1602] = {.lex_state = 20, .external_lex_state = 24},
  [1603] = {.lex_state = 18, .external_lex_state = 23},
  [1604] = {.lex_state = 107, .external_lex_state = 17},
  [1605] = {.lex_state = 107, .external_lex_state = 19},
  [1606] = {.lex_state = 107, .external_lex_state = 18},
  [1607] = {.lex_state = 107, .external_lex_state = 18},
  [1608] = {.lex_state = 107, .external_lex_state = 18},
  [1609] = {.lex_state = 107, .external_lex_state = 18},
  [1610] = {.lex_state = 107, .external_lex_state = 18},
  [1611] = {.lex_state = 107, .external_lex_state = 18},
  [1612] = {.lex_state = 107, .external_lex_state = 18},
  [1613] = {.lex_state = 107, .external_lex_state = 19},
  [1614] = {.lex_state = 107, .external_lex_state = 18},
  [1615] = {.lex_state = 107, .external_lex_state = 17},
  [1616] = {.lex_state = 107, .external_lex_state = 18},
  [1617] = {.lex_state = 107, .external_lex_state = 18},
  [1618] = {.lex_state = 107, .external_lex_state = 17},
  [1619] = {.lex_state = 107, .external_lex_state = 17},
  [1620] = {.lex_state = 18, .external_lex_state = 23},
  [1621] = {.lex_state = 107, .external_lex_state = 17},
  [1622] = {.lex_state = 18, .external_lex_state = 23},
  [1623] = {.lex_state = 107, .external_lex_state = 17},
  [1624] = {.lex_state = 107, .external_lex_state = 17},
  [1625] = {.lex_state = 107, .external_lex_state = 17},
  [1626] = {.lex_state = 107, .external_lex_state = 17},
  [1627] = {.lex_state = 107, .external_lex_state = 17},
  [1628] = {.lex_state = 107, .external_lex_state = 18},
  [1629] = {.lex_state = 107, .external_lex_state = 18},
  [1630] = {.lex_state = 107, .external_lex_state = 18},
  [1631] = {.lex_state = 107, .external_lex_state = 18},
  [1632] = {.lex_state = 107, .external_lex_state = 19},
  [1633] = {.lex_state = 107, .external_lex_state = 18},
  [1634] = {.lex_state = 107, .external_lex_state = 17},
  [1635] = {.lex_state = 107, .external_lex_state = 19},
  [1636] = {.lex_state = 107, .external_lex_state = 17},
  [1637] = {.lex_state = 107, .external_lex_state = 18},
  [1638] = {.lex_state = 107, .external_lex_state = 17},
  [1639] = {.lex_state = 107, .external_lex_state = 17},
  [1640] = {.lex_state = 107, .external_lex_state = 18},
  [1641] = {.lex_state = 107, .external_lex_state = 17},
  [1642] = {.lex_state = 107, .external_lex_state = 17},
  [1643] = {.lex_state = 107, .external_lex_state = 18},
  [1644] = {.lex_state = 107, .external_lex_state = 18},
  [1645] = {.lex_state = 107, .external_lex_state = 18},
  [1646] = {.lex_state = 107, .external_lex_state = 17},
  [1647] = {.lex_state = 107, .external_lex_state = 18},
  [1648] = {.lex_state = 107, .external_lex_state = 17},
  [1649] = {.lex_state = 107, .external_lex_state = 18},
  [1650] = {.lex_state = 107, .external_lex_state = 18},
  [1651] = {.lex_state = 107, .external_lex_state = 18},
  [1652] = {.lex_state = 107, .external_lex_state = 18},
  [1653] = {.lex_state = 107, .external_lex_state = 18},
  [1654] = {.lex_state = 107, .external_lex_state = 18},
  [1655] = {.lex_state = 107, .external_lex_state = 18},
  [1656] = {.lex_state = 107, .external_lex_state = 18},
  [1657] = {.lex_state = 107, .external_lex_state = 18},
  [1658] = {.lex_state = 107, .external_lex_state = 18},
  [1659] = {.lex_state = 107, .external_lex_state = 18},
  [1660] = {.lex_state = 107, .external_lex_state = 18},
  [1661] = {.lex_state = 107, .external_lex_state = 18},
  [1662] = {.lex_state = 107, .external_lex_state = 18},
  [1663] = {.lex_state = 105, .external_lex_state = 19},
  [1664] = {.lex_state = 107, .external_lex_state = 18},
  [1665] = {.lex_state = 107, .external_lex_state = 18},
  [1666] = {.lex_state = 107, .external_lex_state = 18},
  [1667] = {.lex_state = 107, .external_lex_state = 18},
  [1668] = {.lex_state = 107, .external_lex_state = 18},
  [1669] = {.lex_state = 107, .external_lex_state = 18},
  [1670] = {.lex_state = 107, .external_lex_state = 18},
  [1671] = {.lex_state = 107, .external_lex_state = 18},
  [1672] = {.lex_state = 107, .external_lex_state = 18},
  [1673] = {.lex_state = 107, .external_lex_state = 18},
  [1674] = {.lex_state = 107, .external_lex_state = 18},
  [1675] = {.lex_state = 22, .external_lex_state = 22},
  [1676] = {.lex_state = 107, .external_lex_state = 18},
  [1677] = {.lex_state = 107, .external_lex_state = 18},
  [1678] = {.lex_state = 107, .external_lex_state = 18},
  [1679] = {.lex_state = 107, .external_lex_state = 18},
  [1680] = {.lex_state = 107, .external_lex_state = 18},
  [1681] = {.lex_state = 107, .external_lex_state = 18},
  [1682] = {.lex_state = 107, .external_lex_state = 18},
  [1683] = {.lex_state = 107, .external_lex_state = 18},
  [1684] = {.lex_state = 107, .external_lex_state = 18},
  [1685] = {.lex_state = 107, .external_lex_state = 18},
  [1686] = {.lex_state = 107, .external_lex_state = 18},
  [1687] = {.lex_state = 107, .external_lex_state = 18},
  [1688] = {.lex_state = 107, .external_lex_state = 18},
  [1689] = {.lex_state = 107, .external_lex_state = 18},
  [1690] = {.lex_state = 107, .external_lex_state = 18},
  [1691] = {.lex_state = 20, .external_lex_state = 22},
  [1692] = {.lex_state = 20, .external_lex_state = 22},
  [1693] = {.lex_state = 20, .external_lex_state = 22},
  [1694] = {.lex_state = 107, .external_lex_state = 18},
  [1695] = {.lex_state = 20, .external_lex_state = 22},
  [1696] = {.lex_state = 107, .external_lex_state = 18},
  [1697] = {.lex_state = 20, .external_lex_state = 22},
  [1698] = {.lex_state = 107, .external_lex_state = 18},
  [1699] = {.lex_state = 18, .external_lex_state = 23},
  [1700] = {.lex_state = 107, .external_lex_state = 18},
  [1701] = {.lex_state = 20, .external_lex_state = 22},
  [1702] = {.lex_state = 107, .external_lex_state = 18},
  [1703] = {.lex_state = 107, .external_lex_state = 18},
  [1704] = {.lex_state = 107, .external_lex_state = 18},
  [1705] = {.lex_state = 107, .external_lex_state = 18},
  [1706] = {.lex_state = 107, .external_lex_state = 18},
  [1707] = {.lex_state = 107, .external_lex_state = 18},
  [1708] = {.lex_state = 107, .external_lex_state = 18},
  [1709] = {.lex_state = 107, .external_lex_state = 18},
  [1710] = {.lex_state = 107, .external_lex_state = 18},
  [1711] = {.lex_state = 107, .external_lex_state = 18},
  [1712] = {.lex_state = 107, .external_lex_state = 18},
  [1713] = {.lex_state = 107, .external_lex_state = 18},
  [1714] = {.lex_state = 18, .external_lex_state = 23},
  [1715] = {.lex_state = 107, .external_lex_state = 18},
  [1716] = {.lex_state = 107, .external_lex_state = 18},
  [1717] = {.lex_state = 107, .external_lex_state = 19},
  [1718] = {.lex_state = 107, .external_lex_state = 17},
  [1719] = {.lex_state = 107, .external_lex_state = 18},
  [1720] = {.lex_state = 107, .external_lex_state = 18},
  [1721] = {.lex_state = 107, .external_lex_state = 18},
  [1722] = {.lex_state = 107, .external_lex_state = 18},
  [1723] = {.lex_state = 107, .external_lex_state = 18},
  [1724] = {.lex_state = 107, .external_lex_state = 19},
  [1725] = {.lex_state = 107, .external_lex_state = 17},
  [1726] = {.lex_state = 107, .external_lex_state = 18},
  [1727] = {.lex_state = 107, .external_lex_state = 18},
  [1728] = {.lex_state = 107, .external_lex_state = 18},
  [1729] = {.lex_state = 107, .external_lex_state = 18},
  [1730] = {.lex_state = 107, .external_lex_state = 18},
  [1731] = {.lex_state = 107, .external_lex_state = 19},
  [1732] = {.lex_state = 107, .external_lex_state = 18},
  [1733] = {.lex_state = 107, .external_lex_state = 18},
  [1734] = {.lex_state = 107, .external_lex_state = 17},
  [1735] = {.lex_state = 107, .external_lex_state = 18},
  [1736] = {.lex_state = 107, .external_lex_state = 18},
  [1737] = {.lex_state = 107, .external_lex_state = 18},
  [1738] = {.lex_state = 107, .external_lex_state = 18},
  [1739] = {.lex_state = 107, .external_lex_state = 18},
  [1740] = {.lex_state = 107, .external_lex_state = 18},
  [1741] = {.lex_state = 107, .external_lex_state = 17},
  [1742] = {.lex_state = 107, .external_lex_state = 18},
  [1743] = {.lex_state = 107, .external_lex_state = 18},
  [1744] = {.lex_state = 107, .external_lex_state = 18},
  [1745] = {.lex_state = 107, .external_lex_state = 19},
  [1746] = {.lex_state = 107, .external_lex_state = 17},
  [1747] = {.lex_state = 107, .external_lex_state = 18},
  [1748] = {.lex_state = 107, .external_lex_state = 18},
  [1749] = {.lex_state = 23, .external_lex_state = 25},
  [1750] = {.lex_state = 107, .external_lex_state = 18},
  [1751] = {.lex_state = 107, .external_lex_state = 19},
  [1752] = {.lex_state = 107, .external_lex_state = 17},
  [1753] = {.lex_state = 107, .external_lex_state = 19},
  [1754] = {.lex_state = 23, .external_lex_state = 25},
  [1755] = {.lex_state = 107, .external_lex_state = 17},
  [1756] = {.lex_state = 23, .external_lex_state = 25},
  [1757] = {.lex_state = 107, .external_lex_state = 17},
  [1758] = {.lex_state = 107, .external_lex_state = 19},
  [1759] = {.lex_state = 107, .external_lex_state = 18},
  [1760] = {.lex_state = 107, .external_lex_state = 18},
  [1761] = {.lex_state = 23, .external_lex_state = 25},
  [1762] = {.lex_state = 23, .external_lex_state = 25},
  [1763] = {.lex_state = 107, .external_lex_state = 17},
  [1764] = {.lex_state = 107, .external_lex_state = 19},
  [1765] = {.lex_state = 107, .external_lex_state = 19},
  [1766] = {.lex_state = 107, .external_lex_state = 17},
  [1767] = {.lex_state = 107, .external_lex_state = 17},
  [1768] = {.lex_state = 107, .external_lex_state = 17},
  [1769] = {.lex_state = 107, .external_lex_state = 17},
  [1770] = {.lex_state = 107, .external_lex_state = 19},
  [1771] = {.lex_state = 107, .external_lex_state = 17},
  [1772] = {.lex_state = 107, .external_lex_state = 17},
  [1773] = {.lex_state = 107, .external_lex_state = 18},
  [1774] = {.lex_state = 107, .external_lex_state = 17},
  [1775] = {.lex_state = 107, .external_lex_state = 19},
  [1776] = {.lex_state = 107, .external_lex_state = 17},
  [1777] = {.lex_state = 107, .external_lex_state = 19},
  [1778] = {.lex_state = 107, .external_lex_state = 17},
  [1779] = {.lex_state = 107, .external_lex_state = 18},
  [1780] = {.lex_state = 23, .external_lex_state = 25},
  [1781] = {.lex_state = 107, .external_lex_state = 17},
  [1782] = {.lex_state = 107, .external_lex_state = 17},
  [1783] = {.lex_state = 107, .external_lex_state = 17},
  [1784] = {.lex_state = 107, .external_lex_state = 19},
  [1785] = {.lex_state = 107, .external_lex_state = 19},
  [1786] = {.lex_state = 107, .external_lex_state = 19},
  [1787] = {.lex_state = 107, .external_lex_state = 18},
  [1788] = {.lex_state = 107, .external_lex_state = 17},
  [1789] = {.lex_state = 107, .external_lex_state = 17},
  [1790] = {.lex_state = 107, .external_lex_state = 17},
  [1791] = {.lex_state = 107, .external_lex_state = 18},
  [1792] = {.lex_state = 107, .external_lex_state = 17},
  [1793] = {.lex_state = 107, .external_lex_state = 17},
  [1794] = {.lex_state = 107, .external_lex_state = 17},
  [1795] = {.lex_state = 107, .external_lex_state = 17},
  [1796] = {.lex_state = 107, .external_lex_state = 17},
  [1797] = {.lex_state = 107, .external_lex_state = 17},
  [1798] = {.lex_state = 107, .external_lex_state = 17},
  [1799] = {.lex_state = 107, .external_lex_state = 17},
  [1800] = {.lex_state = 107, .external_lex_state = 17},
  [1801] = {.lex_state = 107, .external_lex_state = 19},
  [1802] = {.lex_state = 107, .external_lex_state = 17},
  [1803] = {.lex_state = 107, .external_lex_state = 17},
  [1804] = {.lex_state = 23, .external_lex_state = 25},
  [1805] = {.lex_state = 107, .external_lex_state = 19},
  [1806] = {.lex_state = 107, .external_lex_state = 19},
  [1807] = {.lex_state = 107, .external_lex_state = 19},
  [1808] = {.lex_state = 107, .external_lex_state = 19},
  [1809] = {.lex_state = 107, .external_lex_state = 19},
  [1810] = {.lex_state = 107, .external_lex_state = 17},
  [1811] = {.lex_state = 107, .external_lex_state = 17},
  [1812] = {.lex_state = 107, .external_lex_state = 17},
  [1813] = {.lex_state = 107, .external_lex_state = 19},
  [1814] = {.lex_state = 107, .external_lex_state = 19},
  [1815] = {.lex_state = 23, .external_lex_state = 25},
  [1816] = {.lex_state = 107, .external_lex_state = 17},
  [1817] = {.lex_state = 107, .external_lex_state = 17},
  [1818] = {.lex_state = 107, .external_lex_state = 18},
  [1819] = {.lex_state = 107, .external_lex_state = 19},
  [1820] = {.lex_state = 107, .external_lex_state = 18},
  [1821] = {.lex_state = 107, .external_lex_state = 18},
  [1822] = {.lex_state = 107, .external_lex_state = 18},
  [1823] = {.lex_state = 107, .external_lex_state = 19},
  [1824] = {.lex_state = 107, .external_lex_state = 18},
  [1825] = {.lex_state = 23, .external_lex_state = 25},
  [1826] = {.lex_state = 107, .external_lex_state = 18},
  [1827] = {.lex_state = 107, .external_lex_state = 18},
  [1828] = {.lex_state = 107, .external_lex_state = 17},
  [1829] = {.lex_state = 107, .external_lex_state = 18},
  [1830] = {.lex_state = 107, .external_lex_state = 19},
  [1831] = {.lex_state = 107, .external_lex_state = 18},
  [1832] = {.lex_state = 23, .external_lex_state = 25},
  [1833] = {.lex_state = 107, .external_lex_state = 18},
  [1834] = {.lex_state = 107, .external_lex_state = 18},
  [1835] = {.lex_state = 107, .external_lex_state = 17},
  [1836] = {.lex_state = 107, .external_lex_state = 17},
  [1837] = {.lex_state = 107, .external_lex_state = 17},
  [1838] = {.lex_state = 23, .external_lex_state = 26},
  [1839] = {.lex_state = 107, .external_lex_state = 19},
  [1840] = {.lex_state = 107, .external_lex_state = 17},
  [1841] = {.lex_state = 107, .external_lex_state = 17},
  [1842] = {.lex_state = 107, .external_lex_state = 19},
  [1843] = {.lex_state = 107, .external_lex_state = 17},
  [1844] = {.lex_state = 107, .external_lex_state = 19},
  [1845] = {.lex_state = 107, .external_lex_state = 17},
  [1846] = {.lex_state = 107, .external_lex_state = 19},
  [1847] = {.lex_state = 107, .external_lex_state = 19},
  [1848] = {.lex_state = 107, .external_lex_state = 17},
  [1849] = {.lex_state = 107, .external_lex_state = 19},
  [1850] = {.lex_state = 23, .external_lex_state = 26},
  [1851] = {.lex_state = 107, .external_lex_state = 19},
  [1852] = {.lex_state = 107, .external_lex_state = 19},
  [1853] = {.lex_state = 107, .external_lex_state = 19},
  [1854] = {.lex_state = 107, .external_lex_state = 19},
  [1855] = {.lex_state = 107, .external_lex_state = 17},
  [1856] = {.lex_state = 23, .external_lex_state = 26},
  [1857] = {.lex_state = 107, .external_lex_state = 19},
  [1858] = {.lex_state = 107, .external_lex_state = 17},
  [1859] = {.lex_state = 107, .external_lex_state = 17},
  [1860] = {.lex_state = 107, .external_lex_state = 17},
  [1861] = {.lex_state = 107, .external_lex_state = 19},
  [1862] = {.lex_state = 107, .external_lex_state = 17},
  [1863] = {.lex_state = 107, .external_lex_state = 17},
  [1864] = {.lex_state = 107, .external_lex_state = 19},
  [1865] = {.lex_state = 107, .external_lex_state = 27},
  [1866] = {.lex_state = 107, .external_lex_state = 27},
  [1867] = {.lex_state = 107, .external_lex_state = 17},
  [1868] = {.lex_state = 107, .external_lex_state = 17},
  [1869] = {.lex_state = 107, .external_lex_state = 19},
  [1870] = {.lex_state = 107, .external_lex_state = 17},
  [1871] = {.lex_state = 107, .external_lex_state = 17},
  [1872] = {.lex_state = 107, .external_lex_state = 19},
  [1873] = {.lex_state = 107, .external_lex_state = 19},
  [1874] = {.lex_state = 107, .external_lex_state = 17},
  [1875] = {.lex_state = 107, .external_lex_state = 17},
  [1876] = {.lex_state = 107, .external_lex_state = 17},
  [1877] = {.lex_state = 107, .external_lex_state = 17},
  [1878] = {.lex_state = 107, .external_lex_state = 19},
  [1879] = {.lex_state = 107, .external_lex_state = 19},
  [1880] = {.lex_state = 107, .external_lex_state = 19},
  [1881] = {.lex_state = 107, .external_lex_state = 17},
  [1882] = {.lex_state = 107, .external_lex_state = 17},
  [1883] = {.lex_state = 107, .external_lex_state = 17},
  [1884] = {.lex_state = 107, .external_lex_state = 19},
  [1885] = {.lex_state = 107, .external_lex_state = 19},
  [1886] = {.lex_state = 107, .external_lex_state = 17},
  [1887] = {.lex_state = 107, .external_lex_state = 17},
  [1888] = {.lex_state = 107, .external_lex_state = 17},
  [1889] = {.lex_state = 107, .external_lex_state = 17},
  [1890] = {.lex_state = 107, .external_lex_state = 19},
  [1891] = {.lex_state = 107, .external_lex_state = 17},
  [1892] = {.lex_state = 107, .external_lex_state = 17},
  [1893] = {.lex_state = 107, .external_lex_state = 19},
  [1894] = {.lex_state = 107, .external_lex_state = 17},
  [1895] = {.lex_state = 107, .external_lex_state = 17},
  [1896] = {.lex_state = 107, .external_lex_state = 17},
  [1897] = {.lex_state = 107, .external_lex_state = 19},
  [1898] = {.lex_state = 107, .external_lex_state = 17},
  [1899] = {.lex_state = 107, .external_lex_state = 17},
  [1900] = {.lex_state = 107, .external_lex_state = 17},
  [1901] = {.lex_state = 107, .external_lex_state = 19},
  [1902] = {.lex_state = 107, .external_lex_state = 17},
  [1903] = {.lex_state = 107, .external_lex_state = 17},
  [1904] = {.lex_state = 23, .external_lex_state = 26},
  [1905] = {.lex_state = 107, .external_lex_state = 19},
  [1906] = {.lex_state = 107, .external_lex_state = 17},
  [1907] = {.lex_state = 107, .external_lex_state = 19},
  [1908] = {.lex_state = 107, .external_lex_state = 19},
  [1909] = {.lex_state = 107, .external_lex_state = 19},
  [1910] = {.lex_state = 107, .external_lex_state = 17},
  [1911] = {.lex_state = 107, .external_lex_state = 17},
  [1912] = {.lex_state = 107, .external_lex_state = 19},
  [1913] = {.lex_state = 107, .external_lex_state = 19},
  [1914] = {.lex_state = 107, .external_lex_state = 19},
  [1915] = {.lex_state = 107, .external_lex_state = 19},
  [1916] = {.lex_state = 107, .external_lex_state = 19},
  [1917] = {.lex_state = 107, .external_lex_state = 19},
  [1918] = {.lex_state = 107, .external_lex_state = 19},
  [1919] = {.lex_state = 107, .external_lex_state = 17},
  [1920] = {.lex_state = 107, .external_lex_state = 17},
  [1921] = {.lex_state = 107, .external_lex_state = 17},
  [1922] = {.lex_state = 107, .external_lex_state = 17},
  [1923] = {.lex_state = 107, .external_lex_state = 17},
  [1924] = {.lex_state = 107, .external_lex_state = 17},
  [1925] = {.lex_state = 107, .external_lex_state = 17},
  [1926] = {.lex_state = 107, .external_lex_state = 17},
  [1927] = {.lex_state = 107, .external_lex_state = 19},
  [1928] = {.lex_state = 107, .external_lex_state = 19},
  [1929] = {.lex_state = 107, .external_lex_state = 17},
  [1930] = {.lex_state = 107, .external_lex_state = 19},
  [1931] = {.lex_state = 107, .external_lex_state = 17},
  [1932] = {.lex_state = 107, .external_lex_state = 19},
  [1933] = {.lex_state = 107, .external_lex_state = 19},
  [1934] = {.lex_state = 107, .external_lex_state = 19},
  [1935] = {.lex_state = 107, .external_lex_state = 17},
  [1936] = {.lex_state = 107, .external_lex_state = 19},
  [1937] = {.lex_state = 107, .external_lex_state = 17},
  [1938] = {.lex_state = 107, .external_lex_state = 17},
  [1939] = {.lex_state = 107, .external_lex_state = 17},
  [1940] = {.lex_state = 107, .external_lex_state = 19},
  [1941] = {.lex_state = 107, .external_lex_state = 17},
  [1942] = {.lex_state = 107, .external_lex_state = 19},
  [1943] = {.lex_state = 107, .external_lex_state = 19},
  [1944] = {.lex_state = 107, .external_lex_state = 19},
  [1945] = {.lex_state = 107, .external_lex_state = 19},
  [1946] = {.lex_state = 107, .external_lex_state = 19},
  [1947] = {.lex_state = 107, .external_lex_state = 17},
  [1948] = {.lex_state = 107, .external_lex_state = 19},
  [1949] = {.lex_state = 107, .external_lex_state = 17},
  [1950] = {.lex_state = 107, .external_lex_state = 19},
  [1951] = {.lex_state = 107, .external_lex_state = 17},
  [1952] = {.lex_state = 107, .external_lex_state = 19},
  [1953] = {.lex_state = 107, .external_lex_state = 17},
  [1954] = {.lex_state = 107, .external_lex_state = 19},
  [1955] = {.lex_state = 107, .external_lex_state = 17},
  [1956] = {.lex_state = 107, .external_lex_state = 19},
  [1957] = {.lex_state = 107, .external_lex_state = 17},
  [1958] = {.lex_state = 107, .external_lex_state = 19},
  [1959] = {.lex_state = 107, .external_lex_state = 19},
  [1960] = {.lex_state = 107, .external_lex_state = 19},
  [1961] = {.lex_state = 107, .external_lex_state = 17},
  [1962] = {.lex_state = 107, .external_lex_state = 17},
  [1963] = {.lex_state = 107, .external_lex_state = 19},
  [1964] = {.lex_state = 107, .external_lex_state = 19},
  [1965] = {.lex_state = 107, .external_lex_state = 17},
  [1966] = {.lex_state = 107, .external_lex_state = 19},
  [1967] = {.lex_state = 107, .external_lex_state = 17},
  [1968] = {.lex_state = 107, .external_lex_state = 19},
  [1969] = {.lex_state = 107, .external_lex_state = 17},
  [1970] = {.lex_state = 107, .external_lex_state = 17},
  [1971] = {.lex_state = 107, .external_lex_state = 17},
  [1972] = {.lex_state = 107, .external_lex_state = 17},
  [1973] = {.lex_state = 107, .external_lex_state = 17},
  [1974] = {.lex_state = 107, .external_lex_state = 19},
  [1975] = {.lex_state = 107, .external_lex_state = 19},
  [1976] = {.lex_state = 107, .external_lex_state = 27},
  [1977] = {.lex_state = 107, .external_lex_state = 17},
  [1978] = {.lex_state = 107, .external_lex_state = 17},
  [1979] = {.lex_state = 107, .external_lex_state = 17},
  [1980] = {.lex_state = 107, .external_lex_state = 17},
  [1981] = {.lex_state = 107, .external_lex_state = 17},
  [1982] = {.lex_state = 107, .external_lex_state = 19},
  [1983] = {.lex_state = 107, .external_lex_state = 17},
  [1984] = {.lex_state = 107, .external_lex_state = 17},
  [1985] = {.lex_state = 107, .external_lex_state = 19},
  [1986] = {.lex_state = 107, .external_lex_state = 17},
  [1987] = {.lex_state = 107, .external_lex_state = 19},
  [1988] = {.lex_state = 107, .external_lex_state = 17},
  [1989] = {.lex_state = 107, .external_lex_state = 19},
  [1990] = {.lex_state = 107, .external_lex_state = 19},
  [1991] = {.lex_state = 107, .external_lex_state = 19},
  [1992] = {.lex_state = 107, .external_lex_state = 19},
  [1993] = {.lex_state = 107, .external_lex_state = 27},
  [1994] = {.lex_state = 107, .external_lex_state = 19},
  [1995] = {.lex_state = 107, .external_lex_state = 19},
  [1996] = {.lex_state = 107, .external_lex_state = 19},
  [1997] = {.lex_state = 107, .external_lex_state = 17},
  [1998] = {.lex_state = 107, .external_lex_state = 19},
  [1999] = {.lex_state = 107, .external_lex_state = 19},
  [2000] = {.lex_state = 107, .external_lex_state = 19},
  [2001] = {.lex_state = 107, .external_lex_state = 19},
  [2002] = {.lex_state = 107, .external_lex_state = 19},
  [2003] = {.lex_state = 107, .external_lex_state = 19},
  [2004] = {.lex_state = 107, .external_lex_state = 19},
  [2005] = {.lex_state = 107, .external_lex_state = 19},
  [2006] = {.lex_state = 107, .external_lex_state = 19},
  [2007] = {.lex_state = 107, .external_lex_state = 19},
  [2008] = {.lex_state = 107, .external_lex_state = 19},
  [2009] = {.lex_state = 107, .external_lex_state = 19},
  [2010] = {.lex_state = 107, .external_lex_state = 19},
  [2011] = {.lex_state = 107, .external_lex_state = 19},
  [2012] = {.lex_state = 107, .external_lex_state = 19},
  [2013] = {.lex_state = 107, .external_lex_state = 19},
  [2014] = {.lex_state = 107, .external_lex_state = 19},
  [2015] = {.lex_state = 107, .external_lex_state = 19},
  [2016] = {.lex_state = 107, .external_lex_state = 19},
  [2017] = {.lex_state = 107, .external_lex_state = 19},
  [2018] = {.lex_state = 107, .external_lex_state = 19},
  [2019] = {.lex_state = 107, .external_lex_state = 19},
  [2020] = {.lex_state = 107, .external_lex_state = 19},
  [2021] = {.lex_state = 107, .external_lex_state = 19},
  [2022] = {.lex_state = 107, .external_lex_state = 19},
  [2023] = {.lex_state = 107, .external_lex_state = 19},
  [2024] = {.lex_state = 107, .external_lex_state = 19},
  [2025] = {.lex_state = 107, .external_lex_state = 19},
  [2026] = {.lex_state = 107, .external_lex_state = 19},
  [2027] = {.lex_state = 107, .external_lex_state = 19},
  [2028] = {.lex_state = 107, .external_lex_state = 19},
  [2029] = {.lex_state = 107, .external_lex_state = 19},
  [2030] = {.lex_state = 107, .external_lex_state = 19},
  [2031] = {.lex_state = 107, .external_lex_state = 19},
  [2032] = {.lex_state = 107, .external_lex_state = 19},
  [2033] = {.lex_state = 107, .external_lex_state = 19},
  [2034] = {.lex_state = 107, .external_lex_state = 19},
  [2035] = {.lex_state = 107, .external_lex_state = 19},
  [2036] = {.lex_state = 107, .external_lex_state = 19},
  [2037] = {.lex_state = 107, .external_lex_state = 19},
  [2038] = {.lex_state = 107, .external_lex_state = 19},
  [2039] = {.lex_state = 107, .external_lex_state = 19},
  [2040] = {.lex_state = 107, .external_lex_state = 19},
  [2041] = {.lex_state = 107, .external_lex_state = 19},
  [2042] = {.lex_state = 107, .external_lex_state = 19},
  [2043] = {.lex_state = 107, .external_lex_state = 19},
  [2044] = {.lex_state = 107, .external_lex_state = 19},
  [2045] = {.lex_state = 107, .external_lex_state = 19},
  [2046] = {.lex_state = 107, .external_lex_state = 19},
  [2047] = {.lex_state = 107, .external_lex_state = 19},
  [2048] = {.lex_state = 107, .external_lex_state = 19},
  [2049] = {.lex_state = 107, .external_lex_state = 19},
  [2050] = {.lex_state = 107, .external_lex_state = 19},
  [2051] = {.lex_state = 107, .external_lex_state = 19},
  [2052] = {.lex_state = 107, .external_lex_state = 19},
  [2053] = {.lex_state = 107, .external_lex_state = 19},
  [2054] = {.lex_state = 107, .external_lex_state = 19},
  [2055] = {.lex_state = 107, .external_lex_state = 19},
  [2056] = {.lex_state = 107, .external_lex_state = 19},
  [2057] = {.lex_state = 107, .external_lex_state = 19},
  [2058] = {.lex_state = 107, .external_lex_state = 19},
  [2059] = {.lex_state = 107, .external_lex_state = 19},
  [2060] = {.lex_state = 107, .external_lex_state = 19},
  [2061] = {.lex_state = 107, .external_lex_state = 19},
  [2062] = {.lex_state = 107, .external_lex_state = 19},
  [2063] = {.lex_state = 107, .external_lex_state = 19},
  [2064] = {.lex_state = 107, .external_lex_state = 19},
  [2065] = {.lex_state = 107, .external_lex_state = 19},
  [2066] = {.lex_state = 107, .external_lex_state = 19},
  [2067] = {.lex_state = 107, .external_lex_state = 19},
  [2068] = {.lex_state = 107, .external_lex_state = 19},
  [2069] = {.lex_state = 107, .external_lex_state = 19},
  [2070] = {.lex_state = 107, .external_lex_state = 19},
  [2071] = {.lex_state = 107, .external_lex_state = 19},
  [2072] = {.lex_state = 107, .external_lex_state = 19},
  [2073] = {.lex_state = 107, .external_lex_state = 19},
  [2074] = {.lex_state = 107, .external_lex_state = 19},
  [2075] = {.lex_state = 107, .external_lex_state = 18},
  [2076] = {.lex_state = 107, .external_lex_state = 18},
  [2077] = {.lex_state = 107, .external_lex_state = 18},
  [2078] = {.lex_state = 107, .external_lex_state = 18},
  [2079] = {.lex_state = 107, .external_lex_state = 18},
  [2080] = {.lex_state = 107, .external_lex_state = 18},
  [2081] = {.lex_state = 109, .external_lex_state = 28},
  [2082] = {.lex_state = 109, .external_lex_state = 28},
  [2083] = {.lex_state = 109, .external_lex_state = 28},
  [2084] = {.lex_state = 109, .external_lex_state = 28},
  [2085] = {.lex_state = 109, .external_lex_state = 28},
  [2086] = {.lex_state = 109, .external_lex_state = 28},
  [2087] = {.lex_state = 109, .external_lex_state = 28},
  [2088] = {.lex_state = 109, .external_lex_state = 28},
  [2089] = {.lex_state = 109, .external_lex_state = 28},
  [2090] = {.lex_state = 109, .external_lex_state = 28},
  [2091] = {.lex_state = 100, .external_lex_state = 28},
  [2092] = {.lex_state = 100, .external_lex_state = 28},
  [2093] = {.lex_state = 100, .external_lex_state = 28},
  [2094] = {.lex_state = 100, .external_lex_state = 28},
  [2095] = {.lex_state = 100, .external_lex_state = 28},
  [2096] = {.lex_state = 100, .external_lex_state = 28},
  [2097] = {.lex_state = 100, .external_lex_state = 28},
  [2098] = {.lex_state = 100, .external_lex_state = 28},
  [2099] = {.lex_state = 15, .external_lex_state = 28},
  [2100] = {.lex_state = 100, .external_lex_state = 28},
  [2101] = {.lex_state = 100, .external_lex_state = 28},
  [2102] = {.lex_state = 100, .external_lex_state = 28},
  [2103] = {.lex_state = 15, .external_lex_state = 28},
  [2104] = {.lex_state = 100, .external_lex_state = 28},
  [2105] = {.lex_state = 15, .external_lex_state = 28},
  [2106] = {.lex_state = 15, .external_lex_state = 28},
  [2107] = {.lex_state = 15, .external_lex_state = 28},
  [2108] = {.lex_state = 15, .external_lex_state = 28},
  [2109] = {.lex_state = 100, .external_lex_state = 28},
  [2110] = {.lex_state = 100, .external_lex_state = 28},
  [2111] = {.lex_state = 100, .external_lex_state = 28},
  [2112] = {.lex_state = 100, .external_lex_state = 28},
  [2113] = {.lex_state = 100, .external_lex_state = 28},
  [2114] = {.lex_state = 100, .external_lex_state = 28},
  [2115] = {.lex_state = 100, .external_lex_state = 28},
  [2116] = {.lex_state = 100, .external_lex_state = 28},
  [2117] = {.lex_state = 100, .external_lex_state = 28},
  [2118] = {.lex_state = 100, .external_lex_state = 28},
  [2119] = {.lex_state = 109, .external_lex_state = 28},
  [2120] = {.lex_state = 100, .external_lex_state = 28},
  [2121] = {.lex_state = 100, .external_lex_state = 28},
  [2122] = {.lex_state = 100, .external_lex_state = 28},
  [2123] = {.lex_state = 100, .external_lex_state = 28},
  [2124] = {.lex_state = 100, .external_lex_state = 28},
  [2125] = {.lex_state = 100, .external_lex_state = 28},
  [2126] = {.lex_state = 100, .external_lex_state = 28},
  [2127] = {.lex_state = 15, .external_lex_state = 29},
  [2128] = {.lex_state = 15, .external_lex_state = 29},
  [2129] = {.lex_state = 100, .external_lex_state = 28},
  [2130] = {.lex_state = 100, .external_lex_state = 28},
  [2131] = {.lex_state = 100, .external_lex_state = 28},
  [2132] = {.lex_state = 100, .external_lex_state = 28},
  [2133] = {.lex_state = 100, .external_lex_state = 28},
  [2134] = {.lex_state = 100, .external_lex_state = 28},
  [2135] = {.lex_state = 108, .external_lex_state = 28},
  [2136] = {.lex_state = 15, .external_lex_state = 29},
  [2137] = {.lex_state = 100, .external_lex_state = 28},
  [2138] = {.lex_state = 100, .external_lex_state = 28},
  [2139] = {.lex_state = 15, .external_lex_state = 29},
  [2140] = {.lex_state = 15, .external_lex_state = 28},
  [2141] = {.lex_state = 15, .external_lex_state = 28},
  [2142] = {.lex_state = 15, .external_lex_state = 29},
  [2143] = {.lex_state = 15, .external_lex_state = 28},
  [2144] = {.lex_state = 15},
  [2145] = {.lex_state = 109, .external_lex_state = 28},
  [2146] = {.lex_state = 15, .external_lex_state = 29},
  [2147] = {.lex_state = 109, .external_lex_state = 28},
  [2148] = {.lex_state = 15, .external_lex_state = 30},
  [2149] = {.lex_state = 15, .external_lex_state = 29},
  [2150] = {.lex_state = 100, .external_lex_state = 28},
  [2151] = {.lex_state = 15, .external_lex_state = 29},
  [2152] = {.lex_state = 109, .external_lex_state = 28},
  [2153] = {.lex_state = 100, .external_lex_state = 28},
  [2154] = {.lex_state = 15, .external_lex_state = 29},
  [2155] = {.lex_state = 109, .external_lex_state = 28},
  [2156] = {.lex_state = 15, .external_lex_state = 29},
  [2157] = {.lex_state = 15, .external_lex_state = 29},
  [2158] = {.lex_state = 109, .external_lex_state = 28},
  [2159] = {.lex_state = 15, .external_lex_state = 29},
  [2160] = {.lex_state = 109, .external_lex_state = 28},
  [2161] = {.lex_state = 109, .external_lex_state = 30},
  [2162] = {.lex_state = 28, .external_lex_state = 29},
  [2163] = {.lex_state = 109, .external_lex_state = 30},
  [2164] = {.lex_state = 15, .external_lex_state = 29},
  [2165] = {.lex_state = 15, .external_lex_state = 29},
  [2166] = {.lex_state = 15, .external_lex_state = 29},
  [2167] = {.lex_state = 109, .external_lex_state = 28},
  [2168] = {.lex_state = 15, .external_lex_state = 29},
  [2169] = {.lex_state = 28, .external_lex_state = 29},
  [2170] = {.lex_state = 109, .external_lex_state = 28},
  [2171] = {.lex_state = 109, .external_lex_state = 28},
  [2172] = {.lex_state = 109, .external_lex_state = 28},
  [2173] = {.lex_state = 109, .external_lex_state = 28},
  [2174] = {.lex_state = 109, .external_lex_state = 28},
  [2175] = {.lex_state = 109, .external_lex_state = 30},
  [2176] = {.lex_state = 100, .external_lex_state = 28},
  [2177] = {.lex_state = 100},
  [2178] = {.lex_state = 100, .external_lex_state = 28},
  [2179] = {.lex_state = 100, .external_lex_state = 28},
  [2180] = {.lex_state = 100, .external_lex_state = 28},
  [2181] = {.lex_state = 100, .external_lex_state = 28},
  [2182] = {.lex_state = 100, .external_lex_state = 28},
  [2183] = {.lex_state = 100, .external_lex_state = 28},
  [2184] = {.lex_state = 100},
  [2185] = {.lex_state = 100, .external_lex_state = 28},
  [2186] = {.lex_state = 100},
  [2187] = {.lex_state = 100},
  [2188] = {.lex_state = 109, .external_lex_state = 28},
  [2189] = {.lex_state = 109, .external_lex_state = 28},
  [2190] = {.lex_state = 28, .external_lex_state = 29},
  [2191] = {.lex_state = 109, .external_lex_state = 28},
  [2192] = {.lex_state = 100, .external_lex_state = 28},
  [2193] = {.lex_state = 28, .external_lex_state = 29},
  [2194] = {.lex_state = 109, .external_lex_state = 28},
  [2195] = {.lex_state = 28, .external_lex_state = 29},
  [2196] = {.lex_state = 28, .external_lex_state = 29},
  [2197] = {.lex_state = 28, .external_lex_state = 29},
  [2198] = {.lex_state = 28, .external_lex_state = 29},
  [2199] = {.lex_state = 100},
  [2200] = {.lex_state = 28, .external_lex_state = 29},
  [2201] = {.lex_state = 108, .external_lex_state = 28},
  [2202] = {.lex_state = 100, .external_lex_state = 28},
  [2203] = {.lex_state = 100, .external_lex_state = 28},
  [2204] = {.lex_state = 100, .external_lex_state = 28},
  [2205] = {.lex_state = 100, .external_lex_state = 28},
  [2206] = {.lex_state = 109, .external_lex_state = 30},
  [2207] = {.lex_state = 100},
  [2208] = {.lex_state = 27, .external_lex_state = 28},
  [2209] = {.lex_state = 100, .external_lex_state = 28},
  [2210] = {.lex_state = 100, .external_lex_state = 28},
  [2211] = {.lex_state = 100, .external_lex_state = 28},
  [2212] = {.lex_state = 100, .external_lex_state = 28},
  [2213] = {.lex_state = 100, .external_lex_state = 28},
  [2214] = {.lex_state = 100, .external_lex_state = 28},
  [2215] = {.lex_state = 109, .external_lex_state = 28},
  [2216] = {.lex_state = 109, .external_lex_state = 28},
  [2217] = {.lex_state = 109, .external_lex_state = 28},
  [2218] = {.lex_state = 109, .external_lex_state = 28},
  [2219] = {.lex_state = 100, .external_lex_state = 28},
  [2220] = {.lex_state = 100, .external_lex_state = 28},
  [2221] = {.lex_state = 100, .external_lex_state = 28},
  [2222] = {.lex_state = 100, .external_lex_state = 28},
  [2223] = {.lex_state = 100},
  [2224] = {.lex_state = 100},
  [2225] = {.lex_state = 100},
  [2226] = {.lex_state = 100},
  [2227] = {.lex_state = 100},
  [2228] = {.lex_state = 100},
  [2229] = {.lex_state = 100},
  [2230] = {.lex_state = 100},
  [2231] = {.lex_state = 100},
  [2232] = {.lex_state = 15, .external_lex_state = 28},
  [2233] = {.lex_state = 100},
  [2234] = {.lex_state = 100},
  [2235] = {.lex_state = 100},
  [2236] = {.lex_state = 100},
  [2237] = {.lex_state = 100},
  [2238] = {.lex_state = 100},
  [2239] = {.lex_state = 100, .external_lex_state = 30},
  [2240] = {.lex_state = 100, .external_lex_state = 30},
  [2241] = {.lex_state = 100, .external_lex_state = 29},
  [2242] = {.lex_state = 100, .external_lex_state = 29},
  [2243] = {.lex_state = 100, .external_lex_state = 29},
  [2244] = {.lex_state = 100, .external_lex_state = 28},
  [2245] = {.lex_state = 25, .external_lex_state = 31},
  [2246] = {.lex_state = 28, .external_lex_state = 29},
  [2247] = {.lex_state = 100, .external_lex_state = 29},
  [2248] = {.lex_state = 100, .external_lex_state = 29},
  [2249] = {.lex_state = 100, .external_lex_state = 29},
  [2250] = {.lex_state = 100, .external_lex_state = 29},
  [2251] = {.lex_state = 100, .external_lex_state = 29},
  [2252] = {.lex_state = 100, .external_lex_state = 29},
  [2253] = {.lex_state = 28, .external_lex_state = 29},
  [2254] = {.lex_state = 28, .external_lex_state = 29},
  [2255] = {.lex_state = 28, .external_lex_state = 29},
  [2256] = {.lex_state = 100, .external_lex_state = 29},
  [2257] = {.lex_state = 100, .external_lex_state = 29},
  [2258] = {.lex_state = 28, .external_lex_state = 29},
  [2259] = {.lex_state = 28, .external_lex_state = 29},
  [2260] = {.lex_state = 100, .external_lex_state = 29},
  [2261] = {.lex_state = 25, .external_lex_state = 31},
  [2262] = {.lex_state = 100, .external_lex_state = 29},
  [2263] = {.lex_state = 28, .external_lex_state = 29},
  [2264] = {.lex_state = 28, .external_lex_state = 29},
  [2265] = {.lex_state = 25, .external_lex_state = 31},
  [2266] = {.lex_state = 28, .external_lex_state = 29},
  [2267] = {.lex_state = 28, .external_lex_state = 29},
  [2268] = {.lex_state = 28, .external_lex_state = 29},
  [2269] = {.lex_state = 25, .external_lex_state = 31},
  [2270] = {.lex_state = 100, .external_lex_state = 29},
  [2271] = {.lex_state = 28, .external_lex_state = 29},
  [2272] = {.lex_state = 25, .external_lex_state = 31},
  [2273] = {.lex_state = 100, .external_lex_state = 28},
  [2274] = {.lex_state = 100, .external_lex_state = 29},
  [2275] = {.lex_state = 100, .external_lex_state = 29},
  [2276] = {.lex_state = 28, .external_lex_state = 29},
  [2277] = {.lex_state = 100, .external_lex_state = 29},
  [2278] = {.lex_state = 100, .external_lex_state = 29},
  [2279] = {.lex_state = 28, .external_lex_state = 29},
  [2280] = {.lex_state = 100, .external_lex_state = 29},
  [2281] = {.lex_state = 25, .external_lex_state = 31},
  [2282] = {.lex_state = 25, .external_lex_state = 31},
  [2283] = {.lex_state = 100, .external_lex_state = 29},
  [2284] = {.lex_state = 100, .external_lex_state = 29},
  [2285] = {.lex_state = 100, .external_lex_state = 29},
  [2286] = {.lex_state = 28, .external_lex_state = 29},
  [2287] = {.lex_state = 100, .external_lex_state = 29},
  [2288] = {.lex_state = 100, .external_lex_state = 29},
  [2289] = {.lex_state = 100, .external_lex_state = 29},
  [2290] = {.lex_state = 27, .external_lex_state = 28},
  [2291] = {.lex_state = 100, .external_lex_state = 29},
  [2292] = {.lex_state = 100, .external_lex_state = 29},
  [2293] = {.lex_state = 25, .external_lex_state = 31},
  [2294] = {.lex_state = 28, .external_lex_state = 29},
  [2295] = {.lex_state = 25, .external_lex_state = 31},
  [2296] = {.lex_state = 28, .external_lex_state = 29},
  [2297] = {.lex_state = 28, .external_lex_state = 29},
  [2298] = {.lex_state = 28, .external_lex_state = 29},
  [2299] = {.lex_state = 28, .external_lex_state = 29},
  [2300] = {.lex_state = 28, .external_lex_state = 29},
  [2301] = {.lex_state = 100, .external_lex_state = 29},
  [2302] = {.lex_state = 28, .external_lex_state = 29},
  [2303] = {.lex_state = 100, .external_lex_state = 29},
  [2304] = {.lex_state = 100, .external_lex_state = 29},
  [2305] = {.lex_state = 100, .external_lex_state = 29},
  [2306] = {.lex_state = 100, .external_lex_state = 29},
  [2307] = {.lex_state = 25, .external_lex_state = 31},
  [2308] = {.lex_state = 100, .external_lex_state = 29},
  [2309] = {.lex_state = 25, .external_lex_state = 31},
  [2310] = {.lex_state = 25, .external_lex_state = 31},
  [2311] = {.lex_state = 100, .external_lex_state = 29},
  [2312] = {.lex_state = 100, .external_lex_state = 29},
  [2313] = {.lex_state = 100, .external_lex_state = 29},
  [2314] = {.lex_state = 100, .external_lex_state = 29},
  [2315] = {.lex_state = 109, .external_lex_state = 28},
  [2316] = {.lex_state = 100},
  [2317] = {.lex_state = 100},
  [2318] = {.lex_state = 100},
  [2319] = {.lex_state = 100, .external_lex_state = 28},
  [2320] = {.lex_state = 109, .external_lex_state = 28},
  [2321] = {.lex_state = 109, .external_lex_state = 32},
  [2322] = {.lex_state = 100},
  [2323] = {.lex_state = 100},
  [2324] = {.lex_state = 100},
  [2325] = {.lex_state = 100},
  [2326] = {.lex_state = 100},
  [2327] = {.lex_state = 108},
  [2328] = {.lex_state = 100},
  [2329] = {.lex_state = 100},
  [2330] = {.lex_state = 100},
  [2331] = {.lex_state = 100},
  [2332] = {.lex_state = 100},
  [2333] = {.lex_state = 109, .external_lex_state = 32},
  [2334] = {.lex_state = 100},
  [2335] = {.lex_state = 100, .external_lex_state = 28},
  [2336] = {.lex_state = 100},
  [2337] = {.lex_state = 100},
  [2338] = {.lex_state = 25, .external_lex_state = 31},
  [2339] = {.lex_state = 100},
  [2340] = {.lex_state = 25, .external_lex_state = 31},
  [2341] = {.lex_state = 100},
  [2342] = {.lex_state = 100},
  [2343] = {.lex_state = 25, .external_lex_state = 33},
  [2344] = {.lex_state = 25, .external_lex_state = 33},
  [2345] = {.lex_state = 25, .external_lex_state = 31},
  [2346] = {.lex_state = 25, .external_lex_state = 31},
  [2347] = {.lex_state = 100, .external_lex_state = 29},
  [2348] = {.lex_state = 100},
  [2349] = {.lex_state = 100},
  [2350] = {.lex_state = 25, .external_lex_state = 31},
  [2351] = {.lex_state = 25, .external_lex_state = 31},
  [2352] = {.lex_state = 25, .external_lex_state = 31},
  [2353] = {.lex_state = 25, .external_lex_state = 31},
  [2354] = {.lex_state = 100},
  [2355] = {.lex_state = 100},
  [2356] = {.lex_state = 100},
  [2357] = {.lex_state = 100},
  [2358] = {.lex_state = 100, .external_lex_state = 29},
  [2359] = {.lex_state = 100},
  [2360] = {.lex_state = 109, .external_lex_state = 28},
  [2361] = {.lex_state = 109, .external_lex_state = 28},
  [2362] = {.lex_state = 109, .external_lex_state = 28},
  [2363] = {.lex_state = 109, .external_lex_state = 28},
  [2364] = {.lex_state = 100},
  [2365] = {.lex_state = 109, .external_lex_state = 28},
  [2366] = {.lex_state = 100},
  [2367] = {.lex_state = 109, .external_lex_state = 28},
  [2368] = {.lex_state = 109, .external_lex_state = 28},
  [2369] = {.lex_state = 109, .external_lex_state = 28},
  [2370] = {.lex_state = 109, .external_lex_state = 28},
  [2371] = {.lex_state = 100},
  [2372] = {.lex_state = 100, .external_lex_state = 28},
  [2373] = {.lex_state = 100},
  [2374] = {.lex_state = 109, .external_lex_state = 29},
  [2375] = {.lex_state = 100},
  [2376] = {.lex_state = 25, .external_lex_state = 31},
  [2377] = {.lex_state = 25, .external_lex_state = 31},
  [2378] = {.lex_state = 25, .external_lex_state = 33},
  [2379] = {.lex_state = 25, .external_lex_state = 31},
  [2380] = {.lex_state = 25, .external_lex_state = 31},
  [2381] = {.lex_state = 25, .external_lex_state = 31},
  [2382] = {.lex_state = 25, .external_lex_state = 33},
  [2383] = {.lex_state = 25, .external_lex_state = 31},
  [2384] = {.lex_state = 109, .external_lex_state = 32},
  [2385] = {.lex_state = 100},
  [2386] = {.lex_state = 25, .external_lex_state = 31},
  [2387] = {.lex_state = 26, .external_lex_state = 31},
  [2388] = {.lex_state = 100, .external_lex_state = 29},
  [2389] = {.lex_state = 26, .external_lex_state = 31},
  [2390] = {.lex_state = 26, .external_lex_state = 31},
  [2391] = {.lex_state = 100},
  [2392] = {.lex_state = 25, .external_lex_state = 33},
  [2393] = {.lex_state = 100, .external_lex_state = 29},
  [2394] = {.lex_state = 25, .external_lex_state = 33},
  [2395] = {.lex_state = 100, .external_lex_state = 29},
  [2396] = {.lex_state = 26, .external_lex_state = 31},
  [2397] = {.lex_state = 26, .external_lex_state = 31},
  [2398] = {.lex_state = 26, .external_lex_state = 31},
  [2399] = {.lex_state = 25, .external_lex_state = 33},
  [2400] = {.lex_state = 26, .external_lex_state = 31},
  [2401] = {.lex_state = 25, .external_lex_state = 33},
  [2402] = {.lex_state = 26, .external_lex_state = 31},
  [2403] = {.lex_state = 100, .external_lex_state = 29},
  [2404] = {.lex_state = 26, .external_lex_state = 31},
  [2405] = {.lex_state = 26, .external_lex_state = 31},
  [2406] = {.lex_state = 26, .external_lex_state = 31},
  [2407] = {.lex_state = 26, .external_lex_state = 31},
  [2408] = {.lex_state = 26, .external_lex_state = 31},
  [2409] = {.lex_state = 100, .external_lex_state = 29},
  [2410] = {.lex_state = 26, .external_lex_state = 31},
  [2411] = {.lex_state = 26, .external_lex_state = 31},
  [2412] = {.lex_state = 26, .external_lex_state = 31},
  [2413] = {.lex_state = 26, .external_lex_state = 31},
  [2414] = {.lex_state = 100, .external_lex_state = 29},
  [2415] = {.lex_state = 26, .external_lex_state = 31},
  [2416] = {.lex_state = 100},
  [2417] = {.lex_state = 26, .external_lex_state = 31},
  [2418] = {.lex_state = 26, .external_lex_state = 31},
  [2419] = {.lex_state = 100},
  [2420] = {.lex_state = 100},
  [2421] = {.lex_state = 26, .external_lex_state = 31},
  [2422] = {.lex_state = 26, .external_lex_state = 31},
  [2423] = {.lex_state = 26, .external_lex_state = 31},
  [2424] = {.lex_state = 26, .external_lex_state = 31},
  [2425] = {.lex_state = 100, .external_lex_state = 29},
  [2426] = {.lex_state = 26, .external_lex_state = 31},
  [2427] = {.lex_state = 100, .external_lex_state = 29},
  [2428] = {.lex_state = 26, .external_lex_state = 31},
  [2429] = {.lex_state = 26, .external_lex_state = 31},
  [2430] = {.lex_state = 26, .external_lex_state = 31},
  [2431] = {.lex_state = 26, .external_lex_state = 31},
  [2432] = {.lex_state = 26, .external_lex_state = 31},
  [2433] = {.lex_state = 100, .external_lex_state = 29},
  [2434] = {.lex_state = 26, .external_lex_state = 31},
  [2435] = {.lex_state = 26, .external_lex_state = 31},
  [2436] = {.lex_state = 26, .external_lex_state = 31},
  [2437] = {.lex_state = 26, .external_lex_state = 31},
  [2438] = {.lex_state = 100},
  [2439] = {.lex_state = 100, .external_lex_state = 29},
  [2440] = {.lex_state = 26, .external_lex_state = 31},
  [2441] = {.lex_state = 100, .external_lex_state = 28},
  [2442] = {.lex_state = 26, .external_lex_state = 31},
  [2443] = {.lex_state = 100, .external_lex_state = 29},
  [2444] = {.lex_state = 100, .external_lex_state = 29},
  [2445] = {.lex_state = 26, .external_lex_state = 31},
  [2446] = {.lex_state = 26, .external_lex_state = 31},
  [2447] = {.lex_state = 100, .external_lex_state = 29},
  [2448] = {.lex_state = 26, .external_lex_state = 31},
  [2449] = {.lex_state = 26, .external_lex_state = 31},
  [2450] = {.lex_state = 100, .external_lex_state = 29},
  [2451] = {.lex_state = 26, .external_lex_state = 31},
  [2452] = {.lex_state = 26, .external_lex_state = 31},
  [2453] = {.lex_state = 26, .external_lex_state = 31},
  [2454] = {.lex_state = 26, .external_lex_state = 31},
  [2455] = {.lex_state = 26, .external_lex_state = 31},
  [2456] = {.lex_state = 26, .external_lex_state = 31},
  [2457] = {.lex_state = 100, .external_lex_state = 29},
  [2458] = {.lex_state = 100, .external_lex_state = 29},
  [2459] = {.lex_state = 100, .external_lex_state = 29},
  [2460] = {.lex_state = 100, .external_lex_state = 29},
  [2461] = {.lex_state = 26, .external_lex_state = 31},
  [2462] = {.lex_state = 100},
  [2463] = {.lex_state = 26, .external_lex_state = 31},
  [2464] = {.lex_state = 26, .external_lex_state = 31},
  [2465] = {.lex_state = 26, .external_lex_state = 31},
  [2466] = {.lex_state = 109, .external_lex_state = 29},
  [2467] = {.lex_state = 100, .external_lex_state = 29},
  [2468] = {.lex_state = 109, .external_lex_state = 29},
  [2469] = {.lex_state = 100, .external_lex_state = 29},
  [2470] = {.lex_state = 26, .external_lex_state = 31},
  [2471] = {.lex_state = 109, .external_lex_state = 29},
  [2472] = {.lex_state = 100, .external_lex_state = 29},
  [2473] = {.lex_state = 100, .external_lex_state = 28},
  [2474] = {.lex_state = 109, .external_lex_state = 29},
  [2475] = {.lex_state = 100, .external_lex_state = 29},
  [2476] = {.lex_state = 100, .external_lex_state = 29},
  [2477] = {.lex_state = 26, .external_lex_state = 31},
  [2478] = {.lex_state = 26, .external_lex_state = 31},
  [2479] = {.lex_state = 100, .external_lex_state = 28},
  [2480] = {.lex_state = 100, .external_lex_state = 29},
  [2481] = {.lex_state = 26, .external_lex_state = 31},
  [2482] = {.lex_state = 109, .external_lex_state = 29},
  [2483] = {.lex_state = 26, .external_lex_state = 31},
  [2484] = {.lex_state = 26, .external_lex_state = 31},
  [2485] = {.lex_state = 100, .external_lex_state = 29},
  [2486] = {.lex_state = 109, .external_lex_state = 29},
  [2487] = {.lex_state = 26, .external_lex_state = 31},
  [2488] = {.lex_state = 100, .external_lex_state = 29},
  [2489] = {.lex_state = 26, .external_lex_state = 33},
  [2490] = {.lex_state = 26, .external_lex_state = 33},
  [2491] = {.lex_state = 26, .external_lex_state = 33},
  [2492] = {.lex_state = 25, .external_lex_state = 31},
  [2493] = {.lex_state = 26, .external_lex_state = 33},
  [2494] = {.lex_state = 26, .external_lex_state = 33},
  [2495] = {.lex_state = 26, .external_lex_state = 33},
  [2496] = {.lex_state = 26, .external_lex_state = 33},
  [2497] = {.lex_state = 26, .external_lex_state = 33},
  [2498] = {.lex_state = 26, .external_lex_state = 33},
  [2499] = {.lex_state = 109, .external_lex_state = 32},
  [2500] = {.lex_state = 109, .external_lex_state = 32},
  [2501] = {.lex_state = 100, .external_lex_state = 29},
  [2502] = {.lex_state = 100, .external_lex_state = 28},
  [2503] = {.lex_state = 100, .external_lex_state = 28},
  [2504] = {.lex_state = 30, .external_lex_state = 28},
  [2505] = {.lex_state = 26, .external_lex_state = 33},
  [2506] = {.lex_state = 26, .external_lex_state = 33},
  [2507] = {.lex_state = 26, .external_lex_state = 34},
  [2508] = {.lex_state = 26, .external_lex_state = 34},
  [2509] = {.lex_state = 108, .external_lex_state = 29},
  [2510] = {.lex_state = 100, .external_lex_state = 28},
  [2511] = {.lex_state = 26, .external_lex_state = 35},
  [2512] = {.lex_state = 26, .external_lex_state = 33},
  [2513] = {.lex_state = 100, .external_lex_state = 29},
  [2514] = {.lex_state = 100, .external_lex_state = 29},
  [2515] = {.lex_state = 26, .external_lex_state = 33},
  [2516] = {.lex_state = 100},
  [2517] = {.lex_state = 100},
  [2518] = {.lex_state = 100, .external_lex_state = 28},
  [2519] = {.lex_state = 108, .external_lex_state = 29},
  [2520] = {.lex_state = 100, .external_lex_state = 29},
  [2521] = {.lex_state = 100, .external_lex_state = 29},
  [2522] = {.lex_state = 26, .external_lex_state = 35},
  [2523] = {.lex_state = 100},
  [2524] = {.lex_state = 100},
  [2525] = {.lex_state = 26, .external_lex_state = 35},
  [2526] = {.lex_state = 100, .external_lex_state = 29},
  [2527] = {.lex_state = 26, .external_lex_state = 33},
  [2528] = {.lex_state = 100, .external_lex_state = 29},
  [2529] = {.lex_state = 109, .external_lex_state = 32},
  [2530] = {.lex_state = 109, .external_lex_state = 29},
  [2531] = {.lex_state = 100, .external_lex_state = 28},
  [2532] = {.lex_state = 30, .external_lex_state = 29},
  [2533] = {.lex_state = 25, .external_lex_state = 31},
  [2534] = {.lex_state = 26, .external_lex_state = 33},
  [2535] = {.lex_state = 100, .external_lex_state = 29},
  [2536] = {.lex_state = 100, .external_lex_state = 28},
  [2537] = {.lex_state = 100},
  [2538] = {.lex_state = 100},
  [2539] = {.lex_state = 30, .external_lex_state = 29},
  [2540] = {.lex_state = 100},
  [2541] = {.lex_state = 26, .external_lex_state = 33},
  [2542] = {.lex_state = 26, .external_lex_state = 33},
  [2543] = {.lex_state = 26, .external_lex_state = 33},
  [2544] = {.lex_state = 100, .external_lex_state = 28},
  [2545] = {.lex_state = 108, .external_lex_state = 29},
  [2546] = {.lex_state = 100, .external_lex_state = 29},
  [2547] = {.lex_state = 100},
  [2548] = {.lex_state = 100},
  [2549] = {.lex_state = 100},
  [2550] = {.lex_state = 109, .external_lex_state = 29},
  [2551] = {.lex_state = 109, .external_lex_state = 29},
  [2552] = {.lex_state = 109, .external_lex_state = 29},
  [2553] = {.lex_state = 109, .external_lex_state = 29},
  [2554] = {.lex_state = 109, .external_lex_state = 29},
  [2555] = {.lex_state = 109, .external_lex_state = 29},
  [2556] = {.lex_state = 100, .external_lex_state = 29},
  [2557] = {.lex_state = 100, .external_lex_state = 29},
  [2558] = {.lex_state = 109, .external_lex_state = 29},
  [2559] = {.lex_state = 100, .external_lex_state = 29},
  [2560] = {.lex_state = 100, .external_lex_state = 29},
  [2561] = {.lex_state = 100, .external_lex_state = 28},
  [2562] = {.lex_state = 100, .external_lex_state = 29},
  [2563] = {.lex_state = 109, .external_lex_state = 29},
  [2564] = {.lex_state = 109, .external_lex_state = 29},
  [2565] = {.lex_state = 109, .external_lex_state = 29},
  [2566] = {.lex_state = 109, .external_lex_state = 29},
  [2567] = {.lex_state = 100, .external_lex_state = 29},
  [2568] = {.lex_state = 100, .external_lex_state = 29},
  [2569] = {.lex_state = 26, .external_lex_state = 31},
  [2570] = {.lex_state = 109, .external_lex_state = 29},
  [2571] = {.lex_state = 109, .external_lex_state = 29},
  [2572] = {.lex_state = 100, .external_lex_state = 29},
  [2573] = {.lex_state = 109, .external_lex_state = 29},
  [2574] = {.lex_state = 100, .external_lex_state = 28},
  [2575] = {.lex_state = 109, .external_lex_state = 29},
  [2576] = {.lex_state = 100, .external_lex_state = 29},
  [2577] = {.lex_state = 100, .external_lex_state = 29},
  [2578] = {.lex_state = 109, .external_lex_state = 29},
  [2579] = {.lex_state = 100, .external_lex_state = 29},
  [2580] = {.lex_state = 108, .external_lex_state = 29},
  [2581] = {.lex_state = 100, .external_lex_state = 29},
  [2582] = {.lex_state = 109, .external_lex_state = 29},
  [2583] = {.lex_state = 109, .external_lex_state = 29},
  [2584] = {.lex_state = 100, .external_lex_state = 29},
  [2585] = {.lex_state = 109, .external_lex_state = 29},
  [2586] = {.lex_state = 108, .external_lex_state = 29},
  [2587] = {.lex_state = 109, .external_lex_state = 29},
  [2588] = {.lex_state = 100, .external_lex_state = 30},
  [2589] = {.lex_state = 100},
  [2590] = {.lex_state = 100},
  [2591] = {.lex_state = 109, .external_lex_state = 29},
  [2592] = {.lex_state = 109, .external_lex_state = 29},
  [2593] = {.lex_state = 109, .external_lex_state = 29},
  [2594] = {.lex_state = 109, .external_lex_state = 29},
  [2595] = {.lex_state = 109, .external_lex_state = 29},
  [2596] = {.lex_state = 100, .external_lex_state = 29},
  [2597] = {.lex_state = 26, .external_lex_state = 31},
  [2598] = {.lex_state = 30, .external_lex_state = 29},
  [2599] = {.lex_state = 100, .external_lex_state = 28},
  [2600] = {.lex_state = 109, .external_lex_state = 29},
  [2601] = {.lex_state = 109, .external_lex_state = 29},
  [2602] = {.lex_state = 109, .external_lex_state = 29},
  [2603] = {.lex_state = 109, .external_lex_state = 29},
  [2604] = {.lex_state = 109, .external_lex_state = 29},
  [2605] = {.lex_state = 109, .external_lex_state = 29},
  [2606] = {.lex_state = 109, .external_lex_state = 29},
  [2607] = {.lex_state = 100, .external_lex_state = 29},
  [2608] = {.lex_state = 109, .external_lex_state = 29},
  [2609] = {.lex_state = 100, .external_lex_state = 29},
  [2610] = {.lex_state = 109, .external_lex_state = 29},
  [2611] = {.lex_state = 109, .external_lex_state = 29},
  [2612] = {.lex_state = 100, .external_lex_state = 29},
  [2613] = {.lex_state = 100, .external_lex_state = 29},
  [2614] = {.lex_state = 109, .external_lex_state = 29},
  [2615] = {.lex_state = 109, .external_lex_state = 29},
  [2616] = {.lex_state = 109, .external_lex_state = 29},
  [2617] = {.lex_state = 109, .external_lex_state = 29},
  [2618] = {.lex_state = 100, .external_lex_state = 29},
  [2619] = {.lex_state = 100, .external_lex_state = 29},
  [2620] = {.lex_state = 100, .external_lex_state = 28},
  [2621] = {.lex_state = 100, .external_lex_state = 29},
  [2622] = {.lex_state = 109, .external_lex_state = 29},
  [2623] = {.lex_state = 109, .external_lex_state = 29},
  [2624] = {.lex_state = 109, .external_lex_state = 29},
  [2625] = {.lex_state = 100, .external_lex_state = 29},
  [2626] = {.lex_state = 109, .external_lex_state = 29},
  [2627] = {.lex_state = 100, .external_lex_state = 28},
  [2628] = {.lex_state = 109, .external_lex_state = 29},
  [2629] = {.lex_state = 100, .external_lex_state = 29},
  [2630] = {.lex_state = 100, .external_lex_state = 28},
  [2631] = {.lex_state = 100, .external_lex_state = 28},
  [2632] = {.lex_state = 109, .external_lex_state = 29},
  [2633] = {.lex_state = 109, .external_lex_state = 29},
  [2634] = {.lex_state = 109, .external_lex_state = 29},
  [2635] = {.lex_state = 109, .external_lex_state = 29},
  [2636] = {.lex_state = 109, .external_lex_state = 29},
  [2637] = {.lex_state = 109, .external_lex_state = 29},
  [2638] = {.lex_state = 109, .external_lex_state = 29},
  [2639] = {.lex_state = 109, .external_lex_state = 29},
  [2640] = {.lex_state = 100, .external_lex_state = 29},
  [2641] = {.lex_state = 109, .external_lex_state = 29},
  [2642] = {.lex_state = 109, .external_lex_state = 29},
  [2643] = {.lex_state = 109, .external_lex_state = 29},
  [2644] = {.lex_state = 109, .external_lex_state = 29},
  [2645] = {.lex_state = 109, .external_lex_state = 29},
  [2646] = {.lex_state = 109, .external_lex_state = 29},
  [2647] = {.lex_state = 109, .external_lex_state = 29},
  [2648] = {.lex_state = 109, .external_lex_state = 29},
  [2649] = {.lex_state = 109, .external_lex_state = 29},
  [2650] = {.lex_state = 109, .external_lex_state = 29},
  [2651] = {.lex_state = 109, .external_lex_state = 29},
  [2652] = {.lex_state = 109, .external_lex_state = 29},
  [2653] = {.lex_state = 109, .external_lex_state = 29},
  [2654] = {.lex_state = 109, .external_lex_state = 29},
  [2655] = {.lex_state = 109, .external_lex_state = 29},
  [2656] = {.lex_state = 109, .external_lex_state = 29},
  [2657] = {.lex_state = 109, .external_lex_state = 29},
  [2658] = {.lex_state = 109, .external_lex_state = 29},
  [2659] = {.lex_state = 109, .external_lex_state = 29},
  [2660] = {.lex_state = 109, .external_lex_state = 29},
  [2661] = {.lex_state = 109, .external_lex_state = 29},
  [2662] = {.lex_state = 109, .external_lex_state = 29},
  [2663] = {.lex_state = 109, .external_lex_state = 29},
  [2664] = {.lex_state = 109, .external_lex_state = 29},
  [2665] = {.lex_state = 109, .external_lex_state = 29},
  [2666] = {.lex_state = 109, .external_lex_state = 29},
  [2667] = {.lex_state = 109, .external_lex_state = 29},
  [2668] = {.lex_state = 100, .external_lex_state = 29},
  [2669] = {.lex_state = 100, .external_lex_state = 28},
  [2670] = {.lex_state = 32, .external_lex_state = 36},
  [2671] = {.lex_state = 100, .external_lex_state = 29},
  [2672] = {.lex_state = 100, .external_lex_state = 29},
  [2673] = {.lex_state = 100, .external_lex_state = 29},
  [2674] = {.lex_state = 32, .external_lex_state = 36},
  [2675] = {.lex_state = 100, .external_lex_state = 28},
  [2676] = {.lex_state = 100, .external_lex_state = 29},
  [2677] = {.lex_state = 32, .external_lex_state = 36},
  [2678] = {.lex_state = 100, .external_lex_state = 29},
  [2679] = {.lex_state = 32, .external_lex_state = 36},
  [2680] = {.lex_state = 100, .external_lex_state = 29},
  [2681] = {.lex_state = 100, .external_lex_state = 29},
  [2682] = {.lex_state = 100, .external_lex_state = 29},
  [2683] = {.lex_state = 100, .external_lex_state = 29},
  [2684] = {.lex_state = 100, .external_lex_state = 29},
  [2685] = {.lex_state = 100, .external_lex_state = 29},
  [2686] = {.lex_state = 32, .external_lex_state = 36},
  [2687] = {.lex_state = 100, .external_lex_state = 29},
  [2688] = {.lex_state = 100, .external_lex_state = 29},
  [2689] = {.lex_state = 100, .external_lex_state = 29},
  [2690] = {.lex_state = 100},
  [2691] = {.lex_state = 26, .external_lex_state = 35},
  [2692] = {.lex_state = 100, .external_lex_state = 28},
  [2693] = {.lex_state = 100, .external_lex_state = 29},
  [2694] = {.lex_state = 100, .external_lex_state = 28},
  [2695] = {.lex_state = 100, .external_lex_state = 29},
  [2696] = {.lex_state = 100, .external_lex_state = 29},
  [2697] = {.lex_state = 100, .external_lex_state = 28},
  [2698] = {.lex_state = 100, .external_lex_state = 29},
  [2699] = {.lex_state = 100, .external_lex_state = 28},
  [2700] = {.lex_state = 100, .external_lex_state = 29},
  [2701] = {.lex_state = 32, .external_lex_state = 36},
  [2702] = {.lex_state = 100, .external_lex_state = 29},
  [2703] = {.lex_state = 100, .external_lex_state = 29},
  [2704] = {.lex_state = 100, .external_lex_state = 29},
  [2705] = {.lex_state = 32, .external_lex_state = 36},
  [2706] = {.lex_state = 100, .external_lex_state = 29},
  [2707] = {.lex_state = 100, .external_lex_state = 29},
  [2708] = {.lex_state = 32, .external_lex_state = 36},
  [2709] = {.lex_state = 100, .external_lex_state = 29},
  [2710] = {.lex_state = 100, .external_lex_state = 29},
  [2711] = {.lex_state = 32, .external_lex_state = 36},
  [2712] = {.lex_state = 100, .external_lex_state = 28},
  [2713] = {.lex_state = 100, .external_lex_state = 28},
  [2714] = {.lex_state = 100, .external_lex_state = 29},
  [2715] = {.lex_state = 32, .external_lex_state = 36},
  [2716] = {.lex_state = 100, .external_lex_state = 28},
  [2717] = {.lex_state = 100, .external_lex_state = 28},
  [2718] = {.lex_state = 100, .external_lex_state = 29},
  [2719] = {.lex_state = 32, .external_lex_state = 36},
  [2720] = {.lex_state = 32, .external_lex_state = 36},
  [2721] = {.lex_state = 100, .external_lex_state = 29},
  [2722] = {.lex_state = 32, .external_lex_state = 36},
  [2723] = {.lex_state = 100, .external_lex_state = 29},
  [2724] = {.lex_state = 100, .external_lex_state = 28},
  [2725] = {.lex_state = 100, .external_lex_state = 29},
  [2726] = {.lex_state = 32, .external_lex_state = 36},
  [2727] = {.lex_state = 100, .external_lex_state = 28},
  [2728] = {.lex_state = 100, .external_lex_state = 29},
  [2729] = {.lex_state = 100, .external_lex_state = 28},
  [2730] = {.lex_state = 100, .external_lex_state = 29},
  [2731] = {.lex_state = 100, .external_lex_state = 29},
  [2732] = {.lex_state = 100, .external_lex_state = 28},
  [2733] = {.lex_state = 100, .external_lex_state = 29},
  [2734] = {.lex_state = 100, .external_lex_state = 28},
  [2735] = {.lex_state = 100, .external_lex_state = 28},
  [2736] = {.lex_state = 32, .external_lex_state = 37},
  [2737] = {.lex_state = 105, .external_lex_state = 29},
  [2738] = {.lex_state = 32, .external_lex_state = 37},
  [2739] = {.lex_state = 105, .external_lex_state = 29},
  [2740] = {.lex_state = 105, .external_lex_state = 29},
  [2741] = {.lex_state = 100, .external_lex_state = 29},
  [2742] = {.lex_state = 105, .external_lex_state = 29},
  [2743] = {.lex_state = 105, .external_lex_state = 29},
  [2744] = {.lex_state = 105, .external_lex_state = 29},
  [2745] = {.lex_state = 105, .external_lex_state = 29},
  [2746] = {.lex_state = 105, .external_lex_state = 29},
  [2747] = {.lex_state = 105, .external_lex_state = 29},
  [2748] = {.lex_state = 100, .external_lex_state = 29},
  [2749] = {.lex_state = 100, .external_lex_state = 29},
  [2750] = {.lex_state = 100, .external_lex_state = 29},
  [2751] = {.lex_state = 100, .external_lex_state = 29},
  [2752] = {.lex_state = 105, .external_lex_state = 29},
  [2753] = {.lex_state = 105, .external_lex_state = 29},
  [2754] = {.lex_state = 100, .external_lex_state = 30},
  [2755] = {.lex_state = 100, .external_lex_state = 29},
  [2756] = {.lex_state = 105, .external_lex_state = 29},
  [2757] = {.lex_state = 105, .external_lex_state = 29},
  [2758] = {.lex_state = 108, .external_lex_state = 29},
  [2759] = {.lex_state = 100, .external_lex_state = 29},
  [2760] = {.lex_state = 100, .external_lex_state = 30},
  [2761] = {.lex_state = 105, .external_lex_state = 29},
  [2762] = {.lex_state = 105, .external_lex_state = 29},
  [2763] = {.lex_state = 100, .external_lex_state = 29},
  [2764] = {.lex_state = 100, .external_lex_state = 29},
  [2765] = {.lex_state = 105, .external_lex_state = 29},
  [2766] = {.lex_state = 105, .external_lex_state = 29},
  [2767] = {.lex_state = 100, .external_lex_state = 29},
  [2768] = {.lex_state = 100, .external_lex_state = 29},
  [2769] = {.lex_state = 100},
  [2770] = {.lex_state = 105, .external_lex_state = 29},
  [2771] = {.lex_state = 100, .external_lex_state = 29},
  [2772] = {.lex_state = 100, .external_lex_state = 29},
  [2773] = {.lex_state = 105, .external_lex_state = 29},
  [2774] = {.lex_state = 100, .external_lex_state = 29},
  [2775] = {.lex_state = 100, .external_lex_state = 29},
  [2776] = {.lex_state = 32, .external_lex_state = 37},
  [2777] = {.lex_state = 105, .external_lex_state = 29},
  [2778] = {.lex_state = 32, .external_lex_state = 37},
  [2779] = {.lex_state = 105, .external_lex_state = 29},
  [2780] = {.lex_state = 100},
  [2781] = {.lex_state = 100, .external_lex_state = 29},
  [2782] = {.lex_state = 100, .external_lex_state = 29},
  [2783] = {.lex_state = 100, .external_lex_state = 36},
  [2784] = {.lex_state = 108, .external_lex_state = 29},
  [2785] = {.lex_state = 108, .external_lex_state = 29},
  [2786] = {.lex_state = 105},
  [2787] = {.lex_state = 100, .external_lex_state = 29},
  [2788] = {.lex_state = 100, .external_lex_state = 29},
  [2789] = {.lex_state = 100, .external_lex_state = 29},
  [2790] = {.lex_state = 108, .external_lex_state = 29},
  [2791] = {.lex_state = 100, .external_lex_state = 29},
  [2792] = {.lex_state = 100, .external_lex_state = 29},
  [2793] = {.lex_state = 100, .external_lex_state = 29},
  [2794] = {.lex_state = 100, .external_lex_state = 28},
  [2795] = {.lex_state = 100, .external_lex_state = 29},
  [2796] = {.lex_state = 100, .external_lex_state = 29},
  [2797] = {.lex_state = 20, .external_lex_state = 29},
  [2798] = {.lex_state = 100, .external_lex_state = 36},
  [2799] = {.lex_state = 100, .external_lex_state = 29},
  [2800] = {.lex_state = 100, .external_lex_state = 29},
  [2801] = {.lex_state = 100, .external_lex_state = 29},
  [2802] = {.lex_state = 108, .external_lex_state = 29},
  [2803] = {.lex_state = 100},
  [2804] = {.lex_state = 108, .external_lex_state = 29},
  [2805] = {.lex_state = 108, .external_lex_state = 29},
  [2806] = {.lex_state = 100, .external_lex_state = 29},
  [2807] = {.lex_state = 100, .external_lex_state = 29},
  [2808] = {.lex_state = 100, .external_lex_state = 29},
  [2809] = {.lex_state = 100, .external_lex_state = 29},
  [2810] = {.lex_state = 100, .external_lex_state = 29},
  [2811] = {.lex_state = 108, .external_lex_state = 29},
  [2812] = {.lex_state = 100, .external_lex_state = 29},
  [2813] = {.lex_state = 100, .external_lex_state = 29},
  [2814] = {.lex_state = 108, .external_lex_state = 29},
  [2815] = {.lex_state = 108, .external_lex_state = 29},
  [2816] = {.lex_state = 105},
  [2817] = {.lex_state = 100, .external_lex_state = 29},
  [2818] = {.lex_state = 100, .external_lex_state = 29},
  [2819] = {.lex_state = 100, .external_lex_state = 29},
  [2820] = {.lex_state = 100, .external_lex_state = 29},
  [2821] = {.lex_state = 108, .external_lex_state = 29},
  [2822] = {.lex_state = 100, .external_lex_state = 29},
  [2823] = {.lex_state = 100, .external_lex_state = 36},
  [2824] = {.lex_state = 100, .external_lex_state = 29},
  [2825] = {.lex_state = 100, .external_lex_state = 29},
  [2826] = {.lex_state = 105},
  [2827] = {.lex_state = 100, .external_lex_state = 29},
  [2828] = {.lex_state = 108, .external_lex_state = 29},
  [2829] = {.lex_state = 100, .external_lex_state = 29},
  [2830] = {.lex_state = 108, .external_lex_state = 29},
  [2831] = {.lex_state = 100, .external_lex_state = 29},
  [2832] = {.lex_state = 100, .external_lex_state = 29},
  [2833] = {.lex_state = 115, .external_lex_state = 29},
  [2834] = {.lex_state = 100, .external_lex_state = 29},
  [2835] = {.lex_state = 108, .external_lex_state = 29},
  [2836] = {.lex_state = 100, .external_lex_state = 36},
  [2837] = {.lex_state = 100, .external_lex_state = 29},
  [2838] = {.lex_state = 100, .external_lex_state = 36},
  [2839] = {.lex_state = 108, .external_lex_state = 29},
  [2840] = {.lex_state = 108, .external_lex_state = 29},
  [2841] = {.lex_state = 108, .external_lex_state = 29},
  [2842] = {.lex_state = 100, .external_lex_state = 29},
  [2843] = {.lex_state = 100, .external_lex_state = 29},
  [2844] = {.lex_state = 108, .external_lex_state = 29},
  [2845] = {.lex_state = 100, .external_lex_state = 29},
  [2846] = {.lex_state = 100, .external_lex_state = 29},
  [2847] = {.lex_state = 100, .external_lex_state = 29},
  [2848] = {.lex_state = 100, .external_lex_state = 29},
  [2849] = {.lex_state = 100, .external_lex_state = 29},
  [2850] = {.lex_state = 100, .external_lex_state = 29},
  [2851] = {.lex_state = 108, .external_lex_state = 29},
  [2852] = {.lex_state = 100, .external_lex_state = 29},
  [2853] = {.lex_state = 100, .external_lex_state = 29},
  [2854] = {.lex_state = 100, .external_lex_state = 29},
  [2855] = {.lex_state = 100, .external_lex_state = 29},
  [2856] = {.lex_state = 100, .external_lex_state = 29},
  [2857] = {.lex_state = 100, .external_lex_state = 29},
  [2858] = {.lex_state = 100, .external_lex_state = 29},
  [2859] = {.lex_state = 100, .external_lex_state = 29},
  [2860] = {.lex_state = 100, .external_lex_state = 29},
  [2861] = {.lex_state = 100},
  [2862] = {.lex_state = 100, .external_lex_state = 29},
  [2863] = {.lex_state = 100, .external_lex_state = 29},
  [2864] = {.lex_state = 100, .external_lex_state = 29},
  [2865] = {.lex_state = 100, .external_lex_state = 29},
  [2866] = {.lex_state = 100, .external_lex_state = 29},
  [2867] = {.lex_state = 100, .external_lex_state = 29},
  [2868] = {.lex_state = 100, .external_lex_state = 29},
  [2869] = {.lex_state = 100, .external_lex_state = 29},
  [2870] = {.lex_state = 105},
  [2871] = {.lex_state = 100, .external_lex_state = 29},
  [2872] = {.lex_state = 100, .external_lex_state = 29},
  [2873] = {.lex_state = 100, .external_lex_state = 29},
  [2874] = {.lex_state = 100, .external_lex_state = 29},
  [2875] = {.lex_state = 100, .external_lex_state = 29},
  [2876] = {.lex_state = 100, .external_lex_state = 29},
  [2877] = {.lex_state = 100, .external_lex_state = 29},
  [2878] = {.lex_state = 100, .external_lex_state = 29},
  [2879] = {.lex_state = 105},
  [2880] = {.lex_state = 100, .external_lex_state = 36},
  [2881] = {.lex_state = 100, .external_lex_state = 29},
  [2882] = {.lex_state = 105},
  [2883] = {.lex_state = 100, .external_lex_state = 29},
  [2884] = {.lex_state = 100, .external_lex_state = 29},
  [2885] = {.lex_state = 108, .external_lex_state = 29},
  [2886] = {.lex_state = 115, .external_lex_state = 29},
  [2887] = {.lex_state = 100, .external_lex_state = 29},
  [2888] = {.lex_state = 100, .external_lex_state = 28},
  [2889] = {.lex_state = 20, .external_lex_state = 29},
  [2890] = {.lex_state = 20, .external_lex_state = 29},
  [2891] = {.lex_state = 100, .external_lex_state = 29},
  [2892] = {.lex_state = 108, .external_lex_state = 29},
  [2893] = {.lex_state = 100, .external_lex_state = 29},
  [2894] = {.lex_state = 108, .external_lex_state = 29},
  [2895] = {.lex_state = 108, .external_lex_state = 29},
  [2896] = {.lex_state = 108, .external_lex_state = 29},
  [2897] = {.lex_state = 108, .external_lex_state = 29},
  [2898] = {.lex_state = 100, .external_lex_state = 29},
  [2899] = {.lex_state = 100, .external_lex_state = 29},
  [2900] = {.lex_state = 100, .external_lex_state = 29},
  [2901] = {.lex_state = 100, .external_lex_state = 29},
  [2902] = {.lex_state = 108, .external_lex_state = 29},
  [2903] = {.lex_state = 100, .external_lex_state = 29},
  [2904] = {.lex_state = 100, .external_lex_state = 29},
  [2905] = {.lex_state = 100, .external_lex_state = 29},
  [2906] = {.lex_state = 100, .external_lex_state = 29},
  [2907] = {.lex_state = 100, .external_lex_state = 29},
  [2908] = {.lex_state = 100, .external_lex_state = 29},
  [2909] = {.lex_state = 100, .external_lex_state = 29},
  [2910] = {.lex_state = 100, .external_lex_state = 29},
  [2911] = {.lex_state = 100, .external_lex_state = 29},
  [2912] = {.lex_state = 100, .external_lex_state = 29},
  [2913] = {.lex_state = 100, .external_lex_state = 29},
  [2914] = {.lex_state = 100, .external_lex_state = 29},
  [2915] = {.lex_state = 100, .external_lex_state = 29},
  [2916] = {.lex_state = 100, .external_lex_state = 29},
  [2917] = {.lex_state = 105},
  [2918] = {.lex_state = 100, .external_lex_state = 29},
  [2919] = {.lex_state = 105},
  [2920] = {.lex_state = 100, .external_lex_state = 29},
  [2921] = {.lex_state = 100, .external_lex_state = 29},
  [2922] = {.lex_state = 0},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 0},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 0},
  [2929] = {.lex_state = 0},
  [2930] = {.lex_state = 0},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 0},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 0},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 0},
  [2938] = {.lex_state = 0},
  [2939] = {-1},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 0},
  [2942] = {.lex_state = 108},
  [2943] = {.lex_state = 108},
  [2944] = {.lex_state = 108},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 0},
  [2948] = {-1},
  [2949] = {.lex_state = 0},
  [2950] = {.lex_state = 108},
  [2951] = {.lex_state = 0},
  [2952] = {.lex_state = 0},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 0},
  [2955] = {.lex_state = 20},
  [2956] = {.lex_state = 0},
  [2957] = {.lex_state = 20},
  [2958] = {.lex_state = 108},
  [2959] = {.lex_state = 108},
  [2960] = {.lex_state = 0, .external_lex_state = 37},
  [2961] = {.lex_state = 0},
  [2962] = {.lex_state = 0},
  [2963] = {.lex_state = 108},
  [2964] = {.lex_state = 0, .external_lex_state = 37},
  [2965] = {.lex_state = 0},
  [2966] = {.lex_state = 0},
  [2967] = {.lex_state = 0},
};

enum {
  ts_external_token__line_break = 0,
  ts_external_token__simple_symbol = 1,
  ts_external_token__string_start = 2,
  ts_external_token__symbol_start = 3,
  ts_external_token__subshell_start = 4,
  ts_external_token__regex_start = 5,
  ts_external_token__string_array_start = 6,
  ts_external_token__symbol_array_start = 7,
  ts_external_token__heredoc_body_start = 8,
  ts_external_token__string_content = 9,
  ts_external_token__heredoc_content = 10,
  ts_external_token__string_end = 11,
  ts_external_token_heredoc_end = 12,
  ts_external_token_heredoc_beginning = 13,
  ts_external_token_SLASH = 14,
  ts_external_token__block_ampersand = 15,
  ts_external_token__splat_star = 16,
  ts_external_token__unary_minus = 17,
  ts_external_token__binary_minus = 18,
  ts_external_token__binary_star = 19,
  ts_external_token__singleton_class_left_angle_left_langle = 20,
  ts_external_token__identifier_hash_key = 21,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__simple_symbol] = sym__simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__heredoc_content] = sym__heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token__identifier_hash_key] = sym__identifier_hash_key,
};

static bool ts_external_scanner_states[38][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [2] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [4] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [5] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [6] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [7] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [8] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [9] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [10] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [11] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [12] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [13] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [14] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [15] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
  },
  [16] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
  },
  [17] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [18] = {
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [20] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [21] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [22] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [23] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [24] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [25] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [26] = {
    [ts_external_token_SLASH] = true,
  },
  [27] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [28] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [29] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [30] = {
    [ts_external_token__line_break] = true,
  },
  [31] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [32] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [33] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [34] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
  },
  [35] = {
    [ts_external_token__heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [36] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_end] = true,
  },
  [37] = {
    [ts_external_token__string_end] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_body] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_next] = ACTIONS(1),
    [anon_sym_redo] = ACTIONS(1),
    [anon_sym_retry] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_rescue] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_ensure] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_constant] = ACTIONS(1),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_r] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_TRUE] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_FALSE] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_NIL] = ACTIONS(1),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [sym__line_break] = ACTIONS(1),
    [sym__simple_symbol] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__string_content] = ACTIONS(1),
    [sym__heredoc_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [sym__identifier_hash_key] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2824),
    [sym__statements] = STATE(2768),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2219),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2178),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(1),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(967),
    [aux_sym__statements_repeat1] = STATE(183),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym___END__] = ACTIONS(11),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [anon_sym_undef] = ACTIONS(69),
    [anon_sym_alias] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [2] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(2),
    [sym_call] = STATE(2),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2094),
    [sym_argument_list] = STATE(883),
    [sym__argument] = STATE(2092),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(919),
    [sym_block] = STATE(917),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(2),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(990),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(2),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(115),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(115),
    [anon_sym_elsif] = ACTIONS(115),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_then] = ACTIONS(115),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(107),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [3] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(2),
    [sym_call] = STATE(2),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(881),
    [sym__argument] = STATE(2092),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(919),
    [sym_block] = STATE(917),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(2),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(990),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(3),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(115),
    [anon_sym_elsif] = ACTIONS(115),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_then] = ACTIONS(115),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(107),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [4] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(2),
    [sym_call] = STATE(2),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(884),
    [sym__argument] = STATE(2092),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(937),
    [sym_block] = STATE(939),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(2),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(990),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(4),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(115),
    [anon_sym_elsif] = ACTIONS(115),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_then] = ACTIONS(115),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(107),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [5] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1341),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(6),
    [sym_call] = STATE(6),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(881),
    [sym__argument] = STATE(2092),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(919),
    [sym_block] = STATE(917),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(6),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(990),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(5),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_identifier] = ACTIONS(169),
    [anon_sym___END__] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(169),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [6] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1341),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(6),
    [sym_call] = STATE(6),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2094),
    [sym_argument_list] = STATE(883),
    [sym__argument] = STATE(2092),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(919),
    [sym_block] = STATE(917),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(6),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(990),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(6),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_identifier] = ACTIONS(169),
    [anon_sym___END__] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(115),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(169),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [7] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1341),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(6),
    [sym_call] = STATE(6),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(884),
    [sym__argument] = STATE(2092),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(937),
    [sym_block] = STATE(939),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(6),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(990),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(7),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_identifier] = ACTIONS(169),
    [anon_sym___END__] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(169),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [8] = {
    [sym_method] = STATE(1464),
    [sym_singleton_method] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_singleton_class] = STATE(1464),
    [sym_module] = STATE(1464),
    [sym_return] = STATE(1464),
    [sym_yield] = STATE(1464),
    [sym_break] = STATE(1464),
    [sym_next] = STATE(1464),
    [sym_redo] = STATE(1464),
    [sym_retry] = STATE(1464),
    [sym_while] = STATE(1464),
    [sym_until] = STATE(1464),
    [sym_for] = STATE(1464),
    [sym_case] = STATE(1464),
    [sym_if] = STATE(1464),
    [sym_unless] = STATE(1464),
    [sym_begin] = STATE(1464),
    [sym__arg] = STATE(1628),
    [sym__primary] = STATE(1464),
    [sym_parenthesized_statements] = STATE(1464),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(9),
    [sym_call] = STATE(9),
    [sym_command_call] = STATE(2237),
    [sym_method_call] = STATE(1003),
    [sym_command_argument_list] = STATE(2177),
    [sym_argument_list] = STATE(986),
    [sym__argument] = STATE(2184),
    [sym_splat_argument] = STATE(2184),
    [sym_hash_splat_argument] = STATE(2184),
    [sym_block_argument] = STATE(2184),
    [sym_do_block] = STATE(1019),
    [sym_block] = STATE(1006),
    [sym_assignment] = STATE(1628),
    [sym_operator_assignment] = STATE(1628),
    [sym_conditional] = STATE(1628),
    [sym_range] = STATE(1628),
    [sym_binary] = STATE(1628),
    [sym_unary] = STATE(1628),
    [sym_parenthesized_unary] = STATE(1464),
    [sym_unary_literal] = STATE(1464),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(9),
    [sym_rational] = STATE(1464),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1464),
    [sym_string] = STATE(1342),
    [sym_subshell] = STATE(1464),
    [sym_string_array] = STATE(1464),
    [sym_symbol_array] = STATE(1464),
    [sym_symbol] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_heredoc_body] = STATE(8),
    [sym_array] = STATE(1464),
    [sym_hash] = STATE(1464),
    [sym_pair] = STATE(2184),
    [sym_lambda] = STATE(1464),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(177),
    [sym_instance_variable] = ACTIONS(221),
    [sym_class_variable] = ACTIONS(221),
    [sym_global_variable] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(225),
    [sym_complex] = ACTIONS(227),
    [sym_super] = ACTIONS(229),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(229),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(227),
    [anon_sym_LBRACK2] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [sym__unary_minus] = ACTIONS(259),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(261),
  },
  [9] = {
    [sym_method] = STATE(1464),
    [sym_singleton_method] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_singleton_class] = STATE(1464),
    [sym_module] = STATE(1464),
    [sym_return] = STATE(1464),
    [sym_yield] = STATE(1464),
    [sym_break] = STATE(1464),
    [sym_next] = STATE(1464),
    [sym_redo] = STATE(1464),
    [sym_retry] = STATE(1464),
    [sym_while] = STATE(1464),
    [sym_until] = STATE(1464),
    [sym_for] = STATE(1464),
    [sym_case] = STATE(1464),
    [sym_if] = STATE(1464),
    [sym_unless] = STATE(1464),
    [sym_begin] = STATE(1464),
    [sym__arg] = STATE(1628),
    [sym__primary] = STATE(1464),
    [sym_parenthesized_statements] = STATE(1464),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(9),
    [sym_call] = STATE(9),
    [sym_command_call] = STATE(2237),
    [sym_method_call] = STATE(1003),
    [sym_command_argument_list] = STATE(2187),
    [sym_argument_list] = STATE(983),
    [sym__argument] = STATE(2184),
    [sym_splat_argument] = STATE(2184),
    [sym_hash_splat_argument] = STATE(2184),
    [sym_block_argument] = STATE(2184),
    [sym_do_block] = STATE(1019),
    [sym_block] = STATE(1006),
    [sym_assignment] = STATE(1628),
    [sym_operator_assignment] = STATE(1628),
    [sym_conditional] = STATE(1628),
    [sym_range] = STATE(1628),
    [sym_binary] = STATE(1628),
    [sym_unary] = STATE(1628),
    [sym_parenthesized_unary] = STATE(1464),
    [sym_unary_literal] = STATE(1464),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(9),
    [sym_rational] = STATE(1464),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1464),
    [sym_string] = STATE(1342),
    [sym_subshell] = STATE(1464),
    [sym_string_array] = STATE(1464),
    [sym_symbol_array] = STATE(1464),
    [sym_symbol] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_heredoc_body] = STATE(9),
    [sym_array] = STATE(1464),
    [sym_hash] = STATE(1464),
    [sym_pair] = STATE(2184),
    [sym_lambda] = STATE(1464),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(115),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(177),
    [sym_instance_variable] = ACTIONS(221),
    [sym_class_variable] = ACTIONS(221),
    [sym_global_variable] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(225),
    [sym_complex] = ACTIONS(227),
    [sym_super] = ACTIONS(229),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(229),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(227),
    [anon_sym_LBRACK2] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [sym__unary_minus] = ACTIONS(259),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(261),
  },
  [10] = {
    [sym_method] = STATE(1464),
    [sym_singleton_method] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_singleton_class] = STATE(1464),
    [sym_module] = STATE(1464),
    [sym_return] = STATE(1464),
    [sym_yield] = STATE(1464),
    [sym_break] = STATE(1464),
    [sym_next] = STATE(1464),
    [sym_redo] = STATE(1464),
    [sym_retry] = STATE(1464),
    [sym_while] = STATE(1464),
    [sym_until] = STATE(1464),
    [sym_for] = STATE(1464),
    [sym_case] = STATE(1464),
    [sym_if] = STATE(1464),
    [sym_unless] = STATE(1464),
    [sym_begin] = STATE(1464),
    [sym__arg] = STATE(1628),
    [sym__primary] = STATE(1464),
    [sym_parenthesized_statements] = STATE(1464),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(9),
    [sym_call] = STATE(9),
    [sym_command_call] = STATE(2237),
    [sym_method_call] = STATE(1003),
    [sym_command_argument_list] = STATE(2177),
    [sym_argument_list] = STATE(1004),
    [sym__argument] = STATE(2184),
    [sym_splat_argument] = STATE(2184),
    [sym_hash_splat_argument] = STATE(2184),
    [sym_block_argument] = STATE(2184),
    [sym_do_block] = STATE(1080),
    [sym_block] = STATE(1093),
    [sym_assignment] = STATE(1628),
    [sym_operator_assignment] = STATE(1628),
    [sym_conditional] = STATE(1628),
    [sym_range] = STATE(1628),
    [sym_binary] = STATE(1628),
    [sym_unary] = STATE(1628),
    [sym_parenthesized_unary] = STATE(1464),
    [sym_unary_literal] = STATE(1464),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(9),
    [sym_rational] = STATE(1464),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1464),
    [sym_string] = STATE(1342),
    [sym_subshell] = STATE(1464),
    [sym_string_array] = STATE(1464),
    [sym_symbol_array] = STATE(1464),
    [sym_symbol] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_heredoc_body] = STATE(10),
    [sym_array] = STATE(1464),
    [sym_hash] = STATE(1464),
    [sym_pair] = STATE(2184),
    [sym_lambda] = STATE(1464),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(265),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(177),
    [sym_instance_variable] = ACTIONS(221),
    [sym_class_variable] = ACTIONS(221),
    [sym_global_variable] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(225),
    [sym_complex] = ACTIONS(227),
    [sym_super] = ACTIONS(229),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(229),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(227),
    [anon_sym_LBRACK2] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [sym__unary_minus] = ACTIONS(259),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(261),
  },
  [11] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2113),
    [sym_argument_list] = STATE(1148),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(11),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(273),
    [anon_sym_DOT] = ACTIONS(275),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(275),
    [anon_sym_elsif] = ACTIONS(275),
    [anon_sym_else] = ACTIONS(275),
    [anon_sym_then] = ACTIONS(275),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_COLON_COLON2] = ACTIONS(273),
    [anon_sym_AMP_DOT] = ACTIONS(273),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(273),
    [anon_sym_and] = ACTIONS(275),
    [anon_sym_or] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(273),
    [anon_sym_AMP_AMP] = ACTIONS(273),
    [anon_sym_LT_LT] = ACTIONS(273),
    [anon_sym_GT_GT] = ACTIONS(273),
    [anon_sym_LT_EQ] = ACTIONS(275),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(273),
    [anon_sym_CARET] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(275),
    [anon_sym_SLASH] = ACTIONS(273),
    [anon_sym_PERCENT] = ACTIONS(273),
    [anon_sym_EQ_EQ] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(273),
    [anon_sym_LT_EQ_GT] = ACTIONS(273),
    [anon_sym_EQ_TILDE] = ACTIONS(273),
    [anon_sym_BANG_TILDE] = ACTIONS(273),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(273),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(273),
    [sym__binary_star] = ACTIONS(273),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [12] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2114),
    [sym_argument_list] = STATE(1145),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(12),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(297),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [anon_sym_rescue] = ACTIONS(297),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(297),
    [anon_sym_elsif] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(297),
    [anon_sym_then] = ACTIONS(297),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(297),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_COLON_COLON2] = ACTIONS(295),
    [anon_sym_AMP_DOT] = ACTIONS(295),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(295),
    [anon_sym_CARET] = ACTIONS(295),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_PERCENT] = ACTIONS(295),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(295),
    [anon_sym_LT_EQ_GT] = ACTIONS(295),
    [anon_sym_EQ_TILDE] = ACTIONS(295),
    [anon_sym_BANG_TILDE] = ACTIONS(295),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(295),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(295),
    [sym__binary_star] = ACTIONS(295),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [13] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2111),
    [sym_argument_list] = STATE(1146),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(13),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_until] = ACTIONS(301),
    [anon_sym_rescue] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(301),
    [anon_sym_elsif] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(301),
    [anon_sym_then] = ACTIONS(301),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(301),
    [anon_sym_EQ_GT] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_COLON_COLON2] = ACTIONS(299),
    [anon_sym_AMP_DOT] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT_DOT] = ACTIONS(301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(299),
    [anon_sym_LT_EQ_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [anon_sym_BANG_TILDE] = ACTIONS(299),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(299),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(299),
    [sym__binary_star] = ACTIONS(299),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [14] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2110),
    [sym_argument_list] = STATE(1147),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(14),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_DOT] = ACTIONS(305),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(305),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_unless] = ACTIONS(305),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_rescue] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(305),
    [anon_sym_elsif] = ACTIONS(305),
    [anon_sym_else] = ACTIONS(305),
    [anon_sym_then] = ACTIONS(305),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(305),
    [anon_sym_EQ_GT] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_COLON_COLON2] = ACTIONS(303),
    [anon_sym_AMP_DOT] = ACTIONS(303),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_DOT_DOT] = ACTIONS(305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(303),
    [anon_sym_AMP_AMP] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(305),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(303),
    [anon_sym_LT_EQ_GT] = ACTIONS(303),
    [anon_sym_EQ_TILDE] = ACTIONS(303),
    [anon_sym_BANG_TILDE] = ACTIONS(303),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(303),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(303),
    [sym__binary_star] = ACTIONS(303),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [15] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1341),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2111),
    [sym_argument_list] = STATE(1146),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(15),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(299),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_until] = ACTIONS(301),
    [anon_sym_rescue] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_COLON_COLON2] = ACTIONS(299),
    [anon_sym_AMP_DOT] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT_DOT] = ACTIONS(301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(299),
    [anon_sym_LT_EQ_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [anon_sym_BANG_TILDE] = ACTIONS(299),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(299),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(299),
    [sym__binary_star] = ACTIONS(299),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [16] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1341),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2114),
    [sym_argument_list] = STATE(1145),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(16),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(295),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [anon_sym_rescue] = ACTIONS(297),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_COLON_COLON2] = ACTIONS(295),
    [anon_sym_AMP_DOT] = ACTIONS(295),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(295),
    [anon_sym_CARET] = ACTIONS(295),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_PERCENT] = ACTIONS(295),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(295),
    [anon_sym_LT_EQ_GT] = ACTIONS(295),
    [anon_sym_EQ_TILDE] = ACTIONS(295),
    [anon_sym_BANG_TILDE] = ACTIONS(295),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(295),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(295),
    [sym__binary_star] = ACTIONS(295),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [17] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1341),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2110),
    [sym_argument_list] = STATE(1147),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(17),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(303),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(305),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(305),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(305),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_unless] = ACTIONS(305),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_rescue] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_COLON_COLON2] = ACTIONS(303),
    [anon_sym_AMP_DOT] = ACTIONS(303),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_DOT_DOT] = ACTIONS(305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(303),
    [anon_sym_AMP_AMP] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(305),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(303),
    [anon_sym_LT_EQ_GT] = ACTIONS(303),
    [anon_sym_EQ_TILDE] = ACTIONS(303),
    [anon_sym_BANG_TILDE] = ACTIONS(303),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(303),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(303),
    [sym__binary_star] = ACTIONS(303),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [18] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1341),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(902),
    [sym_command_argument_list] = STATE(2113),
    [sym_argument_list] = STATE(1148),
    [sym__argument] = STATE(2109),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(18),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(273),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(275),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(275),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_COLON_COLON2] = ACTIONS(273),
    [anon_sym_AMP_DOT] = ACTIONS(273),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(273),
    [anon_sym_and] = ACTIONS(275),
    [anon_sym_or] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(273),
    [anon_sym_AMP_AMP] = ACTIONS(273),
    [anon_sym_LT_LT] = ACTIONS(273),
    [anon_sym_GT_GT] = ACTIONS(273),
    [anon_sym_LT_EQ] = ACTIONS(275),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(273),
    [anon_sym_CARET] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(275),
    [anon_sym_SLASH] = ACTIONS(273),
    [anon_sym_PERCENT] = ACTIONS(273),
    [anon_sym_EQ_EQ] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(273),
    [anon_sym_LT_EQ_GT] = ACTIONS(273),
    [anon_sym_EQ_TILDE] = ACTIONS(273),
    [anon_sym_BANG_TILDE] = ACTIONS(273),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(273),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(273),
    [sym__binary_star] = ACTIONS(273),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [19] = {
    [sym_method] = STATE(1464),
    [sym_singleton_method] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_singleton_class] = STATE(1464),
    [sym_module] = STATE(1464),
    [sym_return] = STATE(1464),
    [sym_yield] = STATE(1464),
    [sym_break] = STATE(1464),
    [sym_next] = STATE(1464),
    [sym_redo] = STATE(1464),
    [sym_retry] = STATE(1464),
    [sym_while] = STATE(1464),
    [sym_until] = STATE(1464),
    [sym_for] = STATE(1464),
    [sym_case] = STATE(1464),
    [sym_if] = STATE(1464),
    [sym_unless] = STATE(1464),
    [sym_begin] = STATE(1464),
    [sym__arg] = STATE(1682),
    [sym__primary] = STATE(1464),
    [sym_parenthesized_statements] = STATE(1464),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(8),
    [sym_call] = STATE(8),
    [sym_command_call] = STATE(2237),
    [sym_method_call] = STATE(1052),
    [sym_command_argument_list] = STATE(2375),
    [sym_argument_list] = STATE(1423),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(1682),
    [sym_operator_assignment] = STATE(1682),
    [sym_conditional] = STATE(1682),
    [sym_range] = STATE(1682),
    [sym_binary] = STATE(1682),
    [sym_unary] = STATE(1682),
    [sym_parenthesized_unary] = STATE(1464),
    [sym_unary_literal] = STATE(1464),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(8),
    [sym_rational] = STATE(1464),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1464),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1464),
    [sym_string_array] = STATE(1464),
    [sym_symbol_array] = STATE(1464),
    [sym_symbol] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_heredoc_body] = STATE(19),
    [sym_array] = STATE(1464),
    [sym_hash] = STATE(1464),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(1464),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [anon_sym_rescue] = ACTIONS(297),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_COLON_COLON2] = ACTIONS(295),
    [anon_sym_AMP_DOT] = ACTIONS(295),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(295),
    [anon_sym_CARET] = ACTIONS(295),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_PERCENT] = ACTIONS(295),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(295),
    [anon_sym_LT_EQ_GT] = ACTIONS(295),
    [anon_sym_EQ_TILDE] = ACTIONS(295),
    [anon_sym_BANG_TILDE] = ACTIONS(295),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(225),
    [sym_complex] = ACTIONS(227),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(227),
    [anon_sym_LBRACK2] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(295),
    [sym__binary_star] = ACTIONS(295),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [20] = {
    [sym_method] = STATE(1464),
    [sym_singleton_method] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_singleton_class] = STATE(1464),
    [sym_module] = STATE(1464),
    [sym_return] = STATE(1464),
    [sym_yield] = STATE(1464),
    [sym_break] = STATE(1464),
    [sym_next] = STATE(1464),
    [sym_redo] = STATE(1464),
    [sym_retry] = STATE(1464),
    [sym_while] = STATE(1464),
    [sym_until] = STATE(1464),
    [sym_for] = STATE(1464),
    [sym_case] = STATE(1464),
    [sym_if] = STATE(1464),
    [sym_unless] = STATE(1464),
    [sym_begin] = STATE(1464),
    [sym__arg] = STATE(1682),
    [sym__primary] = STATE(1464),
    [sym_parenthesized_statements] = STATE(1464),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(8),
    [sym_call] = STATE(8),
    [sym_command_call] = STATE(2237),
    [sym_method_call] = STATE(1052),
    [sym_command_argument_list] = STATE(2373),
    [sym_argument_list] = STATE(1422),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(1682),
    [sym_operator_assignment] = STATE(1682),
    [sym_conditional] = STATE(1682),
    [sym_range] = STATE(1682),
    [sym_binary] = STATE(1682),
    [sym_unary] = STATE(1682),
    [sym_parenthesized_unary] = STATE(1464),
    [sym_unary_literal] = STATE(1464),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(8),
    [sym_rational] = STATE(1464),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1464),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1464),
    [sym_string_array] = STATE(1464),
    [sym_symbol_array] = STATE(1464),
    [sym_symbol] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_heredoc_body] = STATE(20),
    [sym_array] = STATE(1464),
    [sym_hash] = STATE(1464),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(1464),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_until] = ACTIONS(301),
    [anon_sym_rescue] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_COLON_COLON2] = ACTIONS(299),
    [anon_sym_AMP_DOT] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT_DOT] = ACTIONS(301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(299),
    [anon_sym_LT_EQ_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [anon_sym_BANG_TILDE] = ACTIONS(299),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(225),
    [sym_complex] = ACTIONS(227),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(227),
    [anon_sym_LBRACK2] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(299),
    [sym__binary_star] = ACTIONS(299),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [21] = {
    [sym_method] = STATE(1464),
    [sym_singleton_method] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_singleton_class] = STATE(1464),
    [sym_module] = STATE(1464),
    [sym_return] = STATE(1464),
    [sym_yield] = STATE(1464),
    [sym_break] = STATE(1464),
    [sym_next] = STATE(1464),
    [sym_redo] = STATE(1464),
    [sym_retry] = STATE(1464),
    [sym_while] = STATE(1464),
    [sym_until] = STATE(1464),
    [sym_for] = STATE(1464),
    [sym_case] = STATE(1464),
    [sym_if] = STATE(1464),
    [sym_unless] = STATE(1464),
    [sym_begin] = STATE(1464),
    [sym__arg] = STATE(1682),
    [sym__primary] = STATE(1464),
    [sym_parenthesized_statements] = STATE(1464),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(8),
    [sym_call] = STATE(8),
    [sym_command_call] = STATE(2237),
    [sym_method_call] = STATE(1052),
    [sym_command_argument_list] = STATE(2371),
    [sym_argument_list] = STATE(1419),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(1682),
    [sym_operator_assignment] = STATE(1682),
    [sym_conditional] = STATE(1682),
    [sym_range] = STATE(1682),
    [sym_binary] = STATE(1682),
    [sym_unary] = STATE(1682),
    [sym_parenthesized_unary] = STATE(1464),
    [sym_unary_literal] = STATE(1464),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(8),
    [sym_rational] = STATE(1464),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1464),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1464),
    [sym_string_array] = STATE(1464),
    [sym_symbol_array] = STATE(1464),
    [sym_symbol] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_heredoc_body] = STATE(21),
    [sym_array] = STATE(1464),
    [sym_hash] = STATE(1464),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(1464),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(305),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(305),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_unless] = ACTIONS(305),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_rescue] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_COLON_COLON2] = ACTIONS(303),
    [anon_sym_AMP_DOT] = ACTIONS(303),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_DOT_DOT] = ACTIONS(305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(303),
    [anon_sym_AMP_AMP] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(305),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(303),
    [anon_sym_LT_EQ_GT] = ACTIONS(303),
    [anon_sym_EQ_TILDE] = ACTIONS(303),
    [anon_sym_BANG_TILDE] = ACTIONS(303),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(225),
    [sym_complex] = ACTIONS(227),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(227),
    [anon_sym_LBRACK2] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(303),
    [sym__binary_star] = ACTIONS(303),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [22] = {
    [sym_method] = STATE(1464),
    [sym_singleton_method] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_singleton_class] = STATE(1464),
    [sym_module] = STATE(1464),
    [sym_return] = STATE(1464),
    [sym_yield] = STATE(1464),
    [sym_break] = STATE(1464),
    [sym_next] = STATE(1464),
    [sym_redo] = STATE(1464),
    [sym_retry] = STATE(1464),
    [sym_while] = STATE(1464),
    [sym_until] = STATE(1464),
    [sym_for] = STATE(1464),
    [sym_case] = STATE(1464),
    [sym_if] = STATE(1464),
    [sym_unless] = STATE(1464),
    [sym_begin] = STATE(1464),
    [sym__arg] = STATE(1682),
    [sym__primary] = STATE(1464),
    [sym_parenthesized_statements] = STATE(1464),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(8),
    [sym_call] = STATE(8),
    [sym_command_call] = STATE(2237),
    [sym_method_call] = STATE(1052),
    [sym_command_argument_list] = STATE(2366),
    [sym_argument_list] = STATE(1405),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(1682),
    [sym_operator_assignment] = STATE(1682),
    [sym_conditional] = STATE(1682),
    [sym_range] = STATE(1682),
    [sym_binary] = STATE(1682),
    [sym_unary] = STATE(1682),
    [sym_parenthesized_unary] = STATE(1464),
    [sym_unary_literal] = STATE(1464),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(8),
    [sym_rational] = STATE(1464),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1464),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1464),
    [sym_string_array] = STATE(1464),
    [sym_symbol_array] = STATE(1464),
    [sym_symbol] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_heredoc_body] = STATE(22),
    [sym_array] = STATE(1464),
    [sym_hash] = STATE(1464),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(1464),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(275),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_COLON_COLON2] = ACTIONS(273),
    [anon_sym_AMP_DOT] = ACTIONS(273),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(273),
    [anon_sym_and] = ACTIONS(275),
    [anon_sym_or] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(273),
    [anon_sym_AMP_AMP] = ACTIONS(273),
    [anon_sym_LT_LT] = ACTIONS(273),
    [anon_sym_GT_GT] = ACTIONS(273),
    [anon_sym_LT_EQ] = ACTIONS(275),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(273),
    [anon_sym_CARET] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(275),
    [anon_sym_SLASH] = ACTIONS(273),
    [anon_sym_PERCENT] = ACTIONS(273),
    [anon_sym_EQ_EQ] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(273),
    [anon_sym_LT_EQ_GT] = ACTIONS(273),
    [anon_sym_EQ_TILDE] = ACTIONS(273),
    [anon_sym_BANG_TILDE] = ACTIONS(273),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(225),
    [sym_complex] = ACTIONS(227),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(227),
    [anon_sym_LBRACK2] = ACTIONS(237),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(273),
    [sym__binary_star] = ACTIONS(273),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [23] = {
    [sym__statements] = STATE(2241),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(60),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(896),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(23),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(59),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [24] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(36),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1140),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(24),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(45),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [25] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(39),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1487),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(25),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(57),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [26] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(35),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2302),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(26),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(48),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [27] = {
    [sym__statements] = STATE(2292),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(61),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2083),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(27),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(62),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [28] = {
    [sym__statements] = STATE(2270),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(42),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1207),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(28),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [29] = {
    [sym__statements] = STATE(2242),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(56),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1063),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(29),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(55),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [30] = {
    [sym__statements] = STATE(2262),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(40),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(932),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(30),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(37),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2260),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [31] = {
    [sym__statements] = STATE(2317),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(76),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2231),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(31),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(381),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [32] = {
    [sym__statements] = STATE(2348),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(74),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1007),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(32),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(77),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(383),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [33] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(67),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1494),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(33),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(66),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(385),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [34] = {
    [sym__statements] = STATE(2342),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(68),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1081),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(34),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(69),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(387),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [35] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2297),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(35),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(93),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [36] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1183),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(36),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(99),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [37] = {
    [sym__statements] = STATE(2262),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(58),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(928),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(37),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2260),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [38] = {
    [sym__statements] = STATE(2270),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1218),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(38),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(97),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [39] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1512),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(39),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(95),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [40] = {
    [sym__statements] = STATE(2262),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(928),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(40),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(108),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2260),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [41] = {
    [sym__statements] = STATE(2270),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(38),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1225),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(41),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [42] = {
    [sym__statements] = STATE(2270),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1225),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(42),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(82),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [43] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1170),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(43),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(106),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [44] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2626),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(44),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(92),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [45] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(50),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1183),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(45),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [46] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1547),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(46),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(112),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [47] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1176),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(47),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [48] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(63),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2297),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(48),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [49] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1446),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(49),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(96),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [50] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1113),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(50),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(88),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [51] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1495),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(51),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(90),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [52] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2603),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(52),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(101),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [53] = {
    [sym__statements] = STATE(2241),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(914),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(53),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(94),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [54] = {
    [sym__statements] = STATE(2242),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1057),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(54),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(86),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [55] = {
    [sym__statements] = STATE(2242),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(54),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1050),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(55),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [56] = {
    [sym__statements] = STATE(2242),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1050),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(56),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(84),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [57] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(51),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1512),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(57),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [58] = {
    [sym__statements] = STATE(2262),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(948),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(58),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(81),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2260),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [59] = {
    [sym__statements] = STATE(2241),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(53),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(922),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(59),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [60] = {
    [sym__statements] = STATE(2241),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(922),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(60),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(83),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [61] = {
    [sym__statements] = STATE(2292),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2089),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(61),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [62] = {
    [sym__statements] = STATE(2292),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(64),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2089),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(62),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [63] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2299),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(63),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(85),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [64] = {
    [sym__statements] = STATE(2292),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2086),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(64),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(100),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [65] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1550),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(65),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [66] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(65),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1530),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(66),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [67] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1530),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(67),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(123),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [68] = {
    [sym__statements] = STATE(2342),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1079),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(68),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(119),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [69] = {
    [sym__statements] = STATE(2342),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(70),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1079),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(69),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [70] = {
    [sym__statements] = STATE(2342),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1077),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(70),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(116),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [71] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1401),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(71),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(118),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(399),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [72] = {
    [sym__statements] = STATE(2317),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2225),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(72),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(125),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(401),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [73] = {
    [sym__statements] = STATE(2348),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1034),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(73),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(121),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [74] = {
    [sym__statements] = STATE(2348),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1032),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(74),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(129),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [75] = {
    [sym__statements] = STATE(2317),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(72),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2227),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(75),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [76] = {
    [sym__statements] = STATE(2317),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2227),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(76),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(120),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [77] = {
    [sym__statements] = STATE(2348),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(73),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1032),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(77),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [78] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1485),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(78),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(124),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(409),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [79] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1447),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(79),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [80] = {
    [sym__statements] = STATE(2292),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2086),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(80),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [81] = {
    [sym__statements] = STATE(2262),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(931),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(81),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2260),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [82] = {
    [sym__statements] = STATE(2270),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1218),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(82),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [83] = {
    [sym__statements] = STATE(2241),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(914),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(83),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [84] = {
    [sym__statements] = STATE(2242),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1057),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(84),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [85] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2300),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(85),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [86] = {
    [sym__statements] = STATE(2242),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1056),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(86),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [87] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2611),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(87),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [88] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1104),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(88),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [89] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2551),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(89),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [90] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1490),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(90),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [91] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2604),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(91),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [92] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2570),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(92),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [93] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2299),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(93),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [94] = {
    [sym__statements] = STATE(2241),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(915),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(94),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [95] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1495),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(95),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [96] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1510),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(96),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [97] = {
    [sym__statements] = STATE(2270),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1221),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(97),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [98] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1096),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(98),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [99] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1113),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(99),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [100] = {
    [sym__statements] = STATE(2292),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2085),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(100),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [101] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2641),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(101),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [102] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2642),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(102),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [103] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1449),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(103),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [104] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1155),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(104),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [105] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1156),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(105),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [106] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1157),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(106),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [107] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1171),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(107),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [108] = {
    [sym__statements] = STATE(2262),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(948),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(108),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2260),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [109] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1564),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(109),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [110] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1172),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(110),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [111] = {
    [sym__statements] = STATE(2314),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1173),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(111),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [112] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1466),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(112),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [113] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1561),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(113),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [114] = {
    [sym__statements] = STATE(2308),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2585),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(114),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [115] = {
    [sym__statements] = STATE(2284),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1448),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(115),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2283),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [116] = {
    [sym__statements] = STATE(2342),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1051),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(116),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(411),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [117] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1471),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(117),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [118] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1529),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(118),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(415),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [119] = {
    [sym__statements] = STATE(2342),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1077),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(119),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [120] = {
    [sym__statements] = STATE(2317),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2225),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(401),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [121] = {
    [sym__statements] = STATE(2348),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1035),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(121),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [122] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1396),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(122),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [123] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1550),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(123),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [124] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1438),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(124),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [125] = {
    [sym__statements] = STATE(2317),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(2223),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(125),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [126] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1436),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(126),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [127] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1483),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(127),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [128] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1437),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(128),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [129] = {
    [sym__statements] = STATE(2348),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1034),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(129),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [130] = {
    [sym__statements] = STATE(2359),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_else] = STATE(2557),
    [sym_begin] = STATE(1100),
    [sym_ensure] = STATE(2557),
    [sym_rescue] = STATE(2557),
    [sym__body_statement] = STATE(1562),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(130),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [aux_sym__body_statement_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(431),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [131] = {
    [sym__statements] = STATE(2866),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(984),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1345),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(131),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [132] = {
    [sym__statements] = STATE(2866),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(984),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1345),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(132),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [133] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2150),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(133),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(459),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(459),
    [anon_sym_elsif] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [134] = {
    [sym__statements] = STATE(2867),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(182),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(984),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1345),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(134),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [135] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2244),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(135),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(463),
    [anon_sym_BEGIN] = ACTIONS(466),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_END] = ACTIONS(474),
    [anon_sym_def] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_COLON_COLON] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(486),
    [anon_sym_STAR] = ACTIONS(489),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_module] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(498),
    [anon_sym_return] = ACTIONS(500),
    [anon_sym_yield] = ACTIONS(503),
    [anon_sym_break] = ACTIONS(506),
    [anon_sym_next] = ACTIONS(509),
    [anon_sym_redo] = ACTIONS(512),
    [anon_sym_retry] = ACTIONS(515),
    [anon_sym_if] = ACTIONS(518),
    [anon_sym_unless] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_until] = ACTIONS(527),
    [anon_sym_rescue] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(530),
    [anon_sym_case] = ACTIONS(533),
    [anon_sym_when] = ACTIONS(498),
    [anon_sym_elsif] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_begin] = ACTIONS(536),
    [anon_sym_ensure] = ACTIONS(498),
    [anon_sym_PLUS] = ACTIONS(539),
    [anon_sym_defined_QMARK] = ACTIONS(542),
    [anon_sym_not] = ACTIONS(545),
    [anon_sym_BANG] = ACTIONS(548),
    [anon_sym_TILDE] = ACTIONS(548),
    [sym_constant] = ACTIONS(463),
    [sym_instance_variable] = ACTIONS(551),
    [sym_class_variable] = ACTIONS(551),
    [sym_global_variable] = ACTIONS(551),
    [anon_sym_undef] = ACTIONS(554),
    [anon_sym_alias] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(560),
    [sym_float] = ACTIONS(563),
    [sym_complex] = ACTIONS(566),
    [sym_super] = ACTIONS(463),
    [anon_sym_true] = ACTIONS(569),
    [anon_sym_TRUE] = ACTIONS(569),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_FALSE] = ACTIONS(572),
    [sym_self] = ACTIONS(463),
    [anon_sym_nil] = ACTIONS(575),
    [anon_sym_NIL] = ACTIONS(575),
    [sym_character] = ACTIONS(566),
    [anon_sym_LBRACK2] = ACTIONS(578),
    [anon_sym_DASH_GT] = ACTIONS(581),
    [sym__simple_symbol] = ACTIONS(584),
    [sym__string_start] = ACTIONS(587),
    [sym__symbol_start] = ACTIONS(590),
    [sym__subshell_start] = ACTIONS(593),
    [sym__regex_start] = ACTIONS(596),
    [sym__string_array_start] = ACTIONS(599),
    [sym__symbol_array_start] = ACTIONS(602),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(566),
    [sym__unary_minus] = ACTIONS(605),
  },
  [136] = {
    [sym__statements] = STATE(2952),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(205),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_hash_splat_argument] = STATE(2769),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(984),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1345),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(136),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2769),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [137] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2796),
    [sym_else] = STATE(2796),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(137),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(610),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [138] = {
    [sym__statements] = STATE(2447),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(138),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(616),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(616),
    [anon_sym_elsif] = ACTIONS(616),
    [anon_sym_else] = ACTIONS(616),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [139] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2876),
    [sym_else] = STATE(2876),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(139),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(618),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [140] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2788),
    [sym_else] = STATE(2788),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(140),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(620),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [141] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2900),
    [sym_else] = STATE(2900),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(141),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [142] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2795),
    [sym_else] = STATE(2795),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(142),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(624),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [143] = {
    [sym__statements] = STATE(2945),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(200),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_hash_splat_argument] = STATE(2769),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(984),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1345),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(143),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2769),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(626),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [144] = {
    [sym__statements] = STATE(2952),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(205),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_hash_splat_argument] = STATE(2769),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(984),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1345),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(144),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2769),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [145] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2918),
    [sym_else] = STATE(2918),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(145),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [146] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(146),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(632),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(632),
    [anon_sym_elsif] = ACTIONS(632),
    [anon_sym_else] = ACTIONS(632),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [147] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2901),
    [sym_else] = STATE(2901),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(147),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [148] = {
    [sym__statements] = STATE(2576),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(148),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [sym__terminator] = STATE(157),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(636),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(636),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(636),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [149] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2934),
    [sym_else] = STATE(2934),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(149),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [150] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(150),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(640),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(640),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(640),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [151] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(151),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(642),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [152] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(152),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(644),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(644),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(644),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [153] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(153),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [154] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_elsif] = STATE(2966),
    [sym_else] = STATE(2966),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(154),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(648),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [155] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(155),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [156] = {
    [sym__statements] = STATE(2403),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(156),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(652),
    [anon_sym_else] = ACTIONS(652),
    [anon_sym_then] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [157] = {
    [sym__statements] = STATE(2613),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(157),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [158] = {
    [sym__statements] = STATE(2577),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(158),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(656),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(656),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [159] = {
    [sym__statements] = STATE(2909),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(174),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(159),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(658),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [160] = {
    [sym__statements] = STATE(2866),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(160),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [161] = {
    [sym__statements] = STATE(2868),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(172),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(161),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [162] = {
    [sym__statements] = STATE(2782),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(173),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(162),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [163] = {
    [sym__statements] = STATE(2845),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(184),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(163),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [164] = {
    [sym__statements] = STATE(2867),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(182),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(164),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [165] = {
    [sym__statements] = STATE(2884),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(179),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(165),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [166] = {
    [sym__statements] = STATE(2843),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(192),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(166),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [167] = {
    [sym__statements] = STATE(2946),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(203),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(167),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [168] = {
    [sym__statements] = STATE(2952),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(205),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(168),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(676),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [169] = {
    [sym__statements] = STATE(2931),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(201),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(169),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [170] = {
    [sym__statements] = STATE(2945),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_block_parameters] = STATE(200),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(170),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [171] = {
    [sym__statements] = STATE(2792),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(171),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(682),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [172] = {
    [sym__statements] = STATE(2860),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(172),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [173] = {
    [sym__statements] = STATE(2834),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(173),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(686),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [174] = {
    [sym__statements] = STATE(2915),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(174),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [175] = {
    [sym__statements] = STATE(2847),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(175),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [176] = {
    [sym__statements] = STATE(2887),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2758),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(176),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [177] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2273),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(177),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(967),
    [aux_sym__statements_repeat1] = STATE(177),
    [ts_builtin_sym_end] = ACTIONS(472),
    [sym_identifier] = ACTIONS(463),
    [anon_sym___END__] = ACTIONS(498),
    [anon_sym_BEGIN] = ACTIONS(466),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_END] = ACTIONS(474),
    [anon_sym_def] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_COLON_COLON] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(489),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_module] = ACTIONS(495),
    [anon_sym_return] = ACTIONS(500),
    [anon_sym_yield] = ACTIONS(503),
    [anon_sym_break] = ACTIONS(506),
    [anon_sym_next] = ACTIONS(509),
    [anon_sym_redo] = ACTIONS(512),
    [anon_sym_retry] = ACTIONS(515),
    [anon_sym_if] = ACTIONS(518),
    [anon_sym_unless] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_until] = ACTIONS(527),
    [anon_sym_for] = ACTIONS(530),
    [anon_sym_case] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(539),
    [anon_sym_defined_QMARK] = ACTIONS(542),
    [anon_sym_not] = ACTIONS(545),
    [anon_sym_BANG] = ACTIONS(548),
    [anon_sym_TILDE] = ACTIONS(548),
    [sym_constant] = ACTIONS(463),
    [sym_instance_variable] = ACTIONS(551),
    [sym_class_variable] = ACTIONS(551),
    [sym_global_variable] = ACTIONS(551),
    [anon_sym_undef] = ACTIONS(554),
    [anon_sym_alias] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(560),
    [sym_float] = ACTIONS(563),
    [sym_complex] = ACTIONS(566),
    [sym_super] = ACTIONS(463),
    [anon_sym_true] = ACTIONS(569),
    [anon_sym_TRUE] = ACTIONS(569),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_FALSE] = ACTIONS(572),
    [sym_self] = ACTIONS(463),
    [anon_sym_nil] = ACTIONS(575),
    [anon_sym_NIL] = ACTIONS(575),
    [sym_character] = ACTIONS(566),
    [anon_sym_LBRACK2] = ACTIONS(578),
    [anon_sym_DASH_GT] = ACTIONS(581),
    [sym__simple_symbol] = ACTIONS(584),
    [sym__string_start] = ACTIONS(587),
    [sym__symbol_start] = ACTIONS(590),
    [sym__subshell_start] = ACTIONS(593),
    [sym__regex_start] = ACTIONS(596),
    [sym__string_array_start] = ACTIONS(599),
    [sym__symbol_array_start] = ACTIONS(602),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(566),
    [sym__unary_minus] = ACTIONS(605),
  },
  [178] = {
    [sym__statements] = STATE(2848),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(178),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(697),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [179] = {
    [sym__statements] = STATE(2921),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(179),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [180] = {
    [sym__statements] = STATE(2793),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(180),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(701),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [181] = {
    [sym__statements] = STATE(2881),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(181),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [182] = {
    [sym__statements] = STATE(2920),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(182),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [183] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2220),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2178),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(183),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(967),
    [aux_sym__statements_repeat1] = STATE(177),
    [ts_builtin_sym_end] = ACTIONS(457),
    [sym_identifier] = ACTIONS(9),
    [anon_sym___END__] = ACTIONS(459),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [anon_sym_undef] = ACTIONS(69),
    [anon_sym_alias] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [184] = {
    [sym__statements] = STATE(2858),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(184),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [185] = {
    [sym__statements] = STATE(2812),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(185),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(709),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [186] = {
    [sym__statements] = STATE(2800),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(186),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [187] = {
    [sym__statements] = STATE(2881),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2758),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(187),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [188] = {
    [sym__statements] = STATE(2869),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(188),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [189] = {
    [sym__statements] = STATE(2913),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(189),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(715),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [190] = {
    [sym__statements] = STATE(2904),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2758),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(190),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [191] = {
    [sym__statements] = STATE(2906),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(191),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(719),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [192] = {
    [sym__statements] = STATE(2831),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(192),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [193] = {
    [sym__statements] = STATE(2877),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(193),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [194] = {
    [sym__statements] = STATE(2905),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(194),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [195] = {
    [sym__statements] = STATE(2871),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(195),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [196] = {
    [sym__statements] = STATE(2938),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(196),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(729),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [197] = {
    [sym__statements] = STATE(2956),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(197),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [198] = {
    [sym__statements] = STATE(2962),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2758),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(198),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [199] = {
    [sym__statements] = STATE(2961),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(199),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [200] = {
    [sym__statements] = STATE(2949),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(200),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [201] = {
    [sym__statements] = STATE(2935),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(201),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [202] = {
    [sym__statements] = STATE(2933),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(202),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(741),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [203] = {
    [sym__statements] = STATE(2925),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(203),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [204] = {
    [sym__statements] = STATE(2941),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(204),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [205] = {
    [sym__statements] = STATE(2928),
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2153),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(205),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_empty_statement] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [206] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2214),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(206),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [207] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2205),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(207),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [208] = {
    [sym_begin_block] = STATE(2427),
    [sym_end_block] = STATE(2427),
    [sym__statement] = STATE(2427),
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2385),
    [sym_yield_command] = STATE(2385),
    [sym_break_command] = STATE(2385),
    [sym_next_command] = STATE(2385),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_if_modifier] = STATE(2427),
    [sym_unless_modifier] = STATE(2427),
    [sym_while_modifier] = STATE(2427),
    [sym_until_modifier] = STATE(2427),
    [sym_rescue_modifier] = STATE(2427),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2385),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2385),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2385),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2385),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2385),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_undef] = STATE(2427),
    [sym_alias] = STATE(2427),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(208),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_BEGIN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_END] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [anon_sym_undef] = ACTIONS(785),
    [anon_sym_alias] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [209] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2213),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(209),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [210] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2209),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(210),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [211] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2204),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(211),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [212] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2212),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(212),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [213] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2221),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(213),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [214] = {
    [sym_begin_block] = STATE(2443),
    [sym_end_block] = STATE(2443),
    [sym__statement] = STATE(2443),
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2385),
    [sym_yield_command] = STATE(2385),
    [sym_break_command] = STATE(2385),
    [sym_next_command] = STATE(2385),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_if_modifier] = STATE(2443),
    [sym_unless_modifier] = STATE(2443),
    [sym_while_modifier] = STATE(2443),
    [sym_until_modifier] = STATE(2443),
    [sym_rescue_modifier] = STATE(2443),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2385),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2385),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2385),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2385),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2385),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_undef] = STATE(2443),
    [sym_alias] = STATE(2443),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(214),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_BEGIN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_END] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [anon_sym_undef] = ACTIONS(785),
    [anon_sym_alias] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [215] = {
    [sym_begin_block] = STATE(2524),
    [sym_end_block] = STATE(2524),
    [sym__statement] = STATE(2524),
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2385),
    [sym_yield_command] = STATE(2385),
    [sym_break_command] = STATE(2385),
    [sym_next_command] = STATE(2385),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_if_modifier] = STATE(2524),
    [sym_unless_modifier] = STATE(2524),
    [sym_while_modifier] = STATE(2524),
    [sym_until_modifier] = STATE(2524),
    [sym_rescue_modifier] = STATE(2524),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2385),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2385),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2385),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2385),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2385),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_undef] = STATE(2524),
    [sym_alias] = STATE(2524),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(215),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_BEGIN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_END] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [anon_sym_undef] = ACTIONS(785),
    [anon_sym_alias] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [216] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2240),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(216),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [217] = {
    [sym_begin_block] = STATE(2130),
    [sym_end_block] = STATE(2130),
    [sym__statement] = STATE(2239),
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_if_modifier] = STATE(2130),
    [sym_unless_modifier] = STATE(2130),
    [sym_while_modifier] = STATE(2130),
    [sym_until_modifier] = STATE(2130),
    [sym_rescue_modifier] = STATE(2130),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2124),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2130),
    [sym_alias] = STATE(2130),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(217),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [218] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1577),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1284),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2802),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(989),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(218),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(805),
    [sym__unary_minus] = ACTIONS(291),
  },
  [219] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1307),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1288),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2784),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(988),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(219),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(815),
  },
  [220] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1313),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1310),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2828),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(952),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(220),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(815),
  },
  [221] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1307),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1288),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2828),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(952),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(221),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(815),
  },
  [222] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1590),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1578),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2802),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(989),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(222),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(805),
    [sym__unary_minus] = ACTIONS(291),
  },
  [223] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1313),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1310),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2784),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(988),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(223),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(815),
  },
  [224] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2857),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(224),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [225] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2827),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(225),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [226] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2822),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(226),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [227] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2878),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(227),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [228] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2829),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(228),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [229] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2817),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(229),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [230] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2908),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(230),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [231] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2910),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(231),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [232] = {
    [sym_heredoc_body] = STATE(232),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [233] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2863),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(233),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [234] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2326),
    [sym_yield_command] = STATE(2326),
    [sym_break_command] = STATE(2326),
    [sym_next_command] = STATE(2326),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2326),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1167),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2326),
    [sym_method_call] = STATE(1167),
    [sym_splat_argument] = STATE(1690),
    [sym_assignment] = STATE(1702),
    [sym_command_assignment] = STATE(2326),
    [sym_operator_assignment] = STATE(1702),
    [sym_command_operator_assignment] = STATE(2326),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_command_binary] = STATE(2326),
    [sym_unary] = STATE(1702),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_right_assignment_list] = STATE(1614),
    [sym_left_assignment_list] = STATE(2959),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1167),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1167),
    [sym_false] = STATE(1167),
    [sym_nil] = STATE(1167),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(234),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(937),
  },
  [235] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2875),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(235),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [236] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2799),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(236),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [237] = {
    [sym_heredoc_body] = STATE(237),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [238] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2789),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(238),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [239] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2809),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(239),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [240] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument] = STATE(2728),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(240),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [241] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2852),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(241),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [242] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2873),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(242),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [243] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2874),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(243),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [244] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2899),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(244),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [245] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument] = STATE(2728),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(245),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [246] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2853),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(246),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [247] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2865),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(247),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [248] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2326),
    [sym_yield_command] = STATE(2326),
    [sym_break_command] = STATE(2326),
    [sym_next_command] = STATE(2326),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2326),
    [sym__arg] = STATE(1715),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1167),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2326),
    [sym_method_call] = STATE(1167),
    [sym_splat_argument] = STATE(1700),
    [sym_assignment] = STATE(1715),
    [sym_command_assignment] = STATE(2326),
    [sym_operator_assignment] = STATE(1715),
    [sym_command_operator_assignment] = STATE(2326),
    [sym_conditional] = STATE(1715),
    [sym_range] = STATE(1715),
    [sym_binary] = STATE(1715),
    [sym_command_binary] = STATE(2326),
    [sym_unary] = STATE(1715),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_right_assignment_list] = STATE(1614),
    [sym_left_assignment_list] = STATE(2959),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1167),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1167),
    [sym_false] = STATE(1167),
    [sym_nil] = STATE(1167),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(248),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(937),
  },
  [249] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2842),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(249),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [250] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2846),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(250),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [251] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2930),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(251),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [252] = {
    [sym_heredoc_body] = STATE(252),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_def] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_module] = ACTIONS(971),
    [anon_sym_end] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_next] = ACTIONS(971),
    [anon_sym_redo] = ACTIONS(971),
    [anon_sym_retry] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_unless] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_until] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_when] = ACTIONS(971),
    [anon_sym_elsif] = ACTIONS(971),
    [anon_sym_else] = ACTIONS(971),
    [anon_sym_then] = ACTIONS(971),
    [anon_sym_begin] = ACTIONS(971),
    [anon_sym_ensure] = ACTIONS(971),
    [anon_sym_EQ_GT] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [anon_sym_defined_QMARK] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(973),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(973),
    [sym_class_variable] = ACTIONS(973),
    [sym_global_variable] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [sym_complex] = ACTIONS(973),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(971),
    [anon_sym_TRUE] = ACTIONS(971),
    [anon_sym_false] = ACTIONS(971),
    [anon_sym_FALSE] = ACTIONS(971),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(971),
    [anon_sym_NIL] = ACTIONS(971),
    [sym_character] = ACTIONS(973),
    [anon_sym_LBRACK2] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(973),
    [sym__line_break] = ACTIONS(973),
    [sym__simple_symbol] = ACTIONS(973),
    [sym__string_start] = ACTIONS(973),
    [sym__symbol_start] = ACTIONS(973),
    [sym__subshell_start] = ACTIONS(973),
    [sym__regex_start] = ACTIONS(973),
    [sym__string_array_start] = ACTIONS(973),
    [sym__symbol_array_start] = ACTIONS(973),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(973),
    [sym__block_ampersand] = ACTIONS(973),
    [sym__splat_star] = ACTIONS(973),
    [sym__unary_minus] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
    [sym__identifier_hash_key] = ACTIONS(973),
  },
  [253] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2967),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(253),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [254] = {
    [sym_heredoc_body] = STATE(254),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_RPAREN] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_end] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_next] = ACTIONS(977),
    [anon_sym_redo] = ACTIONS(977),
    [anon_sym_retry] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_unless] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_until] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_when] = ACTIONS(977),
    [anon_sym_elsif] = ACTIONS(977),
    [anon_sym_else] = ACTIONS(977),
    [anon_sym_then] = ACTIONS(977),
    [anon_sym_begin] = ACTIONS(977),
    [anon_sym_ensure] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(977),
    [anon_sym_or] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(979),
    [sym_constant] = ACTIONS(977),
    [sym_instance_variable] = ACTIONS(979),
    [sym_class_variable] = ACTIONS(979),
    [sym_global_variable] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(977),
    [sym_complex] = ACTIONS(979),
    [sym_super] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(977),
    [anon_sym_TRUE] = ACTIONS(977),
    [anon_sym_false] = ACTIONS(977),
    [anon_sym_FALSE] = ACTIONS(977),
    [sym_self] = ACTIONS(977),
    [anon_sym_nil] = ACTIONS(977),
    [anon_sym_NIL] = ACTIONS(977),
    [sym_character] = ACTIONS(979),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym__line_break] = ACTIONS(979),
    [sym__simple_symbol] = ACTIONS(979),
    [sym__string_start] = ACTIONS(979),
    [sym__symbol_start] = ACTIONS(979),
    [sym__subshell_start] = ACTIONS(979),
    [sym__regex_start] = ACTIONS(979),
    [sym__string_array_start] = ACTIONS(979),
    [sym__symbol_array_start] = ACTIONS(979),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(979),
    [sym__block_ampersand] = ACTIONS(979),
    [sym__splat_star] = ACTIONS(979),
    [sym__unary_minus] = ACTIONS(979),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
    [sym__identifier_hash_key] = ACTIONS(979),
  },
  [255] = {
    [sym_heredoc_body] = STATE(255),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [256] = {
    [sym_heredoc_body] = STATE(256),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_end] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_next] = ACTIONS(981),
    [anon_sym_redo] = ACTIONS(981),
    [anon_sym_retry] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_unless] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_until] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_when] = ACTIONS(981),
    [anon_sym_elsif] = ACTIONS(981),
    [anon_sym_else] = ACTIONS(981),
    [anon_sym_then] = ACTIONS(981),
    [anon_sym_begin] = ACTIONS(981),
    [anon_sym_ensure] = ACTIONS(981),
    [anon_sym_EQ_GT] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(983),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(983),
    [sym_constant] = ACTIONS(981),
    [sym_instance_variable] = ACTIONS(983),
    [sym_class_variable] = ACTIONS(983),
    [sym_global_variable] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(981),
    [sym_complex] = ACTIONS(983),
    [sym_super] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_TRUE] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_FALSE] = ACTIONS(981),
    [sym_self] = ACTIONS(981),
    [anon_sym_nil] = ACTIONS(981),
    [anon_sym_NIL] = ACTIONS(981),
    [sym_character] = ACTIONS(983),
    [anon_sym_LBRACK2] = ACTIONS(981),
    [anon_sym_DASH_GT] = ACTIONS(983),
    [sym__line_break] = ACTIONS(983),
    [sym__simple_symbol] = ACTIONS(983),
    [sym__string_start] = ACTIONS(983),
    [sym__symbol_start] = ACTIONS(983),
    [sym__subshell_start] = ACTIONS(983),
    [sym__regex_start] = ACTIONS(983),
    [sym__string_array_start] = ACTIONS(983),
    [sym__symbol_array_start] = ACTIONS(983),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(983),
    [sym__block_ampersand] = ACTIONS(983),
    [sym__splat_star] = ACTIONS(983),
    [sym__unary_minus] = ACTIONS(983),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
    [sym__identifier_hash_key] = ACTIONS(983),
  },
  [257] = {
    [sym_heredoc_body] = STATE(257),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_end] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_next] = ACTIONS(985),
    [anon_sym_redo] = ACTIONS(985),
    [anon_sym_retry] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_unless] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_until] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_when] = ACTIONS(985),
    [anon_sym_elsif] = ACTIONS(985),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_then] = ACTIONS(985),
    [anon_sym_begin] = ACTIONS(985),
    [anon_sym_ensure] = ACTIONS(985),
    [anon_sym_EQ_GT] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(985),
    [anon_sym_or] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [anon_sym_defined_QMARK] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(987),
    [sym_constant] = ACTIONS(985),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(985),
    [sym_complex] = ACTIONS(987),
    [sym_super] = ACTIONS(985),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_TRUE] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_FALSE] = ACTIONS(985),
    [sym_self] = ACTIONS(985),
    [anon_sym_nil] = ACTIONS(985),
    [anon_sym_NIL] = ACTIONS(985),
    [sym_character] = ACTIONS(987),
    [anon_sym_LBRACK2] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(987),
    [sym__line_break] = ACTIONS(987),
    [sym__simple_symbol] = ACTIONS(987),
    [sym__string_start] = ACTIONS(987),
    [sym__symbol_start] = ACTIONS(987),
    [sym__subshell_start] = ACTIONS(987),
    [sym__regex_start] = ACTIONS(987),
    [sym__string_array_start] = ACTIONS(987),
    [sym__symbol_array_start] = ACTIONS(987),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(987),
    [sym__block_ampersand] = ACTIONS(987),
    [sym__splat_star] = ACTIONS(987),
    [sym__unary_minus] = ACTIONS(987),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
    [sym__identifier_hash_key] = ACTIONS(987),
  },
  [258] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2937),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(258),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(989),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [259] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2954),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(259),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [260] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2923),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(260),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [261] = {
    [sym_heredoc_body] = STATE(261),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_next] = ACTIONS(995),
    [anon_sym_redo] = ACTIONS(995),
    [anon_sym_retry] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_unless] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_until] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_when] = ACTIONS(995),
    [anon_sym_elsif] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_then] = ACTIONS(995),
    [anon_sym_begin] = ACTIONS(995),
    [anon_sym_ensure] = ACTIONS(995),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_defined_QMARK] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [sym_constant] = ACTIONS(995),
    [sym_instance_variable] = ACTIONS(997),
    [sym_class_variable] = ACTIONS(997),
    [sym_global_variable] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [sym_complex] = ACTIONS(997),
    [sym_super] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_TRUE] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_FALSE] = ACTIONS(995),
    [sym_self] = ACTIONS(995),
    [anon_sym_nil] = ACTIONS(995),
    [anon_sym_NIL] = ACTIONS(995),
    [sym_character] = ACTIONS(997),
    [anon_sym_LBRACK2] = ACTIONS(995),
    [anon_sym_DASH_GT] = ACTIONS(997),
    [sym__line_break] = ACTIONS(997),
    [sym__simple_symbol] = ACTIONS(997),
    [sym__string_start] = ACTIONS(997),
    [sym__symbol_start] = ACTIONS(997),
    [sym__subshell_start] = ACTIONS(997),
    [sym__regex_start] = ACTIONS(997),
    [sym__string_array_start] = ACTIONS(997),
    [sym__symbol_array_start] = ACTIONS(997),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(997),
    [sym__block_ampersand] = ACTIONS(997),
    [sym__splat_star] = ACTIONS(997),
    [sym__unary_minus] = ACTIONS(997),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
    [sym__identifier_hash_key] = ACTIONS(997),
  },
  [262] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2965),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(262),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [263] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_then] = STATE(2572),
    [sym_begin] = STATE(1100),
    [sym_exceptions] = STATE(2319),
    [sym_exception_variable] = STATE(2544),
    [sym__arg] = STATE(1741),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(2479),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(263),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym__terminator] = STATE(150),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_then] = ACTIONS(1005),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [264] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2927),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(264),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [265] = {
    [sym_heredoc_body] = STATE(265),
    [sym_identifier] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COLON_COLON] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_end] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_next] = ACTIONS(1027),
    [anon_sym_redo] = ACTIONS(1027),
    [anon_sym_retry] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_unless] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_until] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_when] = ACTIONS(1027),
    [anon_sym_elsif] = ACTIONS(1027),
    [anon_sym_else] = ACTIONS(1027),
    [anon_sym_then] = ACTIONS(1027),
    [anon_sym_begin] = ACTIONS(1027),
    [anon_sym_ensure] = ACTIONS(1027),
    [anon_sym_EQ_GT] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1027),
    [anon_sym_or] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [anon_sym_defined_QMARK] = ACTIONS(1029),
    [anon_sym_not] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1029),
    [sym_constant] = ACTIONS(1027),
    [sym_instance_variable] = ACTIONS(1029),
    [sym_class_variable] = ACTIONS(1029),
    [sym_global_variable] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [sym_complex] = ACTIONS(1029),
    [sym_super] = ACTIONS(1027),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_TRUE] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_FALSE] = ACTIONS(1027),
    [sym_self] = ACTIONS(1027),
    [anon_sym_nil] = ACTIONS(1027),
    [anon_sym_NIL] = ACTIONS(1027),
    [sym_character] = ACTIONS(1029),
    [anon_sym_LBRACK2] = ACTIONS(1027),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [sym__line_break] = ACTIONS(1029),
    [sym__simple_symbol] = ACTIONS(1029),
    [sym__string_start] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(1029),
    [sym__subshell_start] = ACTIONS(1029),
    [sym__regex_start] = ACTIONS(1029),
    [sym__string_array_start] = ACTIONS(1029),
    [sym__symbol_array_start] = ACTIONS(1029),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1029),
    [sym__block_ampersand] = ACTIONS(1029),
    [sym__splat_star] = ACTIONS(1029),
    [sym__unary_minus] = ACTIONS(1029),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
    [sym__identifier_hash_key] = ACTIONS(1029),
  },
  [266] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument_list_with_trailing_comma] = STATE(2926),
    [sym__argument] = STATE(2559),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(266),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(1031),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [267] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2179),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(267),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [268] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2134),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(268),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [269] = {
    [sym_heredoc_body] = STATE(269),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_next] = ACTIONS(995),
    [anon_sym_redo] = ACTIONS(995),
    [anon_sym_retry] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_unless] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_until] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_when] = ACTIONS(995),
    [anon_sym_elsif] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_then] = ACTIONS(995),
    [anon_sym_begin] = ACTIONS(995),
    [anon_sym_ensure] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_defined_QMARK] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [sym_constant] = ACTIONS(995),
    [sym_instance_variable] = ACTIONS(997),
    [sym_class_variable] = ACTIONS(997),
    [sym_global_variable] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [sym_complex] = ACTIONS(997),
    [sym_super] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_TRUE] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_FALSE] = ACTIONS(995),
    [sym_self] = ACTIONS(995),
    [anon_sym_nil] = ACTIONS(995),
    [anon_sym_NIL] = ACTIONS(995),
    [sym_character] = ACTIONS(997),
    [anon_sym_LBRACK2] = ACTIONS(995),
    [anon_sym_DASH_GT] = ACTIONS(997),
    [sym__line_break] = ACTIONS(997),
    [sym__simple_symbol] = ACTIONS(997),
    [sym__string_start] = ACTIONS(997),
    [sym__symbol_start] = ACTIONS(997),
    [sym__subshell_start] = ACTIONS(997),
    [sym__regex_start] = ACTIONS(997),
    [sym__string_array_start] = ACTIONS(997),
    [sym__symbol_array_start] = ACTIONS(997),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(997),
    [sym__block_ampersand] = ACTIONS(997),
    [sym__splat_star] = ACTIONS(997),
    [sym__unary_minus] = ACTIONS(997),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
    [sym__identifier_hash_key] = ACTIONS(997),
  },
  [270] = {
    [sym_heredoc_body] = STATE(270),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [271] = {
    [sym_heredoc_body] = STATE(271),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_RPAREN] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_end] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_next] = ACTIONS(977),
    [anon_sym_redo] = ACTIONS(977),
    [anon_sym_retry] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_unless] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_until] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_when] = ACTIONS(977),
    [anon_sym_elsif] = ACTIONS(977),
    [anon_sym_else] = ACTIONS(977),
    [anon_sym_then] = ACTIONS(977),
    [anon_sym_begin] = ACTIONS(977),
    [anon_sym_ensure] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(977),
    [anon_sym_or] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(979),
    [sym_constant] = ACTIONS(977),
    [sym_instance_variable] = ACTIONS(979),
    [sym_class_variable] = ACTIONS(979),
    [sym_global_variable] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(977),
    [sym_complex] = ACTIONS(979),
    [sym_super] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(977),
    [anon_sym_TRUE] = ACTIONS(977),
    [anon_sym_false] = ACTIONS(977),
    [anon_sym_FALSE] = ACTIONS(977),
    [sym_self] = ACTIONS(977),
    [anon_sym_nil] = ACTIONS(977),
    [anon_sym_NIL] = ACTIONS(977),
    [sym_character] = ACTIONS(979),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym__line_break] = ACTIONS(979),
    [sym__simple_symbol] = ACTIONS(979),
    [sym__string_start] = ACTIONS(979),
    [sym__symbol_start] = ACTIONS(979),
    [sym__subshell_start] = ACTIONS(979),
    [sym__regex_start] = ACTIONS(979),
    [sym__string_array_start] = ACTIONS(979),
    [sym__symbol_array_start] = ACTIONS(979),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(979),
    [sym__block_ampersand] = ACTIONS(979),
    [sym__splat_star] = ACTIONS(979),
    [sym__unary_minus] = ACTIONS(979),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
    [sym__identifier_hash_key] = ACTIONS(979),
  },
  [272] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1316),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2784),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(988),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(272),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [273] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym__argument] = STATE(2097),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(1041),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(273),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [274] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2112),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(274),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [275] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym__argument] = STATE(2097),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(990),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(275),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1037),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [276] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2181),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(276),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [277] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2182),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(277),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [278] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2183),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(278),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [279] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2185),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(279),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [280] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(280),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [281] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2125),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(281),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [282] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1615),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(984),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(282),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [283] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym__argument] = STATE(2728),
    [sym_splat_argument] = STATE(2680),
    [sym_hash_splat_argument] = STATE(2680),
    [sym_block_argument] = STATE(2680),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(283),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2680),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [284] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2138),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(284),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [285] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(285),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [286] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1391),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(991),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(286),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [287] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2120),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(287),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [288] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1316),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2828),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(952),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(288),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [289] = {
    [sym_heredoc_body] = STATE(289),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_def] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_module] = ACTIONS(971),
    [anon_sym_end] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_next] = ACTIONS(971),
    [anon_sym_redo] = ACTIONS(971),
    [anon_sym_retry] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_unless] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_until] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_when] = ACTIONS(971),
    [anon_sym_elsif] = ACTIONS(971),
    [anon_sym_else] = ACTIONS(971),
    [anon_sym_then] = ACTIONS(971),
    [anon_sym_begin] = ACTIONS(971),
    [anon_sym_ensure] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [anon_sym_defined_QMARK] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(973),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(973),
    [sym_class_variable] = ACTIONS(973),
    [sym_global_variable] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [sym_complex] = ACTIONS(973),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(971),
    [anon_sym_TRUE] = ACTIONS(971),
    [anon_sym_false] = ACTIONS(971),
    [anon_sym_FALSE] = ACTIONS(971),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(971),
    [anon_sym_NIL] = ACTIONS(971),
    [sym_character] = ACTIONS(973),
    [anon_sym_LBRACK2] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(973),
    [sym__line_break] = ACTIONS(973),
    [sym__simple_symbol] = ACTIONS(973),
    [sym__string_start] = ACTIONS(973),
    [sym__symbol_start] = ACTIONS(973),
    [sym__subshell_start] = ACTIONS(973),
    [sym__regex_start] = ACTIONS(973),
    [sym__string_array_start] = ACTIONS(973),
    [sym__symbol_array_start] = ACTIONS(973),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(973),
    [sym__block_ampersand] = ACTIONS(973),
    [sym__splat_star] = ACTIONS(973),
    [sym__unary_minus] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
    [sym__identifier_hash_key] = ACTIONS(973),
  },
  [290] = {
    [sym_heredoc_body] = STATE(290),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_end] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_next] = ACTIONS(985),
    [anon_sym_redo] = ACTIONS(985),
    [anon_sym_retry] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_unless] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_until] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_when] = ACTIONS(985),
    [anon_sym_elsif] = ACTIONS(985),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_then] = ACTIONS(985),
    [anon_sym_begin] = ACTIONS(985),
    [anon_sym_ensure] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(985),
    [anon_sym_or] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [anon_sym_defined_QMARK] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(987),
    [sym_constant] = ACTIONS(985),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(985),
    [sym_complex] = ACTIONS(987),
    [sym_super] = ACTIONS(985),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_TRUE] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_FALSE] = ACTIONS(985),
    [sym_self] = ACTIONS(985),
    [anon_sym_nil] = ACTIONS(985),
    [anon_sym_NIL] = ACTIONS(985),
    [sym_character] = ACTIONS(987),
    [anon_sym_LBRACK2] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(987),
    [sym__line_break] = ACTIONS(987),
    [sym__simple_symbol] = ACTIONS(987),
    [sym__string_start] = ACTIONS(987),
    [sym__symbol_start] = ACTIONS(987),
    [sym__subshell_start] = ACTIONS(987),
    [sym__regex_start] = ACTIONS(987),
    [sym__string_array_start] = ACTIONS(987),
    [sym__symbol_array_start] = ACTIONS(987),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(987),
    [sym__block_ampersand] = ACTIONS(987),
    [sym__splat_star] = ACTIONS(987),
    [sym__unary_minus] = ACTIONS(987),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
    [sym__identifier_hash_key] = ACTIONS(987),
  },
  [291] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1597),
    [sym__primary] = STATE(1201),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2802),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(989),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(291),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [292] = {
    [sym_heredoc_body] = STATE(292),
    [sym_identifier] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COLON_COLON] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_end] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_next] = ACTIONS(1027),
    [anon_sym_redo] = ACTIONS(1027),
    [anon_sym_retry] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_unless] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_until] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_when] = ACTIONS(1027),
    [anon_sym_elsif] = ACTIONS(1027),
    [anon_sym_else] = ACTIONS(1027),
    [anon_sym_then] = ACTIONS(1027),
    [anon_sym_begin] = ACTIONS(1027),
    [anon_sym_ensure] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1027),
    [anon_sym_or] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [anon_sym_defined_QMARK] = ACTIONS(1029),
    [anon_sym_not] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1029),
    [sym_constant] = ACTIONS(1027),
    [sym_instance_variable] = ACTIONS(1029),
    [sym_class_variable] = ACTIONS(1029),
    [sym_global_variable] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [sym_complex] = ACTIONS(1029),
    [sym_super] = ACTIONS(1027),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_TRUE] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_FALSE] = ACTIONS(1027),
    [sym_self] = ACTIONS(1027),
    [anon_sym_nil] = ACTIONS(1027),
    [anon_sym_NIL] = ACTIONS(1027),
    [sym_character] = ACTIONS(1029),
    [anon_sym_LBRACK2] = ACTIONS(1027),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [sym__line_break] = ACTIONS(1029),
    [sym__simple_symbol] = ACTIONS(1029),
    [sym__string_start] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(1029),
    [sym__subshell_start] = ACTIONS(1029),
    [sym__regex_start] = ACTIONS(1029),
    [sym__string_array_start] = ACTIONS(1029),
    [sym__symbol_array_start] = ACTIONS(1029),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1029),
    [sym__block_ampersand] = ACTIONS(1029),
    [sym__splat_star] = ACTIONS(1029),
    [sym__unary_minus] = ACTIONS(1029),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
    [sym__identifier_hash_key] = ACTIONS(1029),
  },
  [293] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return_command] = STATE(2115),
    [sym_yield_command] = STATE(2115),
    [sym_break_command] = STATE(2115),
    [sym_next_command] = STATE(2115),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__expression] = STATE(2112),
    [sym__arg] = STATE(1346),
    [sym__primary] = STATE(1285),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2115),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_command_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(1243),
    [sym_command_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_command_binary] = STATE(2115),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2844),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(293),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [294] = {
    [sym_heredoc_body] = STATE(294),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_end] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_next] = ACTIONS(981),
    [anon_sym_redo] = ACTIONS(981),
    [anon_sym_retry] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_unless] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_until] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_when] = ACTIONS(981),
    [anon_sym_elsif] = ACTIONS(981),
    [anon_sym_else] = ACTIONS(981),
    [anon_sym_then] = ACTIONS(981),
    [anon_sym_begin] = ACTIONS(981),
    [anon_sym_ensure] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(983),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(983),
    [sym_constant] = ACTIONS(981),
    [sym_instance_variable] = ACTIONS(983),
    [sym_class_variable] = ACTIONS(983),
    [sym_global_variable] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(981),
    [sym_complex] = ACTIONS(983),
    [sym_super] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_TRUE] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_FALSE] = ACTIONS(981),
    [sym_self] = ACTIONS(981),
    [anon_sym_nil] = ACTIONS(981),
    [anon_sym_NIL] = ACTIONS(981),
    [sym_character] = ACTIONS(983),
    [anon_sym_LBRACK2] = ACTIONS(981),
    [anon_sym_DASH_GT] = ACTIONS(983),
    [sym__line_break] = ACTIONS(983),
    [sym__simple_symbol] = ACTIONS(983),
    [sym__string_start] = ACTIONS(983),
    [sym__symbol_start] = ACTIONS(983),
    [sym__subshell_start] = ACTIONS(983),
    [sym__regex_start] = ACTIONS(983),
    [sym__string_array_start] = ACTIONS(983),
    [sym__symbol_array_start] = ACTIONS(983),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(983),
    [sym__block_ampersand] = ACTIONS(983),
    [sym__splat_star] = ACTIONS(983),
    [sym__unary_minus] = ACTIONS(983),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
    [sym__identifier_hash_key] = ACTIONS(983),
  },
  [295] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1628),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym__argument] = STATE(2207),
    [sym_splat_argument] = STATE(2207),
    [sym_hash_splat_argument] = STATE(2207),
    [sym_block_argument] = STATE(2207),
    [sym_assignment] = STATE(1628),
    [sym_operator_assignment] = STATE(1628),
    [sym_conditional] = STATE(1628),
    [sym_range] = STATE(1628),
    [sym_binary] = STATE(1628),
    [sym_unary] = STATE(1628),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1342),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(295),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_pair] = STATE(2207),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1047),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1043),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__block_ampersand] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [sym__unary_minus] = ACTIONS(259),
    [sym__identifier_hash_key] = ACTIONS(261),
  },
  [296] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2325),
    [sym_yield_command] = STATE(2325),
    [sym_break_command] = STATE(2325),
    [sym_next_command] = STATE(2325),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2325),
    [sym__arg] = STATE(1738),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1167),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1167),
    [sym_assignment] = STATE(1738),
    [sym_command_assignment] = STATE(2325),
    [sym_operator_assignment] = STATE(1738),
    [sym_command_operator_assignment] = STATE(2325),
    [sym_conditional] = STATE(1738),
    [sym_range] = STATE(1738),
    [sym_binary] = STATE(1738),
    [sym_command_binary] = STATE(2325),
    [sym_unary] = STATE(1738),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2959),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1167),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1167),
    [sym_false] = STATE(1167),
    [sym_nil] = STATE(1167),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(296),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(937),
  },
  [297] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2328),
    [sym_yield_command] = STATE(2328),
    [sym_break_command] = STATE(2328),
    [sym_next_command] = STATE(2328),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2328),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2328),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2328),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2328),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2328),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(297),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [298] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2329),
    [sym_yield_command] = STATE(2329),
    [sym_break_command] = STATE(2329),
    [sym_next_command] = STATE(2329),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2329),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2329),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2329),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2329),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2329),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(298),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [299] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2330),
    [sym_yield_command] = STATE(2330),
    [sym_break_command] = STATE(2330),
    [sym_next_command] = STATE(2330),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2330),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2330),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2330),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2330),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2330),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(299),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [300] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2331),
    [sym_yield_command] = STATE(2331),
    [sym_break_command] = STATE(2331),
    [sym_next_command] = STATE(2331),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2331),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2331),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2331),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2331),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2331),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(300),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [301] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2332),
    [sym_yield_command] = STATE(2332),
    [sym_break_command] = STATE(2332),
    [sym_next_command] = STATE(2332),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2332),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2332),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2332),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2332),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2332),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(301),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [302] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2334),
    [sym_yield_command] = STATE(2334),
    [sym_break_command] = STATE(2334),
    [sym_next_command] = STATE(2334),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2334),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2334),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1773),
    [sym_command_assignment] = STATE(2334),
    [sym_operator_assignment] = STATE(1773),
    [sym_command_operator_assignment] = STATE(2334),
    [sym_conditional] = STATE(1773),
    [sym_range] = STATE(1773),
    [sym_binary] = STATE(1773),
    [sym_command_binary] = STATE(2334),
    [sym_unary] = STATE(1773),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(302),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [303] = {
    [sym_method] = STATE(1593),
    [sym_singleton_method] = STATE(1593),
    [sym_class] = STATE(1593),
    [sym_singleton_class] = STATE(1593),
    [sym_module] = STATE(1593),
    [sym_return_command] = STATE(2325),
    [sym_yield_command] = STATE(2325),
    [sym_break_command] = STATE(2325),
    [sym_next_command] = STATE(2325),
    [sym_return] = STATE(1593),
    [sym_yield] = STATE(1593),
    [sym_break] = STATE(1593),
    [sym_next] = STATE(1593),
    [sym_redo] = STATE(1593),
    [sym_retry] = STATE(1593),
    [sym_while] = STATE(1593),
    [sym_until] = STATE(1593),
    [sym_for] = STATE(1593),
    [sym_case] = STATE(1593),
    [sym_if] = STATE(1593),
    [sym_unless] = STATE(1593),
    [sym_begin] = STATE(1593),
    [sym__expression] = STATE(2325),
    [sym__arg] = STATE(1787),
    [sym__primary] = STATE(1593),
    [sym_parenthesized_statements] = STATE(1593),
    [sym_element_reference] = STATE(1099),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1099),
    [sym_assignment] = STATE(1787),
    [sym_command_assignment] = STATE(2325),
    [sym_operator_assignment] = STATE(1787),
    [sym_command_operator_assignment] = STATE(2325),
    [sym_conditional] = STATE(1787),
    [sym_range] = STATE(1787),
    [sym_binary] = STATE(1787),
    [sym_command_binary] = STATE(2325),
    [sym_unary] = STATE(1787),
    [sym_parenthesized_unary] = STATE(1593),
    [sym_unary_literal] = STATE(1593),
    [sym_left_assignment_list] = STATE(2942),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1099),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1593),
    [sym_true] = STATE(1099),
    [sym_false] = STATE(1099),
    [sym_nil] = STATE(1099),
    [sym_chained_string] = STATE(1593),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1593),
    [sym_string_array] = STATE(1593),
    [sym_symbol_array] = STATE(1593),
    [sym_symbol] = STATE(1593),
    [sym_regex] = STATE(1593),
    [sym_heredoc_body] = STATE(303),
    [sym_array] = STATE(1593),
    [sym_hash] = STATE(1593),
    [sym_lambda] = STATE(1593),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [304] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1682),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym__argument] = STATE(2207),
    [sym_splat_argument] = STATE(2207),
    [sym_hash_splat_argument] = STATE(2207),
    [sym_block_argument] = STATE(2207),
    [sym_assignment] = STATE(1682),
    [sym_operator_assignment] = STATE(1682),
    [sym_conditional] = STATE(1682),
    [sym_range] = STATE(1682),
    [sym_binary] = STATE(1682),
    [sym_unary] = STATE(1682),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(304),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_pair] = STATE(2207),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1059),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [305] = {
    [sym_heredoc_body] = STATE(305),
    [ts_builtin_sym_end] = ACTIONS(923),
    [sym_identifier] = ACTIONS(921),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [306] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(306),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [307] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(307),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [308] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(308),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [309] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2710),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(309),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2710),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [310] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(310),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [311] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(311),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [312] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2718),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(312),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2718),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [313] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(313),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [314] = {
    [sym_heredoc_body] = STATE(314),
    [ts_builtin_sym_end] = ACTIONS(923),
    [sym_identifier] = ACTIONS(921),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [315] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(315),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [316] = {
    [sym_heredoc_body] = STATE(316),
    [ts_builtin_sym_end] = ACTIONS(923),
    [sym_identifier] = ACTIONS(921),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [317] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(317),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [318] = {
    [sym_heredoc_body] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(981),
    [anon_sym___END__] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_next] = ACTIONS(981),
    [anon_sym_redo] = ACTIONS(981),
    [anon_sym_retry] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_unless] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_until] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_begin] = ACTIONS(981),
    [anon_sym_EQ_GT] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(983),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(983),
    [sym_constant] = ACTIONS(981),
    [sym_instance_variable] = ACTIONS(983),
    [sym_class_variable] = ACTIONS(983),
    [sym_global_variable] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(981),
    [sym_complex] = ACTIONS(983),
    [sym_super] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_TRUE] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_FALSE] = ACTIONS(981),
    [sym_self] = ACTIONS(981),
    [anon_sym_nil] = ACTIONS(981),
    [anon_sym_NIL] = ACTIONS(981),
    [sym_character] = ACTIONS(983),
    [anon_sym_LBRACK2] = ACTIONS(981),
    [anon_sym_DASH_GT] = ACTIONS(983),
    [sym__line_break] = ACTIONS(983),
    [sym__simple_symbol] = ACTIONS(983),
    [sym__string_start] = ACTIONS(983),
    [sym__symbol_start] = ACTIONS(983),
    [sym__subshell_start] = ACTIONS(983),
    [sym__regex_start] = ACTIONS(983),
    [sym__string_array_start] = ACTIONS(983),
    [sym__symbol_array_start] = ACTIONS(983),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(983),
    [sym__block_ampersand] = ACTIONS(983),
    [sym__splat_star] = ACTIONS(983),
    [sym__unary_minus] = ACTIONS(983),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
    [sym__identifier_hash_key] = ACTIONS(983),
  },
  [319] = {
    [sym_heredoc_body] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(979),
    [sym_identifier] = ACTIONS(977),
    [anon_sym___END__] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_next] = ACTIONS(977),
    [anon_sym_redo] = ACTIONS(977),
    [anon_sym_retry] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_unless] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_until] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_begin] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(977),
    [anon_sym_or] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(979),
    [sym_constant] = ACTIONS(977),
    [sym_instance_variable] = ACTIONS(979),
    [sym_class_variable] = ACTIONS(979),
    [sym_global_variable] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(977),
    [sym_complex] = ACTIONS(979),
    [sym_super] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(977),
    [anon_sym_TRUE] = ACTIONS(977),
    [anon_sym_false] = ACTIONS(977),
    [anon_sym_FALSE] = ACTIONS(977),
    [sym_self] = ACTIONS(977),
    [anon_sym_nil] = ACTIONS(977),
    [anon_sym_NIL] = ACTIONS(977),
    [sym_character] = ACTIONS(979),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym__line_break] = ACTIONS(979),
    [sym__simple_symbol] = ACTIONS(979),
    [sym__string_start] = ACTIONS(979),
    [sym__symbol_start] = ACTIONS(979),
    [sym__subshell_start] = ACTIONS(979),
    [sym__regex_start] = ACTIONS(979),
    [sym__string_array_start] = ACTIONS(979),
    [sym__symbol_array_start] = ACTIONS(979),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(979),
    [sym__block_ampersand] = ACTIONS(979),
    [sym__splat_star] = ACTIONS(979),
    [sym__unary_minus] = ACTIONS(979),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
    [sym__identifier_hash_key] = ACTIONS(979),
  },
  [320] = {
    [sym_heredoc_body] = STATE(320),
    [ts_builtin_sym_end] = ACTIONS(997),
    [sym_identifier] = ACTIONS(995),
    [anon_sym___END__] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_next] = ACTIONS(995),
    [anon_sym_redo] = ACTIONS(995),
    [anon_sym_retry] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_unless] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_until] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_begin] = ACTIONS(995),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_defined_QMARK] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [sym_constant] = ACTIONS(995),
    [sym_instance_variable] = ACTIONS(997),
    [sym_class_variable] = ACTIONS(997),
    [sym_global_variable] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [sym_complex] = ACTIONS(997),
    [sym_super] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_TRUE] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_FALSE] = ACTIONS(995),
    [sym_self] = ACTIONS(995),
    [anon_sym_nil] = ACTIONS(995),
    [anon_sym_NIL] = ACTIONS(995),
    [sym_character] = ACTIONS(997),
    [anon_sym_LBRACK2] = ACTIONS(995),
    [anon_sym_DASH_GT] = ACTIONS(997),
    [sym__line_break] = ACTIONS(997),
    [sym__simple_symbol] = ACTIONS(997),
    [sym__string_start] = ACTIONS(997),
    [sym__symbol_start] = ACTIONS(997),
    [sym__subshell_start] = ACTIONS(997),
    [sym__regex_start] = ACTIONS(997),
    [sym__string_array_start] = ACTIONS(997),
    [sym__symbol_array_start] = ACTIONS(997),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(997),
    [sym__block_ampersand] = ACTIONS(997),
    [sym__splat_star] = ACTIONS(997),
    [sym__unary_minus] = ACTIONS(997),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
    [sym__identifier_hash_key] = ACTIONS(997),
  },
  [321] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(321),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [322] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2772),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(322),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2772),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [323] = {
    [sym_heredoc_body] = STATE(323),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(1101),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [324] = {
    [sym_heredoc_body] = STATE(324),
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_identifier] = ACTIONS(985),
    [anon_sym___END__] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_next] = ACTIONS(985),
    [anon_sym_redo] = ACTIONS(985),
    [anon_sym_retry] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_unless] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_until] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_begin] = ACTIONS(985),
    [anon_sym_EQ_GT] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(985),
    [anon_sym_or] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [anon_sym_defined_QMARK] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(987),
    [sym_constant] = ACTIONS(985),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(985),
    [sym_complex] = ACTIONS(987),
    [sym_super] = ACTIONS(985),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_TRUE] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_FALSE] = ACTIONS(985),
    [sym_self] = ACTIONS(985),
    [anon_sym_nil] = ACTIONS(985),
    [anon_sym_NIL] = ACTIONS(985),
    [sym_character] = ACTIONS(987),
    [anon_sym_LBRACK2] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(987),
    [sym__line_break] = ACTIONS(987),
    [sym__simple_symbol] = ACTIONS(987),
    [sym__string_start] = ACTIONS(987),
    [sym__symbol_start] = ACTIONS(987),
    [sym__subshell_start] = ACTIONS(987),
    [sym__regex_start] = ACTIONS(987),
    [sym__string_array_start] = ACTIONS(987),
    [sym__symbol_array_start] = ACTIONS(987),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(987),
    [sym__block_ampersand] = ACTIONS(987),
    [sym__splat_star] = ACTIONS(987),
    [sym__unary_minus] = ACTIONS(987),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
    [sym__identifier_hash_key] = ACTIONS(987),
  },
  [325] = {
    [sym_heredoc_body] = STATE(325),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1027),
    [anon_sym___END__] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COLON_COLON] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_next] = ACTIONS(1027),
    [anon_sym_redo] = ACTIONS(1027),
    [anon_sym_retry] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_unless] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_until] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_begin] = ACTIONS(1027),
    [anon_sym_EQ_GT] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1027),
    [anon_sym_or] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [anon_sym_defined_QMARK] = ACTIONS(1029),
    [anon_sym_not] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1029),
    [sym_constant] = ACTIONS(1027),
    [sym_instance_variable] = ACTIONS(1029),
    [sym_class_variable] = ACTIONS(1029),
    [sym_global_variable] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [sym_complex] = ACTIONS(1029),
    [sym_super] = ACTIONS(1027),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_TRUE] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_FALSE] = ACTIONS(1027),
    [sym_self] = ACTIONS(1027),
    [anon_sym_nil] = ACTIONS(1027),
    [anon_sym_NIL] = ACTIONS(1027),
    [sym_character] = ACTIONS(1029),
    [anon_sym_LBRACK2] = ACTIONS(1027),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [sym__line_break] = ACTIONS(1029),
    [sym__simple_symbol] = ACTIONS(1029),
    [sym__string_start] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(1029),
    [sym__subshell_start] = ACTIONS(1029),
    [sym__regex_start] = ACTIONS(1029),
    [sym__string_array_start] = ACTIONS(1029),
    [sym__symbol_array_start] = ACTIONS(1029),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1029),
    [sym__block_ampersand] = ACTIONS(1029),
    [sym__splat_star] = ACTIONS(1029),
    [sym__unary_minus] = ACTIONS(1029),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
    [sym__identifier_hash_key] = ACTIONS(1029),
  },
  [326] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_hash_splat_argument] = STATE(2769),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1575),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(326),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_pair] = STATE(2769),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [327] = {
    [sym_heredoc_body] = STATE(327),
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_identifier] = ACTIONS(971),
    [anon_sym___END__] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_def] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_module] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_next] = ACTIONS(971),
    [anon_sym_redo] = ACTIONS(971),
    [anon_sym_retry] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_unless] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_until] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_begin] = ACTIONS(971),
    [anon_sym_EQ_GT] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [anon_sym_defined_QMARK] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(973),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(973),
    [sym_class_variable] = ACTIONS(973),
    [sym_global_variable] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [sym_complex] = ACTIONS(973),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(971),
    [anon_sym_TRUE] = ACTIONS(971),
    [anon_sym_false] = ACTIONS(971),
    [anon_sym_FALSE] = ACTIONS(971),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(971),
    [anon_sym_NIL] = ACTIONS(971),
    [sym_character] = ACTIONS(973),
    [anon_sym_LBRACK2] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(973),
    [sym__line_break] = ACTIONS(973),
    [sym__simple_symbol] = ACTIONS(973),
    [sym__string_start] = ACTIONS(973),
    [sym__symbol_start] = ACTIONS(973),
    [sym__subshell_start] = ACTIONS(973),
    [sym__regex_start] = ACTIONS(973),
    [sym__string_array_start] = ACTIONS(973),
    [sym__symbol_array_start] = ACTIONS(973),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(973),
    [sym__block_ampersand] = ACTIONS(973),
    [sym__splat_star] = ACTIONS(973),
    [sym__unary_minus] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
    [sym__identifier_hash_key] = ACTIONS(973),
  },
  [328] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1794),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1799),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(328),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1119),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [329] = {
    [sym_heredoc_body] = STATE(329),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1027),
    [anon_sym___END__] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COLON_COLON] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_next] = ACTIONS(1027),
    [anon_sym_redo] = ACTIONS(1027),
    [anon_sym_retry] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_unless] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_until] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_begin] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1027),
    [anon_sym_or] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [anon_sym_defined_QMARK] = ACTIONS(1029),
    [anon_sym_not] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1029),
    [sym_constant] = ACTIONS(1027),
    [sym_instance_variable] = ACTIONS(1029),
    [sym_class_variable] = ACTIONS(1029),
    [sym_global_variable] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [sym_complex] = ACTIONS(1029),
    [sym_super] = ACTIONS(1027),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_TRUE] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_FALSE] = ACTIONS(1027),
    [sym_self] = ACTIONS(1027),
    [anon_sym_nil] = ACTIONS(1027),
    [anon_sym_NIL] = ACTIONS(1027),
    [sym_character] = ACTIONS(1029),
    [anon_sym_LBRACK2] = ACTIONS(1027),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [sym__line_break] = ACTIONS(1029),
    [sym__simple_symbol] = ACTIONS(1029),
    [sym__string_start] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(1029),
    [sym__subshell_start] = ACTIONS(1029),
    [sym__regex_start] = ACTIONS(1029),
    [sym__string_array_start] = ACTIONS(1029),
    [sym__symbol_array_start] = ACTIONS(1029),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1029),
    [sym__block_ampersand] = ACTIONS(1029),
    [sym__splat_star] = ACTIONS(1029),
    [sym__unary_minus] = ACTIONS(1029),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
    [sym__identifier_hash_key] = ACTIONS(1029),
  },
  [330] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1953),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(330),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym__terminator] = STATE(2285),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1123),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [331] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1994),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(331),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [332] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1763),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1795),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(332),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1167),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [333] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1950),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1945),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_right_assignment_list] = STATE(1635),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(333),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1171),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [334] = {
    [sym_heredoc_body] = STATE(334),
    [ts_builtin_sym_end] = ACTIONS(979),
    [sym_identifier] = ACTIONS(977),
    [anon_sym___END__] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_next] = ACTIONS(977),
    [anon_sym_redo] = ACTIONS(977),
    [anon_sym_retry] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_unless] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_until] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_begin] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(977),
    [anon_sym_or] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(979),
    [sym_constant] = ACTIONS(977),
    [sym_instance_variable] = ACTIONS(979),
    [sym_class_variable] = ACTIONS(979),
    [sym_global_variable] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(977),
    [sym_complex] = ACTIONS(979),
    [sym_super] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(977),
    [anon_sym_TRUE] = ACTIONS(977),
    [anon_sym_false] = ACTIONS(977),
    [anon_sym_FALSE] = ACTIONS(977),
    [sym_self] = ACTIONS(977),
    [anon_sym_nil] = ACTIONS(977),
    [anon_sym_NIL] = ACTIONS(977),
    [sym_character] = ACTIONS(979),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym__line_break] = ACTIONS(979),
    [sym__simple_symbol] = ACTIONS(979),
    [sym__string_start] = ACTIONS(979),
    [sym__symbol_start] = ACTIONS(979),
    [sym__subshell_start] = ACTIONS(979),
    [sym__regex_start] = ACTIONS(979),
    [sym__string_array_start] = ACTIONS(979),
    [sym__symbol_array_start] = ACTIONS(979),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(979),
    [sym__block_ampersand] = ACTIONS(979),
    [sym__splat_star] = ACTIONS(979),
    [sym__unary_minus] = ACTIONS(979),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
    [sym__identifier_hash_key] = ACTIONS(979),
  },
  [335] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1731),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1717),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_right_assignment_list] = STATE(1635),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(335),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1171),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [336] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_pattern] = STATE(2631),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1845),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(2599),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(336),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1173),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [337] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1298),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1288),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(337),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(815),
  },
  [338] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_splat_argument] = STATE(1765),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_right_assignment_list] = STATE(1635),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(338),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1175),
    [sym__unary_minus] = ACTIONS(905),
  },
  [339] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1887),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1835),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(339),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1167),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [340] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1286),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1284),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(340),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(805),
    [sym__unary_minus] = ACTIONS(291),
  },
  [341] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1586),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1578),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(341),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(805),
    [sym__unary_minus] = ACTIONS(291),
  },
  [342] = {
    [sym_heredoc_body] = STATE(342),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(981),
    [anon_sym___END__] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_next] = ACTIONS(981),
    [anon_sym_redo] = ACTIONS(981),
    [anon_sym_retry] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_unless] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_until] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_begin] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(983),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(983),
    [sym_constant] = ACTIONS(981),
    [sym_instance_variable] = ACTIONS(983),
    [sym_class_variable] = ACTIONS(983),
    [sym_global_variable] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(981),
    [sym_complex] = ACTIONS(983),
    [sym_super] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_TRUE] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_FALSE] = ACTIONS(981),
    [sym_self] = ACTIONS(981),
    [anon_sym_nil] = ACTIONS(981),
    [anon_sym_NIL] = ACTIONS(981),
    [sym_character] = ACTIONS(983),
    [anon_sym_LBRACK2] = ACTIONS(981),
    [anon_sym_DASH_GT] = ACTIONS(983),
    [sym__line_break] = ACTIONS(983),
    [sym__simple_symbol] = ACTIONS(983),
    [sym__string_start] = ACTIONS(983),
    [sym__symbol_start] = ACTIONS(983),
    [sym__subshell_start] = ACTIONS(983),
    [sym__regex_start] = ACTIONS(983),
    [sym__string_array_start] = ACTIONS(983),
    [sym__symbol_array_start] = ACTIONS(983),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(983),
    [sym__block_ampersand] = ACTIONS(983),
    [sym__splat_star] = ACTIONS(983),
    [sym__unary_minus] = ACTIONS(983),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
    [sym__identifier_hash_key] = ACTIONS(983),
  },
  [343] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1963),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1916),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_right_assignment_list] = STATE(1635),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(343),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1187),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [344] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1925),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(344),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1139),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [345] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1901),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1861),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_right_assignment_list] = STATE(1635),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(345),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1199),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [346] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1223),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1226),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(346),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1203),
    [sym__unary_minus] = ACTIONS(155),
  },
  [347] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1923),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(347),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym__terminator] = STATE(2301),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1123),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [348] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1746),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1718),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(348),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1205),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [349] = {
    [sym_heredoc_body] = STATE(349),
    [ts_builtin_sym_end] = ACTIONS(923),
    [sym_identifier] = ACTIONS(921),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__line_break] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [350] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1766),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1781),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(350),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1119),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [351] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_splat_argument] = STATE(1956),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_right_assignment_list] = STATE(1635),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(351),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1175),
    [sym__unary_minus] = ACTIONS(905),
  },
  [352] = {
    [sym_heredoc_body] = STATE(352),
    [ts_builtin_sym_end] = ACTIONS(997),
    [sym_identifier] = ACTIONS(995),
    [anon_sym___END__] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_next] = ACTIONS(995),
    [anon_sym_redo] = ACTIONS(995),
    [anon_sym_retry] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_unless] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_until] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_begin] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_defined_QMARK] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [sym_constant] = ACTIONS(995),
    [sym_instance_variable] = ACTIONS(997),
    [sym_class_variable] = ACTIONS(997),
    [sym_global_variable] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [sym_complex] = ACTIONS(997),
    [sym_super] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_TRUE] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_FALSE] = ACTIONS(995),
    [sym_self] = ACTIONS(995),
    [anon_sym_nil] = ACTIONS(995),
    [anon_sym_NIL] = ACTIONS(995),
    [sym_character] = ACTIONS(997),
    [anon_sym_LBRACK2] = ACTIONS(995),
    [anon_sym_DASH_GT] = ACTIONS(997),
    [sym__line_break] = ACTIONS(997),
    [sym__simple_symbol] = ACTIONS(997),
    [sym__string_start] = ACTIONS(997),
    [sym__symbol_start] = ACTIONS(997),
    [sym__subshell_start] = ACTIONS(997),
    [sym__regex_start] = ACTIONS(997),
    [sym__string_array_start] = ACTIONS(997),
    [sym__symbol_array_start] = ACTIONS(997),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(997),
    [sym__block_ampersand] = ACTIONS(997),
    [sym__splat_star] = ACTIONS(997),
    [sym__unary_minus] = ACTIONS(997),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
    [sym__identifier_hash_key] = ACTIONS(997),
  },
  [353] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1301),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1310),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(353),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(815),
  },
  [354] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1960),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1942),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_right_assignment_list] = STATE(1635),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(354),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1187),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [355] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1252),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1233),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_right_assignment_list] = STATE(1232),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(355),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [356] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1921),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(356),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym__terminator] = STATE(2287),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1123),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [357] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_pattern] = STATE(2372),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1845),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(2599),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(357),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1173),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [358] = {
    [sym_heredoc_body] = STATE(358),
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_identifier] = ACTIONS(985),
    [anon_sym___END__] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_next] = ACTIONS(985),
    [anon_sym_redo] = ACTIONS(985),
    [anon_sym_retry] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_unless] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_until] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_begin] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(985),
    [anon_sym_or] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [anon_sym_defined_QMARK] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(987),
    [sym_constant] = ACTIONS(985),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(985),
    [sym_complex] = ACTIONS(987),
    [sym_super] = ACTIONS(985),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_TRUE] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_FALSE] = ACTIONS(985),
    [sym_self] = ACTIONS(985),
    [anon_sym_nil] = ACTIONS(985),
    [anon_sym_NIL] = ACTIONS(985),
    [sym_character] = ACTIONS(987),
    [anon_sym_LBRACK2] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(987),
    [sym__line_break] = ACTIONS(987),
    [sym__simple_symbol] = ACTIONS(987),
    [sym__string_start] = ACTIONS(987),
    [sym__symbol_start] = ACTIONS(987),
    [sym__subshell_start] = ACTIONS(987),
    [sym__regex_start] = ACTIONS(987),
    [sym__string_array_start] = ACTIONS(987),
    [sym__symbol_array_start] = ACTIONS(987),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(987),
    [sym__block_ampersand] = ACTIONS(987),
    [sym__splat_star] = ACTIONS(987),
    [sym__unary_minus] = ACTIONS(987),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
    [sym__identifier_hash_key] = ACTIONS(987),
  },
  [359] = {
    [sym_heredoc_body] = STATE(359),
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_identifier] = ACTIONS(971),
    [anon_sym___END__] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_def] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_module] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_next] = ACTIONS(971),
    [anon_sym_redo] = ACTIONS(971),
    [anon_sym_retry] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_unless] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_until] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_begin] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [anon_sym_defined_QMARK] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(973),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(973),
    [sym_class_variable] = ACTIONS(973),
    [sym_global_variable] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [sym_complex] = ACTIONS(973),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(971),
    [anon_sym_TRUE] = ACTIONS(971),
    [anon_sym_false] = ACTIONS(971),
    [anon_sym_FALSE] = ACTIONS(971),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(971),
    [anon_sym_NIL] = ACTIONS(971),
    [sym_character] = ACTIONS(973),
    [anon_sym_LBRACK2] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(973),
    [sym__line_break] = ACTIONS(973),
    [sym__simple_symbol] = ACTIONS(973),
    [sym__string_start] = ACTIONS(973),
    [sym__symbol_start] = ACTIONS(973),
    [sym__subshell_start] = ACTIONS(973),
    [sym__regex_start] = ACTIONS(973),
    [sym__string_array_start] = ACTIONS(973),
    [sym__symbol_array_start] = ACTIONS(973),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(973),
    [sym__block_ampersand] = ACTIONS(973),
    [sym__splat_star] = ACTIONS(973),
    [sym__unary_minus] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
    [sym__identifier_hash_key] = ACTIONS(973),
  },
  [360] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1858),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1248),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(360),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1119),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [361] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1812),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(2503),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(361),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [362] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1686),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_splat_argument] = STATE(1700),
    [sym_assignment] = STATE(1686),
    [sym_operator_assignment] = STATE(1686),
    [sym_conditional] = STATE(1686),
    [sym_range] = STATE(1686),
    [sym_binary] = STATE(1686),
    [sym_unary] = STATE(1686),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_right_assignment_list] = STATE(1614),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(362),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(937),
  },
  [363] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1943),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1613),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(363),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1199),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [364] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1770),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1613),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(364),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1171),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [365] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1263),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1248),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(365),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [366] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1667),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_splat_argument] = STATE(1656),
    [sym_assignment] = STATE(1667),
    [sym_operator_assignment] = STATE(1667),
    [sym_conditional] = STATE(1667),
    [sym_range] = STATE(1667),
    [sym_binary] = STATE(1667),
    [sym_unary] = STATE(1667),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_right_assignment_list] = STATE(1614),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(366),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1227),
    [sym__unary_minus] = ACTIONS(331),
  },
  [367] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1896),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1248),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(367),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1167),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [368] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1907),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(368),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1139),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_do] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [369] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1231),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1248),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(369),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1203),
    [sym__unary_minus] = ACTIONS(155),
  },
  [370] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1976),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(370),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym__terminator] = STATE(2364),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1123),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [371] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_splat_argument] = STATE(1613),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(371),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1187),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [372] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1248),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(372),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(805),
    [sym__unary_minus] = ACTIONS(291),
  },
  [373] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1688),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_splat_argument] = STATE(1690),
    [sym_assignment] = STATE(1688),
    [sym_operator_assignment] = STATE(1688),
    [sym_conditional] = STATE(1688),
    [sym_range] = STATE(1688),
    [sym_binary] = STATE(1688),
    [sym_unary] = STATE(1688),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_right_assignment_list] = STATE(1614),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(373),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(937),
  },
  [374] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1599),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_splat_argument] = STATE(1594),
    [sym_assignment] = STATE(1599),
    [sym_operator_assignment] = STATE(1599),
    [sym_conditional] = STATE(1599),
    [sym_range] = STATE(1599),
    [sym_binary] = STATE(1599),
    [sym_unary] = STATE(1599),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_right_assignment_list] = STATE(1614),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(374),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1231),
    [sym__unary_minus] = ACTIONS(259),
  },
  [375] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1989),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(375),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(1139),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1139),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [376] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_splat_argument] = STATE(1248),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(376),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(815),
  },
  [377] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1849),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_splat_argument] = STATE(1613),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(377),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1175),
    [sym__unary_minus] = ACTIONS(905),
  },
  [378] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1774),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_splat_argument] = STATE(1248),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(378),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1205),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [379] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1606),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_splat_argument] = STATE(1607),
    [sym_assignment] = STATE(1606),
    [sym_operator_assignment] = STATE(1606),
    [sym_conditional] = STATE(1606),
    [sym_range] = STATE(1606),
    [sym_binary] = STATE(1606),
    [sym_unary] = STATE(1606),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_right_assignment_list] = STATE(1614),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(379),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(257),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [380] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1696),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_splat_argument] = STATE(1610),
    [sym_assignment] = STATE(1696),
    [sym_operator_assignment] = STATE(1696),
    [sym_conditional] = STATE(1696),
    [sym_range] = STATE(1696),
    [sym_binary] = STATE(1696),
    [sym_unary] = STATE(1696),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(380),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1227),
    [sym__unary_minus] = ACTIONS(331),
  },
  [381] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1649),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_splat_argument] = STATE(1610),
    [sym_assignment] = STATE(1649),
    [sym_operator_assignment] = STATE(1649),
    [sym_conditional] = STATE(1649),
    [sym_range] = STATE(1649),
    [sym_binary] = STATE(1649),
    [sym_unary] = STATE(1649),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(381),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1231),
    [sym__unary_minus] = ACTIONS(259),
  },
  [382] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1678),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_splat_argument] = STATE(1610),
    [sym_assignment] = STATE(1678),
    [sym_operator_assignment] = STATE(1678),
    [sym_conditional] = STATE(1678),
    [sym_range] = STATE(1678),
    [sym_binary] = STATE(1678),
    [sym_unary] = STATE(1678),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(382),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(257),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [383] = {
    [sym_heredoc_body] = STATE(383),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(1247),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [384] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1739),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_splat_argument] = STATE(1610),
    [sym_assignment] = STATE(1739),
    [sym_operator_assignment] = STATE(1739),
    [sym_conditional] = STATE(1739),
    [sym_range] = STATE(1739),
    [sym_binary] = STATE(1739),
    [sym_unary] = STATE(1739),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(384),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(937),
  },
  [385] = {
    [sym_heredoc_body] = STATE(385),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_def] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(921),
    [anon_sym_return] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(921),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(921),
    [anon_sym_retry] = ACTIONS(921),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_while] = ACTIONS(921),
    [anon_sym_until] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_defined_QMARK] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_constant] = ACTIONS(921),
    [sym_instance_variable] = ACTIONS(923),
    [sym_class_variable] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(921),
    [sym_float] = ACTIONS(921),
    [sym_complex] = ACTIONS(923),
    [sym_super] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(921),
    [anon_sym_TRUE] = ACTIONS(921),
    [anon_sym_false] = ACTIONS(921),
    [anon_sym_FALSE] = ACTIONS(921),
    [sym_self] = ACTIONS(921),
    [anon_sym_nil] = ACTIONS(921),
    [anon_sym_NIL] = ACTIONS(921),
    [sym_character] = ACTIONS(923),
    [anon_sym_LBRACK2] = ACTIONS(921),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [sym__simple_symbol] = ACTIONS(923),
    [sym__string_start] = ACTIONS(923),
    [sym__symbol_start] = ACTIONS(923),
    [sym__subshell_start] = ACTIONS(923),
    [sym__regex_start] = ACTIONS(923),
    [sym__string_array_start] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(923),
    [sym_heredoc_beginning] = ACTIONS(923),
    [sym__block_ampersand] = ACTIONS(923),
    [sym__splat_star] = ACTIONS(923),
    [sym__unary_minus] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [sym__identifier_hash_key] = ACTIONS(923),
  },
  [386] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(386),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [387] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1327),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(387),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [388] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1325),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(388),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [389] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1998),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(389),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [390] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2004),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(390),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [391] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1848),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(391),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [392] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1280),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(392),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [393] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1261),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(393),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [394] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1964),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(394),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [395] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2001),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(395),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [396] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1855),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(396),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [397] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1281),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(397),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [398] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2000),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(398),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [399] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(399),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [400] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1304),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(400),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [401] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1303),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(401),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [402] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1840),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(402),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [403] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1868),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(403),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [404] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2071),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(404),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [405] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1995),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(405),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [406] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(406),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [407] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1784),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(407),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [408] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1973),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(408),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [409] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1785),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(409),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [410] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1867),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(410),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [411] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1786),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(411),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [412] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1862),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(412),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [413] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(413),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [414] = {
    [sym_heredoc_body] = STATE(414),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_next] = ACTIONS(981),
    [anon_sym_redo] = ACTIONS(981),
    [anon_sym_retry] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_unless] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_until] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_begin] = ACTIONS(981),
    [anon_sym_EQ_GT] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(983),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(983),
    [sym_constant] = ACTIONS(981),
    [sym_instance_variable] = ACTIONS(983),
    [sym_class_variable] = ACTIONS(983),
    [sym_global_variable] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(981),
    [sym_complex] = ACTIONS(983),
    [sym_super] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_TRUE] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_FALSE] = ACTIONS(981),
    [sym_self] = ACTIONS(981),
    [anon_sym_nil] = ACTIONS(981),
    [anon_sym_NIL] = ACTIONS(981),
    [sym_character] = ACTIONS(983),
    [anon_sym_LBRACK2] = ACTIONS(981),
    [anon_sym_DASH_GT] = ACTIONS(983),
    [sym__simple_symbol] = ACTIONS(983),
    [sym__string_start] = ACTIONS(983),
    [sym__symbol_start] = ACTIONS(983),
    [sym__subshell_start] = ACTIONS(983),
    [sym__regex_start] = ACTIONS(983),
    [sym__string_array_start] = ACTIONS(983),
    [sym__symbol_array_start] = ACTIONS(983),
    [sym_heredoc_beginning] = ACTIONS(983),
    [sym__block_ampersand] = ACTIONS(983),
    [sym__splat_star] = ACTIONS(983),
    [sym__unary_minus] = ACTIONS(983),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
    [sym__identifier_hash_key] = ACTIONS(983),
  },
  [415] = {
    [sym_heredoc_body] = STATE(415),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_next] = ACTIONS(985),
    [anon_sym_redo] = ACTIONS(985),
    [anon_sym_retry] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_unless] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_until] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_begin] = ACTIONS(985),
    [anon_sym_EQ_GT] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(985),
    [anon_sym_or] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [anon_sym_defined_QMARK] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(987),
    [sym_constant] = ACTIONS(985),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(985),
    [sym_complex] = ACTIONS(987),
    [sym_super] = ACTIONS(985),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_TRUE] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_FALSE] = ACTIONS(985),
    [sym_self] = ACTIONS(985),
    [anon_sym_nil] = ACTIONS(985),
    [anon_sym_NIL] = ACTIONS(985),
    [sym_character] = ACTIONS(987),
    [anon_sym_LBRACK2] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(987),
    [sym__simple_symbol] = ACTIONS(987),
    [sym__string_start] = ACTIONS(987),
    [sym__symbol_start] = ACTIONS(987),
    [sym__subshell_start] = ACTIONS(987),
    [sym__regex_start] = ACTIONS(987),
    [sym__string_array_start] = ACTIONS(987),
    [sym__symbol_array_start] = ACTIONS(987),
    [sym_heredoc_beginning] = ACTIONS(987),
    [sym__block_ampersand] = ACTIONS(987),
    [sym__splat_star] = ACTIONS(987),
    [sym__unary_minus] = ACTIONS(987),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
    [sym__identifier_hash_key] = ACTIONS(987),
  },
  [416] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2005),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(416),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [417] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1974),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(417),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [418] = {
    [sym_heredoc_body] = STATE(418),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_next] = ACTIONS(995),
    [anon_sym_redo] = ACTIONS(995),
    [anon_sym_retry] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_unless] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_until] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_begin] = ACTIONS(995),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_defined_QMARK] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [sym_constant] = ACTIONS(995),
    [sym_instance_variable] = ACTIONS(997),
    [sym_class_variable] = ACTIONS(997),
    [sym_global_variable] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [sym_complex] = ACTIONS(997),
    [sym_super] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_TRUE] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_FALSE] = ACTIONS(995),
    [sym_self] = ACTIONS(995),
    [anon_sym_nil] = ACTIONS(995),
    [anon_sym_NIL] = ACTIONS(995),
    [sym_character] = ACTIONS(997),
    [anon_sym_LBRACK2] = ACTIONS(995),
    [anon_sym_DASH_GT] = ACTIONS(997),
    [sym__simple_symbol] = ACTIONS(997),
    [sym__string_start] = ACTIONS(997),
    [sym__symbol_start] = ACTIONS(997),
    [sym__subshell_start] = ACTIONS(997),
    [sym__regex_start] = ACTIONS(997),
    [sym__string_array_start] = ACTIONS(997),
    [sym__symbol_array_start] = ACTIONS(997),
    [sym_heredoc_beginning] = ACTIONS(997),
    [sym__block_ampersand] = ACTIONS(997),
    [sym__splat_star] = ACTIONS(997),
    [sym__unary_minus] = ACTIONS(997),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
    [sym__identifier_hash_key] = ACTIONS(997),
  },
  [419] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1992),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(419),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [420] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1990),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(420),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [421] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2046),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(421),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [422] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2054),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(422),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [423] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1836),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(423),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [424] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1296),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(424),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [425] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1295),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(425),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [426] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1841),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(426),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [427] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1294),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(427),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [428] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1987),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(428),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [429] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1292),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(429),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [430] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1985),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(430),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [431] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1291),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(431),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [432] = {
    [sym_heredoc_body] = STATE(432),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_def] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_module] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_next] = ACTIONS(971),
    [anon_sym_redo] = ACTIONS(971),
    [anon_sym_retry] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_unless] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_until] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_begin] = ACTIONS(971),
    [anon_sym_EQ_GT] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [anon_sym_defined_QMARK] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(973),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(973),
    [sym_class_variable] = ACTIONS(973),
    [sym_global_variable] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [sym_complex] = ACTIONS(973),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(971),
    [anon_sym_TRUE] = ACTIONS(971),
    [anon_sym_false] = ACTIONS(971),
    [anon_sym_FALSE] = ACTIONS(971),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(971),
    [anon_sym_NIL] = ACTIONS(971),
    [sym_character] = ACTIONS(973),
    [anon_sym_LBRACK2] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(973),
    [sym__simple_symbol] = ACTIONS(973),
    [sym__string_start] = ACTIONS(973),
    [sym__symbol_start] = ACTIONS(973),
    [sym__subshell_start] = ACTIONS(973),
    [sym__regex_start] = ACTIONS(973),
    [sym__string_array_start] = ACTIONS(973),
    [sym__symbol_array_start] = ACTIONS(973),
    [sym_heredoc_beginning] = ACTIONS(973),
    [sym__block_ampersand] = ACTIONS(973),
    [sym__splat_star] = ACTIONS(973),
    [sym__unary_minus] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
    [sym__identifier_hash_key] = ACTIONS(973),
  },
  [433] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1290),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(433),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [434] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1311),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(434),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [435] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1961),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(435),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [436] = {
    [sym_heredoc_body] = STATE(436),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_next] = ACTIONS(977),
    [anon_sym_redo] = ACTIONS(977),
    [anon_sym_retry] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_unless] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_until] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_begin] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(977),
    [anon_sym_or] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(979),
    [sym_constant] = ACTIONS(977),
    [sym_instance_variable] = ACTIONS(979),
    [sym_class_variable] = ACTIONS(979),
    [sym_global_variable] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(977),
    [sym_complex] = ACTIONS(979),
    [sym_super] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(977),
    [anon_sym_TRUE] = ACTIONS(977),
    [anon_sym_false] = ACTIONS(977),
    [anon_sym_FALSE] = ACTIONS(977),
    [sym_self] = ACTIONS(977),
    [anon_sym_nil] = ACTIONS(977),
    [anon_sym_NIL] = ACTIONS(977),
    [sym_character] = ACTIONS(979),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym__simple_symbol] = ACTIONS(979),
    [sym__string_start] = ACTIONS(979),
    [sym__symbol_start] = ACTIONS(979),
    [sym__subshell_start] = ACTIONS(979),
    [sym__regex_start] = ACTIONS(979),
    [sym__string_array_start] = ACTIONS(979),
    [sym__symbol_array_start] = ACTIONS(979),
    [sym_heredoc_beginning] = ACTIONS(979),
    [sym__block_ampersand] = ACTIONS(979),
    [sym__splat_star] = ACTIONS(979),
    [sym__unary_minus] = ACTIONS(979),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
    [sym__identifier_hash_key] = ACTIONS(979),
  },
  [437] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(437),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [438] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1305),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(438),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [439] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(439),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [440] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1871),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(440),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [441] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1957),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(441),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [442] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1851),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(442),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [443] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1875),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(443),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [444] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(444),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [445] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1842),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(445),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [446] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(446),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [447] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1922),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(447),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [448] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1297),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(448),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [449] = {
    [sym_heredoc_body] = STATE(449),
    [sym_identifier] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COLON_COLON] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_next] = ACTIONS(1027),
    [anon_sym_redo] = ACTIONS(1027),
    [anon_sym_retry] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_unless] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_until] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_begin] = ACTIONS(1027),
    [anon_sym_EQ_GT] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1027),
    [anon_sym_or] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [anon_sym_defined_QMARK] = ACTIONS(1029),
    [anon_sym_not] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1029),
    [sym_constant] = ACTIONS(1027),
    [sym_instance_variable] = ACTIONS(1029),
    [sym_class_variable] = ACTIONS(1029),
    [sym_global_variable] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [sym_complex] = ACTIONS(1029),
    [sym_super] = ACTIONS(1027),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_TRUE] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_FALSE] = ACTIONS(1027),
    [sym_self] = ACTIONS(1027),
    [anon_sym_nil] = ACTIONS(1027),
    [anon_sym_NIL] = ACTIONS(1027),
    [sym_character] = ACTIONS(1029),
    [anon_sym_LBRACK2] = ACTIONS(1027),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [sym__simple_symbol] = ACTIONS(1029),
    [sym__string_start] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(1029),
    [sym__subshell_start] = ACTIONS(1029),
    [sym__regex_start] = ACTIONS(1029),
    [sym__string_array_start] = ACTIONS(1029),
    [sym__symbol_array_start] = ACTIONS(1029),
    [sym_heredoc_beginning] = ACTIONS(1029),
    [sym__block_ampersand] = ACTIONS(1029),
    [sym__splat_star] = ACTIONS(1029),
    [sym__unary_minus] = ACTIONS(1029),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
    [sym__identifier_hash_key] = ACTIONS(1029),
  },
  [450] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1951),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(450),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [451] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(451),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [452] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(452),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [453] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1902),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(453),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [454] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2053),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(454),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [455] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1906),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(455),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [456] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1874),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(456),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1289),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [457] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1853),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(457),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [458] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2028),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(458),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [459] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1870),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(459),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [460] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1924),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(460),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [461] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1941),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(461),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [462] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1758),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(462),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [463] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(463),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [464] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(464),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [465] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(465),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [466] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1347),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(466),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [467] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(467),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [468] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1980),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(468),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [469] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1965),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(469),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [470] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1340),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(470),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [471] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1898),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(471),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [472] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1852),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(472),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [473] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1900),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(473),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [474] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1903),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(474),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [475] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1837),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(475),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1289),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [476] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1981),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(476),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [477] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1991),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(477),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [478] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1789),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(478),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [479] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1839),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(479),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [480] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1315),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(480),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [481] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2037),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(481),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [482] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1920),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(482),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1289),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [483] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1869),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(483),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [484] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1312),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(484),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [485] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1846),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(485),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [486] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2017),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(486),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [487] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2048),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(487),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [488] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(488),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [489] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1984),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(489),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [490] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1982),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(490),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [491] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1988),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(491),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1289),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [492] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1986),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(492),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [493] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1338),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(493),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [494] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1969),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(494),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [495] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1847),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(495),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [496] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(496),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [497] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2065),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(497),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [498] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1634),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(498),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [499] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(499),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [500] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1636),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(500),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [501] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1638),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(501),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [502] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1857),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(502),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [503] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1859),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(503),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [504] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1864),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(504),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [505] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1873),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(505),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [506] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1970),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(506),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [507] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1863),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(507),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [508] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1884),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(508),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [509] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1881),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(509),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [510] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1878),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(510),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [511] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1772),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(511),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [512] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2007),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(512),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [513] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1805),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(513),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [514] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2058),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(514),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [515] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1879),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(515),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [516] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1882),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(516),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [517] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1886),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(517),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [518] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1888),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(518),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [519] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1880),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(519),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [520] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1885),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(520),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [521] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1348),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(521),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [522] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1329),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(522),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [523] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1966),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(523),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [524] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(524),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [525] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1262),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(525),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [526] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(526),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [527] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1283),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(527),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [528] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1889),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(528),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [529] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1287),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(529),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [530] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(530),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [531] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1268),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(531),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [532] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2003),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(532),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [533] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2002),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(533),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [534] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1914),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(534),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [535] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1642),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(535),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [536] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(536),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [537] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1337),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(537),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [538] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1892),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(538),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [539] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1894),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(539),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [540] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1897),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(540),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [541] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1895),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(541),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [542] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1336),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(542),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [543] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1899),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(543),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [544] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2060),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(544),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [545] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2031),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(545),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [546] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1265),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(546),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [547] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2072),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(547),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [548] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1264),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(548),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [549] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2070),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(549),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [550] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(550),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [551] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(551),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [552] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1755),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(552),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [553] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1752),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(553),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [554] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1828),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(554),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1289),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [555] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2022),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(555),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [556] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2035),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(556),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [557] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1928),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(557),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [558] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2023),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(558),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [559] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1269),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(559),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [560] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2033),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(560),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [561] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2047),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(561),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [562] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2049),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(562),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [563] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1646),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(563),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [564] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1604),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(564),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [565] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1641),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(565),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [566] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1627),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(566),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [567] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1235),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(567),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [568] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2064),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(568),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [569] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(569),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [570] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2067),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(570),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [571] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2013),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(571),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [572] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(572),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [573] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1270),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(573),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [574] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1271),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(574),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [575] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2051),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(575),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [576] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1626),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(576),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [577] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1289),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(577),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [578] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1931),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(578),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [579] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1335),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(579),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [580] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2010),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(580),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [581] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2012),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(581),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [582] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2021),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(582),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [583] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(583),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [584] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1267),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(584),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [585] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2019),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(585),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [586] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1272),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(586),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [587] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2052),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(587),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [588] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2014),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(588),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [589] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1891),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2815),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(589),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [590] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2055),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(590),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [591] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1334),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(591),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [592] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1236),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(592),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [593] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1326),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(593),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [594] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1333),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(594),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [595] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1753),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(595),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [596] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1954),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(596),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [597] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1798),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(597),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [598] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1273),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(598),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [599] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(599),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [600] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1944),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(600),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [601] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1948),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(601),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [602] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1777),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(602),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [603] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1299),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(929),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(603),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [604] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1934),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(604),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [605] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1952),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(605),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [606] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1751),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(606),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [607] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1958),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(607),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [608] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1801),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(608),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [609] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1775),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(609),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [610] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1332),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(610),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [611] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1279),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(611),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [612] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1932),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(612),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [613] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1971),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(613),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [614] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1972),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(614),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [615] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1808),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(615),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [616] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1977),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(616),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [617] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1927),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(617),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [618] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1946),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(618),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [619] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1933),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(619),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [620] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1819),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(620),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [621] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1917),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(621),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [622] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1918),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(622),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [623] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2056),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(623),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [624] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1962),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(624),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [625] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1237),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(625),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [626] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1913),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(626),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [627] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2029),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(627),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [628] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1254),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(628),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [629] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1358),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(629),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [630] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1356),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(630),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [631] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1354),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(631),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [632] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(632),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [633] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1238),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(633),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [634] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1996),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(634),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_defined_QMARK] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1189),
  },
  [635] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(635),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [636] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1817),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(636),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [637] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1353),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(637),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [638] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1959),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(638),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [639] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1618),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(639),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [640] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1619),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(640),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [641] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1324),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(641),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [642] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1322),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(642),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [643] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1621),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(643),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [644] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1624),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(644),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [645] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1319),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(645),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [646] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1811),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(646),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [647] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1909),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(647),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [648] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1239),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(648),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [649] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1823),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(649),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [650] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2020),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(650),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [651] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1814),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(651),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [652] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1908),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(652),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [653] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1940),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(653),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [654] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1352),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(654),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [655] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1813),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(655),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [656] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2011),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(656),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [657] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2034),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(657),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [658] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1768),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(658),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [659] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2066),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(659),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [660] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(660),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [661] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2050),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(661),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [662] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2045),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(662),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [663] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2044),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(663),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [664] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1330),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(664),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [665] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1323),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(665),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [666] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(666),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [667] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1351),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(667),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [668] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1350),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(668),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [669] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1797),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(669),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [670] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1349),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(670),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [671] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(671),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [672] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1274),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(672),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [673] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1343),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(673),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [674] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2042),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(674),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [675] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1344),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(675),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [676] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(676),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [677] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1276),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(677),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [678] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2018),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(678),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [679] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2041),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(679),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [680] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(680),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [681] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2016),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1544),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(681),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [682] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1955),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(682),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [683] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1949),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(683),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [684] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1788),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(684),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [685] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(685),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [686] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1793),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(686),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [687] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2009),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(687),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [688] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1800),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(688),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [689] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1802),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(689),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [690] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1803),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(690),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [691] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1810),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(691),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [692] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1339),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(692),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [693] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1778),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(693),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [694] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2885),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(694),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [695] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2038),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(695),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [696] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1905),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2814),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(696),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [697] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1757),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(697),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [698] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(698),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [699] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1767),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(699),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [700] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1816),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(700),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [701] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1776),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(701),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [702] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1277),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(702),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [703] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2008),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(703),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [704] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1241),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(704),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [705] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1979),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(705),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [706] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1947),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(706),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [707] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1625),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(707),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [708] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2024),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(708),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [709] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2025),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(709),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [710] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2026),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(710),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [711] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2027),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(711),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [712] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(712),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [713] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2032),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(713),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [714] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(714),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [715] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2006),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(715),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [716] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2061),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(716),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [717] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2040),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(717),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [718] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(718),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [719] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2073),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(719),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [720] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1926),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(720),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [721] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1792),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2839),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(721),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1023),
  },
  [722] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1860),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2821),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1198),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(722),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1121),
  },
  [723] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1320),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(723),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [724] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1278),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2902),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(924),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(724),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_defined_QMARK] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1215),
  },
  [725] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1939),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(725),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [726] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1938),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(726),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [727] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1937),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(727),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [728] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(728),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [729] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(729),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [730] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1318),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(730),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [731] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2063),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(731),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [732] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2062),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(732),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [733] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2059),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(733),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [734] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1255),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(734),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [735] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1935),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(735),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [736] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(736),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [737] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1251),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(737),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [738] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1967),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(738),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [739] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1929),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(739),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [740] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2043),
    [sym__primary] = STATE(1663),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1220),
    [sym_scope_resolution] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_method_call] = STATE(1220),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2790),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1260),
    [sym__variable] = STATE(1000),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1220),
    [sym_false] = STATE(1220),
    [sym_nil] = STATE(1220),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(740),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [741] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1983),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(741),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [742] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(742),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [743] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1919),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(743),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [744] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1242),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1179),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(744),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [745] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1234),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(886),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(745),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [746] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1911),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(746),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [747] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1764),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2894),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1197),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(747),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_defined_QMARK] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1157),
  },
  [748] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(1912),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1219),
    [sym__variable] = STATE(1106),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(748),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_defined_QMARK] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1201),
  },
  [749] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1910),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(749),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [750] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1648),
    [sym__primary] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(902),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(902),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_nil] = STATE(902),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(750),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(1001),
    [sym_instance_variable] = ACTIONS(1017),
    [sym_class_variable] = ACTIONS(1017),
    [sym_global_variable] = ACTIONS(1017),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(1001),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [751] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1321),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2785),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(751),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_defined_QMARK] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(815),
  },
  [752] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1726),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1726),
    [sym_operator_assignment] = STATE(1726),
    [sym_conditional] = STATE(1726),
    [sym_range] = STATE(1726),
    [sym_binary] = STATE(1726),
    [sym_unary] = STATE(1726),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(752),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [753] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1779),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1779),
    [sym_operator_assignment] = STATE(1779),
    [sym_conditional] = STATE(1779),
    [sym_range] = STATE(1779),
    [sym_binary] = STATE(1779),
    [sym_unary] = STATE(1779),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(753),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [754] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1670),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1670),
    [sym_operator_assignment] = STATE(1670),
    [sym_conditional] = STATE(1670),
    [sym_range] = STATE(1670),
    [sym_binary] = STATE(1670),
    [sym_unary] = STATE(1670),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(754),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [755] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1654),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1654),
    [sym_operator_assignment] = STATE(1654),
    [sym_conditional] = STATE(1654),
    [sym_range] = STATE(1654),
    [sym_binary] = STATE(1654),
    [sym_unary] = STATE(1654),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(755),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [756] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1650),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1650),
    [sym_operator_assignment] = STATE(1650),
    [sym_conditional] = STATE(1650),
    [sym_range] = STATE(1650),
    [sym_binary] = STATE(1650),
    [sym_unary] = STATE(1650),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(756),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [757] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1736),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1736),
    [sym_operator_assignment] = STATE(1736),
    [sym_conditional] = STATE(1736),
    [sym_range] = STATE(1736),
    [sym_binary] = STATE(1736),
    [sym_unary] = STATE(1736),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(757),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [758] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1735),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1735),
    [sym_operator_assignment] = STATE(1735),
    [sym_conditional] = STATE(1735),
    [sym_range] = STATE(1735),
    [sym_binary] = STATE(1735),
    [sym_unary] = STATE(1735),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(758),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [759] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1655),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1655),
    [sym_operator_assignment] = STATE(1655),
    [sym_conditional] = STATE(1655),
    [sym_range] = STATE(1655),
    [sym_binary] = STATE(1655),
    [sym_unary] = STATE(1655),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(759),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [760] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2078),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(760),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [761] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1665),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1665),
    [sym_operator_assignment] = STATE(1665),
    [sym_conditional] = STATE(1665),
    [sym_range] = STATE(1665),
    [sym_binary] = STATE(1665),
    [sym_unary] = STATE(1665),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(761),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [762] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1727),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1727),
    [sym_operator_assignment] = STATE(1727),
    [sym_conditional] = STATE(1727),
    [sym_range] = STATE(1727),
    [sym_binary] = STATE(1727),
    [sym_unary] = STATE(1727),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(762),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [763] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(763),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [764] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1685),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1685),
    [sym_operator_assignment] = STATE(1685),
    [sym_conditional] = STATE(1685),
    [sym_range] = STATE(1685),
    [sym_binary] = STATE(1685),
    [sym_unary] = STATE(1685),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(764),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [765] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1684),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1684),
    [sym_operator_assignment] = STATE(1684),
    [sym_conditional] = STATE(1684),
    [sym_range] = STATE(1684),
    [sym_binary] = STATE(1684),
    [sym_unary] = STATE(1684),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(765),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [766] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1687),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1687),
    [sym_operator_assignment] = STATE(1687),
    [sym_conditional] = STATE(1687),
    [sym_range] = STATE(1687),
    [sym_binary] = STATE(1687),
    [sym_unary] = STATE(1687),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(766),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [767] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1722),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1722),
    [sym_operator_assignment] = STATE(1722),
    [sym_conditional] = STATE(1722),
    [sym_range] = STATE(1722),
    [sym_binary] = STATE(1722),
    [sym_unary] = STATE(1722),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(767),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [768] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1664),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1664),
    [sym_operator_assignment] = STATE(1664),
    [sym_conditional] = STATE(1664),
    [sym_range] = STATE(1664),
    [sym_binary] = STATE(1664),
    [sym_unary] = STATE(1664),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(768),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [769] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1759),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1759),
    [sym_operator_assignment] = STATE(1759),
    [sym_conditional] = STATE(1759),
    [sym_range] = STATE(1759),
    [sym_binary] = STATE(1759),
    [sym_unary] = STATE(1759),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(769),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [770] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1733),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1733),
    [sym_operator_assignment] = STATE(1733),
    [sym_conditional] = STATE(1733),
    [sym_range] = STATE(1733),
    [sym_binary] = STATE(1733),
    [sym_unary] = STATE(1733),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(770),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [771] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(771),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [772] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2080),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(772),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [773] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1732),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1732),
    [sym_operator_assignment] = STATE(1732),
    [sym_conditional] = STATE(1732),
    [sym_range] = STATE(1732),
    [sym_binary] = STATE(1732),
    [sym_unary] = STATE(1732),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(773),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [774] = {
    [sym_heredoc_body] = STATE(774),
    [sym_identifier] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COLON_COLON] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_next] = ACTIONS(1027),
    [anon_sym_redo] = ACTIONS(1027),
    [anon_sym_retry] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_unless] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_until] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_begin] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1027),
    [anon_sym_or] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [anon_sym_defined_QMARK] = ACTIONS(1029),
    [anon_sym_not] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1029),
    [sym_constant] = ACTIONS(1027),
    [sym_instance_variable] = ACTIONS(1029),
    [sym_class_variable] = ACTIONS(1029),
    [sym_global_variable] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [sym_complex] = ACTIONS(1029),
    [sym_super] = ACTIONS(1027),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_TRUE] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_FALSE] = ACTIONS(1027),
    [sym_self] = ACTIONS(1027),
    [anon_sym_nil] = ACTIONS(1027),
    [anon_sym_NIL] = ACTIONS(1027),
    [sym_character] = ACTIONS(1029),
    [anon_sym_LBRACK2] = ACTIONS(1027),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [sym__simple_symbol] = ACTIONS(1029),
    [sym__string_start] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(1029),
    [sym__subshell_start] = ACTIONS(1029),
    [sym__regex_start] = ACTIONS(1029),
    [sym__string_array_start] = ACTIONS(1029),
    [sym__symbol_array_start] = ACTIONS(1029),
    [sym_heredoc_beginning] = ACTIONS(1029),
    [sym__block_ampersand] = ACTIONS(1029),
    [sym__splat_star] = ACTIONS(1029),
    [sym__unary_minus] = ACTIONS(1029),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
    [sym__identifier_hash_key] = ACTIONS(1029),
  },
  [775] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1748),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1748),
    [sym_operator_assignment] = STATE(1748),
    [sym_conditional] = STATE(1748),
    [sym_range] = STATE(1748),
    [sym_binary] = STATE(1748),
    [sym_unary] = STATE(1748),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(775),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [776] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1865),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(776),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [777] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1659),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1659),
    [sym_operator_assignment] = STATE(1659),
    [sym_conditional] = STATE(1659),
    [sym_range] = STATE(1659),
    [sym_binary] = STATE(1659),
    [sym_unary] = STATE(1659),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(777),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [778] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1658),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1658),
    [sym_operator_assignment] = STATE(1658),
    [sym_conditional] = STATE(1658),
    [sym_range] = STATE(1658),
    [sym_binary] = STATE(1658),
    [sym_unary] = STATE(1658),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(778),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [779] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1657),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1657),
    [sym_operator_assignment] = STATE(1657),
    [sym_conditional] = STATE(1657),
    [sym_range] = STATE(1657),
    [sym_binary] = STATE(1657),
    [sym_unary] = STATE(1657),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(779),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [780] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(780),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [781] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1993),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2805),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1224),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(781),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_defined_QMARK] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1133),
  },
  [782] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2079),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2851),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1249),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1372),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(782),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [783] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1672),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1672),
    [sym_operator_assignment] = STATE(1672),
    [sym_conditional] = STATE(1672),
    [sym_range] = STATE(1672),
    [sym_binary] = STATE(1672),
    [sym_unary] = STATE(1672),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(783),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [784] = {
    [sym_heredoc_body] = STATE(784),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_next] = ACTIONS(977),
    [anon_sym_redo] = ACTIONS(977),
    [anon_sym_retry] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_unless] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_until] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_begin] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(977),
    [anon_sym_or] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(979),
    [sym_constant] = ACTIONS(977),
    [sym_instance_variable] = ACTIONS(979),
    [sym_class_variable] = ACTIONS(979),
    [sym_global_variable] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(977),
    [sym_complex] = ACTIONS(979),
    [sym_super] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(977),
    [anon_sym_TRUE] = ACTIONS(977),
    [anon_sym_false] = ACTIONS(977),
    [anon_sym_FALSE] = ACTIONS(977),
    [sym_self] = ACTIONS(977),
    [anon_sym_nil] = ACTIONS(977),
    [anon_sym_NIL] = ACTIONS(977),
    [sym_character] = ACTIONS(979),
    [anon_sym_LBRACK2] = ACTIONS(977),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym__simple_symbol] = ACTIONS(979),
    [sym__string_start] = ACTIONS(979),
    [sym__symbol_start] = ACTIONS(979),
    [sym__subshell_start] = ACTIONS(979),
    [sym__regex_start] = ACTIONS(979),
    [sym__string_array_start] = ACTIONS(979),
    [sym__symbol_array_start] = ACTIONS(979),
    [sym_heredoc_beginning] = ACTIONS(979),
    [sym__block_ampersand] = ACTIONS(979),
    [sym__splat_star] = ACTIONS(979),
    [sym__unary_minus] = ACTIONS(979),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
    [sym__identifier_hash_key] = ACTIONS(979),
  },
  [785] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1747),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1747),
    [sym_operator_assignment] = STATE(1747),
    [sym_conditional] = STATE(1747),
    [sym_range] = STATE(1747),
    [sym_binary] = STATE(1747),
    [sym_unary] = STATE(1747),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(785),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [786] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1683),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1683),
    [sym_operator_assignment] = STATE(1683),
    [sym_conditional] = STATE(1683),
    [sym_range] = STATE(1683),
    [sym_binary] = STATE(1683),
    [sym_unary] = STATE(1683),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(786),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [787] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1703),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1703),
    [sym_operator_assignment] = STATE(1703),
    [sym_conditional] = STATE(1703),
    [sym_range] = STATE(1703),
    [sym_binary] = STATE(1703),
    [sym_unary] = STATE(1703),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(787),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [788] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1704),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1704),
    [sym_operator_assignment] = STATE(1704),
    [sym_conditional] = STATE(1704),
    [sym_range] = STATE(1704),
    [sym_binary] = STATE(1704),
    [sym_unary] = STATE(1704),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(788),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [789] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1706),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1706),
    [sym_operator_assignment] = STATE(1706),
    [sym_conditional] = STATE(1706),
    [sym_range] = STATE(1706),
    [sym_binary] = STATE(1706),
    [sym_unary] = STATE(1706),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(789),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [790] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1707),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1707),
    [sym_operator_assignment] = STATE(1707),
    [sym_conditional] = STATE(1707),
    [sym_range] = STATE(1707),
    [sym_binary] = STATE(1707),
    [sym_unary] = STATE(1707),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(790),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [791] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1708),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1708),
    [sym_operator_assignment] = STATE(1708),
    [sym_conditional] = STATE(1708),
    [sym_range] = STATE(1708),
    [sym_binary] = STATE(1708),
    [sym_unary] = STATE(1708),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(791),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [792] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1710),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1710),
    [sym_operator_assignment] = STATE(1710),
    [sym_conditional] = STATE(1710),
    [sym_range] = STATE(1710),
    [sym_binary] = STATE(1710),
    [sym_unary] = STATE(1710),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(792),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [793] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1711),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1711),
    [sym_operator_assignment] = STATE(1711),
    [sym_conditional] = STATE(1711),
    [sym_range] = STATE(1711),
    [sym_binary] = STATE(1711),
    [sym_unary] = STATE(1711),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(793),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [794] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1712),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1712),
    [sym_operator_assignment] = STATE(1712),
    [sym_conditional] = STATE(1712),
    [sym_range] = STATE(1712),
    [sym_binary] = STATE(1712),
    [sym_unary] = STATE(1712),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(794),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [795] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(795),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [796] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1716),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1716),
    [sym_operator_assignment] = STATE(1716),
    [sym_conditional] = STATE(1716),
    [sym_range] = STATE(1716),
    [sym_binary] = STATE(1716),
    [sym_unary] = STATE(1716),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(796),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [797] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1676),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1676),
    [sym_operator_assignment] = STATE(1676),
    [sym_conditional] = STATE(1676),
    [sym_range] = STATE(1676),
    [sym_binary] = STATE(1676),
    [sym_unary] = STATE(1676),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(797),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [798] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1829),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1829),
    [sym_operator_assignment] = STATE(1829),
    [sym_conditional] = STATE(1829),
    [sym_range] = STATE(1829),
    [sym_binary] = STATE(1829),
    [sym_unary] = STATE(1829),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(798),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [799] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1728),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1728),
    [sym_operator_assignment] = STATE(1728),
    [sym_conditional] = STATE(1728),
    [sym_range] = STATE(1728),
    [sym_binary] = STATE(1728),
    [sym_unary] = STATE(1728),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(799),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [800] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1760),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1760),
    [sym_operator_assignment] = STATE(1760),
    [sym_conditional] = STATE(1760),
    [sym_range] = STATE(1760),
    [sym_binary] = STATE(1760),
    [sym_unary] = STATE(1760),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(800),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [801] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(801),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [802] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1617),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1617),
    [sym_operator_assignment] = STATE(1617),
    [sym_conditional] = STATE(1617),
    [sym_range] = STATE(1617),
    [sym_binary] = STATE(1617),
    [sym_unary] = STATE(1617),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(802),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [803] = {
    [sym_heredoc_body] = STATE(803),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_def] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_module] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_next] = ACTIONS(971),
    [anon_sym_redo] = ACTIONS(971),
    [anon_sym_retry] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_unless] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_until] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_begin] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [anon_sym_defined_QMARK] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(973),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(973),
    [sym_class_variable] = ACTIONS(973),
    [sym_global_variable] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [sym_complex] = ACTIONS(973),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(971),
    [anon_sym_TRUE] = ACTIONS(971),
    [anon_sym_false] = ACTIONS(971),
    [anon_sym_FALSE] = ACTIONS(971),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(971),
    [anon_sym_NIL] = ACTIONS(971),
    [sym_character] = ACTIONS(973),
    [anon_sym_LBRACK2] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(973),
    [sym__simple_symbol] = ACTIONS(973),
    [sym__string_start] = ACTIONS(973),
    [sym__symbol_start] = ACTIONS(973),
    [sym__subshell_start] = ACTIONS(973),
    [sym__regex_start] = ACTIONS(973),
    [sym__string_array_start] = ACTIONS(973),
    [sym__symbol_array_start] = ACTIONS(973),
    [sym_heredoc_beginning] = ACTIONS(973),
    [sym__block_ampersand] = ACTIONS(973),
    [sym__splat_star] = ACTIONS(973),
    [sym__unary_minus] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
    [sym__identifier_hash_key] = ACTIONS(973),
  },
  [804] = {
    [sym_heredoc_body] = STATE(804),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_next] = ACTIONS(981),
    [anon_sym_redo] = ACTIONS(981),
    [anon_sym_retry] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_unless] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_until] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_begin] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(983),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(983),
    [sym_constant] = ACTIONS(981),
    [sym_instance_variable] = ACTIONS(983),
    [sym_class_variable] = ACTIONS(983),
    [sym_global_variable] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(981),
    [sym_complex] = ACTIONS(983),
    [sym_super] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_TRUE] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_FALSE] = ACTIONS(981),
    [sym_self] = ACTIONS(981),
    [anon_sym_nil] = ACTIONS(981),
    [anon_sym_NIL] = ACTIONS(981),
    [sym_character] = ACTIONS(983),
    [anon_sym_LBRACK2] = ACTIONS(981),
    [anon_sym_DASH_GT] = ACTIONS(983),
    [sym__simple_symbol] = ACTIONS(983),
    [sym__string_start] = ACTIONS(983),
    [sym__symbol_start] = ACTIONS(983),
    [sym__subshell_start] = ACTIONS(983),
    [sym__regex_start] = ACTIONS(983),
    [sym__string_array_start] = ACTIONS(983),
    [sym__symbol_array_start] = ACTIONS(983),
    [sym_heredoc_beginning] = ACTIONS(983),
    [sym__block_ampersand] = ACTIONS(983),
    [sym__splat_star] = ACTIONS(983),
    [sym__unary_minus] = ACTIONS(983),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
    [sym__identifier_hash_key] = ACTIONS(983),
  },
  [805] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1609),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1505),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1609),
    [sym_operator_assignment] = STATE(1609),
    [sym_conditional] = STATE(1609),
    [sym_range] = STATE(1609),
    [sym_binary] = STATE(1609),
    [sym_unary] = STATE(1609),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(805),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [806] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1671),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1671),
    [sym_operator_assignment] = STATE(1671),
    [sym_conditional] = STATE(1671),
    [sym_range] = STATE(1671),
    [sym_binary] = STATE(1671),
    [sym_unary] = STATE(1671),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(806),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [807] = {
    [sym_heredoc_body] = STATE(807),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_next] = ACTIONS(985),
    [anon_sym_redo] = ACTIONS(985),
    [anon_sym_retry] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_unless] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_until] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_begin] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(985),
    [anon_sym_or] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [anon_sym_defined_QMARK] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(987),
    [sym_constant] = ACTIONS(985),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(985),
    [sym_complex] = ACTIONS(987),
    [sym_super] = ACTIONS(985),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_TRUE] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_FALSE] = ACTIONS(985),
    [sym_self] = ACTIONS(985),
    [anon_sym_nil] = ACTIONS(985),
    [anon_sym_NIL] = ACTIONS(985),
    [sym_character] = ACTIONS(987),
    [anon_sym_LBRACK2] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(987),
    [sym__simple_symbol] = ACTIONS(987),
    [sym__string_start] = ACTIONS(987),
    [sym__symbol_start] = ACTIONS(987),
    [sym__subshell_start] = ACTIONS(987),
    [sym__regex_start] = ACTIONS(987),
    [sym__string_array_start] = ACTIONS(987),
    [sym__symbol_array_start] = ACTIONS(987),
    [sym_heredoc_beginning] = ACTIONS(987),
    [sym__block_ampersand] = ACTIONS(987),
    [sym__splat_star] = ACTIONS(987),
    [sym__unary_minus] = ACTIONS(987),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
    [sym__identifier_hash_key] = ACTIONS(987),
  },
  [808] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1713),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1713),
    [sym_operator_assignment] = STATE(1713),
    [sym_conditional] = STATE(1713),
    [sym_range] = STATE(1713),
    [sym_binary] = STATE(1713),
    [sym_unary] = STATE(1713),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(808),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [809] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1633),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1633),
    [sym_operator_assignment] = STATE(1633),
    [sym_conditional] = STATE(1633),
    [sym_range] = STATE(1633),
    [sym_binary] = STATE(1633),
    [sym_unary] = STATE(1633),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(809),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [810] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1662),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1662),
    [sym_operator_assignment] = STATE(1662),
    [sym_conditional] = STATE(1662),
    [sym_range] = STATE(1662),
    [sym_binary] = STATE(1662),
    [sym_unary] = STATE(1662),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(810),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [811] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1652),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1652),
    [sym_operator_assignment] = STATE(1652),
    [sym_conditional] = STATE(1652),
    [sym_range] = STATE(1652),
    [sym_binary] = STATE(1652),
    [sym_unary] = STATE(1652),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(811),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [812] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1653),
    [sym_operator_assignment] = STATE(1653),
    [sym_conditional] = STATE(1653),
    [sym_range] = STATE(1653),
    [sym_binary] = STATE(1653),
    [sym_unary] = STATE(1653),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(812),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [813] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1681),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1681),
    [sym_operator_assignment] = STATE(1681),
    [sym_conditional] = STATE(1681),
    [sym_range] = STATE(1681),
    [sym_binary] = STATE(1681),
    [sym_unary] = STATE(1681),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(813),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [814] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1611),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1611),
    [sym_operator_assignment] = STATE(1611),
    [sym_conditional] = STATE(1611),
    [sym_range] = STATE(1611),
    [sym_binary] = STATE(1611),
    [sym_unary] = STATE(1611),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(814),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [815] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1729),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1729),
    [sym_operator_assignment] = STATE(1729),
    [sym_conditional] = STATE(1729),
    [sym_range] = STATE(1729),
    [sym_binary] = STATE(1729),
    [sym_unary] = STATE(1729),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(815),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [816] = {
    [sym_method] = STATE(1100),
    [sym_singleton_method] = STATE(1100),
    [sym_class] = STATE(1100),
    [sym_singleton_class] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_return] = STATE(1100),
    [sym_yield] = STATE(1100),
    [sym_break] = STATE(1100),
    [sym_next] = STATE(1100),
    [sym_redo] = STATE(1100),
    [sym_retry] = STATE(1100),
    [sym_while] = STATE(1100),
    [sym_until] = STATE(1100),
    [sym_for] = STATE(1100),
    [sym_case] = STATE(1100),
    [sym_if] = STATE(1100),
    [sym_unless] = STATE(1100),
    [sym_begin] = STATE(1100),
    [sym__arg] = STATE(1866),
    [sym__primary] = STATE(1195),
    [sym_parenthesized_statements] = STATE(1100),
    [sym_element_reference] = STATE(949),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(949),
    [sym_assignment] = STATE(1243),
    [sym_operator_assignment] = STATE(1243),
    [sym_conditional] = STATE(1243),
    [sym_range] = STATE(1243),
    [sym_binary] = STATE(1243),
    [sym_unary] = STATE(1243),
    [sym_parenthesized_unary] = STATE(1100),
    [sym_unary_literal] = STATE(1100),
    [sym_left_assignment_list] = STATE(2841),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1199),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1100),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_nil] = STATE(949),
    [sym_chained_string] = STATE(1100),
    [sym_string] = STATE(998),
    [sym_subshell] = STATE(1100),
    [sym_string_array] = STATE(1100),
    [sym_symbol_array] = STATE(1100),
    [sym_symbol] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_heredoc_body] = STATE(816),
    [sym_array] = STATE(1100),
    [sym_hash] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_defined_QMARK] = ACTIONS(1281),
    [anon_sym_not] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1287),
  },
  [817] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1689),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1689),
    [sym_operator_assignment] = STATE(1689),
    [sym_conditional] = STATE(1689),
    [sym_range] = STATE(1689),
    [sym_binary] = STATE(1689),
    [sym_unary] = STATE(1689),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(817),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [818] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1742),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1742),
    [sym_operator_assignment] = STATE(1742),
    [sym_conditional] = STATE(1742),
    [sym_range] = STATE(1742),
    [sym_binary] = STATE(1742),
    [sym_unary] = STATE(1742),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(818),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [819] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(819),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [820] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(820),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [821] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2076),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(821),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [822] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1674),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1674),
    [sym_operator_assignment] = STATE(1674),
    [sym_conditional] = STATE(1674),
    [sym_range] = STATE(1674),
    [sym_binary] = STATE(1674),
    [sym_unary] = STATE(1674),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(822),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [823] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1698),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1052),
    [sym_scope_resolution] = STATE(974),
    [sym_call] = STATE(974),
    [sym_method_call] = STATE(1052),
    [sym_assignment] = STATE(1698),
    [sym_operator_assignment] = STATE(1698),
    [sym_conditional] = STATE(1698),
    [sym_range] = STATE(1698),
    [sym_binary] = STATE(1698),
    [sym_unary] = STATE(1698),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1052),
    [sym__variable] = STATE(974),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1052),
    [sym_false] = STATE(1052),
    [sym_nil] = STATE(1052),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(823),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [824] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1651),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(824),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [825] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1616),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1616),
    [sym_operator_assignment] = STATE(1616),
    [sym_conditional] = STATE(1616),
    [sym_range] = STATE(1616),
    [sym_binary] = STATE(1616),
    [sym_unary] = STATE(1616),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(825),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [826] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1668),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1668),
    [sym_operator_assignment] = STATE(1668),
    [sym_conditional] = STATE(1668),
    [sym_range] = STATE(1668),
    [sym_binary] = STATE(1668),
    [sym_unary] = STATE(1668),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(826),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [827] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1719),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1719),
    [sym_operator_assignment] = STATE(1719),
    [sym_conditional] = STATE(1719),
    [sym_range] = STATE(1719),
    [sym_binary] = STATE(1719),
    [sym_unary] = STATE(1719),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(827),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [828] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1629),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1629),
    [sym_operator_assignment] = STATE(1629),
    [sym_conditional] = STATE(1629),
    [sym_range] = STATE(1629),
    [sym_binary] = STATE(1629),
    [sym_unary] = STATE(1629),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(828),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [829] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1680),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1680),
    [sym_operator_assignment] = STATE(1680),
    [sym_conditional] = STATE(1680),
    [sym_range] = STATE(1680),
    [sym_binary] = STATE(1680),
    [sym_unary] = STATE(1680),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(829),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [830] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(830),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [831] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1631),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1631),
    [sym_operator_assignment] = STATE(1631),
    [sym_conditional] = STATE(1631),
    [sym_range] = STATE(1631),
    [sym_binary] = STATE(1631),
    [sym_unary] = STATE(1631),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(831),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [832] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1791),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1791),
    [sym_operator_assignment] = STATE(1791),
    [sym_conditional] = STATE(1791),
    [sym_range] = STATE(1791),
    [sym_binary] = STATE(1791),
    [sym_unary] = STATE(1791),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(832),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [833] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1723),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1723),
    [sym_operator_assignment] = STATE(1723),
    [sym_conditional] = STATE(1723),
    [sym_range] = STATE(1723),
    [sym_binary] = STATE(1723),
    [sym_unary] = STATE(1723),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(833),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [834] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1637),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1637),
    [sym_operator_assignment] = STATE(1637),
    [sym_conditional] = STATE(1637),
    [sym_range] = STATE(1637),
    [sym_binary] = STATE(1637),
    [sym_unary] = STATE(1637),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(834),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [835] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1744),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1744),
    [sym_operator_assignment] = STATE(1744),
    [sym_conditional] = STATE(1744),
    [sym_range] = STATE(1744),
    [sym_binary] = STATE(1744),
    [sym_unary] = STATE(1744),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(835),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [836] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1737),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1737),
    [sym_operator_assignment] = STATE(1737),
    [sym_conditional] = STATE(1737),
    [sym_range] = STATE(1737),
    [sym_binary] = STATE(1737),
    [sym_unary] = STATE(1737),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(836),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [837] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1640),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(837),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [838] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2077),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(838),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [839] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1743),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1743),
    [sym_operator_assignment] = STATE(1743),
    [sym_conditional] = STATE(1743),
    [sym_range] = STATE(1743),
    [sym_binary] = STATE(1743),
    [sym_unary] = STATE(1743),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(839),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [840] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1820),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1820),
    [sym_operator_assignment] = STATE(1820),
    [sym_conditional] = STATE(1820),
    [sym_range] = STATE(1820),
    [sym_binary] = STATE(1820),
    [sym_unary] = STATE(1820),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(840),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [841] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1826),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1826),
    [sym_operator_assignment] = STATE(1826),
    [sym_conditional] = STATE(1826),
    [sym_range] = STATE(1826),
    [sym_binary] = STATE(1826),
    [sym_unary] = STATE(1826),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(841),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [842] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1827),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1827),
    [sym_operator_assignment] = STATE(1827),
    [sym_conditional] = STATE(1827),
    [sym_range] = STATE(1827),
    [sym_binary] = STATE(1827),
    [sym_unary] = STATE(1827),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(842),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [843] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1833),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1833),
    [sym_operator_assignment] = STATE(1833),
    [sym_conditional] = STATE(1833),
    [sym_range] = STATE(1833),
    [sym_binary] = STATE(1833),
    [sym_unary] = STATE(1833),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(843),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [844] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1834),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1834),
    [sym_operator_assignment] = STATE(1834),
    [sym_conditional] = STATE(1834),
    [sym_range] = STATE(1834),
    [sym_binary] = STATE(1834),
    [sym_unary] = STATE(1834),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(844),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [845] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1831),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1831),
    [sym_operator_assignment] = STATE(1831),
    [sym_conditional] = STATE(1831),
    [sym_range] = STATE(1831),
    [sym_binary] = STATE(1831),
    [sym_unary] = STATE(1831),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(845),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [846] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1824),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1824),
    [sym_operator_assignment] = STATE(1824),
    [sym_conditional] = STATE(1824),
    [sym_range] = STATE(1824),
    [sym_binary] = STATE(1824),
    [sym_unary] = STATE(1824),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(846),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [847] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1822),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1822),
    [sym_operator_assignment] = STATE(1822),
    [sym_conditional] = STATE(1822),
    [sym_range] = STATE(1822),
    [sym_binary] = STATE(1822),
    [sym_unary] = STATE(1822),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(847),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [848] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1821),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1821),
    [sym_operator_assignment] = STATE(1821),
    [sym_conditional] = STATE(1821),
    [sym_range] = STATE(1821),
    [sym_binary] = STATE(1821),
    [sym_unary] = STATE(1821),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(848),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [849] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1818),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1097),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1097),
    [sym_assignment] = STATE(1818),
    [sym_operator_assignment] = STATE(1818),
    [sym_conditional] = STATE(1818),
    [sym_range] = STATE(1818),
    [sym_binary] = STATE(1818),
    [sym_unary] = STATE(1818),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2950),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1097),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1097),
    [sym_false] = STATE(1097),
    [sym_nil] = STATE(1097),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(849),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [850] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1720),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1720),
    [sym_operator_assignment] = STATE(1720),
    [sym_conditional] = STATE(1720),
    [sym_range] = STATE(1720),
    [sym_binary] = STATE(1720),
    [sym_unary] = STATE(1720),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(850),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [851] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1673),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1673),
    [sym_operator_assignment] = STATE(1673),
    [sym_conditional] = STATE(1673),
    [sym_range] = STATE(1673),
    [sym_binary] = STATE(1673),
    [sym_unary] = STATE(1673),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(851),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [852] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1666),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1666),
    [sym_operator_assignment] = STATE(1666),
    [sym_conditional] = STATE(1666),
    [sym_range] = STATE(1666),
    [sym_binary] = STATE(1666),
    [sym_unary] = STATE(1666),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(852),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [853] = {
    [sym_heredoc_body] = STATE(853),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_next] = ACTIONS(995),
    [anon_sym_redo] = ACTIONS(995),
    [anon_sym_retry] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_unless] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_until] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_begin] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_defined_QMARK] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [sym_constant] = ACTIONS(995),
    [sym_instance_variable] = ACTIONS(997),
    [sym_class_variable] = ACTIONS(997),
    [sym_global_variable] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [sym_complex] = ACTIONS(997),
    [sym_super] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_TRUE] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_FALSE] = ACTIONS(995),
    [sym_self] = ACTIONS(995),
    [anon_sym_nil] = ACTIONS(995),
    [anon_sym_NIL] = ACTIONS(995),
    [sym_character] = ACTIONS(997),
    [anon_sym_LBRACK2] = ACTIONS(995),
    [anon_sym_DASH_GT] = ACTIONS(997),
    [sym__simple_symbol] = ACTIONS(997),
    [sym__string_start] = ACTIONS(997),
    [sym__symbol_start] = ACTIONS(997),
    [sym__subshell_start] = ACTIONS(997),
    [sym__regex_start] = ACTIONS(997),
    [sym__string_array_start] = ACTIONS(997),
    [sym__symbol_array_start] = ACTIONS(997),
    [sym_heredoc_beginning] = ACTIONS(997),
    [sym__block_ampersand] = ACTIONS(997),
    [sym__splat_star] = ACTIONS(997),
    [sym__unary_minus] = ACTIONS(997),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
    [sym__identifier_hash_key] = ACTIONS(997),
  },
  [854] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1661),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1010),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1010),
    [sym_assignment] = STATE(1661),
    [sym_operator_assignment] = STATE(1661),
    [sym_conditional] = STATE(1661),
    [sym_range] = STATE(1661),
    [sym_binary] = STATE(1661),
    [sym_unary] = STATE(1661),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2944),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1010),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_nil] = STATE(1010),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(854),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_defined_QMARK] = ACTIONS(1237),
    [anon_sym_not] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [sym_constant] = ACTIONS(1233),
    [sym_instance_variable] = ACTIONS(1243),
    [sym_class_variable] = ACTIONS(1243),
    [sym_global_variable] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1233),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1245),
  },
  [855] = {
    [sym_method] = STATE(1573),
    [sym_singleton_method] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_singleton_class] = STATE(1573),
    [sym_module] = STATE(1573),
    [sym_return] = STATE(1573),
    [sym_yield] = STATE(1573),
    [sym_break] = STATE(1573),
    [sym_next] = STATE(1573),
    [sym_redo] = STATE(1573),
    [sym_retry] = STATE(1573),
    [sym_while] = STATE(1573),
    [sym_until] = STATE(1573),
    [sym_for] = STATE(1573),
    [sym_case] = STATE(1573),
    [sym_if] = STATE(1573),
    [sym_unless] = STATE(1573),
    [sym_begin] = STATE(1573),
    [sym__arg] = STATE(1721),
    [sym__primary] = STATE(1573),
    [sym_parenthesized_statements] = STATE(1573),
    [sym_element_reference] = STATE(1180),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1180),
    [sym_assignment] = STATE(1721),
    [sym_operator_assignment] = STATE(1721),
    [sym_conditional] = STATE(1721),
    [sym_range] = STATE(1721),
    [sym_binary] = STATE(1721),
    [sym_unary] = STATE(1721),
    [sym_parenthesized_unary] = STATE(1573),
    [sym_unary_literal] = STATE(1573),
    [sym_left_assignment_list] = STATE(2958),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1180),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1573),
    [sym_true] = STATE(1180),
    [sym_false] = STATE(1180),
    [sym_nil] = STATE(1180),
    [sym_chained_string] = STATE(1573),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1573),
    [sym_string_array] = STATE(1573),
    [sym_symbol_array] = STATE(1573),
    [sym_symbol] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_heredoc_body] = STATE(855),
    [sym_array] = STATE(1573),
    [sym_hash] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [anon_sym_not] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(937),
  },
  [856] = {
    [sym_method] = STATE(1558),
    [sym_singleton_method] = STATE(1558),
    [sym_class] = STATE(1558),
    [sym_singleton_class] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_return] = STATE(1558),
    [sym_yield] = STATE(1558),
    [sym_break] = STATE(1558),
    [sym_next] = STATE(1558),
    [sym_redo] = STATE(1558),
    [sym_retry] = STATE(1558),
    [sym_while] = STATE(1558),
    [sym_until] = STATE(1558),
    [sym_for] = STATE(1558),
    [sym_case] = STATE(1558),
    [sym_if] = STATE(1558),
    [sym_unless] = STATE(1558),
    [sym_begin] = STATE(1558),
    [sym__arg] = STATE(2075),
    [sym__primary] = STATE(1571),
    [sym_parenthesized_statements] = STATE(1558),
    [sym_element_reference] = STATE(1082),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1082),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1558),
    [sym_unary_literal] = STATE(1558),
    [sym_left_assignment_list] = STATE(2830),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1253),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1558),
    [sym_true] = STATE(1082),
    [sym_false] = STATE(1082),
    [sym_nil] = STATE(1082),
    [sym_chained_string] = STATE(1558),
    [sym_string] = STATE(1603),
    [sym_subshell] = STATE(1558),
    [sym_string_array] = STATE(1558),
    [sym_symbol_array] = STATE(1558),
    [sym_symbol] = STATE(1558),
    [sym_regex] = STATE(1558),
    [sym_heredoc_body] = STATE(856),
    [sym_array] = STATE(1558),
    [sym_hash] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_next] = ACTIONS(837),
    [anon_sym_redo] = ACTIONS(839),
    [anon_sym_retry] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_unless] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1135),
    [sym_instance_variable] = ACTIONS(1149),
    [sym_class_variable] = ACTIONS(1149),
    [sym_global_variable] = ACTIONS(1149),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_TRUE] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_FALSE] = ACTIONS(1153),
    [sym_self] = ACTIONS(1135),
    [anon_sym_nil] = ACTIONS(1155),
    [anon_sym_NIL] = ACTIONS(1155),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1185),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [857] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1647),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1647),
    [sym_operator_assignment] = STATE(1647),
    [sym_conditional] = STATE(1647),
    [sym_range] = STATE(1647),
    [sym_binary] = STATE(1647),
    [sym_unary] = STATE(1647),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(857),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [858] = {
    [sym_method] = STATE(1526),
    [sym_singleton_method] = STATE(1526),
    [sym_class] = STATE(1526),
    [sym_singleton_class] = STATE(1526),
    [sym_module] = STATE(1526),
    [sym_return] = STATE(1526),
    [sym_yield] = STATE(1526),
    [sym_break] = STATE(1526),
    [sym_next] = STATE(1526),
    [sym_redo] = STATE(1526),
    [sym_retry] = STATE(1526),
    [sym_while] = STATE(1526),
    [sym_until] = STATE(1526),
    [sym_for] = STATE(1526),
    [sym_case] = STATE(1526),
    [sym_if] = STATE(1526),
    [sym_unless] = STATE(1526),
    [sym_begin] = STATE(1526),
    [sym__arg] = STATE(1643),
    [sym__primary] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1526),
    [sym_element_reference] = STATE(1003),
    [sym_scope_resolution] = STATE(977),
    [sym_call] = STATE(977),
    [sym_method_call] = STATE(1003),
    [sym_assignment] = STATE(1643),
    [sym_operator_assignment] = STATE(1643),
    [sym_conditional] = STATE(1643),
    [sym_range] = STATE(1643),
    [sym_binary] = STATE(1643),
    [sym_unary] = STATE(1643),
    [sym_parenthesized_unary] = STATE(1526),
    [sym_unary_literal] = STATE(1526),
    [sym_left_assignment_list] = STATE(2943),
    [sym__mlhs] = STATE(2840),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(1003),
    [sym__variable] = STATE(977),
    [sym_rational] = STATE(1526),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_nil] = STATE(1003),
    [sym_chained_string] = STATE(1526),
    [sym_string] = STATE(1362),
    [sym_subshell] = STATE(1526),
    [sym_string_array] = STATE(1526),
    [sym_symbol_array] = STATE(1526),
    [sym_symbol] = STATE(1526),
    [sym_regex] = STATE(1526),
    [sym_heredoc_body] = STATE(858),
    [sym_array] = STATE(1526),
    [sym_hash] = STATE(1526),
    [sym_lambda] = STATE(1526),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_begin] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(213),
    [anon_sym_not] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(231),
    [anon_sym_TRUE] = ACTIONS(231),
    [anon_sym_false] = ACTIONS(233),
    [anon_sym_FALSE] = ACTIONS(233),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(235),
    [anon_sym_NIL] = ACTIONS(235),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [sym__simple_symbol] = ACTIONS(241),
    [sym__string_start] = ACTIONS(243),
    [sym__symbol_start] = ACTIONS(245),
    [sym__subshell_start] = ACTIONS(247),
    [sym__regex_start] = ACTIONS(249),
    [sym__string_array_start] = ACTIONS(251),
    [sym__symbol_array_start] = ACTIONS(253),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(259),
  },
  [859] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym_destructured_left_assignment] = STATE(2586),
    [sym_rest_assignment] = STATE(2586),
    [sym__lhs] = STATE(2271),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(859),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [860] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym_destructured_left_assignment] = STATE(2586),
    [sym_rest_assignment] = STATE(2586),
    [sym__lhs] = STATE(2271),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(860),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(1379),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [861] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__mlhs] = STATE(2767),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(861),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [862] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__mlhs] = STATE(2771),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(862),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [863] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2286),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(863),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_COMMA] = ACTIONS(1385),
    [anon_sym_EQ] = ACTIONS(1385),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1387),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [864] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__mlhs] = STATE(2748),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(864),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [865] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__mlhs] = STATE(2922),
    [sym_destructured_left_assignment] = STATE(2509),
    [sym_rest_assignment] = STATE(2509),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(865),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [866] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2594),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2162),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym_destructured_left_assignment] = STATE(2586),
    [sym_rest_assignment] = STATE(2586),
    [sym__lhs] = STATE(2271),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(866),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [867] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2145),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(867),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1391),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1393),
  },
  [868] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2147),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(868),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1397),
  },
  [869] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2152),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(869),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1401),
  },
  [870] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2158),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(870),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1403),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [871] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2161),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(871),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1405),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1407),
  },
  [872] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2155),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(872),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1409),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [873] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2160),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(873),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [874] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2558),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2367),
    [sym_scope_resolution] = STATE(2167),
    [sym_call] = STATE(2167),
    [sym_method_call] = STATE(2367),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2320),
    [sym__variable] = STATE(2167),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2367),
    [sym_false] = STATE(2367),
    [sym_nil] = STATE(2367),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(874),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1415),
    [sym_class_variable] = ACTIONS(1415),
    [sym_global_variable] = ACTIONS(1415),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1417),
    [anon_sym_TRUE] = ACTIONS(1417),
    [anon_sym_false] = ACTIONS(1419),
    [anon_sym_FALSE] = ACTIONS(1419),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1421),
    [anon_sym_NIL] = ACTIONS(1421),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [875] = {
    [sym_method] = STATE(2550),
    [sym_singleton_method] = STATE(2550),
    [sym_class] = STATE(2550),
    [sym_singleton_class] = STATE(2550),
    [sym_module] = STATE(2550),
    [sym_return] = STATE(2550),
    [sym_yield] = STATE(2550),
    [sym_break] = STATE(2550),
    [sym_next] = STATE(2550),
    [sym_redo] = STATE(2550),
    [sym_retry] = STATE(2550),
    [sym_while] = STATE(2550),
    [sym_until] = STATE(2550),
    [sym_for] = STATE(2550),
    [sym_case] = STATE(2550),
    [sym_if] = STATE(2550),
    [sym_unless] = STATE(2550),
    [sym_begin] = STATE(2550),
    [sym__primary] = STATE(2601),
    [sym_parenthesized_statements] = STATE(2550),
    [sym_element_reference] = STATE(2263),
    [sym_scope_resolution] = STATE(2163),
    [sym_call] = STATE(2162),
    [sym_method_call] = STATE(2263),
    [sym_parenthesized_unary] = STATE(2550),
    [sym_unary_literal] = STATE(2550),
    [sym__lhs] = STATE(2550),
    [sym__variable] = STATE(2162),
    [sym_rational] = STATE(2550),
    [sym_true] = STATE(2263),
    [sym_false] = STATE(2263),
    [sym_nil] = STATE(2263),
    [sym_chained_string] = STATE(2550),
    [sym_string] = STATE(2384),
    [sym_subshell] = STATE(2550),
    [sym_string_array] = STATE(2550),
    [sym_symbol_array] = STATE(2550),
    [sym_symbol] = STATE(2550),
    [sym_regex] = STATE(2550),
    [sym_heredoc_body] = STATE(875),
    [sym_array] = STATE(2550),
    [sym_hash] = STATE(2550),
    [sym_lambda] = STATE(2550),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1423),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [876] = {
    [sym_argument_list] = STATE(881),
    [sym_do_block] = STATE(919),
    [sym_block] = STATE(917),
    [sym_heredoc_body] = STATE(876),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [877] = {
    [sym_argument_list] = STATE(883),
    [sym_do_block] = STATE(919),
    [sym_block] = STATE(917),
    [sym_heredoc_body] = STATE(877),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [878] = {
    [sym_argument_list] = STATE(885),
    [sym_do_block] = STATE(937),
    [sym_block] = STATE(939),
    [sym_heredoc_body] = STATE(878),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [879] = {
    [sym_argument_list] = STATE(884),
    [sym_do_block] = STATE(937),
    [sym_block] = STATE(939),
    [sym_heredoc_body] = STATE(879),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(1431),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [880] = {
    [sym_heredoc_body] = STATE(880),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
  },
  [881] = {
    [sym_do_block] = STATE(899),
    [sym_block] = STATE(906),
    [sym_heredoc_body] = STATE(881),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [882] = {
    [sym_heredoc_body] = STATE(882),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
  },
  [883] = {
    [sym_do_block] = STATE(899),
    [sym_block] = STATE(906),
    [sym_heredoc_body] = STATE(883),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [884] = {
    [sym_do_block] = STATE(945),
    [sym_block] = STATE(944),
    [sym_heredoc_body] = STATE(884),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1431),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [885] = {
    [sym_do_block] = STATE(945),
    [sym_block] = STATE(944),
    [sym_heredoc_body] = STATE(885),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [886] = {
    [sym_heredoc_body] = STATE(886),
    [aux_sym__mlhs_repeat1] = STATE(2545),
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym___END__] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_EQ_GT] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_COLON_COLON2] = ACTIONS(1437),
    [anon_sym_AMP_DOT] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1443),
    [anon_sym_DASH_EQ] = ACTIONS(1443),
    [anon_sym_STAR_EQ] = ACTIONS(1443),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1443),
    [anon_sym_SLASH_EQ] = ACTIONS(1443),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1443),
    [anon_sym_PIPE_EQ] = ACTIONS(1443),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1443),
    [anon_sym_AMP_EQ] = ACTIONS(1443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1443),
    [anon_sym_CARET_EQ] = ACTIONS(1443),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_LT_EQ_GT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_BANG_TILDE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1437),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1437),
    [sym__binary_star] = ACTIONS(1437),
  },
  [887] = {
    [sym_heredoc_body] = STATE(887),
    [ts_builtin_sym_end] = ACTIONS(997),
    [anon_sym___END__] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(997),
    [anon_sym_elsif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(997),
    [anon_sym_ensure] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(997),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
  },
  [888] = {
    [sym_heredoc_body] = STATE(888),
    [ts_builtin_sym_end] = ACTIONS(973),
    [anon_sym___END__] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_end] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_unless] = ACTIONS(973),
    [anon_sym_while] = ACTIONS(973),
    [anon_sym_until] = ACTIONS(973),
    [anon_sym_rescue] = ACTIONS(973),
    [anon_sym_do] = ACTIONS(973),
    [anon_sym_when] = ACTIONS(973),
    [anon_sym_elsif] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_then] = ACTIONS(973),
    [anon_sym_ensure] = ACTIONS(973),
    [anon_sym_EQ_GT] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(973),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(973),
    [anon_sym_or] = ACTIONS(973),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(973),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
  },
  [889] = {
    [sym_heredoc_body] = STATE(889),
    [ts_builtin_sym_end] = ACTIONS(979),
    [anon_sym___END__] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_RPAREN] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_end] = ACTIONS(979),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_unless] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_until] = ACTIONS(979),
    [anon_sym_rescue] = ACTIONS(979),
    [anon_sym_do] = ACTIONS(979),
    [anon_sym_when] = ACTIONS(979),
    [anon_sym_elsif] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_then] = ACTIONS(979),
    [anon_sym_ensure] = ACTIONS(979),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(979),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(979),
    [anon_sym_or] = ACTIONS(979),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(979),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
  },
  [890] = {
    [sym_heredoc_body] = STATE(890),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
  },
  [891] = {
    [sym_heredoc_body] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [anon_sym___END__] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_end] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_unless] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_until] = ACTIONS(1029),
    [anon_sym_rescue] = ACTIONS(1029),
    [anon_sym_do] = ACTIONS(1029),
    [anon_sym_when] = ACTIONS(1029),
    [anon_sym_elsif] = ACTIONS(1029),
    [anon_sym_else] = ACTIONS(1029),
    [anon_sym_then] = ACTIONS(1029),
    [anon_sym_ensure] = ACTIONS(1029),
    [anon_sym_EQ_GT] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1029),
    [anon_sym_or] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1029),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
  },
  [892] = {
    [sym_heredoc_body] = STATE(892),
    [ts_builtin_sym_end] = ACTIONS(983),
    [anon_sym___END__] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_end] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_unless] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_until] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(983),
    [anon_sym_do] = ACTIONS(983),
    [anon_sym_when] = ACTIONS(983),
    [anon_sym_elsif] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(983),
    [anon_sym_then] = ACTIONS(983),
    [anon_sym_ensure] = ACTIONS(983),
    [anon_sym_EQ_GT] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(983),
    [anon_sym_or] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(983),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
  },
  [893] = {
    [sym_heredoc_body] = STATE(893),
    [ts_builtin_sym_end] = ACTIONS(987),
    [anon_sym___END__] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_end] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_unless] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_until] = ACTIONS(987),
    [anon_sym_rescue] = ACTIONS(987),
    [anon_sym_do] = ACTIONS(987),
    [anon_sym_when] = ACTIONS(987),
    [anon_sym_elsif] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_then] = ACTIONS(987),
    [anon_sym_ensure] = ACTIONS(987),
    [anon_sym_EQ_GT] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(987),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
  },
  [894] = {
    [sym_heredoc_body] = STATE(894),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_BEGIN] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_END] = ACTIONS(1445),
    [anon_sym_def] = ACTIONS(1445),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_RPAREN] = ACTIONS(1447),
    [anon_sym_COLON_COLON] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_end] = ACTIONS(1445),
    [anon_sym_return] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1445),
    [anon_sym_break] = ACTIONS(1445),
    [anon_sym_next] = ACTIONS(1445),
    [anon_sym_redo] = ACTIONS(1445),
    [anon_sym_retry] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_unless] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1445),
    [anon_sym_until] = ACTIONS(1445),
    [anon_sym_rescue] = ACTIONS(1445),
    [anon_sym_for] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_when] = ACTIONS(1445),
    [anon_sym_elsif] = ACTIONS(1445),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_then] = ACTIONS(1445),
    [anon_sym_begin] = ACTIONS(1445),
    [anon_sym_ensure] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_defined_QMARK] = ACTIONS(1447),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [sym_constant] = ACTIONS(1445),
    [sym_instance_variable] = ACTIONS(1447),
    [sym_class_variable] = ACTIONS(1447),
    [sym_global_variable] = ACTIONS(1447),
    [anon_sym_undef] = ACTIONS(1445),
    [anon_sym_alias] = ACTIONS(1445),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1445),
    [sym_float] = ACTIONS(1445),
    [sym_complex] = ACTIONS(1447),
    [sym_super] = ACTIONS(1445),
    [anon_sym_true] = ACTIONS(1445),
    [anon_sym_TRUE] = ACTIONS(1445),
    [anon_sym_false] = ACTIONS(1445),
    [anon_sym_FALSE] = ACTIONS(1445),
    [sym_self] = ACTIONS(1445),
    [anon_sym_nil] = ACTIONS(1445),
    [anon_sym_NIL] = ACTIONS(1445),
    [sym_character] = ACTIONS(1447),
    [anon_sym_LBRACK2] = ACTIONS(1447),
    [anon_sym_DASH_GT] = ACTIONS(1447),
    [sym__simple_symbol] = ACTIONS(1447),
    [sym__string_start] = ACTIONS(1447),
    [sym__symbol_start] = ACTIONS(1447),
    [sym__subshell_start] = ACTIONS(1447),
    [sym__regex_start] = ACTIONS(1447),
    [sym__string_array_start] = ACTIONS(1447),
    [sym__symbol_array_start] = ACTIONS(1447),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1447),
    [sym__unary_minus] = ACTIONS(1447),
  },
  [895] = {
    [sym_heredoc_body] = STATE(895),
    [ts_builtin_sym_end] = ACTIONS(1449),
    [anon_sym___END__] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_STAR_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_unless] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_until] = ACTIONS(1449),
    [anon_sym_rescue] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_when] = ACTIONS(1449),
    [anon_sym_elsif] = ACTIONS(1449),
    [anon_sym_else] = ACTIONS(1449),
    [anon_sym_then] = ACTIONS(1449),
    [anon_sym_ensure] = ACTIONS(1449),
    [anon_sym_EQ_GT] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_COLON_COLON2] = ACTIONS(1449),
    [anon_sym_AMP_DOT] = ACTIONS(1449),
    [anon_sym_PLUS_EQ] = ACTIONS(1449),
    [anon_sym_DASH_EQ] = ACTIONS(1449),
    [anon_sym_STAR_EQ] = ACTIONS(1449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1449),
    [anon_sym_SLASH_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1449),
    [anon_sym_AMP_EQ] = ACTIONS(1449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1449),
    [anon_sym_CARET_EQ] = ACTIONS(1449),
    [anon_sym_QMARK] = ACTIONS(1449),
    [anon_sym_DOT_DOT] = ACTIONS(1451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1449),
    [anon_sym_and] = ACTIONS(1449),
    [anon_sym_or] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_LT_EQ_GT] = ACTIONS(1449),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [anon_sym_BANG_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1449),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1449),
    [sym__binary_star] = ACTIONS(1449),
  },
  [896] = {
    [sym_heredoc_body] = STATE(896),
    [ts_builtin_sym_end] = ACTIONS(1453),
    [anon_sym___END__] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_DOT] = ACTIONS(1455),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_EQ] = ACTIONS(1455),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_end] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_unless] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_until] = ACTIONS(1453),
    [anon_sym_rescue] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_when] = ACTIONS(1453),
    [anon_sym_elsif] = ACTIONS(1453),
    [anon_sym_else] = ACTIONS(1453),
    [anon_sym_then] = ACTIONS(1453),
    [anon_sym_ensure] = ACTIONS(1453),
    [anon_sym_EQ_GT] = ACTIONS(1453),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_COLON_COLON2] = ACTIONS(1453),
    [anon_sym_AMP_DOT] = ACTIONS(1453),
    [anon_sym_PLUS_EQ] = ACTIONS(1453),
    [anon_sym_DASH_EQ] = ACTIONS(1453),
    [anon_sym_STAR_EQ] = ACTIONS(1453),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1453),
    [anon_sym_SLASH_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1453),
    [anon_sym_AMP_EQ] = ACTIONS(1453),
    [anon_sym_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_GT_GT_EQ] = ACTIONS(1453),
    [anon_sym_LT_LT_EQ] = ACTIONS(1453),
    [anon_sym_CARET_EQ] = ACTIONS(1453),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1453),
    [anon_sym_and] = ACTIONS(1453),
    [anon_sym_or] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1455),
    [anon_sym_AMP_AMP] = ACTIONS(1455),
    [anon_sym_LT_LT] = ACTIONS(1455),
    [anon_sym_GT_GT] = ACTIONS(1455),
    [anon_sym_LT_EQ] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1455),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_CARET] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1455),
    [anon_sym_EQ_EQ] = ACTIONS(1455),
    [anon_sym_BANG_EQ] = ACTIONS(1453),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1453),
    [anon_sym_LT_EQ_GT] = ACTIONS(1453),
    [anon_sym_EQ_TILDE] = ACTIONS(1453),
    [anon_sym_BANG_TILDE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1453),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__binary_star] = ACTIONS(1453),
  },
  [897] = {
    [sym_heredoc_body] = STATE(897),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym___END__] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_unless] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_until] = ACTIONS(1457),
    [anon_sym_rescue] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_when] = ACTIONS(1457),
    [anon_sym_elsif] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_then] = ACTIONS(1457),
    [anon_sym_ensure] = ACTIONS(1457),
    [anon_sym_EQ_GT] = ACTIONS(1457),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON_COLON2] = ACTIONS(1457),
    [anon_sym_AMP_DOT] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1457),
    [anon_sym_LT_EQ_GT] = ACTIONS(1457),
    [anon_sym_EQ_TILDE] = ACTIONS(1457),
    [anon_sym_BANG_TILDE] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1457),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1457),
    [sym__binary_star] = ACTIONS(1457),
  },
  [898] = {
    [sym_heredoc_body] = STATE(898),
    [ts_builtin_sym_end] = ACTIONS(973),
    [anon_sym___END__] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_end] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_unless] = ACTIONS(973),
    [anon_sym_while] = ACTIONS(973),
    [anon_sym_until] = ACTIONS(973),
    [anon_sym_rescue] = ACTIONS(973),
    [anon_sym_do] = ACTIONS(973),
    [anon_sym_when] = ACTIONS(973),
    [anon_sym_elsif] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_then] = ACTIONS(973),
    [anon_sym_ensure] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_COLON_COLON2] = ACTIONS(973),
    [anon_sym_AMP_DOT] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(973),
    [anon_sym_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(973),
    [anon_sym_or] = ACTIONS(973),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_LT_EQ_GT] = ACTIONS(973),
    [anon_sym_EQ_TILDE] = ACTIONS(973),
    [anon_sym_BANG_TILDE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(973),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(973),
    [sym__binary_star] = ACTIONS(973),
  },
  [899] = {
    [sym_heredoc_body] = STATE(899),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_EQ_GT] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [900] = {
    [sym_heredoc_body] = STATE(900),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym___END__] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1465),
    [anon_sym_RBRACE] = ACTIONS(1465),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_DOT] = ACTIONS(1467),
    [anon_sym_COMMA] = ACTIONS(1465),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1465),
    [anon_sym_STAR_STAR] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1467),
    [anon_sym_end] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_unless] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_until] = ACTIONS(1465),
    [anon_sym_rescue] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_when] = ACTIONS(1465),
    [anon_sym_elsif] = ACTIONS(1465),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_then] = ACTIONS(1465),
    [anon_sym_ensure] = ACTIONS(1465),
    [anon_sym_EQ_GT] = ACTIONS(1465),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_COLON_COLON2] = ACTIONS(1465),
    [anon_sym_AMP_DOT] = ACTIONS(1465),
    [anon_sym_PLUS_EQ] = ACTIONS(1465),
    [anon_sym_DASH_EQ] = ACTIONS(1465),
    [anon_sym_STAR_EQ] = ACTIONS(1465),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1465),
    [anon_sym_SLASH_EQ] = ACTIONS(1465),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1465),
    [anon_sym_PIPE_EQ] = ACTIONS(1465),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1465),
    [anon_sym_AMP_EQ] = ACTIONS(1465),
    [anon_sym_PERCENT_EQ] = ACTIONS(1465),
    [anon_sym_GT_GT_EQ] = ACTIONS(1465),
    [anon_sym_LT_LT_EQ] = ACTIONS(1465),
    [anon_sym_CARET_EQ] = ACTIONS(1465),
    [anon_sym_QMARK] = ACTIONS(1465),
    [anon_sym_DOT_DOT] = ACTIONS(1467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1465),
    [anon_sym_and] = ACTIONS(1465),
    [anon_sym_or] = ACTIONS(1465),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_LT_LT] = ACTIONS(1467),
    [anon_sym_GT_GT] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1465),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_SLASH] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(1467),
    [anon_sym_EQ_EQ] = ACTIONS(1467),
    [anon_sym_BANG_EQ] = ACTIONS(1465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1465),
    [anon_sym_LT_EQ_GT] = ACTIONS(1465),
    [anon_sym_EQ_TILDE] = ACTIONS(1465),
    [anon_sym_BANG_TILDE] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1465),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__binary_star] = ACTIONS(1465),
  },
  [901] = {
    [sym_heredoc_body] = STATE(901),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym___END__] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_unless] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_until] = ACTIONS(1457),
    [anon_sym_rescue] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_when] = ACTIONS(1457),
    [anon_sym_elsif] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_then] = ACTIONS(1457),
    [anon_sym_ensure] = ACTIONS(1457),
    [anon_sym_EQ_GT] = ACTIONS(1457),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON_COLON2] = ACTIONS(1457),
    [anon_sym_AMP_DOT] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1457),
    [anon_sym_LT_EQ_GT] = ACTIONS(1457),
    [anon_sym_EQ_TILDE] = ACTIONS(1457),
    [anon_sym_BANG_TILDE] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1457),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1457),
    [sym__binary_star] = ACTIONS(1457),
  },
  [902] = {
    [sym_heredoc_body] = STATE(902),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [903] = {
    [sym_heredoc_body] = STATE(903),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
  },
  [904] = {
    [sym_heredoc_body] = STATE(904),
    [ts_builtin_sym_end] = ACTIONS(983),
    [anon_sym___END__] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_end] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_unless] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_until] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(983),
    [anon_sym_do] = ACTIONS(983),
    [anon_sym_when] = ACTIONS(983),
    [anon_sym_elsif] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(983),
    [anon_sym_then] = ACTIONS(983),
    [anon_sym_ensure] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_COLON_COLON2] = ACTIONS(983),
    [anon_sym_AMP_DOT] = ACTIONS(983),
    [anon_sym_LPAREN2] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(983),
    [anon_sym_or] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ_GT] = ACTIONS(983),
    [anon_sym_EQ_TILDE] = ACTIONS(983),
    [anon_sym_BANG_TILDE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(983),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(983),
    [sym__binary_star] = ACTIONS(983),
  },
  [905] = {
    [sym_heredoc_body] = STATE(905),
    [ts_builtin_sym_end] = ACTIONS(979),
    [anon_sym___END__] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_RPAREN] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_end] = ACTIONS(979),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_unless] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_until] = ACTIONS(979),
    [anon_sym_rescue] = ACTIONS(979),
    [anon_sym_do] = ACTIONS(979),
    [anon_sym_when] = ACTIONS(979),
    [anon_sym_elsif] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_then] = ACTIONS(979),
    [anon_sym_ensure] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_COLON_COLON2] = ACTIONS(979),
    [anon_sym_AMP_DOT] = ACTIONS(979),
    [anon_sym_LPAREN2] = ACTIONS(979),
    [anon_sym_PLUS_EQ] = ACTIONS(979),
    [anon_sym_DASH_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(979),
    [anon_sym_SLASH_EQ] = ACTIONS(979),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(979),
    [anon_sym_PIPE_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(979),
    [anon_sym_AMP_EQ] = ACTIONS(979),
    [anon_sym_PERCENT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT_EQ] = ACTIONS(979),
    [anon_sym_LT_LT_EQ] = ACTIONS(979),
    [anon_sym_CARET_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(979),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(979),
    [anon_sym_or] = ACTIONS(979),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ_GT] = ACTIONS(979),
    [anon_sym_EQ_TILDE] = ACTIONS(979),
    [anon_sym_BANG_TILDE] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(979),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(979),
    [sym__binary_star] = ACTIONS(979),
  },
  [906] = {
    [sym_heredoc_body] = STATE(906),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_EQ_GT] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [907] = {
    [sym_heredoc_body] = STATE(907),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [anon_sym___END__] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_end] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_unless] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_until] = ACTIONS(1029),
    [anon_sym_rescue] = ACTIONS(1029),
    [anon_sym_do] = ACTIONS(1029),
    [anon_sym_when] = ACTIONS(1029),
    [anon_sym_elsif] = ACTIONS(1029),
    [anon_sym_else] = ACTIONS(1029),
    [anon_sym_then] = ACTIONS(1029),
    [anon_sym_ensure] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_COLON_COLON2] = ACTIONS(1029),
    [anon_sym_AMP_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN2] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1029),
    [anon_sym_or] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ_GT] = ACTIONS(1029),
    [anon_sym_EQ_TILDE] = ACTIONS(1029),
    [anon_sym_BANG_TILDE] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1029),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1029),
    [sym__binary_star] = ACTIONS(1029),
  },
  [908] = {
    [sym_heredoc_body] = STATE(908),
    [ts_builtin_sym_end] = ACTIONS(1469),
    [anon_sym___END__] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1469),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_DOT] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_STAR_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_end] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_unless] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_until] = ACTIONS(1469),
    [anon_sym_rescue] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_when] = ACTIONS(1469),
    [anon_sym_elsif] = ACTIONS(1469),
    [anon_sym_else] = ACTIONS(1469),
    [anon_sym_then] = ACTIONS(1469),
    [anon_sym_ensure] = ACTIONS(1469),
    [anon_sym_EQ_GT] = ACTIONS(1469),
    [anon_sym_LBRACK] = ACTIONS(1469),
    [anon_sym_COLON_COLON2] = ACTIONS(1469),
    [anon_sym_AMP_DOT] = ACTIONS(1469),
    [anon_sym_PLUS_EQ] = ACTIONS(1469),
    [anon_sym_DASH_EQ] = ACTIONS(1469),
    [anon_sym_STAR_EQ] = ACTIONS(1469),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1469),
    [anon_sym_SLASH_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1469),
    [anon_sym_AMP_EQ] = ACTIONS(1469),
    [anon_sym_PERCENT_EQ] = ACTIONS(1469),
    [anon_sym_GT_GT_EQ] = ACTIONS(1469),
    [anon_sym_LT_LT_EQ] = ACTIONS(1469),
    [anon_sym_CARET_EQ] = ACTIONS(1469),
    [anon_sym_QMARK] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1469),
    [anon_sym_or] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(1471),
    [anon_sym_LT_EQ] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_EQ] = ACTIONS(1469),
    [anon_sym_CARET] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_SLASH] = ACTIONS(1471),
    [anon_sym_PERCENT] = ACTIONS(1471),
    [anon_sym_EQ_EQ] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1469),
    [anon_sym_LT_EQ_GT] = ACTIONS(1469),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_BANG_TILDE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1469),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1469),
    [sym__binary_star] = ACTIONS(1469),
  },
  [909] = {
    [sym_heredoc_body] = STATE(909),
    [ts_builtin_sym_end] = ACTIONS(1473),
    [anon_sym___END__] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_end] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_unless] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_until] = ACTIONS(1473),
    [anon_sym_rescue] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_when] = ACTIONS(1473),
    [anon_sym_elsif] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_then] = ACTIONS(1473),
    [anon_sym_ensure] = ACTIONS(1473),
    [anon_sym_EQ_GT] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1473),
    [anon_sym_COLON_COLON2] = ACTIONS(1473),
    [anon_sym_AMP_DOT] = ACTIONS(1473),
    [anon_sym_PLUS_EQ] = ACTIONS(1473),
    [anon_sym_DASH_EQ] = ACTIONS(1473),
    [anon_sym_STAR_EQ] = ACTIONS(1473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1473),
    [anon_sym_SLASH_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1473),
    [anon_sym_AMP_EQ] = ACTIONS(1473),
    [anon_sym_PERCENT_EQ] = ACTIONS(1473),
    [anon_sym_GT_GT_EQ] = ACTIONS(1473),
    [anon_sym_LT_LT_EQ] = ACTIONS(1473),
    [anon_sym_CARET_EQ] = ACTIONS(1473),
    [anon_sym_QMARK] = ACTIONS(1473),
    [anon_sym_DOT_DOT] = ACTIONS(1475),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1473),
    [anon_sym_or] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1473),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1473),
    [anon_sym_LT_EQ_GT] = ACTIONS(1473),
    [anon_sym_EQ_TILDE] = ACTIONS(1473),
    [anon_sym_BANG_TILDE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1473),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1473),
    [sym__binary_star] = ACTIONS(1473),
  },
  [910] = {
    [sym_heredoc_body] = STATE(910),
    [ts_builtin_sym_end] = ACTIONS(1477),
    [anon_sym___END__] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_unless] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_until] = ACTIONS(1477),
    [anon_sym_rescue] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_elsif] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1477),
    [anon_sym_ensure] = ACTIONS(1477),
    [anon_sym_EQ_GT] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1477),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_DOT_DOT] = ACTIONS(1479),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1477),
    [anon_sym_or] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1479),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1479),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ_GT] = ACTIONS(1477),
    [anon_sym_EQ_TILDE] = ACTIONS(1477),
    [anon_sym_BANG_TILDE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1477),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(1477),
  },
  [911] = {
    [sym_heredoc_body] = STATE(911),
    [ts_builtin_sym_end] = ACTIONS(1481),
    [anon_sym___END__] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_DOT] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_STAR_STAR] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1483),
    [anon_sym_end] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1481),
    [anon_sym_unless] = ACTIONS(1481),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_until] = ACTIONS(1481),
    [anon_sym_rescue] = ACTIONS(1481),
    [anon_sym_do] = ACTIONS(1481),
    [anon_sym_when] = ACTIONS(1481),
    [anon_sym_elsif] = ACTIONS(1481),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_then] = ACTIONS(1481),
    [anon_sym_ensure] = ACTIONS(1481),
    [anon_sym_EQ_GT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_COLON_COLON2] = ACTIONS(1481),
    [anon_sym_AMP_DOT] = ACTIONS(1481),
    [anon_sym_PLUS_EQ] = ACTIONS(1481),
    [anon_sym_DASH_EQ] = ACTIONS(1481),
    [anon_sym_STAR_EQ] = ACTIONS(1481),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1481),
    [anon_sym_SLASH_EQ] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1481),
    [anon_sym_PIPE_EQ] = ACTIONS(1481),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1481),
    [anon_sym_AMP_EQ] = ACTIONS(1481),
    [anon_sym_PERCENT_EQ] = ACTIONS(1481),
    [anon_sym_GT_GT_EQ] = ACTIONS(1481),
    [anon_sym_LT_LT_EQ] = ACTIONS(1481),
    [anon_sym_CARET_EQ] = ACTIONS(1481),
    [anon_sym_QMARK] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_and] = ACTIONS(1481),
    [anon_sym_or] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_LT_LT] = ACTIONS(1483),
    [anon_sym_GT_GT] = ACTIONS(1483),
    [anon_sym_LT_EQ] = ACTIONS(1483),
    [anon_sym_GT] = ACTIONS(1483),
    [anon_sym_GT_EQ] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(1483),
    [anon_sym_PERCENT] = ACTIONS(1483),
    [anon_sym_EQ_EQ] = ACTIONS(1483),
    [anon_sym_BANG_EQ] = ACTIONS(1481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1481),
    [anon_sym_LT_EQ_GT] = ACTIONS(1481),
    [anon_sym_EQ_TILDE] = ACTIONS(1481),
    [anon_sym_BANG_TILDE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1481),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1481),
    [sym__binary_star] = ACTIONS(1481),
  },
  [912] = {
    [sym_heredoc_body] = STATE(912),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym___END__] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_unless] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_until] = ACTIONS(1457),
    [anon_sym_rescue] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1485),
    [anon_sym_when] = ACTIONS(1457),
    [anon_sym_elsif] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_then] = ACTIONS(1457),
    [anon_sym_ensure] = ACTIONS(1457),
    [anon_sym_EQ_GT] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON_COLON2] = ACTIONS(1457),
    [anon_sym_AMP_DOT] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1457),
    [anon_sym_LT_EQ_GT] = ACTIONS(1457),
    [anon_sym_EQ_TILDE] = ACTIONS(1457),
    [anon_sym_BANG_TILDE] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1457),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1457),
    [sym__binary_star] = ACTIONS(1457),
  },
  [913] = {
    [sym_heredoc_body] = STATE(913),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym___END__] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_unless] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_until] = ACTIONS(1457),
    [anon_sym_rescue] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1485),
    [anon_sym_when] = ACTIONS(1457),
    [anon_sym_elsif] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_then] = ACTIONS(1457),
    [anon_sym_ensure] = ACTIONS(1457),
    [anon_sym_EQ_GT] = ACTIONS(1457),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON_COLON2] = ACTIONS(1457),
    [anon_sym_AMP_DOT] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1457),
    [anon_sym_LT_EQ_GT] = ACTIONS(1457),
    [anon_sym_EQ_TILDE] = ACTIONS(1457),
    [anon_sym_BANG_TILDE] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1457),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1457),
    [sym__binary_star] = ACTIONS(1457),
  },
  [914] = {
    [sym_heredoc_body] = STATE(914),
    [ts_builtin_sym_end] = ACTIONS(1487),
    [anon_sym___END__] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_STAR_STAR] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_end] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_unless] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_until] = ACTIONS(1487),
    [anon_sym_rescue] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1487),
    [anon_sym_elsif] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_then] = ACTIONS(1487),
    [anon_sym_ensure] = ACTIONS(1487),
    [anon_sym_EQ_GT] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_COLON_COLON2] = ACTIONS(1487),
    [anon_sym_AMP_DOT] = ACTIONS(1487),
    [anon_sym_PLUS_EQ] = ACTIONS(1487),
    [anon_sym_DASH_EQ] = ACTIONS(1487),
    [anon_sym_STAR_EQ] = ACTIONS(1487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1487),
    [anon_sym_SLASH_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1487),
    [anon_sym_AMP_EQ] = ACTIONS(1487),
    [anon_sym_PERCENT_EQ] = ACTIONS(1487),
    [anon_sym_GT_GT_EQ] = ACTIONS(1487),
    [anon_sym_LT_LT_EQ] = ACTIONS(1487),
    [anon_sym_CARET_EQ] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1487),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1487),
    [anon_sym_and] = ACTIONS(1487),
    [anon_sym_or] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE] = ACTIONS(1489),
    [anon_sym_AMP_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1489),
    [anon_sym_GT_GT] = ACTIONS(1489),
    [anon_sym_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(1489),
    [anon_sym_GT_EQ] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_SLASH] = ACTIONS(1489),
    [anon_sym_PERCENT] = ACTIONS(1489),
    [anon_sym_EQ_EQ] = ACTIONS(1489),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1487),
    [anon_sym_LT_EQ_GT] = ACTIONS(1487),
    [anon_sym_EQ_TILDE] = ACTIONS(1487),
    [anon_sym_BANG_TILDE] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1487),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1487),
    [sym__binary_star] = ACTIONS(1487),
  },
  [915] = {
    [sym_heredoc_body] = STATE(915),
    [ts_builtin_sym_end] = ACTIONS(1491),
    [anon_sym___END__] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(1491),
    [anon_sym_DOT] = ACTIONS(1493),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1493),
    [anon_sym_EQ] = ACTIONS(1493),
    [anon_sym_LT] = ACTIONS(1493),
    [anon_sym_end] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1491),
    [anon_sym_unless] = ACTIONS(1491),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_until] = ACTIONS(1491),
    [anon_sym_rescue] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1491),
    [anon_sym_when] = ACTIONS(1491),
    [anon_sym_elsif] = ACTIONS(1491),
    [anon_sym_else] = ACTIONS(1491),
    [anon_sym_then] = ACTIONS(1491),
    [anon_sym_ensure] = ACTIONS(1491),
    [anon_sym_EQ_GT] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_COLON_COLON2] = ACTIONS(1491),
    [anon_sym_AMP_DOT] = ACTIONS(1491),
    [anon_sym_PLUS_EQ] = ACTIONS(1491),
    [anon_sym_DASH_EQ] = ACTIONS(1491),
    [anon_sym_STAR_EQ] = ACTIONS(1491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1491),
    [anon_sym_SLASH_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1491),
    [anon_sym_AMP_EQ] = ACTIONS(1491),
    [anon_sym_PERCENT_EQ] = ACTIONS(1491),
    [anon_sym_GT_GT_EQ] = ACTIONS(1491),
    [anon_sym_LT_LT_EQ] = ACTIONS(1491),
    [anon_sym_CARET_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1491),
    [anon_sym_DOT_DOT] = ACTIONS(1493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1491),
    [anon_sym_and] = ACTIONS(1491),
    [anon_sym_or] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1493),
    [anon_sym_AMP_AMP] = ACTIONS(1493),
    [anon_sym_LT_LT] = ACTIONS(1493),
    [anon_sym_GT_GT] = ACTIONS(1493),
    [anon_sym_LT_EQ] = ACTIONS(1493),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_CARET] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1493),
    [anon_sym_PERCENT] = ACTIONS(1493),
    [anon_sym_EQ_EQ] = ACTIONS(1493),
    [anon_sym_BANG_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_LT_EQ_GT] = ACTIONS(1491),
    [anon_sym_EQ_TILDE] = ACTIONS(1491),
    [anon_sym_BANG_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1491),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1491),
    [sym__binary_star] = ACTIONS(1491),
  },
  [916] = {
    [sym_heredoc_body] = STATE(916),
    [ts_builtin_sym_end] = ACTIONS(1495),
    [anon_sym___END__] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_RBRACE] = ACTIONS(1495),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_DOT] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_STAR_STAR] = ACTIONS(1497),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_EQ] = ACTIONS(1497),
    [anon_sym_LT] = ACTIONS(1497),
    [anon_sym_end] = ACTIONS(1495),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_unless] = ACTIONS(1495),
    [anon_sym_while] = ACTIONS(1495),
    [anon_sym_until] = ACTIONS(1495),
    [anon_sym_rescue] = ACTIONS(1495),
    [anon_sym_do] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(1495),
    [anon_sym_elsif] = ACTIONS(1495),
    [anon_sym_else] = ACTIONS(1495),
    [anon_sym_then] = ACTIONS(1495),
    [anon_sym_ensure] = ACTIONS(1495),
    [anon_sym_EQ_GT] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1495),
    [anon_sym_COLON_COLON2] = ACTIONS(1495),
    [anon_sym_AMP_DOT] = ACTIONS(1495),
    [anon_sym_PLUS_EQ] = ACTIONS(1495),
    [anon_sym_DASH_EQ] = ACTIONS(1495),
    [anon_sym_STAR_EQ] = ACTIONS(1495),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1495),
    [anon_sym_SLASH_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1495),
    [anon_sym_AMP_EQ] = ACTIONS(1495),
    [anon_sym_PERCENT_EQ] = ACTIONS(1495),
    [anon_sym_GT_GT_EQ] = ACTIONS(1495),
    [anon_sym_LT_LT_EQ] = ACTIONS(1495),
    [anon_sym_CARET_EQ] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(1495),
    [anon_sym_DOT_DOT] = ACTIONS(1497),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1495),
    [anon_sym_and] = ACTIONS(1495),
    [anon_sym_or] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE] = ACTIONS(1497),
    [anon_sym_AMP_AMP] = ACTIONS(1497),
    [anon_sym_LT_LT] = ACTIONS(1497),
    [anon_sym_GT_GT] = ACTIONS(1497),
    [anon_sym_LT_EQ] = ACTIONS(1497),
    [anon_sym_GT] = ACTIONS(1497),
    [anon_sym_GT_EQ] = ACTIONS(1495),
    [anon_sym_CARET] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_SLASH] = ACTIONS(1497),
    [anon_sym_PERCENT] = ACTIONS(1497),
    [anon_sym_EQ_EQ] = ACTIONS(1497),
    [anon_sym_BANG_EQ] = ACTIONS(1495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1495),
    [anon_sym_LT_EQ_GT] = ACTIONS(1495),
    [anon_sym_EQ_TILDE] = ACTIONS(1495),
    [anon_sym_BANG_TILDE] = ACTIONS(1495),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1495),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__binary_star] = ACTIONS(1495),
  },
  [917] = {
    [sym_heredoc_body] = STATE(917),
    [ts_builtin_sym_end] = ACTIONS(1499),
    [anon_sym___END__] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_DOT] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_STAR_STAR] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1501),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_end] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_unless] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_until] = ACTIONS(1499),
    [anon_sym_rescue] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_when] = ACTIONS(1499),
    [anon_sym_elsif] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_then] = ACTIONS(1499),
    [anon_sym_ensure] = ACTIONS(1499),
    [anon_sym_EQ_GT] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_COLON_COLON2] = ACTIONS(1499),
    [anon_sym_AMP_DOT] = ACTIONS(1499),
    [anon_sym_PLUS_EQ] = ACTIONS(1499),
    [anon_sym_DASH_EQ] = ACTIONS(1499),
    [anon_sym_STAR_EQ] = ACTIONS(1499),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1499),
    [anon_sym_SLASH_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1499),
    [anon_sym_AMP_EQ] = ACTIONS(1499),
    [anon_sym_PERCENT_EQ] = ACTIONS(1499),
    [anon_sym_GT_GT_EQ] = ACTIONS(1499),
    [anon_sym_LT_LT_EQ] = ACTIONS(1499),
    [anon_sym_CARET_EQ] = ACTIONS(1499),
    [anon_sym_QMARK] = ACTIONS(1499),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_and] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE] = ACTIONS(1501),
    [anon_sym_AMP_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1501),
    [anon_sym_GT_GT] = ACTIONS(1501),
    [anon_sym_LT_EQ] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1501),
    [anon_sym_GT_EQ] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1501),
    [anon_sym_EQ_EQ] = ACTIONS(1501),
    [anon_sym_BANG_EQ] = ACTIONS(1499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1499),
    [anon_sym_LT_EQ_GT] = ACTIONS(1499),
    [anon_sym_EQ_TILDE] = ACTIONS(1499),
    [anon_sym_BANG_TILDE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1499),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1499),
    [sym__binary_star] = ACTIONS(1499),
  },
  [918] = {
    [sym_heredoc_body] = STATE(918),
    [ts_builtin_sym_end] = ACTIONS(997),
    [anon_sym___END__] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(997),
    [anon_sym_elsif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(997),
    [anon_sym_ensure] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(997),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(997),
    [sym__binary_star] = ACTIONS(997),
  },
  [919] = {
    [sym_heredoc_body] = STATE(919),
    [ts_builtin_sym_end] = ACTIONS(1499),
    [anon_sym___END__] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_DOT] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_STAR_STAR] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1501),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_end] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_unless] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_until] = ACTIONS(1499),
    [anon_sym_rescue] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_when] = ACTIONS(1499),
    [anon_sym_elsif] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_then] = ACTIONS(1499),
    [anon_sym_ensure] = ACTIONS(1499),
    [anon_sym_EQ_GT] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_COLON_COLON2] = ACTIONS(1499),
    [anon_sym_AMP_DOT] = ACTIONS(1499),
    [anon_sym_PLUS_EQ] = ACTIONS(1499),
    [anon_sym_DASH_EQ] = ACTIONS(1499),
    [anon_sym_STAR_EQ] = ACTIONS(1499),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1499),
    [anon_sym_SLASH_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1499),
    [anon_sym_AMP_EQ] = ACTIONS(1499),
    [anon_sym_PERCENT_EQ] = ACTIONS(1499),
    [anon_sym_GT_GT_EQ] = ACTIONS(1499),
    [anon_sym_LT_LT_EQ] = ACTIONS(1499),
    [anon_sym_CARET_EQ] = ACTIONS(1499),
    [anon_sym_QMARK] = ACTIONS(1499),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_and] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE] = ACTIONS(1501),
    [anon_sym_AMP_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1501),
    [anon_sym_GT_GT] = ACTIONS(1501),
    [anon_sym_LT_EQ] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1501),
    [anon_sym_GT_EQ] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1501),
    [anon_sym_EQ_EQ] = ACTIONS(1501),
    [anon_sym_BANG_EQ] = ACTIONS(1499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1499),
    [anon_sym_LT_EQ_GT] = ACTIONS(1499),
    [anon_sym_EQ_TILDE] = ACTIONS(1499),
    [anon_sym_BANG_TILDE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1499),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1499),
    [sym__binary_star] = ACTIONS(1499),
  },
  [920] = {
    [sym_heredoc_body] = STATE(920),
    [ts_builtin_sym_end] = ACTIONS(1503),
    [anon_sym___END__] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_RBRACE] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_DOT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_PIPE] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_STAR_STAR] = ACTIONS(1505),
    [anon_sym_AMP] = ACTIONS(1505),
    [anon_sym_EQ] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_unless] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_until] = ACTIONS(1503),
    [anon_sym_rescue] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(1503),
    [anon_sym_elsif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_then] = ACTIONS(1503),
    [anon_sym_ensure] = ACTIONS(1503),
    [anon_sym_EQ_GT] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_COLON_COLON2] = ACTIONS(1503),
    [anon_sym_AMP_DOT] = ACTIONS(1503),
    [anon_sym_PLUS_EQ] = ACTIONS(1503),
    [anon_sym_DASH_EQ] = ACTIONS(1503),
    [anon_sym_STAR_EQ] = ACTIONS(1503),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1503),
    [anon_sym_SLASH_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1503),
    [anon_sym_AMP_EQ] = ACTIONS(1503),
    [anon_sym_PERCENT_EQ] = ACTIONS(1503),
    [anon_sym_GT_GT_EQ] = ACTIONS(1503),
    [anon_sym_LT_LT_EQ] = ACTIONS(1503),
    [anon_sym_CARET_EQ] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_and] = ACTIONS(1503),
    [anon_sym_or] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE] = ACTIONS(1505),
    [anon_sym_AMP_AMP] = ACTIONS(1505),
    [anon_sym_LT_LT] = ACTIONS(1505),
    [anon_sym_GT_GT] = ACTIONS(1505),
    [anon_sym_LT_EQ] = ACTIONS(1505),
    [anon_sym_GT] = ACTIONS(1505),
    [anon_sym_GT_EQ] = ACTIONS(1503),
    [anon_sym_CARET] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(1505),
    [anon_sym_PERCENT] = ACTIONS(1505),
    [anon_sym_EQ_EQ] = ACTIONS(1505),
    [anon_sym_BANG_EQ] = ACTIONS(1503),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1503),
    [anon_sym_LT_EQ_GT] = ACTIONS(1503),
    [anon_sym_EQ_TILDE] = ACTIONS(1503),
    [anon_sym_BANG_TILDE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1503),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1503),
    [sym__binary_star] = ACTIONS(1503),
  },
  [921] = {
    [sym_heredoc_body] = STATE(921),
    [ts_builtin_sym_end] = ACTIONS(1507),
    [anon_sym___END__] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_RPAREN] = ACTIONS(1507),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym_PIPE] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_EQ] = ACTIONS(1509),
    [anon_sym_LT] = ACTIONS(1509),
    [anon_sym_end] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_unless] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1507),
    [anon_sym_until] = ACTIONS(1507),
    [anon_sym_rescue] = ACTIONS(1507),
    [anon_sym_do] = ACTIONS(1507),
    [anon_sym_when] = ACTIONS(1507),
    [anon_sym_elsif] = ACTIONS(1507),
    [anon_sym_else] = ACTIONS(1507),
    [anon_sym_then] = ACTIONS(1507),
    [anon_sym_ensure] = ACTIONS(1507),
    [anon_sym_EQ_GT] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1507),
    [anon_sym_COLON_COLON2] = ACTIONS(1507),
    [anon_sym_AMP_DOT] = ACTIONS(1507),
    [anon_sym_PLUS_EQ] = ACTIONS(1507),
    [anon_sym_DASH_EQ] = ACTIONS(1507),
    [anon_sym_STAR_EQ] = ACTIONS(1507),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1507),
    [anon_sym_SLASH_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1507),
    [anon_sym_AMP_EQ] = ACTIONS(1507),
    [anon_sym_PERCENT_EQ] = ACTIONS(1507),
    [anon_sym_GT_GT_EQ] = ACTIONS(1507),
    [anon_sym_LT_LT_EQ] = ACTIONS(1507),
    [anon_sym_CARET_EQ] = ACTIONS(1507),
    [anon_sym_QMARK] = ACTIONS(1507),
    [anon_sym_DOT_DOT] = ACTIONS(1509),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1507),
    [anon_sym_and] = ACTIONS(1507),
    [anon_sym_or] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE] = ACTIONS(1509),
    [anon_sym_AMP_AMP] = ACTIONS(1509),
    [anon_sym_LT_LT] = ACTIONS(1509),
    [anon_sym_GT_GT] = ACTIONS(1509),
    [anon_sym_LT_EQ] = ACTIONS(1509),
    [anon_sym_GT] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(1507),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_EQ] = ACTIONS(1509),
    [anon_sym_BANG_EQ] = ACTIONS(1507),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1507),
    [anon_sym_LT_EQ_GT] = ACTIONS(1507),
    [anon_sym_EQ_TILDE] = ACTIONS(1507),
    [anon_sym_BANG_TILDE] = ACTIONS(1507),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1507),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1507),
    [sym__binary_star] = ACTIONS(1507),
  },
  [922] = {
    [sym_heredoc_body] = STATE(922),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_STAR_STAR] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_when] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(1511),
    [anon_sym_DOT_DOT] = ACTIONS(1513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_LT_EQ] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_EQ] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_SLASH] = ACTIONS(1513),
    [anon_sym_PERCENT] = ACTIONS(1513),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1511),
    [anon_sym_LT_EQ_GT] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(1511),
  },
  [923] = {
    [sym_heredoc_body] = STATE(923),
    [ts_builtin_sym_end] = ACTIONS(987),
    [anon_sym___END__] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_end] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_unless] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_until] = ACTIONS(987),
    [anon_sym_rescue] = ACTIONS(987),
    [anon_sym_do] = ACTIONS(987),
    [anon_sym_when] = ACTIONS(987),
    [anon_sym_elsif] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_then] = ACTIONS(987),
    [anon_sym_ensure] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_COLON_COLON2] = ACTIONS(987),
    [anon_sym_AMP_DOT] = ACTIONS(987),
    [anon_sym_LPAREN2] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_LT_EQ_GT] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(987),
    [anon_sym_BANG_TILDE] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(987),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(987),
    [sym__binary_star] = ACTIONS(987),
  },
  [924] = {
    [sym_heredoc_body] = STATE(924),
    [aux_sym__mlhs_repeat1] = STATE(2545),
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym___END__] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_COLON_COLON2] = ACTIONS(1437),
    [anon_sym_AMP_DOT] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1517),
    [anon_sym_DASH_EQ] = ACTIONS(1517),
    [anon_sym_STAR_EQ] = ACTIONS(1517),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1517),
    [anon_sym_SLASH_EQ] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1517),
    [anon_sym_PIPE_EQ] = ACTIONS(1517),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1517),
    [anon_sym_AMP_EQ] = ACTIONS(1517),
    [anon_sym_PERCENT_EQ] = ACTIONS(1517),
    [anon_sym_GT_GT_EQ] = ACTIONS(1517),
    [anon_sym_LT_LT_EQ] = ACTIONS(1517),
    [anon_sym_CARET_EQ] = ACTIONS(1517),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_LT_EQ_GT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_BANG_TILDE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1437),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1437),
    [sym__binary_star] = ACTIONS(1437),
  },
  [925] = {
    [sym_heredoc_body] = STATE(925),
    [ts_builtin_sym_end] = ACTIONS(1519),
    [anon_sym___END__] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_RBRACE] = ACTIONS(1519),
    [anon_sym_RPAREN] = ACTIONS(1519),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_end] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_unless] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_until] = ACTIONS(1519),
    [anon_sym_rescue] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(1519),
    [anon_sym_elsif] = ACTIONS(1519),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_then] = ACTIONS(1519),
    [anon_sym_ensure] = ACTIONS(1519),
    [anon_sym_EQ_GT] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1519),
    [anon_sym_COLON_COLON2] = ACTIONS(1519),
    [anon_sym_AMP_DOT] = ACTIONS(1519),
    [anon_sym_PLUS_EQ] = ACTIONS(1519),
    [anon_sym_DASH_EQ] = ACTIONS(1519),
    [anon_sym_STAR_EQ] = ACTIONS(1519),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1519),
    [anon_sym_SLASH_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1519),
    [anon_sym_AMP_EQ] = ACTIONS(1519),
    [anon_sym_PERCENT_EQ] = ACTIONS(1519),
    [anon_sym_GT_GT_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_EQ] = ACTIONS(1519),
    [anon_sym_CARET_EQ] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1519),
    [anon_sym_DOT_DOT] = ACTIONS(1521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1519),
    [anon_sym_and] = ACTIONS(1519),
    [anon_sym_or] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1521),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_EQ] = ACTIONS(1519),
    [anon_sym_CARET] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1519),
    [anon_sym_LT_EQ_GT] = ACTIONS(1519),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_BANG_TILDE] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1519),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1519),
    [sym__binary_star] = ACTIONS(1519),
  },
  [926] = {
    [sym_heredoc_body] = STATE(926),
    [ts_builtin_sym_end] = ACTIONS(1495),
    [anon_sym___END__] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_RBRACE] = ACTIONS(1495),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_DOT] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_STAR_STAR] = ACTIONS(1497),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_EQ] = ACTIONS(1497),
    [anon_sym_LT] = ACTIONS(1497),
    [anon_sym_end] = ACTIONS(1495),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_unless] = ACTIONS(1495),
    [anon_sym_while] = ACTIONS(1495),
    [anon_sym_until] = ACTIONS(1495),
    [anon_sym_rescue] = ACTIONS(1495),
    [anon_sym_do] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(1495),
    [anon_sym_elsif] = ACTIONS(1495),
    [anon_sym_else] = ACTIONS(1495),
    [anon_sym_then] = ACTIONS(1495),
    [anon_sym_ensure] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1495),
    [anon_sym_COLON_COLON2] = ACTIONS(1495),
    [anon_sym_AMP_DOT] = ACTIONS(1495),
    [anon_sym_PLUS_EQ] = ACTIONS(1495),
    [anon_sym_DASH_EQ] = ACTIONS(1495),
    [anon_sym_STAR_EQ] = ACTIONS(1495),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1495),
    [anon_sym_SLASH_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1495),
    [anon_sym_AMP_EQ] = ACTIONS(1495),
    [anon_sym_PERCENT_EQ] = ACTIONS(1495),
    [anon_sym_GT_GT_EQ] = ACTIONS(1495),
    [anon_sym_LT_LT_EQ] = ACTIONS(1495),
    [anon_sym_CARET_EQ] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(1495),
    [anon_sym_DOT_DOT] = ACTIONS(1497),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1495),
    [anon_sym_and] = ACTIONS(1495),
    [anon_sym_or] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE] = ACTIONS(1497),
    [anon_sym_AMP_AMP] = ACTIONS(1497),
    [anon_sym_LT_LT] = ACTIONS(1497),
    [anon_sym_GT_GT] = ACTIONS(1497),
    [anon_sym_LT_EQ] = ACTIONS(1497),
    [anon_sym_GT] = ACTIONS(1497),
    [anon_sym_GT_EQ] = ACTIONS(1495),
    [anon_sym_CARET] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_SLASH] = ACTIONS(1497),
    [anon_sym_PERCENT] = ACTIONS(1497),
    [anon_sym_EQ_EQ] = ACTIONS(1497),
    [anon_sym_BANG_EQ] = ACTIONS(1495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1495),
    [anon_sym_LT_EQ_GT] = ACTIONS(1495),
    [anon_sym_EQ_TILDE] = ACTIONS(1495),
    [anon_sym_BANG_TILDE] = ACTIONS(1495),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1495),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__binary_star] = ACTIONS(1495),
  },
  [927] = {
    [sym_heredoc_body] = STATE(927),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BEGIN] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_END] = ACTIONS(1523),
    [anon_sym_def] = ACTIONS(1523),
    [anon_sym_LPAREN] = ACTIONS(1525),
    [anon_sym_RPAREN] = ACTIONS(1525),
    [anon_sym_COLON_COLON] = ACTIONS(1525),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_class] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_end] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_next] = ACTIONS(1523),
    [anon_sym_redo] = ACTIONS(1523),
    [anon_sym_retry] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_unless] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_until] = ACTIONS(1523),
    [anon_sym_rescue] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(1523),
    [anon_sym_elsif] = ACTIONS(1523),
    [anon_sym_else] = ACTIONS(1523),
    [anon_sym_begin] = ACTIONS(1523),
    [anon_sym_ensure] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_defined_QMARK] = ACTIONS(1525),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [sym_constant] = ACTIONS(1523),
    [sym_instance_variable] = ACTIONS(1525),
    [sym_class_variable] = ACTIONS(1525),
    [sym_global_variable] = ACTIONS(1525),
    [anon_sym_undef] = ACTIONS(1523),
    [anon_sym_alias] = ACTIONS(1523),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1523),
    [sym_float] = ACTIONS(1523),
    [sym_complex] = ACTIONS(1525),
    [sym_super] = ACTIONS(1523),
    [anon_sym_true] = ACTIONS(1523),
    [anon_sym_TRUE] = ACTIONS(1523),
    [anon_sym_false] = ACTIONS(1523),
    [anon_sym_FALSE] = ACTIONS(1523),
    [sym_self] = ACTIONS(1523),
    [anon_sym_nil] = ACTIONS(1523),
    [anon_sym_NIL] = ACTIONS(1523),
    [sym_character] = ACTIONS(1525),
    [anon_sym_LBRACK2] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [sym__simple_symbol] = ACTIONS(1525),
    [sym__string_start] = ACTIONS(1525),
    [sym__symbol_start] = ACTIONS(1525),
    [sym__subshell_start] = ACTIONS(1525),
    [sym__regex_start] = ACTIONS(1525),
    [sym__string_array_start] = ACTIONS(1525),
    [sym__symbol_array_start] = ACTIONS(1525),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1525),
  },
  [928] = {
    [sym_heredoc_body] = STATE(928),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_STAR_STAR] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_when] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(1511),
    [anon_sym_DOT_DOT] = ACTIONS(1513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_LT_EQ] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_EQ] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_SLASH] = ACTIONS(1513),
    [anon_sym_PERCENT] = ACTIONS(1513),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1511),
    [anon_sym_LT_EQ_GT] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(1511),
  },
  [929] = {
    [sym_heredoc_body] = STATE(929),
    [aux_sym__mlhs_repeat1] = STATE(2545),
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym___END__] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_EQ_GT] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_COLON_COLON2] = ACTIONS(1437),
    [anon_sym_AMP_DOT] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1529),
    [anon_sym_DASH_EQ] = ACTIONS(1529),
    [anon_sym_STAR_EQ] = ACTIONS(1529),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1529),
    [anon_sym_SLASH_EQ] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1529),
    [anon_sym_PIPE_EQ] = ACTIONS(1529),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1529),
    [anon_sym_AMP_EQ] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1529),
    [anon_sym_GT_GT_EQ] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1529),
    [anon_sym_CARET_EQ] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_LT_EQ_GT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_BANG_TILDE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1437),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1437),
    [sym__binary_star] = ACTIONS(1437),
  },
  [930] = {
    [sym_heredoc_body] = STATE(930),
    [ts_builtin_sym_end] = ACTIONS(1469),
    [anon_sym___END__] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1469),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_DOT] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_STAR_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_end] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_unless] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_until] = ACTIONS(1469),
    [anon_sym_rescue] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_when] = ACTIONS(1469),
    [anon_sym_elsif] = ACTIONS(1469),
    [anon_sym_else] = ACTIONS(1469),
    [anon_sym_then] = ACTIONS(1469),
    [anon_sym_ensure] = ACTIONS(1469),
    [anon_sym_LBRACK] = ACTIONS(1469),
    [anon_sym_COLON_COLON2] = ACTIONS(1469),
    [anon_sym_AMP_DOT] = ACTIONS(1469),
    [anon_sym_PLUS_EQ] = ACTIONS(1469),
    [anon_sym_DASH_EQ] = ACTIONS(1469),
    [anon_sym_STAR_EQ] = ACTIONS(1469),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1469),
    [anon_sym_SLASH_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1469),
    [anon_sym_AMP_EQ] = ACTIONS(1469),
    [anon_sym_PERCENT_EQ] = ACTIONS(1469),
    [anon_sym_GT_GT_EQ] = ACTIONS(1469),
    [anon_sym_LT_LT_EQ] = ACTIONS(1469),
    [anon_sym_CARET_EQ] = ACTIONS(1469),
    [anon_sym_QMARK] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1469),
    [anon_sym_or] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(1471),
    [anon_sym_LT_EQ] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_EQ] = ACTIONS(1469),
    [anon_sym_CARET] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_SLASH] = ACTIONS(1471),
    [anon_sym_PERCENT] = ACTIONS(1471),
    [anon_sym_EQ_EQ] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1469),
    [anon_sym_LT_EQ_GT] = ACTIONS(1469),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_BANG_TILDE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1469),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1469),
    [sym__binary_star] = ACTIONS(1469),
  },
  [931] = {
    [sym_heredoc_body] = STATE(931),
    [ts_builtin_sym_end] = ACTIONS(1491),
    [anon_sym___END__] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(1491),
    [anon_sym_DOT] = ACTIONS(1493),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1493),
    [anon_sym_EQ] = ACTIONS(1493),
    [anon_sym_LT] = ACTIONS(1493),
    [anon_sym_end] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1491),
    [anon_sym_unless] = ACTIONS(1491),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_until] = ACTIONS(1491),
    [anon_sym_rescue] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1491),
    [anon_sym_when] = ACTIONS(1491),
    [anon_sym_elsif] = ACTIONS(1491),
    [anon_sym_else] = ACTIONS(1491),
    [anon_sym_then] = ACTIONS(1491),
    [anon_sym_ensure] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_COLON_COLON2] = ACTIONS(1491),
    [anon_sym_AMP_DOT] = ACTIONS(1491),
    [anon_sym_PLUS_EQ] = ACTIONS(1491),
    [anon_sym_DASH_EQ] = ACTIONS(1491),
    [anon_sym_STAR_EQ] = ACTIONS(1491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1491),
    [anon_sym_SLASH_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1491),
    [anon_sym_AMP_EQ] = ACTIONS(1491),
    [anon_sym_PERCENT_EQ] = ACTIONS(1491),
    [anon_sym_GT_GT_EQ] = ACTIONS(1491),
    [anon_sym_LT_LT_EQ] = ACTIONS(1491),
    [anon_sym_CARET_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1491),
    [anon_sym_DOT_DOT] = ACTIONS(1493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1491),
    [anon_sym_and] = ACTIONS(1491),
    [anon_sym_or] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1493),
    [anon_sym_AMP_AMP] = ACTIONS(1493),
    [anon_sym_LT_LT] = ACTIONS(1493),
    [anon_sym_GT_GT] = ACTIONS(1493),
    [anon_sym_LT_EQ] = ACTIONS(1493),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_CARET] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1493),
    [anon_sym_PERCENT] = ACTIONS(1493),
    [anon_sym_EQ_EQ] = ACTIONS(1493),
    [anon_sym_BANG_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_LT_EQ_GT] = ACTIONS(1491),
    [anon_sym_EQ_TILDE] = ACTIONS(1491),
    [anon_sym_BANG_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1491),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1491),
    [sym__binary_star] = ACTIONS(1491),
  },
  [932] = {
    [sym_heredoc_body] = STATE(932),
    [ts_builtin_sym_end] = ACTIONS(1453),
    [anon_sym___END__] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_DOT] = ACTIONS(1455),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_EQ] = ACTIONS(1455),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_end] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_unless] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_until] = ACTIONS(1453),
    [anon_sym_rescue] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_when] = ACTIONS(1453),
    [anon_sym_elsif] = ACTIONS(1453),
    [anon_sym_else] = ACTIONS(1453),
    [anon_sym_then] = ACTIONS(1453),
    [anon_sym_ensure] = ACTIONS(1453),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_COLON_COLON2] = ACTIONS(1453),
    [anon_sym_AMP_DOT] = ACTIONS(1453),
    [anon_sym_PLUS_EQ] = ACTIONS(1453),
    [anon_sym_DASH_EQ] = ACTIONS(1453),
    [anon_sym_STAR_EQ] = ACTIONS(1453),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1453),
    [anon_sym_SLASH_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1453),
    [anon_sym_AMP_EQ] = ACTIONS(1453),
    [anon_sym_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_GT_GT_EQ] = ACTIONS(1453),
    [anon_sym_LT_LT_EQ] = ACTIONS(1453),
    [anon_sym_CARET_EQ] = ACTIONS(1453),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1453),
    [anon_sym_and] = ACTIONS(1453),
    [anon_sym_or] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1455),
    [anon_sym_AMP_AMP] = ACTIONS(1455),
    [anon_sym_LT_LT] = ACTIONS(1455),
    [anon_sym_GT_GT] = ACTIONS(1455),
    [anon_sym_LT_EQ] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1455),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_CARET] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1455),
    [anon_sym_EQ_EQ] = ACTIONS(1455),
    [anon_sym_BANG_EQ] = ACTIONS(1453),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1453),
    [anon_sym_LT_EQ_GT] = ACTIONS(1453),
    [anon_sym_EQ_TILDE] = ACTIONS(1453),
    [anon_sym_BANG_TILDE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1453),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__binary_star] = ACTIONS(1453),
  },
  [933] = {
    [sym_heredoc_body] = STATE(933),
    [ts_builtin_sym_end] = ACTIONS(1503),
    [anon_sym___END__] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_RBRACE] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_DOT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_PIPE] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_STAR_STAR] = ACTIONS(1505),
    [anon_sym_AMP] = ACTIONS(1505),
    [anon_sym_EQ] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_unless] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_until] = ACTIONS(1503),
    [anon_sym_rescue] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(1503),
    [anon_sym_elsif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_then] = ACTIONS(1503),
    [anon_sym_ensure] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_COLON_COLON2] = ACTIONS(1503),
    [anon_sym_AMP_DOT] = ACTIONS(1503),
    [anon_sym_PLUS_EQ] = ACTIONS(1503),
    [anon_sym_DASH_EQ] = ACTIONS(1503),
    [anon_sym_STAR_EQ] = ACTIONS(1503),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1503),
    [anon_sym_SLASH_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1503),
    [anon_sym_AMP_EQ] = ACTIONS(1503),
    [anon_sym_PERCENT_EQ] = ACTIONS(1503),
    [anon_sym_GT_GT_EQ] = ACTIONS(1503),
    [anon_sym_LT_LT_EQ] = ACTIONS(1503),
    [anon_sym_CARET_EQ] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_and] = ACTIONS(1503),
    [anon_sym_or] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE] = ACTIONS(1505),
    [anon_sym_AMP_AMP] = ACTIONS(1505),
    [anon_sym_LT_LT] = ACTIONS(1505),
    [anon_sym_GT_GT] = ACTIONS(1505),
    [anon_sym_LT_EQ] = ACTIONS(1505),
    [anon_sym_GT] = ACTIONS(1505),
    [anon_sym_GT_EQ] = ACTIONS(1503),
    [anon_sym_CARET] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(1505),
    [anon_sym_PERCENT] = ACTIONS(1505),
    [anon_sym_EQ_EQ] = ACTIONS(1505),
    [anon_sym_BANG_EQ] = ACTIONS(1503),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1503),
    [anon_sym_LT_EQ_GT] = ACTIONS(1503),
    [anon_sym_EQ_TILDE] = ACTIONS(1503),
    [anon_sym_BANG_TILDE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1503),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1503),
    [sym__binary_star] = ACTIONS(1503),
  },
  [934] = {
    [sym_heredoc_body] = STATE(934),
    [ts_builtin_sym_end] = ACTIONS(1477),
    [anon_sym___END__] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_unless] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_until] = ACTIONS(1477),
    [anon_sym_rescue] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_elsif] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1477),
    [anon_sym_ensure] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1477),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_DOT_DOT] = ACTIONS(1479),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1477),
    [anon_sym_or] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1479),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1479),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ_GT] = ACTIONS(1477),
    [anon_sym_EQ_TILDE] = ACTIONS(1477),
    [anon_sym_BANG_TILDE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1477),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(1477),
  },
  [935] = {
    [sym_heredoc_body] = STATE(935),
    [ts_builtin_sym_end] = ACTIONS(1449),
    [anon_sym___END__] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_STAR_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_unless] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_until] = ACTIONS(1449),
    [anon_sym_rescue] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_when] = ACTIONS(1449),
    [anon_sym_elsif] = ACTIONS(1449),
    [anon_sym_else] = ACTIONS(1449),
    [anon_sym_then] = ACTIONS(1449),
    [anon_sym_ensure] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_COLON_COLON2] = ACTIONS(1449),
    [anon_sym_AMP_DOT] = ACTIONS(1449),
    [anon_sym_PLUS_EQ] = ACTIONS(1449),
    [anon_sym_DASH_EQ] = ACTIONS(1449),
    [anon_sym_STAR_EQ] = ACTIONS(1449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1449),
    [anon_sym_SLASH_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1449),
    [anon_sym_AMP_EQ] = ACTIONS(1449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1449),
    [anon_sym_CARET_EQ] = ACTIONS(1449),
    [anon_sym_QMARK] = ACTIONS(1449),
    [anon_sym_DOT_DOT] = ACTIONS(1451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1449),
    [anon_sym_and] = ACTIONS(1449),
    [anon_sym_or] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_LT_EQ_GT] = ACTIONS(1449),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [anon_sym_BANG_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1449),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1449),
    [sym__binary_star] = ACTIONS(1449),
  },
  [936] = {
    [sym_heredoc_body] = STATE(936),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_BEGIN] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_END] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1533),
    [anon_sym_RPAREN] = ACTIONS(1533),
    [anon_sym_COLON_COLON] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1531),
    [anon_sym_module] = ACTIONS(1531),
    [anon_sym_end] = ACTIONS(1531),
    [anon_sym_return] = ACTIONS(1531),
    [anon_sym_yield] = ACTIONS(1531),
    [anon_sym_break] = ACTIONS(1531),
    [anon_sym_next] = ACTIONS(1531),
    [anon_sym_redo] = ACTIONS(1531),
    [anon_sym_retry] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_unless] = ACTIONS(1531),
    [anon_sym_while] = ACTIONS(1531),
    [anon_sym_until] = ACTIONS(1531),
    [anon_sym_rescue] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(1531),
    [anon_sym_when] = ACTIONS(1531),
    [anon_sym_elsif] = ACTIONS(1531),
    [anon_sym_else] = ACTIONS(1531),
    [anon_sym_begin] = ACTIONS(1531),
    [anon_sym_ensure] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_defined_QMARK] = ACTIONS(1533),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1533),
    [sym_constant] = ACTIONS(1531),
    [sym_instance_variable] = ACTIONS(1533),
    [sym_class_variable] = ACTIONS(1533),
    [sym_global_variable] = ACTIONS(1533),
    [anon_sym_undef] = ACTIONS(1531),
    [anon_sym_alias] = ACTIONS(1531),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1531),
    [sym_float] = ACTIONS(1531),
    [sym_complex] = ACTIONS(1533),
    [sym_super] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_TRUE] = ACTIONS(1531),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_FALSE] = ACTIONS(1531),
    [sym_self] = ACTIONS(1531),
    [anon_sym_nil] = ACTIONS(1531),
    [anon_sym_NIL] = ACTIONS(1531),
    [sym_character] = ACTIONS(1533),
    [anon_sym_LBRACK2] = ACTIONS(1533),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [sym__simple_symbol] = ACTIONS(1533),
    [sym__string_start] = ACTIONS(1533),
    [sym__symbol_start] = ACTIONS(1533),
    [sym__subshell_start] = ACTIONS(1533),
    [sym__regex_start] = ACTIONS(1533),
    [sym__string_array_start] = ACTIONS(1533),
    [sym__symbol_array_start] = ACTIONS(1533),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1533),
    [sym__unary_minus] = ACTIONS(1533),
  },
  [937] = {
    [sym_heredoc_body] = STATE(937),
    [ts_builtin_sym_end] = ACTIONS(1499),
    [anon_sym___END__] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_DOT] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_STAR_STAR] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1501),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_end] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_unless] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_until] = ACTIONS(1499),
    [anon_sym_rescue] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_when] = ACTIONS(1499),
    [anon_sym_elsif] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_then] = ACTIONS(1499),
    [anon_sym_ensure] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_COLON_COLON2] = ACTIONS(1499),
    [anon_sym_AMP_DOT] = ACTIONS(1499),
    [anon_sym_PLUS_EQ] = ACTIONS(1499),
    [anon_sym_DASH_EQ] = ACTIONS(1499),
    [anon_sym_STAR_EQ] = ACTIONS(1499),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1499),
    [anon_sym_SLASH_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1499),
    [anon_sym_AMP_EQ] = ACTIONS(1499),
    [anon_sym_PERCENT_EQ] = ACTIONS(1499),
    [anon_sym_GT_GT_EQ] = ACTIONS(1499),
    [anon_sym_LT_LT_EQ] = ACTIONS(1499),
    [anon_sym_CARET_EQ] = ACTIONS(1499),
    [anon_sym_QMARK] = ACTIONS(1499),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_and] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE] = ACTIONS(1501),
    [anon_sym_AMP_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1501),
    [anon_sym_GT_GT] = ACTIONS(1501),
    [anon_sym_LT_EQ] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1501),
    [anon_sym_GT_EQ] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1501),
    [anon_sym_EQ_EQ] = ACTIONS(1501),
    [anon_sym_BANG_EQ] = ACTIONS(1499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1499),
    [anon_sym_LT_EQ_GT] = ACTIONS(1499),
    [anon_sym_EQ_TILDE] = ACTIONS(1499),
    [anon_sym_BANG_TILDE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1499),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1499),
    [sym__binary_star] = ACTIONS(1499),
  },
  [938] = {
    [sym_heredoc_body] = STATE(938),
    [ts_builtin_sym_end] = ACTIONS(1507),
    [anon_sym___END__] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_RPAREN] = ACTIONS(1507),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym_PIPE] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_EQ] = ACTIONS(1509),
    [anon_sym_LT] = ACTIONS(1509),
    [anon_sym_end] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_unless] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1507),
    [anon_sym_until] = ACTIONS(1507),
    [anon_sym_rescue] = ACTIONS(1507),
    [anon_sym_do] = ACTIONS(1507),
    [anon_sym_when] = ACTIONS(1507),
    [anon_sym_elsif] = ACTIONS(1507),
    [anon_sym_else] = ACTIONS(1507),
    [anon_sym_then] = ACTIONS(1507),
    [anon_sym_ensure] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1507),
    [anon_sym_COLON_COLON2] = ACTIONS(1507),
    [anon_sym_AMP_DOT] = ACTIONS(1507),
    [anon_sym_PLUS_EQ] = ACTIONS(1507),
    [anon_sym_DASH_EQ] = ACTIONS(1507),
    [anon_sym_STAR_EQ] = ACTIONS(1507),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1507),
    [anon_sym_SLASH_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1507),
    [anon_sym_AMP_EQ] = ACTIONS(1507),
    [anon_sym_PERCENT_EQ] = ACTIONS(1507),
    [anon_sym_GT_GT_EQ] = ACTIONS(1507),
    [anon_sym_LT_LT_EQ] = ACTIONS(1507),
    [anon_sym_CARET_EQ] = ACTIONS(1507),
    [anon_sym_QMARK] = ACTIONS(1507),
    [anon_sym_DOT_DOT] = ACTIONS(1509),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1507),
    [anon_sym_and] = ACTIONS(1507),
    [anon_sym_or] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE] = ACTIONS(1509),
    [anon_sym_AMP_AMP] = ACTIONS(1509),
    [anon_sym_LT_LT] = ACTIONS(1509),
    [anon_sym_GT_GT] = ACTIONS(1509),
    [anon_sym_LT_EQ] = ACTIONS(1509),
    [anon_sym_GT] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(1507),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_EQ] = ACTIONS(1509),
    [anon_sym_BANG_EQ] = ACTIONS(1507),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1507),
    [anon_sym_LT_EQ_GT] = ACTIONS(1507),
    [anon_sym_EQ_TILDE] = ACTIONS(1507),
    [anon_sym_BANG_TILDE] = ACTIONS(1507),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1507),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1507),
    [sym__binary_star] = ACTIONS(1507),
  },
  [939] = {
    [sym_heredoc_body] = STATE(939),
    [ts_builtin_sym_end] = ACTIONS(1499),
    [anon_sym___END__] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_DOT] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_STAR_STAR] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1501),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_end] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_unless] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_until] = ACTIONS(1499),
    [anon_sym_rescue] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_when] = ACTIONS(1499),
    [anon_sym_elsif] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_then] = ACTIONS(1499),
    [anon_sym_ensure] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_COLON_COLON2] = ACTIONS(1499),
    [anon_sym_AMP_DOT] = ACTIONS(1499),
    [anon_sym_PLUS_EQ] = ACTIONS(1499),
    [anon_sym_DASH_EQ] = ACTIONS(1499),
    [anon_sym_STAR_EQ] = ACTIONS(1499),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1499),
    [anon_sym_SLASH_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1499),
    [anon_sym_AMP_EQ] = ACTIONS(1499),
    [anon_sym_PERCENT_EQ] = ACTIONS(1499),
    [anon_sym_GT_GT_EQ] = ACTIONS(1499),
    [anon_sym_LT_LT_EQ] = ACTIONS(1499),
    [anon_sym_CARET_EQ] = ACTIONS(1499),
    [anon_sym_QMARK] = ACTIONS(1499),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_and] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE] = ACTIONS(1501),
    [anon_sym_AMP_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1501),
    [anon_sym_GT_GT] = ACTIONS(1501),
    [anon_sym_LT_EQ] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1501),
    [anon_sym_GT_EQ] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1501),
    [anon_sym_EQ_EQ] = ACTIONS(1501),
    [anon_sym_BANG_EQ] = ACTIONS(1499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1499),
    [anon_sym_LT_EQ_GT] = ACTIONS(1499),
    [anon_sym_EQ_TILDE] = ACTIONS(1499),
    [anon_sym_BANG_TILDE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1499),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1499),
    [sym__binary_star] = ACTIONS(1499),
  },
  [940] = {
    [sym_heredoc_body] = STATE(940),
    [ts_builtin_sym_end] = ACTIONS(1481),
    [anon_sym___END__] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_DOT] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_STAR_STAR] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1483),
    [anon_sym_end] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1481),
    [anon_sym_unless] = ACTIONS(1481),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_until] = ACTIONS(1481),
    [anon_sym_rescue] = ACTIONS(1481),
    [anon_sym_do] = ACTIONS(1481),
    [anon_sym_when] = ACTIONS(1481),
    [anon_sym_elsif] = ACTIONS(1481),
    [anon_sym_else] = ACTIONS(1481),
    [anon_sym_then] = ACTIONS(1481),
    [anon_sym_ensure] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_COLON_COLON2] = ACTIONS(1481),
    [anon_sym_AMP_DOT] = ACTIONS(1481),
    [anon_sym_PLUS_EQ] = ACTIONS(1481),
    [anon_sym_DASH_EQ] = ACTIONS(1481),
    [anon_sym_STAR_EQ] = ACTIONS(1481),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1481),
    [anon_sym_SLASH_EQ] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1481),
    [anon_sym_PIPE_EQ] = ACTIONS(1481),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1481),
    [anon_sym_AMP_EQ] = ACTIONS(1481),
    [anon_sym_PERCENT_EQ] = ACTIONS(1481),
    [anon_sym_GT_GT_EQ] = ACTIONS(1481),
    [anon_sym_LT_LT_EQ] = ACTIONS(1481),
    [anon_sym_CARET_EQ] = ACTIONS(1481),
    [anon_sym_QMARK] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_and] = ACTIONS(1481),
    [anon_sym_or] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_LT_LT] = ACTIONS(1483),
    [anon_sym_GT_GT] = ACTIONS(1483),
    [anon_sym_LT_EQ] = ACTIONS(1483),
    [anon_sym_GT] = ACTIONS(1483),
    [anon_sym_GT_EQ] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(1483),
    [anon_sym_PERCENT] = ACTIONS(1483),
    [anon_sym_EQ_EQ] = ACTIONS(1483),
    [anon_sym_BANG_EQ] = ACTIONS(1481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1481),
    [anon_sym_LT_EQ_GT] = ACTIONS(1481),
    [anon_sym_EQ_TILDE] = ACTIONS(1481),
    [anon_sym_BANG_TILDE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1481),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1481),
    [sym__binary_star] = ACTIONS(1481),
  },
  [941] = {
    [sym_heredoc_body] = STATE(941),
    [ts_builtin_sym_end] = ACTIONS(1473),
    [anon_sym___END__] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_end] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_unless] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_until] = ACTIONS(1473),
    [anon_sym_rescue] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_when] = ACTIONS(1473),
    [anon_sym_elsif] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_then] = ACTIONS(1473),
    [anon_sym_ensure] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1473),
    [anon_sym_COLON_COLON2] = ACTIONS(1473),
    [anon_sym_AMP_DOT] = ACTIONS(1473),
    [anon_sym_PLUS_EQ] = ACTIONS(1473),
    [anon_sym_DASH_EQ] = ACTIONS(1473),
    [anon_sym_STAR_EQ] = ACTIONS(1473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1473),
    [anon_sym_SLASH_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1473),
    [anon_sym_AMP_EQ] = ACTIONS(1473),
    [anon_sym_PERCENT_EQ] = ACTIONS(1473),
    [anon_sym_GT_GT_EQ] = ACTIONS(1473),
    [anon_sym_LT_LT_EQ] = ACTIONS(1473),
    [anon_sym_CARET_EQ] = ACTIONS(1473),
    [anon_sym_QMARK] = ACTIONS(1473),
    [anon_sym_DOT_DOT] = ACTIONS(1475),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1473),
    [anon_sym_or] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1473),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1473),
    [anon_sym_LT_EQ_GT] = ACTIONS(1473),
    [anon_sym_EQ_TILDE] = ACTIONS(1473),
    [anon_sym_BANG_TILDE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1473),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1473),
    [sym__binary_star] = ACTIONS(1473),
  },
  [942] = {
    [sym_heredoc_body] = STATE(942),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym___END__] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_unless] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_until] = ACTIONS(1457),
    [anon_sym_rescue] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_when] = ACTIONS(1457),
    [anon_sym_elsif] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_then] = ACTIONS(1457),
    [anon_sym_ensure] = ACTIONS(1457),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON_COLON2] = ACTIONS(1457),
    [anon_sym_AMP_DOT] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1457),
    [anon_sym_LT_EQ_GT] = ACTIONS(1457),
    [anon_sym_EQ_TILDE] = ACTIONS(1457),
    [anon_sym_BANG_TILDE] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1457),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1457),
    [sym__binary_star] = ACTIONS(1457),
  },
  [943] = {
    [sym_heredoc_body] = STATE(943),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym___END__] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1465),
    [anon_sym_RBRACE] = ACTIONS(1465),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_DOT] = ACTIONS(1467),
    [anon_sym_COMMA] = ACTIONS(1465),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1465),
    [anon_sym_STAR_STAR] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_EQ] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1467),
    [anon_sym_end] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_unless] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_until] = ACTIONS(1465),
    [anon_sym_rescue] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_when] = ACTIONS(1465),
    [anon_sym_elsif] = ACTIONS(1465),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_then] = ACTIONS(1465),
    [anon_sym_ensure] = ACTIONS(1465),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_COLON_COLON2] = ACTIONS(1465),
    [anon_sym_AMP_DOT] = ACTIONS(1465),
    [anon_sym_PLUS_EQ] = ACTIONS(1465),
    [anon_sym_DASH_EQ] = ACTIONS(1465),
    [anon_sym_STAR_EQ] = ACTIONS(1465),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1465),
    [anon_sym_SLASH_EQ] = ACTIONS(1465),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1465),
    [anon_sym_PIPE_EQ] = ACTIONS(1465),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1465),
    [anon_sym_AMP_EQ] = ACTIONS(1465),
    [anon_sym_PERCENT_EQ] = ACTIONS(1465),
    [anon_sym_GT_GT_EQ] = ACTIONS(1465),
    [anon_sym_LT_LT_EQ] = ACTIONS(1465),
    [anon_sym_CARET_EQ] = ACTIONS(1465),
    [anon_sym_QMARK] = ACTIONS(1465),
    [anon_sym_DOT_DOT] = ACTIONS(1467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1465),
    [anon_sym_and] = ACTIONS(1465),
    [anon_sym_or] = ACTIONS(1465),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_LT_LT] = ACTIONS(1467),
    [anon_sym_GT_GT] = ACTIONS(1467),
    [anon_sym_LT_EQ] = ACTIONS(1467),
    [anon_sym_GT] = ACTIONS(1467),
    [anon_sym_GT_EQ] = ACTIONS(1465),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_SLASH] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(1467),
    [anon_sym_EQ_EQ] = ACTIONS(1467),
    [anon_sym_BANG_EQ] = ACTIONS(1465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1465),
    [anon_sym_LT_EQ_GT] = ACTIONS(1465),
    [anon_sym_EQ_TILDE] = ACTIONS(1465),
    [anon_sym_BANG_TILDE] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1465),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__binary_star] = ACTIONS(1465),
  },
  [944] = {
    [sym_heredoc_body] = STATE(944),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [945] = {
    [sym_heredoc_body] = STATE(945),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [946] = {
    [sym_heredoc_body] = STATE(946),
    [ts_builtin_sym_end] = ACTIONS(1519),
    [anon_sym___END__] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_RBRACE] = ACTIONS(1519),
    [anon_sym_RPAREN] = ACTIONS(1519),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_end] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_unless] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_until] = ACTIONS(1519),
    [anon_sym_rescue] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(1519),
    [anon_sym_elsif] = ACTIONS(1519),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_then] = ACTIONS(1519),
    [anon_sym_ensure] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1519),
    [anon_sym_COLON_COLON2] = ACTIONS(1519),
    [anon_sym_AMP_DOT] = ACTIONS(1519),
    [anon_sym_PLUS_EQ] = ACTIONS(1519),
    [anon_sym_DASH_EQ] = ACTIONS(1519),
    [anon_sym_STAR_EQ] = ACTIONS(1519),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1519),
    [anon_sym_SLASH_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1519),
    [anon_sym_AMP_EQ] = ACTIONS(1519),
    [anon_sym_PERCENT_EQ] = ACTIONS(1519),
    [anon_sym_GT_GT_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_EQ] = ACTIONS(1519),
    [anon_sym_CARET_EQ] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1519),
    [anon_sym_DOT_DOT] = ACTIONS(1521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1519),
    [anon_sym_and] = ACTIONS(1519),
    [anon_sym_or] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1521),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_EQ] = ACTIONS(1519),
    [anon_sym_CARET] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1519),
    [anon_sym_LT_EQ_GT] = ACTIONS(1519),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_BANG_TILDE] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1519),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1519),
    [sym__binary_star] = ACTIONS(1519),
  },
  [947] = {
    [sym_heredoc_body] = STATE(947),
    [sym_identifier] = ACTIONS(498),
    [anon_sym_BEGIN] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(472),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_END] = ACTIONS(498),
    [anon_sym_def] = ACTIONS(498),
    [anon_sym_LPAREN] = ACTIONS(472),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SEMI] = ACTIONS(472),
    [anon_sym_STAR] = ACTIONS(472),
    [anon_sym_class] = ACTIONS(498),
    [anon_sym_module] = ACTIONS(498),
    [anon_sym_end] = ACTIONS(498),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_yield] = ACTIONS(498),
    [anon_sym_break] = ACTIONS(498),
    [anon_sym_next] = ACTIONS(498),
    [anon_sym_redo] = ACTIONS(498),
    [anon_sym_retry] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_unless] = ACTIONS(498),
    [anon_sym_while] = ACTIONS(498),
    [anon_sym_until] = ACTIONS(498),
    [anon_sym_rescue] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(498),
    [anon_sym_case] = ACTIONS(498),
    [anon_sym_when] = ACTIONS(498),
    [anon_sym_elsif] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_begin] = ACTIONS(498),
    [anon_sym_ensure] = ACTIONS(498),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_defined_QMARK] = ACTIONS(472),
    [anon_sym_not] = ACTIONS(498),
    [anon_sym_BANG] = ACTIONS(472),
    [anon_sym_TILDE] = ACTIONS(472),
    [sym_constant] = ACTIONS(498),
    [sym_instance_variable] = ACTIONS(472),
    [sym_class_variable] = ACTIONS(472),
    [sym_global_variable] = ACTIONS(472),
    [anon_sym_undef] = ACTIONS(498),
    [anon_sym_alias] = ACTIONS(498),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(498),
    [sym_float] = ACTIONS(498),
    [sym_complex] = ACTIONS(472),
    [sym_super] = ACTIONS(498),
    [anon_sym_true] = ACTIONS(498),
    [anon_sym_TRUE] = ACTIONS(498),
    [anon_sym_false] = ACTIONS(498),
    [anon_sym_FALSE] = ACTIONS(498),
    [sym_self] = ACTIONS(498),
    [anon_sym_nil] = ACTIONS(498),
    [anon_sym_NIL] = ACTIONS(498),
    [sym_character] = ACTIONS(472),
    [anon_sym_LBRACK2] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(472),
    [sym__simple_symbol] = ACTIONS(472),
    [sym__string_start] = ACTIONS(472),
    [sym__symbol_start] = ACTIONS(472),
    [sym__subshell_start] = ACTIONS(472),
    [sym__regex_start] = ACTIONS(472),
    [sym__string_array_start] = ACTIONS(472),
    [sym__symbol_array_start] = ACTIONS(472),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(472),
    [sym__unary_minus] = ACTIONS(472),
  },
  [948] = {
    [sym_heredoc_body] = STATE(948),
    [ts_builtin_sym_end] = ACTIONS(1487),
    [anon_sym___END__] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_STAR_STAR] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_end] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_unless] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_until] = ACTIONS(1487),
    [anon_sym_rescue] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1487),
    [anon_sym_elsif] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_then] = ACTIONS(1487),
    [anon_sym_ensure] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_COLON_COLON2] = ACTIONS(1487),
    [anon_sym_AMP_DOT] = ACTIONS(1487),
    [anon_sym_PLUS_EQ] = ACTIONS(1487),
    [anon_sym_DASH_EQ] = ACTIONS(1487),
    [anon_sym_STAR_EQ] = ACTIONS(1487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1487),
    [anon_sym_SLASH_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1487),
    [anon_sym_AMP_EQ] = ACTIONS(1487),
    [anon_sym_PERCENT_EQ] = ACTIONS(1487),
    [anon_sym_GT_GT_EQ] = ACTIONS(1487),
    [anon_sym_LT_LT_EQ] = ACTIONS(1487),
    [anon_sym_CARET_EQ] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1487),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1487),
    [anon_sym_and] = ACTIONS(1487),
    [anon_sym_or] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE] = ACTIONS(1489),
    [anon_sym_AMP_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1489),
    [anon_sym_GT_GT] = ACTIONS(1489),
    [anon_sym_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(1489),
    [anon_sym_GT_EQ] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_SLASH] = ACTIONS(1489),
    [anon_sym_PERCENT] = ACTIONS(1489),
    [anon_sym_EQ_EQ] = ACTIONS(1489),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1487),
    [anon_sym_LT_EQ_GT] = ACTIONS(1487),
    [anon_sym_EQ_TILDE] = ACTIONS(1487),
    [anon_sym_BANG_TILDE] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1487),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1487),
    [sym__binary_star] = ACTIONS(1487),
  },
  [949] = {
    [sym_heredoc_body] = STATE(949),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [950] = {
    [sym_heredoc_body] = STATE(950),
    [aux_sym__mlhs_repeat1] = STATE(2545),
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym___END__] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_COLON_COLON2] = ACTIONS(1437),
    [anon_sym_AMP_DOT] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1537),
    [anon_sym_DASH_EQ] = ACTIONS(1537),
    [anon_sym_STAR_EQ] = ACTIONS(1537),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1537),
    [anon_sym_SLASH_EQ] = ACTIONS(1537),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1537),
    [anon_sym_PIPE_EQ] = ACTIONS(1537),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1537),
    [anon_sym_AMP_EQ] = ACTIONS(1537),
    [anon_sym_PERCENT_EQ] = ACTIONS(1537),
    [anon_sym_GT_GT_EQ] = ACTIONS(1537),
    [anon_sym_LT_LT_EQ] = ACTIONS(1537),
    [anon_sym_CARET_EQ] = ACTIONS(1537),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_LT_EQ_GT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_BANG_TILDE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1437),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1437),
    [sym__binary_star] = ACTIONS(1437),
  },
  [951] = {
    [sym_heredoc_body] = STATE(951),
    [aux_sym__mlhs_repeat1] = STATE(2545),
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym___END__] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_COLON_COLON2] = ACTIONS(1437),
    [anon_sym_AMP_DOT] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1543),
    [anon_sym_DASH_EQ] = ACTIONS(1543),
    [anon_sym_STAR_EQ] = ACTIONS(1543),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1543),
    [anon_sym_SLASH_EQ] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1543),
    [anon_sym_PIPE_EQ] = ACTIONS(1543),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1543),
    [anon_sym_AMP_EQ] = ACTIONS(1543),
    [anon_sym_PERCENT_EQ] = ACTIONS(1543),
    [anon_sym_GT_GT_EQ] = ACTIONS(1543),
    [anon_sym_LT_LT_EQ] = ACTIONS(1543),
    [anon_sym_CARET_EQ] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_LT_EQ_GT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_BANG_TILDE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1437),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1437),
    [sym__binary_star] = ACTIONS(1437),
  },
  [952] = {
    [sym_heredoc_body] = STATE(952),
    [aux_sym__mlhs_repeat1] = STATE(2545),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_COLON_COLON2] = ACTIONS(1437),
    [anon_sym_AMP_DOT] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1547),
    [anon_sym_DASH_EQ] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1547),
    [anon_sym_SLASH_EQ] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1547),
    [anon_sym_PERCENT_EQ] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1547),
    [anon_sym_LT_LT_EQ] = ACTIONS(1547),
    [anon_sym_CARET_EQ] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_LT_EQ_GT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_BANG_TILDE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1437),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1437),
    [sym__binary_star] = ACTIONS(1437),
  },
  [953] = {
    [sym_heredoc_body] = STATE(953),
    [sym_identifier] = ACTIONS(1549),
    [anon_sym_BEGIN] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_END] = ACTIONS(1549),
    [anon_sym_def] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_COLON_COLON] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_class] = ACTIONS(1549),
    [anon_sym_module] = ACTIONS(1549),
    [anon_sym_end] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_next] = ACTIONS(1549),
    [anon_sym_redo] = ACTIONS(1549),
    [anon_sym_retry] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_unless] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_rescue] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_begin] = ACTIONS(1549),
    [anon_sym_ensure] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_defined_QMARK] = ACTIONS(1551),
    [anon_sym_not] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_constant] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1551),
    [sym_class_variable] = ACTIONS(1551),
    [sym_global_variable] = ACTIONS(1551),
    [anon_sym_undef] = ACTIONS(1549),
    [anon_sym_alias] = ACTIONS(1549),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1549),
    [sym_float] = ACTIONS(1549),
    [sym_complex] = ACTIONS(1551),
    [sym_super] = ACTIONS(1549),
    [anon_sym_true] = ACTIONS(1549),
    [anon_sym_TRUE] = ACTIONS(1549),
    [anon_sym_false] = ACTIONS(1549),
    [anon_sym_FALSE] = ACTIONS(1549),
    [sym_self] = ACTIONS(1549),
    [anon_sym_nil] = ACTIONS(1549),
    [anon_sym_NIL] = ACTIONS(1549),
    [sym_character] = ACTIONS(1551),
    [anon_sym_LBRACK2] = ACTIONS(1551),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [sym__line_break] = ACTIONS(1551),
    [sym__simple_symbol] = ACTIONS(1551),
    [sym__string_start] = ACTIONS(1551),
    [sym__symbol_start] = ACTIONS(1551),
    [sym__subshell_start] = ACTIONS(1551),
    [sym__regex_start] = ACTIONS(1551),
    [sym__string_array_start] = ACTIONS(1551),
    [sym__symbol_array_start] = ACTIONS(1551),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1551),
    [sym__unary_minus] = ACTIONS(1551),
  },
  [954] = {
    [sym_heredoc_body] = STATE(954),
    [sym_identifier] = ACTIONS(1553),
    [anon_sym_BEGIN] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_END] = ACTIONS(1553),
    [anon_sym_def] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_COLON_COLON] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_class] = ACTIONS(1553),
    [anon_sym_module] = ACTIONS(1553),
    [anon_sym_end] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1553),
    [anon_sym_redo] = ACTIONS(1553),
    [anon_sym_retry] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_unless] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_until] = ACTIONS(1553),
    [anon_sym_rescue] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(1553),
    [anon_sym_ensure] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1555),
    [anon_sym_not] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1555),
    [sym_constant] = ACTIONS(1553),
    [sym_instance_variable] = ACTIONS(1555),
    [sym_class_variable] = ACTIONS(1555),
    [sym_global_variable] = ACTIONS(1555),
    [anon_sym_undef] = ACTIONS(1553),
    [anon_sym_alias] = ACTIONS(1553),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1553),
    [sym_float] = ACTIONS(1553),
    [sym_complex] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(1553),
    [anon_sym_TRUE] = ACTIONS(1553),
    [anon_sym_false] = ACTIONS(1553),
    [anon_sym_FALSE] = ACTIONS(1553),
    [sym_self] = ACTIONS(1553),
    [anon_sym_nil] = ACTIONS(1553),
    [anon_sym_NIL] = ACTIONS(1553),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACK2] = ACTIONS(1555),
    [anon_sym_DASH_GT] = ACTIONS(1555),
    [sym__line_break] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1555),
    [sym__string_start] = ACTIONS(1555),
    [sym__symbol_start] = ACTIONS(1555),
    [sym__subshell_start] = ACTIONS(1555),
    [sym__regex_start] = ACTIONS(1555),
    [sym__string_array_start] = ACTIONS(1555),
    [sym__symbol_array_start] = ACTIONS(1555),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [sym__unary_minus] = ACTIONS(1555),
  },
  [955] = {
    [sym_heredoc_body] = STATE(955),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_BEGIN] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_END] = ACTIONS(1557),
    [anon_sym_def] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1559),
    [anon_sym_COLON_COLON] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_class] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_end] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_next] = ACTIONS(1557),
    [anon_sym_redo] = ACTIONS(1557),
    [anon_sym_retry] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_until] = ACTIONS(1557),
    [anon_sym_rescue] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_begin] = ACTIONS(1557),
    [anon_sym_ensure] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym_constant] = ACTIONS(1557),
    [sym_instance_variable] = ACTIONS(1559),
    [sym_class_variable] = ACTIONS(1559),
    [sym_global_variable] = ACTIONS(1559),
    [anon_sym_undef] = ACTIONS(1557),
    [anon_sym_alias] = ACTIONS(1557),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1557),
    [sym_float] = ACTIONS(1557),
    [sym_complex] = ACTIONS(1559),
    [sym_super] = ACTIONS(1557),
    [anon_sym_true] = ACTIONS(1557),
    [anon_sym_TRUE] = ACTIONS(1557),
    [anon_sym_false] = ACTIONS(1557),
    [anon_sym_FALSE] = ACTIONS(1557),
    [sym_self] = ACTIONS(1557),
    [anon_sym_nil] = ACTIONS(1557),
    [anon_sym_NIL] = ACTIONS(1557),
    [sym_character] = ACTIONS(1559),
    [anon_sym_LBRACK2] = ACTIONS(1559),
    [anon_sym_DASH_GT] = ACTIONS(1559),
    [sym__line_break] = ACTIONS(1559),
    [sym__simple_symbol] = ACTIONS(1559),
    [sym__string_start] = ACTIONS(1559),
    [sym__symbol_start] = ACTIONS(1559),
    [sym__subshell_start] = ACTIONS(1559),
    [sym__regex_start] = ACTIONS(1559),
    [sym__string_array_start] = ACTIONS(1559),
    [sym__symbol_array_start] = ACTIONS(1559),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1559),
    [sym__unary_minus] = ACTIONS(1559),
  },
  [956] = {
    [sym_heredoc_body] = STATE(956),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_BEGIN] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_END] = ACTIONS(1445),
    [anon_sym_def] = ACTIONS(1445),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COLON_COLON] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_end] = ACTIONS(1445),
    [anon_sym_return] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1445),
    [anon_sym_break] = ACTIONS(1445),
    [anon_sym_next] = ACTIONS(1445),
    [anon_sym_redo] = ACTIONS(1445),
    [anon_sym_retry] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_unless] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1445),
    [anon_sym_until] = ACTIONS(1445),
    [anon_sym_rescue] = ACTIONS(1445),
    [anon_sym_for] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_begin] = ACTIONS(1445),
    [anon_sym_ensure] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_defined_QMARK] = ACTIONS(1447),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [sym_constant] = ACTIONS(1445),
    [sym_instance_variable] = ACTIONS(1447),
    [sym_class_variable] = ACTIONS(1447),
    [sym_global_variable] = ACTIONS(1447),
    [anon_sym_undef] = ACTIONS(1445),
    [anon_sym_alias] = ACTIONS(1445),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1445),
    [sym_float] = ACTIONS(1445),
    [sym_complex] = ACTIONS(1447),
    [sym_super] = ACTIONS(1445),
    [anon_sym_true] = ACTIONS(1445),
    [anon_sym_TRUE] = ACTIONS(1445),
    [anon_sym_false] = ACTIONS(1445),
    [anon_sym_FALSE] = ACTIONS(1445),
    [sym_self] = ACTIONS(1445),
    [anon_sym_nil] = ACTIONS(1445),
    [anon_sym_NIL] = ACTIONS(1445),
    [sym_character] = ACTIONS(1447),
    [anon_sym_LBRACK2] = ACTIONS(1447),
    [anon_sym_DASH_GT] = ACTIONS(1447),
    [sym__simple_symbol] = ACTIONS(1447),
    [sym__string_start] = ACTIONS(1447),
    [sym__symbol_start] = ACTIONS(1447),
    [sym__subshell_start] = ACTIONS(1447),
    [sym__regex_start] = ACTIONS(1447),
    [sym__string_array_start] = ACTIONS(1447),
    [sym__symbol_array_start] = ACTIONS(1447),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1447),
    [sym__unary_minus] = ACTIONS(1447),
  },
  [957] = {
    [sym_heredoc_body] = STATE(957),
    [sym_identifier] = ACTIONS(1561),
    [anon_sym_BEGIN] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_END] = ACTIONS(1561),
    [anon_sym_def] = ACTIONS(1561),
    [anon_sym_LPAREN] = ACTIONS(1563),
    [anon_sym_COLON_COLON] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_end] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1561),
    [anon_sym_redo] = ACTIONS(1561),
    [anon_sym_retry] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_unless] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_until] = ACTIONS(1561),
    [anon_sym_rescue] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(1561),
    [anon_sym_ensure] = ACTIONS(1561),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1561),
    [sym_instance_variable] = ACTIONS(1563),
    [sym_class_variable] = ACTIONS(1563),
    [sym_global_variable] = ACTIONS(1563),
    [anon_sym_undef] = ACTIONS(1561),
    [anon_sym_alias] = ACTIONS(1561),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1561),
    [sym_float] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1563),
    [sym_super] = ACTIONS(1561),
    [anon_sym_true] = ACTIONS(1561),
    [anon_sym_TRUE] = ACTIONS(1561),
    [anon_sym_false] = ACTIONS(1561),
    [anon_sym_FALSE] = ACTIONS(1561),
    [sym_self] = ACTIONS(1561),
    [anon_sym_nil] = ACTIONS(1561),
    [anon_sym_NIL] = ACTIONS(1561),
    [sym_character] = ACTIONS(1563),
    [anon_sym_LBRACK2] = ACTIONS(1563),
    [anon_sym_DASH_GT] = ACTIONS(1563),
    [sym__line_break] = ACTIONS(1563),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym__string_start] = ACTIONS(1563),
    [sym__symbol_start] = ACTIONS(1563),
    [sym__subshell_start] = ACTIONS(1563),
    [sym__regex_start] = ACTIONS(1563),
    [sym__string_array_start] = ACTIONS(1563),
    [sym__symbol_array_start] = ACTIONS(1563),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1563),
    [sym__unary_minus] = ACTIONS(1563),
  },
  [958] = {
    [sym_heredoc_body] = STATE(958),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_BEGIN] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_END] = ACTIONS(1565),
    [anon_sym_def] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_COLON_COLON] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_class] = ACTIONS(1565),
    [anon_sym_module] = ACTIONS(1565),
    [anon_sym_end] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_yield] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_next] = ACTIONS(1565),
    [anon_sym_redo] = ACTIONS(1565),
    [anon_sym_retry] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_unless] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_until] = ACTIONS(1565),
    [anon_sym_rescue] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_begin] = ACTIONS(1565),
    [anon_sym_ensure] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1567),
    [sym_class_variable] = ACTIONS(1567),
    [sym_global_variable] = ACTIONS(1567),
    [anon_sym_undef] = ACTIONS(1565),
    [anon_sym_alias] = ACTIONS(1565),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1565),
    [sym_float] = ACTIONS(1565),
    [sym_complex] = ACTIONS(1567),
    [sym_super] = ACTIONS(1565),
    [anon_sym_true] = ACTIONS(1565),
    [anon_sym_TRUE] = ACTIONS(1565),
    [anon_sym_false] = ACTIONS(1565),
    [anon_sym_FALSE] = ACTIONS(1565),
    [sym_self] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(1565),
    [anon_sym_NIL] = ACTIONS(1565),
    [sym_character] = ACTIONS(1567),
    [anon_sym_LBRACK2] = ACTIONS(1567),
    [anon_sym_DASH_GT] = ACTIONS(1567),
    [sym__line_break] = ACTIONS(1567),
    [sym__simple_symbol] = ACTIONS(1567),
    [sym__string_start] = ACTIONS(1567),
    [sym__symbol_start] = ACTIONS(1567),
    [sym__subshell_start] = ACTIONS(1567),
    [sym__regex_start] = ACTIONS(1567),
    [sym__string_array_start] = ACTIONS(1567),
    [sym__symbol_array_start] = ACTIONS(1567),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1567),
    [sym__unary_minus] = ACTIONS(1567),
  },
  [959] = {
    [sym_heredoc_body] = STATE(959),
    [aux_sym__mlhs_repeat1] = STATE(2545),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_COLON_COLON2] = ACTIONS(1437),
    [anon_sym_AMP_DOT] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1571),
    [anon_sym_DASH_EQ] = ACTIONS(1571),
    [anon_sym_STAR_EQ] = ACTIONS(1571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1571),
    [anon_sym_SLASH_EQ] = ACTIONS(1571),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1571),
    [anon_sym_PIPE_EQ] = ACTIONS(1571),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1571),
    [anon_sym_AMP_EQ] = ACTIONS(1571),
    [anon_sym_PERCENT_EQ] = ACTIONS(1571),
    [anon_sym_GT_GT_EQ] = ACTIONS(1571),
    [anon_sym_LT_LT_EQ] = ACTIONS(1571),
    [anon_sym_CARET_EQ] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_LT_EQ_GT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_BANG_TILDE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1437),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1437),
    [sym__binary_star] = ACTIONS(1437),
  },
  [960] = {
    [sym_heredoc_body] = STATE(960),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_BEGIN] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_END] = ACTIONS(1573),
    [anon_sym_def] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_class] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_end] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_next] = ACTIONS(1573),
    [anon_sym_redo] = ACTIONS(1573),
    [anon_sym_retry] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_unless] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_until] = ACTIONS(1573),
    [anon_sym_rescue] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(1573),
    [anon_sym_ensure] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1575),
    [sym_constant] = ACTIONS(1573),
    [sym_instance_variable] = ACTIONS(1575),
    [sym_class_variable] = ACTIONS(1575),
    [sym_global_variable] = ACTIONS(1575),
    [anon_sym_undef] = ACTIONS(1573),
    [anon_sym_alias] = ACTIONS(1573),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [sym_complex] = ACTIONS(1575),
    [sym_super] = ACTIONS(1573),
    [anon_sym_true] = ACTIONS(1573),
    [anon_sym_TRUE] = ACTIONS(1573),
    [anon_sym_false] = ACTIONS(1573),
    [anon_sym_FALSE] = ACTIONS(1573),
    [sym_self] = ACTIONS(1573),
    [anon_sym_nil] = ACTIONS(1573),
    [anon_sym_NIL] = ACTIONS(1573),
    [sym_character] = ACTIONS(1575),
    [anon_sym_LBRACK2] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym__line_break] = ACTIONS(1575),
    [sym__simple_symbol] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1575),
    [sym__symbol_start] = ACTIONS(1575),
    [sym__subshell_start] = ACTIONS(1575),
    [sym__regex_start] = ACTIONS(1575),
    [sym__string_array_start] = ACTIONS(1575),
    [sym__symbol_array_start] = ACTIONS(1575),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1575),
    [sym__unary_minus] = ACTIONS(1575),
  },
  [961] = {
    [sym_heredoc_body] = STATE(961),
    [sym_identifier] = ACTIONS(1577),
    [anon_sym_BEGIN] = ACTIONS(1577),
    [anon_sym_LBRACE] = ACTIONS(1579),
    [anon_sym_END] = ACTIONS(1577),
    [anon_sym_def] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_COLON_COLON] = ACTIONS(1579),
    [anon_sym_SEMI] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_class] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_end] = ACTIONS(1577),
    [anon_sym_return] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(1577),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1577),
    [anon_sym_redo] = ACTIONS(1577),
    [anon_sym_retry] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(1577),
    [anon_sym_unless] = ACTIONS(1577),
    [anon_sym_while] = ACTIONS(1577),
    [anon_sym_until] = ACTIONS(1577),
    [anon_sym_rescue] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(1577),
    [anon_sym_case] = ACTIONS(1577),
    [anon_sym_else] = ACTIONS(1577),
    [anon_sym_begin] = ACTIONS(1577),
    [anon_sym_ensure] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(1579),
    [anon_sym_not] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1579),
    [anon_sym_TILDE] = ACTIONS(1579),
    [sym_constant] = ACTIONS(1577),
    [sym_instance_variable] = ACTIONS(1579),
    [sym_class_variable] = ACTIONS(1579),
    [sym_global_variable] = ACTIONS(1579),
    [anon_sym_undef] = ACTIONS(1577),
    [anon_sym_alias] = ACTIONS(1577),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1577),
    [sym_float] = ACTIONS(1577),
    [sym_complex] = ACTIONS(1579),
    [sym_super] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(1577),
    [anon_sym_TRUE] = ACTIONS(1577),
    [anon_sym_false] = ACTIONS(1577),
    [anon_sym_FALSE] = ACTIONS(1577),
    [sym_self] = ACTIONS(1577),
    [anon_sym_nil] = ACTIONS(1577),
    [anon_sym_NIL] = ACTIONS(1577),
    [sym_character] = ACTIONS(1579),
    [anon_sym_LBRACK2] = ACTIONS(1579),
    [anon_sym_DASH_GT] = ACTIONS(1579),
    [sym__line_break] = ACTIONS(1579),
    [sym__simple_symbol] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1579),
    [sym__symbol_start] = ACTIONS(1579),
    [sym__subshell_start] = ACTIONS(1579),
    [sym__regex_start] = ACTIONS(1579),
    [sym__string_array_start] = ACTIONS(1579),
    [sym__symbol_array_start] = ACTIONS(1579),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1579),
    [sym__unary_minus] = ACTIONS(1579),
  },
  [962] = {
    [sym_heredoc_body] = STATE(962),
    [sym_identifier] = ACTIONS(1581),
    [anon_sym_BEGIN] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1583),
    [anon_sym_END] = ACTIONS(1581),
    [anon_sym_def] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_COLON_COLON] = ACTIONS(1583),
    [anon_sym_SEMI] = ACTIONS(1583),
    [anon_sym_STAR] = ACTIONS(1583),
    [anon_sym_class] = ACTIONS(1581),
    [anon_sym_module] = ACTIONS(1581),
    [anon_sym_end] = ACTIONS(1581),
    [anon_sym_return] = ACTIONS(1581),
    [anon_sym_yield] = ACTIONS(1581),
    [anon_sym_break] = ACTIONS(1581),
    [anon_sym_next] = ACTIONS(1581),
    [anon_sym_redo] = ACTIONS(1581),
    [anon_sym_retry] = ACTIONS(1581),
    [anon_sym_if] = ACTIONS(1581),
    [anon_sym_unless] = ACTIONS(1581),
    [anon_sym_while] = ACTIONS(1581),
    [anon_sym_until] = ACTIONS(1581),
    [anon_sym_rescue] = ACTIONS(1581),
    [anon_sym_for] = ACTIONS(1581),
    [anon_sym_case] = ACTIONS(1581),
    [anon_sym_else] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(1581),
    [anon_sym_ensure] = ACTIONS(1581),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1581),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_constant] = ACTIONS(1581),
    [sym_instance_variable] = ACTIONS(1583),
    [sym_class_variable] = ACTIONS(1583),
    [sym_global_variable] = ACTIONS(1583),
    [anon_sym_undef] = ACTIONS(1581),
    [anon_sym_alias] = ACTIONS(1581),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1581),
    [sym_float] = ACTIONS(1581),
    [sym_complex] = ACTIONS(1583),
    [sym_super] = ACTIONS(1581),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_TRUE] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [anon_sym_FALSE] = ACTIONS(1581),
    [sym_self] = ACTIONS(1581),
    [anon_sym_nil] = ACTIONS(1581),
    [anon_sym_NIL] = ACTIONS(1581),
    [sym_character] = ACTIONS(1583),
    [anon_sym_LBRACK2] = ACTIONS(1583),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym__line_break] = ACTIONS(1583),
    [sym__simple_symbol] = ACTIONS(1583),
    [sym__string_start] = ACTIONS(1583),
    [sym__symbol_start] = ACTIONS(1583),
    [sym__subshell_start] = ACTIONS(1583),
    [sym__regex_start] = ACTIONS(1583),
    [sym__string_array_start] = ACTIONS(1583),
    [sym__symbol_array_start] = ACTIONS(1583),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(1583),
  },
  [963] = {
    [sym_heredoc_body] = STATE(963),
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_BEGIN] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_END] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_COLON_COLON] = ACTIONS(1587),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(1587),
    [anon_sym_class] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_end] = ACTIONS(1585),
    [anon_sym_return] = ACTIONS(1585),
    [anon_sym_yield] = ACTIONS(1585),
    [anon_sym_break] = ACTIONS(1585),
    [anon_sym_next] = ACTIONS(1585),
    [anon_sym_redo] = ACTIONS(1585),
    [anon_sym_retry] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_unless] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_until] = ACTIONS(1585),
    [anon_sym_rescue] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_case] = ACTIONS(1585),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_begin] = ACTIONS(1585),
    [anon_sym_ensure] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_defined_QMARK] = ACTIONS(1587),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(1585),
    [sym_instance_variable] = ACTIONS(1587),
    [sym_class_variable] = ACTIONS(1587),
    [sym_global_variable] = ACTIONS(1587),
    [anon_sym_undef] = ACTIONS(1585),
    [anon_sym_alias] = ACTIONS(1585),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1585),
    [sym_float] = ACTIONS(1585),
    [sym_complex] = ACTIONS(1587),
    [sym_super] = ACTIONS(1585),
    [anon_sym_true] = ACTIONS(1585),
    [anon_sym_TRUE] = ACTIONS(1585),
    [anon_sym_false] = ACTIONS(1585),
    [anon_sym_FALSE] = ACTIONS(1585),
    [sym_self] = ACTIONS(1585),
    [anon_sym_nil] = ACTIONS(1585),
    [anon_sym_NIL] = ACTIONS(1585),
    [sym_character] = ACTIONS(1587),
    [anon_sym_LBRACK2] = ACTIONS(1587),
    [anon_sym_DASH_GT] = ACTIONS(1587),
    [sym__line_break] = ACTIONS(1587),
    [sym__simple_symbol] = ACTIONS(1587),
    [sym__string_start] = ACTIONS(1587),
    [sym__symbol_start] = ACTIONS(1587),
    [sym__subshell_start] = ACTIONS(1587),
    [sym__regex_start] = ACTIONS(1587),
    [sym__string_array_start] = ACTIONS(1587),
    [sym__symbol_array_start] = ACTIONS(1587),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1587),
    [sym__unary_minus] = ACTIONS(1587),
  },
  [964] = {
    [sym_heredoc_body] = STATE(964),
    [sym_identifier] = ACTIONS(1589),
    [anon_sym_BEGIN] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(1591),
    [anon_sym_END] = ACTIONS(1589),
    [anon_sym_def] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_COLON_COLON] = ACTIONS(1591),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_class] = ACTIONS(1589),
    [anon_sym_module] = ACTIONS(1589),
    [anon_sym_end] = ACTIONS(1589),
    [anon_sym_return] = ACTIONS(1589),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_break] = ACTIONS(1589),
    [anon_sym_next] = ACTIONS(1589),
    [anon_sym_redo] = ACTIONS(1589),
    [anon_sym_retry] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1589),
    [anon_sym_unless] = ACTIONS(1589),
    [anon_sym_while] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1589),
    [anon_sym_rescue] = ACTIONS(1589),
    [anon_sym_for] = ACTIONS(1589),
    [anon_sym_case] = ACTIONS(1589),
    [anon_sym_else] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(1589),
    [anon_sym_ensure] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(1589),
    [anon_sym_defined_QMARK] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1589),
    [anon_sym_BANG] = ACTIONS(1591),
    [anon_sym_TILDE] = ACTIONS(1591),
    [sym_constant] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(1591),
    [sym_class_variable] = ACTIONS(1591),
    [sym_global_variable] = ACTIONS(1591),
    [anon_sym_undef] = ACTIONS(1589),
    [anon_sym_alias] = ACTIONS(1589),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1589),
    [sym_float] = ACTIONS(1589),
    [sym_complex] = ACTIONS(1591),
    [sym_super] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(1589),
    [anon_sym_TRUE] = ACTIONS(1589),
    [anon_sym_false] = ACTIONS(1589),
    [anon_sym_FALSE] = ACTIONS(1589),
    [sym_self] = ACTIONS(1589),
    [anon_sym_nil] = ACTIONS(1589),
    [anon_sym_NIL] = ACTIONS(1589),
    [sym_character] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1591),
    [anon_sym_DASH_GT] = ACTIONS(1591),
    [sym__line_break] = ACTIONS(1591),
    [sym__simple_symbol] = ACTIONS(1591),
    [sym__string_start] = ACTIONS(1591),
    [sym__symbol_start] = ACTIONS(1591),
    [sym__subshell_start] = ACTIONS(1591),
    [sym__regex_start] = ACTIONS(1591),
    [sym__string_array_start] = ACTIONS(1591),
    [sym__symbol_array_start] = ACTIONS(1591),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1591),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(965), 1,
      sym_heredoc_body,
    ACTIONS(1447), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1445), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [74] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(966), 1,
      sym_heredoc_body,
    ACTIONS(1533), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1531), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [148] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(967), 1,
      sym_heredoc_body,
    ACTIONS(1525), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1523), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [222] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(968), 1,
      sym_heredoc_body,
    ACTIONS(472), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(498), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [296] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(969), 1,
      sym_heredoc_body,
    ACTIONS(1579), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1577), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [369] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(970), 1,
      sym_heredoc_body,
    ACTIONS(1591), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1589), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [442] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(971), 1,
      sym_heredoc_body,
    ACTIONS(1595), 24,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1593), 35,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_end,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [515] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(972), 1,
      sym_heredoc_body,
    ACTIONS(1583), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1581), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [588] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(973), 1,
      sym_heredoc_body,
    ACTIONS(1587), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1585), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [661] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_LPAREN2,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    ACTIONS(1599), 1,
      anon_sym_do,
    STATE(974), 1,
      sym_heredoc_body,
    STATE(986), 1,
      sym_argument_list,
    STATE(1006), 1,
      sym_block,
    STATE(1019), 1,
      sym_do_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [744] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(975), 1,
      sym_heredoc_body,
    ACTIONS(1575), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1573), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [817] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(976), 1,
      sym_heredoc_body,
    ACTIONS(1555), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1553), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [890] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_LPAREN2,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    STATE(977), 1,
      sym_heredoc_body,
    STATE(983), 1,
      sym_argument_list,
    STATE(1006), 1,
      sym_block,
    STATE(1019), 1,
      sym_do_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [971] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(978), 1,
      sym_heredoc_body,
    ACTIONS(1567), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1565), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [1044] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LPAREN2,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1603), 1,
      anon_sym_do,
    STATE(979), 1,
      sym_heredoc_body,
    STATE(1004), 1,
      sym_argument_list,
    STATE(1080), 1,
      sym_do_block,
    STATE(1093), 1,
      sym_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1126] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LPAREN2,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    STATE(980), 1,
      sym_heredoc_body,
    STATE(992), 1,
      sym_argument_list,
    STATE(1080), 1,
      sym_do_block,
    STATE(1093), 1,
      sym_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1206] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    ACTIONS(1607), 1,
      anon_sym_do,
    ACTIONS(1609), 1,
      anon_sym_LPAREN2,
    STATE(981), 1,
      sym_heredoc_body,
    STATE(1001), 1,
      sym_argument_list,
    STATE(1072), 1,
      sym_block,
    STATE(1074), 1,
      sym_do_block,
    ACTIONS(115), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 33,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      anon_sym_COLON,
    STATE(982), 1,
      sym_heredoc_body,
    ACTIONS(921), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(923), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    STATE(983), 1,
      sym_heredoc_body,
    STATE(1025), 1,
      sym_do_block,
    STATE(1029), 1,
      sym_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1436] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 1,
      anon_sym_EQ,
    STATE(984), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1613), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1515] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(1615), 1,
      anon_sym_EQ,
    STATE(985), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1617), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    ACTIONS(1599), 1,
      anon_sym_do,
    STATE(986), 1,
      sym_heredoc_body,
    STATE(1025), 1,
      sym_do_block,
    STATE(1029), 1,
      sym_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      anon_sym_COLON,
    STATE(987), 1,
      sym_heredoc_body,
    ACTIONS(921), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(923), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1742] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1619), 1,
      anon_sym_EQ,
    STATE(988), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1621), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1819] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    STATE(989), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1625), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1896] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    ACTIONS(1627), 1,
      anon_sym_COLON,
    STATE(990), 1,
      sym_heredoc_body,
    STATE(993), 1,
      aux_sym_chained_string_repeat1,
    STATE(1067), 1,
      sym_string,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1975] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(991), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1631), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2054] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    STATE(992), 1,
      sym_heredoc_body,
    STATE(1054), 1,
      sym_do_block,
    STATE(1087), 1,
      sym_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2128] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    STATE(993), 1,
      sym_heredoc_body,
    STATE(1002), 1,
      aux_sym_chained_string_repeat1,
    STATE(1067), 1,
      sym_string,
    ACTIONS(1635), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(994), 1,
      sym_heredoc_body,
    ACTIONS(971), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(973), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(995), 1,
      sym_heredoc_body,
    ACTIONS(1027), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1029), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(996), 1,
      sym_heredoc_body,
    ACTIONS(977), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(979), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(997), 1,
      sym_heredoc_body,
    ACTIONS(981), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(983), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2476] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    STATE(993), 1,
      aux_sym_chained_string_repeat1,
    STATE(998), 1,
      sym_heredoc_body,
    STATE(1067), 1,
      sym_string,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(999), 1,
      sym_heredoc_body,
    ACTIONS(985), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(987), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2620] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1637), 1,
      anon_sym_LBRACE,
    ACTIONS(1639), 1,
      anon_sym_do,
    ACTIONS(1641), 1,
      anon_sym_LPAREN2,
    STATE(1000), 1,
      sym_heredoc_body,
    STATE(1059), 1,
      sym_argument_list,
    STATE(1227), 1,
      sym_do_block,
    STATE(1228), 1,
      sym_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2702] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    ACTIONS(1607), 1,
      anon_sym_do,
    STATE(1001), 1,
      sym_heredoc_body,
    STATE(1069), 1,
      sym_block,
    STATE(1092), 1,
      sym_do_block,
    ACTIONS(1435), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 33,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2780] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1647), 1,
      sym__string_start,
    STATE(1067), 1,
      sym_string,
    STATE(1002), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1645), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1643), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2854] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      anon_sym_EQ,
    STATE(1003), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1652), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2928] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1603), 1,
      anon_sym_do,
    STATE(1004), 1,
      sym_heredoc_body,
    STATE(1054), 1,
      sym_do_block,
    STATE(1087), 1,
      sym_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1005), 1,
      sym_heredoc_body,
    ACTIONS(995), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(997), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1006), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1007), 1,
      sym_heredoc_body,
    ACTIONS(1455), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3206] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1008), 1,
      sym_heredoc_body,
    STATE(1148), 1,
      sym_argument_list,
    ACTIONS(275), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(273), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1009), 1,
      sym_heredoc_body,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 1,
      anon_sym_EQ,
    STATE(1010), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1656), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1011), 1,
      sym_heredoc_body,
    ACTIONS(985), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(987), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3488] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1012), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 46,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1013), 1,
      sym_heredoc_body,
    ACTIONS(1471), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1014), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1015), 1,
      sym_heredoc_body,
    ACTIONS(985), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(987), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1016), 1,
      sym_heredoc_body,
    ACTIONS(981), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(983), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1017), 1,
      sym_heredoc_body,
    ACTIONS(977), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(979), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1018), 1,
      sym_heredoc_body,
    ACTIONS(1467), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1465), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1019), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1020), 1,
      sym_heredoc_body,
    ACTIONS(971), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(973), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1021), 1,
      sym_heredoc_body,
    ACTIONS(995), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(997), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1022), 1,
      sym_heredoc_body,
    ACTIONS(921), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(923), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1023), 1,
      sym_heredoc_body,
    ACTIONS(1027), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1029), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1024), 1,
      sym_heredoc_body,
    ACTIONS(1475), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1025), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1026), 1,
      sym_heredoc_body,
    ACTIONS(1479), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4505] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1027), 1,
      sym_heredoc_body,
    STATE(1147), 1,
      sym_argument_list,
    ACTIONS(305), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(303), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1028), 1,
      sym_heredoc_body,
    ACTIONS(1027), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1029), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1029), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1030), 1,
      sym_heredoc_body,
    ACTIONS(1509), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1031), 1,
      sym_heredoc_body,
    ACTIONS(1505), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1032), 1,
      sym_heredoc_body,
    ACTIONS(1513), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1033), 1,
      sym_heredoc_body,
    ACTIONS(1521), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1034), 1,
      sym_heredoc_body,
    ACTIONS(1489), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1035), 1,
      sym_heredoc_body,
    ACTIONS(1493), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5114] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1036), 1,
      sym_heredoc_body,
    STATE(1149), 1,
      sym_argument_list,
    ACTIONS(1664), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1662), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5187] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1037), 1,
      sym_heredoc_body,
    STATE(1146), 1,
      sym_argument_list,
    ACTIONS(301), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(299), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1038), 1,
      sym_heredoc_body,
    ACTIONS(995), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(997), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1039), 1,
      sym_heredoc_body,
    ACTIONS(977), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(979), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1040), 1,
      sym_heredoc_body,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5463] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    ACTIONS(1666), 1,
      anon_sym_COLON,
    STATE(993), 1,
      aux_sym_chained_string_repeat1,
    STATE(1041), 1,
      sym_heredoc_body,
    STATE(1067), 1,
      sym_string,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1042), 1,
      sym_heredoc_body,
    ACTIONS(971), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(973), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1043), 1,
      sym_heredoc_body,
    ACTIONS(1497), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5674] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1044), 1,
      sym_heredoc_body,
    STATE(1145), 1,
      sym_argument_list,
    ACTIONS(297), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(295), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5747] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1045), 1,
      sym_heredoc_body,
    ACTIONS(1670), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1668), 46,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1046), 1,
      sym_heredoc_body,
    ACTIONS(1485), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1047), 1,
      sym_heredoc_body,
    ACTIONS(1485), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_EQ_GT,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1048), 1,
      sym_heredoc_body,
    ACTIONS(981), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(983), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6021] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1049), 1,
      sym_heredoc_body,
    STATE(1150), 1,
      sym_argument_list,
    ACTIONS(1674), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1672), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1050), 1,
      sym_heredoc_body,
    ACTIONS(1513), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1051), 1,
      sym_heredoc_body,
    ACTIONS(1493), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6228] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_EQ,
    STATE(1052), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1678), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1053), 1,
      sym_heredoc_body,
    ACTIONS(1475), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1054), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1055), 1,
      sym_heredoc_body,
    ACTIONS(1459), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1056), 1,
      sym_heredoc_body,
    ACTIONS(1493), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1057), 1,
      sym_heredoc_body,
    ACTIONS(1489), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1058), 1,
      sym_heredoc_body,
    ACTIONS(1521), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6704] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1637), 1,
      anon_sym_LBRACE,
    ACTIONS(1639), 1,
      anon_sym_do,
    STATE(1059), 1,
      sym_heredoc_body,
    STATE(1212), 1,
      sym_do_block,
    STATE(1229), 1,
      sym_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1060), 1,
      sym_heredoc_body,
    ACTIONS(1497), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1061), 1,
      sym_heredoc_body,
    ACTIONS(1505), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1062), 1,
      sym_heredoc_body,
    ACTIONS(1509), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1063), 1,
      sym_heredoc_body,
    ACTIONS(1455), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1064), 1,
      sym_heredoc_body,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1065), 1,
      sym_heredoc_body,
    ACTIONS(1479), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1066), 1,
      sym_heredoc_body,
    ACTIONS(1479), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7250] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1067), 1,
      sym_heredoc_body,
    ACTIONS(1682), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1680), 46,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1068), 1,
      sym_heredoc_body,
    ACTIONS(1497), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7386] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1069), 1,
      sym_heredoc_body,
    ACTIONS(1463), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1070), 1,
      sym_heredoc_body,
    ACTIONS(1483), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1481), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1071), 1,
      sym_heredoc_body,
    ACTIONS(1475), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1072), 1,
      sym_heredoc_body,
    ACTIONS(1501), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1101), 1,
      anon_sym_COLON,
    STATE(1073), 1,
      sym_heredoc_body,
    ACTIONS(921), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(923), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1074), 1,
      sym_heredoc_body,
    ACTIONS(1501), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7796] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_r,
    STATE(1075), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1076), 1,
      sym_heredoc_body,
    ACTIONS(1471), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1077), 1,
      sym_heredoc_body,
    ACTIONS(1489), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1078), 1,
      sym_heredoc_body,
    ACTIONS(1521), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1079), 1,
      sym_heredoc_body,
    ACTIONS(1513), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1080), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1081), 1,
      sym_heredoc_body,
    ACTIONS(1455), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1082), 1,
      sym_heredoc_body,
    ACTIONS(115), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1083), 1,
      sym_heredoc_body,
    ACTIONS(1467), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1465), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1084), 1,
      sym_heredoc_body,
    ACTIONS(1467), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1465), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1085), 1,
      sym_heredoc_body,
    ACTIONS(1451), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1086), 1,
      sym_heredoc_body,
    ACTIONS(1471), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1087), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1088), 1,
      sym_heredoc_body,
    ACTIONS(1505), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1089), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8798] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_r,
    STATE(1090), 1,
      sym_heredoc_body,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1091), 1,
      sym_heredoc_body,
    ACTIONS(1509), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1092), 1,
      sym_heredoc_body,
    ACTIONS(1463), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1093), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9068] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1094), 1,
      sym_heredoc_body,
    ACTIONS(1692), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1690), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9135] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1095), 1,
      sym_heredoc_body,
    ACTIONS(1696), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1694), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9202] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1096), 1,
      sym_heredoc_body,
    ACTIONS(1700), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1698), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(1702), 1,
      anon_sym_EQ,
    STATE(1097), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1704), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9342] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1098), 1,
      sym_heredoc_body,
    ACTIONS(1708), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1706), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9409] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(1710), 1,
      anon_sym_EQ,
    STATE(1099), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1712), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9482] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1100), 1,
      sym_heredoc_body,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9549] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1101), 1,
      sym_heredoc_body,
    ACTIONS(1716), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1714), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9616] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1102), 1,
      sym_heredoc_body,
    ACTIONS(1479), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9683] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1103), 1,
      sym_heredoc_body,
    ACTIONS(1720), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1718), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9750] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1104), 1,
      sym_heredoc_body,
    ACTIONS(1493), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9817] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1105), 1,
      sym_heredoc_body,
    ACTIONS(1724), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1722), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9884] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    ACTIONS(1609), 1,
      anon_sym_LPAREN2,
    STATE(1072), 1,
      sym_block,
    STATE(1074), 1,
      sym_do_block,
    STATE(1106), 1,
      sym_heredoc_body,
    STATE(1200), 1,
      sym_argument_list,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1107), 1,
      sym_heredoc_body,
    ACTIONS(981), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(983), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10028] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1108), 1,
      sym_heredoc_body,
    ACTIONS(1728), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1726), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10095] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1109), 1,
      sym_heredoc_body,
    ACTIONS(1732), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1730), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10162] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1110), 1,
      sym_heredoc_body,
    ACTIONS(1736), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1734), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10229] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1111), 1,
      sym_heredoc_body,
    ACTIONS(1740), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1738), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10296] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1112), 1,
      sym_heredoc_body,
    ACTIONS(1744), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1742), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10363] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1113), 1,
      sym_heredoc_body,
    ACTIONS(1489), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10430] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1114), 1,
      sym_heredoc_body,
    ACTIONS(1521), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1115), 1,
      sym_heredoc_body,
    ACTIONS(1027), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1029), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10564] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1116), 1,
      sym_heredoc_body,
    ACTIONS(1748), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1117), 1,
      sym_heredoc_body,
    ACTIONS(971), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(973), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10698] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1118), 1,
      sym_heredoc_body,
    ACTIONS(1752), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1750), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10765] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1119), 1,
      sym_heredoc_body,
    ACTIONS(1756), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1754), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10832] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1120), 1,
      sym_heredoc_body,
    ACTIONS(1760), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1758), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10899] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1121), 1,
      sym_heredoc_body,
    ACTIONS(1764), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1762), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10966] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1122), 1,
      sym_heredoc_body,
    ACTIONS(1768), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1766), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1123), 1,
      sym_heredoc_body,
    ACTIONS(985), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(987), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11100] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1124), 1,
      sym_heredoc_body,
    ACTIONS(1772), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1770), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11167] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1125), 1,
      sym_heredoc_body,
    ACTIONS(1776), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1774), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11234] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1126), 1,
      sym_heredoc_body,
    ACTIONS(1780), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1778), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11301] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1127), 1,
      sym_heredoc_body,
    ACTIONS(1784), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1782), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11368] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1128), 1,
      sym_heredoc_body,
    ACTIONS(1788), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1786), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11435] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1129), 1,
      sym_heredoc_body,
    ACTIONS(1792), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1790), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11502] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1130), 1,
      sym_heredoc_body,
    ACTIONS(1796), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1794), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11569] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1131), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11636] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1132), 1,
      sym_heredoc_body,
    ACTIONS(1800), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1798), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11703] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_DOT,
    ACTIONS(1808), 1,
      anon_sym_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1812), 1,
      anon_sym_AMP_DOT,
    STATE(1133), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11778] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1134), 1,
      sym_heredoc_body,
    ACTIONS(1814), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1485), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11845] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1135), 1,
      sym_heredoc_body,
    ACTIONS(1459), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11912] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1136), 1,
      sym_heredoc_body,
    ACTIONS(1818), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1816), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11979] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1137), 1,
      sym_heredoc_body,
    ACTIONS(1822), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1820), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12046] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1138), 1,
      sym_heredoc_body,
    ACTIONS(1826), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1824), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1139), 1,
      sym_heredoc_body,
    ACTIONS(995), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(997), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12180] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1140), 1,
      sym_heredoc_body,
    ACTIONS(1455), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12247] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1141), 1,
      sym_heredoc_body,
    ACTIONS(1830), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1828), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12314] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1142), 1,
      sym_heredoc_body,
    ACTIONS(1834), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1832), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12381] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1143), 1,
      sym_heredoc_body,
    ACTIONS(1838), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1836), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12448] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1144), 1,
      sym_heredoc_body,
    ACTIONS(1842), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1840), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12515] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1145), 1,
      sym_heredoc_body,
    ACTIONS(1846), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1844), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12582] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1146), 1,
      sym_heredoc_body,
    ACTIONS(1850), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1848), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12649] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1147), 1,
      sym_heredoc_body,
    ACTIONS(1854), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1852), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12716] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1148), 1,
      sym_heredoc_body,
    ACTIONS(1858), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1856), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12783] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1149), 1,
      sym_heredoc_body,
    ACTIONS(1862), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1860), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12850] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1150), 1,
      sym_heredoc_body,
    ACTIONS(1866), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1864), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12917] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1151), 1,
      sym_heredoc_body,
    ACTIONS(1870), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1868), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12984] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1152), 1,
      sym_heredoc_body,
    ACTIONS(1874), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1872), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13051] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1153), 1,
      sym_heredoc_body,
    ACTIONS(1878), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1876), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13118] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1154), 1,
      sym_heredoc_body,
    ACTIONS(1882), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1880), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13185] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1155), 1,
      sym_heredoc_body,
    ACTIONS(1886), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1884), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13252] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1156), 1,
      sym_heredoc_body,
    ACTIONS(1890), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1888), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13319] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1157), 1,
      sym_heredoc_body,
    ACTIONS(1894), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1892), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13386] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1158), 1,
      sym_heredoc_body,
    ACTIONS(1898), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1896), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13453] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1159), 1,
      sym_heredoc_body,
    ACTIONS(1902), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1900), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13520] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1160), 1,
      sym_heredoc_body,
    ACTIONS(1906), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1904), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13587] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1161), 1,
      sym_heredoc_body,
    ACTIONS(1910), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1908), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13654] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1162), 1,
      sym_heredoc_body,
    ACTIONS(1914), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1912), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1163), 1,
      sym_heredoc_body,
    ACTIONS(921), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(923), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13788] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1164), 1,
      sym_heredoc_body,
    ACTIONS(1918), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1916), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13855] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1165), 1,
      sym_heredoc_body,
    ACTIONS(985), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(987), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13922] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1166), 1,
      sym_heredoc_body,
    ACTIONS(1922), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1920), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13989] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1924), 1,
      anon_sym_EQ,
    STATE(1167), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1926), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1168), 1,
      sym_heredoc_body,
    ACTIONS(1930), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1928), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14127] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1169), 1,
      sym_heredoc_body,
    ACTIONS(1934), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1932), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14194] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1170), 1,
      sym_heredoc_body,
    ACTIONS(1938), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1936), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14261] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1171), 1,
      sym_heredoc_body,
    ACTIONS(1942), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1940), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14328] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1172), 1,
      sym_heredoc_body,
    ACTIONS(1946), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1944), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14395] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1173), 1,
      sym_heredoc_body,
    ACTIONS(1950), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1948), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14462] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1174), 1,
      sym_heredoc_body,
    ACTIONS(1954), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1952), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14529] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1175), 1,
      sym_heredoc_body,
    ACTIONS(1483), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1481), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14596] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1176), 1,
      sym_heredoc_body,
    ACTIONS(1958), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1956), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14663] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1177), 1,
      sym_heredoc_body,
    ACTIONS(1962), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1960), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14730] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1178), 1,
      sym_heredoc_body,
    ACTIONS(1966), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1964), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14797] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1179), 1,
      sym_heredoc_body,
    ACTIONS(1970), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1968), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14864] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1972), 1,
      anon_sym_EQ,
    STATE(1180), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1974), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14935] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1181), 1,
      sym_heredoc_body,
    ACTIONS(1978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1976), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15002] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1182), 1,
      sym_heredoc_body,
    ACTIONS(981), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(983), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15069] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1183), 1,
      sym_heredoc_body,
    ACTIONS(1513), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15136] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1184), 1,
      sym_heredoc_body,
    ACTIONS(1505), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15203] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1185), 1,
      sym_heredoc_body,
    ACTIONS(1509), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15270] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1186), 1,
      sym_heredoc_body,
    ACTIONS(1982), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1980), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1187), 1,
      sym_heredoc_body,
    ACTIONS(977), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(979), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15404] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1188), 1,
      sym_heredoc_body,
    ACTIONS(1986), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1984), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15471] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1189), 1,
      sym_heredoc_body,
    ACTIONS(1990), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1988), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15538] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1190), 1,
      sym_heredoc_body,
    ACTIONS(1994), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1992), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15605] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1191), 1,
      sym_heredoc_body,
    ACTIONS(1998), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1996), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15672] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1192), 1,
      sym_heredoc_body,
    ACTIONS(2002), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2000), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15739] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1193), 1,
      sym_heredoc_body,
    ACTIONS(2006), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2004), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15806] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1194), 1,
      sym_heredoc_body,
    ACTIONS(2010), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2008), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15873] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2012), 1,
      anon_sym_DOT,
    ACTIONS(2014), 1,
      anon_sym_LBRACK,
    ACTIONS(2016), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2018), 1,
      anon_sym_AMP_DOT,
    STATE(1195), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    STATE(1196), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2022), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2024), 1,
      anon_sym_EQ,
    STATE(1197), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2026), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 20,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16091] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2028), 1,
      anon_sym_EQ,
    STATE(1198), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2030), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16162] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(2032), 1,
      anon_sym_EQ,
    STATE(1199), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2034), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 18,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    STATE(1069), 1,
      sym_block,
    STATE(1092), 1,
      sym_do_block,
    STATE(1200), 1,
      sym_heredoc_body,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16306] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_LBRACK,
    ACTIONS(2036), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2040), 1,
      anon_sym_AMP_DOT,
    STATE(1201), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2042), 1,
      anon_sym_EQ,
    STATE(1202), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2044), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 19,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16450] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2046), 1,
      anon_sym_EQ,
    STATE(1203), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2048), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1204), 1,
      sym_heredoc_body,
    ACTIONS(1471), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1205), 1,
      sym_heredoc_body,
    ACTIONS(1521), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1206), 1,
      sym_heredoc_body,
    ACTIONS(1479), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1207), 1,
      sym_heredoc_body,
    ACTIONS(1455), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1208), 1,
      sym_heredoc_body,
    ACTIONS(1497), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1209), 1,
      sym_heredoc_body,
    ACTIONS(1483), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1481), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1210), 1,
      sym_heredoc_body,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16969] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2052), 1,
      anon_sym_COMMA,
    STATE(1211), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1212), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1213), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17163] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2059), 1,
      anon_sym_COMMA,
    STATE(1211), 1,
      aux_sym_exceptions_repeat1,
    STATE(1214), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1215), 1,
      sym_heredoc_body,
    ACTIONS(1467), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1465), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1216), 1,
      sym_heredoc_body,
    ACTIONS(1475), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1217), 1,
      sym_heredoc_body,
    ACTIONS(1505), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1218), 1,
      sym_heredoc_body,
    ACTIONS(1489), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17487] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2063), 1,
      anon_sym_EQ,
    STATE(1219), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2065), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 18,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1220), 1,
      sym_heredoc_body,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1221), 1,
      sym_heredoc_body,
    ACTIONS(1493), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1222), 1,
      sym_heredoc_body,
    ACTIONS(1509), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17749] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1214), 1,
      aux_sym_exceptions_repeat1,
    STATE(1223), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [17843] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(2099), 1,
      anon_sym_EQ,
    STATE(1224), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2101), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1437), 17,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [17915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1225), 1,
      sym_heredoc_body,
    ACTIONS(1513), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17979] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1214), 1,
      aux_sym_exceptions_repeat1,
    STATE(1226), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1227), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1228), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1229), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18237] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_COMMA,
    STATE(1230), 1,
      sym_heredoc_body,
    STATE(1258), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18304] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1231), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [18395] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1232), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18458] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1230), 1,
      aux_sym_exceptions_repeat1,
    STATE(1233), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18523] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    STATE(1234), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18588] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1235), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [18679] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1236), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [18770] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    STATE(1237), 1,
      sym_heredoc_body,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 27,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [18855] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    STATE(1238), 1,
      sym_heredoc_body,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 36,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18924] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    STATE(1239), 1,
      sym_heredoc_body,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 27,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [19009] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1240), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [19100] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1241), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 24,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [19189] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1242), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [19280] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1243), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19343] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1244), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [19434] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    STATE(1245), 1,
      sym_heredoc_body,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    STATE(1246), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2123), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1437), 16,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1439), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [19580] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    STATE(1247), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [19671] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1248), 1,
      sym_heredoc_body,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(2127), 1,
      anon_sym_EQ,
    STATE(1249), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2129), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1437), 16,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [19805] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_PIPE,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    ACTIONS(2077), 1,
      anon_sym_QMARK,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_GT_EQ,
    ACTIONS(2089), 1,
      anon_sym_CARET,
    ACTIONS(2095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2133), 1,
      anon_sym_EQ_GT,
    STATE(1250), 1,
      sym_heredoc_body,
    ACTIONS(2083), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2131), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [19898] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    STATE(1251), 1,
      sym_heredoc_body,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 34,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19969] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1230), 1,
      aux_sym_exceptions_repeat1,
    STATE(1252), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [20062] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(2165), 1,
      anon_sym_EQ,
    STATE(1253), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2167), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1437), 15,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1439), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [20133] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    STATE(1254), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20198] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2073), 1,
      anon_sym_AMP,
    STATE(1255), 1,
      sym_heredoc_body,
    ACTIONS(2085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 34,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20271] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    STATE(1256), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20336] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_STAR_STAR,
    STATE(1257), 1,
      sym_heredoc_body,
    ACTIONS(2093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 38,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20403] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2169), 1,
      anon_sym_COMMA,
    STATE(1258), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20468] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1259), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20531] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(2172), 1,
      anon_sym_EQ,
    STATE(1260), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2174), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1437), 16,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1439), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [20602] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1261), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2176), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [20692] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1262), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [20782] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1263), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [20872] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1264), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2178), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [20962] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1265), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2180), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [21052] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2182), 1,
      anon_sym_COMMA,
    STATE(1266), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21116] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1267), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2185), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [21206] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    STATE(1268), 1,
      sym_heredoc_body,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 37,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21272] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    STATE(1269), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21336] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    STATE(1270), 1,
      sym_heredoc_body,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21408] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    STATE(1271), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21472] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    STATE(1272), 1,
      sym_heredoc_body,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21542] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    STATE(1273), 1,
      sym_heredoc_body,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21618] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1274), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [21706] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1275), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [21796] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1276), 1,
      sym_heredoc_body,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 26,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [21880] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    STATE(1277), 1,
      sym_heredoc_body,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 35,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21948] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1278), 1,
      sym_heredoc_body,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 26,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [22032] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1279), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22122] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1280), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22212] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1281), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22302] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_COMMA,
    STATE(1266), 1,
      aux_sym_exceptions_repeat1,
    STATE(1282), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22368] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_PIPE,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2139), 1,
      anon_sym_AMP,
    ACTIONS(2143), 1,
      anon_sym_QMARK,
    ACTIONS(2145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2153), 1,
      anon_sym_GT_EQ,
    ACTIONS(2155), 1,
      anon_sym_CARET,
    ACTIONS(2161), 1,
      anon_sym_EQ_EQ,
    STATE(1283), 1,
      sym_heredoc_body,
    ACTIONS(2149), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2151), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2157), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2141), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2159), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2163), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22458] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1282), 1,
      aux_sym_exceptions_repeat1,
    STATE(1284), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22522] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2193), 1,
      anon_sym_AMP_DOT,
    STATE(1285), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22592] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1282), 1,
      aux_sym_exceptions_repeat1,
    STATE(1286), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [22684] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_STAR_STAR,
    STATE(1287), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22748] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(1288), 1,
      sym_heredoc_body,
    STATE(1314), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22813] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1289), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [22902] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    STATE(1290), 1,
      sym_heredoc_body,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22971] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    STATE(1291), 1,
      sym_heredoc_body,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 31,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23046] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1292), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [23133] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1293), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [23222] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1294), 1,
      sym_heredoc_body,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [23305] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    STATE(1295), 1,
      sym_heredoc_body,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 34,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23372] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1296), 1,
      sym_heredoc_body,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [23455] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    STATE(1297), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23518] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1298), 1,
      sym_heredoc_body,
    STATE(1314), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [23611] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1299), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [23700] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    STATE(1300), 1,
      sym_heredoc_body,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 36,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23765] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1301), 1,
      sym_heredoc_body,
    STATE(1314), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [23856] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2257), 1,
      anon_sym_EQ_GT,
    STATE(1302), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2131), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [23947] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1303), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [24036] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1304), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [24125] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    STATE(1305), 1,
      sym_heredoc_body,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24196] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1306), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [24285] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1307), 1,
      sym_heredoc_body,
    STATE(1314), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [24378] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    STATE(1308), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24441] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    STATE(1309), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24504] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1310), 1,
      sym_heredoc_body,
    STATE(1314), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24567] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    STATE(1311), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24630] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1312), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [24719] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1313), 1,
      sym_heredoc_body,
    STATE(1314), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [24810] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(1308), 1,
      aux_sym_exceptions_repeat1,
    STATE(1314), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24875] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1315), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2185), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [24963] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1316), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25051] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1317), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 24,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [25133] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1318), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2180), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25221] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1319), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25283] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1320), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2178), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25371] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1321), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25459] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1322), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25547] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1323), 1,
      sym_heredoc_body,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25613] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1324), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25701] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1325), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25789] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1326), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25877] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1327), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2176), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25965] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1328), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [26053] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1329), 1,
      sym_heredoc_body,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 35,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26117] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1330), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 24,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [26199] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1331), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [26287] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1332), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [26373] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    STATE(1333), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 30,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26447] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1334), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 31,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26515] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1335), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26577] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    STATE(1336), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 31,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26647] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1337), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26709] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    STATE(1338), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [26790] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1339), 1,
      sym_heredoc_body,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 34,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26853] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1340), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26914] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_LBRACK,
    ACTIONS(2284), 1,
      anon_sym_DOT,
    ACTIONS(2286), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2288), 1,
      anon_sym_AMP_DOT,
    STATE(1341), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26981] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(243), 1,
      sym__string_start,
    ACTIONS(2290), 1,
      anon_sym_COLON,
    STATE(1342), 1,
      sym_heredoc_body,
    STATE(1360), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27044] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1343), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27131] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1344), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27218] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    ACTIONS(2300), 1,
      anon_sym_COLON,
    STATE(993), 1,
      aux_sym_chained_string_repeat1,
    STATE(1067), 1,
      sym_string,
    STATE(1345), 1,
      sym_heredoc_body,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27285] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1346), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2302), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27372] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1347), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27459] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1348), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27546] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1349), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27607] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    STATE(1350), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 30,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27676] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1351), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27737] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1352), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 30,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27804] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    STATE(1353), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 29,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27877] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1354), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [27962] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1355), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [28049] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    STATE(1356), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [28130] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2272), 1,
      anon_sym_GT_EQ,
    ACTIONS(2274), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1357), 1,
      sym_heredoc_body,
    ACTIONS(2270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2298), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2268), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2282), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [28217] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1358), 1,
      sym_heredoc_body,
    ACTIONS(2276), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2278), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28282] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2306), 1,
      anon_sym_LPAREN,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    STATE(1137), 1,
      sym__method_rest,
    STATE(1359), 1,
      sym_heredoc_body,
    STATE(2141), 1,
      sym__method_name,
    STATE(2759), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28360] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(243), 1,
      sym__string_start,
    STATE(1360), 1,
      sym_heredoc_body,
    STATE(1363), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1635), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28420] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2320), 1,
      anon_sym_LPAREN,
    STATE(1361), 1,
      sym_heredoc_body,
    STATE(1482), 1,
      sym__method_rest,
    STATE(2143), 1,
      sym__method_name,
    STATE(2781), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28498] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(243), 1,
      sym__string_start,
    STATE(1362), 1,
      sym_heredoc_body,
    STATE(1360), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28558] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2322), 1,
      sym__string_start,
    STATE(1363), 3,
      sym_string,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1645), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1643), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28616] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2325), 1,
      anon_sym_LPAREN,
    STATE(1364), 1,
      sym_heredoc_body,
    STATE(2140), 1,
      sym__method_name,
    STATE(2600), 1,
      sym__method_rest,
    STATE(2741), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28694] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_LPAREN2,
    STATE(1365), 1,
      sym_heredoc_body,
    STATE(1563), 1,
      sym_argument_list,
    ACTIONS(1664), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1662), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28755] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_LPAREN2,
    STATE(1366), 1,
      sym_heredoc_body,
    STATE(1540), 1,
      sym_argument_list,
    ACTIONS(275), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(273), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28816] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2329), 1,
      sym__string_start,
    STATE(1387), 1,
      sym_string,
    STATE(1367), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1645), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1643), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28877] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1368), 1,
      sym_heredoc_body,
    ACTIONS(1670), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1668), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28932] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(243), 1,
      sym__string_start,
    ACTIONS(2332), 1,
      anon_sym_COLON,
    STATE(1369), 1,
      sym_heredoc_body,
    STATE(1360), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28993] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1370), 1,
      sym_heredoc_body,
    STATE(1422), 1,
      sym_argument_list,
    ACTIONS(301), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(299), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29052] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1371), 1,
      sym_heredoc_body,
    STATE(1419), 1,
      sym_argument_list,
    ACTIONS(305), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(303), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29111] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(889), 1,
      sym__string_start,
    STATE(1372), 1,
      sym_heredoc_body,
    STATE(1375), 1,
      aux_sym_chained_string_repeat1,
    STATE(1387), 1,
      sym_string,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29174] = 14,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2334), 1,
      anon_sym_LPAREN,
    STATE(1373), 1,
      sym_heredoc_body,
    STATE(1444), 1,
      sym__method_rest,
    STATE(2148), 1,
      sym__method_name,
    STATE(2803), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29249] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1374), 1,
      sym_heredoc_body,
    STATE(1398), 1,
      sym_argument_list,
    ACTIONS(1664), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1662), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29308] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(889), 1,
      sym__string_start,
    STATE(1367), 1,
      aux_sym_chained_string_repeat1,
    STATE(1375), 1,
      sym_heredoc_body,
    STATE(1387), 1,
      sym_string,
    ACTIONS(1635), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29371] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_LPAREN2,
    STATE(1376), 1,
      sym_heredoc_body,
    STATE(1522), 1,
      sym_argument_list,
    ACTIONS(301), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(299), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29432] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_LPAREN2,
    STATE(1377), 1,
      sym_heredoc_body,
    STATE(1532), 1,
      sym_argument_list,
    ACTIONS(305), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(303), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29493] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1378), 1,
      sym_heredoc_body,
    STATE(1397), 1,
      sym_argument_list,
    ACTIONS(1674), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1672), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29552] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1379), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29607] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1380), 1,
      sym_heredoc_body,
    STATE(1405), 1,
      sym_argument_list,
    ACTIONS(275), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(273), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29666] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_LPAREN2,
    STATE(1381), 1,
      sym_heredoc_body,
    STATE(1566), 1,
      sym_argument_list,
    ACTIONS(1674), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1672), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29727] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1382), 1,
      sym_heredoc_body,
    STATE(1423), 1,
      sym_argument_list,
    ACTIONS(297), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(295), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29786] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_LPAREN2,
    STATE(1383), 1,
      sym_heredoc_body,
    STATE(1521), 1,
      sym_argument_list,
    ACTIONS(297), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(295), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29847] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1384), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 33,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29903] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2336), 1,
      anon_sym_r,
    STATE(1385), 1,
      sym_heredoc_body,
    ACTIONS(1439), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29961] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2338), 1,
      anon_sym_r,
    STATE(1386), 1,
      sym_heredoc_body,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30017] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1387), 1,
      sym_heredoc_body,
    ACTIONS(1682), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1680), 33,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30073] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2338), 1,
      anon_sym_r,
    STATE(1388), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30129] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1389), 1,
      sym_heredoc_body,
    ACTIONS(1670), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1668), 33,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30185] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2336), 1,
      anon_sym_r,
    STATE(1390), 1,
      sym_heredoc_body,
    ACTIONS(1686), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30243] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACK,
    ACTIONS(2340), 1,
      anon_sym_DOT,
    ACTIONS(2342), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2344), 1,
      anon_sym_AMP_DOT,
    STATE(1391), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30307] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1392), 1,
      sym_heredoc_body,
    ACTIONS(1898), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1896), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30360] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1393), 1,
      sym_heredoc_body,
    ACTIONS(1902), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1900), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30413] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1394), 1,
      sym_heredoc_body,
    ACTIONS(1834), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1832), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30468] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1395), 1,
      sym_heredoc_body,
    ACTIONS(1724), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1722), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30523] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1396), 1,
      sym_heredoc_body,
    ACTIONS(1946), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1944), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30576] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1397), 1,
      sym_heredoc_body,
    ACTIONS(1866), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1864), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30629] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1398), 1,
      sym_heredoc_body,
    ACTIONS(1862), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1860), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30682] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1399), 1,
      sym_heredoc_body,
    ACTIONS(1902), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1900), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30737] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1400), 1,
      sym_heredoc_body,
    ACTIONS(1918), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1916), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30792] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1401), 1,
      sym_heredoc_body,
    ACTIONS(1958), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1956), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30845] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1402), 1,
      sym_heredoc_body,
    ACTIONS(1922), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1920), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30900] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1403), 1,
      sym_heredoc_body,
    ACTIONS(1728), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1726), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30955] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1404), 1,
      sym_heredoc_body,
    ACTIONS(1692), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1690), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31008] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1405), 1,
      sym_heredoc_body,
    ACTIONS(1858), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1856), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31061] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1406), 1,
      sym_heredoc_body,
    ACTIONS(1986), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1984), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31114] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1407), 1,
      sym_heredoc_body,
    ACTIONS(1724), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1722), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31167] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1408), 1,
      sym_heredoc_body,
    ACTIONS(1479), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31220] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1409), 1,
      sym_heredoc_body,
    ACTIONS(1740), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1738), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31275] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1410), 1,
      sym_heredoc_body,
    ACTIONS(1728), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1726), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31328] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1411), 1,
      sym_heredoc_body,
    ACTIONS(1732), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1730), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31381] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1412), 1,
      sym_heredoc_body,
    ACTIONS(1736), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1734), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31434] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1413), 1,
      sym_heredoc_body,
    ACTIONS(1740), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1738), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31487] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1414), 1,
      sym_heredoc_body,
    ACTIONS(1744), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1742), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31540] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1415), 1,
      sym_heredoc_body,
    ACTIONS(1930), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1928), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31595] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1416), 1,
      sym_heredoc_body,
    ACTIONS(1744), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1742), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31650] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1417), 1,
      sym_heredoc_body,
    ACTIONS(1990), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1988), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31703] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1418), 1,
      sym_heredoc_body,
    ACTIONS(1732), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1730), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31758] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1419), 1,
      sym_heredoc_body,
    ACTIONS(1854), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1852), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31811] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1420), 1,
      sym_heredoc_body,
    ACTIONS(1760), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1758), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31866] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1421), 1,
      sym_heredoc_body,
    ACTIONS(1760), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1758), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31919] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1422), 1,
      sym_heredoc_body,
    ACTIONS(1850), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1848), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31972] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1423), 1,
      sym_heredoc_body,
    ACTIONS(1846), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1844), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32025] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1424), 1,
      sym_heredoc_body,
    ACTIONS(1692), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1690), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32080] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1425), 1,
      sym_heredoc_body,
    ACTIONS(1826), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1824), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32133] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1426), 1,
      sym_heredoc_body,
    ACTIONS(1764), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1762), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32186] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1427), 1,
      sym_heredoc_body,
    ACTIONS(1792), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1790), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32239] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1428), 1,
      sym_heredoc_body,
    ACTIONS(1800), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1798), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32292] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1429), 1,
      sym_heredoc_body,
    ACTIONS(1838), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1836), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32345] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1430), 1,
      sym_heredoc_body,
    ACTIONS(1814), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1485), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32398] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1431), 1,
      sym_heredoc_body,
    ACTIONS(1878), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1876), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32451] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1432), 1,
      sym_heredoc_body,
    ACTIONS(1764), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1762), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32506] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1433), 1,
      sym_heredoc_body,
    ACTIONS(1882), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1880), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32559] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1434), 1,
      sym_heredoc_body,
    ACTIONS(1509), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32612] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1435), 1,
      sym_heredoc_body,
    ACTIONS(1686), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32667] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1436), 1,
      sym_heredoc_body,
    ACTIONS(1886), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1884), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32720] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1437), 1,
      sym_heredoc_body,
    ACTIONS(1890), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1888), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32773] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1438), 1,
      sym_heredoc_body,
    ACTIONS(1894), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1892), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32826] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1439), 1,
      sym_heredoc_body,
    ACTIONS(1978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1976), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32879] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1440), 1,
      sym_heredoc_body,
    ACTIONS(1914), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1912), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32932] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1441), 1,
      sym_heredoc_body,
    ACTIONS(1954), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1952), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32985] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1442), 1,
      sym_heredoc_body,
    ACTIONS(1962), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1960), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33038] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1443), 1,
      sym_heredoc_body,
    ACTIONS(1966), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1964), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33091] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1444), 1,
      sym_heredoc_body,
    ACTIONS(1822), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1820), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33144] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1445), 1,
      sym_heredoc_body,
    ACTIONS(1934), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1932), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33199] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1446), 1,
      sym_heredoc_body,
    ACTIONS(1938), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1936), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33254] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1447), 1,
      sym_heredoc_body,
    ACTIONS(1942), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1940), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33309] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1448), 1,
      sym_heredoc_body,
    ACTIONS(1946), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1944), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33364] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1449), 1,
      sym_heredoc_body,
    ACTIONS(1950), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1948), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33419] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1450), 1,
      sym_heredoc_body,
    ACTIONS(1982), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1980), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33474] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1451), 1,
      sym_heredoc_body,
    ACTIONS(1784), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1782), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33529] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1452), 1,
      sym_heredoc_body,
    ACTIONS(1998), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1996), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33582] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1453), 1,
      sym_heredoc_body,
    ACTIONS(1788), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1786), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33637] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1454), 1,
      sym_heredoc_body,
    ACTIONS(2010), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2008), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33690] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1455), 1,
      sym_heredoc_body,
    ACTIONS(2006), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2004), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33743] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1456), 1,
      sym_heredoc_body,
    ACTIONS(1788), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1786), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33796] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1457), 1,
      sym_heredoc_body,
    ACTIONS(2002), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2000), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33849] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1458), 1,
      sym_heredoc_body,
    ACTIONS(1994), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1992), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33902] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1459), 1,
      sym_heredoc_body,
    ACTIONS(1784), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1782), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33955] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1460), 1,
      sym_heredoc_body,
    ACTIONS(1780), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1778), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34008] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1461), 1,
      sym_heredoc_body,
    ACTIONS(1830), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1828), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34063] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1462), 1,
      sym_heredoc_body,
    ACTIONS(1776), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1774), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34116] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1463), 1,
      sym_heredoc_body,
    ACTIONS(1748), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34171] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2346), 1,
      anon_sym_DOT,
    ACTIONS(2348), 1,
      anon_sym_LBRACK,
    ACTIONS(2350), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2352), 1,
      anon_sym_AMP_DOT,
    STATE(1464), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34232] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1465), 1,
      sym_heredoc_body,
    ACTIONS(1459), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34287] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1466), 1,
      sym_heredoc_body,
    ACTIONS(1700), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1698), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34342] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1467), 1,
      sym_heredoc_body,
    ACTIONS(1479), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34397] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1468), 1,
      sym_heredoc_body,
    ACTIONS(1768), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1766), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34452] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1469), 1,
      sym_heredoc_body,
    ACTIONS(1982), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1980), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34505] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1470), 1,
      sym_heredoc_body,
    ACTIONS(985), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(987), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34560] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1471), 1,
      sym_heredoc_body,
    ACTIONS(1950), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1948), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34613] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1472), 1,
      sym_heredoc_body,
    ACTIONS(1708), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1706), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34668] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1473), 1,
      sym_heredoc_body,
    ACTIONS(1814), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1485), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34723] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1474), 1,
      sym_heredoc_body,
    ACTIONS(1818), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1816), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34778] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1475), 1,
      sym_heredoc_body,
    ACTIONS(1736), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1734), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34833] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1476), 1,
      sym_heredoc_body,
    ACTIONS(1716), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1714), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34888] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1477), 1,
      sym_heredoc_body,
    ACTIONS(1994), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1992), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34943] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1478), 1,
      sym_heredoc_body,
    ACTIONS(2002), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2000), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34998] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1479), 1,
      sym_heredoc_body,
    ACTIONS(1780), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1778), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35053] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1480), 1,
      sym_heredoc_body,
    ACTIONS(1776), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1774), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35108] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1481), 1,
      sym_heredoc_body,
    ACTIONS(985), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(987), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35161] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1482), 1,
      sym_heredoc_body,
    ACTIONS(1822), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1820), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35216] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1483), 1,
      sym_heredoc_body,
    ACTIONS(1942), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1940), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35269] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1484), 1,
      sym_heredoc_body,
    ACTIONS(2006), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2004), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35324] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1485), 1,
      sym_heredoc_body,
    ACTIONS(1938), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1936), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35377] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1486), 1,
      sym_heredoc_body,
    ACTIONS(1934), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1932), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35430] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1487), 1,
      sym_heredoc_body,
    ACTIONS(1455), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35485] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1488), 1,
      sym_heredoc_body,
    ACTIONS(1826), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1824), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35540] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1489), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35593] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1490), 1,
      sym_heredoc_body,
    ACTIONS(1493), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35648] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1491), 1,
      sym_heredoc_body,
    ACTIONS(1930), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1928), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35701] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1492), 1,
      sym_heredoc_body,
    ACTIONS(1922), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1920), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35754] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1493), 1,
      sym_heredoc_body,
    ACTIONS(1918), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1916), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35807] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1494), 1,
      sym_heredoc_body,
    ACTIONS(1455), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35860] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1495), 1,
      sym_heredoc_body,
    ACTIONS(1489), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35915] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1496), 1,
      sym_heredoc_body,
    ACTIONS(1910), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1908), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35968] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1497), 1,
      sym_heredoc_body,
    ACTIONS(1874), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1872), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36023] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1498), 1,
      sym_heredoc_body,
    ACTIONS(1756), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1754), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36078] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1499), 1,
      sym_heredoc_body,
    ACTIONS(1874), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1872), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36131] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1500), 1,
      sym_heredoc_body,
    ACTIONS(1772), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1770), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36186] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1501), 1,
      sym_heredoc_body,
    ACTIONS(1521), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36241] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1502), 1,
      sym_heredoc_body,
    ACTIONS(1834), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1832), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36294] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1503), 1,
      sym_heredoc_body,
    ACTIONS(2010), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2008), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36349] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1504), 1,
      sym_heredoc_body,
    ACTIONS(1998), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1996), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36404] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1505), 1,
      sym_heredoc_body,
    ACTIONS(1970), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1968), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36457] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1506), 1,
      sym_heredoc_body,
    ACTIONS(1910), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1908), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36512] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1507), 1,
      sym_heredoc_body,
    ACTIONS(1792), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1790), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36567] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1508), 1,
      sym_heredoc_body,
    ACTIONS(1800), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1798), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36622] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1509), 1,
      sym_heredoc_body,
    ACTIONS(1720), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1718), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36677] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1510), 1,
      sym_heredoc_body,
    ACTIONS(1894), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1892), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36732] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1511), 1,
      sym_heredoc_body,
    ACTIONS(1838), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1836), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36787] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1512), 1,
      sym_heredoc_body,
    ACTIONS(1513), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36842] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1513), 1,
      sym_heredoc_body,
    ACTIONS(1796), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1794), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36897] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1514), 1,
      sym_heredoc_body,
    ACTIONS(1752), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1750), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36952] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1515), 1,
      sym_heredoc_body,
    ACTIONS(981), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(983), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37005] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1516), 1,
      sym_heredoc_body,
    ACTIONS(1505), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37060] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1517), 1,
      sym_heredoc_body,
    ACTIONS(1842), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1840), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37113] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1518), 1,
      sym_heredoc_body,
    ACTIONS(1870), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1868), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37168] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1519), 1,
      sym_heredoc_body,
    ACTIONS(1906), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1904), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37223] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1520), 1,
      sym_heredoc_body,
    ACTIONS(1696), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1694), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37278] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1521), 1,
      sym_heredoc_body,
    ACTIONS(1846), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1844), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37333] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1522), 1,
      sym_heredoc_body,
    ACTIONS(1850), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1848), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37388] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1523), 1,
      sym_heredoc_body,
    ACTIONS(1505), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37441] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1524), 1,
      sym_heredoc_body,
    ACTIONS(1772), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1770), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37494] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1525), 1,
      sym_heredoc_body,
    ACTIONS(1830), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1828), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37547] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2348), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_DOT,
    ACTIONS(2356), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2358), 1,
      anon_sym_AMP_DOT,
    STATE(1526), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37608] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1527), 1,
      sym_heredoc_body,
    ACTIONS(1748), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37661] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1528), 1,
      sym_heredoc_body,
    ACTIONS(981), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(983), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37716] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1529), 1,
      sym_heredoc_body,
    ACTIONS(1700), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1698), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37769] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1530), 1,
      sym_heredoc_body,
    ACTIONS(1513), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37822] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1531), 1,
      sym_heredoc_body,
    ACTIONS(1768), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1766), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37875] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1532), 1,
      sym_heredoc_body,
    ACTIONS(1854), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1852), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37930] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1533), 1,
      sym_heredoc_body,
    ACTIONS(1978), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1976), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37985] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1534), 1,
      sym_heredoc_body,
    ACTIONS(1966), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1964), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38040] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1535), 1,
      sym_heredoc_body,
    ACTIONS(1708), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1706), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38093] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1536), 1,
      sym_heredoc_body,
    ACTIONS(1962), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1960), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38148] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1537), 1,
      sym_heredoc_body,
    ACTIONS(1521), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38201] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1538), 1,
      sym_heredoc_body,
    ACTIONS(1990), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1988), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38256] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1539), 1,
      sym_heredoc_body,
    ACTIONS(1986), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1984), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38311] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1540), 1,
      sym_heredoc_body,
    ACTIONS(1858), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1856), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38366] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1541), 1,
      sym_heredoc_body,
    ACTIONS(1716), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1714), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38419] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1542), 1,
      sym_heredoc_body,
    ACTIONS(1954), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1952), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38474] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1543), 1,
      sym_heredoc_body,
    ACTIONS(1914), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1912), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38529] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1544), 1,
      sym_heredoc_body,
    ACTIONS(1970), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1968), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38584] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1545), 1,
      sym_heredoc_body,
    ACTIONS(1756), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1754), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38637] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1546), 1,
      sym_heredoc_body,
    ACTIONS(1696), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1694), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38690] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1547), 1,
      sym_heredoc_body,
    ACTIONS(1958), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1956), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38745] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1548), 1,
      sym_heredoc_body,
    ACTIONS(1483), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1481), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38800] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1549), 1,
      sym_heredoc_body,
    ACTIONS(1898), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1896), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38855] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1550), 1,
      sym_heredoc_body,
    ACTIONS(1489), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38908] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1551), 1,
      sym_heredoc_body,
    ACTIONS(1720), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1718), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38961] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1552), 1,
      sym_heredoc_body,
    ACTIONS(1459), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39014] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1553), 1,
      sym_heredoc_body,
    ACTIONS(1796), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1794), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39067] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1554), 1,
      sym_heredoc_body,
    ACTIONS(1752), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1750), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39120] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1555), 1,
      sym_heredoc_body,
    ACTIONS(1818), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1816), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39173] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1556), 1,
      sym_heredoc_body,
    ACTIONS(1870), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1868), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39226] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1557), 1,
      sym_heredoc_body,
    ACTIONS(1842), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1840), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39281] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1558), 1,
      sym_heredoc_body,
    ACTIONS(1439), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39336] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1559), 1,
      sym_heredoc_body,
    ACTIONS(1906), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1904), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39389] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1560), 1,
      sym_heredoc_body,
    ACTIONS(1509), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39444] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1561), 1,
      sym_heredoc_body,
    ACTIONS(1890), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1888), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39499] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1562), 1,
      sym_heredoc_body,
    ACTIONS(1493), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39552] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1563), 1,
      sym_heredoc_body,
    ACTIONS(1862), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1860), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39607] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1564), 1,
      sym_heredoc_body,
    ACTIONS(1886), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1884), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39662] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1565), 1,
      sym_heredoc_body,
    ACTIONS(1882), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1880), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39717] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1566), 1,
      sym_heredoc_body,
    ACTIONS(1866), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1864), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39772] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1567), 1,
      sym_heredoc_body,
    ACTIONS(1878), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1876), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39827] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1475), 1,
      sym__method_rest,
    STATE(1568), 1,
      sym_heredoc_body,
    STATE(2143), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39895] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1445), 1,
      sym__method_rest,
    STATE(1569), 1,
      sym_heredoc_body,
    STATE(2143), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39963] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1570), 1,
      sym_heredoc_body,
    STATE(2140), 1,
      sym__method_name,
    STATE(2595), 1,
      sym__method_rest,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40031] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_DOT,
    ACTIONS(2366), 1,
      anon_sym_LBRACK,
    ACTIONS(2368), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2370), 1,
      anon_sym_AMP_DOT,
    STATE(1571), 1,
      sym_heredoc_body,
    ACTIONS(1806), 8,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40093] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1572), 1,
      sym_heredoc_body,
    STATE(2140), 1,
      sym__method_name,
    STATE(2663), 1,
      sym__method_rest,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40161] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2372), 1,
      anon_sym_DOT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2378), 1,
      anon_sym_AMP_DOT,
    STATE(1573), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40221] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1110), 1,
      sym__method_rest,
    STATE(1574), 1,
      sym_heredoc_body,
    STATE(2141), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40289] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(889), 1,
      sym__string_start,
    ACTIONS(2300), 1,
      anon_sym_COLON,
    STATE(1375), 1,
      aux_sym_chained_string_repeat1,
    STATE(1387), 1,
      sym_string,
    STATE(1575), 1,
      sym_heredoc_body,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40351] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1169), 1,
      sym__method_rest,
    STATE(1576), 1,
      sym_heredoc_body,
    STATE(2141), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40419] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1282), 1,
      aux_sym_exceptions_repeat1,
    STATE(1577), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 12,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [40502] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_COMMA,
    STATE(1282), 1,
      aux_sym_exceptions_repeat1,
    STATE(1578), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40559] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1412), 1,
      sym__method_rest,
    STATE(1579), 1,
      sym_heredoc_body,
    STATE(2148), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40624] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2380), 1,
      sym_identifier,
    STATE(1580), 1,
      sym_heredoc_body,
    STATE(2121), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40689] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2382), 1,
      sym_identifier,
    ACTIONS(2390), 1,
      sym__simple_symbol,
    ACTIONS(2392), 1,
      sym__symbol_start,
    STATE(1581), 1,
      sym_heredoc_body,
    STATE(2118), 1,
      sym__method_name,
    STATE(2211), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2388), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2386), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2384), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40754] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2382), 1,
      sym_identifier,
    ACTIONS(2390), 1,
      sym__simple_symbol,
    ACTIONS(2392), 1,
      sym__symbol_start,
    STATE(1582), 1,
      sym_heredoc_body,
    STATE(2176), 1,
      sym__method_name,
    STATE(2211), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2388), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2386), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2384), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40819] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2394), 1,
      sym_identifier,
    ACTIONS(2402), 1,
      sym__simple_symbol,
    ACTIONS(2404), 1,
      sym__symbol_start,
    STATE(1580), 1,
      sym__method_name,
    STATE(1583), 1,
      sym_heredoc_body,
    STATE(1692), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2400), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2398), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2396), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40884] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2394), 1,
      sym_identifier,
    ACTIONS(2402), 1,
      sym__simple_symbol,
    ACTIONS(2404), 1,
      sym__symbol_start,
    STATE(1584), 1,
      sym_heredoc_body,
    STATE(1585), 1,
      sym__method_name,
    STATE(1692), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2400), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2398), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2396), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40949] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2382), 1,
      sym_identifier,
    ACTIONS(2390), 1,
      sym__simple_symbol,
    ACTIONS(2392), 1,
      sym__symbol_start,
    STATE(1585), 1,
      sym_heredoc_body,
    STATE(2121), 1,
      sym__method_name,
    STATE(2211), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2388), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2386), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2384), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41014] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_COMMA,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1282), 1,
      aux_sym_exceptions_repeat1,
    STATE(1586), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [41099] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_r,
    STATE(1587), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41154] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2380), 1,
      sym_identifier,
    STATE(1588), 1,
      sym_heredoc_body,
    STATE(2131), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41219] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_r,
    STATE(1589), 1,
      sym_heredoc_body,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41274] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_COMMA,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1282), 1,
      aux_sym_exceptions_repeat1,
    STATE(1590), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [41359] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1486), 1,
      sym__method_rest,
    STATE(1591), 1,
      sym_heredoc_body,
    STATE(2148), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41424] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2380), 1,
      sym_identifier,
    STATE(1592), 1,
      sym_heredoc_body,
    STATE(2118), 1,
      sym__method_name,
    STATE(2108), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41489] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_DOT,
    ACTIONS(2410), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2412), 1,
      anon_sym_AMP_DOT,
    STATE(1593), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41547] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1594), 1,
      sym_heredoc_body,
    STATE(1600), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41599] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2422), 1,
      sym__simple_symbol,
    ACTIONS(2424), 1,
      sym__symbol_start,
    STATE(1595), 1,
      sym_heredoc_body,
    ACTIONS(2420), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(2462), 4,
      sym_operator,
      sym__method_name,
      sym_setter,
      sym_symbol,
    ACTIONS(2418), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2416), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41659] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2394), 1,
      sym_identifier,
    ACTIONS(2402), 1,
      sym__simple_symbol,
    ACTIONS(2404), 1,
      sym__symbol_start,
    STATE(1596), 1,
      sym_heredoc_body,
    STATE(1598), 1,
      sym__method_name,
    STATE(1692), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2400), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2398), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2396), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41721] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    ACTIONS(2197), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2199), 1,
      anon_sym_AMP,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(2205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2213), 1,
      anon_sym_GT_EQ,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2221), 1,
      anon_sym_EQ_EQ,
    STATE(1597), 1,
      sym_heredoc_body,
    ACTIONS(2209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2211), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2201), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2219), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 12,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [41801] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2422), 1,
      sym__simple_symbol,
    ACTIONS(2424), 1,
      sym__symbol_start,
    STATE(1598), 1,
      sym_heredoc_body,
    ACTIONS(2426), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(2523), 4,
      sym_operator,
      sym__method_name,
      sym_setter,
      sym_symbol,
    ACTIONS(2418), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2416), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41861] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1599), 1,
      sym_heredoc_body,
    STATE(1600), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [41941] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_COMMA,
    STATE(1600), 1,
      sym_heredoc_body,
    STATE(1601), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41995] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_COMMA,
    STATE(1601), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42047] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2422), 1,
      sym__simple_symbol,
    ACTIONS(2424), 1,
      sym__symbol_start,
    STATE(1602), 1,
      sym_heredoc_body,
    ACTIONS(2463), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(2356), 4,
      sym_operator,
      sym__method_name,
      sym_setter,
      sym_symbol,
    ACTIONS(2418), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2416), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [42107] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1185), 1,
      sym__string_start,
    STATE(1387), 1,
      sym_string,
    STATE(1603), 1,
      sym_heredoc_body,
    STATE(1620), 1,
      aux_sym_chained_string_repeat1,
    ACTIONS(1439), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1437), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42164] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1604), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42221] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1605), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42272] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1606), 1,
      sym_heredoc_body,
    STATE(1645), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [42351] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1607), 1,
      sym_heredoc_body,
    STATE(1645), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42402] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2501), 1,
      anon_sym_COMMA,
    STATE(1608), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42453] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1609), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [42530] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1610), 1,
      sym_heredoc_body,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42579] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    STATE(1611), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42630] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    STATE(1612), 1,
      sym_heredoc_body,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 27,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42683] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1613), 1,
      sym_heredoc_body,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42734] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1614), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42783] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_QMARK,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1615), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [42862] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1616), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [42939] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1617), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [43016] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1618), 1,
      sym_heredoc_body,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 26,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43071] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1619), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43124] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1185), 1,
      sym__string_start,
    STATE(1387), 1,
      sym_string,
    STATE(1620), 1,
      sym_heredoc_body,
    STATE(1622), 1,
      aux_sym_chained_string_repeat1,
    ACTIONS(1635), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43181] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    STATE(1621), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43242] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2528), 1,
      sym__string_start,
    STATE(1387), 1,
      sym_string,
    STATE(1622), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1645), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1643), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43297] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_QMARK,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2531), 1,
      anon_sym_EQ_GT,
    STATE(1623), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2302), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [43378] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1624), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43431] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1625), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43490] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    STATE(1626), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43555] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1627), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 12,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [43632] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2533), 1,
      anon_sym_EQ_GT,
    STATE(1628), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2131), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [43711] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    STATE(1629), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43762] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    STATE(1630), 1,
      sym_heredoc_body,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43821] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    STATE(1631), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43872] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1632), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43923] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1633), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43972] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_QMARK,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1634), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44051] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1635), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44102] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_QMARK,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1636), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44181] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    STATE(1637), 1,
      sym_heredoc_body,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44238] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1638), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44291] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_QMARK,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1639), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44370] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    STATE(1640), 1,
      sym_heredoc_body,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44433] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1641), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [44506] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_QMARK,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1642), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44585] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1643), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [44660] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1644), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44737] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2535), 1,
      anon_sym_COMMA,
    STATE(1608), 1,
      aux_sym_exceptions_repeat1,
    STATE(1645), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44790] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1646), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [44863] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1647), 1,
      sym_heredoc_body,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [44934] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_QMARK,
    ACTIONS(2512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2514), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2520), 1,
      anon_sym_GT_EQ,
    ACTIONS(2522), 1,
      anon_sym_CARET,
    ACTIONS(2524), 1,
      anon_sym_EQ_EQ,
    STATE(1648), 1,
      sym_heredoc_body,
    ACTIONS(2467), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2469), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2508), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2526), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [45013] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1649), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [45090] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1650), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [45167] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    STATE(1651), 1,
      sym_heredoc_body,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 25,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45222] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    ACTIONS(2438), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1652), 1,
      sym_heredoc_body,
    ACTIONS(2442), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [45299] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2428), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_AMP,
    ACTIONS(2446), 1,
      anon_sym_GT_EQ,
    ACTIONS(2448), 1,
      anon_sym_CARET,
    ACTIONS(2454), 1,
      anon_sym_EQ_EQ,
    STATE(1653), 1,
      sym_heredoc_body,
    ACTIONS(2444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2450), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2434), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2452), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2456), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45370] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    STATE(1654), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45420] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1655), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2176), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45496] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1656), 1,
      sym_heredoc_body,
    STATE(1679), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45546] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1657), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45622] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1658), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45698] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    STATE(1659), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45748] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1660), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2178), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45824] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1661), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45900] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1662), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2180), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45976] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_DOT,
    ACTIONS(2539), 1,
      anon_sym_LBRACK,
    ACTIONS(2541), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2543), 1,
      anon_sym_AMP_DOT,
    STATE(1663), 1,
      sym_heredoc_body,
    ACTIONS(1806), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46034] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    STATE(1664), 1,
      sym_heredoc_body,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 26,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46086] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1665), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2185), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46162] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1666), 1,
      sym_heredoc_body,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [46232] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1667), 1,
      sym_heredoc_body,
    STATE(1679), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [46310] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1668), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46386] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2575), 1,
      anon_sym_COMMA,
    STATE(1669), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46436] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    STATE(1670), 1,
      sym_heredoc_body,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46494] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    STATE(1671), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46544] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    STATE(1672), 1,
      sym_heredoc_body,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46600] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1673), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46676] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    STATE(1674), 1,
      sym_heredoc_body,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2582), 1,
      anon_sym_EQ,
    STATE(1675), 1,
      sym_heredoc_body,
    ACTIONS(2580), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2578), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [46790] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1676), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [46864] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1677), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46940] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1678), 1,
      sym_heredoc_body,
    ACTIONS(2485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [47016] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_COMMA,
    STATE(1669), 1,
      aux_sym_exceptions_repeat1,
    STATE(1679), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47068] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    STATE(1680), 1,
      sym_heredoc_body,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47122] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(2473), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2475), 1,
      anon_sym_AMP,
    ACTIONS(2489), 1,
      anon_sym_GT_EQ,
    ACTIONS(2491), 1,
      anon_sym_CARET,
    ACTIONS(2497), 1,
      anon_sym_EQ_EQ,
    STATE(1681), 1,
      sym_heredoc_body,
    ACTIONS(2487), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2493), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2477), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2495), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [47192] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2586), 1,
      anon_sym_EQ_GT,
    STATE(1682), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2131), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [47269] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    STATE(1683), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47318] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1684), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [47393] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1685), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [47468] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_COMMA,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1686), 1,
      sym_heredoc_body,
    STATE(1694), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [47547] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    STATE(1687), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47596] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1688), 1,
      sym_heredoc_body,
    STATE(1694), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [47673] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    STATE(1689), 1,
      sym_heredoc_body,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 25,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47724] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1690), 1,
      sym_heredoc_body,
    STATE(1694), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47773] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1691), 1,
      sym_heredoc_body,
    ACTIONS(995), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(997), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [47822] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1692), 1,
      sym_heredoc_body,
    ACTIONS(2580), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2578), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [47871] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1693), 1,
      sym_heredoc_body,
    ACTIONS(1696), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(1694), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [47920] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_COMMA,
    STATE(1694), 1,
      sym_heredoc_body,
    STATE(1705), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47971] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1695), 1,
      sym_heredoc_body,
    ACTIONS(1772), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(1770), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [48020] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1696), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [48095] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1697), 1,
      sym_heredoc_body,
    ACTIONS(1842), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(1840), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [48144] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1698), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [48219] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1699), 1,
      sym_heredoc_body,
    ACTIONS(1670), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1668), 26,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48268] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_COMMA,
    STATE(1694), 1,
      aux_sym_exceptions_repeat1,
    STATE(1700), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48319] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1701), 1,
      sym_heredoc_body,
    ACTIONS(2622), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2620), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [48368] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1694), 1,
      aux_sym_exceptions_repeat1,
    STATE(1702), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [48445] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    STATE(1703), 1,
      sym_heredoc_body,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48502] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    STATE(1704), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48551] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_COMMA,
    STATE(1705), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48600] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    STATE(1706), 1,
      sym_heredoc_body,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48655] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    STATE(1707), 1,
      sym_heredoc_body,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48716] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1708), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [48789] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1709), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [48864] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1710), 1,
      sym_heredoc_body,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [48933] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    STATE(1711), 1,
      sym_heredoc_body,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48986] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1712), 1,
      sym_heredoc_body,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49055] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1713), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [49130] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1714), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 26,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49179] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_COMMA,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1694), 1,
      aux_sym_exceptions_repeat1,
    STATE(1715), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49258] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2549), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_QMARK,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2563), 1,
      anon_sym_GT_EQ,
    ACTIONS(2565), 1,
      anon_sym_CARET,
    ACTIONS(2571), 1,
      anon_sym_EQ_EQ,
    STATE(1716), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [49333] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1717), 1,
      sym_heredoc_body,
    STATE(1745), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49383] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1718), 1,
      sym_heredoc_body,
    STATE(1734), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49433] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1719), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49501] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    STATE(1720), 1,
      sym_heredoc_body,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49553] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1721), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49621] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1722), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2178), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49695] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1723), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49769] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_COMMA,
    STATE(1724), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49819] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_COMMA,
    STATE(1725), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49869] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1726), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49943] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1727), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50017] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1728), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2180), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50091] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    STATE(1729), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50139] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1730), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50213] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1731), 1,
      sym_heredoc_body,
    STATE(1745), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [50291] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1732), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [50363] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    STATE(1733), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50423] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2663), 1,
      anon_sym_COMMA,
    STATE(1725), 1,
      aux_sym_exceptions_repeat1,
    STATE(1734), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50475] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    STATE(1735), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50529] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    STATE(1736), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50577] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    STATE(1737), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50633] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1738), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50707] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1739), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50781] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    STATE(1740), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50829] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_COMMA,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1741), 1,
      sym_heredoc_body,
    STATE(2473), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2683), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2669), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50911] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    STATE(1742), 1,
      sym_heredoc_body,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50961] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1743), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2176), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51035] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1744), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2185), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51109] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_COMMA,
    STATE(1724), 1,
      aux_sym_exceptions_repeat1,
    STATE(1745), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51161] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1734), 1,
      aux_sym_exceptions_repeat1,
    STATE(1746), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [51239] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1747), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51313] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_PIPE,
    ACTIONS(2592), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2594), 1,
      anon_sym_AMP,
    ACTIONS(2598), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2608), 1,
      anon_sym_GT_EQ,
    ACTIONS(2610), 1,
      anon_sym_CARET,
    ACTIONS(2616), 1,
      anon_sym_EQ_EQ,
    STATE(1748), 1,
      sym_heredoc_body,
    ACTIONS(2604), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2612), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2596), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2614), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2618), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51387] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_LPAREN2,
    STATE(1749), 1,
      sym_heredoc_body,
    ACTIONS(2703), 2,
      sym_constant,
      sym_identifier,
    STATE(292), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2707), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2705), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [51440] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2719), 1,
      anon_sym_QMARK,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1750), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51513] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    STATE(1751), 1,
      sym_heredoc_body,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51570] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1752), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [51645] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    STATE(1753), 1,
      sym_heredoc_body,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51696] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    STATE(1754), 1,
      sym_heredoc_body,
    ACTIONS(2741), 2,
      sym_constant,
      sym_identifier,
    STATE(2195), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2745), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2743), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [51749] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1755), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [51824] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2755), 1,
      anon_sym_LPAREN2,
    STATE(1756), 1,
      sym_heredoc_body,
    ACTIONS(2749), 2,
      sym_constant,
      sym_identifier,
    STATE(325), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2753), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2751), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [51877] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    STATE(1757), 1,
      sym_heredoc_body,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51934] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1758), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [52009] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    STATE(1759), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52056] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2719), 1,
      anon_sym_QMARK,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1760), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [52129] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_LPAREN2,
    STATE(1761), 1,
      sym_heredoc_body,
    ACTIONS(2757), 2,
      sym_constant,
      sym_identifier,
    STATE(329), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2761), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2759), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [52182] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN2,
    STATE(1762), 1,
      sym_heredoc_body,
    ACTIONS(2765), 2,
      sym_constant,
      sym_identifier,
    STATE(891), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2769), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2767), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [52235] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1763), 1,
      sym_heredoc_body,
    STATE(1782), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [52312] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1764), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [52387] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1765), 1,
      sym_heredoc_body,
    STATE(1806), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52436] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_COMMA,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1766), 1,
      sym_heredoc_body,
    STATE(1769), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2067), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52515] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    STATE(1767), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52564] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1768), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [52639] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_COMMA,
    STATE(1769), 1,
      sym_heredoc_body,
    STATE(1796), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52690] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1770), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [52765] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2833), 1,
      anon_sym_COMMA,
    STATE(1771), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52814] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1772), 1,
      sym_heredoc_body,
    ACTIONS(2683), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2125), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52891] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2719), 1,
      anon_sym_QMARK,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1773), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2302), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [52964] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1774), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [53039] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    STATE(1775), 1,
      sym_heredoc_body,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53094] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1776), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [53169] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    STATE(1777), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53218] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    STATE(1778), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53267] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2719), 1,
      anon_sym_QMARK,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1779), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [53340] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_LPAREN2,
    STATE(1780), 1,
      sym_heredoc_body,
    ACTIONS(2836), 2,
      sym_constant,
      sym_identifier,
    STATE(2215), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2386), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2384), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [53393] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_COMMA,
    STATE(1769), 1,
      aux_sym_exceptions_repeat1,
    STATE(1781), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53444] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_exceptions_repeat1,
    STATE(1782), 1,
      sym_heredoc_body,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53495] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(186), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1783), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53578] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    STATE(1784), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53627] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1785), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [53702] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1786), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [53777] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2719), 1,
      anon_sym_QMARK,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1787), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [53850] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1788), 1,
      sym_heredoc_body,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 11,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [53919] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(185), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1789), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54002] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    STATE(1790), 1,
      sym_heredoc_body,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 20,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54055] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2719), 1,
      anon_sym_QMARK,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1791), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [54128] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1792), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [54203] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1793), 1,
      sym_heredoc_body,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 11,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [54272] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1769), 1,
      aux_sym_exceptions_repeat1,
    STATE(1794), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [54349] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1782), 1,
      aux_sym_exceptions_repeat1,
    STATE(1795), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54398] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_COMMA,
    STATE(1796), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54447] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(171), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1797), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54530] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(180), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1798), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54613] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1769), 1,
      aux_sym_exceptions_repeat1,
    STATE(1799), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54662] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1800), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [54737] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    STATE(1801), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54786] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1802), 1,
      sym_heredoc_body,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [54859] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    STATE(1803), 1,
      sym_heredoc_body,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54920] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1609), 1,
      anon_sym_LPAREN2,
    STATE(1804), 1,
      sym_heredoc_body,
    ACTIONS(2879), 2,
      sym_constant,
      sym_identifier,
    STATE(1023), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2883), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2881), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [54973] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1805), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [55048] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2885), 1,
      anon_sym_COMMA,
    STATE(1806), 1,
      sym_heredoc_body,
    STATE(1830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55099] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1806), 1,
      aux_sym_exceptions_repeat1,
    STATE(1807), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2067), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [55176] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    STATE(1808), 1,
      sym_heredoc_body,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55237] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1809), 1,
      sym_heredoc_body,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [55306] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    STATE(1810), 1,
      sym_heredoc_body,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55361] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(191), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1811), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55444] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_PIPE,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2673), 1,
      anon_sym_AMP,
    ACTIONS(2677), 1,
      anon_sym_QMARK,
    ACTIONS(2679), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2689), 1,
      anon_sym_GT_EQ,
    ACTIONS(2691), 1,
      anon_sym_CARET,
    ACTIONS(2697), 1,
      anon_sym_EQ_EQ,
    STATE(1812), 1,
      sym_heredoc_body,
    ACTIONS(2683), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2685), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2693), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2675), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2050), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
    ACTIONS(2699), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55521] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    STATE(1813), 1,
      sym_heredoc_body,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55574] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1814), 1,
      sym_heredoc_body,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [55643] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1641), 1,
      anon_sym_LPAREN2,
    STATE(1815), 1,
      sym_heredoc_body,
    ACTIONS(2917), 2,
      sym_constant,
      sym_identifier,
    STATE(1115), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2921), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2919), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [55696] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    STATE(1816), 1,
      sym_heredoc_body,
    ACTIONS(2695), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55747] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(194), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1817), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55830] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    STATE(1818), 1,
      sym_heredoc_body,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55879] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1819), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [55952] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1820), 1,
      sym_heredoc_body,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 12,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [56019] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    STATE(1821), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56066] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    STATE(1822), 1,
      sym_heredoc_body,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56121] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1823), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [56196] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    STATE(1824), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56243] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(167), 1,
      anon_sym_LPAREN2,
    STATE(1825), 1,
      sym_heredoc_body,
    ACTIONS(2923), 2,
      sym_constant,
      sym_identifier,
    STATE(907), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2927), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2925), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [56296] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    STATE(1826), 1,
      sym_heredoc_body,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56347] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1827), 1,
      sym_heredoc_body,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 12,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [56414] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_STAR_STAR,
    STATE(1828), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56463] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2719), 1,
      anon_sym_QMARK,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1829), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [56536] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_COMMA,
    STATE(1830), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56585] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    STATE(1831), 1,
      sym_heredoc_body,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56638] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2938), 1,
      anon_sym_LPAREN2,
    STATE(1832), 1,
      sym_heredoc_body,
    ACTIONS(2932), 2,
      sym_constant,
      sym_identifier,
    STATE(265), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2936), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2934), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [56691] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2729), 1,
      anon_sym_GT_EQ,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_EQ_EQ,
    STATE(1833), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2717), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 9,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [56762] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_PIPE,
    ACTIONS(2713), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2715), 1,
      anon_sym_AMP,
    ACTIONS(2731), 1,
      anon_sym_CARET,
    STATE(1834), 1,
      sym_heredoc_body,
    ACTIONS(2727), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2733), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2735), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56821] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_COMMA,
    STATE(1782), 1,
      aux_sym_exceptions_repeat1,
    STATE(1835), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56871] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1836), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [56945] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    STATE(1837), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56993] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_LPAREN2,
    STATE(1838), 1,
      sym_heredoc_body,
    ACTIONS(2940), 2,
      sym_constant,
      sym_identifier,
    STATE(995), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2944), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2942), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [57043] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    STATE(1839), 1,
      sym_heredoc_body,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57093] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    STATE(1840), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57141] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1841), 1,
      sym_heredoc_body,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [57209] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1842), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [57283] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    STATE(1843), 1,
      sym_heredoc_body,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57335] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1844), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [57409] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1845), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2948), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2946), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57485] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    STATE(1846), 1,
      sym_heredoc_body,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57541] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1847), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [57615] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    STATE(1848), 1,
      sym_heredoc_body,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57671] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1849), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [57745] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LPAREN2,
    STATE(1850), 1,
      sym_heredoc_body,
    ACTIONS(2950), 2,
      sym_constant,
      sym_identifier,
    STATE(1028), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2954), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2952), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [57795] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    STATE(1851), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57843] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1852), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2185), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57919] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    STATE(1853), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57967] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    STATE(1854), 1,
      sym_heredoc_body,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58021] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1855), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58095] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_LPAREN2,
    STATE(1856), 1,
      sym_heredoc_body,
    ACTIONS(2958), 2,
      sym_constant,
      sym_identifier,
    STATE(449), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2962), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2960), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [58145] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    STATE(1857), 1,
      sym_heredoc_body,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58205] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1858), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58279] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1859), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58353] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1860), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58427] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1861), 1,
      sym_heredoc_body,
    STATE(1872), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58475] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1862), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [58547] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1863), 1,
      sym_heredoc_body,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [58615] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1864), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [58687] = 22,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(196), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1865), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58767] = 22,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_do,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(204), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(1866), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58847] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    STATE(1867), 1,
      sym_heredoc_body,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58907] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    STATE(1868), 1,
      sym_heredoc_body,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58961] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    STATE(1869), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59009] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1870), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2125), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [59083] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1871), 1,
      sym_heredoc_body,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59151] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2966), 1,
      anon_sym_COMMA,
    STATE(1872), 1,
      sym_heredoc_body,
    STATE(1893), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59201] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1873), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [59275] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    STATE(1874), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59323] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    STATE(1875), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59371] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1876), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [59445] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    STATE(1877), 1,
      sym_heredoc_body,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59495] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1878), 1,
      sym_heredoc_body,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59563] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1879), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2180), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59639] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    STATE(1880), 1,
      sym_heredoc_body,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59691] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    STATE(1881), 1,
      sym_heredoc_body,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59743] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1882), 1,
      sym_heredoc_body,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59811] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1883), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [59885] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1884), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2178), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59961] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1885), 1,
      sym_heredoc_body,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [60029] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1886), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [60101] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2840), 1,
      anon_sym_COMMA,
    STATE(1782), 1,
      aux_sym_exceptions_repeat1,
    STATE(1887), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2067), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60179] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    STATE(1888), 1,
      sym_heredoc_body,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60239] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    STATE(1889), 1,
      sym_heredoc_body,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60293] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_EQ_GT,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1890), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2968), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2131), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60371] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1891), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [60445] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    STATE(1892), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60493] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2970), 1,
      anon_sym_COMMA,
    STATE(1893), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60541] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    STATE(1894), 1,
      sym_heredoc_body,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60597] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    STATE(1895), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60645] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1896), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2050), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [60719] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1897), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [60793] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1898), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [60867] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    STATE(1899), 1,
      sym_heredoc_body,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60917] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_PIPE,
    ACTIONS(2805), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    ACTIONS(2813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2815), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2821), 1,
      anon_sym_GT_EQ,
    ACTIONS(2823), 1,
      anon_sym_CARET,
    ACTIONS(2829), 1,
      anon_sym_EQ_EQ,
    STATE(1900), 1,
      sym_heredoc_body,
    ACTIONS(2817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2809), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2827), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2831), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [60991] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1872), 1,
      aux_sym_exceptions_repeat1,
    STATE(1901), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2067), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61067] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1902), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [61141] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1903), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2948), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2125), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61217] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3009), 1,
      anon_sym_LPAREN2,
    STATE(1904), 1,
      sym_heredoc_body,
    ACTIONS(3003), 2,
      sym_constant,
      sym_identifier,
    STATE(774), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(3007), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3005), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [61267] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1905), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [61341] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1906), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2107), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [61415] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1907), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3013), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3011), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61490] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1908), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2176), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61565] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1909), 1,
      sym_heredoc_body,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [61632] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1910), 1,
      sym_heredoc_body,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [61699] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    STATE(1911), 1,
      sym_heredoc_body,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61750] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1912), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61823] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1913), 1,
      sym_heredoc_body,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [61890] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1914), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3013), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3015), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61965] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2885), 1,
      anon_sym_COMMA,
    ACTIONS(2887), 1,
      anon_sym_PIPE,
    ACTIONS(2889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2891), 1,
      anon_sym_AMP,
    ACTIONS(2895), 1,
      anon_sym_QMARK,
    ACTIONS(2897), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2905), 1,
      anon_sym_GT_EQ,
    ACTIONS(2907), 1,
      anon_sym_CARET,
    ACTIONS(2913), 1,
      anon_sym_EQ_EQ,
    STATE(1806), 1,
      aux_sym_exceptions_repeat1,
    STATE(1915), 1,
      sym_heredoc_body,
    ACTIONS(2901), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2909), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2067), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2893), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2911), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2915), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62042] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_COMMA,
    STATE(1916), 1,
      sym_heredoc_body,
    STATE(1930), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62091] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1917), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [62162] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1918), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2115), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62235] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1919), 1,
      sym_heredoc_body,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [62302] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    STATE(1920), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62349] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1921), 1,
      sym_heredoc_body,
    STATE(2277), 1,
      sym__terminator,
    ACTIONS(1123), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62426] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1922), 1,
      sym_heredoc_body,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62499] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1923), 1,
      sym_heredoc_body,
    STATE(2247), 1,
      sym__terminator,
    ACTIONS(1123), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62576] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1924), 1,
      sym_heredoc_body,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62649] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1925), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2948), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3011), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62724] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1926), 1,
      sym_heredoc_body,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62797] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    STATE(1927), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62844] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1928), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2125), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62917] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1929), 1,
      sym_heredoc_body,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2115), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62990] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_COMMA,
    STATE(1930), 1,
      sym_heredoc_body,
    STATE(1936), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2061), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2057), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63039] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(2773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2779), 1,
      anon_sym_QMARK,
    ACTIONS(2781), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2783), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2789), 1,
      anon_sym_GT_EQ,
    ACTIONS(2791), 1,
      anon_sym_CARET,
    ACTIONS(2797), 1,
      anon_sym_EQ_EQ,
    STATE(1931), 1,
      sym_heredoc_body,
    ACTIONS(2785), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2787), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2793), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2948), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2777), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2795), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3015), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2799), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63114] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    STATE(1932), 1,
      sym_heredoc_body,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63169] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    STATE(1933), 1,
      sym_heredoc_body,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63228] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    STATE(1934), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63275] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1935), 1,
      sym_heredoc_body,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2119), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [63346] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_COMMA,
    STATE(1936), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2055), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2050), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63393] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    STATE(1937), 1,
      sym_heredoc_body,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63452] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    STATE(1938), 1,
      sym_heredoc_body,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63505] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    STATE(1939), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63552] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1940), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2125), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63627] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(105), 1,
      sym__terminator,
    STATE(1941), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63704] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1930), 1,
      aux_sym_exceptions_repeat1,
    STATE(1942), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63751] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1943), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2050), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63824] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    STATE(1944), 1,
      sym_heredoc_body,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 20,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63873] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_COMMA,
    STATE(1745), 1,
      aux_sym_exceptions_repeat1,
    STATE(1945), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63922] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    STATE(1946), 1,
      sym_heredoc_body,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63975] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    STATE(1947), 1,
      sym_heredoc_body,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64030] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1948), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64103] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    STATE(1949), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64150] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2701), 1,
      anon_sym_COMMA,
    STATE(1745), 1,
      aux_sym_exceptions_repeat1,
    STATE(1950), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2067), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64227] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1951), 1,
      sym_heredoc_body,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64300] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1952), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64373] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1953), 1,
      sym_heredoc_body,
    STATE(2252), 1,
      sym__terminator,
    ACTIONS(1123), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64450] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2977), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_QMARK,
    ACTIONS(2983), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2991), 1,
      anon_sym_GT_EQ,
    ACTIONS(2993), 1,
      anon_sym_CARET,
    ACTIONS(2999), 1,
      anon_sym_EQ_EQ,
    STATE(1954), 1,
      sym_heredoc_body,
    ACTIONS(2987), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2989), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2979), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3001), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64523] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    STATE(1955), 1,
      sym_heredoc_body,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 20,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64572] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2885), 1,
      anon_sym_COMMA,
    STATE(1806), 1,
      aux_sym_exceptions_repeat1,
    STATE(1956), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2067), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64621] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2846), 1,
      anon_sym_AMP,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2864), 1,
      anon_sym_GT_EQ,
    ACTIONS(2866), 1,
      anon_sym_CARET,
    ACTIONS(2872), 1,
      anon_sym_EQ_EQ,
    STATE(1957), 1,
      sym_heredoc_body,
    ACTIONS(2858), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2860), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2848), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2870), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3054), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
    ACTIONS(2874), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64696] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    STATE(1958), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64743] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_STAR_STAR,
    STATE(1959), 1,
      sym_heredoc_body,
    ACTIONS(2995), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2997), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64794] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1930), 1,
      aux_sym_exceptions_repeat1,
    STATE(1960), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2067), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64869] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(113), 1,
      sym__terminator,
    STATE(1961), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64946] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(102), 1,
      sym__terminator,
    STATE(1962), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65023] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_COMMA,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1930), 1,
      aux_sym_exceptions_repeat1,
    STATE(1963), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2067), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65100] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1964), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65146] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    STATE(1965), 1,
      sym_heredoc_body,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65200] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1966), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65272] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    STATE(1967), 1,
      sym_heredoc_body,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65324] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1968), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2050), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65396] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1969), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65468] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    STATE(1970), 1,
      sym_heredoc_body,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65526] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1971), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2119), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65596] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1972), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2115), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65668] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    STATE(1973), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65714] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1974), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2125), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65786] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1975), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2115), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65858] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1976), 1,
      sym_heredoc_body,
    STATE(2339), 1,
      sym__terminator,
    ACTIONS(1123), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65932] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1977), 1,
      sym_heredoc_body,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [65998] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    STATE(1978), 1,
      sym_heredoc_body,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66048] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1979), 1,
      sym_heredoc_body,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [66114] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1980), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66186] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    STATE(1981), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66232] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1982), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3015), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66306] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1983), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66378] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    STATE(1984), 1,
      sym_heredoc_body,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66426] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1985), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 8,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [66492] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1986), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66564] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1987), 1,
      sym_heredoc_body,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 17,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66614] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    STATE(1988), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66660] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    STATE(1989), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3011), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66734] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1990), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 8,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [66800] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1991), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66872] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1992), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2119), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66942] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(128), 1,
      sym__terminator,
    STATE(1993), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67016] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3086), 1,
      anon_sym_PIPE,
    STATE(1994), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3011), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67090] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    STATE(1995), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67148] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1996), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67200] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3023), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_QMARK,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3039), 1,
      anon_sym_GT_EQ,
    ACTIONS(3041), 1,
      anon_sym_CARET,
    ACTIONS(3047), 1,
      anon_sym_EQ_EQ,
    STATE(1997), 1,
      sym_heredoc_body,
    ACTIONS(3033), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3037), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3043), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3088), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3025), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3045), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3049), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67274] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2637), 1,
      anon_sym_AMP,
    ACTIONS(2641), 1,
      anon_sym_QMARK,
    ACTIONS(2643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2651), 1,
      anon_sym_GT_EQ,
    ACTIONS(2653), 1,
      anon_sym_CARET,
    ACTIONS(2659), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3090), 1,
      anon_sym_PIPE,
    STATE(1998), 1,
      sym_heredoc_body,
    ACTIONS(2647), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2649), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2655), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2956), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3015), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2639), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2657), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2661), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67348] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1999), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67394] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(2000), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67440] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    STATE(2001), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67494] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(2002), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67566] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(2003), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67638] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(2004), 1,
      sym_heredoc_body,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 19,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67686] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_RPAREN,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2005), 1,
      sym_heredoc_body,
    ACTIONS(3108), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67759] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3134), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3136), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    STATE(2006), 1,
      sym_heredoc_body,
    ACTIONS(3138), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2119), 4,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67828] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3164), 1,
      anon_sym_COLON2,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2007), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67901] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3188), 1,
      anon_sym_RPAREN,
    STATE(2008), 1,
      sym_heredoc_body,
    ACTIONS(3108), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67974] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    STATE(2009), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68019] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    STATE(2010), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68064] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3190), 1,
      anon_sym_COLON2,
    STATE(2011), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68137] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3134), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3136), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3192), 1,
      anon_sym_QMARK,
    STATE(2012), 1,
      sym_heredoc_body,
    ACTIONS(3138), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2107), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68208] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    STATE(2013), 1,
      sym_heredoc_body,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68255] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3194), 1,
      anon_sym_COLON2,
    STATE(2014), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68328] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3196), 1,
      anon_sym_RPAREN,
    STATE(2015), 1,
      sym_heredoc_body,
    ACTIONS(3108), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68401] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2016), 1,
      sym_heredoc_body,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2107), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68472] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3198), 1,
      anon_sym_COLON2,
    STATE(2017), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68545] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2018), 1,
      sym_heredoc_body,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2107), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68616] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3200), 1,
      anon_sym_COLON2,
    STATE(2019), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68689] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3134), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3136), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3192), 1,
      anon_sym_QMARK,
    STATE(2020), 1,
      sym_heredoc_body,
    ACTIONS(3138), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2111), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68760] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3134), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3136), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3192), 1,
      anon_sym_QMARK,
    STATE(2021), 1,
      sym_heredoc_body,
    ACTIONS(3138), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2107), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68831] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3202), 1,
      anon_sym_COLON2,
    STATE(2022), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68904] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    STATE(2023), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68949] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    STATE(2024), 1,
      sym_heredoc_body,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      sym__binary_minus,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68996] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    STATE(2025), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69041] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    STATE(2026), 1,
      sym_heredoc_body,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69094] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    STATE(2027), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69139] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3204), 1,
      anon_sym_COLON2,
    STATE(2028), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69212] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2029), 1,
      sym_heredoc_body,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2111), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69283] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    STATE(2030), 1,
      sym_heredoc_body,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69334] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    STATE(2031), 1,
      sym_heredoc_body,
    ACTIONS(2109), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69379] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    STATE(2032), 1,
      sym_heredoc_body,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 13,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69436] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3206), 1,
      anon_sym_COLON2,
    STATE(2033), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69509] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    STATE(2034), 1,
      sym_heredoc_body,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69562] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3208), 1,
      anon_sym_COLON2,
    STATE(2035), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69635] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_EQ_GT,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3134), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3136), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3192), 1,
      anon_sym_QMARK,
    STATE(2036), 1,
      sym_heredoc_body,
    ACTIONS(3138), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3210), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69708] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2037), 1,
      sym_heredoc_body,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2113), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69779] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2038), 1,
      sym_heredoc_body,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [69844] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    STATE(2039), 1,
      sym_heredoc_body,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69893] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    STATE(2040), 1,
      sym_heredoc_body,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [69958] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2041), 1,
      sym_heredoc_body,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [70023] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2042), 1,
      sym_heredoc_body,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2115), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70094] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3134), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3136), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3192), 1,
      anon_sym_QMARK,
    STATE(2043), 1,
      sym_heredoc_body,
    ACTIONS(3138), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2113), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70165] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2044), 1,
      sym_heredoc_body,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2119), 4,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70234] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    STATE(2045), 1,
      sym_heredoc_body,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 13,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70291] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3212), 1,
      anon_sym_COLON2,
    STATE(2046), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70364] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3214), 1,
      anon_sym_COLON2,
    STATE(2047), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70437] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3216), 1,
      anon_sym_COLON2,
    STATE(2048), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70510] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3218), 1,
      anon_sym_COLON2,
    STATE(2049), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70583] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    STATE(2050), 1,
      sym_heredoc_body,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70634] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    STATE(2051), 1,
      sym_heredoc_body,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 18,
      sym__binary_minus,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70681] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    STATE(2052), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70726] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3220), 1,
      anon_sym_COLON2,
    STATE(2053), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70799] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2054), 1,
      sym_heredoc_body,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2111), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70870] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2055), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [70935] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    STATE(2056), 1,
      sym_heredoc_body,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70984] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    STATE(2057), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71037] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2058), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [71102] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    STATE(2059), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71147] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2060), 1,
      sym_heredoc_body,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2115), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71218] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3134), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3136), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3192), 1,
      anon_sym_QMARK,
    STATE(2061), 1,
      sym_heredoc_body,
    ACTIONS(3138), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2115), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71289] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2062), 1,
      sym_heredoc_body,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2113), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71360] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    STATE(2063), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 14,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71411] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3222), 1,
      anon_sym_COLON2,
    STATE(2064), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71484] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    STATE(2065), 1,
      sym_heredoc_body,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2119), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71553] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    STATE(2066), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 13,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71610] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3224), 1,
      anon_sym_COLON2,
    STATE(2067), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71683] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    STATE(2068), 1,
      sym_heredoc_body,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71728] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3226), 1,
      anon_sym_COLON2,
    STATE(2069), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71801] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2070), 1,
      sym_heredoc_body,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2107), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71872] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3228), 1,
      anon_sym_COLON2,
    STATE(2071), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71945] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    STATE(2072), 1,
      sym_heredoc_body,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2107), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72016] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3126), 1,
      anon_sym_PIPE,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3130), 1,
      anon_sym_AMP,
    ACTIONS(3142), 1,
      anon_sym_GT_EQ,
    ACTIONS(3144), 1,
      anon_sym_CARET,
    ACTIONS(3150), 1,
      anon_sym_EQ_EQ,
    STATE(2073), 1,
      sym_heredoc_body,
    ACTIONS(3140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3132), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3152), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2115), 7,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [72081] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_STAR_STAR,
    STATE(2074), 1,
      sym_heredoc_body,
    ACTIONS(3146), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3148), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2117), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2115), 16,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72130] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3230), 1,
      anon_sym_COLON2,
    STATE(2075), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72200] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3232), 1,
      anon_sym_COLON2,
    STATE(2076), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72270] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3234), 1,
      anon_sym_COLON2,
    STATE(2077), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72340] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3236), 1,
      anon_sym_COLON2,
    STATE(2078), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72410] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3098), 1,
      anon_sym_AMP,
    ACTIONS(3102), 1,
      anon_sym_QMARK,
    ACTIONS(3104), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_GT_EQ,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    ACTIONS(3122), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3238), 1,
      anon_sym_RPAREN,
    STATE(2079), 1,
      sym_heredoc_body,
    ACTIONS(3108), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3110), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3112), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3118), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3100), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3120), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3124), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72480] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_PIPE,
    ACTIONS(3156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3162), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3176), 1,
      anon_sym_GT_EQ,
    ACTIONS(3178), 1,
      anon_sym_CARET,
    ACTIONS(3184), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3240), 1,
      anon_sym_COLON2,
    STATE(2080), 1,
      sym_heredoc_body,
    ACTIONS(3170), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3172), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3174), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3180), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3160), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3182), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3186), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2081), 1,
      sym_heredoc_body,
    ACTIONS(1507), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72587] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2082), 1,
      sym_heredoc_body,
    ACTIONS(1503), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72624] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2083), 1,
      sym_heredoc_body,
    ACTIONS(1453), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72661] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2084), 1,
      sym_heredoc_body,
    ACTIONS(1477), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72698] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2085), 1,
      sym_heredoc_body,
    ACTIONS(1491), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72735] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2086), 1,
      sym_heredoc_body,
    ACTIONS(1487), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72772] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2087), 1,
      sym_heredoc_body,
    ACTIONS(1519), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72809] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2088), 1,
      sym_heredoc_body,
    ACTIONS(1481), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72846] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2089), 1,
      sym_heredoc_body,
    ACTIONS(1511), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72883] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2090), 1,
      sym_heredoc_body,
    ACTIONS(1457), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72920] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_do,
    STATE(2091), 1,
      sym_heredoc_body,
    STATE(2098), 1,
      sym_do_block,
    STATE(2100), 1,
      sym_block,
    ACTIONS(3242), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [72963] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      sym_heredoc_body,
    STATE(2093), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3248), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73002] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      sym_heredoc_body,
    STATE(2095), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3252), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73041] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    STATE(2094), 1,
      sym_heredoc_body,
    STATE(2098), 1,
      sym_do_block,
    STATE(2100), 1,
      sym_block,
    ACTIONS(3242), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73082] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3256), 1,
      anon_sym_COMMA,
    STATE(2095), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3254), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73119] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2096), 1,
      sym_heredoc_body,
    ACTIONS(2131), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73153] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2097), 1,
      sym_heredoc_body,
    ACTIONS(3254), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73187] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2098), 1,
      sym_heredoc_body,
    ACTIONS(3259), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73220] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2099), 1,
      sym_heredoc_body,
    ACTIONS(1770), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(1772), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73255] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2100), 1,
      sym_heredoc_body,
    ACTIONS(3259), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73288] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3261), 1,
      anon_sym_COMMA,
    STATE(2101), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3254), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73323] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2102), 1,
      sym_heredoc_body,
    ACTIONS(3248), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73356] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2103), 1,
      sym_heredoc_body,
    ACTIONS(1694), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(1696), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73391] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3264), 1,
      anon_sym_COMMA,
    STATE(2101), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2104), 1,
      sym_heredoc_body,
    ACTIONS(3252), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73428] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2105), 1,
      sym_heredoc_body,
    ACTIONS(2620), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2622), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73463] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2106), 1,
      sym_heredoc_body,
    ACTIONS(997), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(995), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73498] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2107), 1,
      sym_heredoc_body,
    ACTIONS(1840), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(1842), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73533] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2108), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2580), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73568] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3264), 1,
      anon_sym_COMMA,
    STATE(2104), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2109), 1,
      sym_heredoc_body,
    ACTIONS(3248), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73605] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2110), 1,
      sym_heredoc_body,
    ACTIONS(3266), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73636] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2111), 1,
      sym_heredoc_body,
    ACTIONS(3268), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73667] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2112), 1,
      sym_heredoc_body,
    ACTIONS(3270), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73698] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2113), 1,
      sym_heredoc_body,
    ACTIONS(3272), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73729] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2114), 1,
      sym_heredoc_body,
    ACTIONS(3274), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73760] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2115), 1,
      sym_heredoc_body,
    ACTIONS(2302), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73791] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2116), 1,
      sym_heredoc_body,
    ACTIONS(3276), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73822] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2117), 1,
      sym_heredoc_body,
    ACTIONS(3278), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73853] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2118), 1,
      sym_heredoc_body,
    ACTIONS(3280), 18,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [73883] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2119), 1,
      sym_heredoc_body,
    ACTIONS(997), 18,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [73913] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2120), 1,
      sym_heredoc_body,
    ACTIONS(3284), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3282), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [73944] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2121), 1,
      sym_heredoc_body,
    ACTIONS(3286), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [73973] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2122), 1,
      sym_heredoc_body,
    ACTIONS(3288), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74002] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2123), 1,
      sym_heredoc_body,
    ACTIONS(3290), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74031] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2124), 1,
      sym_heredoc_body,
    ACTIONS(3284), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3292), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74062] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2125), 1,
      sym_heredoc_body,
    ACTIONS(3284), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3294), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74093] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2126), 1,
      sym_heredoc_body,
    ACTIONS(3296), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74122] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym_identifier,
    ACTIONS(3300), 1,
      anon_sym_LBRACE,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3310), 1,
      anon_sym_do,
    STATE(2127), 1,
      sym_heredoc_body,
    STATE(2562), 1,
      sym__simple_formal_parameter,
    STATE(1533), 2,
      sym_do_block,
      sym_block,
    STATE(2621), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74171] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym_identifier,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      anon_sym_do,
    STATE(2128), 1,
      sym_heredoc_body,
    STATE(2562), 1,
      sym__simple_formal_parameter,
    STATE(1181), 2,
      sym_do_block,
      sym_block,
    STATE(2560), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74220] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3316), 1,
      anon_sym_COMMA,
    STATE(2129), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(3280), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74251] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2130), 1,
      sym_heredoc_body,
    ACTIONS(3292), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74280] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      sym_heredoc_body,
    STATE(2133), 1,
      aux_sym_undef_repeat1,
    ACTIONS(3319), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74313] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2132), 1,
      sym_heredoc_body,
    ACTIONS(3284), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3323), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74344] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      aux_sym_undef_repeat1,
    STATE(2133), 1,
      sym_heredoc_body,
    ACTIONS(3325), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74377] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2134), 1,
      sym_heredoc_body,
    ACTIONS(3284), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3327), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3329), 1,
      anon_sym_EQ,
    STATE(2135), 1,
      sym_heredoc_body,
    ACTIONS(2578), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74439] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym_identifier,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3333), 1,
      anon_sym_do,
    STATE(2136), 1,
      sym_heredoc_body,
    STATE(2562), 1,
      sym__simple_formal_parameter,
    STATE(2640), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2644), 2,
      sym_do_block,
      sym_block,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74488] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2137), 1,
      sym_heredoc_body,
    ACTIONS(3335), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74517] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2138), 1,
      sym_heredoc_body,
    ACTIONS(3284), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3337), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74548] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      sym_identifier,
    ACTIONS(3341), 1,
      anon_sym_COMMA,
    ACTIONS(3343), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      anon_sym_SEMI,
    STATE(2139), 1,
      sym_heredoc_body,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2609), 1,
      sym__formal_parameter,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74598] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3347), 1,
      sym_identifier,
    ACTIONS(3349), 1,
      anon_sym_LPAREN,
    ACTIONS(3351), 1,
      anon_sym_STAR,
    ACTIONS(3353), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3355), 1,
      anon_sym_AMP,
    STATE(52), 1,
      sym_parameters,
    STATE(91), 1,
      sym__terminator,
    STATE(2140), 1,
      sym_heredoc_body,
    STATE(2620), 1,
      sym__simple_formal_parameter,
    STATE(2699), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2692), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74646] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3347), 1,
      sym_identifier,
    ACTIONS(3349), 1,
      anon_sym_LPAREN,
    ACTIONS(3351), 1,
      anon_sym_STAR,
    ACTIONS(3353), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3355), 1,
      anon_sym_AMP,
    STATE(43), 1,
      sym_parameters,
    STATE(107), 1,
      sym__terminator,
    STATE(2141), 1,
      sym_heredoc_body,
    STATE(2620), 1,
      sym__simple_formal_parameter,
    STATE(2669), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2692), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74694] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_COMMA,
    ACTIONS(3359), 1,
      anon_sym_PIPE,
    ACTIONS(3361), 1,
      anon_sym_SEMI,
    STATE(2142), 1,
      sym_heredoc_body,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2618), 1,
      sym__formal_parameter,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74744] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3347), 1,
      sym_identifier,
    ACTIONS(3349), 1,
      anon_sym_LPAREN,
    ACTIONS(3351), 1,
      anon_sym_STAR,
    ACTIONS(3353), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3355), 1,
      anon_sym_AMP,
    STATE(49), 1,
      sym_parameters,
    STATE(79), 1,
      sym__terminator,
    STATE(2143), 1,
      sym_heredoc_body,
    STATE(2620), 1,
      sym__simple_formal_parameter,
    STATE(2717), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2692), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74792] = 13,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3298), 1,
      sym_identifier,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3363), 1,
      anon_sym_LBRACE,
    ACTIONS(3365), 1,
      anon_sym_do,
    STATE(2144), 1,
      sym_heredoc_body,
    STATE(2562), 1,
      sym__simple_formal_parameter,
    STATE(1439), 2,
      sym_do_block,
      sym_block,
    STATE(2690), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74838] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3367), 1,
      anon_sym_LT,
    ACTIONS(3369), 1,
      anon_sym_do,
    STATE(110), 1,
      sym__terminator,
    STATE(2145), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    STATE(2727), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [74885] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      sym_identifier,
    ACTIONS(3371), 1,
      anon_sym_PIPE,
    ACTIONS(3373), 1,
      anon_sym_SEMI,
    STATE(2146), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      sym__formal_parameter,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74932] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3367), 1,
      anon_sym_LT,
    ACTIONS(3369), 1,
      anon_sym_do,
    STATE(115), 1,
      sym__terminator,
    STATE(2147), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    STATE(2732), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [74979] = 13,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3347), 1,
      sym_identifier,
    ACTIONS(3349), 1,
      anon_sym_LPAREN,
    ACTIONS(3351), 1,
      anon_sym_STAR,
    ACTIONS(3353), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3355), 1,
      anon_sym_AMP,
    STATE(78), 1,
      sym_parameters,
    STATE(127), 1,
      sym__terminator,
    STATE(2148), 1,
      sym_heredoc_body,
    STATE(2620), 1,
      sym__simple_formal_parameter,
    STATE(2760), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2692), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75024] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      sym_identifier,
    ACTIONS(3375), 1,
      anon_sym_PIPE,
    ACTIONS(3377), 1,
      anon_sym_SEMI,
    STATE(2149), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      sym__formal_parameter,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75071] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    STATE(947), 1,
      sym__terminator,
    STATE(2150), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3379), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [75112] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      sym_identifier,
    ACTIONS(3391), 1,
      anon_sym_PIPE,
    ACTIONS(3393), 1,
      anon_sym_SEMI,
    STATE(2151), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      sym__formal_parameter,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75159] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3367), 1,
      anon_sym_LT,
    ACTIONS(3369), 1,
      anon_sym_do,
    STATE(89), 1,
      sym__terminator,
    STATE(2152), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    STATE(2697), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75206] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    STATE(947), 1,
      sym__terminator,
    STATE(2153), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(457), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [75247] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      sym_identifier,
    ACTIONS(3395), 1,
      anon_sym_PIPE,
    ACTIONS(3397), 1,
      anon_sym_SEMI,
    STATE(2154), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      sym__formal_parameter,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75294] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_do,
    ACTIONS(3399), 1,
      anon_sym_end,
    STATE(87), 1,
      sym__terminator,
    STATE(2155), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75338] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3401), 1,
      sym_identifier,
    ACTIONS(3403), 1,
      anon_sym_RPAREN,
    STATE(2156), 1,
      sym_heredoc_body,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2678), 1,
      sym__formal_parameter,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75382] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3401), 1,
      sym_identifier,
    ACTIONS(3405), 1,
      anon_sym_RPAREN,
    STATE(2157), 1,
      sym_heredoc_body,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2721), 1,
      sym__formal_parameter,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75426] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_do,
    ACTIONS(3407), 1,
      anon_sym_end,
    STATE(103), 1,
      sym__terminator,
    STATE(2158), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75470] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3401), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_RPAREN,
    STATE(2159), 1,
      sym_heredoc_body,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2676), 1,
      sym__formal_parameter,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75514] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_do,
    ACTIONS(3411), 1,
      anon_sym_end,
    STATE(111), 1,
      sym__terminator,
    STATE(2160), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75558] = 13,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3367), 1,
      anon_sym_LT,
    ACTIONS(3369), 1,
      anon_sym_do,
    STATE(122), 1,
      sym__terminator,
    STATE(2161), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    STATE(2754), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75602] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_do,
    STATE(2162), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    ACTIONS(111), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75640] = 12,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_do,
    ACTIONS(3413), 1,
      anon_sym_end,
    STATE(117), 1,
      sym__terminator,
    STATE(2163), 1,
      sym_heredoc_body,
    STATE(2169), 1,
      sym_argument_list,
    STATE(2255), 1,
      sym_do_block,
    STATE(2258), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75681] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3401), 1,
      sym_identifier,
    STATE(2164), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      sym__formal_parameter,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75722] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3415), 1,
      sym_identifier,
    STATE(2165), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      sym__formal_parameter,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75763] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3347), 1,
      sym_identifier,
    ACTIONS(3351), 1,
      anon_sym_STAR,
    ACTIONS(3353), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3355), 1,
      anon_sym_AMP,
    ACTIONS(3417), 1,
      anon_sym_LPAREN,
    STATE(2166), 1,
      sym_heredoc_body,
    STATE(2712), 1,
      sym_parameters,
    STATE(2713), 1,
      sym__simple_formal_parameter,
    STATE(2716), 1,
      sym__formal_parameter,
    STATE(2692), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75804] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_LPAREN2,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_do,
    STATE(2167), 1,
      sym_heredoc_body,
    STATE(2194), 1,
      sym_argument_list,
    STATE(2315), 1,
      sym_do_block,
    STATE(2365), 1,
      sym_block,
    ACTIONS(111), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75841] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      anon_sym_STAR,
    ACTIONS(3306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3308), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      sym_identifier,
    STATE(2168), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      sym__formal_parameter,
    STATE(2472), 1,
      sym__simple_formal_parameter,
    STATE(2475), 1,
      sym_parameters,
    STATE(2433), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75882] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_do,
    STATE(2169), 1,
      sym_heredoc_body,
    STATE(2267), 1,
      sym_do_block,
    STATE(2268), 1,
      sym_block,
    ACTIONS(1433), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75914] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_LT,
    STATE(115), 1,
      sym__terminator,
    STATE(2170), 1,
      sym_heredoc_body,
    STATE(2732), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [75946] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_LT,
    STATE(89), 1,
      sym__terminator,
    STATE(2171), 1,
      sym_heredoc_body,
    STATE(2697), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [75978] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_LT,
    STATE(110), 1,
      sym__terminator,
    STATE(2172), 1,
      sym_heredoc_body,
    STATE(2727), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76010] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2173), 1,
      sym_heredoc_body,
    ACTIONS(973), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LT,
      anon_sym_end,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76034] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2174), 1,
      sym_heredoc_body,
    ACTIONS(979), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LT,
      anon_sym_end,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76058] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_LT,
    STATE(122), 1,
      sym__terminator,
    STATE(2175), 1,
      sym_heredoc_body,
    STATE(2754), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76087] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_COMMA,
    STATE(2176), 1,
      sym_heredoc_body,
    STATE(2180), 1,
      aux_sym_undef_repeat1,
    ACTIONS(3319), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76114] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3423), 1,
      anon_sym_do,
    STATE(2177), 1,
      sym_heredoc_body,
    STATE(2234), 1,
      sym_do_block,
    STATE(2236), 1,
      sym_block,
    ACTIONS(3242), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [76143] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2178), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3292), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76168] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2179), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3282), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76193] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_COMMA,
    STATE(2180), 1,
      sym_heredoc_body,
    STATE(2192), 1,
      aux_sym_undef_repeat1,
    ACTIONS(3325), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76220] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2181), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3327), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76245] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2182), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3337), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76270] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2183), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3294), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76295] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_COMMA,
    STATE(2184), 1,
      sym_heredoc_body,
    STATE(2186), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3248), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76320] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2185), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3323), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76345] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_COMMA,
    STATE(2186), 1,
      sym_heredoc_body,
    STATE(2199), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3252), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76370] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    STATE(2187), 1,
      sym_heredoc_body,
    STATE(2234), 1,
      sym_do_block,
    STATE(2236), 1,
      sym_block,
    ACTIONS(3242), 9,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76397] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3407), 1,
      anon_sym_end,
    STATE(103), 1,
      sym__terminator,
    STATE(2188), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76426] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3411), 1,
      anon_sym_end,
    STATE(111), 1,
      sym__terminator,
    STATE(2189), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2190), 1,
      sym_heredoc_body,
    ACTIONS(979), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76478] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_end,
    STATE(87), 1,
      sym__terminator,
    STATE(2191), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76507] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_COMMA,
    STATE(2192), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(3280), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2193), 1,
      sym_heredoc_body,
    ACTIONS(987), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76555] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_do,
    STATE(2194), 1,
      sym_heredoc_body,
    STATE(2361), 1,
      sym_block,
    STATE(2362), 1,
      sym_do_block,
    ACTIONS(1433), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [76586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2195), 1,
      sym_heredoc_body,
    ACTIONS(1029), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2196), 1,
      sym_heredoc_body,
    ACTIONS(973), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2197), 1,
      sym_heredoc_body,
    ACTIONS(983), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2198), 1,
      sym_heredoc_body,
    ACTIONS(923), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76678] = 4,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3432), 1,
      anon_sym_COMMA,
    STATE(2199), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3254), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2200), 1,
      sym_heredoc_body,
    ACTIONS(997), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    STATE(2201), 1,
      sym_heredoc_body,
    ACTIONS(2578), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76749] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2202), 1,
      sym_heredoc_body,
    ACTIONS(2620), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76771] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2203), 1,
      sym_heredoc_body,
    ACTIONS(1770), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76793] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(137), 1,
      sym__terminator,
    STATE(2204), 1,
      sym_heredoc_body,
    STATE(2528), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [76831] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(140), 1,
      sym__terminator,
    STATE(2205), 1,
      sym_heredoc_body,
    STATE(2521), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [76869] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_end,
    STATE(117), 1,
      sym__terminator,
    STATE(2206), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(923), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76895] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2207), 1,
      sym_heredoc_body,
    ACTIONS(3254), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76915] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2580), 1,
      anon_sym_STAR,
    ACTIONS(3329), 1,
      anon_sym_EQ,
    STATE(2208), 1,
      sym_heredoc_body,
    ACTIONS(923), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(2578), 6,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [76943] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(139), 1,
      sym__terminator,
    STATE(2209), 1,
      sym_heredoc_body,
    STATE(2520), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [76981] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2210), 1,
      sym_heredoc_body,
    ACTIONS(1694), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [77003] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2211), 1,
      sym_heredoc_body,
    ACTIONS(2578), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [77025] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(142), 1,
      sym__terminator,
    STATE(2212), 1,
      sym_heredoc_body,
    STATE(2535), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77063] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(147), 1,
      sym__terminator,
    STATE(2213), 1,
      sym_heredoc_body,
    STATE(2546), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77101] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(141), 1,
      sym__terminator,
    STATE(2214), 1,
      sym_heredoc_body,
    STATE(2526), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77139] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2215), 1,
      sym_heredoc_body,
    ACTIONS(1029), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77161] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2216), 1,
      sym_heredoc_body,
    ACTIONS(923), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77183] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2217), 1,
      sym_heredoc_body,
    ACTIONS(987), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77205] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2218), 1,
      sym_heredoc_body,
    ACTIONS(983), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77227] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_if,
    ACTIONS(3443), 1,
      anon_sym_unless,
    ACTIONS(3445), 1,
      anon_sym_while,
    ACTIONS(3447), 1,
      anon_sym_until,
    ACTIONS(3449), 1,
      anon_sym_rescue,
    STATE(968), 1,
      sym__terminator,
    STATE(2219), 1,
      sym_heredoc_body,
    ACTIONS(457), 2,
      ts_builtin_sym_end,
      anon_sym___END__,
    ACTIONS(3439), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77263] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_if,
    ACTIONS(3443), 1,
      anon_sym_unless,
    ACTIONS(3445), 1,
      anon_sym_while,
    ACTIONS(3447), 1,
      anon_sym_until,
    ACTIONS(3449), 1,
      anon_sym_rescue,
    STATE(968), 1,
      sym__terminator,
    STATE(2220), 1,
      sym_heredoc_body,
    ACTIONS(3379), 2,
      ts_builtin_sym_end,
      anon_sym___END__,
    ACTIONS(3439), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77299] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(145), 1,
      sym__terminator,
    STATE(2221), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77337] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2222), 1,
      sym_heredoc_body,
    ACTIONS(1840), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [77359] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2223), 1,
      sym_heredoc_body,
    ACTIONS(1491), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77378] = 4,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    STATE(2224), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3254), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [77399] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2225), 1,
      sym_heredoc_body,
    ACTIONS(1487), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77418] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2226), 1,
      sym_heredoc_body,
    ACTIONS(1519), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77437] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2227), 1,
      sym_heredoc_body,
    ACTIONS(1511), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77456] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2228), 1,
      sym_heredoc_body,
    ACTIONS(1503), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77475] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_COMMA,
    STATE(2224), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2229), 1,
      sym_heredoc_body,
    ACTIONS(3252), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [77498] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2230), 1,
      sym_heredoc_body,
    ACTIONS(1507), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77517] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2231), 1,
      sym_heredoc_body,
    ACTIONS(1453), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77536] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2580), 1,
      anon_sym_STAR,
    STATE(2232), 1,
      sym_heredoc_body,
    ACTIONS(923), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(2578), 6,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [77561] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2233), 1,
      sym_heredoc_body,
    ACTIONS(1477), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77580] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2234), 1,
      sym_heredoc_body,
    ACTIONS(3259), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77599] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2235), 1,
      sym_heredoc_body,
    ACTIONS(1457), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77618] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2236), 1,
      sym_heredoc_body,
    ACTIONS(3259), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77637] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2237), 1,
      sym_heredoc_body,
    ACTIONS(3248), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77656] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_COMMA,
    STATE(2229), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2238), 1,
      sym_heredoc_body,
    ACTIONS(3248), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [77679] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(149), 1,
      sym__terminator,
    STATE(2239), 1,
      sym_heredoc_body,
    STATE(2590), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77714] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(154), 1,
      sym__terminator,
    STATE(2240), 1,
      sym_heredoc_body,
    STATE(2589), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77749] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3456), 1,
      anon_sym_end,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    STATE(2241), 1,
      sym_heredoc_body,
    STATE(2289), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [77779] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3464), 1,
      anon_sym_end,
    STATE(2242), 1,
      sym_heredoc_body,
    STATE(2304), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [77809] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3466), 1,
      anon_sym_end,
    STATE(2243), 1,
      sym_heredoc_body,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [77839] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    STATE(947), 1,
      sym__terminator,
    STATE(2244), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77871] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3470), 1,
      aux_sym_string_array_token1,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3476), 1,
      sym__string_end,
    STATE(2245), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2677), 1,
      aux_sym_symbol_array_repeat1,
  [77905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2246), 1,
      sym_heredoc_body,
    ACTIONS(1481), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [77925] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3480), 1,
      anon_sym_end,
    ACTIONS(3482), 1,
      anon_sym_when,
    STATE(2247), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym_case_repeat1,
    STATE(2395), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2791), 1,
      sym_else,
  [77959] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3484), 1,
      anon_sym_end,
    STATE(2248), 1,
      sym_heredoc_body,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [77989] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3486), 1,
      anon_sym_end,
    STATE(2249), 1,
      sym_heredoc_body,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78019] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3488), 1,
      anon_sym_end,
    STATE(2250), 1,
      sym_heredoc_body,
    STATE(2414), 1,
      aux_sym_case_repeat2,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2731), 1,
      sym_when,
    STATE(2912), 1,
      sym_else,
  [78053] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3490), 1,
      anon_sym_end,
    STATE(2251), 1,
      sym_heredoc_body,
    STATE(2480), 1,
      aux_sym_case_repeat2,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2731), 1,
      sym_when,
    STATE(2787), 1,
      sym_else,
  [78087] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3492), 1,
      anon_sym_end,
    STATE(2252), 1,
      sym_heredoc_body,
    STATE(2311), 1,
      aux_sym_case_repeat1,
    STATE(2409), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2907), 1,
      sym_else,
  [78121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2253), 1,
      sym_heredoc_body,
    ACTIONS(1469), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2254), 1,
      sym_heredoc_body,
    ACTIONS(1449), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2255), 1,
      sym_heredoc_body,
    ACTIONS(1499), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78181] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3494), 1,
      anon_sym_end,
    STATE(2256), 1,
      sym_heredoc_body,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78211] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3496), 1,
      anon_sym_end,
    ACTIONS(3498), 1,
      anon_sym_rescue,
    ACTIONS(3501), 1,
      anon_sym_else,
    ACTIONS(3504), 1,
      anon_sym_ensure,
    STATE(2257), 2,
      sym_heredoc_body,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2258), 1,
      sym_heredoc_body,
    ACTIONS(1499), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2259), 1,
      sym_heredoc_body,
    ACTIONS(1465), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78279] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3507), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2260), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78309] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3509), 1,
      aux_sym_string_array_token1,
    ACTIONS(3511), 1,
      sym__string_end,
    STATE(2261), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2670), 1,
      aux_sym_string_array_repeat1,
  [78343] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3507), 1,
      anon_sym_end,
    STATE(2249), 1,
      aux_sym__body_statement_repeat1,
    STATE(2262), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2263), 1,
      sym_heredoc_body,
    ACTIONS(111), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2264), 1,
      sym_heredoc_body,
    ACTIONS(1477), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78413] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3513), 1,
      aux_sym_string_array_token1,
    ACTIONS(3515), 1,
      sym__string_end,
    STATE(2265), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2726), 1,
      aux_sym_symbol_array_repeat1,
  [78447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2266), 1,
      sym_heredoc_body,
    ACTIONS(1473), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2267), 1,
      sym_heredoc_body,
    ACTIONS(1461), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2268), 1,
      sym_heredoc_body,
    ACTIONS(1461), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78507] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3517), 1,
      aux_sym_string_array_token1,
    ACTIONS(3519), 1,
      sym__string_end,
    STATE(2269), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2715), 1,
      aux_sym_symbol_array_repeat1,
  [78541] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3521), 1,
      anon_sym_end,
    STATE(2270), 1,
      sym_heredoc_body,
    STATE(2275), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2271), 1,
      sym_heredoc_body,
    ACTIONS(1437), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(3523), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [78593] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3525), 1,
      aux_sym_string_array_token1,
    ACTIONS(3527), 1,
      sym__string_end,
    STATE(2272), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2719), 1,
      aux_sym_string_array_repeat1,
  [78627] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_if,
    ACTIONS(3383), 1,
      anon_sym_unless,
    ACTIONS(3385), 1,
      anon_sym_while,
    ACTIONS(3387), 1,
      anon_sym_until,
    ACTIONS(3389), 1,
      anon_sym_rescue,
    STATE(968), 1,
      sym__terminator,
    STATE(2273), 1,
      sym_heredoc_body,
    ACTIONS(3439), 2,
      sym__line_break,
      anon_sym_SEMI,
  [78659] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3521), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2274), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78689] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3529), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2275), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2276), 1,
      sym_heredoc_body,
    ACTIONS(1507), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78739] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3531), 1,
      anon_sym_end,
    STATE(2277), 1,
      sym_heredoc_body,
    STATE(2312), 1,
      aux_sym_case_repeat1,
    STATE(2459), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2820), 1,
      sym_else,
  [78773] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3533), 1,
      anon_sym_end,
    STATE(2278), 1,
      sym_heredoc_body,
    STATE(2457), 1,
      aux_sym_case_repeat2,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2731), 1,
      sym_when,
    STATE(2832), 1,
      sym_else,
  [78807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2279), 1,
      sym_heredoc_body,
    ACTIONS(1495), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78827] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3535), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2280), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78857] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3537), 1,
      aux_sym_string_array_token1,
    ACTIONS(3539), 1,
      sym__string_end,
    STATE(2281), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2720), 1,
      aux_sym_string_array_repeat1,
  [78891] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3541), 1,
      aux_sym_string_array_token1,
    ACTIONS(3543), 1,
      sym__string_end,
    STATE(2282), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2722), 1,
      aux_sym_symbol_array_repeat1,
  [78925] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3545), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2283), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78955] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3545), 1,
      anon_sym_end,
    STATE(2248), 1,
      aux_sym__body_statement_repeat1,
    STATE(2284), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78985] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3547), 1,
      anon_sym_end,
    STATE(2250), 1,
      aux_sym_case_repeat1,
    STATE(2285), 1,
      sym_heredoc_body,
    STATE(2488), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2859), 1,
      sym_else,
  [79019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2286), 1,
      sym_heredoc_body,
    ACTIONS(1437), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(3549), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [79041] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3551), 1,
      anon_sym_end,
    STATE(2278), 1,
      aux_sym_case_repeat1,
    STATE(2287), 1,
      sym_heredoc_body,
    STATE(2425), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2818), 1,
      sym_else,
  [79075] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3456), 1,
      anon_sym_end,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2288), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79105] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3553), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2289), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2580), 1,
      anon_sym_STAR,
    ACTIONS(3329), 1,
      anon_sym_EQ,
    STATE(2290), 1,
      sym_heredoc_body,
    ACTIONS(2578), 6,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [79159] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3555), 1,
      anon_sym_end,
    STATE(2291), 1,
      sym_heredoc_body,
    STATE(2444), 1,
      aux_sym_case_repeat2,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2731), 1,
      sym_when,
    STATE(2849), 1,
      sym_else,
  [79193] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3557), 1,
      anon_sym_end,
    STATE(2292), 1,
      sym_heredoc_body,
    STATE(2305), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79223] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3559), 1,
      aux_sym_string_array_token1,
    ACTIONS(3561), 1,
      sym__string_end,
    STATE(2293), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2711), 1,
      aux_sym_symbol_array_repeat1,
  [79257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2294), 1,
      sym_heredoc_body,
    ACTIONS(1457), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79277] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3563), 1,
      aux_sym_string_array_token1,
    ACTIONS(3565), 1,
      sym__string_end,
    STATE(2295), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2701), 1,
      aux_sym_string_array_repeat1,
  [79311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2296), 1,
      sym_heredoc_body,
    ACTIONS(1503), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2297), 1,
      sym_heredoc_body,
    ACTIONS(1511), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2298), 1,
      sym_heredoc_body,
    ACTIONS(1519), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2299), 1,
      sym_heredoc_body,
    ACTIONS(1487), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2300), 1,
      sym_heredoc_body,
    ACTIONS(1491), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79411] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3567), 1,
      anon_sym_end,
    STATE(2251), 1,
      aux_sym_case_repeat1,
    STATE(2301), 1,
      sym_heredoc_body,
    STATE(2485), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2856), 1,
      sym_else,
  [79445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2302), 1,
      sym_heredoc_body,
    ACTIONS(1453), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79465] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3557), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2303), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79495] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3569), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2304), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79525] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3571), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2305), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79555] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3573), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2306), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79585] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3575), 1,
      aux_sym_string_array_token1,
    ACTIONS(3577), 1,
      sym__string_end,
    STATE(2307), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2705), 1,
      aux_sym_symbol_array_repeat1,
  [79619] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3466), 1,
      anon_sym_end,
    STATE(2280), 1,
      aux_sym__body_statement_repeat1,
    STATE(2308), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79649] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3579), 1,
      aux_sym_string_array_token1,
    ACTIONS(3581), 1,
      sym__string_end,
    STATE(2309), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2686), 1,
      aux_sym_string_array_repeat1,
  [79683] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3583), 1,
      aux_sym_string_array_token1,
    ACTIONS(3585), 1,
      sym__string_end,
    STATE(2310), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2708), 1,
      aux_sym_string_array_repeat1,
  [79717] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3587), 1,
      anon_sym_end,
    STATE(2311), 1,
      sym_heredoc_body,
    STATE(2439), 1,
      aux_sym_case_repeat2,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2731), 1,
      sym_when,
    STATE(2911), 1,
      sym_else,
  [79751] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3589), 1,
      anon_sym_end,
    STATE(2312), 1,
      sym_heredoc_body,
    STATE(2388), 1,
      aux_sym_case_repeat2,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2731), 1,
      sym_when,
    STATE(2850), 1,
      sym_else,
  [79785] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3464), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2313), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79815] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3573), 1,
      anon_sym_end,
    STATE(2256), 1,
      aux_sym__body_statement_repeat1,
    STATE(2314), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79845] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2315), 1,
      sym_heredoc_body,
    ACTIONS(1499), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79864] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3591), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2316), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79891] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3593), 1,
      anon_sym_end,
    STATE(2317), 1,
      sym_heredoc_body,
    STATE(2318), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79918] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3595), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2318), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79945] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_EQ_GT,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(153), 1,
      sym__terminator,
    STATE(2319), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_exception_variable,
    STATE(2607), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [79974] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2320), 1,
      sym_heredoc_body,
    ACTIONS(3597), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(1437), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79995] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1365), 1,
      sym__string_start,
    STATE(2321), 1,
      sym_heredoc_body,
    STATE(2333), 1,
      aux_sym_chained_string_repeat1,
    STATE(2500), 1,
      sym_string,
    ACTIONS(1633), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80020] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3593), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2322), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80047] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3599), 1,
      anon_sym_end,
    STATE(2323), 1,
      sym_heredoc_body,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2538), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2932), 1,
      sym_else,
  [80078] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COMMA,
    STATE(2324), 1,
      sym_heredoc_body,
    STATE(2355), 1,
      aux_sym_undef_repeat1,
    ACTIONS(3325), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80099] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2325), 1,
      sym_heredoc_body,
    ACTIONS(3278), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [80116] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2326), 1,
      sym_heredoc_body,
    ACTIONS(3276), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [80133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_EQ,
    STATE(2327), 1,
      sym_heredoc_body,
    ACTIONS(2578), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80152] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2328), 1,
      sym_heredoc_body,
    ACTIONS(3605), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3323), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80171] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2329), 1,
      sym_heredoc_body,
    ACTIONS(3605), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3294), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80190] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2330), 1,
      sym_heredoc_body,
    ACTIONS(3605), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3337), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80209] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2331), 1,
      sym_heredoc_body,
    ACTIONS(3605), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3327), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80228] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2332), 1,
      sym_heredoc_body,
    ACTIONS(3605), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3282), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80247] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3607), 1,
      sym__string_start,
    STATE(2500), 1,
      sym_string,
    STATE(2333), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1643), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80270] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2334), 1,
      sym_heredoc_body,
    ACTIONS(3270), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [80287] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_then,
    ACTIONS(3610), 1,
      anon_sym_COMMA,
    STATE(156), 1,
      sym__terminator,
    STATE(2335), 1,
      sym_heredoc_body,
    STATE(2502), 1,
      aux_sym_when_repeat1,
    STATE(2714), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [80316] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3612), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2336), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80343] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3614), 1,
      anon_sym_end,
    STATE(2337), 1,
      sym_heredoc_body,
    STATE(2514), 1,
      aux_sym_case_repeat1,
    STATE(2547), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2951), 1,
      sym_else,
  [80374] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3616), 1,
      aux_sym_string_array_token1,
    ACTIONS(3618), 1,
      sym__string_end,
    STATE(2293), 1,
      aux_sym__literal_contents,
    STATE(2338), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [80405] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3620), 1,
      anon_sym_end,
    STATE(2323), 1,
      aux_sym_case_repeat1,
    STATE(2339), 1,
      sym_heredoc_body,
    STATE(2549), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2936), 1,
      sym_else,
  [80436] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3622), 1,
      aux_sym_string_array_token1,
    ACTIONS(3624), 1,
      sym__string_end,
    STATE(2281), 1,
      aux_sym__literal_contents,
    STATE(2340), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [80467] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3626), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2341), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80494] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3626), 1,
      anon_sym_end,
    STATE(2316), 1,
      aux_sym__body_statement_repeat1,
    STATE(2342), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80521] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3628), 1,
      aux_sym_string_array_token1,
    ACTIONS(3630), 1,
      sym__string_end,
    STATE(2343), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2738), 1,
      aux_sym_symbol_array_repeat1,
  [80552] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3632), 1,
      aux_sym_string_array_token1,
    ACTIONS(3634), 1,
      sym__string_end,
    STATE(2344), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2736), 1,
      aux_sym_string_array_repeat1,
  [80583] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3636), 1,
      aux_sym_string_array_token1,
    ACTIONS(3638), 1,
      sym__string_end,
    STATE(2345), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
  [80614] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3640), 1,
      aux_sym_string_array_token1,
    ACTIONS(3642), 1,
      sym__string_end,
    STATE(2282), 1,
      aux_sym__literal_contents,
    STATE(2346), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [80645] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3644), 1,
      sym_identifier,
    ACTIONS(3648), 1,
      anon_sym_do,
    STATE(2347), 1,
      sym_heredoc_body,
    ACTIONS(3646), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [80668] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3650), 1,
      anon_sym_end,
    STATE(2348), 1,
      sym_heredoc_body,
    STATE(2354), 1,
      aux_sym__body_statement_repeat1,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80695] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3650), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2349), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80722] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3652), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3655), 1,
      aux_sym_string_array_token1,
    ACTIONS(3657), 1,
      sym_escape_sequence,
    ACTIONS(3660), 1,
      sym__string_content,
    ACTIONS(3663), 1,
      sym__string_end,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2350), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [80751] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3665), 1,
      aux_sym_string_array_token1,
    ACTIONS(3667), 1,
      sym__string_end,
    STATE(2265), 1,
      aux_sym__literal_contents,
    STATE(2351), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [80782] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3669), 1,
      aux_sym_string_array_token1,
    ACTIONS(3671), 1,
      sym__string_end,
    STATE(2261), 1,
      aux_sym__literal_contents,
    STATE(2352), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [80813] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3673), 1,
      aux_sym_string_array_token1,
    ACTIONS(3675), 1,
      sym__string_end,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2353), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [80844] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3677), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2354), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80871] = 4,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_COMMA,
    STATE(2355), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(3280), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80890] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COMMA,
    STATE(2324), 1,
      aux_sym_undef_repeat1,
    STATE(2356), 1,
      sym_heredoc_body,
    ACTIONS(3319), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80911] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3682), 1,
      anon_sym_end,
    STATE(2257), 1,
      aux_sym__body_statement_repeat1,
    STATE(2357), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80938] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3688), 1,
      anon_sym_do,
    STATE(2358), 1,
      sym_heredoc_body,
    ACTIONS(3686), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [80961] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_rescue,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_ensure,
    ACTIONS(3682), 1,
      anon_sym_end,
    STATE(2336), 1,
      aux_sym__body_statement_repeat1,
    STATE(2359), 1,
      sym_heredoc_body,
    STATE(2557), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80988] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2360), 1,
      sym_heredoc_body,
    ACTIONS(1495), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81007] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2361), 1,
      sym_heredoc_body,
    ACTIONS(1461), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81026] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2362), 1,
      sym_heredoc_body,
    ACTIONS(1461), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81045] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2363), 1,
      sym_heredoc_body,
    ACTIONS(1473), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81064] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3690), 1,
      anon_sym_end,
    STATE(2337), 1,
      aux_sym_case_repeat1,
    STATE(2364), 1,
      sym_heredoc_body,
    STATE(2548), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2953), 1,
      sym_else,
  [81095] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2365), 1,
      sym_heredoc_body,
    ACTIONS(1499), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81114] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2366), 1,
      sym_heredoc_body,
    ACTIONS(3272), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81131] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2367), 1,
      sym_heredoc_body,
    ACTIONS(111), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81150] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2368), 1,
      sym_heredoc_body,
    ACTIONS(1465), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81169] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2369), 1,
      sym_heredoc_body,
    ACTIONS(1449), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81188] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2370), 1,
      sym_heredoc_body,
    ACTIONS(1469), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81207] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2371), 1,
      sym_heredoc_body,
    ACTIONS(3266), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81224] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_then,
    ACTIONS(3610), 1,
      anon_sym_COMMA,
    STATE(155), 1,
      sym__terminator,
    STATE(2335), 1,
      aux_sym_when_repeat1,
    STATE(2372), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [81253] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2373), 1,
      sym_heredoc_body,
    ACTIONS(3268), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81270] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    ACTIONS(3692), 1,
      anon_sym_in,
    STATE(2374), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1437), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81295] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2375), 1,
      sym_heredoc_body,
    ACTIONS(3274), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81312] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3694), 1,
      aux_sym_string_array_token1,
    ACTIONS(3696), 1,
      sym__string_end,
    STATE(2309), 1,
      aux_sym__literal_contents,
    STATE(2376), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81343] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3698), 1,
      aux_sym_string_array_token1,
    ACTIONS(3700), 1,
      sym__string_end,
    STATE(2245), 1,
      aux_sym__literal_contents,
    STATE(2377), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81374] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3702), 1,
      aux_sym_string_array_token1,
    ACTIONS(3704), 1,
      sym__string_end,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2378), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2778), 1,
      aux_sym_symbol_array_repeat1,
  [81405] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3706), 1,
      aux_sym_string_array_token1,
    ACTIONS(3708), 1,
      sym__string_end,
    STATE(2272), 1,
      aux_sym__literal_contents,
    STATE(2379), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81436] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3710), 1,
      aux_sym_string_array_token1,
    ACTIONS(3712), 1,
      sym__string_end,
    STATE(2307), 1,
      aux_sym__literal_contents,
    STATE(2380), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81467] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3714), 1,
      aux_sym_string_array_token1,
    ACTIONS(3716), 1,
      sym__string_end,
    STATE(2310), 1,
      aux_sym__literal_contents,
    STATE(2381), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81498] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3718), 1,
      aux_sym_string_array_token1,
    ACTIONS(3720), 1,
      sym__string_end,
    STATE(2350), 1,
      aux_sym__literal_contents,
    STATE(2382), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2776), 1,
      aux_sym_string_array_repeat1,
  [81529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3722), 1,
      aux_sym_string_array_token1,
    ACTIONS(3724), 1,
      sym__string_end,
    STATE(2295), 1,
      aux_sym__literal_contents,
    STATE(2383), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81560] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1365), 1,
      sym__string_start,
    STATE(2321), 1,
      aux_sym_chained_string_repeat1,
    STATE(2384), 1,
      sym_heredoc_body,
    STATE(2500), 1,
      sym_string,
    ACTIONS(1437), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81585] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2385), 1,
      sym_heredoc_body,
    ACTIONS(3605), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3292), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81604] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3726), 1,
      aux_sym_string_array_token1,
    ACTIONS(3728), 1,
      sym__string_end,
    STATE(2269), 1,
      aux_sym__literal_contents,
    STATE(2386), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81635] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3734), 1,
      sym__string_end,
    STATE(2387), 1,
      sym_heredoc_body,
    STATE(2481), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [81661] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3736), 1,
      anon_sym_end,
    STATE(2388), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2862), 1,
      sym_else,
  [81689] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3738), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2389), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [81715] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3740), 1,
      sym__string_end,
    STATE(2390), 1,
      sym_heredoc_body,
    STATE(2421), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [81741] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2391), 1,
      sym_heredoc_body,
    ACTIONS(2620), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81757] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3742), 1,
      aux_sym_string_array_token1,
    ACTIONS(3744), 1,
      sym__string_end,
    STATE(2382), 1,
      aux_sym__literal_contents,
    STATE(2392), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81785] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2393), 1,
      sym_heredoc_body,
    ACTIONS(1551), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [81803] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3746), 1,
      aux_sym_string_array_token1,
    ACTIONS(3748), 1,
      sym__string_end,
    STATE(2378), 1,
      aux_sym__literal_contents,
    STATE(2394), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81831] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3555), 1,
      anon_sym_end,
    STATE(2395), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2849), 1,
      sym_else,
  [81859] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3750), 1,
      sym__string_end,
    STATE(2396), 1,
      sym_heredoc_body,
    STATE(2406), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [81885] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3752), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2397), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [81911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3754), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2398), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [81937] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3756), 1,
      aux_sym_string_array_token1,
    ACTIONS(3758), 1,
      sym__string_end,
    STATE(2344), 1,
      aux_sym__literal_contents,
    STATE(2399), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [81965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3760), 1,
      sym__string_end,
    STATE(2400), 1,
      sym_heredoc_body,
    STATE(2428), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [81991] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3472), 1,
      sym_escape_sequence,
    ACTIONS(3474), 1,
      sym__string_content,
    ACTIONS(3762), 1,
      aux_sym_string_array_token1,
    ACTIONS(3764), 1,
      sym__string_end,
    STATE(2343), 1,
      aux_sym__literal_contents,
    STATE(2401), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
  [82019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3766), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2402), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82045] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2403), 1,
      sym_heredoc_body,
    ACTIONS(3768), 6,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [82063] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3770), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2404), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82089] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3772), 1,
      sym__string_end,
    STATE(2405), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3774), 1,
      sym__string_end,
    STATE(2406), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82141] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3776), 1,
      sym__string_end,
    STATE(2405), 1,
      aux_sym__literal_contents,
    STATE(2407), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82167] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3778), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2408), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82193] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3587), 1,
      anon_sym_end,
    STATE(2409), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2911), 1,
      sym_else,
  [82221] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3780), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2410), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82247] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3782), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2411), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82273] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3784), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2412), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3786), 1,
      sym__string_end,
    STATE(2413), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82325] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3788), 1,
      anon_sym_end,
    STATE(2414), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2898), 1,
      sym_else,
  [82353] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3790), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2415), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82379] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2416), 1,
      sym_heredoc_body,
    ACTIONS(1770), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [82395] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3792), 1,
      sym__string_end,
    STATE(2417), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3794), 1,
      sym__string_end,
    STATE(2418), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82447] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2419), 1,
      sym_heredoc_body,
    ACTIONS(1694), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [82463] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2420), 1,
      sym_heredoc_body,
    ACTIONS(1840), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [82479] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3796), 1,
      sym__string_end,
    STATE(2421), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82505] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3798), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2422), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3800), 1,
      sym__string_end,
    STATE(2423), 1,
      sym_heredoc_body,
    STATE(2432), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82557] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3802), 1,
      sym__string_end,
    STATE(2424), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82583] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3533), 1,
      anon_sym_end,
    STATE(2425), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2832), 1,
      sym_else,
  [82611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3804), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2426), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82637] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_RBRACE,
    ACTIONS(3808), 1,
      anon_sym_if,
    ACTIONS(3810), 1,
      anon_sym_unless,
    ACTIONS(3812), 1,
      anon_sym_while,
    ACTIONS(3814), 1,
      anon_sym_until,
    ACTIONS(3816), 1,
      anon_sym_rescue,
    STATE(2427), 1,
      sym_heredoc_body,
  [82665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3818), 1,
      sym__string_end,
    STATE(2428), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82691] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3820), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2429), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82717] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3822), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2430), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [82743] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3824), 1,
      sym__string_end,
    STATE(2431), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82769] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3826), 1,
      sym__string_end,
    STATE(2432), 1,
      sym_heredoc_body,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82795] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2433), 1,
      sym_heredoc_body,
    ACTIONS(3828), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [82813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3830), 1,
      sym__string_end,
    STATE(2434), 1,
      sym_heredoc_body,
    STATE(2454), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3832), 1,
      sym__string_end,
    STATE(2431), 1,
      aux_sym__literal_contents,
    STATE(2435), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82865] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3834), 1,
      sym__string_end,
    STATE(2436), 1,
      sym_heredoc_body,
    STATE(2463), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82891] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3836), 1,
      sym__string_end,
    STATE(2424), 1,
      aux_sym__literal_contents,
    STATE(2437), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [82917] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2438), 1,
      sym_heredoc_body,
    ACTIONS(997), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [82933] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3838), 1,
      anon_sym_end,
    STATE(2439), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2883), 1,
      sym_else,
  [82961] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3663), 1,
      sym__string_end,
    ACTIONS(3840), 1,
      anon_sym_POUND_LBRACE,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3843), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2440), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [82985] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
    STATE(2441), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2050), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [83005] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3849), 1,
      sym__string_end,
    STATE(2442), 1,
      sym_heredoc_body,
    STATE(2487), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83031] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3808), 1,
      anon_sym_if,
    ACTIONS(3810), 1,
      anon_sym_unless,
    ACTIONS(3812), 1,
      anon_sym_while,
    ACTIONS(3814), 1,
      anon_sym_until,
    ACTIONS(3816), 1,
      anon_sym_rescue,
    ACTIONS(3851), 1,
      anon_sym_RBRACE,
    STATE(2443), 1,
      sym_heredoc_body,
  [83059] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3853), 1,
      anon_sym_end,
    STATE(2444), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2891), 1,
      sym_else,
  [83087] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3855), 1,
      sym__string_end,
    STATE(2413), 1,
      aux_sym__literal_contents,
    STATE(2445), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83113] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3857), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2446), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83139] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2447), 1,
      sym_heredoc_body,
    ACTIONS(3859), 6,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [83157] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3861), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2448), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3863), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2449), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83209] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2450), 1,
      sym_heredoc_body,
    ACTIONS(3865), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83227] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3867), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2451), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83253] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3869), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2452), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83279] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3871), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2453), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83305] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3873), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2454), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3875), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2455), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3877), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2456), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83383] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3879), 1,
      anon_sym_end,
    STATE(2457), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2854), 1,
      sym_else,
  [83411] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2458), 1,
      sym_heredoc_body,
    ACTIONS(3881), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83429] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3589), 1,
      anon_sym_end,
    STATE(2459), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2850), 1,
      sym_else,
  [83457] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2460), 1,
      sym_heredoc_body,
    ACTIONS(1559), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83475] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3883), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2461), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83501] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2462), 1,
      sym_heredoc_body,
    ACTIONS(3280), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [83517] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3885), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2463), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83543] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3887), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2464), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83569] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3889), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2465), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83595] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    STATE(2466), 1,
      sym_heredoc_body,
    STATE(2610), 1,
      sym_argument_list,
    ACTIONS(273), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [83617] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2467), 1,
      sym_heredoc_body,
    ACTIONS(3891), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83635] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    STATE(2468), 1,
      sym_heredoc_body,
    STATE(2608), 1,
      sym_argument_list,
    ACTIONS(303), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [83657] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2469), 1,
      sym_heredoc_body,
    ACTIONS(3893), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83675] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3895), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2470), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [83701] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    STATE(2471), 1,
      sym_heredoc_body,
    STATE(2606), 1,
      sym_argument_list,
    ACTIONS(299), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [83723] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2472), 1,
      sym_heredoc_body,
    ACTIONS(3897), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83741] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_COMMA,
    STATE(2441), 1,
      aux_sym_exceptions_repeat1,
    STATE(2473), 1,
      sym_heredoc_body,
    ACTIONS(3899), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [83763] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    STATE(2474), 1,
      sym_heredoc_body,
    STATE(2605), 1,
      sym_argument_list,
    ACTIONS(295), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [83785] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2475), 1,
      sym_heredoc_body,
    ACTIONS(3901), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83803] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2476), 1,
      sym_heredoc_body,
    ACTIONS(1563), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3903), 1,
      sym__string_end,
    STATE(2417), 1,
      aux_sym__literal_contents,
    STATE(2477), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83847] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3905), 1,
      sym__string_end,
    STATE(2418), 1,
      aux_sym__literal_contents,
    STATE(2478), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83873] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_COMMA,
    STATE(2473), 1,
      aux_sym_exceptions_repeat1,
    STATE(2479), 1,
      sym_heredoc_body,
    ACTIONS(2669), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [83895] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3907), 1,
      anon_sym_end,
    STATE(2480), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2855), 1,
      sym_else,
  [83923] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3909), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2481), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83949] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    STATE(2482), 1,
      sym_heredoc_body,
    STATE(2622), 1,
      sym_argument_list,
    ACTIONS(1662), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [83971] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3911), 1,
      sym__string_end,
    STATE(2464), 1,
      aux_sym__literal_contents,
    STATE(2483), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [83997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3913), 1,
      sym__string_end,
    STATE(2465), 1,
      aux_sym__literal_contents,
    STATE(2484), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84023] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3490), 1,
      anon_sym_end,
    STATE(2485), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2787), 1,
      sym_else,
  [84051] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN2,
    STATE(2486), 1,
      sym_heredoc_body,
    STATE(2623), 1,
      sym_argument_list,
    ACTIONS(1672), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84073] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3915), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2487), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84099] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3488), 1,
      anon_sym_end,
    STATE(2488), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2731), 1,
      sym_when,
    STATE(2912), 1,
      sym_else,
  [84127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3917), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2489), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [84150] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3919), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2490), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_interpolation,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [84173] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3921), 1,
      sym__string_end,
    STATE(2491), 1,
      sym_heredoc_body,
    STATE(2493), 1,
      aux_sym__literal_contents,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2492), 1,
      sym_heredoc_body,
    ACTIONS(3925), 2,
      sym__string_content,
      sym__string_end,
    ACTIONS(3923), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
  [84215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3927), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2493), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84238] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3929), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2494), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3931), 1,
      sym__string_end,
    STATE(2494), 1,
      aux_sym__literal_contents,
    STATE(2495), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84284] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3933), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2496), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3935), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2497), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3937), 1,
      sym__string_end,
    STATE(2496), 1,
      aux_sym__literal_contents,
    STATE(2498), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84353] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2499), 1,
      sym_heredoc_body,
    ACTIONS(1658), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84370] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2500), 1,
      sym_heredoc_body,
    ACTIONS(1680), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84387] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3939), 1,
      anon_sym_end,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    STATE(2501), 1,
      sym_heredoc_body,
    STATE(2918), 2,
      sym_elsif,
      sym_else,
  [84410] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_COMMA,
    STATE(2502), 2,
      sym_heredoc_body,
      aux_sym_when_repeat1,
    ACTIONS(3946), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [84429] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2503), 1,
      sym_heredoc_body,
    ACTIONS(2050), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [84446] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3948), 1,
      anon_sym_COLON,
    ACTIONS(3950), 1,
      anon_sym_EQ,
    STATE(2504), 1,
      sym_heredoc_body,
    ACTIONS(3828), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84467] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3952), 1,
      sym__string_end,
    STATE(2440), 1,
      aux_sym__literal_contents,
    STATE(2505), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3954), 1,
      sym__string_end,
    STATE(2505), 1,
      aux_sym__literal_contents,
    STATE(2506), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [84513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2507), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [84536] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2508), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [84559] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1539), 1,
      anon_sym_COMMA,
    STATE(2509), 1,
      sym_heredoc_body,
    STATE(2545), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3692), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [84580] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(152), 1,
      sym__terminator,
    STATE(2510), 1,
      sym_heredoc_body,
    STATE(2625), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [84603] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3956), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3960), 1,
      sym_heredoc_end,
    STATE(2511), 1,
      sym_heredoc_body,
    ACTIONS(3958), 2,
      sym__heredoc_content,
      sym_escape_sequence,
    STATE(2525), 2,
      sym_interpolation,
      aux_sym_heredoc_body_repeat1,
  [84624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3962), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2512), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [84647] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3966), 1,
      anon_sym_when,
    STATE(2731), 1,
      sym_when,
    ACTIONS(3964), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(2513), 2,
      sym_heredoc_body,
      aux_sym_case_repeat2,
  [84668] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3969), 1,
      anon_sym_SEMI,
    STATE(2514), 2,
      sym_heredoc_body,
      aux_sym_case_repeat1,
    ACTIONS(3972), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [84687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3974), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2515), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [84710] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2516), 1,
      sym_heredoc_body,
    ACTIONS(3296), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [84725] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2517), 1,
      sym_heredoc_body,
    ACTIONS(3335), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [84740] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_do,
    STATE(189), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(2518), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [84763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3976), 1,
      anon_sym_COMMA,
    STATE(2519), 2,
      sym_heredoc_body,
      aux_sym__mlhs_repeat1,
    ACTIONS(3523), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [84782] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(3979), 1,
      anon_sym_end,
    STATE(2520), 1,
      sym_heredoc_body,
    STATE(2876), 2,
      sym_elsif,
      sym_else,
  [84805] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(3981), 1,
      anon_sym_end,
    STATE(2521), 1,
      sym_heredoc_body,
    STATE(2788), 2,
      sym_elsif,
      sym_else,
  [84828] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3956), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3985), 1,
      sym_heredoc_end,
    STATE(2522), 1,
      sym_heredoc_body,
    ACTIONS(3983), 2,
      sym__heredoc_content,
      sym_escape_sequence,
    STATE(2511), 2,
      sym_interpolation,
      aux_sym_heredoc_body_repeat1,
  [84849] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2523), 1,
      sym_heredoc_body,
    ACTIONS(3286), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [84864] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3808), 1,
      anon_sym_if,
    ACTIONS(3810), 1,
      anon_sym_unless,
    ACTIONS(3812), 1,
      anon_sym_while,
    ACTIONS(3814), 1,
      anon_sym_until,
    ACTIONS(3816), 1,
      anon_sym_rescue,
    ACTIONS(3987), 1,
      anon_sym_RBRACE,
    STATE(2524), 1,
      sym_heredoc_body,
  [84889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3995), 1,
      sym_heredoc_end,
    ACTIONS(3992), 2,
      sym__heredoc_content,
      sym_escape_sequence,
    STATE(2525), 3,
      sym_interpolation,
      sym_heredoc_body,
      aux_sym_heredoc_body_repeat1,
  [84908] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(3997), 1,
      anon_sym_end,
    STATE(2526), 1,
      sym_heredoc_body,
    STATE(2900), 2,
      sym_elsif,
      sym_else,
  [84931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3999), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2527), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [84954] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(4001), 1,
      anon_sym_end,
    STATE(2528), 1,
      sym_heredoc_body,
    STATE(2796), 2,
      sym_elsif,
      sym_else,
  [84977] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2529), 1,
      sym_heredoc_body,
    ACTIONS(1668), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84994] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_r,
    STATE(2530), 1,
      sym_heredoc_body,
    ACTIONS(1437), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85013] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_do,
    STATE(175), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(2531), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [85036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4005), 1,
      anon_sym_COLON,
    ACTIONS(4007), 1,
      anon_sym_EQ,
    STATE(2532), 1,
      sym_heredoc_body,
    ACTIONS(3828), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [85057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2533), 1,
      sym_heredoc_body,
    ACTIONS(4011), 2,
      sym__string_content,
      sym__string_end,
    ACTIONS(4009), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
  [85076] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4013), 1,
      sym__string_end,
    STATE(2497), 1,
      aux_sym__literal_contents,
    STATE(2534), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_interpolation,
    ACTIONS(3732), 2,
      sym__string_content,
      sym_escape_sequence,
  [85099] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(4015), 1,
      anon_sym_end,
    STATE(2535), 1,
      sym_heredoc_body,
    STATE(2795), 2,
      sym_elsif,
      sym_else,
  [85122] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_do,
    STATE(178), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(2536), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [85145] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2537), 1,
      sym_heredoc_body,
    ACTIONS(3290), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [85160] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(4017), 1,
      anon_sym_end,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2538), 1,
      sym_heredoc_body,
    STATE(2731), 1,
      sym_when,
    STATE(2929), 1,
      sym_else,
  [85185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4019), 1,
      anon_sym_COLON,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    STATE(2539), 1,
      sym_heredoc_body,
    ACTIONS(3828), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
  [85206] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2540), 1,
      sym_heredoc_body,
    ACTIONS(3288), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [85221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4023), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2541), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [85244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4025), 1,
      sym__string_end,
    STATE(2353), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2542), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [85267] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4027), 1,
      sym__string_end,
    STATE(2345), 1,
      aux_sym__literal_contents,
    STATE(2492), 1,
      sym_interpolation,
    STATE(2543), 1,
      sym_heredoc_body,
    ACTIONS(3474), 2,
      sym__string_content,
      sym_escape_sequence,
  [85290] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_then,
    STATE(151), 1,
      sym__terminator,
    STATE(2544), 1,
      sym_heredoc_body,
    STATE(2612), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [85313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4029), 1,
      anon_sym_COMMA,
    STATE(2519), 1,
      aux_sym__mlhs_repeat1,
    STATE(2545), 1,
      sym_heredoc_body,
    ACTIONS(1379), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [85334] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(4031), 1,
      anon_sym_end,
    STATE(2546), 1,
      sym_heredoc_body,
    STATE(2901), 2,
      sym_elsif,
      sym_else,
  [85357] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(4033), 1,
      anon_sym_end,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2547), 1,
      sym_heredoc_body,
    STATE(2731), 1,
      sym_when,
    STATE(2947), 1,
      sym_else,
  [85382] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3614), 1,
      anon_sym_end,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2548), 1,
      sym_heredoc_body,
    STATE(2731), 1,
      sym_when,
    STATE(2951), 1,
      sym_else,
  [85407] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3482), 1,
      anon_sym_when,
    ACTIONS(3599), 1,
      anon_sym_end,
    STATE(2513), 1,
      aux_sym_case_repeat2,
    STATE(2549), 1,
      sym_heredoc_body,
    STATE(2731), 1,
      sym_when,
    STATE(2932), 1,
      sym_else,
  [85432] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2550), 1,
      sym_heredoc_body,
    ACTIONS(1437), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85448] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2551), 1,
      sym_heredoc_body,
    ACTIONS(1944), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85464] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2552), 1,
      sym_heredoc_body,
    ACTIONS(1786), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85480] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2553), 1,
      sym_heredoc_body,
    ACTIONS(1782), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85496] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2554), 1,
      sym_heredoc_body,
    ACTIONS(1778), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85512] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2555), 1,
      sym_heredoc_body,
    ACTIONS(1774), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85528] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2556), 1,
      sym_heredoc_body,
    ACTIONS(1447), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [85544] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2557), 1,
      sym_heredoc_body,
    ACTIONS(4035), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85560] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4039), 1,
      anon_sym_LBRACK,
    ACTIONS(4041), 1,
      anon_sym_COLON_COLON2,
    STATE(2558), 1,
      sym_heredoc_body,
    ACTIONS(4037), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [85580] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4045), 1,
      anon_sym_COMMA,
    STATE(2559), 1,
      sym_heredoc_body,
    STATE(2579), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(4043), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [85600] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(4047), 1,
      anon_sym_do,
    STATE(2560), 1,
      sym_heredoc_body,
    STATE(1141), 2,
      sym_do_block,
      sym_block,
  [85620] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4049), 1,
      anon_sym_COMMA,
    ACTIONS(3881), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2561), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [85638] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COMMA,
    STATE(2562), 1,
      sym_heredoc_body,
    STATE(2581), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4052), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [85658] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2563), 1,
      sym_heredoc_body,
    ACTIONS(1908), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85674] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2564), 1,
      sym_heredoc_body,
    ACTIONS(1766), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85690] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2565), 1,
      sym_heredoc_body,
    ACTIONS(1684), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85706] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2566), 1,
      sym_heredoc_body,
    ACTIONS(1968), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85722] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_COMMA,
    ACTIONS(3254), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2567), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
  [85740] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2568), 1,
      sym_heredoc_body,
    ACTIONS(4059), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [85756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4009), 1,
      anon_sym_POUND_LBRACE,
    STATE(2569), 1,
      sym_heredoc_body,
    ACTIONS(4011), 3,
      sym__string_content,
      sym__string_end,
      sym_escape_sequence,
  [85774] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2570), 1,
      sym_heredoc_body,
    ACTIONS(1698), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85790] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2571), 1,
      sym_heredoc_body,
    ACTIONS(1746), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85806] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2572), 1,
      sym_heredoc_body,
    ACTIONS(4061), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85822] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2573), 1,
      sym_heredoc_body,
    ACTIONS(1832), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85838] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4063), 1,
      anon_sym_COMMA,
    STATE(2561), 1,
      aux_sym_parameters_repeat1,
    STATE(2574), 1,
      sym_heredoc_body,
    ACTIONS(4065), 2,
      sym__line_break,
      anon_sym_SEMI,
  [85858] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2575), 1,
      sym_heredoc_body,
    ACTIONS(1872), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85874] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2576), 1,
      sym_heredoc_body,
    ACTIONS(4067), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85890] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2577), 1,
      sym_heredoc_body,
    ACTIONS(4069), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85906] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2578), 1,
      sym_heredoc_body,
    ACTIONS(1706), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85922] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4071), 1,
      anon_sym_COMMA,
    STATE(2567), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2579), 1,
      sym_heredoc_body,
    ACTIONS(949), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [85942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2580), 1,
      sym_heredoc_body,
    ACTIONS(4073), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [85958] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COMMA,
    STATE(2581), 1,
      sym_heredoc_body,
    STATE(2619), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4065), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [85978] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2582), 1,
      sym_heredoc_body,
    ACTIONS(1714), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85994] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2583), 1,
      sym_heredoc_body,
    ACTIONS(1900), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86010] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    ACTIONS(3881), 2,
      anon_sym_PIPE,
      anon_sym_SEMI,
    STATE(2584), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [86028] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2585), 1,
      sym_heredoc_body,
    ACTIONS(1884), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2586), 1,
      sym_heredoc_body,
    ACTIONS(3523), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [86060] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2587), 1,
      sym_heredoc_body,
    ACTIONS(1916), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86076] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_do,
    STATE(202), 1,
      sym__do,
    STATE(971), 1,
      sym__terminator,
    STATE(2588), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [86096] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(4078), 1,
      anon_sym_end,
    STATE(2589), 1,
      sym_heredoc_body,
    STATE(2966), 2,
      sym_elsif,
      sym_else,
  [86116] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_else,
    ACTIONS(3941), 1,
      anon_sym_elsif,
    ACTIONS(4080), 1,
      anon_sym_end,
    STATE(2590), 1,
      sym_heredoc_body,
    STATE(2934), 2,
      sym_elsif,
      sym_else,
  [86136] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2591), 1,
      sym_heredoc_body,
    ACTIONS(1920), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86152] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2592), 1,
      sym_heredoc_body,
    ACTIONS(1485), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86168] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2593), 1,
      sym_heredoc_body,
    ACTIONS(1928), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86184] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_LBRACK,
    ACTIONS(4086), 1,
      anon_sym_COLON_COLON2,
    STATE(2594), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [86204] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2595), 1,
      sym_heredoc_body,
    ACTIONS(1932), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86220] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_PIPE,
    ACTIONS(3377), 1,
      anon_sym_SEMI,
    ACTIONS(4088), 1,
      anon_sym_COMMA,
    STATE(2584), 1,
      aux_sym_parameters_repeat1,
    STATE(2596), 1,
      sym_heredoc_body,
  [86242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3923), 1,
      anon_sym_POUND_LBRACE,
    STATE(2597), 1,
      sym_heredoc_body,
    ACTIONS(3925), 3,
      sym__string_content,
      sym__string_end,
      sym_escape_sequence,
  [86260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4090), 1,
      anon_sym_COLON,
    ACTIONS(4092), 1,
      anon_sym_EQ,
    STATE(2598), 1,
      sym_heredoc_body,
    ACTIONS(3828), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [86280] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2599), 1,
      sym_heredoc_body,
    ACTIONS(2946), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [86296] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2600), 1,
      sym_heredoc_body,
    ACTIONS(1820), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86312] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4041), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4084), 1,
      anon_sym_LBRACK,
    STATE(2601), 1,
      sym_heredoc_body,
    ACTIONS(4082), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [86332] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2602), 1,
      sym_heredoc_body,
    ACTIONS(1824), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86348] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2603), 1,
      sym_heredoc_body,
    ACTIONS(1936), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86364] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2604), 1,
      sym_heredoc_body,
    ACTIONS(1940), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86380] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2605), 1,
      sym_heredoc_body,
    ACTIONS(1844), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86396] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2606), 1,
      sym_heredoc_body,
    ACTIONS(1848), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86412] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2607), 1,
      sym_heredoc_body,
    ACTIONS(4094), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [86428] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2608), 1,
      sym_heredoc_body,
    ACTIONS(1852), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86444] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_COMMA,
    ACTIONS(4098), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_SEMI,
    STATE(2596), 1,
      aux_sym_parameters_repeat1,
    STATE(2609), 1,
      sym_heredoc_body,
  [86466] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2610), 1,
      sym_heredoc_body,
    ACTIONS(1856), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86482] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2611), 1,
      sym_heredoc_body,
    ACTIONS(1948), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86498] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2612), 1,
      sym_heredoc_body,
    ACTIONS(4102), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [86514] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2613), 1,
      sym_heredoc_body,
    ACTIONS(4104), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [86530] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2614), 1,
      sym_heredoc_body,
    ACTIONS(1980), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86546] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2615), 1,
      sym_heredoc_body,
    ACTIONS(1992), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86562] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2616), 1,
      sym_heredoc_body,
    ACTIONS(2000), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86578] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2617), 1,
      sym_heredoc_body,
    ACTIONS(2004), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86594] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4106), 1,
      anon_sym_COMMA,
    ACTIONS(4108), 1,
      anon_sym_PIPE,
    ACTIONS(4110), 1,
      anon_sym_SEMI,
    STATE(2618), 1,
      sym_heredoc_body,
    STATE(2629), 1,
      aux_sym_parameters_repeat1,
  [86616] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_COMMA,
    ACTIONS(3881), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    STATE(2619), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [86634] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4063), 1,
      anon_sym_COMMA,
    STATE(2574), 1,
      aux_sym_parameters_repeat1,
    STATE(2620), 1,
      sym_heredoc_body,
    ACTIONS(4052), 2,
      sym__line_break,
      anon_sym_SEMI,
  [86654] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LBRACE,
    ACTIONS(4115), 1,
      anon_sym_do,
    STATE(2621), 1,
      sym_heredoc_body,
    STATE(1461), 2,
      sym_do_block,
      sym_block,
  [86674] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2622), 1,
      sym_heredoc_body,
    ACTIONS(1860), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86690] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2623), 1,
      sym_heredoc_body,
    ACTIONS(1864), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86706] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2624), 1,
      sym_heredoc_body,
    ACTIONS(2008), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86722] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2625), 1,
      sym_heredoc_body,
    ACTIONS(4117), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [86738] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2626), 1,
      sym_heredoc_body,
    ACTIONS(1956), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86754] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    STATE(2627), 1,
      sym_heredoc_body,
    ACTIONS(3646), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86772] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2628), 1,
      sym_heredoc_body,
    ACTIONS(1984), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86788] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3395), 1,
      anon_sym_PIPE,
    ACTIONS(3397), 1,
      anon_sym_SEMI,
    ACTIONS(4121), 1,
      anon_sym_COMMA,
    STATE(2584), 1,
      aux_sym_parameters_repeat1,
    STATE(2629), 1,
      sym_heredoc_body,
  [86810] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4123), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_heredoc_body,
    ACTIONS(3686), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86828] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2631), 1,
      sym_heredoc_body,
    ACTIONS(3946), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [86844] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2632), 1,
      sym_heredoc_body,
    ACTIONS(1996), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86860] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2633), 1,
      sym_heredoc_body,
    ACTIONS(1828), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86876] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2634), 1,
      sym_heredoc_body,
    ACTIONS(1964), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86892] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2635), 1,
      sym_heredoc_body,
    ACTIONS(1960), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86908] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2636), 1,
      sym_heredoc_body,
    ACTIONS(1988), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86924] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2637), 1,
      sym_heredoc_body,
    ACTIONS(1952), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86940] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2638), 1,
      sym_heredoc_body,
    ACTIONS(1912), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86956] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2639), 1,
      sym_heredoc_body,
    ACTIONS(1896), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86972] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_do,
    STATE(2640), 1,
      sym_heredoc_body,
    STATE(2633), 2,
      sym_do_block,
      sym_block,
  [86992] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2641), 1,
      sym_heredoc_body,
    ACTIONS(1892), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87008] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2642), 1,
      sym_heredoc_body,
    ACTIONS(1888), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87024] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2643), 1,
      sym_heredoc_body,
    ACTIONS(1690), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87040] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2644), 1,
      sym_heredoc_body,
    ACTIONS(1976), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87056] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2645), 1,
      sym_heredoc_body,
    ACTIONS(1880), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87072] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2646), 1,
      sym_heredoc_body,
    ACTIONS(1876), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87088] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2647), 1,
      sym_heredoc_body,
    ACTIONS(1836), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87104] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2648), 1,
      sym_heredoc_body,
    ACTIONS(1798), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87120] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2649), 1,
      sym_heredoc_body,
    ACTIONS(1790), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87136] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2650), 1,
      sym_heredoc_body,
    ACTIONS(1762), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87152] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2651), 1,
      sym_heredoc_body,
    ACTIONS(1758), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87168] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2652), 1,
      sym_heredoc_body,
    ACTIONS(1904), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87184] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2653), 1,
      sym_heredoc_body,
    ACTIONS(1868), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87200] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2654), 1,
      sym_heredoc_body,
    ACTIONS(1816), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87216] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2655), 1,
      sym_heredoc_body,
    ACTIONS(1770), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87232] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2656), 1,
      sym_heredoc_body,
    ACTIONS(1750), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87248] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2657), 1,
      sym_heredoc_body,
    ACTIONS(1794), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87264] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2658), 1,
      sym_heredoc_body,
    ACTIONS(1718), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87280] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2659), 1,
      sym_heredoc_body,
    ACTIONS(1840), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87296] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2660), 1,
      sym_heredoc_body,
    ACTIONS(1742), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87312] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2661), 1,
      sym_heredoc_body,
    ACTIONS(1738), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87328] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2662), 1,
      sym_heredoc_body,
    ACTIONS(1754), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87344] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2663), 1,
      sym_heredoc_body,
    ACTIONS(1734), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87360] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2664), 1,
      sym_heredoc_body,
    ACTIONS(1730), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87376] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2665), 1,
      sym_heredoc_body,
    ACTIONS(1726), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87392] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2666), 1,
      sym_heredoc_body,
    ACTIONS(1722), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87408] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2667), 1,
      sym_heredoc_body,
    ACTIONS(1694), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87424] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1081), 1,
      anon_sym_RBRACE,
    ACTIONS(4125), 1,
      anon_sym_COMMA,
    STATE(2668), 1,
      sym_heredoc_body,
    STATE(2671), 1,
      aux_sym_hash_repeat1,
  [87443] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(106), 1,
      sym__terminator,
    STATE(2669), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [87460] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3766), 1,
      sym__string_end,
    ACTIONS(4127), 1,
      aux_sym_string_array_token1,
    STATE(2670), 1,
      sym_heredoc_body,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
  [87479] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_RBRACE,
    ACTIONS(4131), 1,
      anon_sym_COMMA,
    STATE(2671), 2,
      sym_heredoc_body,
      aux_sym_hash_repeat1,
  [87496] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3881), 1,
      anon_sym_RPAREN,
    ACTIONS(4134), 1,
      anon_sym_COMMA,
    STATE(2672), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [87513] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3371), 1,
      anon_sym_PIPE,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    STATE(2673), 1,
      sym_heredoc_body,
    STATE(2706), 1,
      aux_sym_block_parameters_repeat1,
  [87532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4139), 1,
      aux_sym_string_array_token1,
    ACTIONS(4142), 1,
      sym__string_end,
    STATE(2674), 2,
      sym_heredoc_body,
      aux_sym_symbol_array_repeat1,
  [87549] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2675), 1,
      sym_heredoc_body,
    ACTIONS(1551), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87564] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4144), 1,
      anon_sym_RPAREN,
    ACTIONS(4146), 1,
      anon_sym_COMMA,
    STATE(2676), 1,
      sym_heredoc_body,
    STATE(2700), 1,
      aux_sym_parameters_repeat1,
  [87583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3798), 1,
      sym__string_end,
    ACTIONS(4148), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2677), 1,
      sym_heredoc_body,
  [87602] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_COMMA,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
    STATE(2678), 1,
      sym_heredoc_body,
    STATE(2707), 1,
      aux_sym_parameters_repeat1,
  [87621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4152), 1,
      aux_sym_string_array_token1,
    ACTIONS(4155), 1,
      sym__string_end,
    STATE(2679), 2,
      sym_heredoc_body,
      aux_sym_string_array_repeat1,
  [87638] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2680), 1,
      sym_heredoc_body,
    ACTIONS(2131), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [87653] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4157), 1,
      anon_sym_PIPE,
    STATE(2681), 1,
      sym_heredoc_body,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
  [87672] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4159), 1,
      anon_sym_PIPE,
    STATE(2681), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2682), 1,
      sym_heredoc_body,
  [87691] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4159), 1,
      anon_sym_PIPE,
    STATE(2683), 1,
      sym_heredoc_body,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
  [87710] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4161), 1,
      anon_sym_PIPE,
    STATE(2683), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2684), 1,
      sym_heredoc_body,
  [87729] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4161), 1,
      anon_sym_PIPE,
    STATE(2685), 1,
      sym_heredoc_body,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
  [87748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3820), 1,
      sym__string_end,
    ACTIONS(4163), 1,
      aux_sym_string_array_token1,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
    STATE(2686), 1,
      sym_heredoc_body,
  [87767] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_PIPE,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    STATE(2685), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2687), 1,
      sym_heredoc_body,
  [87786] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4165), 1,
      anon_sym_RBRACE,
    ACTIONS(4167), 1,
      anon_sym_COMMA,
    STATE(2688), 1,
      sym_heredoc_body,
    STATE(2725), 1,
      aux_sym_hash_repeat1,
  [87805] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_PIPE,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    STATE(2689), 1,
      sym_heredoc_body,
    STATE(2730), 1,
      aux_sym_block_parameters_repeat1,
  [87824] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3363), 1,
      anon_sym_LBRACE,
    ACTIONS(4169), 1,
      anon_sym_do,
    STATE(2690), 1,
      sym_heredoc_body,
    STATE(1525), 2,
      sym_do_block,
      sym_block,
  [87841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_POUND_LBRACE,
    STATE(2691), 1,
      sym_heredoc_body,
    ACTIONS(4011), 3,
      sym__heredoc_content,
      sym_heredoc_end,
      sym_escape_sequence,
  [87856] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2692), 1,
      sym_heredoc_body,
    ACTIONS(3828), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87871] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4171), 1,
      anon_sym_PIPE,
    STATE(2693), 1,
      sym_heredoc_body,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
  [87890] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2694), 1,
      sym_heredoc_body,
    ACTIONS(1559), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87905] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4173), 1,
      anon_sym_PIPE,
    STATE(2693), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2695), 1,
      sym_heredoc_body,
  [87924] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4173), 1,
      anon_sym_PIPE,
    STATE(2696), 1,
      sym_heredoc_body,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
  [87943] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(114), 1,
      sym__terminator,
    STATE(2697), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [87960] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4175), 1,
      anon_sym_PIPE,
    STATE(2696), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2698), 1,
      sym_heredoc_body,
  [87979] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(101), 1,
      sym__terminator,
    STATE(2699), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [87996] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_COMMA,
    ACTIONS(4177), 1,
      anon_sym_RPAREN,
    STATE(2672), 1,
      aux_sym_parameters_repeat1,
    STATE(2700), 1,
      sym_heredoc_body,
  [88015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3861), 1,
      sym__string_end,
    ACTIONS(4179), 1,
      aux_sym_string_array_token1,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
    STATE(2701), 1,
      sym_heredoc_body,
  [88034] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_COMMA,
    ACTIONS(4181), 1,
      anon_sym_RPAREN,
    STATE(2672), 1,
      aux_sym_parameters_repeat1,
    STATE(2702), 1,
      sym_heredoc_body,
  [88053] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_COMMA,
    ACTIONS(4186), 1,
      anon_sym_PIPE,
    STATE(2703), 2,
      sym_heredoc_body,
      aux_sym_block_parameters_repeat1,
  [88070] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1083), 1,
      anon_sym_RBRACE,
    ACTIONS(4188), 1,
      anon_sym_COMMA,
    STATE(2671), 1,
      aux_sym_hash_repeat1,
    STATE(2704), 1,
      sym_heredoc_body,
  [88089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3883), 1,
      sym__string_end,
    ACTIONS(4190), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2705), 1,
      sym_heredoc_body,
  [88108] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4175), 1,
      anon_sym_PIPE,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2706), 1,
      sym_heredoc_body,
  [88127] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_COMMA,
    ACTIONS(4192), 1,
      anon_sym_RPAREN,
    STATE(2672), 1,
      aux_sym_parameters_repeat1,
    STATE(2707), 1,
      sym_heredoc_body,
  [88146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3895), 1,
      sym__string_end,
    ACTIONS(4194), 1,
      aux_sym_string_array_token1,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
    STATE(2708), 1,
      sym_heredoc_body,
  [88165] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3371), 1,
      anon_sym_PIPE,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2709), 1,
      sym_heredoc_body,
  [88184] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4196), 1,
      anon_sym_RBRACE,
    ACTIONS(4198), 1,
      anon_sym_COMMA,
    STATE(2668), 1,
      aux_sym_hash_repeat1,
    STATE(2710), 1,
      sym_heredoc_body,
  [88203] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3863), 1,
      sym__string_end,
    ACTIONS(4200), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2711), 1,
      sym_heredoc_body,
  [88222] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2712), 1,
      sym_heredoc_body,
    ACTIONS(3901), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88237] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2713), 1,
      sym_heredoc_body,
    ACTIONS(3897), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88252] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2714), 1,
      sym_heredoc_body,
    ACTIONS(4202), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [88267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3871), 1,
      sym__string_end,
    ACTIONS(4204), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2715), 1,
      sym_heredoc_body,
  [88286] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2716), 1,
      sym_heredoc_body,
    ACTIONS(3881), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88301] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(96), 1,
      sym__terminator,
    STATE(2717), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88318] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4206), 1,
      anon_sym_RBRACE,
    ACTIONS(4208), 1,
      anon_sym_COMMA,
    STATE(2704), 1,
      aux_sym_hash_repeat1,
    STATE(2718), 1,
      sym_heredoc_body,
  [88337] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3770), 1,
      sym__string_end,
    ACTIONS(4210), 1,
      aux_sym_string_array_token1,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
    STATE(2719), 1,
      sym_heredoc_body,
  [88356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3752), 1,
      sym__string_end,
    ACTIONS(4212), 1,
      aux_sym_string_array_token1,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
    STATE(2720), 1,
      sym_heredoc_body,
  [88375] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_COMMA,
    ACTIONS(4214), 1,
      anon_sym_RPAREN,
    STATE(2702), 1,
      aux_sym_parameters_repeat1,
    STATE(2721), 1,
      sym_heredoc_body,
  [88394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3790), 1,
      sym__string_end,
    ACTIONS(4216), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2722), 1,
      sym_heredoc_body,
  [88413] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3395), 1,
      anon_sym_PIPE,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    STATE(2709), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2723), 1,
      sym_heredoc_body,
  [88432] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2724), 1,
      sym_heredoc_body,
    ACTIONS(3893), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88447] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_RBRACE,
    ACTIONS(4218), 1,
      anon_sym_COMMA,
    STATE(2671), 1,
      aux_sym_hash_repeat1,
    STATE(2725), 1,
      sym_heredoc_body,
  [88466] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3784), 1,
      sym__string_end,
    ACTIONS(4220), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2726), 1,
      sym_heredoc_body,
  [88485] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(104), 1,
      sym__terminator,
    STATE(2727), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88502] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2728), 1,
      sym_heredoc_body,
    ACTIONS(3254), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [88517] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2729), 1,
      sym_heredoc_body,
    ACTIONS(3891), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88532] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_PIPE,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    STATE(2703), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2730), 1,
      sym_heredoc_body,
  [88551] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2731), 1,
      sym_heredoc_body,
    ACTIONS(4222), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [88566] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(109), 1,
      sym__terminator,
    STATE(2732), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88583] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2733), 1,
      sym_heredoc_body,
    ACTIONS(4224), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [88598] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2734), 1,
      sym_heredoc_body,
    ACTIONS(1563), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88613] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2735), 1,
      sym_heredoc_body,
    ACTIONS(3865), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3999), 1,
      sym__string_end,
    ACTIONS(4226), 1,
      aux_sym_string_array_token1,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
    STATE(2736), 1,
      sym_heredoc_body,
  [88644] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2737), 1,
      sym_heredoc_body,
    ACTIONS(4228), 2,
      sym_constant,
      sym_identifier,
  [88658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      sym__string_end,
    ACTIONS(4230), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2738), 1,
      sym_heredoc_body,
  [88674] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2739), 1,
      sym_heredoc_body,
    ACTIONS(4232), 2,
      sym_constant,
      sym_identifier,
  [88688] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2740), 1,
      sym_heredoc_body,
    ACTIONS(4234), 2,
      sym_constant,
      sym_identifier,
  [88702] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2741), 1,
      sym_heredoc_body,
    ACTIONS(4236), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [88716] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2742), 1,
      sym_heredoc_body,
    ACTIONS(4238), 2,
      sym_constant,
      sym_identifier,
  [88730] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2743), 1,
      sym_heredoc_body,
    ACTIONS(4240), 2,
      sym_constant,
      sym_identifier,
  [88744] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2744), 1,
      sym_heredoc_body,
    ACTIONS(4242), 2,
      sym_constant,
      sym_identifier,
  [88758] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2745), 1,
      sym_heredoc_body,
    ACTIONS(4244), 2,
      sym_constant,
      sym_identifier,
  [88772] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2746), 1,
      sym_heredoc_body,
    ACTIONS(4246), 2,
      sym_constant,
      sym_identifier,
  [88786] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2747), 1,
      sym_heredoc_body,
    ACTIONS(4248), 2,
      sym_constant,
      sym_identifier,
  [88800] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_in,
    STATE(2536), 1,
      sym_in,
    STATE(2748), 1,
      sym_heredoc_body,
  [88816] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4098), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_SEMI,
    STATE(2749), 1,
      sym_heredoc_body,
  [88832] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2750), 1,
      sym_heredoc_body,
    ACTIONS(4252), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [88846] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2751), 1,
      sym_heredoc_body,
    ACTIONS(4186), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [88860] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2752), 1,
      sym_heredoc_body,
    ACTIONS(4254), 2,
      sym_constant,
      sym_identifier,
  [88874] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2753), 1,
      sym_heredoc_body,
    ACTIONS(4256), 2,
      sym_constant,
      sym_identifier,
  [88888] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(126), 1,
      sym__terminator,
    STATE(2754), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88902] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    STATE(2566), 1,
      sym_parenthesized_statements,
    STATE(2755), 1,
      sym_heredoc_body,
  [88918] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2756), 1,
      sym_heredoc_body,
    ACTIONS(4258), 2,
      sym_integer,
      sym_float,
  [88932] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2757), 1,
      sym_heredoc_body,
    ACTIONS(4260), 2,
      sym_constant,
      sym_identifier,
  [88946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4262), 1,
      anon_sym_RPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2758), 1,
      sym_heredoc_body,
  [88962] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2759), 1,
      sym_heredoc_body,
    ACTIONS(4266), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [88976] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(124), 1,
      sym__terminator,
    STATE(2760), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88990] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2761), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      sym_constant,
      sym_identifier,
  [89004] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2762), 1,
      sym_heredoc_body,
    ACTIONS(4270), 2,
      sym_constant,
      sym_identifier,
  [89018] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_PIPE,
    ACTIONS(4110), 1,
      anon_sym_SEMI,
    STATE(2763), 1,
      sym_heredoc_body,
  [89034] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2764), 1,
      sym_heredoc_body,
    ACTIONS(923), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89048] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2765), 1,
      sym_heredoc_body,
    ACTIONS(4272), 2,
      sym_constant,
      sym_identifier,
  [89062] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2766), 1,
      sym_heredoc_body,
    ACTIONS(4274), 2,
      sym_constant,
      sym_identifier,
  [89076] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_in,
    STATE(2518), 1,
      sym_in,
    STATE(2767), 1,
      sym_heredoc_body,
  [89092] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4276), 1,
      ts_builtin_sym_end,
    ACTIONS(4278), 1,
      anon_sym___END__,
    STATE(2768), 1,
      sym_heredoc_body,
  [89108] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_RBRACE,
    ACTIONS(4282), 1,
      anon_sym_COMMA,
    STATE(2769), 1,
      sym_heredoc_body,
    STATE(2780), 1,
      aux_sym_hash_repeat1,
  [89124] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2770), 1,
      sym_heredoc_body,
    ACTIONS(4284), 2,
      sym_constant,
      sym_identifier,
  [89138] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_in,
    STATE(2531), 1,
      sym_in,
    STATE(2771), 1,
      sym_heredoc_body,
  [89154] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2772), 1,
      sym_heredoc_body,
    ACTIONS(4129), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [89168] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2773), 1,
      sym_heredoc_body,
    ACTIONS(4286), 2,
      sym_constant,
      sym_identifier,
  [89182] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2774), 1,
      sym_heredoc_body,
    ACTIONS(4288), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89196] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2775), 1,
      sym_heredoc_body,
    ACTIONS(4290), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3962), 1,
      sym__string_end,
    ACTIONS(4292), 1,
      aux_sym_string_array_token1,
    STATE(2679), 1,
      aux_sym_string_array_repeat1,
    STATE(2776), 1,
      sym_heredoc_body,
  [89226] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2777), 1,
      sym_heredoc_body,
    ACTIONS(4294), 2,
      sym_constant,
      sym_identifier,
  [89240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3974), 1,
      sym__string_end,
    ACTIONS(4296), 1,
      aux_sym_string_array_token1,
    STATE(2674), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2778), 1,
      sym_heredoc_body,
  [89256] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2779), 1,
      sym_heredoc_body,
    ACTIONS(4298), 2,
      sym_constant,
      sym_identifier,
  [89270] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1099), 1,
      anon_sym_RBRACE,
    ACTIONS(4300), 1,
      anon_sym_COMMA,
    STATE(2671), 1,
      aux_sym_hash_repeat1,
    STATE(2780), 1,
      sym_heredoc_body,
  [89286] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2781), 1,
      sym_heredoc_body,
    ACTIONS(4302), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89300] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(686), 1,
      anon_sym_RBRACE,
    STATE(2782), 1,
      sym_heredoc_body,
  [89313] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4304), 1,
      sym__string_end,
    STATE(2783), 1,
      sym_heredoc_body,
  [89326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4306), 1,
      anon_sym_EQ,
    STATE(2784), 1,
      sym_heredoc_body,
  [89339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4308), 1,
      anon_sym_EQ,
    STATE(2785), 1,
      sym_heredoc_body,
  [89352] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2786), 1,
      sym_heredoc_body,
    ACTIONS(4310), 2,
      sym_constant,
      sym_identifier,
  [89363] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3907), 1,
      anon_sym_end,
    STATE(2787), 1,
      sym_heredoc_body,
  [89376] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_end,
    STATE(2788), 1,
      sym_heredoc_body,
  [89389] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4314), 1,
      anon_sym_RBRACK,
    STATE(2789), 1,
      sym_heredoc_body,
  [89402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    STATE(2790), 1,
      sym_heredoc_body,
  [89415] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3555), 1,
      anon_sym_end,
    STATE(2791), 1,
      sym_heredoc_body,
  [89428] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4318), 1,
      anon_sym_end,
    STATE(2792), 1,
      sym_heredoc_body,
  [89441] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4320), 1,
      anon_sym_end,
    STATE(2793), 1,
      sym_heredoc_body,
  [89454] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4322), 1,
      sym__line_break,
    STATE(2794), 1,
      sym_heredoc_body,
  [89467] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_end,
    STATE(2795), 1,
      sym_heredoc_body,
  [89480] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4326), 1,
      anon_sym_end,
    STATE(2796), 1,
      sym_heredoc_body,
  [89493] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_COLON,
    STATE(2797), 1,
      sym_heredoc_body,
  [89506] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4328), 1,
      sym__string_end,
    STATE(2798), 1,
      sym_heredoc_body,
  [89519] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4330), 1,
      anon_sym_RPAREN,
    STATE(2799), 1,
      sym_heredoc_body,
  [89532] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4332), 1,
      anon_sym_end,
    STATE(2800), 1,
      sym_heredoc_body,
  [89545] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4334), 1,
      sym_identifier,
    STATE(2801), 1,
      sym_heredoc_body,
  [89558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4336), 1,
      anon_sym_EQ,
    STATE(2802), 1,
      sym_heredoc_body,
  [89571] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2803), 1,
      sym_heredoc_body,
    ACTIONS(4338), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4340), 1,
      anon_sym_EQ,
    STATE(2804), 1,
      sym_heredoc_body,
  [89595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4342), 1,
      anon_sym_EQ,
    STATE(2805), 1,
      sym_heredoc_body,
  [89608] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4344), 1,
      sym_identifier,
    STATE(2806), 1,
      sym_heredoc_body,
  [89621] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4346), 1,
      sym_identifier,
    STATE(2807), 1,
      sym_heredoc_body,
  [89634] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4348), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_heredoc_body,
  [89647] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4350), 1,
      anon_sym_RBRACK,
    STATE(2809), 1,
      sym_heredoc_body,
  [89660] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4352), 1,
      anon_sym_LBRACE,
    STATE(2810), 1,
      sym_heredoc_body,
  [89673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4354), 1,
      anon_sym_EQ,
    STATE(2811), 1,
      sym_heredoc_body,
  [89686] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_end,
    STATE(2812), 1,
      sym_heredoc_body,
  [89699] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_LBRACE,
    STATE(2813), 1,
      sym_heredoc_body,
  [89712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4360), 1,
      anon_sym_EQ,
    STATE(2814), 1,
      sym_heredoc_body,
  [89725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4362), 1,
      anon_sym_EQ,
    STATE(2815), 1,
      sym_heredoc_body,
  [89738] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2816), 1,
      sym_heredoc_body,
    ACTIONS(4364), 2,
      sym_constant,
      sym_identifier,
  [89749] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4366), 1,
      anon_sym_RPAREN,
    STATE(2817), 1,
      sym_heredoc_body,
  [89762] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_end,
    STATE(2818), 1,
      sym_heredoc_body,
  [89775] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4368), 1,
      sym_identifier,
    STATE(2819), 1,
      sym_heredoc_body,
  [89788] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_end,
    STATE(2820), 1,
      sym_heredoc_body,
  [89801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4370), 1,
      anon_sym_EQ,
    STATE(2821), 1,
      sym_heredoc_body,
  [89814] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4372), 1,
      anon_sym_RPAREN,
    STATE(2822), 1,
      sym_heredoc_body,
  [89827] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4374), 1,
      sym__string_end,
    STATE(2823), 1,
      sym_heredoc_body,
  [89840] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4376), 1,
      ts_builtin_sym_end,
    STATE(2824), 1,
      sym_heredoc_body,
  [89853] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym_identifier,
    STATE(2825), 1,
      sym_heredoc_body,
  [89866] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2826), 1,
      sym_heredoc_body,
    ACTIONS(4380), 2,
      sym_constant,
      sym_identifier,
  [89877] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4382), 1,
      anon_sym_RBRACK,
    STATE(2827), 1,
      sym_heredoc_body,
  [89890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4384), 1,
      anon_sym_EQ,
    STATE(2828), 1,
      sym_heredoc_body,
  [89903] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4386), 1,
      anon_sym_RPAREN,
    STATE(2829), 1,
      sym_heredoc_body,
  [89916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    STATE(2830), 1,
      sym_heredoc_body,
  [89929] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4390), 1,
      anon_sym_RBRACE,
    STATE(2831), 1,
      sym_heredoc_body,
  [89942] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3879), 1,
      anon_sym_end,
    STATE(2832), 1,
      sym_heredoc_body,
  [89955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4392), 1,
      sym_uninterpreted,
    STATE(2833), 1,
      sym_heredoc_body,
  [89968] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_RBRACE,
    STATE(2834), 1,
      sym_heredoc_body,
  [89981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4396), 1,
      anon_sym_EQ,
    STATE(2835), 1,
      sym_heredoc_body,
  [89994] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4398), 1,
      sym__string_end,
    STATE(2836), 1,
      sym_heredoc_body,
  [90007] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4400), 1,
      ts_builtin_sym_end,
    STATE(2837), 1,
      sym_heredoc_body,
  [90020] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4402), 1,
      sym__string_end,
    STATE(2838), 1,
      sym_heredoc_body,
  [90033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4404), 1,
      anon_sym_EQ,
    STATE(2839), 1,
      sym_heredoc_body,
  [90046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2840), 1,
      sym_heredoc_body,
  [90059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4406), 1,
      anon_sym_EQ,
    STATE(2841), 1,
      sym_heredoc_body,
  [90072] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_RPAREN,
    STATE(2842), 1,
      sym_heredoc_body,
  [90085] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_RBRACE,
    STATE(2843), 1,
      sym_heredoc_body,
  [90098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4410), 1,
      anon_sym_EQ,
    STATE(2844), 1,
      sym_heredoc_body,
  [90111] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(707), 1,
      anon_sym_RBRACE,
    STATE(2845), 1,
      sym_heredoc_body,
  [90124] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_RPAREN,
    STATE(2846), 1,
      sym_heredoc_body,
  [90137] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4414), 1,
      anon_sym_end,
    STATE(2847), 1,
      sym_heredoc_body,
  [90150] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4416), 1,
      anon_sym_end,
    STATE(2848), 1,
      sym_heredoc_body,
  [90163] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3853), 1,
      anon_sym_end,
    STATE(2849), 1,
      sym_heredoc_body,
  [90176] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3736), 1,
      anon_sym_end,
    STATE(2850), 1,
      sym_heredoc_body,
  [90189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4418), 1,
      anon_sym_EQ,
    STATE(2851), 1,
      sym_heredoc_body,
  [90202] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4420), 1,
      anon_sym_RPAREN,
    STATE(2852), 1,
      sym_heredoc_body,
  [90215] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4422), 1,
      anon_sym_RPAREN,
    STATE(2853), 1,
      sym_heredoc_body,
  [90228] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_end,
    STATE(2854), 1,
      sym_heredoc_body,
  [90241] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4426), 1,
      anon_sym_end,
    STATE(2855), 1,
      sym_heredoc_body,
  [90254] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3490), 1,
      anon_sym_end,
    STATE(2856), 1,
      sym_heredoc_body,
  [90267] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4428), 1,
      anon_sym_RBRACK,
    STATE(2857), 1,
      sym_heredoc_body,
  [90280] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4430), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      sym_heredoc_body,
  [90293] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3488), 1,
      anon_sym_end,
    STATE(2859), 1,
      sym_heredoc_body,
  [90306] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4432), 1,
      anon_sym_RBRACE,
    STATE(2860), 1,
      sym_heredoc_body,
  [90319] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2861), 1,
      sym_heredoc_body,
    ACTIONS(4434), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [90330] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_end,
    STATE(2862), 1,
      sym_heredoc_body,
  [90343] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4438), 1,
      anon_sym_RPAREN,
    STATE(2863), 1,
      sym_heredoc_body,
  [90356] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4440), 1,
      sym_identifier,
    STATE(2864), 1,
      sym_heredoc_body,
  [90369] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4442), 1,
      anon_sym_RPAREN,
    STATE(2865), 1,
      sym_heredoc_body,
  [90382] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(723), 1,
      anon_sym_RBRACE,
    STATE(2866), 1,
      sym_heredoc_body,
  [90395] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_RBRACE,
    STATE(2867), 1,
      sym_heredoc_body,
  [90408] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(684), 1,
      anon_sym_RBRACE,
    STATE(2868), 1,
      sym_heredoc_body,
  [90421] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4444), 1,
      anon_sym_RBRACE,
    STATE(2869), 1,
      sym_heredoc_body,
  [90434] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2870), 1,
      sym_heredoc_body,
    ACTIONS(4446), 2,
      sym_constant,
      sym_identifier,
  [90445] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_RBRACE,
    STATE(2871), 1,
      sym_heredoc_body,
  [90458] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4450), 1,
      ts_builtin_sym_end,
    STATE(2872), 1,
      sym_heredoc_body,
  [90471] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4452), 1,
      anon_sym_RPAREN,
    STATE(2873), 1,
      sym_heredoc_body,
  [90484] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4454), 1,
      anon_sym_RBRACK,
    STATE(2874), 1,
      sym_heredoc_body,
  [90497] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4456), 1,
      anon_sym_RBRACK,
    STATE(2875), 1,
      sym_heredoc_body,
  [90510] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4458), 1,
      anon_sym_end,
    STATE(2876), 1,
      sym_heredoc_body,
  [90523] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4460), 1,
      anon_sym_RBRACE,
    STATE(2877), 1,
      sym_heredoc_body,
  [90536] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_RBRACK,
    STATE(2878), 1,
      sym_heredoc_body,
  [90549] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2879), 1,
      sym_heredoc_body,
    ACTIONS(4464), 2,
      sym_constant,
      sym_identifier,
  [90560] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4466), 1,
      sym__string_end,
    STATE(2880), 1,
      sym_heredoc_body,
  [90573] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4468), 1,
      anon_sym_RPAREN,
    STATE(2881), 1,
      sym_heredoc_body,
  [90586] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2882), 1,
      sym_heredoc_body,
    ACTIONS(4470), 2,
      sym_constant,
      sym_identifier,
  [90597] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_end,
    STATE(2883), 1,
      sym_heredoc_body,
  [90610] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(699), 1,
      anon_sym_RBRACE,
    STATE(2884), 1,
      sym_heredoc_body,
  [90623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4474), 1,
      anon_sym_EQ,
    STATE(2885), 1,
      sym_heredoc_body,
  [90636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4476), 1,
      sym_uninterpreted,
    STATE(2886), 1,
      sym_heredoc_body,
  [90649] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4478), 1,
      anon_sym_RPAREN,
    STATE(2887), 1,
      sym_heredoc_body,
  [90662] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4480), 1,
      sym__line_break,
    STATE(2888), 1,
      sym_heredoc_body,
  [90675] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_COLON,
    STATE(2889), 1,
      sym_heredoc_body,
  [90688] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_COLON,
    STATE(2890), 1,
      sym_heredoc_body,
  [90701] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_end,
    STATE(2891), 1,
      sym_heredoc_body,
  [90714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4484), 1,
      anon_sym_EQ,
    STATE(2892), 1,
      sym_heredoc_body,
  [90727] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4486), 1,
      sym_identifier,
    STATE(2893), 1,
      sym_heredoc_body,
  [90740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4488), 1,
      anon_sym_EQ,
    STATE(2894), 1,
      sym_heredoc_body,
  [90753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4490), 1,
      anon_sym_EQ,
    STATE(2895), 1,
      sym_heredoc_body,
  [90766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4492), 1,
      anon_sym_EQ,
    STATE(2896), 1,
      sym_heredoc_body,
  [90779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4494), 1,
      anon_sym_EQ,
    STATE(2897), 1,
      sym_heredoc_body,
  [90792] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4496), 1,
      anon_sym_end,
    STATE(2898), 1,
      sym_heredoc_body,
  [90805] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_RBRACK,
    STATE(2899), 1,
      sym_heredoc_body,
  [90818] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4500), 1,
      anon_sym_end,
    STATE(2900), 1,
      sym_heredoc_body,
  [90831] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4502), 1,
      anon_sym_end,
    STATE(2901), 1,
      sym_heredoc_body,
  [90844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4504), 1,
      anon_sym_EQ,
    STATE(2902), 1,
      sym_heredoc_body,
  [90857] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4506), 1,
      sym_identifier,
    STATE(2903), 1,
      sym_heredoc_body,
  [90870] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4508), 1,
      anon_sym_RPAREN,
    STATE(2904), 1,
      sym_heredoc_body,
  [90883] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_end,
    STATE(2905), 1,
      sym_heredoc_body,
  [90896] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_end,
    STATE(2906), 1,
      sym_heredoc_body,
  [90909] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_end,
    STATE(2907), 1,
      sym_heredoc_body,
  [90922] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4514), 1,
      anon_sym_RPAREN,
    STATE(2908), 1,
      sym_heredoc_body,
  [90935] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(688), 1,
      anon_sym_RBRACE,
    STATE(2909), 1,
      sym_heredoc_body,
  [90948] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4516), 1,
      anon_sym_RBRACK,
    STATE(2910), 1,
      sym_heredoc_body,
  [90961] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3838), 1,
      anon_sym_end,
    STATE(2911), 1,
      sym_heredoc_body,
  [90974] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3788), 1,
      anon_sym_end,
    STATE(2912), 1,
      sym_heredoc_body,
  [90987] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_end,
    STATE(2913), 1,
      sym_heredoc_body,
  [91000] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym_identifier,
    STATE(2914), 1,
      sym_heredoc_body,
  [91013] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    STATE(2915), 1,
      sym_heredoc_body,
  [91026] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4524), 1,
      sym_identifier,
    STATE(2916), 1,
      sym_heredoc_body,
  [91039] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2917), 1,
      sym_heredoc_body,
    ACTIONS(4526), 2,
      sym_constant,
      sym_identifier,
  [91050] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4528), 1,
      anon_sym_end,
    STATE(2918), 1,
      sym_heredoc_body,
  [91063] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2919), 1,
      sym_heredoc_body,
    ACTIONS(4530), 2,
      sym_constant,
      sym_identifier,
  [91074] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4532), 1,
      anon_sym_RBRACE,
    STATE(2920), 1,
      sym_heredoc_body,
  [91087] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_RBRACE,
    STATE(2921), 1,
      sym_heredoc_body,
  [91100] = 2,
    ACTIONS(4250), 1,
      anon_sym_in,
    STATE(2588), 1,
      sym_in,
  [91107] = 1,
    ACTIONS(4536), 1,
      anon_sym_RBRACK,
  [91111] = 1,
    ACTIONS(4538), 1,
      anon_sym_LBRACE,
  [91115] = 1,
    ACTIONS(4540), 1,
      anon_sym_RBRACE,
  [91119] = 1,
    ACTIONS(4542), 1,
      anon_sym_RPAREN,
  [91123] = 1,
    ACTIONS(4544), 1,
      anon_sym_RPAREN,
  [91127] = 1,
    ACTIONS(4546), 1,
      anon_sym_RBRACE,
  [91131] = 1,
    ACTIONS(4548), 1,
      anon_sym_end,
  [91135] = 1,
    ACTIONS(4550), 1,
      anon_sym_RBRACK,
  [91139] = 1,
    ACTIONS(739), 1,
      anon_sym_RBRACE,
  [91143] = 1,
    ACTIONS(4017), 1,
      anon_sym_end,
  [91147] = 1,
    ACTIONS(4552), 1,
      anon_sym_end,
  [91151] = 1,
    ACTIONS(4554), 1,
      anon_sym_end,
  [91155] = 1,
    ACTIONS(4556), 1,
      anon_sym_RBRACE,
  [91159] = 1,
    ACTIONS(3599), 1,
      anon_sym_end,
  [91163] = 1,
    ACTIONS(4558), 1,
      anon_sym_RPAREN,
  [91167] = 1,
    ACTIONS(4560), 1,
      anon_sym_end,
  [91171] = 1,
    ACTIONS(4562), 1,
      ts_builtin_sym_end,
  [91175] = 1,
    ACTIONS(4564), 1,
      anon_sym_LBRACE,
  [91179] = 1,
    ACTIONS(4566), 1,
      anon_sym_end,
  [91183] = 1,
    ACTIONS(4568), 1,
      anon_sym_EQ,
  [91187] = 1,
    ACTIONS(4570), 1,
      anon_sym_EQ,
  [91191] = 1,
    ACTIONS(4572), 1,
      anon_sym_EQ,
  [91195] = 1,
    ACTIONS(737), 1,
      anon_sym_RBRACE,
  [91199] = 1,
    ACTIONS(743), 1,
      anon_sym_RBRACE,
  [91203] = 1,
    ACTIONS(4574), 1,
      anon_sym_end,
  [91207] = 1,
    ACTIONS(4576), 1,
      ts_builtin_sym_end,
  [91211] = 1,
    ACTIONS(4578), 1,
      anon_sym_RBRACE,
  [91215] = 1,
    ACTIONS(4580), 1,
      anon_sym_EQ,
  [91219] = 1,
    ACTIONS(4033), 1,
      anon_sym_end,
  [91223] = 1,
    ACTIONS(747), 1,
      anon_sym_RBRACE,
  [91227] = 1,
    ACTIONS(3614), 1,
      anon_sym_end,
  [91231] = 1,
    ACTIONS(4582), 1,
      anon_sym_RPAREN,
  [91235] = 1,
    ACTIONS(2586), 1,
      anon_sym_COLON,
  [91239] = 1,
    ACTIONS(4584), 1,
      anon_sym_RBRACE,
  [91243] = 1,
    ACTIONS(2533), 1,
      anon_sym_COLON,
  [91247] = 1,
    ACTIONS(4586), 1,
      anon_sym_EQ,
  [91251] = 1,
    ACTIONS(4588), 1,
      anon_sym_EQ,
  [91255] = 1,
    ACTIONS(4590), 1,
      sym__string_end,
  [91259] = 1,
    ACTIONS(4592), 1,
      anon_sym_RBRACE,
  [91263] = 1,
    ACTIONS(4594), 1,
      anon_sym_RPAREN,
  [91267] = 1,
    ACTIONS(4596), 1,
      anon_sym_EQ,
  [91271] = 1,
    ACTIONS(4598), 1,
      sym__string_end,
  [91275] = 1,
    ACTIONS(4600), 1,
      anon_sym_RPAREN,
  [91279] = 1,
    ACTIONS(4602), 1,
      anon_sym_end,
  [91283] = 1,
    ACTIONS(4604), 1,
      anon_sym_RBRACK,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(965)] = 0,
  [SMALL_STATE(966)] = 74,
  [SMALL_STATE(967)] = 148,
  [SMALL_STATE(968)] = 222,
  [SMALL_STATE(969)] = 296,
  [SMALL_STATE(970)] = 369,
  [SMALL_STATE(971)] = 442,
  [SMALL_STATE(972)] = 515,
  [SMALL_STATE(973)] = 588,
  [SMALL_STATE(974)] = 661,
  [SMALL_STATE(975)] = 744,
  [SMALL_STATE(976)] = 817,
  [SMALL_STATE(977)] = 890,
  [SMALL_STATE(978)] = 971,
  [SMALL_STATE(979)] = 1044,
  [SMALL_STATE(980)] = 1126,
  [SMALL_STATE(981)] = 1206,
  [SMALL_STATE(982)] = 1290,
  [SMALL_STATE(983)] = 1361,
  [SMALL_STATE(984)] = 1436,
  [SMALL_STATE(985)] = 1515,
  [SMALL_STATE(986)] = 1594,
  [SMALL_STATE(987)] = 1671,
  [SMALL_STATE(988)] = 1742,
  [SMALL_STATE(989)] = 1819,
  [SMALL_STATE(990)] = 1896,
  [SMALL_STATE(991)] = 1975,
  [SMALL_STATE(992)] = 2054,
  [SMALL_STATE(993)] = 2128,
  [SMALL_STATE(994)] = 2204,
  [SMALL_STATE(995)] = 2272,
  [SMALL_STATE(996)] = 2340,
  [SMALL_STATE(997)] = 2408,
  [SMALL_STATE(998)] = 2476,
  [SMALL_STATE(999)] = 2552,
  [SMALL_STATE(1000)] = 2620,
  [SMALL_STATE(1001)] = 2702,
  [SMALL_STATE(1002)] = 2780,
  [SMALL_STATE(1003)] = 2854,
  [SMALL_STATE(1004)] = 2928,
  [SMALL_STATE(1005)] = 3004,
  [SMALL_STATE(1006)] = 3072,
  [SMALL_STATE(1007)] = 3139,
  [SMALL_STATE(1008)] = 3206,
  [SMALL_STATE(1009)] = 3279,
  [SMALL_STATE(1010)] = 3346,
  [SMALL_STATE(1011)] = 3419,
  [SMALL_STATE(1012)] = 3488,
  [SMALL_STATE(1013)] = 3557,
  [SMALL_STATE(1014)] = 3624,
  [SMALL_STATE(1015)] = 3691,
  [SMALL_STATE(1016)] = 3758,
  [SMALL_STATE(1017)] = 3827,
  [SMALL_STATE(1018)] = 3896,
  [SMALL_STATE(1019)] = 3963,
  [SMALL_STATE(1020)] = 4030,
  [SMALL_STATE(1021)] = 4099,
  [SMALL_STATE(1022)] = 4166,
  [SMALL_STATE(1023)] = 4235,
  [SMALL_STATE(1024)] = 4304,
  [SMALL_STATE(1025)] = 4371,
  [SMALL_STATE(1026)] = 4438,
  [SMALL_STATE(1027)] = 4505,
  [SMALL_STATE(1028)] = 4578,
  [SMALL_STATE(1029)] = 4645,
  [SMALL_STATE(1030)] = 4712,
  [SMALL_STATE(1031)] = 4779,
  [SMALL_STATE(1032)] = 4846,
  [SMALL_STATE(1033)] = 4913,
  [SMALL_STATE(1034)] = 4980,
  [SMALL_STATE(1035)] = 5047,
  [SMALL_STATE(1036)] = 5114,
  [SMALL_STATE(1037)] = 5187,
  [SMALL_STATE(1038)] = 5260,
  [SMALL_STATE(1039)] = 5329,
  [SMALL_STATE(1040)] = 5396,
  [SMALL_STATE(1041)] = 5463,
  [SMALL_STATE(1042)] = 5540,
  [SMALL_STATE(1043)] = 5607,
  [SMALL_STATE(1044)] = 5674,
  [SMALL_STATE(1045)] = 5747,
  [SMALL_STATE(1046)] = 5816,
  [SMALL_STATE(1047)] = 5885,
  [SMALL_STATE(1048)] = 5954,
  [SMALL_STATE(1049)] = 6021,
  [SMALL_STATE(1050)] = 6094,
  [SMALL_STATE(1051)] = 6162,
  [SMALL_STATE(1052)] = 6228,
  [SMALL_STATE(1053)] = 6300,
  [SMALL_STATE(1054)] = 6366,
  [SMALL_STATE(1055)] = 6432,
  [SMALL_STATE(1056)] = 6500,
  [SMALL_STATE(1057)] = 6568,
  [SMALL_STATE(1058)] = 6636,
  [SMALL_STATE(1059)] = 6704,
  [SMALL_STATE(1060)] = 6780,
  [SMALL_STATE(1061)] = 6846,
  [SMALL_STATE(1062)] = 6914,
  [SMALL_STATE(1063)] = 6982,
  [SMALL_STATE(1064)] = 7050,
  [SMALL_STATE(1065)] = 7116,
  [SMALL_STATE(1066)] = 7184,
  [SMALL_STATE(1067)] = 7250,
  [SMALL_STATE(1068)] = 7318,
  [SMALL_STATE(1069)] = 7386,
  [SMALL_STATE(1070)] = 7454,
  [SMALL_STATE(1071)] = 7522,
  [SMALL_STATE(1072)] = 7590,
  [SMALL_STATE(1073)] = 7658,
  [SMALL_STATE(1074)] = 7728,
  [SMALL_STATE(1075)] = 7796,
  [SMALL_STATE(1076)] = 7866,
  [SMALL_STATE(1077)] = 7932,
  [SMALL_STATE(1078)] = 7998,
  [SMALL_STATE(1079)] = 8064,
  [SMALL_STATE(1080)] = 8130,
  [SMALL_STATE(1081)] = 8196,
  [SMALL_STATE(1082)] = 8262,
  [SMALL_STATE(1083)] = 8330,
  [SMALL_STATE(1084)] = 8396,
  [SMALL_STATE(1085)] = 8464,
  [SMALL_STATE(1086)] = 8532,
  [SMALL_STATE(1087)] = 8600,
  [SMALL_STATE(1088)] = 8666,
  [SMALL_STATE(1089)] = 8732,
  [SMALL_STATE(1090)] = 8798,
  [SMALL_STATE(1091)] = 8868,
  [SMALL_STATE(1092)] = 8934,
  [SMALL_STATE(1093)] = 9002,
  [SMALL_STATE(1094)] = 9068,
  [SMALL_STATE(1095)] = 9135,
  [SMALL_STATE(1096)] = 9202,
  [SMALL_STATE(1097)] = 9269,
  [SMALL_STATE(1098)] = 9342,
  [SMALL_STATE(1099)] = 9409,
  [SMALL_STATE(1100)] = 9482,
  [SMALL_STATE(1101)] = 9549,
  [SMALL_STATE(1102)] = 9616,
  [SMALL_STATE(1103)] = 9683,
  [SMALL_STATE(1104)] = 9750,
  [SMALL_STATE(1105)] = 9817,
  [SMALL_STATE(1106)] = 9884,
  [SMALL_STATE(1107)] = 9961,
  [SMALL_STATE(1108)] = 10028,
  [SMALL_STATE(1109)] = 10095,
  [SMALL_STATE(1110)] = 10162,
  [SMALL_STATE(1111)] = 10229,
  [SMALL_STATE(1112)] = 10296,
  [SMALL_STATE(1113)] = 10363,
  [SMALL_STATE(1114)] = 10430,
  [SMALL_STATE(1115)] = 10497,
  [SMALL_STATE(1116)] = 10564,
  [SMALL_STATE(1117)] = 10631,
  [SMALL_STATE(1118)] = 10698,
  [SMALL_STATE(1119)] = 10765,
  [SMALL_STATE(1120)] = 10832,
  [SMALL_STATE(1121)] = 10899,
  [SMALL_STATE(1122)] = 10966,
  [SMALL_STATE(1123)] = 11033,
  [SMALL_STATE(1124)] = 11100,
  [SMALL_STATE(1125)] = 11167,
  [SMALL_STATE(1126)] = 11234,
  [SMALL_STATE(1127)] = 11301,
  [SMALL_STATE(1128)] = 11368,
  [SMALL_STATE(1129)] = 11435,
  [SMALL_STATE(1130)] = 11502,
  [SMALL_STATE(1131)] = 11569,
  [SMALL_STATE(1132)] = 11636,
  [SMALL_STATE(1133)] = 11703,
  [SMALL_STATE(1134)] = 11778,
  [SMALL_STATE(1135)] = 11845,
  [SMALL_STATE(1136)] = 11912,
  [SMALL_STATE(1137)] = 11979,
  [SMALL_STATE(1138)] = 12046,
  [SMALL_STATE(1139)] = 12113,
  [SMALL_STATE(1140)] = 12180,
  [SMALL_STATE(1141)] = 12247,
  [SMALL_STATE(1142)] = 12314,
  [SMALL_STATE(1143)] = 12381,
  [SMALL_STATE(1144)] = 12448,
  [SMALL_STATE(1145)] = 12515,
  [SMALL_STATE(1146)] = 12582,
  [SMALL_STATE(1147)] = 12649,
  [SMALL_STATE(1148)] = 12716,
  [SMALL_STATE(1149)] = 12783,
  [SMALL_STATE(1150)] = 12850,
  [SMALL_STATE(1151)] = 12917,
  [SMALL_STATE(1152)] = 12984,
  [SMALL_STATE(1153)] = 13051,
  [SMALL_STATE(1154)] = 13118,
  [SMALL_STATE(1155)] = 13185,
  [SMALL_STATE(1156)] = 13252,
  [SMALL_STATE(1157)] = 13319,
  [SMALL_STATE(1158)] = 13386,
  [SMALL_STATE(1159)] = 13453,
  [SMALL_STATE(1160)] = 13520,
  [SMALL_STATE(1161)] = 13587,
  [SMALL_STATE(1162)] = 13654,
  [SMALL_STATE(1163)] = 13721,
  [SMALL_STATE(1164)] = 13788,
  [SMALL_STATE(1165)] = 13855,
  [SMALL_STATE(1166)] = 13922,
  [SMALL_STATE(1167)] = 13989,
  [SMALL_STATE(1168)] = 14060,
  [SMALL_STATE(1169)] = 14127,
  [SMALL_STATE(1170)] = 14194,
  [SMALL_STATE(1171)] = 14261,
  [SMALL_STATE(1172)] = 14328,
  [SMALL_STATE(1173)] = 14395,
  [SMALL_STATE(1174)] = 14462,
  [SMALL_STATE(1175)] = 14529,
  [SMALL_STATE(1176)] = 14596,
  [SMALL_STATE(1177)] = 14663,
  [SMALL_STATE(1178)] = 14730,
  [SMALL_STATE(1179)] = 14797,
  [SMALL_STATE(1180)] = 14864,
  [SMALL_STATE(1181)] = 14935,
  [SMALL_STATE(1182)] = 15002,
  [SMALL_STATE(1183)] = 15069,
  [SMALL_STATE(1184)] = 15136,
  [SMALL_STATE(1185)] = 15203,
  [SMALL_STATE(1186)] = 15270,
  [SMALL_STATE(1187)] = 15337,
  [SMALL_STATE(1188)] = 15404,
  [SMALL_STATE(1189)] = 15471,
  [SMALL_STATE(1190)] = 15538,
  [SMALL_STATE(1191)] = 15605,
  [SMALL_STATE(1192)] = 15672,
  [SMALL_STATE(1193)] = 15739,
  [SMALL_STATE(1194)] = 15806,
  [SMALL_STATE(1195)] = 15873,
  [SMALL_STATE(1196)] = 15947,
  [SMALL_STATE(1197)] = 16019,
  [SMALL_STATE(1198)] = 16091,
  [SMALL_STATE(1199)] = 16162,
  [SMALL_STATE(1200)] = 16235,
  [SMALL_STATE(1201)] = 16306,
  [SMALL_STATE(1202)] = 16379,
  [SMALL_STATE(1203)] = 16450,
  [SMALL_STATE(1204)] = 16521,
  [SMALL_STATE(1205)] = 16585,
  [SMALL_STATE(1206)] = 16649,
  [SMALL_STATE(1207)] = 16713,
  [SMALL_STATE(1208)] = 16777,
  [SMALL_STATE(1209)] = 16841,
  [SMALL_STATE(1210)] = 16905,
  [SMALL_STATE(1211)] = 16969,
  [SMALL_STATE(1212)] = 17035,
  [SMALL_STATE(1213)] = 17099,
  [SMALL_STATE(1214)] = 17163,
  [SMALL_STATE(1215)] = 17231,
  [SMALL_STATE(1216)] = 17295,
  [SMALL_STATE(1217)] = 17359,
  [SMALL_STATE(1218)] = 17423,
  [SMALL_STATE(1219)] = 17487,
  [SMALL_STATE(1220)] = 17557,
  [SMALL_STATE(1221)] = 17621,
  [SMALL_STATE(1222)] = 17685,
  [SMALL_STATE(1223)] = 17749,
  [SMALL_STATE(1224)] = 17843,
  [SMALL_STATE(1225)] = 17915,
  [SMALL_STATE(1226)] = 17979,
  [SMALL_STATE(1227)] = 18045,
  [SMALL_STATE(1228)] = 18109,
  [SMALL_STATE(1229)] = 18173,
  [SMALL_STATE(1230)] = 18237,
  [SMALL_STATE(1231)] = 18304,
  [SMALL_STATE(1232)] = 18395,
  [SMALL_STATE(1233)] = 18458,
  [SMALL_STATE(1234)] = 18523,
  [SMALL_STATE(1235)] = 18588,
  [SMALL_STATE(1236)] = 18679,
  [SMALL_STATE(1237)] = 18770,
  [SMALL_STATE(1238)] = 18855,
  [SMALL_STATE(1239)] = 18924,
  [SMALL_STATE(1240)] = 19009,
  [SMALL_STATE(1241)] = 19100,
  [SMALL_STATE(1242)] = 19189,
  [SMALL_STATE(1243)] = 19280,
  [SMALL_STATE(1244)] = 19343,
  [SMALL_STATE(1245)] = 19434,
  [SMALL_STATE(1246)] = 19511,
  [SMALL_STATE(1247)] = 19580,
  [SMALL_STATE(1248)] = 19671,
  [SMALL_STATE(1249)] = 19734,
  [SMALL_STATE(1250)] = 19805,
  [SMALL_STATE(1251)] = 19898,
  [SMALL_STATE(1252)] = 19969,
  [SMALL_STATE(1253)] = 20062,
  [SMALL_STATE(1254)] = 20133,
  [SMALL_STATE(1255)] = 20198,
  [SMALL_STATE(1256)] = 20271,
  [SMALL_STATE(1257)] = 20336,
  [SMALL_STATE(1258)] = 20403,
  [SMALL_STATE(1259)] = 20468,
  [SMALL_STATE(1260)] = 20531,
  [SMALL_STATE(1261)] = 20602,
  [SMALL_STATE(1262)] = 20692,
  [SMALL_STATE(1263)] = 20782,
  [SMALL_STATE(1264)] = 20872,
  [SMALL_STATE(1265)] = 20962,
  [SMALL_STATE(1266)] = 21052,
  [SMALL_STATE(1267)] = 21116,
  [SMALL_STATE(1268)] = 21206,
  [SMALL_STATE(1269)] = 21272,
  [SMALL_STATE(1270)] = 21336,
  [SMALL_STATE(1271)] = 21408,
  [SMALL_STATE(1272)] = 21472,
  [SMALL_STATE(1273)] = 21542,
  [SMALL_STATE(1274)] = 21618,
  [SMALL_STATE(1275)] = 21706,
  [SMALL_STATE(1276)] = 21796,
  [SMALL_STATE(1277)] = 21880,
  [SMALL_STATE(1278)] = 21948,
  [SMALL_STATE(1279)] = 22032,
  [SMALL_STATE(1280)] = 22122,
  [SMALL_STATE(1281)] = 22212,
  [SMALL_STATE(1282)] = 22302,
  [SMALL_STATE(1283)] = 22368,
  [SMALL_STATE(1284)] = 22458,
  [SMALL_STATE(1285)] = 22522,
  [SMALL_STATE(1286)] = 22592,
  [SMALL_STATE(1287)] = 22684,
  [SMALL_STATE(1288)] = 22748,
  [SMALL_STATE(1289)] = 22813,
  [SMALL_STATE(1290)] = 22902,
  [SMALL_STATE(1291)] = 22971,
  [SMALL_STATE(1292)] = 23046,
  [SMALL_STATE(1293)] = 23133,
  [SMALL_STATE(1294)] = 23222,
  [SMALL_STATE(1295)] = 23305,
  [SMALL_STATE(1296)] = 23372,
  [SMALL_STATE(1297)] = 23455,
  [SMALL_STATE(1298)] = 23518,
  [SMALL_STATE(1299)] = 23611,
  [SMALL_STATE(1300)] = 23700,
  [SMALL_STATE(1301)] = 23765,
  [SMALL_STATE(1302)] = 23856,
  [SMALL_STATE(1303)] = 23947,
  [SMALL_STATE(1304)] = 24036,
  [SMALL_STATE(1305)] = 24125,
  [SMALL_STATE(1306)] = 24196,
  [SMALL_STATE(1307)] = 24285,
  [SMALL_STATE(1308)] = 24378,
  [SMALL_STATE(1309)] = 24441,
  [SMALL_STATE(1310)] = 24504,
  [SMALL_STATE(1311)] = 24567,
  [SMALL_STATE(1312)] = 24630,
  [SMALL_STATE(1313)] = 24719,
  [SMALL_STATE(1314)] = 24810,
  [SMALL_STATE(1315)] = 24875,
  [SMALL_STATE(1316)] = 24963,
  [SMALL_STATE(1317)] = 25051,
  [SMALL_STATE(1318)] = 25133,
  [SMALL_STATE(1319)] = 25221,
  [SMALL_STATE(1320)] = 25283,
  [SMALL_STATE(1321)] = 25371,
  [SMALL_STATE(1322)] = 25459,
  [SMALL_STATE(1323)] = 25547,
  [SMALL_STATE(1324)] = 25613,
  [SMALL_STATE(1325)] = 25701,
  [SMALL_STATE(1326)] = 25789,
  [SMALL_STATE(1327)] = 25877,
  [SMALL_STATE(1328)] = 25965,
  [SMALL_STATE(1329)] = 26053,
  [SMALL_STATE(1330)] = 26117,
  [SMALL_STATE(1331)] = 26199,
  [SMALL_STATE(1332)] = 26287,
  [SMALL_STATE(1333)] = 26373,
  [SMALL_STATE(1334)] = 26447,
  [SMALL_STATE(1335)] = 26515,
  [SMALL_STATE(1336)] = 26577,
  [SMALL_STATE(1337)] = 26647,
  [SMALL_STATE(1338)] = 26709,
  [SMALL_STATE(1339)] = 26790,
  [SMALL_STATE(1340)] = 26853,
  [SMALL_STATE(1341)] = 26914,
  [SMALL_STATE(1342)] = 26981,
  [SMALL_STATE(1343)] = 27044,
  [SMALL_STATE(1344)] = 27131,
  [SMALL_STATE(1345)] = 27218,
  [SMALL_STATE(1346)] = 27285,
  [SMALL_STATE(1347)] = 27372,
  [SMALL_STATE(1348)] = 27459,
  [SMALL_STATE(1349)] = 27546,
  [SMALL_STATE(1350)] = 27607,
  [SMALL_STATE(1351)] = 27676,
  [SMALL_STATE(1352)] = 27737,
  [SMALL_STATE(1353)] = 27804,
  [SMALL_STATE(1354)] = 27877,
  [SMALL_STATE(1355)] = 27962,
  [SMALL_STATE(1356)] = 28049,
  [SMALL_STATE(1357)] = 28130,
  [SMALL_STATE(1358)] = 28217,
  [SMALL_STATE(1359)] = 28282,
  [SMALL_STATE(1360)] = 28360,
  [SMALL_STATE(1361)] = 28420,
  [SMALL_STATE(1362)] = 28498,
  [SMALL_STATE(1363)] = 28558,
  [SMALL_STATE(1364)] = 28616,
  [SMALL_STATE(1365)] = 28694,
  [SMALL_STATE(1366)] = 28755,
  [SMALL_STATE(1367)] = 28816,
  [SMALL_STATE(1368)] = 28877,
  [SMALL_STATE(1369)] = 28932,
  [SMALL_STATE(1370)] = 28993,
  [SMALL_STATE(1371)] = 29052,
  [SMALL_STATE(1372)] = 29111,
  [SMALL_STATE(1373)] = 29174,
  [SMALL_STATE(1374)] = 29249,
  [SMALL_STATE(1375)] = 29308,
  [SMALL_STATE(1376)] = 29371,
  [SMALL_STATE(1377)] = 29432,
  [SMALL_STATE(1378)] = 29493,
  [SMALL_STATE(1379)] = 29552,
  [SMALL_STATE(1380)] = 29607,
  [SMALL_STATE(1381)] = 29666,
  [SMALL_STATE(1382)] = 29727,
  [SMALL_STATE(1383)] = 29786,
  [SMALL_STATE(1384)] = 29847,
  [SMALL_STATE(1385)] = 29903,
  [SMALL_STATE(1386)] = 29961,
  [SMALL_STATE(1387)] = 30017,
  [SMALL_STATE(1388)] = 30073,
  [SMALL_STATE(1389)] = 30129,
  [SMALL_STATE(1390)] = 30185,
  [SMALL_STATE(1391)] = 30243,
  [SMALL_STATE(1392)] = 30307,
  [SMALL_STATE(1393)] = 30360,
  [SMALL_STATE(1394)] = 30413,
  [SMALL_STATE(1395)] = 30468,
  [SMALL_STATE(1396)] = 30523,
  [SMALL_STATE(1397)] = 30576,
  [SMALL_STATE(1398)] = 30629,
  [SMALL_STATE(1399)] = 30682,
  [SMALL_STATE(1400)] = 30737,
  [SMALL_STATE(1401)] = 30792,
  [SMALL_STATE(1402)] = 30845,
  [SMALL_STATE(1403)] = 30900,
  [SMALL_STATE(1404)] = 30955,
  [SMALL_STATE(1405)] = 31008,
  [SMALL_STATE(1406)] = 31061,
  [SMALL_STATE(1407)] = 31114,
  [SMALL_STATE(1408)] = 31167,
  [SMALL_STATE(1409)] = 31220,
  [SMALL_STATE(1410)] = 31275,
  [SMALL_STATE(1411)] = 31328,
  [SMALL_STATE(1412)] = 31381,
  [SMALL_STATE(1413)] = 31434,
  [SMALL_STATE(1414)] = 31487,
  [SMALL_STATE(1415)] = 31540,
  [SMALL_STATE(1416)] = 31595,
  [SMALL_STATE(1417)] = 31650,
  [SMALL_STATE(1418)] = 31703,
  [SMALL_STATE(1419)] = 31758,
  [SMALL_STATE(1420)] = 31811,
  [SMALL_STATE(1421)] = 31866,
  [SMALL_STATE(1422)] = 31919,
  [SMALL_STATE(1423)] = 31972,
  [SMALL_STATE(1424)] = 32025,
  [SMALL_STATE(1425)] = 32080,
  [SMALL_STATE(1426)] = 32133,
  [SMALL_STATE(1427)] = 32186,
  [SMALL_STATE(1428)] = 32239,
  [SMALL_STATE(1429)] = 32292,
  [SMALL_STATE(1430)] = 32345,
  [SMALL_STATE(1431)] = 32398,
  [SMALL_STATE(1432)] = 32451,
  [SMALL_STATE(1433)] = 32506,
  [SMALL_STATE(1434)] = 32559,
  [SMALL_STATE(1435)] = 32612,
  [SMALL_STATE(1436)] = 32667,
  [SMALL_STATE(1437)] = 32720,
  [SMALL_STATE(1438)] = 32773,
  [SMALL_STATE(1439)] = 32826,
  [SMALL_STATE(1440)] = 32879,
  [SMALL_STATE(1441)] = 32932,
  [SMALL_STATE(1442)] = 32985,
  [SMALL_STATE(1443)] = 33038,
  [SMALL_STATE(1444)] = 33091,
  [SMALL_STATE(1445)] = 33144,
  [SMALL_STATE(1446)] = 33199,
  [SMALL_STATE(1447)] = 33254,
  [SMALL_STATE(1448)] = 33309,
  [SMALL_STATE(1449)] = 33364,
  [SMALL_STATE(1450)] = 33419,
  [SMALL_STATE(1451)] = 33474,
  [SMALL_STATE(1452)] = 33529,
  [SMALL_STATE(1453)] = 33582,
  [SMALL_STATE(1454)] = 33637,
  [SMALL_STATE(1455)] = 33690,
  [SMALL_STATE(1456)] = 33743,
  [SMALL_STATE(1457)] = 33796,
  [SMALL_STATE(1458)] = 33849,
  [SMALL_STATE(1459)] = 33902,
  [SMALL_STATE(1460)] = 33955,
  [SMALL_STATE(1461)] = 34008,
  [SMALL_STATE(1462)] = 34063,
  [SMALL_STATE(1463)] = 34116,
  [SMALL_STATE(1464)] = 34171,
  [SMALL_STATE(1465)] = 34232,
  [SMALL_STATE(1466)] = 34287,
  [SMALL_STATE(1467)] = 34342,
  [SMALL_STATE(1468)] = 34397,
  [SMALL_STATE(1469)] = 34452,
  [SMALL_STATE(1470)] = 34505,
  [SMALL_STATE(1471)] = 34560,
  [SMALL_STATE(1472)] = 34613,
  [SMALL_STATE(1473)] = 34668,
  [SMALL_STATE(1474)] = 34723,
  [SMALL_STATE(1475)] = 34778,
  [SMALL_STATE(1476)] = 34833,
  [SMALL_STATE(1477)] = 34888,
  [SMALL_STATE(1478)] = 34943,
  [SMALL_STATE(1479)] = 34998,
  [SMALL_STATE(1480)] = 35053,
  [SMALL_STATE(1481)] = 35108,
  [SMALL_STATE(1482)] = 35161,
  [SMALL_STATE(1483)] = 35216,
  [SMALL_STATE(1484)] = 35269,
  [SMALL_STATE(1485)] = 35324,
  [SMALL_STATE(1486)] = 35377,
  [SMALL_STATE(1487)] = 35430,
  [SMALL_STATE(1488)] = 35485,
  [SMALL_STATE(1489)] = 35540,
  [SMALL_STATE(1490)] = 35593,
  [SMALL_STATE(1491)] = 35648,
  [SMALL_STATE(1492)] = 35701,
  [SMALL_STATE(1493)] = 35754,
  [SMALL_STATE(1494)] = 35807,
  [SMALL_STATE(1495)] = 35860,
  [SMALL_STATE(1496)] = 35915,
  [SMALL_STATE(1497)] = 35968,
  [SMALL_STATE(1498)] = 36023,
  [SMALL_STATE(1499)] = 36078,
  [SMALL_STATE(1500)] = 36131,
  [SMALL_STATE(1501)] = 36186,
  [SMALL_STATE(1502)] = 36241,
  [SMALL_STATE(1503)] = 36294,
  [SMALL_STATE(1504)] = 36349,
  [SMALL_STATE(1505)] = 36404,
  [SMALL_STATE(1506)] = 36457,
  [SMALL_STATE(1507)] = 36512,
  [SMALL_STATE(1508)] = 36567,
  [SMALL_STATE(1509)] = 36622,
  [SMALL_STATE(1510)] = 36677,
  [SMALL_STATE(1511)] = 36732,
  [SMALL_STATE(1512)] = 36787,
  [SMALL_STATE(1513)] = 36842,
  [SMALL_STATE(1514)] = 36897,
  [SMALL_STATE(1515)] = 36952,
  [SMALL_STATE(1516)] = 37005,
  [SMALL_STATE(1517)] = 37060,
  [SMALL_STATE(1518)] = 37113,
  [SMALL_STATE(1519)] = 37168,
  [SMALL_STATE(1520)] = 37223,
  [SMALL_STATE(1521)] = 37278,
  [SMALL_STATE(1522)] = 37333,
  [SMALL_STATE(1523)] = 37388,
  [SMALL_STATE(1524)] = 37441,
  [SMALL_STATE(1525)] = 37494,
  [SMALL_STATE(1526)] = 37547,
  [SMALL_STATE(1527)] = 37608,
  [SMALL_STATE(1528)] = 37661,
  [SMALL_STATE(1529)] = 37716,
  [SMALL_STATE(1530)] = 37769,
  [SMALL_STATE(1531)] = 37822,
  [SMALL_STATE(1532)] = 37875,
  [SMALL_STATE(1533)] = 37930,
  [SMALL_STATE(1534)] = 37985,
  [SMALL_STATE(1535)] = 38040,
  [SMALL_STATE(1536)] = 38093,
  [SMALL_STATE(1537)] = 38148,
  [SMALL_STATE(1538)] = 38201,
  [SMALL_STATE(1539)] = 38256,
  [SMALL_STATE(1540)] = 38311,
  [SMALL_STATE(1541)] = 38366,
  [SMALL_STATE(1542)] = 38419,
  [SMALL_STATE(1543)] = 38474,
  [SMALL_STATE(1544)] = 38529,
  [SMALL_STATE(1545)] = 38584,
  [SMALL_STATE(1546)] = 38637,
  [SMALL_STATE(1547)] = 38690,
  [SMALL_STATE(1548)] = 38745,
  [SMALL_STATE(1549)] = 38800,
  [SMALL_STATE(1550)] = 38855,
  [SMALL_STATE(1551)] = 38908,
  [SMALL_STATE(1552)] = 38961,
  [SMALL_STATE(1553)] = 39014,
  [SMALL_STATE(1554)] = 39067,
  [SMALL_STATE(1555)] = 39120,
  [SMALL_STATE(1556)] = 39173,
  [SMALL_STATE(1557)] = 39226,
  [SMALL_STATE(1558)] = 39281,
  [SMALL_STATE(1559)] = 39336,
  [SMALL_STATE(1560)] = 39389,
  [SMALL_STATE(1561)] = 39444,
  [SMALL_STATE(1562)] = 39499,
  [SMALL_STATE(1563)] = 39552,
  [SMALL_STATE(1564)] = 39607,
  [SMALL_STATE(1565)] = 39662,
  [SMALL_STATE(1566)] = 39717,
  [SMALL_STATE(1567)] = 39772,
  [SMALL_STATE(1568)] = 39827,
  [SMALL_STATE(1569)] = 39895,
  [SMALL_STATE(1570)] = 39963,
  [SMALL_STATE(1571)] = 40031,
  [SMALL_STATE(1572)] = 40093,
  [SMALL_STATE(1573)] = 40161,
  [SMALL_STATE(1574)] = 40221,
  [SMALL_STATE(1575)] = 40289,
  [SMALL_STATE(1576)] = 40351,
  [SMALL_STATE(1577)] = 40419,
  [SMALL_STATE(1578)] = 40502,
  [SMALL_STATE(1579)] = 40559,
  [SMALL_STATE(1580)] = 40624,
  [SMALL_STATE(1581)] = 40689,
  [SMALL_STATE(1582)] = 40754,
  [SMALL_STATE(1583)] = 40819,
  [SMALL_STATE(1584)] = 40884,
  [SMALL_STATE(1585)] = 40949,
  [SMALL_STATE(1586)] = 41014,
  [SMALL_STATE(1587)] = 41099,
  [SMALL_STATE(1588)] = 41154,
  [SMALL_STATE(1589)] = 41219,
  [SMALL_STATE(1590)] = 41274,
  [SMALL_STATE(1591)] = 41359,
  [SMALL_STATE(1592)] = 41424,
  [SMALL_STATE(1593)] = 41489,
  [SMALL_STATE(1594)] = 41547,
  [SMALL_STATE(1595)] = 41599,
  [SMALL_STATE(1596)] = 41659,
  [SMALL_STATE(1597)] = 41721,
  [SMALL_STATE(1598)] = 41801,
  [SMALL_STATE(1599)] = 41861,
  [SMALL_STATE(1600)] = 41941,
  [SMALL_STATE(1601)] = 41995,
  [SMALL_STATE(1602)] = 42047,
  [SMALL_STATE(1603)] = 42107,
  [SMALL_STATE(1604)] = 42164,
  [SMALL_STATE(1605)] = 42221,
  [SMALL_STATE(1606)] = 42272,
  [SMALL_STATE(1607)] = 42351,
  [SMALL_STATE(1608)] = 42402,
  [SMALL_STATE(1609)] = 42453,
  [SMALL_STATE(1610)] = 42530,
  [SMALL_STATE(1611)] = 42579,
  [SMALL_STATE(1612)] = 42630,
  [SMALL_STATE(1613)] = 42683,
  [SMALL_STATE(1614)] = 42734,
  [SMALL_STATE(1615)] = 42783,
  [SMALL_STATE(1616)] = 42862,
  [SMALL_STATE(1617)] = 42939,
  [SMALL_STATE(1618)] = 43016,
  [SMALL_STATE(1619)] = 43071,
  [SMALL_STATE(1620)] = 43124,
  [SMALL_STATE(1621)] = 43181,
  [SMALL_STATE(1622)] = 43242,
  [SMALL_STATE(1623)] = 43297,
  [SMALL_STATE(1624)] = 43378,
  [SMALL_STATE(1625)] = 43431,
  [SMALL_STATE(1626)] = 43490,
  [SMALL_STATE(1627)] = 43555,
  [SMALL_STATE(1628)] = 43632,
  [SMALL_STATE(1629)] = 43711,
  [SMALL_STATE(1630)] = 43762,
  [SMALL_STATE(1631)] = 43821,
  [SMALL_STATE(1632)] = 43872,
  [SMALL_STATE(1633)] = 43923,
  [SMALL_STATE(1634)] = 43972,
  [SMALL_STATE(1635)] = 44051,
  [SMALL_STATE(1636)] = 44102,
  [SMALL_STATE(1637)] = 44181,
  [SMALL_STATE(1638)] = 44238,
  [SMALL_STATE(1639)] = 44291,
  [SMALL_STATE(1640)] = 44370,
  [SMALL_STATE(1641)] = 44433,
  [SMALL_STATE(1642)] = 44506,
  [SMALL_STATE(1643)] = 44585,
  [SMALL_STATE(1644)] = 44660,
  [SMALL_STATE(1645)] = 44737,
  [SMALL_STATE(1646)] = 44790,
  [SMALL_STATE(1647)] = 44863,
  [SMALL_STATE(1648)] = 44934,
  [SMALL_STATE(1649)] = 45013,
  [SMALL_STATE(1650)] = 45090,
  [SMALL_STATE(1651)] = 45167,
  [SMALL_STATE(1652)] = 45222,
  [SMALL_STATE(1653)] = 45299,
  [SMALL_STATE(1654)] = 45370,
  [SMALL_STATE(1655)] = 45420,
  [SMALL_STATE(1656)] = 45496,
  [SMALL_STATE(1657)] = 45546,
  [SMALL_STATE(1658)] = 45622,
  [SMALL_STATE(1659)] = 45698,
  [SMALL_STATE(1660)] = 45748,
  [SMALL_STATE(1661)] = 45824,
  [SMALL_STATE(1662)] = 45900,
  [SMALL_STATE(1663)] = 45976,
  [SMALL_STATE(1664)] = 46034,
  [SMALL_STATE(1665)] = 46086,
  [SMALL_STATE(1666)] = 46162,
  [SMALL_STATE(1667)] = 46232,
  [SMALL_STATE(1668)] = 46310,
  [SMALL_STATE(1669)] = 46386,
  [SMALL_STATE(1670)] = 46436,
  [SMALL_STATE(1671)] = 46494,
  [SMALL_STATE(1672)] = 46544,
  [SMALL_STATE(1673)] = 46600,
  [SMALL_STATE(1674)] = 46676,
  [SMALL_STATE(1675)] = 46738,
  [SMALL_STATE(1676)] = 46790,
  [SMALL_STATE(1677)] = 46864,
  [SMALL_STATE(1678)] = 46940,
  [SMALL_STATE(1679)] = 47016,
  [SMALL_STATE(1680)] = 47068,
  [SMALL_STATE(1681)] = 47122,
  [SMALL_STATE(1682)] = 47192,
  [SMALL_STATE(1683)] = 47269,
  [SMALL_STATE(1684)] = 47318,
  [SMALL_STATE(1685)] = 47393,
  [SMALL_STATE(1686)] = 47468,
  [SMALL_STATE(1687)] = 47547,
  [SMALL_STATE(1688)] = 47596,
  [SMALL_STATE(1689)] = 47673,
  [SMALL_STATE(1690)] = 47724,
  [SMALL_STATE(1691)] = 47773,
  [SMALL_STATE(1692)] = 47822,
  [SMALL_STATE(1693)] = 47871,
  [SMALL_STATE(1694)] = 47920,
  [SMALL_STATE(1695)] = 47971,
  [SMALL_STATE(1696)] = 48020,
  [SMALL_STATE(1697)] = 48095,
  [SMALL_STATE(1698)] = 48144,
  [SMALL_STATE(1699)] = 48219,
  [SMALL_STATE(1700)] = 48268,
  [SMALL_STATE(1701)] = 48319,
  [SMALL_STATE(1702)] = 48368,
  [SMALL_STATE(1703)] = 48445,
  [SMALL_STATE(1704)] = 48502,
  [SMALL_STATE(1705)] = 48551,
  [SMALL_STATE(1706)] = 48600,
  [SMALL_STATE(1707)] = 48655,
  [SMALL_STATE(1708)] = 48716,
  [SMALL_STATE(1709)] = 48789,
  [SMALL_STATE(1710)] = 48864,
  [SMALL_STATE(1711)] = 48933,
  [SMALL_STATE(1712)] = 48986,
  [SMALL_STATE(1713)] = 49055,
  [SMALL_STATE(1714)] = 49130,
  [SMALL_STATE(1715)] = 49179,
  [SMALL_STATE(1716)] = 49258,
  [SMALL_STATE(1717)] = 49333,
  [SMALL_STATE(1718)] = 49383,
  [SMALL_STATE(1719)] = 49433,
  [SMALL_STATE(1720)] = 49501,
  [SMALL_STATE(1721)] = 49553,
  [SMALL_STATE(1722)] = 49621,
  [SMALL_STATE(1723)] = 49695,
  [SMALL_STATE(1724)] = 49769,
  [SMALL_STATE(1725)] = 49819,
  [SMALL_STATE(1726)] = 49869,
  [SMALL_STATE(1727)] = 49943,
  [SMALL_STATE(1728)] = 50017,
  [SMALL_STATE(1729)] = 50091,
  [SMALL_STATE(1730)] = 50139,
  [SMALL_STATE(1731)] = 50213,
  [SMALL_STATE(1732)] = 50291,
  [SMALL_STATE(1733)] = 50363,
  [SMALL_STATE(1734)] = 50423,
  [SMALL_STATE(1735)] = 50475,
  [SMALL_STATE(1736)] = 50529,
  [SMALL_STATE(1737)] = 50577,
  [SMALL_STATE(1738)] = 50633,
  [SMALL_STATE(1739)] = 50707,
  [SMALL_STATE(1740)] = 50781,
  [SMALL_STATE(1741)] = 50829,
  [SMALL_STATE(1742)] = 50911,
  [SMALL_STATE(1743)] = 50961,
  [SMALL_STATE(1744)] = 51035,
  [SMALL_STATE(1745)] = 51109,
  [SMALL_STATE(1746)] = 51161,
  [SMALL_STATE(1747)] = 51239,
  [SMALL_STATE(1748)] = 51313,
  [SMALL_STATE(1749)] = 51387,
  [SMALL_STATE(1750)] = 51440,
  [SMALL_STATE(1751)] = 51513,
  [SMALL_STATE(1752)] = 51570,
  [SMALL_STATE(1753)] = 51645,
  [SMALL_STATE(1754)] = 51696,
  [SMALL_STATE(1755)] = 51749,
  [SMALL_STATE(1756)] = 51824,
  [SMALL_STATE(1757)] = 51877,
  [SMALL_STATE(1758)] = 51934,
  [SMALL_STATE(1759)] = 52009,
  [SMALL_STATE(1760)] = 52056,
  [SMALL_STATE(1761)] = 52129,
  [SMALL_STATE(1762)] = 52182,
  [SMALL_STATE(1763)] = 52235,
  [SMALL_STATE(1764)] = 52312,
  [SMALL_STATE(1765)] = 52387,
  [SMALL_STATE(1766)] = 52436,
  [SMALL_STATE(1767)] = 52515,
  [SMALL_STATE(1768)] = 52564,
  [SMALL_STATE(1769)] = 52639,
  [SMALL_STATE(1770)] = 52690,
  [SMALL_STATE(1771)] = 52765,
  [SMALL_STATE(1772)] = 52814,
  [SMALL_STATE(1773)] = 52891,
  [SMALL_STATE(1774)] = 52964,
  [SMALL_STATE(1775)] = 53039,
  [SMALL_STATE(1776)] = 53094,
  [SMALL_STATE(1777)] = 53169,
  [SMALL_STATE(1778)] = 53218,
  [SMALL_STATE(1779)] = 53267,
  [SMALL_STATE(1780)] = 53340,
  [SMALL_STATE(1781)] = 53393,
  [SMALL_STATE(1782)] = 53444,
  [SMALL_STATE(1783)] = 53495,
  [SMALL_STATE(1784)] = 53578,
  [SMALL_STATE(1785)] = 53627,
  [SMALL_STATE(1786)] = 53702,
  [SMALL_STATE(1787)] = 53777,
  [SMALL_STATE(1788)] = 53850,
  [SMALL_STATE(1789)] = 53919,
  [SMALL_STATE(1790)] = 54002,
  [SMALL_STATE(1791)] = 54055,
  [SMALL_STATE(1792)] = 54128,
  [SMALL_STATE(1793)] = 54203,
  [SMALL_STATE(1794)] = 54272,
  [SMALL_STATE(1795)] = 54349,
  [SMALL_STATE(1796)] = 54398,
  [SMALL_STATE(1797)] = 54447,
  [SMALL_STATE(1798)] = 54530,
  [SMALL_STATE(1799)] = 54613,
  [SMALL_STATE(1800)] = 54662,
  [SMALL_STATE(1801)] = 54737,
  [SMALL_STATE(1802)] = 54786,
  [SMALL_STATE(1803)] = 54859,
  [SMALL_STATE(1804)] = 54920,
  [SMALL_STATE(1805)] = 54973,
  [SMALL_STATE(1806)] = 55048,
  [SMALL_STATE(1807)] = 55099,
  [SMALL_STATE(1808)] = 55176,
  [SMALL_STATE(1809)] = 55237,
  [SMALL_STATE(1810)] = 55306,
  [SMALL_STATE(1811)] = 55361,
  [SMALL_STATE(1812)] = 55444,
  [SMALL_STATE(1813)] = 55521,
  [SMALL_STATE(1814)] = 55574,
  [SMALL_STATE(1815)] = 55643,
  [SMALL_STATE(1816)] = 55696,
  [SMALL_STATE(1817)] = 55747,
  [SMALL_STATE(1818)] = 55830,
  [SMALL_STATE(1819)] = 55879,
  [SMALL_STATE(1820)] = 55952,
  [SMALL_STATE(1821)] = 56019,
  [SMALL_STATE(1822)] = 56066,
  [SMALL_STATE(1823)] = 56121,
  [SMALL_STATE(1824)] = 56196,
  [SMALL_STATE(1825)] = 56243,
  [SMALL_STATE(1826)] = 56296,
  [SMALL_STATE(1827)] = 56347,
  [SMALL_STATE(1828)] = 56414,
  [SMALL_STATE(1829)] = 56463,
  [SMALL_STATE(1830)] = 56536,
  [SMALL_STATE(1831)] = 56585,
  [SMALL_STATE(1832)] = 56638,
  [SMALL_STATE(1833)] = 56691,
  [SMALL_STATE(1834)] = 56762,
  [SMALL_STATE(1835)] = 56821,
  [SMALL_STATE(1836)] = 56871,
  [SMALL_STATE(1837)] = 56945,
  [SMALL_STATE(1838)] = 56993,
  [SMALL_STATE(1839)] = 57043,
  [SMALL_STATE(1840)] = 57093,
  [SMALL_STATE(1841)] = 57141,
  [SMALL_STATE(1842)] = 57209,
  [SMALL_STATE(1843)] = 57283,
  [SMALL_STATE(1844)] = 57335,
  [SMALL_STATE(1845)] = 57409,
  [SMALL_STATE(1846)] = 57485,
  [SMALL_STATE(1847)] = 57541,
  [SMALL_STATE(1848)] = 57615,
  [SMALL_STATE(1849)] = 57671,
  [SMALL_STATE(1850)] = 57745,
  [SMALL_STATE(1851)] = 57795,
  [SMALL_STATE(1852)] = 57843,
  [SMALL_STATE(1853)] = 57919,
  [SMALL_STATE(1854)] = 57967,
  [SMALL_STATE(1855)] = 58021,
  [SMALL_STATE(1856)] = 58095,
  [SMALL_STATE(1857)] = 58145,
  [SMALL_STATE(1858)] = 58205,
  [SMALL_STATE(1859)] = 58279,
  [SMALL_STATE(1860)] = 58353,
  [SMALL_STATE(1861)] = 58427,
  [SMALL_STATE(1862)] = 58475,
  [SMALL_STATE(1863)] = 58547,
  [SMALL_STATE(1864)] = 58615,
  [SMALL_STATE(1865)] = 58687,
  [SMALL_STATE(1866)] = 58767,
  [SMALL_STATE(1867)] = 58847,
  [SMALL_STATE(1868)] = 58907,
  [SMALL_STATE(1869)] = 58961,
  [SMALL_STATE(1870)] = 59009,
  [SMALL_STATE(1871)] = 59083,
  [SMALL_STATE(1872)] = 59151,
  [SMALL_STATE(1873)] = 59201,
  [SMALL_STATE(1874)] = 59275,
  [SMALL_STATE(1875)] = 59323,
  [SMALL_STATE(1876)] = 59371,
  [SMALL_STATE(1877)] = 59445,
  [SMALL_STATE(1878)] = 59495,
  [SMALL_STATE(1879)] = 59563,
  [SMALL_STATE(1880)] = 59639,
  [SMALL_STATE(1881)] = 59691,
  [SMALL_STATE(1882)] = 59743,
  [SMALL_STATE(1883)] = 59811,
  [SMALL_STATE(1884)] = 59885,
  [SMALL_STATE(1885)] = 59961,
  [SMALL_STATE(1886)] = 60029,
  [SMALL_STATE(1887)] = 60101,
  [SMALL_STATE(1888)] = 60179,
  [SMALL_STATE(1889)] = 60239,
  [SMALL_STATE(1890)] = 60293,
  [SMALL_STATE(1891)] = 60371,
  [SMALL_STATE(1892)] = 60445,
  [SMALL_STATE(1893)] = 60493,
  [SMALL_STATE(1894)] = 60541,
  [SMALL_STATE(1895)] = 60597,
  [SMALL_STATE(1896)] = 60645,
  [SMALL_STATE(1897)] = 60719,
  [SMALL_STATE(1898)] = 60793,
  [SMALL_STATE(1899)] = 60867,
  [SMALL_STATE(1900)] = 60917,
  [SMALL_STATE(1901)] = 60991,
  [SMALL_STATE(1902)] = 61067,
  [SMALL_STATE(1903)] = 61141,
  [SMALL_STATE(1904)] = 61217,
  [SMALL_STATE(1905)] = 61267,
  [SMALL_STATE(1906)] = 61341,
  [SMALL_STATE(1907)] = 61415,
  [SMALL_STATE(1908)] = 61490,
  [SMALL_STATE(1909)] = 61565,
  [SMALL_STATE(1910)] = 61632,
  [SMALL_STATE(1911)] = 61699,
  [SMALL_STATE(1912)] = 61750,
  [SMALL_STATE(1913)] = 61823,
  [SMALL_STATE(1914)] = 61890,
  [SMALL_STATE(1915)] = 61965,
  [SMALL_STATE(1916)] = 62042,
  [SMALL_STATE(1917)] = 62091,
  [SMALL_STATE(1918)] = 62162,
  [SMALL_STATE(1919)] = 62235,
  [SMALL_STATE(1920)] = 62302,
  [SMALL_STATE(1921)] = 62349,
  [SMALL_STATE(1922)] = 62426,
  [SMALL_STATE(1923)] = 62499,
  [SMALL_STATE(1924)] = 62576,
  [SMALL_STATE(1925)] = 62649,
  [SMALL_STATE(1926)] = 62724,
  [SMALL_STATE(1927)] = 62797,
  [SMALL_STATE(1928)] = 62844,
  [SMALL_STATE(1929)] = 62917,
  [SMALL_STATE(1930)] = 62990,
  [SMALL_STATE(1931)] = 63039,
  [SMALL_STATE(1932)] = 63114,
  [SMALL_STATE(1933)] = 63169,
  [SMALL_STATE(1934)] = 63228,
  [SMALL_STATE(1935)] = 63275,
  [SMALL_STATE(1936)] = 63346,
  [SMALL_STATE(1937)] = 63393,
  [SMALL_STATE(1938)] = 63452,
  [SMALL_STATE(1939)] = 63505,
  [SMALL_STATE(1940)] = 63552,
  [SMALL_STATE(1941)] = 63627,
  [SMALL_STATE(1942)] = 63704,
  [SMALL_STATE(1943)] = 63751,
  [SMALL_STATE(1944)] = 63824,
  [SMALL_STATE(1945)] = 63873,
  [SMALL_STATE(1946)] = 63922,
  [SMALL_STATE(1947)] = 63975,
  [SMALL_STATE(1948)] = 64030,
  [SMALL_STATE(1949)] = 64103,
  [SMALL_STATE(1950)] = 64150,
  [SMALL_STATE(1951)] = 64227,
  [SMALL_STATE(1952)] = 64300,
  [SMALL_STATE(1953)] = 64373,
  [SMALL_STATE(1954)] = 64450,
  [SMALL_STATE(1955)] = 64523,
  [SMALL_STATE(1956)] = 64572,
  [SMALL_STATE(1957)] = 64621,
  [SMALL_STATE(1958)] = 64696,
  [SMALL_STATE(1959)] = 64743,
  [SMALL_STATE(1960)] = 64794,
  [SMALL_STATE(1961)] = 64869,
  [SMALL_STATE(1962)] = 64946,
  [SMALL_STATE(1963)] = 65023,
  [SMALL_STATE(1964)] = 65100,
  [SMALL_STATE(1965)] = 65146,
  [SMALL_STATE(1966)] = 65200,
  [SMALL_STATE(1967)] = 65272,
  [SMALL_STATE(1968)] = 65324,
  [SMALL_STATE(1969)] = 65396,
  [SMALL_STATE(1970)] = 65468,
  [SMALL_STATE(1971)] = 65526,
  [SMALL_STATE(1972)] = 65596,
  [SMALL_STATE(1973)] = 65668,
  [SMALL_STATE(1974)] = 65714,
  [SMALL_STATE(1975)] = 65786,
  [SMALL_STATE(1976)] = 65858,
  [SMALL_STATE(1977)] = 65932,
  [SMALL_STATE(1978)] = 65998,
  [SMALL_STATE(1979)] = 66048,
  [SMALL_STATE(1980)] = 66114,
  [SMALL_STATE(1981)] = 66186,
  [SMALL_STATE(1982)] = 66232,
  [SMALL_STATE(1983)] = 66306,
  [SMALL_STATE(1984)] = 66378,
  [SMALL_STATE(1985)] = 66426,
  [SMALL_STATE(1986)] = 66492,
  [SMALL_STATE(1987)] = 66564,
  [SMALL_STATE(1988)] = 66614,
  [SMALL_STATE(1989)] = 66660,
  [SMALL_STATE(1990)] = 66734,
  [SMALL_STATE(1991)] = 66800,
  [SMALL_STATE(1992)] = 66872,
  [SMALL_STATE(1993)] = 66942,
  [SMALL_STATE(1994)] = 67016,
  [SMALL_STATE(1995)] = 67090,
  [SMALL_STATE(1996)] = 67148,
  [SMALL_STATE(1997)] = 67200,
  [SMALL_STATE(1998)] = 67274,
  [SMALL_STATE(1999)] = 67348,
  [SMALL_STATE(2000)] = 67394,
  [SMALL_STATE(2001)] = 67440,
  [SMALL_STATE(2002)] = 67494,
  [SMALL_STATE(2003)] = 67566,
  [SMALL_STATE(2004)] = 67638,
  [SMALL_STATE(2005)] = 67686,
  [SMALL_STATE(2006)] = 67759,
  [SMALL_STATE(2007)] = 67828,
  [SMALL_STATE(2008)] = 67901,
  [SMALL_STATE(2009)] = 67974,
  [SMALL_STATE(2010)] = 68019,
  [SMALL_STATE(2011)] = 68064,
  [SMALL_STATE(2012)] = 68137,
  [SMALL_STATE(2013)] = 68208,
  [SMALL_STATE(2014)] = 68255,
  [SMALL_STATE(2015)] = 68328,
  [SMALL_STATE(2016)] = 68401,
  [SMALL_STATE(2017)] = 68472,
  [SMALL_STATE(2018)] = 68545,
  [SMALL_STATE(2019)] = 68616,
  [SMALL_STATE(2020)] = 68689,
  [SMALL_STATE(2021)] = 68760,
  [SMALL_STATE(2022)] = 68831,
  [SMALL_STATE(2023)] = 68904,
  [SMALL_STATE(2024)] = 68949,
  [SMALL_STATE(2025)] = 68996,
  [SMALL_STATE(2026)] = 69041,
  [SMALL_STATE(2027)] = 69094,
  [SMALL_STATE(2028)] = 69139,
  [SMALL_STATE(2029)] = 69212,
  [SMALL_STATE(2030)] = 69283,
  [SMALL_STATE(2031)] = 69334,
  [SMALL_STATE(2032)] = 69379,
  [SMALL_STATE(2033)] = 69436,
  [SMALL_STATE(2034)] = 69509,
  [SMALL_STATE(2035)] = 69562,
  [SMALL_STATE(2036)] = 69635,
  [SMALL_STATE(2037)] = 69708,
  [SMALL_STATE(2038)] = 69779,
  [SMALL_STATE(2039)] = 69844,
  [SMALL_STATE(2040)] = 69893,
  [SMALL_STATE(2041)] = 69958,
  [SMALL_STATE(2042)] = 70023,
  [SMALL_STATE(2043)] = 70094,
  [SMALL_STATE(2044)] = 70165,
  [SMALL_STATE(2045)] = 70234,
  [SMALL_STATE(2046)] = 70291,
  [SMALL_STATE(2047)] = 70364,
  [SMALL_STATE(2048)] = 70437,
  [SMALL_STATE(2049)] = 70510,
  [SMALL_STATE(2050)] = 70583,
  [SMALL_STATE(2051)] = 70634,
  [SMALL_STATE(2052)] = 70681,
  [SMALL_STATE(2053)] = 70726,
  [SMALL_STATE(2054)] = 70799,
  [SMALL_STATE(2055)] = 70870,
  [SMALL_STATE(2056)] = 70935,
  [SMALL_STATE(2057)] = 70984,
  [SMALL_STATE(2058)] = 71037,
  [SMALL_STATE(2059)] = 71102,
  [SMALL_STATE(2060)] = 71147,
  [SMALL_STATE(2061)] = 71218,
  [SMALL_STATE(2062)] = 71289,
  [SMALL_STATE(2063)] = 71360,
  [SMALL_STATE(2064)] = 71411,
  [SMALL_STATE(2065)] = 71484,
  [SMALL_STATE(2066)] = 71553,
  [SMALL_STATE(2067)] = 71610,
  [SMALL_STATE(2068)] = 71683,
  [SMALL_STATE(2069)] = 71728,
  [SMALL_STATE(2070)] = 71801,
  [SMALL_STATE(2071)] = 71872,
  [SMALL_STATE(2072)] = 71945,
  [SMALL_STATE(2073)] = 72016,
  [SMALL_STATE(2074)] = 72081,
  [SMALL_STATE(2075)] = 72130,
  [SMALL_STATE(2076)] = 72200,
  [SMALL_STATE(2077)] = 72270,
  [SMALL_STATE(2078)] = 72340,
  [SMALL_STATE(2079)] = 72410,
  [SMALL_STATE(2080)] = 72480,
  [SMALL_STATE(2081)] = 72550,
  [SMALL_STATE(2082)] = 72587,
  [SMALL_STATE(2083)] = 72624,
  [SMALL_STATE(2084)] = 72661,
  [SMALL_STATE(2085)] = 72698,
  [SMALL_STATE(2086)] = 72735,
  [SMALL_STATE(2087)] = 72772,
  [SMALL_STATE(2088)] = 72809,
  [SMALL_STATE(2089)] = 72846,
  [SMALL_STATE(2090)] = 72883,
  [SMALL_STATE(2091)] = 72920,
  [SMALL_STATE(2092)] = 72963,
  [SMALL_STATE(2093)] = 73002,
  [SMALL_STATE(2094)] = 73041,
  [SMALL_STATE(2095)] = 73082,
  [SMALL_STATE(2096)] = 73119,
  [SMALL_STATE(2097)] = 73153,
  [SMALL_STATE(2098)] = 73187,
  [SMALL_STATE(2099)] = 73220,
  [SMALL_STATE(2100)] = 73255,
  [SMALL_STATE(2101)] = 73288,
  [SMALL_STATE(2102)] = 73323,
  [SMALL_STATE(2103)] = 73356,
  [SMALL_STATE(2104)] = 73391,
  [SMALL_STATE(2105)] = 73428,
  [SMALL_STATE(2106)] = 73463,
  [SMALL_STATE(2107)] = 73498,
  [SMALL_STATE(2108)] = 73533,
  [SMALL_STATE(2109)] = 73568,
  [SMALL_STATE(2110)] = 73605,
  [SMALL_STATE(2111)] = 73636,
  [SMALL_STATE(2112)] = 73667,
  [SMALL_STATE(2113)] = 73698,
  [SMALL_STATE(2114)] = 73729,
  [SMALL_STATE(2115)] = 73760,
  [SMALL_STATE(2116)] = 73791,
  [SMALL_STATE(2117)] = 73822,
  [SMALL_STATE(2118)] = 73853,
  [SMALL_STATE(2119)] = 73883,
  [SMALL_STATE(2120)] = 73913,
  [SMALL_STATE(2121)] = 73944,
  [SMALL_STATE(2122)] = 73973,
  [SMALL_STATE(2123)] = 74002,
  [SMALL_STATE(2124)] = 74031,
  [SMALL_STATE(2125)] = 74062,
  [SMALL_STATE(2126)] = 74093,
  [SMALL_STATE(2127)] = 74122,
  [SMALL_STATE(2128)] = 74171,
  [SMALL_STATE(2129)] = 74220,
  [SMALL_STATE(2130)] = 74251,
  [SMALL_STATE(2131)] = 74280,
  [SMALL_STATE(2132)] = 74313,
  [SMALL_STATE(2133)] = 74344,
  [SMALL_STATE(2134)] = 74377,
  [SMALL_STATE(2135)] = 74408,
  [SMALL_STATE(2136)] = 74439,
  [SMALL_STATE(2137)] = 74488,
  [SMALL_STATE(2138)] = 74517,
  [SMALL_STATE(2139)] = 74548,
  [SMALL_STATE(2140)] = 74598,
  [SMALL_STATE(2141)] = 74646,
  [SMALL_STATE(2142)] = 74694,
  [SMALL_STATE(2143)] = 74744,
  [SMALL_STATE(2144)] = 74792,
  [SMALL_STATE(2145)] = 74838,
  [SMALL_STATE(2146)] = 74885,
  [SMALL_STATE(2147)] = 74932,
  [SMALL_STATE(2148)] = 74979,
  [SMALL_STATE(2149)] = 75024,
  [SMALL_STATE(2150)] = 75071,
  [SMALL_STATE(2151)] = 75112,
  [SMALL_STATE(2152)] = 75159,
  [SMALL_STATE(2153)] = 75206,
  [SMALL_STATE(2154)] = 75247,
  [SMALL_STATE(2155)] = 75294,
  [SMALL_STATE(2156)] = 75338,
  [SMALL_STATE(2157)] = 75382,
  [SMALL_STATE(2158)] = 75426,
  [SMALL_STATE(2159)] = 75470,
  [SMALL_STATE(2160)] = 75514,
  [SMALL_STATE(2161)] = 75558,
  [SMALL_STATE(2162)] = 75602,
  [SMALL_STATE(2163)] = 75640,
  [SMALL_STATE(2164)] = 75681,
  [SMALL_STATE(2165)] = 75722,
  [SMALL_STATE(2166)] = 75763,
  [SMALL_STATE(2167)] = 75804,
  [SMALL_STATE(2168)] = 75841,
  [SMALL_STATE(2169)] = 75882,
  [SMALL_STATE(2170)] = 75914,
  [SMALL_STATE(2171)] = 75946,
  [SMALL_STATE(2172)] = 75978,
  [SMALL_STATE(2173)] = 76010,
  [SMALL_STATE(2174)] = 76034,
  [SMALL_STATE(2175)] = 76058,
  [SMALL_STATE(2176)] = 76087,
  [SMALL_STATE(2177)] = 76114,
  [SMALL_STATE(2178)] = 76143,
  [SMALL_STATE(2179)] = 76168,
  [SMALL_STATE(2180)] = 76193,
  [SMALL_STATE(2181)] = 76220,
  [SMALL_STATE(2182)] = 76245,
  [SMALL_STATE(2183)] = 76270,
  [SMALL_STATE(2184)] = 76295,
  [SMALL_STATE(2185)] = 76320,
  [SMALL_STATE(2186)] = 76345,
  [SMALL_STATE(2187)] = 76370,
  [SMALL_STATE(2188)] = 76397,
  [SMALL_STATE(2189)] = 76426,
  [SMALL_STATE(2190)] = 76455,
  [SMALL_STATE(2191)] = 76478,
  [SMALL_STATE(2192)] = 76507,
  [SMALL_STATE(2193)] = 76532,
  [SMALL_STATE(2194)] = 76555,
  [SMALL_STATE(2195)] = 76586,
  [SMALL_STATE(2196)] = 76609,
  [SMALL_STATE(2197)] = 76632,
  [SMALL_STATE(2198)] = 76655,
  [SMALL_STATE(2199)] = 76678,
  [SMALL_STATE(2200)] = 76701,
  [SMALL_STATE(2201)] = 76724,
  [SMALL_STATE(2202)] = 76749,
  [SMALL_STATE(2203)] = 76771,
  [SMALL_STATE(2204)] = 76793,
  [SMALL_STATE(2205)] = 76831,
  [SMALL_STATE(2206)] = 76869,
  [SMALL_STATE(2207)] = 76895,
  [SMALL_STATE(2208)] = 76915,
  [SMALL_STATE(2209)] = 76943,
  [SMALL_STATE(2210)] = 76981,
  [SMALL_STATE(2211)] = 77003,
  [SMALL_STATE(2212)] = 77025,
  [SMALL_STATE(2213)] = 77063,
  [SMALL_STATE(2214)] = 77101,
  [SMALL_STATE(2215)] = 77139,
  [SMALL_STATE(2216)] = 77161,
  [SMALL_STATE(2217)] = 77183,
  [SMALL_STATE(2218)] = 77205,
  [SMALL_STATE(2219)] = 77227,
  [SMALL_STATE(2220)] = 77263,
  [SMALL_STATE(2221)] = 77299,
  [SMALL_STATE(2222)] = 77337,
  [SMALL_STATE(2223)] = 77359,
  [SMALL_STATE(2224)] = 77378,
  [SMALL_STATE(2225)] = 77399,
  [SMALL_STATE(2226)] = 77418,
  [SMALL_STATE(2227)] = 77437,
  [SMALL_STATE(2228)] = 77456,
  [SMALL_STATE(2229)] = 77475,
  [SMALL_STATE(2230)] = 77498,
  [SMALL_STATE(2231)] = 77517,
  [SMALL_STATE(2232)] = 77536,
  [SMALL_STATE(2233)] = 77561,
  [SMALL_STATE(2234)] = 77580,
  [SMALL_STATE(2235)] = 77599,
  [SMALL_STATE(2236)] = 77618,
  [SMALL_STATE(2237)] = 77637,
  [SMALL_STATE(2238)] = 77656,
  [SMALL_STATE(2239)] = 77679,
  [SMALL_STATE(2240)] = 77714,
  [SMALL_STATE(2241)] = 77749,
  [SMALL_STATE(2242)] = 77779,
  [SMALL_STATE(2243)] = 77809,
  [SMALL_STATE(2244)] = 77839,
  [SMALL_STATE(2245)] = 77871,
  [SMALL_STATE(2246)] = 77905,
  [SMALL_STATE(2247)] = 77925,
  [SMALL_STATE(2248)] = 77959,
  [SMALL_STATE(2249)] = 77989,
  [SMALL_STATE(2250)] = 78019,
  [SMALL_STATE(2251)] = 78053,
  [SMALL_STATE(2252)] = 78087,
  [SMALL_STATE(2253)] = 78121,
  [SMALL_STATE(2254)] = 78141,
  [SMALL_STATE(2255)] = 78161,
  [SMALL_STATE(2256)] = 78181,
  [SMALL_STATE(2257)] = 78211,
  [SMALL_STATE(2258)] = 78239,
  [SMALL_STATE(2259)] = 78259,
  [SMALL_STATE(2260)] = 78279,
  [SMALL_STATE(2261)] = 78309,
  [SMALL_STATE(2262)] = 78343,
  [SMALL_STATE(2263)] = 78373,
  [SMALL_STATE(2264)] = 78393,
  [SMALL_STATE(2265)] = 78413,
  [SMALL_STATE(2266)] = 78447,
  [SMALL_STATE(2267)] = 78467,
  [SMALL_STATE(2268)] = 78487,
  [SMALL_STATE(2269)] = 78507,
  [SMALL_STATE(2270)] = 78541,
  [SMALL_STATE(2271)] = 78571,
  [SMALL_STATE(2272)] = 78593,
  [SMALL_STATE(2273)] = 78627,
  [SMALL_STATE(2274)] = 78659,
  [SMALL_STATE(2275)] = 78689,
  [SMALL_STATE(2276)] = 78719,
  [SMALL_STATE(2277)] = 78739,
  [SMALL_STATE(2278)] = 78773,
  [SMALL_STATE(2279)] = 78807,
  [SMALL_STATE(2280)] = 78827,
  [SMALL_STATE(2281)] = 78857,
  [SMALL_STATE(2282)] = 78891,
  [SMALL_STATE(2283)] = 78925,
  [SMALL_STATE(2284)] = 78955,
  [SMALL_STATE(2285)] = 78985,
  [SMALL_STATE(2286)] = 79019,
  [SMALL_STATE(2287)] = 79041,
  [SMALL_STATE(2288)] = 79075,
  [SMALL_STATE(2289)] = 79105,
  [SMALL_STATE(2290)] = 79135,
  [SMALL_STATE(2291)] = 79159,
  [SMALL_STATE(2292)] = 79193,
  [SMALL_STATE(2293)] = 79223,
  [SMALL_STATE(2294)] = 79257,
  [SMALL_STATE(2295)] = 79277,
  [SMALL_STATE(2296)] = 79311,
  [SMALL_STATE(2297)] = 79331,
  [SMALL_STATE(2298)] = 79351,
  [SMALL_STATE(2299)] = 79371,
  [SMALL_STATE(2300)] = 79391,
  [SMALL_STATE(2301)] = 79411,
  [SMALL_STATE(2302)] = 79445,
  [SMALL_STATE(2303)] = 79465,
  [SMALL_STATE(2304)] = 79495,
  [SMALL_STATE(2305)] = 79525,
  [SMALL_STATE(2306)] = 79555,
  [SMALL_STATE(2307)] = 79585,
  [SMALL_STATE(2308)] = 79619,
  [SMALL_STATE(2309)] = 79649,
  [SMALL_STATE(2310)] = 79683,
  [SMALL_STATE(2311)] = 79717,
  [SMALL_STATE(2312)] = 79751,
  [SMALL_STATE(2313)] = 79785,
  [SMALL_STATE(2314)] = 79815,
  [SMALL_STATE(2315)] = 79845,
  [SMALL_STATE(2316)] = 79864,
  [SMALL_STATE(2317)] = 79891,
  [SMALL_STATE(2318)] = 79918,
  [SMALL_STATE(2319)] = 79945,
  [SMALL_STATE(2320)] = 79974,
  [SMALL_STATE(2321)] = 79995,
  [SMALL_STATE(2322)] = 80020,
  [SMALL_STATE(2323)] = 80047,
  [SMALL_STATE(2324)] = 80078,
  [SMALL_STATE(2325)] = 80099,
  [SMALL_STATE(2326)] = 80116,
  [SMALL_STATE(2327)] = 80133,
  [SMALL_STATE(2328)] = 80152,
  [SMALL_STATE(2329)] = 80171,
  [SMALL_STATE(2330)] = 80190,
  [SMALL_STATE(2331)] = 80209,
  [SMALL_STATE(2332)] = 80228,
  [SMALL_STATE(2333)] = 80247,
  [SMALL_STATE(2334)] = 80270,
  [SMALL_STATE(2335)] = 80287,
  [SMALL_STATE(2336)] = 80316,
  [SMALL_STATE(2337)] = 80343,
  [SMALL_STATE(2338)] = 80374,
  [SMALL_STATE(2339)] = 80405,
  [SMALL_STATE(2340)] = 80436,
  [SMALL_STATE(2341)] = 80467,
  [SMALL_STATE(2342)] = 80494,
  [SMALL_STATE(2343)] = 80521,
  [SMALL_STATE(2344)] = 80552,
  [SMALL_STATE(2345)] = 80583,
  [SMALL_STATE(2346)] = 80614,
  [SMALL_STATE(2347)] = 80645,
  [SMALL_STATE(2348)] = 80668,
  [SMALL_STATE(2349)] = 80695,
  [SMALL_STATE(2350)] = 80722,
  [SMALL_STATE(2351)] = 80751,
  [SMALL_STATE(2352)] = 80782,
  [SMALL_STATE(2353)] = 80813,
  [SMALL_STATE(2354)] = 80844,
  [SMALL_STATE(2355)] = 80871,
  [SMALL_STATE(2356)] = 80890,
  [SMALL_STATE(2357)] = 80911,
  [SMALL_STATE(2358)] = 80938,
  [SMALL_STATE(2359)] = 80961,
  [SMALL_STATE(2360)] = 80988,
  [SMALL_STATE(2361)] = 81007,
  [SMALL_STATE(2362)] = 81026,
  [SMALL_STATE(2363)] = 81045,
  [SMALL_STATE(2364)] = 81064,
  [SMALL_STATE(2365)] = 81095,
  [SMALL_STATE(2366)] = 81114,
  [SMALL_STATE(2367)] = 81131,
  [SMALL_STATE(2368)] = 81150,
  [SMALL_STATE(2369)] = 81169,
  [SMALL_STATE(2370)] = 81188,
  [SMALL_STATE(2371)] = 81207,
  [SMALL_STATE(2372)] = 81224,
  [SMALL_STATE(2373)] = 81253,
  [SMALL_STATE(2374)] = 81270,
  [SMALL_STATE(2375)] = 81295,
  [SMALL_STATE(2376)] = 81312,
  [SMALL_STATE(2377)] = 81343,
  [SMALL_STATE(2378)] = 81374,
  [SMALL_STATE(2379)] = 81405,
  [SMALL_STATE(2380)] = 81436,
  [SMALL_STATE(2381)] = 81467,
  [SMALL_STATE(2382)] = 81498,
  [SMALL_STATE(2383)] = 81529,
  [SMALL_STATE(2384)] = 81560,
  [SMALL_STATE(2385)] = 81585,
  [SMALL_STATE(2386)] = 81604,
  [SMALL_STATE(2387)] = 81635,
  [SMALL_STATE(2388)] = 81661,
  [SMALL_STATE(2389)] = 81689,
  [SMALL_STATE(2390)] = 81715,
  [SMALL_STATE(2391)] = 81741,
  [SMALL_STATE(2392)] = 81757,
  [SMALL_STATE(2393)] = 81785,
  [SMALL_STATE(2394)] = 81803,
  [SMALL_STATE(2395)] = 81831,
  [SMALL_STATE(2396)] = 81859,
  [SMALL_STATE(2397)] = 81885,
  [SMALL_STATE(2398)] = 81911,
  [SMALL_STATE(2399)] = 81937,
  [SMALL_STATE(2400)] = 81965,
  [SMALL_STATE(2401)] = 81991,
  [SMALL_STATE(2402)] = 82019,
  [SMALL_STATE(2403)] = 82045,
  [SMALL_STATE(2404)] = 82063,
  [SMALL_STATE(2405)] = 82089,
  [SMALL_STATE(2406)] = 82115,
  [SMALL_STATE(2407)] = 82141,
  [SMALL_STATE(2408)] = 82167,
  [SMALL_STATE(2409)] = 82193,
  [SMALL_STATE(2410)] = 82221,
  [SMALL_STATE(2411)] = 82247,
  [SMALL_STATE(2412)] = 82273,
  [SMALL_STATE(2413)] = 82299,
  [SMALL_STATE(2414)] = 82325,
  [SMALL_STATE(2415)] = 82353,
  [SMALL_STATE(2416)] = 82379,
  [SMALL_STATE(2417)] = 82395,
  [SMALL_STATE(2418)] = 82421,
  [SMALL_STATE(2419)] = 82447,
  [SMALL_STATE(2420)] = 82463,
  [SMALL_STATE(2421)] = 82479,
  [SMALL_STATE(2422)] = 82505,
  [SMALL_STATE(2423)] = 82531,
  [SMALL_STATE(2424)] = 82557,
  [SMALL_STATE(2425)] = 82583,
  [SMALL_STATE(2426)] = 82611,
  [SMALL_STATE(2427)] = 82637,
  [SMALL_STATE(2428)] = 82665,
  [SMALL_STATE(2429)] = 82691,
  [SMALL_STATE(2430)] = 82717,
  [SMALL_STATE(2431)] = 82743,
  [SMALL_STATE(2432)] = 82769,
  [SMALL_STATE(2433)] = 82795,
  [SMALL_STATE(2434)] = 82813,
  [SMALL_STATE(2435)] = 82839,
  [SMALL_STATE(2436)] = 82865,
  [SMALL_STATE(2437)] = 82891,
  [SMALL_STATE(2438)] = 82917,
  [SMALL_STATE(2439)] = 82933,
  [SMALL_STATE(2440)] = 82961,
  [SMALL_STATE(2441)] = 82985,
  [SMALL_STATE(2442)] = 83005,
  [SMALL_STATE(2443)] = 83031,
  [SMALL_STATE(2444)] = 83059,
  [SMALL_STATE(2445)] = 83087,
  [SMALL_STATE(2446)] = 83113,
  [SMALL_STATE(2447)] = 83139,
  [SMALL_STATE(2448)] = 83157,
  [SMALL_STATE(2449)] = 83183,
  [SMALL_STATE(2450)] = 83209,
  [SMALL_STATE(2451)] = 83227,
  [SMALL_STATE(2452)] = 83253,
  [SMALL_STATE(2453)] = 83279,
  [SMALL_STATE(2454)] = 83305,
  [SMALL_STATE(2455)] = 83331,
  [SMALL_STATE(2456)] = 83357,
  [SMALL_STATE(2457)] = 83383,
  [SMALL_STATE(2458)] = 83411,
  [SMALL_STATE(2459)] = 83429,
  [SMALL_STATE(2460)] = 83457,
  [SMALL_STATE(2461)] = 83475,
  [SMALL_STATE(2462)] = 83501,
  [SMALL_STATE(2463)] = 83517,
  [SMALL_STATE(2464)] = 83543,
  [SMALL_STATE(2465)] = 83569,
  [SMALL_STATE(2466)] = 83595,
  [SMALL_STATE(2467)] = 83617,
  [SMALL_STATE(2468)] = 83635,
  [SMALL_STATE(2469)] = 83657,
  [SMALL_STATE(2470)] = 83675,
  [SMALL_STATE(2471)] = 83701,
  [SMALL_STATE(2472)] = 83723,
  [SMALL_STATE(2473)] = 83741,
  [SMALL_STATE(2474)] = 83763,
  [SMALL_STATE(2475)] = 83785,
  [SMALL_STATE(2476)] = 83803,
  [SMALL_STATE(2477)] = 83821,
  [SMALL_STATE(2478)] = 83847,
  [SMALL_STATE(2479)] = 83873,
  [SMALL_STATE(2480)] = 83895,
  [SMALL_STATE(2481)] = 83923,
  [SMALL_STATE(2482)] = 83949,
  [SMALL_STATE(2483)] = 83971,
  [SMALL_STATE(2484)] = 83997,
  [SMALL_STATE(2485)] = 84023,
  [SMALL_STATE(2486)] = 84051,
  [SMALL_STATE(2487)] = 84073,
  [SMALL_STATE(2488)] = 84099,
  [SMALL_STATE(2489)] = 84127,
  [SMALL_STATE(2490)] = 84150,
  [SMALL_STATE(2491)] = 84173,
  [SMALL_STATE(2492)] = 84196,
  [SMALL_STATE(2493)] = 84215,
  [SMALL_STATE(2494)] = 84238,
  [SMALL_STATE(2495)] = 84261,
  [SMALL_STATE(2496)] = 84284,
  [SMALL_STATE(2497)] = 84307,
  [SMALL_STATE(2498)] = 84330,
  [SMALL_STATE(2499)] = 84353,
  [SMALL_STATE(2500)] = 84370,
  [SMALL_STATE(2501)] = 84387,
  [SMALL_STATE(2502)] = 84410,
  [SMALL_STATE(2503)] = 84429,
  [SMALL_STATE(2504)] = 84446,
  [SMALL_STATE(2505)] = 84467,
  [SMALL_STATE(2506)] = 84490,
  [SMALL_STATE(2507)] = 84513,
  [SMALL_STATE(2508)] = 84536,
  [SMALL_STATE(2509)] = 84559,
  [SMALL_STATE(2510)] = 84580,
  [SMALL_STATE(2511)] = 84603,
  [SMALL_STATE(2512)] = 84624,
  [SMALL_STATE(2513)] = 84647,
  [SMALL_STATE(2514)] = 84668,
  [SMALL_STATE(2515)] = 84687,
  [SMALL_STATE(2516)] = 84710,
  [SMALL_STATE(2517)] = 84725,
  [SMALL_STATE(2518)] = 84740,
  [SMALL_STATE(2519)] = 84763,
  [SMALL_STATE(2520)] = 84782,
  [SMALL_STATE(2521)] = 84805,
  [SMALL_STATE(2522)] = 84828,
  [SMALL_STATE(2523)] = 84849,
  [SMALL_STATE(2524)] = 84864,
  [SMALL_STATE(2525)] = 84889,
  [SMALL_STATE(2526)] = 84908,
  [SMALL_STATE(2527)] = 84931,
  [SMALL_STATE(2528)] = 84954,
  [SMALL_STATE(2529)] = 84977,
  [SMALL_STATE(2530)] = 84994,
  [SMALL_STATE(2531)] = 85013,
  [SMALL_STATE(2532)] = 85036,
  [SMALL_STATE(2533)] = 85057,
  [SMALL_STATE(2534)] = 85076,
  [SMALL_STATE(2535)] = 85099,
  [SMALL_STATE(2536)] = 85122,
  [SMALL_STATE(2537)] = 85145,
  [SMALL_STATE(2538)] = 85160,
  [SMALL_STATE(2539)] = 85185,
  [SMALL_STATE(2540)] = 85206,
  [SMALL_STATE(2541)] = 85221,
  [SMALL_STATE(2542)] = 85244,
  [SMALL_STATE(2543)] = 85267,
  [SMALL_STATE(2544)] = 85290,
  [SMALL_STATE(2545)] = 85313,
  [SMALL_STATE(2546)] = 85334,
  [SMALL_STATE(2547)] = 85357,
  [SMALL_STATE(2548)] = 85382,
  [SMALL_STATE(2549)] = 85407,
  [SMALL_STATE(2550)] = 85432,
  [SMALL_STATE(2551)] = 85448,
  [SMALL_STATE(2552)] = 85464,
  [SMALL_STATE(2553)] = 85480,
  [SMALL_STATE(2554)] = 85496,
  [SMALL_STATE(2555)] = 85512,
  [SMALL_STATE(2556)] = 85528,
  [SMALL_STATE(2557)] = 85544,
  [SMALL_STATE(2558)] = 85560,
  [SMALL_STATE(2559)] = 85580,
  [SMALL_STATE(2560)] = 85600,
  [SMALL_STATE(2561)] = 85620,
  [SMALL_STATE(2562)] = 85638,
  [SMALL_STATE(2563)] = 85658,
  [SMALL_STATE(2564)] = 85674,
  [SMALL_STATE(2565)] = 85690,
  [SMALL_STATE(2566)] = 85706,
  [SMALL_STATE(2567)] = 85722,
  [SMALL_STATE(2568)] = 85740,
  [SMALL_STATE(2569)] = 85756,
  [SMALL_STATE(2570)] = 85774,
  [SMALL_STATE(2571)] = 85790,
  [SMALL_STATE(2572)] = 85806,
  [SMALL_STATE(2573)] = 85822,
  [SMALL_STATE(2574)] = 85838,
  [SMALL_STATE(2575)] = 85858,
  [SMALL_STATE(2576)] = 85874,
  [SMALL_STATE(2577)] = 85890,
  [SMALL_STATE(2578)] = 85906,
  [SMALL_STATE(2579)] = 85922,
  [SMALL_STATE(2580)] = 85942,
  [SMALL_STATE(2581)] = 85958,
  [SMALL_STATE(2582)] = 85978,
  [SMALL_STATE(2583)] = 85994,
  [SMALL_STATE(2584)] = 86010,
  [SMALL_STATE(2585)] = 86028,
  [SMALL_STATE(2586)] = 86044,
  [SMALL_STATE(2587)] = 86060,
  [SMALL_STATE(2588)] = 86076,
  [SMALL_STATE(2589)] = 86096,
  [SMALL_STATE(2590)] = 86116,
  [SMALL_STATE(2591)] = 86136,
  [SMALL_STATE(2592)] = 86152,
  [SMALL_STATE(2593)] = 86168,
  [SMALL_STATE(2594)] = 86184,
  [SMALL_STATE(2595)] = 86204,
  [SMALL_STATE(2596)] = 86220,
  [SMALL_STATE(2597)] = 86242,
  [SMALL_STATE(2598)] = 86260,
  [SMALL_STATE(2599)] = 86280,
  [SMALL_STATE(2600)] = 86296,
  [SMALL_STATE(2601)] = 86312,
  [SMALL_STATE(2602)] = 86332,
  [SMALL_STATE(2603)] = 86348,
  [SMALL_STATE(2604)] = 86364,
  [SMALL_STATE(2605)] = 86380,
  [SMALL_STATE(2606)] = 86396,
  [SMALL_STATE(2607)] = 86412,
  [SMALL_STATE(2608)] = 86428,
  [SMALL_STATE(2609)] = 86444,
  [SMALL_STATE(2610)] = 86466,
  [SMALL_STATE(2611)] = 86482,
  [SMALL_STATE(2612)] = 86498,
  [SMALL_STATE(2613)] = 86514,
  [SMALL_STATE(2614)] = 86530,
  [SMALL_STATE(2615)] = 86546,
  [SMALL_STATE(2616)] = 86562,
  [SMALL_STATE(2617)] = 86578,
  [SMALL_STATE(2618)] = 86594,
  [SMALL_STATE(2619)] = 86616,
  [SMALL_STATE(2620)] = 86634,
  [SMALL_STATE(2621)] = 86654,
  [SMALL_STATE(2622)] = 86674,
  [SMALL_STATE(2623)] = 86690,
  [SMALL_STATE(2624)] = 86706,
  [SMALL_STATE(2625)] = 86722,
  [SMALL_STATE(2626)] = 86738,
  [SMALL_STATE(2627)] = 86754,
  [SMALL_STATE(2628)] = 86772,
  [SMALL_STATE(2629)] = 86788,
  [SMALL_STATE(2630)] = 86810,
  [SMALL_STATE(2631)] = 86828,
  [SMALL_STATE(2632)] = 86844,
  [SMALL_STATE(2633)] = 86860,
  [SMALL_STATE(2634)] = 86876,
  [SMALL_STATE(2635)] = 86892,
  [SMALL_STATE(2636)] = 86908,
  [SMALL_STATE(2637)] = 86924,
  [SMALL_STATE(2638)] = 86940,
  [SMALL_STATE(2639)] = 86956,
  [SMALL_STATE(2640)] = 86972,
  [SMALL_STATE(2641)] = 86992,
  [SMALL_STATE(2642)] = 87008,
  [SMALL_STATE(2643)] = 87024,
  [SMALL_STATE(2644)] = 87040,
  [SMALL_STATE(2645)] = 87056,
  [SMALL_STATE(2646)] = 87072,
  [SMALL_STATE(2647)] = 87088,
  [SMALL_STATE(2648)] = 87104,
  [SMALL_STATE(2649)] = 87120,
  [SMALL_STATE(2650)] = 87136,
  [SMALL_STATE(2651)] = 87152,
  [SMALL_STATE(2652)] = 87168,
  [SMALL_STATE(2653)] = 87184,
  [SMALL_STATE(2654)] = 87200,
  [SMALL_STATE(2655)] = 87216,
  [SMALL_STATE(2656)] = 87232,
  [SMALL_STATE(2657)] = 87248,
  [SMALL_STATE(2658)] = 87264,
  [SMALL_STATE(2659)] = 87280,
  [SMALL_STATE(2660)] = 87296,
  [SMALL_STATE(2661)] = 87312,
  [SMALL_STATE(2662)] = 87328,
  [SMALL_STATE(2663)] = 87344,
  [SMALL_STATE(2664)] = 87360,
  [SMALL_STATE(2665)] = 87376,
  [SMALL_STATE(2666)] = 87392,
  [SMALL_STATE(2667)] = 87408,
  [SMALL_STATE(2668)] = 87424,
  [SMALL_STATE(2669)] = 87443,
  [SMALL_STATE(2670)] = 87460,
  [SMALL_STATE(2671)] = 87479,
  [SMALL_STATE(2672)] = 87496,
  [SMALL_STATE(2673)] = 87513,
  [SMALL_STATE(2674)] = 87532,
  [SMALL_STATE(2675)] = 87549,
  [SMALL_STATE(2676)] = 87564,
  [SMALL_STATE(2677)] = 87583,
  [SMALL_STATE(2678)] = 87602,
  [SMALL_STATE(2679)] = 87621,
  [SMALL_STATE(2680)] = 87638,
  [SMALL_STATE(2681)] = 87653,
  [SMALL_STATE(2682)] = 87672,
  [SMALL_STATE(2683)] = 87691,
  [SMALL_STATE(2684)] = 87710,
  [SMALL_STATE(2685)] = 87729,
  [SMALL_STATE(2686)] = 87748,
  [SMALL_STATE(2687)] = 87767,
  [SMALL_STATE(2688)] = 87786,
  [SMALL_STATE(2689)] = 87805,
  [SMALL_STATE(2690)] = 87824,
  [SMALL_STATE(2691)] = 87841,
  [SMALL_STATE(2692)] = 87856,
  [SMALL_STATE(2693)] = 87871,
  [SMALL_STATE(2694)] = 87890,
  [SMALL_STATE(2695)] = 87905,
  [SMALL_STATE(2696)] = 87924,
  [SMALL_STATE(2697)] = 87943,
  [SMALL_STATE(2698)] = 87960,
  [SMALL_STATE(2699)] = 87979,
  [SMALL_STATE(2700)] = 87996,
  [SMALL_STATE(2701)] = 88015,
  [SMALL_STATE(2702)] = 88034,
  [SMALL_STATE(2703)] = 88053,
  [SMALL_STATE(2704)] = 88070,
  [SMALL_STATE(2705)] = 88089,
  [SMALL_STATE(2706)] = 88108,
  [SMALL_STATE(2707)] = 88127,
  [SMALL_STATE(2708)] = 88146,
  [SMALL_STATE(2709)] = 88165,
  [SMALL_STATE(2710)] = 88184,
  [SMALL_STATE(2711)] = 88203,
  [SMALL_STATE(2712)] = 88222,
  [SMALL_STATE(2713)] = 88237,
  [SMALL_STATE(2714)] = 88252,
  [SMALL_STATE(2715)] = 88267,
  [SMALL_STATE(2716)] = 88286,
  [SMALL_STATE(2717)] = 88301,
  [SMALL_STATE(2718)] = 88318,
  [SMALL_STATE(2719)] = 88337,
  [SMALL_STATE(2720)] = 88356,
  [SMALL_STATE(2721)] = 88375,
  [SMALL_STATE(2722)] = 88394,
  [SMALL_STATE(2723)] = 88413,
  [SMALL_STATE(2724)] = 88432,
  [SMALL_STATE(2725)] = 88447,
  [SMALL_STATE(2726)] = 88466,
  [SMALL_STATE(2727)] = 88485,
  [SMALL_STATE(2728)] = 88502,
  [SMALL_STATE(2729)] = 88517,
  [SMALL_STATE(2730)] = 88532,
  [SMALL_STATE(2731)] = 88551,
  [SMALL_STATE(2732)] = 88566,
  [SMALL_STATE(2733)] = 88583,
  [SMALL_STATE(2734)] = 88598,
  [SMALL_STATE(2735)] = 88613,
  [SMALL_STATE(2736)] = 88628,
  [SMALL_STATE(2737)] = 88644,
  [SMALL_STATE(2738)] = 88658,
  [SMALL_STATE(2739)] = 88674,
  [SMALL_STATE(2740)] = 88688,
  [SMALL_STATE(2741)] = 88702,
  [SMALL_STATE(2742)] = 88716,
  [SMALL_STATE(2743)] = 88730,
  [SMALL_STATE(2744)] = 88744,
  [SMALL_STATE(2745)] = 88758,
  [SMALL_STATE(2746)] = 88772,
  [SMALL_STATE(2747)] = 88786,
  [SMALL_STATE(2748)] = 88800,
  [SMALL_STATE(2749)] = 88816,
  [SMALL_STATE(2750)] = 88832,
  [SMALL_STATE(2751)] = 88846,
  [SMALL_STATE(2752)] = 88860,
  [SMALL_STATE(2753)] = 88874,
  [SMALL_STATE(2754)] = 88888,
  [SMALL_STATE(2755)] = 88902,
  [SMALL_STATE(2756)] = 88918,
  [SMALL_STATE(2757)] = 88932,
  [SMALL_STATE(2758)] = 88946,
  [SMALL_STATE(2759)] = 88962,
  [SMALL_STATE(2760)] = 88976,
  [SMALL_STATE(2761)] = 88990,
  [SMALL_STATE(2762)] = 89004,
  [SMALL_STATE(2763)] = 89018,
  [SMALL_STATE(2764)] = 89034,
  [SMALL_STATE(2765)] = 89048,
  [SMALL_STATE(2766)] = 89062,
  [SMALL_STATE(2767)] = 89076,
  [SMALL_STATE(2768)] = 89092,
  [SMALL_STATE(2769)] = 89108,
  [SMALL_STATE(2770)] = 89124,
  [SMALL_STATE(2771)] = 89138,
  [SMALL_STATE(2772)] = 89154,
  [SMALL_STATE(2773)] = 89168,
  [SMALL_STATE(2774)] = 89182,
  [SMALL_STATE(2775)] = 89196,
  [SMALL_STATE(2776)] = 89210,
  [SMALL_STATE(2777)] = 89226,
  [SMALL_STATE(2778)] = 89240,
  [SMALL_STATE(2779)] = 89256,
  [SMALL_STATE(2780)] = 89270,
  [SMALL_STATE(2781)] = 89286,
  [SMALL_STATE(2782)] = 89300,
  [SMALL_STATE(2783)] = 89313,
  [SMALL_STATE(2784)] = 89326,
  [SMALL_STATE(2785)] = 89339,
  [SMALL_STATE(2786)] = 89352,
  [SMALL_STATE(2787)] = 89363,
  [SMALL_STATE(2788)] = 89376,
  [SMALL_STATE(2789)] = 89389,
  [SMALL_STATE(2790)] = 89402,
  [SMALL_STATE(2791)] = 89415,
  [SMALL_STATE(2792)] = 89428,
  [SMALL_STATE(2793)] = 89441,
  [SMALL_STATE(2794)] = 89454,
  [SMALL_STATE(2795)] = 89467,
  [SMALL_STATE(2796)] = 89480,
  [SMALL_STATE(2797)] = 89493,
  [SMALL_STATE(2798)] = 89506,
  [SMALL_STATE(2799)] = 89519,
  [SMALL_STATE(2800)] = 89532,
  [SMALL_STATE(2801)] = 89545,
  [SMALL_STATE(2802)] = 89558,
  [SMALL_STATE(2803)] = 89571,
  [SMALL_STATE(2804)] = 89582,
  [SMALL_STATE(2805)] = 89595,
  [SMALL_STATE(2806)] = 89608,
  [SMALL_STATE(2807)] = 89621,
  [SMALL_STATE(2808)] = 89634,
  [SMALL_STATE(2809)] = 89647,
  [SMALL_STATE(2810)] = 89660,
  [SMALL_STATE(2811)] = 89673,
  [SMALL_STATE(2812)] = 89686,
  [SMALL_STATE(2813)] = 89699,
  [SMALL_STATE(2814)] = 89712,
  [SMALL_STATE(2815)] = 89725,
  [SMALL_STATE(2816)] = 89738,
  [SMALL_STATE(2817)] = 89749,
  [SMALL_STATE(2818)] = 89762,
  [SMALL_STATE(2819)] = 89775,
  [SMALL_STATE(2820)] = 89788,
  [SMALL_STATE(2821)] = 89801,
  [SMALL_STATE(2822)] = 89814,
  [SMALL_STATE(2823)] = 89827,
  [SMALL_STATE(2824)] = 89840,
  [SMALL_STATE(2825)] = 89853,
  [SMALL_STATE(2826)] = 89866,
  [SMALL_STATE(2827)] = 89877,
  [SMALL_STATE(2828)] = 89890,
  [SMALL_STATE(2829)] = 89903,
  [SMALL_STATE(2830)] = 89916,
  [SMALL_STATE(2831)] = 89929,
  [SMALL_STATE(2832)] = 89942,
  [SMALL_STATE(2833)] = 89955,
  [SMALL_STATE(2834)] = 89968,
  [SMALL_STATE(2835)] = 89981,
  [SMALL_STATE(2836)] = 89994,
  [SMALL_STATE(2837)] = 90007,
  [SMALL_STATE(2838)] = 90020,
  [SMALL_STATE(2839)] = 90033,
  [SMALL_STATE(2840)] = 90046,
  [SMALL_STATE(2841)] = 90059,
  [SMALL_STATE(2842)] = 90072,
  [SMALL_STATE(2843)] = 90085,
  [SMALL_STATE(2844)] = 90098,
  [SMALL_STATE(2845)] = 90111,
  [SMALL_STATE(2846)] = 90124,
  [SMALL_STATE(2847)] = 90137,
  [SMALL_STATE(2848)] = 90150,
  [SMALL_STATE(2849)] = 90163,
  [SMALL_STATE(2850)] = 90176,
  [SMALL_STATE(2851)] = 90189,
  [SMALL_STATE(2852)] = 90202,
  [SMALL_STATE(2853)] = 90215,
  [SMALL_STATE(2854)] = 90228,
  [SMALL_STATE(2855)] = 90241,
  [SMALL_STATE(2856)] = 90254,
  [SMALL_STATE(2857)] = 90267,
  [SMALL_STATE(2858)] = 90280,
  [SMALL_STATE(2859)] = 90293,
  [SMALL_STATE(2860)] = 90306,
  [SMALL_STATE(2861)] = 90319,
  [SMALL_STATE(2862)] = 90330,
  [SMALL_STATE(2863)] = 90343,
  [SMALL_STATE(2864)] = 90356,
  [SMALL_STATE(2865)] = 90369,
  [SMALL_STATE(2866)] = 90382,
  [SMALL_STATE(2867)] = 90395,
  [SMALL_STATE(2868)] = 90408,
  [SMALL_STATE(2869)] = 90421,
  [SMALL_STATE(2870)] = 90434,
  [SMALL_STATE(2871)] = 90445,
  [SMALL_STATE(2872)] = 90458,
  [SMALL_STATE(2873)] = 90471,
  [SMALL_STATE(2874)] = 90484,
  [SMALL_STATE(2875)] = 90497,
  [SMALL_STATE(2876)] = 90510,
  [SMALL_STATE(2877)] = 90523,
  [SMALL_STATE(2878)] = 90536,
  [SMALL_STATE(2879)] = 90549,
  [SMALL_STATE(2880)] = 90560,
  [SMALL_STATE(2881)] = 90573,
  [SMALL_STATE(2882)] = 90586,
  [SMALL_STATE(2883)] = 90597,
  [SMALL_STATE(2884)] = 90610,
  [SMALL_STATE(2885)] = 90623,
  [SMALL_STATE(2886)] = 90636,
  [SMALL_STATE(2887)] = 90649,
  [SMALL_STATE(2888)] = 90662,
  [SMALL_STATE(2889)] = 90675,
  [SMALL_STATE(2890)] = 90688,
  [SMALL_STATE(2891)] = 90701,
  [SMALL_STATE(2892)] = 90714,
  [SMALL_STATE(2893)] = 90727,
  [SMALL_STATE(2894)] = 90740,
  [SMALL_STATE(2895)] = 90753,
  [SMALL_STATE(2896)] = 90766,
  [SMALL_STATE(2897)] = 90779,
  [SMALL_STATE(2898)] = 90792,
  [SMALL_STATE(2899)] = 90805,
  [SMALL_STATE(2900)] = 90818,
  [SMALL_STATE(2901)] = 90831,
  [SMALL_STATE(2902)] = 90844,
  [SMALL_STATE(2903)] = 90857,
  [SMALL_STATE(2904)] = 90870,
  [SMALL_STATE(2905)] = 90883,
  [SMALL_STATE(2906)] = 90896,
  [SMALL_STATE(2907)] = 90909,
  [SMALL_STATE(2908)] = 90922,
  [SMALL_STATE(2909)] = 90935,
  [SMALL_STATE(2910)] = 90948,
  [SMALL_STATE(2911)] = 90961,
  [SMALL_STATE(2912)] = 90974,
  [SMALL_STATE(2913)] = 90987,
  [SMALL_STATE(2914)] = 91000,
  [SMALL_STATE(2915)] = 91013,
  [SMALL_STATE(2916)] = 91026,
  [SMALL_STATE(2917)] = 91039,
  [SMALL_STATE(2918)] = 91050,
  [SMALL_STATE(2919)] = 91063,
  [SMALL_STATE(2920)] = 91074,
  [SMALL_STATE(2921)] = 91087,
  [SMALL_STATE(2922)] = 91100,
  [SMALL_STATE(2923)] = 91107,
  [SMALL_STATE(2924)] = 91111,
  [SMALL_STATE(2925)] = 91115,
  [SMALL_STATE(2926)] = 91119,
  [SMALL_STATE(2927)] = 91123,
  [SMALL_STATE(2928)] = 91127,
  [SMALL_STATE(2929)] = 91131,
  [SMALL_STATE(2930)] = 91135,
  [SMALL_STATE(2931)] = 91139,
  [SMALL_STATE(2932)] = 91143,
  [SMALL_STATE(2933)] = 91147,
  [SMALL_STATE(2934)] = 91151,
  [SMALL_STATE(2935)] = 91155,
  [SMALL_STATE(2936)] = 91159,
  [SMALL_STATE(2937)] = 91163,
  [SMALL_STATE(2938)] = 91167,
  [SMALL_STATE(2939)] = 91171,
  [SMALL_STATE(2940)] = 91175,
  [SMALL_STATE(2941)] = 91179,
  [SMALL_STATE(2942)] = 91183,
  [SMALL_STATE(2943)] = 91187,
  [SMALL_STATE(2944)] = 91191,
  [SMALL_STATE(2945)] = 91195,
  [SMALL_STATE(2946)] = 91199,
  [SMALL_STATE(2947)] = 91203,
  [SMALL_STATE(2948)] = 91207,
  [SMALL_STATE(2949)] = 91211,
  [SMALL_STATE(2950)] = 91215,
  [SMALL_STATE(2951)] = 91219,
  [SMALL_STATE(2952)] = 91223,
  [SMALL_STATE(2953)] = 91227,
  [SMALL_STATE(2954)] = 91231,
  [SMALL_STATE(2955)] = 91235,
  [SMALL_STATE(2956)] = 91239,
  [SMALL_STATE(2957)] = 91243,
  [SMALL_STATE(2958)] = 91247,
  [SMALL_STATE(2959)] = 91251,
  [SMALL_STATE(2960)] = 91255,
  [SMALL_STATE(2961)] = 91259,
  [SMALL_STATE(2962)] = 91263,
  [SMALL_STATE(2963)] = 91267,
  [SMALL_STATE(2964)] = 91271,
  [SMALL_STATE(2965)] = 91275,
  [SMALL_STATE(2966)] = 91279,
  [SMALL_STATE(2967)] = 91283,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2522),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(349),
  [11] = {.count = 1, .reusable = false}, SHIFT(2794),
  [13] = {.count = 1, .reusable = false}, SHIFT(2810),
  [15] = {.count = 1, .reusable = true}, SHIFT(311),
  [17] = {.count = 1, .reusable = false}, SHIFT(2813),
  [19] = {.count = 1, .reusable = false}, SHIFT(1359),
  [21] = {.count = 1, .reusable = true}, SHIFT(190),
  [23] = {.count = 1, .reusable = true}, SHIFT(2770),
  [25] = {.count = 1, .reusable = true}, SHIFT(966),
  [27] = {.count = 1, .reusable = true}, SHIFT(863),
  [29] = {.count = 1, .reusable = false}, SHIFT(867),
  [31] = {.count = 1, .reusable = false}, SHIFT(873),
  [33] = {.count = 1, .reusable = false}, SHIFT(16),
  [35] = {.count = 1, .reusable = false}, SHIFT(15),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = false}, SHIFT(18),
  [41] = {.count = 1, .reusable = false}, SHIFT(1036),
  [43] = {.count = 1, .reusable = false}, SHIFT(1049),
  [45] = {.count = 1, .reusable = false}, SHIFT(211),
  [47] = {.count = 1, .reusable = false}, SHIFT(212),
  [49] = {.count = 1, .reusable = false}, SHIFT(597),
  [51] = {.count = 1, .reusable = false}, SHIFT(669),
  [53] = {.count = 1, .reusable = false}, SHIFT(864),
  [55] = {.count = 1, .reusable = false}, SHIFT(347),
  [57] = {.count = 1, .reusable = false}, SHIFT(47),
  [59] = {.count = 1, .reusable = false}, SHIFT(470),
  [61] = {.count = 1, .reusable = true}, SHIFT(673),
  [63] = {.count = 1, .reusable = false}, SHIFT(675),
  [65] = {.count = 1, .reusable = true}, SHIFT(694),
  [67] = {.count = 1, .reusable = true}, SHIFT(349),
  [69] = {.count = 1, .reusable = false}, SHIFT(1582),
  [71] = {.count = 1, .reusable = false}, SHIFT(1584),
  [73] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [75] = {.count = 1, .reusable = false}, SHIFT(1090),
  [77] = {.count = 1, .reusable = false}, SHIFT(1100),
  [79] = {.count = 1, .reusable = true}, SHIFT(1100),
  [81] = {.count = 1, .reusable = false}, SHIFT(930),
  [83] = {.count = 1, .reusable = false}, SHIFT(935),
  [85] = {.count = 1, .reusable = false}, SHIFT(943),
  [87] = {.count = 1, .reusable = true}, SHIFT(244),
  [89] = {.count = 1, .reusable = true}, SHIFT(2128),
  [91] = {.count = 1, .reusable = true}, SHIFT(1144),
  [93] = {.count = 1, .reusable = true}, SHIFT(2423),
  [95] = {.count = 1, .reusable = true}, SHIFT(2478),
  [97] = {.count = 1, .reusable = true}, SHIFT(2477),
  [99] = {.count = 1, .reusable = true}, SHIFT(2445),
  [101] = {.count = 1, .reusable = true}, SHIFT(2340),
  [103] = {.count = 1, .reusable = true}, SHIFT(2346),
  [105] = {.count = 1, .reusable = true}, SHIFT(470),
  [107] = {.count = 1, .reusable = false}, SHIFT(237),
  [109] = {.count = 1, .reusable = true}, SHIFT(131),
  [111] = {.count = 1, .reusable = true}, REDUCE(sym__lhs, 1),
  [113] = {.count = 1, .reusable = false}, SHIFT(190),
  [115] = {.count = 1, .reusable = false}, REDUCE(sym__lhs, 1),
  [117] = {.count = 1, .reusable = false}, SHIFT(2737),
  [119] = {.count = 1, .reusable = false}, SHIFT(863),
  [121] = {.count = 1, .reusable = false}, SHIFT(1044),
  [123] = {.count = 1, .reusable = false}, SHIFT(1037),
  [125] = {.count = 1, .reusable = false}, SHIFT(1027),
  [127] = {.count = 1, .reusable = false}, SHIFT(1008),
  [129] = {.count = 1, .reusable = true}, SHIFT(246),
  [131] = {.count = 1, .reusable = true}, SHIFT(744),
  [133] = {.count = 1, .reusable = false}, SHIFT(742),
  [135] = {.count = 1, .reusable = false}, SHIFT(386),
  [137] = {.count = 1, .reusable = true}, SHIFT(386),
  [139] = {.count = 1, .reusable = true}, SHIFT(255),
  [141] = {.count = 1, .reusable = false}, SHIFT(255),
  [143] = {.count = 1, .reusable = false}, SHIFT(908),
  [145] = {.count = 1, .reusable = false}, SHIFT(895),
  [147] = {.count = 1, .reusable = false}, SHIFT(900),
  [149] = {.count = 1, .reusable = false}, SHIFT(244),
  [151] = {.count = 1, .reusable = true}, SHIFT(393),
  [153] = {.count = 1, .reusable = true}, SHIFT(392),
  [155] = {.count = 1, .reusable = true}, SHIFT(745),
  [157] = {.count = 1, .reusable = true}, SHIFT(2889),
  [159] = {.count = 1, .reusable = true}, SHIFT(132),
  [161] = {.count = 1, .reusable = false}, SHIFT(23),
  [163] = {.count = 1, .reusable = true}, SHIFT(134),
  [165] = {.count = 1, .reusable = false}, SHIFT(30),
  [167] = {.count = 1, .reusable = true}, SHIFT(241),
  [169] = {.count = 1, .reusable = false}, SHIFT(305),
  [171] = {.count = 1, .reusable = false}, SHIFT(2761),
  [173] = {.count = 1, .reusable = true}, SHIFT(316),
  [175] = {.count = 1, .reusable = false}, SHIFT(316),
  [177] = {.count = 1, .reusable = false}, SHIFT(385),
  [179] = {.count = 1, .reusable = true}, SHIFT(144),
  [181] = {.count = 1, .reusable = false}, SHIFT(1373),
  [183] = {.count = 1, .reusable = false}, SHIFT(198),
  [185] = {.count = 1, .reusable = false}, SHIFT(2870),
  [187] = {.count = 1, .reusable = false}, SHIFT(871),
  [189] = {.count = 1, .reusable = false}, SHIFT(875),
  [191] = {.count = 1, .reusable = false}, SHIFT(1382),
  [193] = {.count = 1, .reusable = false}, SHIFT(1370),
  [195] = {.count = 1, .reusable = false}, SHIFT(1371),
  [197] = {.count = 1, .reusable = false}, SHIFT(1380),
  [199] = {.count = 1, .reusable = false}, SHIFT(1374),
  [201] = {.count = 1, .reusable = false}, SHIFT(1378),
  [203] = {.count = 1, .reusable = false}, SHIFT(865),
  [205] = {.count = 1, .reusable = false}, SHIFT(32),
  [207] = {.count = 1, .reusable = false}, SHIFT(370),
  [209] = {.count = 1, .reusable = false}, SHIFT(71),
  [211] = {.count = 1, .reusable = true}, SHIFT(258),
  [213] = {.count = 1, .reusable = true}, SHIFT(805),
  [215] = {.count = 1, .reusable = false}, SHIFT(802),
  [217] = {.count = 1, .reusable = false}, SHIFT(795),
  [219] = {.count = 1, .reusable = true}, SHIFT(795),
  [221] = {.count = 1, .reusable = true}, SHIFT(9),
  [223] = {.count = 1, .reusable = false}, SHIFT(1386),
  [225] = {.count = 1, .reusable = false}, SHIFT(1464),
  [227] = {.count = 1, .reusable = true}, SHIFT(1464),
  [229] = {.count = 1, .reusable = false}, SHIFT(9),
  [231] = {.count = 1, .reusable = false}, SHIFT(1013),
  [233] = {.count = 1, .reusable = false}, SHIFT(1014),
  [235] = {.count = 1, .reusable = false}, SHIFT(1018),
  [237] = {.count = 1, .reusable = false}, SHIFT(260),
  [239] = {.count = 1, .reusable = true}, SHIFT(2144),
  [241] = {.count = 1, .reusable = true}, SHIFT(1517),
  [243] = {.count = 1, .reusable = true}, SHIFT(2491),
  [245] = {.count = 1, .reusable = true}, SHIFT(2495),
  [247] = {.count = 1, .reusable = true}, SHIFT(2498),
  [249] = {.count = 1, .reusable = true}, SHIFT(2534),
  [251] = {.count = 1, .reusable = true}, SHIFT(2392),
  [253] = {.count = 1, .reusable = true}, SHIFT(2394),
  [255] = {.count = 1, .reusable = true}, SHIFT(759),
  [257] = {.count = 1, .reusable = true}, SHIFT(826),
  [259] = {.count = 1, .reusable = true}, SHIFT(814),
  [261] = {.count = 1, .reusable = true}, SHIFT(2957),
  [263] = {.count = 1, .reusable = true}, SHIFT(136),
  [265] = {.count = 1, .reusable = true}, SHIFT(143),
  [267] = {.count = 1, .reusable = false}, SHIFT(34),
  [269] = {.count = 1, .reusable = true}, SHIFT(262),
  [271] = {.count = 1, .reusable = false}, SHIFT(232),
  [273] = {.count = 1, .reusable = true}, REDUCE(sym_next, 1),
  [275] = {.count = 1, .reusable = false}, REDUCE(sym_next, 1),
  [277] = {.count = 1, .reusable = true}, SHIFT(233),
  [279] = {.count = 1, .reusable = true}, SHIFT(401),
  [281] = {.count = 1, .reusable = false}, SHIFT(400),
  [283] = {.count = 1, .reusable = false}, SHIFT(399),
  [285] = {.count = 1, .reusable = true}, SHIFT(399),
  [287] = {.count = 1, .reusable = true}, SHIFT(387),
  [289] = {.count = 1, .reusable = true}, SHIFT(593),
  [291] = {.count = 1, .reusable = true}, SHIFT(406),
  [293] = {.count = 1, .reusable = true}, SHIFT(2797),
  [295] = {.count = 1, .reusable = true}, REDUCE(sym_return, 1),
  [297] = {.count = 1, .reusable = false}, REDUCE(sym_return, 1),
  [299] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [301] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 1),
  [303] = {.count = 1, .reusable = true}, REDUCE(sym_break, 1),
  [305] = {.count = 1, .reusable = false}, REDUCE(sym_break, 1),
  [307] = {.count = 1, .reusable = false}, SHIFT(314),
  [309] = {.count = 1, .reusable = false}, SHIFT(383),
  [311] = {.count = 1, .reusable = true}, SHIFT(326),
  [313] = {.count = 1, .reusable = true}, SHIFT(259),
  [315] = {.count = 1, .reusable = true}, SHIFT(765),
  [317] = {.count = 1, .reusable = false}, SHIFT(764),
  [319] = {.count = 1, .reusable = false}, SHIFT(763),
  [321] = {.count = 1, .reusable = true}, SHIFT(763),
  [323] = {.count = 1, .reusable = true}, SHIFT(8),
  [325] = {.count = 1, .reusable = false}, SHIFT(8),
  [327] = {.count = 1, .reusable = true}, SHIFT(839),
  [329] = {.count = 1, .reusable = true}, SHIFT(775),
  [331] = {.count = 1, .reusable = true}, SHIFT(766),
  [333] = {.count = 1, .reusable = true}, SHIFT(2955),
  [335] = {.count = 1, .reusable = false}, SHIFT(270),
  [337] = {.count = 1, .reusable = true}, SHIFT(2777),
  [339] = {.count = 1, .reusable = true}, SHIFT(2139),
  [341] = {.count = 1, .reusable = true}, SHIFT(956),
  [343] = {.count = 1, .reusable = false}, SHIFT(911),
  [345] = {.count = 1, .reusable = false}, SHIFT(12),
  [347] = {.count = 1, .reusable = false}, SHIFT(13),
  [349] = {.count = 1, .reusable = false}, SHIFT(14),
  [351] = {.count = 1, .reusable = false}, SHIFT(11),
  [353] = {.count = 1, .reusable = false}, SHIFT(263),
  [355] = {.count = 1, .reusable = false}, SHIFT(148),
  [357] = {.count = 1, .reusable = false}, SHIFT(158),
  [359] = {.count = 1, .reusable = true}, SHIFT(270),
  [361] = {.count = 1, .reusable = false}, SHIFT(1588),
  [363] = {.count = 1, .reusable = false}, SHIFT(1583),
  [365] = {.count = 1, .reusable = true}, SHIFT(894),
  [367] = {.count = 1, .reusable = false}, SHIFT(1175),
  [369] = {.count = 1, .reusable = false}, SHIFT(1548),
  [371] = {.count = 1, .reusable = false}, SHIFT(2246),
  [373] = {.count = 1, .reusable = false}, SHIFT(2088),
  [375] = {.count = 1, .reusable = false}, SHIFT(1209),
  [377] = {.count = 1, .reusable = false}, SHIFT(1070),
  [379] = {.count = 1, .reusable = false}, SHIFT(940),
  [381] = {.count = 1, .reusable = false}, SHIFT(2231),
  [383] = {.count = 1, .reusable = false}, SHIFT(1007),
  [385] = {.count = 1, .reusable = false}, SHIFT(1494),
  [387] = {.count = 1, .reusable = false}, SHIFT(1081),
  [389] = {.count = 1, .reusable = true}, SHIFT(936),
  [391] = {.count = 1, .reusable = false}, SHIFT(1550),
  [393] = {.count = 1, .reusable = false}, SHIFT(1530),
  [395] = {.count = 1, .reusable = false}, SHIFT(1079),
  [397] = {.count = 1, .reusable = false}, SHIFT(1077),
  [399] = {.count = 1, .reusable = false}, SHIFT(1401),
  [401] = {.count = 1, .reusable = false}, SHIFT(2225),
  [403] = {.count = 1, .reusable = false}, SHIFT(1034),
  [405] = {.count = 1, .reusable = false}, SHIFT(1032),
  [407] = {.count = 1, .reusable = false}, SHIFT(2227),
  [409] = {.count = 1, .reusable = false}, SHIFT(1485),
  [411] = {.count = 1, .reusable = false}, SHIFT(1051),
  [413] = {.count = 1, .reusable = false}, SHIFT(1471),
  [415] = {.count = 1, .reusable = false}, SHIFT(1529),
  [417] = {.count = 1, .reusable = false}, SHIFT(1035),
  [419] = {.count = 1, .reusable = false}, SHIFT(1396),
  [421] = {.count = 1, .reusable = false}, SHIFT(1438),
  [423] = {.count = 1, .reusable = false}, SHIFT(2223),
  [425] = {.count = 1, .reusable = false}, SHIFT(1436),
  [427] = {.count = 1, .reusable = false}, SHIFT(1483),
  [429] = {.count = 1, .reusable = false}, SHIFT(1437),
  [431] = {.count = 1, .reusable = false}, SHIFT(1562),
  [433] = {.count = 1, .reusable = false}, SHIFT(323),
  [435] = {.count = 1, .reusable = true}, SHIFT(901),
  [437] = {.count = 1, .reusable = true}, SHIFT(2737),
  [439] = {.count = 1, .reusable = true}, SHIFT(2142),
  [441] = {.count = 1, .reusable = true}, SHIFT(472),
  [443] = {.count = 1, .reusable = false}, SHIFT(501),
  [445] = {.count = 1, .reusable = true}, SHIFT(500),
  [447] = {.count = 1, .reusable = false}, SHIFT(498),
  [449] = {.count = 1, .reusable = true}, SHIFT(496),
  [451] = {.count = 1, .reusable = true}, SHIFT(501),
  [453] = {.count = 1, .reusable = true}, SHIFT(2890),
  [455] = {.count = 1, .reusable = true}, SHIFT(913),
  [457] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [459] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [461] = {.count = 1, .reusable = true}, SHIFT(912),
  [463] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(270),
  [466] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2810),
  [469] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(311),
  [472] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [474] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2813),
  [477] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1359),
  [480] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(190),
  [483] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2777),
  [486] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(936),
  [489] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(863),
  [492] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(867),
  [495] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(873),
  [498] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [500] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(12),
  [503] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [506] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [509] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [512] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1036),
  [515] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1049),
  [518] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(211),
  [521] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(212),
  [524] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(597),
  [527] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(669),
  [530] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(864),
  [533] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(347),
  [536] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(47),
  [539] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(470),
  [542] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(673),
  [545] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(675),
  [548] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(694),
  [551] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(270),
  [554] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1588),
  [557] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1583),
  [560] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1090),
  [563] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1100),
  [566] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1100),
  [569] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(930),
  [572] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(935),
  [575] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(943),
  [578] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(244),
  [581] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2128),
  [584] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1144),
  [587] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2423),
  [590] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2478),
  [593] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2477),
  [596] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2445),
  [599] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2340),
  [602] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2346),
  [605] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(470),
  [608] = {.count = 1, .reusable = true}, SHIFT(1009),
  [610] = {.count = 1, .reusable = false}, SHIFT(1186),
  [612] = {.count = 1, .reusable = false}, SHIFT(213),
  [614] = {.count = 1, .reusable = false}, SHIFT(138),
  [616] = {.count = 1, .reusable = false}, REDUCE(sym_then, 2),
  [618] = {.count = 1, .reusable = false}, SHIFT(2615),
  [620] = {.count = 1, .reusable = false}, SHIFT(2614),
  [622] = {.count = 1, .reusable = false}, SHIFT(1450),
  [624] = {.count = 1, .reusable = false}, SHIFT(1190),
  [626] = {.count = 1, .reusable = true}, SHIFT(1047),
  [628] = {.count = 1, .reusable = true}, SHIFT(1046),
  [630] = {.count = 1, .reusable = false}, REDUCE(sym_elsif, 3, .production_id = 40),
  [632] = {.count = 1, .reusable = false}, REDUCE(sym_then, 1),
  [634] = {.count = 1, .reusable = false}, SHIFT(1477),
  [636] = {.count = 1, .reusable = false}, REDUCE(sym_else, 1),
  [638] = {.count = 1, .reusable = false}, SHIFT(1469),
  [640] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 2),
  [642] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3, .production_id = 45),
  [644] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 4, .production_id = 57),
  [646] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3, .production_id = 43),
  [648] = {.count = 1, .reusable = false}, SHIFT(1458),
  [650] = {.count = 1, .reusable = false}, REDUCE(sym_when, 3, .production_id = 55),
  [652] = {.count = 1, .reusable = false}, REDUCE(sym_when, 4, .production_id = 63),
  [654] = {.count = 1, .reusable = false}, REDUCE(sym_else, 2, .production_id = 16),
  [656] = {.count = 1, .reusable = false}, REDUCE(sym_ensure, 1),
  [658] = {.count = 1, .reusable = true}, SHIFT(2090),
  [660] = {.count = 1, .reusable = true}, SHIFT(897),
  [662] = {.count = 1, .reusable = true}, SHIFT(1055),
  [664] = {.count = 1, .reusable = true}, SHIFT(1465),
  [666] = {.count = 1, .reusable = true}, SHIFT(2294),
  [668] = {.count = 1, .reusable = true}, SHIFT(942),
  [670] = {.count = 1, .reusable = true}, SHIFT(1210),
  [672] = {.count = 1, .reusable = true}, SHIFT(1135),
  [674] = {.count = 1, .reusable = true}, SHIFT(2235),
  [676] = {.count = 1, .reusable = true}, SHIFT(1040),
  [678] = {.count = 1, .reusable = true}, SHIFT(1552),
  [680] = {.count = 1, .reusable = true}, SHIFT(1064),
  [682] = {.count = 1, .reusable = false}, SHIFT(1193),
  [684] = {.count = 1, .reusable = true}, SHIFT(1061),
  [686] = {.count = 1, .reusable = true}, SHIFT(1516),
  [688] = {.count = 1, .reusable = true}, SHIFT(2082),
  [690] = {.count = 1, .reusable = false}, SHIFT(2649),
  [692] = {.count = 1, .reusable = true}, SHIFT(1488),
  [694] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(966),
  [697] = {.count = 1, .reusable = false}, SHIFT(1129),
  [699] = {.count = 1, .reusable = true}, SHIFT(1217),
  [701] = {.count = 1, .reusable = false}, SHIFT(1192),
  [703] = {.count = 1, .reusable = true}, SHIFT(2602),
  [705] = {.count = 1, .reusable = true}, SHIFT(933),
  [707] = {.count = 1, .reusable = true}, SHIFT(2296),
  [709] = {.count = 1, .reusable = false}, SHIFT(2617),
  [711] = {.count = 1, .reusable = false}, SHIFT(2616),
  [713] = {.count = 1, .reusable = true}, SHIFT(2137),
  [715] = {.count = 1, .reusable = false}, SHIFT(1507),
  [717] = {.count = 1, .reusable = true}, SHIFT(1138),
  [719] = {.count = 1, .reusable = false}, SHIFT(1484),
  [721] = {.count = 1, .reusable = true}, SHIFT(1184),
  [723] = {.count = 1, .reusable = true}, SHIFT(920),
  [725] = {.count = 1, .reusable = false}, SHIFT(1478),
  [727] = {.count = 1, .reusable = true}, SHIFT(2126),
  [729] = {.count = 1, .reusable = false}, SHIFT(1455),
  [731] = {.count = 1, .reusable = true}, SHIFT(2517),
  [733] = {.count = 1, .reusable = true}, SHIFT(1425),
  [735] = {.count = 1, .reusable = true}, SHIFT(2516),
  [737] = {.count = 1, .reusable = true}, SHIFT(1088),
  [739] = {.count = 1, .reusable = true}, SHIFT(1523),
  [741] = {.count = 1, .reusable = false}, SHIFT(1427),
  [743] = {.count = 1, .reusable = true}, SHIFT(2228),
  [745] = {.count = 1, .reusable = false}, SHIFT(1457),
  [747] = {.count = 1, .reusable = true}, SHIFT(1031),
  [749] = {.count = 1, .reusable = false}, SHIFT(10),
  [751] = {.count = 1, .reusable = false}, SHIFT(2924),
  [753] = {.count = 1, .reusable = false}, SHIFT(2940),
  [755] = {.count = 1, .reusable = true}, SHIFT(198),
  [757] = {.count = 1, .reusable = true}, SHIFT(2882),
  [759] = {.count = 1, .reusable = false}, SHIFT(19),
  [761] = {.count = 1, .reusable = false}, SHIFT(20),
  [763] = {.count = 1, .reusable = false}, SHIFT(21),
  [765] = {.count = 1, .reusable = false}, SHIFT(22),
  [767] = {.count = 1, .reusable = false}, SHIFT(217),
  [769] = {.count = 1, .reusable = false}, SHIFT(216),
  [771] = {.count = 1, .reusable = false}, SHIFT(816),
  [773] = {.count = 1, .reusable = false}, SHIFT(776),
  [775] = {.count = 1, .reusable = false}, SHIFT(769),
  [777] = {.count = 1, .reusable = true}, SHIFT(798),
  [779] = {.count = 1, .reusable = false}, SHIFT(800),
  [781] = {.count = 1, .reusable = true}, SHIFT(809),
  [783] = {.count = 1, .reusable = true}, SHIFT(10),
  [785] = {.count = 1, .reusable = false}, SHIFT(1602),
  [787] = {.count = 1, .reusable = false}, SHIFT(1596),
  [789] = {.count = 1, .reusable = false}, SHIFT(1593),
  [791] = {.count = 1, .reusable = true}, SHIFT(1593),
  [793] = {.count = 1, .reusable = false}, SHIFT(1076),
  [795] = {.count = 1, .reusable = false}, SHIFT(1089),
  [797] = {.count = 1, .reusable = false}, SHIFT(1083),
  [799] = {.count = 1, .reusable = true}, SHIFT(260),
  [801] = {.count = 1, .reusable = true}, SHIFT(769),
  [803] = {.count = 1, .reusable = false}, SHIFT(406),
  [805] = {.count = 1, .reusable = true}, SHIFT(577),
  [807] = {.count = 1, .reusable = false}, SHIFT(645),
  [809] = {.count = 1, .reusable = true}, SHIFT(642),
  [811] = {.count = 1, .reusable = false}, SHIFT(641),
  [813] = {.count = 1, .reusable = true}, SHIFT(635),
  [815] = {.count = 1, .reusable = true}, SHIFT(645),
  [817] = {.count = 1, .reusable = false}, SHIFT(1073),
  [819] = {.count = 1, .reusable = true}, SHIFT(309),
  [821] = {.count = 1, .reusable = false}, SHIFT(1361),
  [823] = {.count = 1, .reusable = true}, SHIFT(176),
  [825] = {.count = 1, .reusable = true}, SHIFT(2745),
  [827] = {.count = 1, .reusable = false}, SHIFT(868),
  [829] = {.count = 1, .reusable = false}, SHIFT(870),
  [831] = {.count = 1, .reusable = false}, SHIFT(1383),
  [833] = {.count = 1, .reusable = false}, SHIFT(1376),
  [835] = {.count = 1, .reusable = false}, SHIFT(1377),
  [837] = {.count = 1, .reusable = false}, SHIFT(1366),
  [839] = {.count = 1, .reusable = false}, SHIFT(1365),
  [841] = {.count = 1, .reusable = false}, SHIFT(1381),
  [843] = {.count = 1, .reusable = false}, SHIFT(206),
  [845] = {.count = 1, .reusable = false}, SHIFT(209),
  [847] = {.count = 1, .reusable = false}, SHIFT(636),
  [849] = {.count = 1, .reusable = false}, SHIFT(646),
  [851] = {.count = 1, .reusable = false}, SHIFT(861),
  [853] = {.count = 1, .reusable = false}, SHIFT(330),
  [855] = {.count = 1, .reusable = false}, SHIFT(46),
  [857] = {.count = 1, .reusable = true}, SHIFT(1071),
  [859] = {.count = 1, .reusable = false}, SHIFT(442),
  [861] = {.count = 1, .reusable = true}, SHIFT(444),
  [863] = {.count = 1, .reusable = false}, SHIFT(445),
  [865] = {.count = 1, .reusable = true}, SHIFT(446),
  [867] = {.count = 1, .reusable = true}, SHIFT(1163),
  [869] = {.count = 1, .reusable = false}, SHIFT(1385),
  [871] = {.count = 1, .reusable = false}, SHIFT(1558),
  [873] = {.count = 1, .reusable = true}, SHIFT(1558),
  [875] = {.count = 1, .reusable = false}, SHIFT(1163),
  [877] = {.count = 1, .reusable = false}, SHIFT(1204),
  [879] = {.count = 1, .reusable = false}, SHIFT(1213),
  [881] = {.count = 1, .reusable = false}, SHIFT(1215),
  [883] = {.count = 1, .reusable = true}, SHIFT(239),
  [885] = {.count = 1, .reusable = true}, SHIFT(2127),
  [887] = {.count = 1, .reusable = true}, SHIFT(1557),
  [889] = {.count = 1, .reusable = true}, SHIFT(2434),
  [891] = {.count = 1, .reusable = true}, SHIFT(2436),
  [893] = {.count = 1, .reusable = true}, SHIFT(2387),
  [895] = {.count = 1, .reusable = true}, SHIFT(2442),
  [897] = {.count = 1, .reusable = true}, SHIFT(2383),
  [899] = {.count = 1, .reusable = true}, SHIFT(2338),
  [901] = {.count = 1, .reusable = true}, SHIFT(652),
  [903] = {.count = 1, .reusable = true}, SHIFT(653),
  [905] = {.count = 1, .reusable = true}, SHIFT(442),
  [907] = {.count = 1, .reusable = true}, SHIFT(941),
  [909] = {.count = 1, .reusable = true}, SHIFT(257),
  [911] = {.count = 1, .reusable = true}, SHIFT(1216),
  [913] = {.count = 1, .reusable = true}, SHIFT(1470),
  [915] = {.count = 1, .reusable = true}, SHIFT(2217),
  [917] = {.count = 1, .reusable = true}, SHIFT(358),
  [919] = {.count = 1, .reusable = true}, SHIFT(909),
  [921] = {.count = 1, .reusable = false}, REDUCE(sym__variable, 1),
  [923] = {.count = 1, .reusable = true}, REDUCE(sym__variable, 1),
  [925] = {.count = 1, .reusable = false}, SHIFT(723),
  [927] = {.count = 1, .reusable = true}, SHIFT(1165),
  [929] = {.count = 1, .reusable = false}, SHIFT(815),
  [931] = {.count = 1, .reusable = true}, SHIFT(762),
  [933] = {.count = 1, .reusable = false}, SHIFT(752),
  [935] = {.count = 1, .reusable = true}, SHIFT(801),
  [937] = {.count = 1, .reusable = true}, SHIFT(815),
  [939] = {.count = 1, .reusable = true}, SHIFT(2636),
  [941] = {.count = 1, .reusable = true}, SHIFT(324),
  [943] = {.count = 1, .reusable = false}, SHIFT(548),
  [945] = {.count = 1, .reusable = true}, SHIFT(2266),
  [947] = {.count = 1, .reusable = true}, SHIFT(1538),
  [949] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 2),
  [951] = {.count = 1, .reusable = true}, SHIFT(923),
  [953] = {.count = 1, .reusable = true}, SHIFT(1011),
  [955] = {.count = 1, .reusable = true}, SHIFT(2363),
  [957] = {.count = 1, .reusable = true}, SHIFT(1189),
  [959] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 3),
  [961] = {.count = 1, .reusable = true}, SHIFT(893),
  [963] = {.count = 1, .reusable = true}, SHIFT(1123),
  [965] = {.count = 1, .reusable = true}, SHIFT(2193),
  [967] = {.count = 1, .reusable = true}, SHIFT(290),
  [969] = {.count = 1, .reusable = true}, SHIFT(1053),
  [971] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 3, .production_id = 26),
  [973] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 3, .production_id = 26),
  [975] = {.count = 1, .reusable = true}, SHIFT(1024),
  [977] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 2, .production_id = 6),
  [979] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 2, .production_id = 6),
  [981] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [983] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [985] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [987] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [989] = {.count = 1, .reusable = true}, SHIFT(999),
  [991] = {.count = 1, .reusable = true}, SHIFT(1481),
  [993] = {.count = 1, .reusable = true}, SHIFT(1417),
  [995] = {.count = 1, .reusable = false}, REDUCE(sym_operator, 1),
  [997] = {.count = 1, .reusable = true}, REDUCE(sym_operator, 1),
  [999] = {.count = 1, .reusable = true}, SHIFT(1015),
  [1001] = {.count = 1, .reusable = false}, SHIFT(890),
  [1003] = {.count = 1, .reusable = true}, SHIFT(2746),
  [1005] = {.count = 1, .reusable = false}, SHIFT(146),
  [1007] = {.count = 1, .reusable = true}, SHIFT(874),
  [1009] = {.count = 1, .reusable = false}, SHIFT(554),
  [1011] = {.count = 1, .reusable = true}, SHIFT(553),
  [1013] = {.count = 1, .reusable = false}, SHIFT(552),
  [1015] = {.count = 1, .reusable = true}, SHIFT(551),
  [1017] = {.count = 1, .reusable = true}, SHIFT(890),
  [1019] = {.count = 1, .reusable = false}, SHIFT(1589),
  [1021] = {.count = 1, .reusable = true}, SHIFT(511),
  [1023] = {.count = 1, .reusable = true}, SHIFT(554),
  [1025] = {.count = 1, .reusable = true}, SHIFT(415),
  [1027] = {.count = 1, .reusable = false}, REDUCE(sym_call, 3, .production_id = 24),
  [1029] = {.count = 1, .reusable = true}, REDUCE(sym_call, 3, .production_id = 24),
  [1031] = {.count = 1, .reusable = true}, SHIFT(807),
  [1033] = {.count = 1, .reusable = false}, SHIFT(880),
  [1035] = {.count = 1, .reusable = true}, SHIFT(480),
  [1037] = {.count = 1, .reusable = false}, SHIFT(882),
  [1039] = {.count = 1, .reusable = true}, SHIFT(584),
  [1041] = {.count = 1, .reusable = false}, SHIFT(745),
  [1043] = {.count = 1, .reusable = false}, SHIFT(987),
  [1045] = {.count = 1, .reusable = true}, SHIFT(2919),
  [1047] = {.count = 1, .reusable = true}, SHIFT(761),
  [1049] = {.count = 1, .reusable = false}, SHIFT(814),
  [1051] = {.count = 1, .reusable = true}, SHIFT(977),
  [1053] = {.count = 1, .reusable = false}, SHIFT(1526),
  [1055] = {.count = 1, .reusable = true}, SHIFT(1526),
  [1057] = {.count = 1, .reusable = false}, SHIFT(977),
  [1059] = {.count = 1, .reusable = false}, SHIFT(982),
  [1061] = {.count = 1, .reusable = true}, SHIFT(835),
  [1063] = {.count = 1, .reusable = false}, SHIFT(766),
  [1065] = {.count = 1, .reusable = true}, SHIFT(974),
  [1067] = {.count = 1, .reusable = false}, SHIFT(974),
  [1069] = {.count = 1, .reusable = true}, SHIFT(2639),
  [1071] = {.count = 1, .reusable = false}, SHIFT(558),
  [1073] = {.count = 1, .reusable = true}, SHIFT(581),
  [1075] = {.count = 1, .reusable = false}, SHIFT(582),
  [1077] = {.count = 1, .reusable = true}, SHIFT(583),
  [1079] = {.count = 1, .reusable = true}, SHIFT(558),
  [1081] = {.count = 1, .reusable = true}, SHIFT(1415),
  [1083] = {.count = 1, .reusable = true}, SHIFT(2593),
  [1085] = {.count = 1, .reusable = true}, SHIFT(1473),
  [1087] = {.count = 1, .reusable = true}, SHIFT(1168),
  [1089] = {.count = 1, .reusable = true}, SHIFT(1134),
  [1091] = {.count = 1, .reusable = true}, SHIFT(2592),
  [1093] = {.count = 1, .reusable = true}, SHIFT(1158),
  [1095] = {.count = 1, .reusable = true}, SHIFT(1549),
  [1097] = {.count = 1, .reusable = true}, SHIFT(1392),
  [1099] = {.count = 1, .reusable = true}, SHIFT(1491),
  [1101] = {.count = 1, .reusable = false}, SHIFT(508),
  [1103] = {.count = 1, .reusable = true}, SHIFT(1430),
  [1105] = {.count = 1, .reusable = false}, SHIFT(903),
  [1107] = {.count = 1, .reusable = true}, SHIFT(2744),
  [1109] = {.count = 1, .reusable = false}, SHIFT(475),
  [1111] = {.count = 1, .reusable = true}, SHIFT(473),
  [1113] = {.count = 1, .reusable = false}, SHIFT(471),
  [1115] = {.count = 1, .reusable = true}, SHIFT(465),
  [1117] = {.count = 1, .reusable = true}, SHIFT(903),
  [1119] = {.count = 1, .reusable = true}, SHIFT(722),
  [1121] = {.count = 1, .reusable = true}, SHIFT(475),
  [1123] = {.count = 1, .reusable = true}, SHIFT(2556),
  [1125] = {.count = 1, .reusable = false}, SHIFT(491),
  [1127] = {.count = 1, .reusable = true}, SHIFT(492),
  [1129] = {.count = 1, .reusable = false}, SHIFT(494),
  [1131] = {.count = 1, .reusable = true}, SHIFT(499),
  [1133] = {.count = 1, .reusable = true}, SHIFT(491),
  [1135] = {.count = 1, .reusable = false}, SHIFT(1022),
  [1137] = {.count = 1, .reusable = true}, SHIFT(2747),
  [1139] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 2, .production_id = 19),
  [1141] = {.count = 1, .reusable = false}, SHIFT(407),
  [1143] = {.count = 1, .reusable = true}, SHIFT(409),
  [1145] = {.count = 1, .reusable = false}, SHIFT(411),
  [1147] = {.count = 1, .reusable = true}, SHIFT(413),
  [1149] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1151] = {.count = 1, .reusable = false}, SHIFT(1086),
  [1153] = {.count = 1, .reusable = false}, SHIFT(1085),
  [1155] = {.count = 1, .reusable = false}, SHIFT(1084),
  [1157] = {.count = 1, .reusable = true}, SHIFT(407),
  [1159] = {.count = 1, .reusable = false}, SHIFT(456),
  [1161] = {.count = 1, .reusable = true}, SHIFT(455),
  [1163] = {.count = 1, .reusable = false}, SHIFT(453),
  [1165] = {.count = 1, .reusable = true}, SHIFT(452),
  [1167] = {.count = 1, .reusable = true}, SHIFT(459),
  [1169] = {.count = 1, .reusable = true}, SHIFT(456),
  [1171] = {.count = 1, .reusable = true}, SHIFT(462),
  [1173] = {.count = 1, .reusable = true}, SHIFT(474),
  [1175] = {.count = 1, .reusable = true}, SHIFT(495),
  [1177] = {.count = 1, .reusable = false}, SHIFT(536),
  [1179] = {.count = 1, .reusable = true}, SHIFT(533),
  [1181] = {.count = 1, .reusable = false}, SHIFT(532),
  [1183] = {.count = 1, .reusable = true}, SHIFT(530),
  [1185] = {.count = 1, .reusable = true}, SHIFT(2483),
  [1187] = {.count = 1, .reusable = true}, SHIFT(417),
  [1189] = {.count = 1, .reusable = true}, SHIFT(536),
  [1191] = {.count = 1, .reusable = false}, SHIFT(607),
  [1193] = {.count = 1, .reusable = true}, SHIFT(605),
  [1195] = {.count = 1, .reusable = false}, SHIFT(601),
  [1197] = {.count = 1, .reusable = true}, SHIFT(599),
  [1199] = {.count = 1, .reusable = true}, SHIFT(557),
  [1201] = {.count = 1, .reusable = true}, SHIFT(607),
  [1203] = {.count = 1, .reusable = true}, SHIFT(569),
  [1205] = {.count = 1, .reusable = true}, SHIFT(721),
  [1207] = {.count = 1, .reusable = false}, SHIFT(529),
  [1209] = {.count = 1, .reusable = true}, SHIFT(527),
  [1211] = {.count = 1, .reusable = false}, SHIFT(525),
  [1213] = {.count = 1, .reusable = true}, SHIFT(524),
  [1215] = {.count = 1, .reusable = true}, SHIFT(529),
  [1217] = {.count = 1, .reusable = false}, SHIFT(979),
  [1219] = {.count = 1, .reusable = true}, SHIFT(2826),
  [1221] = {.count = 1, .reusable = true}, SHIFT(979),
  [1223] = {.count = 1, .reusable = false}, SHIFT(1573),
  [1225] = {.count = 1, .reusable = true}, SHIFT(1573),
  [1227] = {.count = 1, .reusable = true}, SHIFT(823),
  [1229] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 2, .production_id = 19),
  [1231] = {.count = 1, .reusable = true}, SHIFT(825),
  [1233] = {.count = 1, .reusable = false}, SHIFT(980),
  [1235] = {.count = 1, .reusable = false}, SHIFT(777),
  [1237] = {.count = 1, .reusable = true}, SHIFT(778),
  [1239] = {.count = 1, .reusable = false}, SHIFT(779),
  [1241] = {.count = 1, .reusable = true}, SHIFT(780),
  [1243] = {.count = 1, .reusable = true}, SHIFT(980),
  [1245] = {.count = 1, .reusable = true}, SHIFT(777),
  [1247] = {.count = 1, .reusable = false}, SHIFT(767),
  [1249] = {.count = 1, .reusable = false}, SHIFT(819),
  [1251] = {.count = 1, .reusable = false}, SHIFT(687),
  [1253] = {.count = 1, .reusable = true}, SHIFT(681),
  [1255] = {.count = 1, .reusable = false}, SHIFT(678),
  [1257] = {.count = 1, .reusable = true}, SHIFT(676),
  [1259] = {.count = 1, .reusable = true}, SHIFT(687),
  [1261] = {.count = 1, .reusable = false}, SHIFT(1075),
  [1263] = {.count = 1, .reusable = false}, SHIFT(1131),
  [1265] = {.count = 1, .reusable = false}, SHIFT(1390),
  [1267] = {.count = 1, .reusable = false}, SHIFT(1435),
  [1269] = {.count = 1, .reusable = false}, SHIFT(545),
  [1271] = {.count = 1, .reusable = true}, SHIFT(547),
  [1273] = {.count = 1, .reusable = false}, SHIFT(549),
  [1275] = {.count = 1, .reusable = true}, SHIFT(550),
  [1277] = {.count = 1, .reusable = true}, SHIFT(545),
  [1279] = {.count = 1, .reusable = false}, SHIFT(482),
  [1281] = {.count = 1, .reusable = true}, SHIFT(447),
  [1283] = {.count = 1, .reusable = false}, SHIFT(450),
  [1285] = {.count = 1, .reusable = true}, SHIFT(464),
  [1287] = {.count = 1, .reusable = true}, SHIFT(482),
  [1289] = {.count = 1, .reusable = false}, SHIFT(1587),
  [1291] = {.count = 1, .reusable = false}, SHIFT(1388),
  [1293] = {.count = 1, .reusable = false}, SHIFT(1489),
  [1295] = {.count = 1, .reusable = false}, SHIFT(2198),
  [1297] = {.count = 1, .reusable = true}, SHIFT(312),
  [1299] = {.count = 1, .reusable = false}, SHIFT(1364),
  [1301] = {.count = 1, .reusable = true}, SHIFT(187),
  [1303] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 3),
  [1305] = {.count = 1, .reusable = true}, SHIFT(2779),
  [1307] = {.count = 1, .reusable = false}, SHIFT(869),
  [1309] = {.count = 1, .reusable = false}, SHIFT(872),
  [1311] = {.count = 1, .reusable = false}, SHIFT(2474),
  [1313] = {.count = 1, .reusable = false}, SHIFT(2471),
  [1315] = {.count = 1, .reusable = false}, SHIFT(2468),
  [1317] = {.count = 1, .reusable = false}, SHIFT(2466),
  [1319] = {.count = 1, .reusable = false}, SHIFT(2482),
  [1321] = {.count = 1, .reusable = false}, SHIFT(2486),
  [1323] = {.count = 1, .reusable = false}, SHIFT(207),
  [1325] = {.count = 1, .reusable = false}, SHIFT(210),
  [1327] = {.count = 1, .reusable = false}, SHIFT(488),
  [1329] = {.count = 1, .reusable = false}, SHIFT(478),
  [1331] = {.count = 1, .reusable = false}, SHIFT(862),
  [1333] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 3),
  [1335] = {.count = 1, .reusable = false}, SHIFT(356),
  [1337] = {.count = 1, .reusable = false}, SHIFT(44),
  [1339] = {.count = 1, .reusable = false}, SHIFT(2756),
  [1341] = {.count = 1, .reusable = true}, SHIFT(2755),
  [1343] = {.count = 1, .reusable = false}, SHIFT(2755),
  [1345] = {.count = 1, .reusable = true}, SHIFT(2198),
  [1347] = {.count = 1, .reusable = false}, SHIFT(2530),
  [1349] = {.count = 1, .reusable = false}, SHIFT(2550),
  [1351] = {.count = 1, .reusable = true}, SHIFT(2550),
  [1353] = {.count = 1, .reusable = false}, SHIFT(2253),
  [1355] = {.count = 1, .reusable = false}, SHIFT(2254),
  [1357] = {.count = 1, .reusable = false}, SHIFT(2259),
  [1359] = {.count = 1, .reusable = true}, SHIFT(235),
  [1361] = {.count = 1, .reusable = true}, SHIFT(2136),
  [1363] = {.count = 1, .reusable = true}, SHIFT(2659),
  [1365] = {.count = 1, .reusable = true}, SHIFT(2390),
  [1367] = {.count = 1, .reusable = true}, SHIFT(2484),
  [1369] = {.count = 1, .reusable = true}, SHIFT(2437),
  [1371] = {.count = 1, .reusable = true}, SHIFT(2400),
  [1373] = {.count = 1, .reusable = true}, SHIFT(2381),
  [1375] = {.count = 1, .reusable = true}, SHIFT(2380),
  [1377] = {.count = 1, .reusable = true}, SHIFT(2756),
  [1379] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 2),
  [1381] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 2),
  [1383] = {.count = 1, .reusable = true}, SHIFT(181),
  [1385] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 1),
  [1387] = {.count = 1, .reusable = false}, REDUCE(sym_rest_assignment, 1),
  [1389] = {.count = 1, .reusable = true}, SHIFT(2773),
  [1391] = {.count = 1, .reusable = false}, SHIFT(2172),
  [1393] = {.count = 1, .reusable = true}, SHIFT(461),
  [1395] = {.count = 1, .reusable = false}, SHIFT(2170),
  [1397] = {.count = 1, .reusable = true}, SHIFT(435),
  [1399] = {.count = 1, .reusable = false}, SHIFT(2171),
  [1401] = {.count = 1, .reusable = true}, SHIFT(624),
  [1403] = {.count = 1, .reusable = false}, SHIFT(2188),
  [1405] = {.count = 1, .reusable = false}, SHIFT(2175),
  [1407] = {.count = 1, .reusable = true}, SHIFT(781),
  [1409] = {.count = 1, .reusable = false}, SHIFT(2191),
  [1411] = {.count = 1, .reusable = false}, SHIFT(2189),
  [1413] = {.count = 1, .reusable = false}, SHIFT(2216),
  [1415] = {.count = 1, .reusable = true}, SHIFT(2216),
  [1417] = {.count = 1, .reusable = false}, SHIFT(2370),
  [1419] = {.count = 1, .reusable = false}, SHIFT(2369),
  [1421] = {.count = 1, .reusable = false}, SHIFT(2368),
  [1423] = {.count = 1, .reusable = false}, SHIFT(2206),
  [1425] = {.count = 1, .reusable = true}, SHIFT(160),
  [1427] = {.count = 1, .reusable = true}, SHIFT(23),
  [1429] = {.count = 1, .reusable = true}, SHIFT(164),
  [1431] = {.count = 1, .reusable = true}, SHIFT(30),
  [1433] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2, .production_id = 8),
  [1435] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2, .production_id = 8),
  [1437] = {.count = 1, .reusable = true}, REDUCE(sym__primary, 1),
  [1439] = {.count = 1, .reusable = false}, REDUCE(sym__primary, 1),
  [1441] = {.count = 1, .reusable = false}, SHIFT(346),
  [1443] = {.count = 1, .reusable = true}, SHIFT(592),
  [1445] = {.count = 1, .reusable = false}, REDUCE(sym__terminator, 1),
  [1447] = {.count = 1, .reusable = true}, REDUCE(sym__terminator, 1),
  [1449] = {.count = 1, .reusable = true}, REDUCE(sym_false, 1),
  [1451] = {.count = 1, .reusable = false}, REDUCE(sym_false, 1),
  [1453] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 2),
  [1455] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 2),
  [1457] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [1459] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [1461] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 3, .production_id = 27),
  [1463] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 3, .production_id = 27),
  [1465] = {.count = 1, .reusable = true}, REDUCE(sym_nil, 1),
  [1467] = {.count = 1, .reusable = false}, REDUCE(sym_nil, 1),
  [1469] = {.count = 1, .reusable = true}, REDUCE(sym_true, 1),
  [1471] = {.count = 1, .reusable = false}, REDUCE(sym_true, 1),
  [1473] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 3, .production_id = 25),
  [1475] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 3, .production_id = 25),
  [1477] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 2),
  [1479] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 2),
  [1481] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 1),
  [1483] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 1),
  [1485] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 2),
  [1487] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 4),
  [1489] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 4),
  [1491] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 5),
  [1493] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 5),
  [1495] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 4, .production_id = 25),
  [1497] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 4, .production_id = 25),
  [1499] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2, .production_id = 9),
  [1501] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2, .production_id = 9),
  [1503] = {.count = 1, .reusable = true}, REDUCE(sym_block, 3),
  [1505] = {.count = 1, .reusable = false}, REDUCE(sym_block, 3),
  [1507] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 3),
  [1509] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 3),
  [1511] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 3),
  [1513] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 3),
  [1515] = {.count = 1, .reusable = false}, SHIFT(355),
  [1517] = {.count = 1, .reusable = true}, SHIFT(611),
  [1519] = {.count = 1, .reusable = true}, REDUCE(sym_block, 4),
  [1521] = {.count = 1, .reusable = false}, REDUCE(sym_block, 4),
  [1523] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 1),
  [1525] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 1),
  [1527] = {.count = 1, .reusable = false}, SHIFT(340),
  [1529] = {.count = 1, .reusable = true}, SHIFT(603),
  [1531] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [1533] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [1535] = {.count = 1, .reusable = false}, SHIFT(353),
  [1537] = {.count = 1, .reusable = true}, SHIFT(751),
  [1539] = {.count = 1, .reusable = true}, SHIFT(860),
  [1541] = {.count = 1, .reusable = false}, SHIFT(337),
  [1543] = {.count = 1, .reusable = true}, SHIFT(521),
  [1545] = {.count = 1, .reusable = false}, SHIFT(220),
  [1547] = {.count = 1, .reusable = true}, SHIFT(288),
  [1549] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 4),
  [1551] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 4),
  [1553] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 3),
  [1555] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 3),
  [1557] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 3),
  [1559] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [1561] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 2),
  [1563] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [1565] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 4),
  [1567] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 4),
  [1569] = {.count = 1, .reusable = false}, SHIFT(221),
  [1571] = {.count = 1, .reusable = true}, SHIFT(285),
  [1573] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 5),
  [1575] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 5),
  [1577] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 6),
  [1579] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 6),
  [1581] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 7),
  [1583] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 7),
  [1585] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 8),
  [1587] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 8),
  [1589] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 2),
  [1591] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 2),
  [1593] = {.count = 1, .reusable = false}, REDUCE(sym__do, 1),
  [1595] = {.count = 1, .reusable = true}, REDUCE(sym__do, 1),
  [1597] = {.count = 1, .reusable = true}, SHIFT(168),
  [1599] = {.count = 1, .reusable = true}, SHIFT(32),
  [1601] = {.count = 1, .reusable = true}, SHIFT(170),
  [1603] = {.count = 1, .reusable = true}, SHIFT(34),
  [1605] = {.count = 1, .reusable = true}, SHIFT(161),
  [1607] = {.count = 1, .reusable = true}, SHIFT(29),
  [1609] = {.count = 1, .reusable = true}, SHIFT(242),
  [1611] = {.count = 1, .reusable = false}, SHIFT(222),
  [1613] = {.count = 1, .reusable = true}, SHIFT(282),
  [1615] = {.count = 1, .reusable = false}, SHIFT(341),
  [1617] = {.count = 1, .reusable = true}, SHIFT(535),
  [1619] = {.count = 1, .reusable = false}, SHIFT(223),
  [1621] = {.count = 1, .reusable = true}, SHIFT(272),
  [1623] = {.count = 1, .reusable = false}, SHIFT(218),
  [1625] = {.count = 1, .reusable = true}, SHIFT(291),
  [1627] = {.count = 1, .reusable = false}, SHIFT(546),
  [1629] = {.count = 1, .reusable = false}, SHIFT(219),
  [1631] = {.count = 1, .reusable = true}, SHIFT(286),
  [1633] = {.count = 1, .reusable = true}, REDUCE(sym_chained_string, 2),
  [1635] = {.count = 1, .reusable = false}, REDUCE(sym_chained_string, 2),
  [1637] = {.count = 1, .reusable = true}, SHIFT(165),
  [1639] = {.count = 1, .reusable = true}, SHIFT(28),
  [1641] = {.count = 1, .reusable = true}, SHIFT(247),
  [1643] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [1645] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [1647] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2423),
  [1650] = {.count = 1, .reusable = false}, SHIFT(374),
  [1652] = {.count = 1, .reusable = true}, SHIFT(811),
  [1654] = {.count = 1, .reusable = false}, SHIFT(379),
  [1656] = {.count = 1, .reusable = true}, SHIFT(854),
  [1658] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3, .production_id = 10),
  [1660] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3, .production_id = 10),
  [1662] = {.count = 1, .reusable = true}, REDUCE(sym_redo, 1),
  [1664] = {.count = 1, .reusable = false}, REDUCE(sym_redo, 1),
  [1666] = {.count = 1, .reusable = false}, SHIFT(730),
  [1668] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2, .production_id = 1),
  [1670] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2, .production_id = 1),
  [1672] = {.count = 1, .reusable = true}, REDUCE(sym_retry, 1),
  [1674] = {.count = 1, .reusable = false}, REDUCE(sym_retry, 1),
  [1676] = {.count = 1, .reusable = false}, SHIFT(366),
  [1678] = {.count = 1, .reusable = true}, SHIFT(796),
  [1680] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 1),
  [1682] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 1),
  [1684] = {.count = 1, .reusable = true}, REDUCE(sym_unary_literal, 2),
  [1686] = {.count = 1, .reusable = false}, REDUCE(sym_unary_literal, 2),
  [1688] = {.count = 1, .reusable = false}, SHIFT(1188),
  [1690] = {.count = 1, .reusable = true}, REDUCE(sym_case, 7, .production_id = 41),
  [1692] = {.count = 1, .reusable = false}, REDUCE(sym_case, 7, .production_id = 41),
  [1694] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 3, .production_id = 10),
  [1696] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 3, .production_id = 10),
  [1698] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 3),
  [1700] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 3),
  [1702] = {.count = 1, .reusable = false}, SHIFT(362),
  [1704] = {.count = 1, .reusable = true}, SHIFT(753),
  [1706] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3, .production_id = 6),
  [1708] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3, .production_id = 6),
  [1710] = {.count = 1, .reusable = false}, SHIFT(248),
  [1712] = {.count = 1, .reusable = true}, SHIFT(303),
  [1714] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 3),
  [1716] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 3),
  [1718] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .production_id = 15),
  [1720] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .production_id = 15),
  [1722] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6),
  [1724] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6),
  [1726] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6, .production_id = 41),
  [1728] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6, .production_id = 41),
  [1730] = {.count = 1, .reusable = true}, REDUCE(sym_for, 6, .production_id = 53),
  [1732] = {.count = 1, .reusable = false}, REDUCE(sym_for, 6, .production_id = 53),
  [1734] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 6, .production_id = 61),
  [1736] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 6, .production_id = 61),
  [1738] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 6, .production_id = 60),
  [1740] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 6, .production_id = 60),
  [1742] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 6, .production_id = 59),
  [1744] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 6, .production_id = 59),
  [1746] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [1748] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [1750] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .production_id = 14),
  [1752] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .production_id = 14),
  [1754] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 3),
  [1756] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 3),
  [1758] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5),
  [1760] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5),
  [1762] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5, .production_id = 41),
  [1764] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5, .production_id = 41),
  [1766] = {.count = 1, .reusable = true}, REDUCE(sym_case, 3),
  [1768] = {.count = 1, .reusable = false}, REDUCE(sym_case, 3),
  [1770] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 2, .production_id = 1),
  [1772] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 2, .production_id = 1),
  [1774] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 2, .production_id = 2),
  [1776] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 2, .production_id = 2),
  [1778] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2, .production_id = 3),
  [1780] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 2, .production_id = 3),
  [1782] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 2, .production_id = 4),
  [1784] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 2, .production_id = 4),
  [1786] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 2, .production_id = 4),
  [1788] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 2, .production_id = 4),
  [1790] = {.count = 1, .reusable = true}, REDUCE(sym_for, 5, .production_id = 53),
  [1792] = {.count = 1, .reusable = false}, REDUCE(sym_for, 5, .production_id = 53),
  [1794] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .production_id = 13),
  [1796] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .production_id = 13),
  [1798] = {.count = 1, .reusable = true}, REDUCE(sym_until, 5, .production_id = 16),
  [1800] = {.count = 1, .reusable = false}, REDUCE(sym_until, 5, .production_id = 16),
  [1802] = {.count = 1, .reusable = true}, REDUCE(sym__arg, 1),
  [1804] = {.count = 1, .reusable = false}, SHIFT(1762),
  [1806] = {.count = 1, .reusable = false}, REDUCE(sym__arg, 1),
  [1808] = {.count = 1, .reusable = true}, SHIFT(231),
  [1810] = {.count = 1, .reusable = true}, SHIFT(2753),
  [1812] = {.count = 1, .reusable = true}, SHIFT(1762),
  [1814] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 2),
  [1816] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .production_id = 13),
  [1818] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .production_id = 13),
  [1820] = {.count = 1, .reusable = true}, REDUCE(sym_method, 2, .production_id = 5),
  [1822] = {.count = 1, .reusable = false}, REDUCE(sym_method, 2, .production_id = 5),
  [1824] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 2),
  [1826] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 2),
  [1828] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3, .production_id = 20),
  [1830] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 3, .production_id = 20),
  [1832] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .production_id = 29),
  [1834] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .production_id = 29),
  [1836] = {.count = 1, .reusable = true}, REDUCE(sym_while, 5, .production_id = 16),
  [1838] = {.count = 1, .reusable = false}, REDUCE(sym_while, 5, .production_id = 16),
  [1840] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 1),
  [1842] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 1),
  [1844] = {.count = 1, .reusable = true}, REDUCE(sym_return, 2),
  [1846] = {.count = 1, .reusable = false}, REDUCE(sym_return, 2),
  [1848] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [1850] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 2),
  [1852] = {.count = 1, .reusable = true}, REDUCE(sym_break, 2),
  [1854] = {.count = 1, .reusable = false}, REDUCE(sym_break, 2),
  [1856] = {.count = 1, .reusable = true}, REDUCE(sym_next, 2),
  [1858] = {.count = 1, .reusable = false}, REDUCE(sym_next, 2),
  [1860] = {.count = 1, .reusable = true}, REDUCE(sym_redo, 2),
  [1862] = {.count = 1, .reusable = false}, REDUCE(sym_redo, 2),
  [1864] = {.count = 1, .reusable = true}, REDUCE(sym_retry, 2),
  [1866] = {.count = 1, .reusable = false}, REDUCE(sym_retry, 2),
  [1868] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 12),
  [1870] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 12),
  [1872] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .production_id = 30),
  [1874] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .production_id = 30),
  [1876] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 5, .production_id = 52),
  [1878] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 5, .production_id = 52),
  [1880] = {.count = 1, .reusable = true}, REDUCE(sym_if, 5, .production_id = 52),
  [1882] = {.count = 1, .reusable = false}, REDUCE(sym_if, 5, .production_id = 52),
  [1884] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 6),
  [1886] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 6),
  [1888] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_class, 5, .production_id = 51),
  [1890] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_class, 5, .production_id = 51),
  [1892] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 4, .production_id = 39),
  [1894] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 4, .production_id = 39),
  [1896] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 5),
  [1898] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 5),
  [1900] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .production_id = 31),
  [1902] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .production_id = 31),
  [1904] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3, .production_id = 11),
  [1906] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3, .production_id = 11),
  [1908] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .production_id = 29),
  [1910] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .production_id = 29),
  [1912] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .production_id = 50),
  [1914] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .production_id = 50),
  [1916] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .production_id = 33),
  [1918] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .production_id = 33),
  [1920] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .production_id = 34),
  [1922] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .production_id = 34),
  [1924] = {.count = 1, .reusable = false}, SHIFT(234),
  [1926] = {.count = 1, .reusable = true}, SHIFT(296),
  [1928] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 4),
  [1930] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 4),
  [1932] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 4, .production_id = 38),
  [1934] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 4, .production_id = 38),
  [1936] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3, .production_id = 39),
  [1938] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3, .production_id = 39),
  [1940] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3, .production_id = 19),
  [1942] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3, .production_id = 19),
  [1944] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 6),
  [1946] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 6),
  [1948] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4, .production_id = 6),
  [1950] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4, .production_id = 6),
  [1952] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .production_id = 49),
  [1954] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .production_id = 49),
  [1956] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 2),
  [1958] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 2),
  [1960] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .production_id = 48),
  [1962] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .production_id = 48),
  [1964] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .production_id = 47),
  [1966] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .production_id = 47),
  [1968] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_unary, 2),
  [1970] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_unary, 2),
  [1972] = {.count = 1, .reusable = false}, SHIFT(373),
  [1974] = {.count = 1, .reusable = true}, SHIFT(785),
  [1976] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 2, .production_id = 7),
  [1978] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 2, .production_id = 7),
  [1980] = {.count = 1, .reusable = true}, REDUCE(sym_if, 4, .production_id = 40),
  [1982] = {.count = 1, .reusable = false}, REDUCE(sym_if, 4, .production_id = 40),
  [1984] = {.count = 1, .reusable = true}, REDUCE(sym_rational, 2),
  [1986] = {.count = 1, .reusable = false}, REDUCE(sym_rational, 2),
  [1988] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [1990] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [1992] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 4, .production_id = 40),
  [1994] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 4, .production_id = 40),
  [1996] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4),
  [1998] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4),
  [2000] = {.count = 1, .reusable = true}, REDUCE(sym_while, 4, .production_id = 16),
  [2002] = {.count = 1, .reusable = false}, REDUCE(sym_while, 4, .production_id = 16),
  [2004] = {.count = 1, .reusable = true}, REDUCE(sym_until, 4, .production_id = 16),
  [2006] = {.count = 1, .reusable = false}, REDUCE(sym_until, 4, .production_id = 16),
  [2008] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4, .production_id = 41),
  [2010] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4, .production_id = 41),
  [2012] = {.count = 1, .reusable = false}, SHIFT(1825),
  [2014] = {.count = 1, .reusable = true}, SHIFT(225),
  [2016] = {.count = 1, .reusable = true}, SHIFT(2762),
  [2018] = {.count = 1, .reusable = true}, SHIFT(1825),
  [2020] = {.count = 1, .reusable = false}, SHIFT(348),
  [2022] = {.count = 1, .reusable = true}, SHIFT(701),
  [2024] = {.count = 1, .reusable = false}, SHIFT(335),
  [2026] = {.count = 1, .reusable = true}, SHIFT(513),
  [2028] = {.count = 1, .reusable = false}, SHIFT(328),
  [2030] = {.count = 1, .reusable = true}, SHIFT(503),
  [2032] = {.count = 1, .reusable = false}, SHIFT(350),
  [2034] = {.count = 1, .reusable = true}, SHIFT(720),
  [2036] = {.count = 1, .reusable = false}, SHIFT(1832),
  [2038] = {.count = 1, .reusable = true}, SHIFT(2742),
  [2040] = {.count = 1, .reusable = true}, SHIFT(1832),
  [2042] = {.count = 1, .reusable = false}, SHIFT(338),
  [2044] = {.count = 1, .reusable = true}, SHIFT(540),
  [2046] = {.count = 1, .reusable = false}, SHIFT(332),
  [2048] = {.count = 1, .reusable = true}, SHIFT(467),
  [2050] = {.count = 1, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [2052] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(369),
  [2055] = {.count = 1, .reusable = false}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [2057] = {.count = 1, .reusable = true}, REDUCE(sym_right_assignment_list, 2),
  [2059] = {.count = 1, .reusable = true}, SHIFT(369),
  [2061] = {.count = 1, .reusable = false}, REDUCE(sym_right_assignment_list, 2),
  [2063] = {.count = 1, .reusable = false}, SHIFT(345),
  [2065] = {.count = 1, .reusable = true}, SHIFT(596),
  [2067] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3, .production_id = 28),
  [2069] = {.count = 1, .reusable = false}, SHIFT(734),
  [2071] = {.count = 1, .reusable = true}, SHIFT(628),
  [2073] = {.count = 1, .reusable = false}, SHIFT(737),
  [2075] = {.count = 1, .reusable = false}, SHIFT(714),
  [2077] = {.count = 1, .reusable = true}, SHIFT(487),
  [2079] = {.count = 1, .reusable = false}, SHIFT(704),
  [2081] = {.count = 1, .reusable = true}, SHIFT(704),
  [2083] = {.count = 1, .reusable = true}, SHIFT(648),
  [2085] = {.count = 1, .reusable = true}, SHIFT(633),
  [2087] = {.count = 1, .reusable = true}, SHIFT(714),
  [2089] = {.count = 1, .reusable = true}, SHIFT(734),
  [2091] = {.count = 1, .reusable = true}, SHIFT(728),
  [2093] = {.count = 1, .reusable = true}, SHIFT(729),
  [2095] = {.count = 1, .reusable = false}, SHIFT(625),
  [2097] = {.count = 1, .reusable = true}, SHIFT(625),
  [2099] = {.count = 1, .reusable = false}, SHIFT(339),
  [2101] = {.count = 1, .reusable = true}, SHIFT(468),
  [2103] = {.count = 1, .reusable = false}, REDUCE(sym_assignment, 3, .production_id = 28),
  [2105] = {.count = 1, .reusable = true}, SHIFT(365),
  [2107] = {.count = 1, .reusable = true}, REDUCE(sym_unary, 2),
  [2109] = {.count = 1, .reusable = false}, REDUCE(sym_unary, 2),
  [2111] = {.count = 1, .reusable = true}, REDUCE(sym_conditional, 5, .production_id = 58),
  [2113] = {.count = 1, .reusable = true}, REDUCE(sym_operator_assignment, 3, .production_id = 28),
  [2115] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3, .production_id = 23),
  [2117] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3, .production_id = 23),
  [2119] = {.count = 1, .reusable = true}, REDUCE(sym_range, 3),
  [2121] = {.count = 1, .reusable = false}, SHIFT(354),
  [2123] = {.count = 1, .reusable = true}, SHIFT(477),
  [2125] = {.count = 1, .reusable = true}, REDUCE(sym_splat_argument, 2),
  [2127] = {.count = 1, .reusable = false}, SHIFT(333),
  [2129] = {.count = 1, .reusable = true}, SHIFT(481),
  [2131] = {.count = 1, .reusable = true}, REDUCE(sym__argument, 1),
  [2133] = {.count = 1, .reusable = true}, SHIFT(546),
  [2135] = {.count = 1, .reusable = false}, SHIFT(573),
  [2137] = {.count = 1, .reusable = true}, SHIFT(574),
  [2139] = {.count = 1, .reusable = false}, SHIFT(586),
  [2141] = {.count = 1, .reusable = false}, SHIFT(598),
  [2143] = {.count = 1, .reusable = true}, SHIFT(454),
  [2145] = {.count = 1, .reusable = false}, SHIFT(672),
  [2147] = {.count = 1, .reusable = true}, SHIFT(672),
  [2149] = {.count = 1, .reusable = true}, SHIFT(677),
  [2151] = {.count = 1, .reusable = true}, SHIFT(702),
  [2153] = {.count = 1, .reusable = true}, SHIFT(598),
  [2155] = {.count = 1, .reusable = true}, SHIFT(573),
  [2157] = {.count = 1, .reusable = true}, SHIFT(531),
  [2159] = {.count = 1, .reusable = true}, SHIFT(559),
  [2161] = {.count = 1, .reusable = false}, SHIFT(724),
  [2163] = {.count = 1, .reusable = true}, SHIFT(724),
  [2165] = {.count = 1, .reusable = false}, SHIFT(343),
  [2167] = {.count = 1, .reusable = true}, SHIFT(732),
  [2169] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(365),
  [2172] = {.count = 1, .reusable = false}, SHIFT(351),
  [2174] = {.count = 1, .reusable = true}, SHIFT(740),
  [2176] = {.count = 1, .reusable = true}, REDUCE(sym_block_argument, 2),
  [2178] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 37),
  [2180] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 36),
  [2182] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(372),
  [2185] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_argument, 2),
  [2187] = {.count = 1, .reusable = true}, SHIFT(372),
  [2189] = {.count = 1, .reusable = false}, SHIFT(1749),
  [2191] = {.count = 1, .reusable = true}, SHIFT(2766),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1749),
  [2195] = {.count = 1, .reusable = false}, SHIFT(438),
  [2197] = {.count = 1, .reusable = true}, SHIFT(434),
  [2199] = {.count = 1, .reusable = false}, SHIFT(433),
  [2201] = {.count = 1, .reusable = false}, SHIFT(431),
  [2203] = {.count = 1, .reusable = true}, SHIFT(560),
  [2205] = {.count = 1, .reusable = false}, SHIFT(429),
  [2207] = {.count = 1, .reusable = true}, SHIFT(429),
  [2209] = {.count = 1, .reusable = true}, SHIFT(427),
  [2211] = {.count = 1, .reusable = true}, SHIFT(425),
  [2213] = {.count = 1, .reusable = true}, SHIFT(431),
  [2215] = {.count = 1, .reusable = true}, SHIFT(438),
  [2217] = {.count = 1, .reusable = true}, SHIFT(451),
  [2219] = {.count = 1, .reusable = true}, SHIFT(448),
  [2221] = {.count = 1, .reusable = false}, SHIFT(424),
  [2223] = {.count = 1, .reusable = true}, SHIFT(424),
  [2225] = {.count = 1, .reusable = true}, SHIFT(376),
  [2227] = {.count = 1, .reusable = false}, SHIFT(542),
  [2229] = {.count = 1, .reusable = true}, SHIFT(579),
  [2231] = {.count = 1, .reusable = false}, SHIFT(591),
  [2233] = {.count = 1, .reusable = false}, SHIFT(594),
  [2235] = {.count = 1, .reusable = true}, SHIFT(656),
  [2237] = {.count = 1, .reusable = false}, SHIFT(610),
  [2239] = {.count = 1, .reusable = true}, SHIFT(610),
  [2241] = {.count = 1, .reusable = true}, SHIFT(664),
  [2243] = {.count = 1, .reusable = true}, SHIFT(665),
  [2245] = {.count = 1, .reusable = true}, SHIFT(594),
  [2247] = {.count = 1, .reusable = true}, SHIFT(542),
  [2249] = {.count = 1, .reusable = true}, SHIFT(522),
  [2251] = {.count = 1, .reusable = true}, SHIFT(537),
  [2253] = {.count = 1, .reusable = false}, SHIFT(666),
  [2255] = {.count = 1, .reusable = true}, SHIFT(666),
  [2257] = {.count = 1, .reusable = true}, SHIFT(730),
  [2259] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(376),
  [2262] = {.count = 1, .reusable = false}, SHIFT(668),
  [2264] = {.count = 1, .reusable = true}, SHIFT(667),
  [2266] = {.count = 1, .reusable = false}, SHIFT(654),
  [2268] = {.count = 1, .reusable = false}, SHIFT(637),
  [2270] = {.count = 1, .reusable = true}, SHIFT(629),
  [2272] = {.count = 1, .reusable = true}, SHIFT(637),
  [2274] = {.count = 1, .reusable = true}, SHIFT(668),
  [2276] = {.count = 1, .reusable = true}, SHIFT(692),
  [2278] = {.count = 1, .reusable = true}, SHIFT(670),
  [2280] = {.count = 1, .reusable = false}, SHIFT(493),
  [2282] = {.count = 1, .reusable = true}, SHIFT(493),
  [2284] = {.count = 1, .reusable = false}, SHIFT(1756),
  [2286] = {.count = 1, .reusable = true}, SHIFT(2757),
  [2288] = {.count = 1, .reusable = true}, SHIFT(1756),
  [2290] = {.count = 1, .reusable = false}, SHIFT(810),
  [2292] = {.count = 1, .reusable = true}, SHIFT(404),
  [2294] = {.count = 1, .reusable = false}, SHIFT(631),
  [2296] = {.count = 1, .reusable = true}, SHIFT(631),
  [2298] = {.count = 1, .reusable = true}, SHIFT(630),
  [2300] = {.count = 1, .reusable = false}, SHIFT(515),
  [2302] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [2304] = {.count = 1, .reusable = false}, SHIFT(2208),
  [2306] = {.count = 1, .reusable = true}, SHIFT(416),
  [2308] = {.count = 1, .reusable = true}, SHIFT(2106),
  [2310] = {.count = 1, .reusable = false}, SHIFT(2106),
  [2312] = {.count = 1, .reusable = true}, SHIFT(2232),
  [2314] = {.count = 1, .reusable = false}, SHIFT(2764),
  [2316] = {.count = 1, .reusable = true}, SHIFT(2107),
  [2318] = {.count = 1, .reusable = true}, SHIFT(2396),
  [2320] = {.count = 1, .reusable = true}, SHIFT(437),
  [2322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2491),
  [2325] = {.count = 1, .reusable = true}, SHIFT(703),
  [2327] = {.count = 1, .reusable = true}, SHIFT(228),
  [2329] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2434),
  [2332] = {.count = 1, .reusable = false}, SHIFT(799),
  [2334] = {.count = 1, .reusable = true}, SHIFT(782),
  [2336] = {.count = 1, .reusable = true}, SHIFT(1539),
  [2338] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2340] = {.count = 1, .reusable = false}, SHIFT(1761),
  [2342] = {.count = 1, .reusable = true}, SHIFT(2740),
  [2344] = {.count = 1, .reusable = true}, SHIFT(1761),
  [2346] = {.count = 1, .reusable = false}, SHIFT(1856),
  [2348] = {.count = 1, .reusable = true}, SHIFT(253),
  [2350] = {.count = 1, .reusable = true}, SHIFT(2879),
  [2352] = {.count = 1, .reusable = true}, SHIFT(1856),
  [2354] = {.count = 1, .reusable = false}, SHIFT(1838),
  [2356] = {.count = 1, .reusable = true}, SHIFT(2917),
  [2358] = {.count = 1, .reusable = true}, SHIFT(1838),
  [2360] = {.count = 1, .reusable = true}, SHIFT(2290),
  [2362] = {.count = 1, .reusable = true}, SHIFT(2108),
  [2364] = {.count = 1, .reusable = false}, SHIFT(1804),
  [2366] = {.count = 1, .reusable = true}, SHIFT(224),
  [2368] = {.count = 1, .reusable = true}, SHIFT(2739),
  [2370] = {.count = 1, .reusable = true}, SHIFT(1804),
  [2372] = {.count = 1, .reusable = false}, SHIFT(1850),
  [2374] = {.count = 1, .reusable = true}, SHIFT(251),
  [2376] = {.count = 1, .reusable = true}, SHIFT(2786),
  [2378] = {.count = 1, .reusable = true}, SHIFT(1850),
  [2380] = {.count = 1, .reusable = true}, SHIFT(2135),
  [2382] = {.count = 1, .reusable = true}, SHIFT(2201),
  [2384] = {.count = 1, .reusable = true}, SHIFT(2119),
  [2386] = {.count = 1, .reusable = false}, SHIFT(2119),
  [2388] = {.count = 1, .reusable = true}, SHIFT(2211),
  [2390] = {.count = 1, .reusable = true}, SHIFT(2222),
  [2392] = {.count = 1, .reusable = true}, SHIFT(2435),
  [2394] = {.count = 1, .reusable = true}, SHIFT(1675),
  [2396] = {.count = 1, .reusable = true}, SHIFT(1691),
  [2398] = {.count = 1, .reusable = false}, SHIFT(1691),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1692),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1697),
  [2404] = {.count = 1, .reusable = true}, SHIFT(2407),
  [2406] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2408] = {.count = 1, .reusable = false}, SHIFT(1904),
  [2410] = {.count = 1, .reusable = true}, SHIFT(2816),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1904),
  [2414] = {.count = 1, .reusable = true}, SHIFT(2327),
  [2416] = {.count = 1, .reusable = true}, SHIFT(2438),
  [2418] = {.count = 1, .reusable = false}, SHIFT(2438),
  [2420] = {.count = 1, .reusable = true}, SHIFT(2462),
  [2422] = {.count = 1, .reusable = true}, SHIFT(2420),
  [2424] = {.count = 1, .reusable = true}, SHIFT(2506),
  [2426] = {.count = 1, .reusable = true}, SHIFT(2523),
  [2428] = {.count = 1, .reusable = false}, SHIFT(830),
  [2430] = {.count = 1, .reusable = true}, SHIFT(831),
  [2432] = {.count = 1, .reusable = false}, SHIFT(834),
  [2434] = {.count = 1, .reusable = false}, SHIFT(837),
  [2436] = {.count = 1, .reusable = true}, SHIFT(856),
  [2438] = {.count = 1, .reusable = false}, SHIFT(858),
  [2440] = {.count = 1, .reusable = true}, SHIFT(858),
  [2442] = {.count = 1, .reusable = true}, SHIFT(857),
  [2444] = {.count = 1, .reusable = true}, SHIFT(824),
  [2446] = {.count = 1, .reusable = true}, SHIFT(837),
  [2448] = {.count = 1, .reusable = true}, SHIFT(830),
  [2450] = {.count = 1, .reusable = true}, SHIFT(820),
  [2452] = {.count = 1, .reusable = true}, SHIFT(828),
  [2454] = {.count = 1, .reusable = false}, SHIFT(812),
  [2456] = {.count = 1, .reusable = true}, SHIFT(812),
  [2458] = {.count = 1, .reusable = true}, SHIFT(381),
  [2460] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(381),
  [2463] = {.count = 1, .reusable = true}, SHIFT(2356),
  [2465] = {.count = 1, .reusable = true}, SHIFT(644),
  [2467] = {.count = 1, .reusable = true}, SHIFT(639),
  [2469] = {.count = 1, .reusable = true}, SHIFT(640),
  [2471] = {.count = 1, .reusable = false}, SHIFT(754),
  [2473] = {.count = 1, .reusable = true}, SHIFT(806),
  [2475] = {.count = 1, .reusable = false}, SHIFT(783),
  [2477] = {.count = 1, .reusable = false}, SHIFT(822),
  [2479] = {.count = 1, .reusable = true}, SHIFT(821),
  [2481] = {.count = 1, .reusable = false}, SHIFT(797),
  [2483] = {.count = 1, .reusable = true}, SHIFT(797),
  [2485] = {.count = 1, .reusable = true}, SHIFT(852),
  [2487] = {.count = 1, .reusable = true}, SHIFT(829),
  [2489] = {.count = 1, .reusable = true}, SHIFT(822),
  [2491] = {.count = 1, .reusable = true}, SHIFT(754),
  [2493] = {.count = 1, .reusable = true}, SHIFT(768),
  [2495] = {.count = 1, .reusable = true}, SHIFT(755),
  [2497] = {.count = 1, .reusable = false}, SHIFT(813),
  [2499] = {.count = 1, .reusable = true}, SHIFT(813),
  [2501] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(382),
  [2504] = {.count = 1, .reusable = false}, SHIFT(643),
  [2506] = {.count = 1, .reusable = false}, SHIFT(707),
  [2508] = {.count = 1, .reusable = false}, SHIFT(576),
  [2510] = {.count = 1, .reusable = true}, SHIFT(568),
  [2512] = {.count = 1, .reusable = false}, SHIFT(566),
  [2514] = {.count = 1, .reusable = true}, SHIFT(566),
  [2516] = {.count = 1, .reusable = true}, SHIFT(565),
  [2518] = {.count = 1, .reusable = true}, SHIFT(564),
  [2520] = {.count = 1, .reusable = true}, SHIFT(576),
  [2522] = {.count = 1, .reusable = true}, SHIFT(643),
  [2524] = {.count = 1, .reusable = false}, SHIFT(563),
  [2526] = {.count = 1, .reusable = true}, SHIFT(563),
  [2528] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2483),
  [2531] = {.count = 1, .reusable = true}, SHIFT(515),
  [2533] = {.count = 1, .reusable = true}, SHIFT(810),
  [2535] = {.count = 1, .reusable = true}, SHIFT(382),
  [2537] = {.count = 1, .reusable = false}, SHIFT(1815),
  [2539] = {.count = 1, .reusable = true}, SHIFT(227),
  [2541] = {.count = 1, .reusable = true}, SHIFT(2743),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1815),
  [2545] = {.count = 1, .reusable = false}, SHIFT(787),
  [2547] = {.count = 1, .reusable = true}, SHIFT(788),
  [2549] = {.count = 1, .reusable = false}, SHIFT(789),
  [2551] = {.count = 1, .reusable = false}, SHIFT(790),
  [2553] = {.count = 1, .reusable = true}, SHIFT(838),
  [2555] = {.count = 1, .reusable = false}, SHIFT(791),
  [2557] = {.count = 1, .reusable = true}, SHIFT(791),
  [2559] = {.count = 1, .reusable = true}, SHIFT(792),
  [2561] = {.count = 1, .reusable = true}, SHIFT(793),
  [2563] = {.count = 1, .reusable = true}, SHIFT(790),
  [2565] = {.count = 1, .reusable = true}, SHIFT(787),
  [2567] = {.count = 1, .reusable = true}, SHIFT(817),
  [2569] = {.count = 1, .reusable = true}, SHIFT(786),
  [2571] = {.count = 1, .reusable = false}, SHIFT(794),
  [2573] = {.count = 1, .reusable = true}, SHIFT(794),
  [2575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(380),
  [2578] = {.count = 1, .reusable = true}, REDUCE(sym__method_name, 1),
  [2580] = {.count = 1, .reusable = false}, REDUCE(sym__method_name, 1),
  [2582] = {.count = 1, .reusable = false}, SHIFT(1701),
  [2584] = {.count = 1, .reusable = true}, SHIFT(380),
  [2586] = {.count = 1, .reusable = true}, SHIFT(799),
  [2588] = {.count = 1, .reusable = true}, SHIFT(384),
  [2590] = {.count = 1, .reusable = false}, SHIFT(836),
  [2592] = {.count = 1, .reusable = true}, SHIFT(757),
  [2594] = {.count = 1, .reusable = false}, SHIFT(758),
  [2596] = {.count = 1, .reusable = false}, SHIFT(770),
  [2598] = {.count = 1, .reusable = true}, SHIFT(772),
  [2600] = {.count = 1, .reusable = false}, SHIFT(773),
  [2602] = {.count = 1, .reusable = true}, SHIFT(773),
  [2604] = {.count = 1, .reusable = true}, SHIFT(827),
  [2606] = {.count = 1, .reusable = true}, SHIFT(850),
  [2608] = {.count = 1, .reusable = true}, SHIFT(770),
  [2610] = {.count = 1, .reusable = true}, SHIFT(836),
  [2612] = {.count = 1, .reusable = true}, SHIFT(818),
  [2614] = {.count = 1, .reusable = true}, SHIFT(771),
  [2616] = {.count = 1, .reusable = false}, SHIFT(855),
  [2618] = {.count = 1, .reusable = true}, SHIFT(855),
  [2620] = {.count = 1, .reusable = true}, REDUCE(sym_setter, 2),
  [2622] = {.count = 1, .reusable = false}, REDUCE(sym_setter, 2),
  [2624] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(384),
  [2627] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(364),
  [2630] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(378),
  [2633] = {.count = 1, .reusable = false}, SHIFT(606),
  [2635] = {.count = 1, .reusable = true}, SHIFT(608),
  [2637] = {.count = 1, .reusable = false}, SHIFT(609),
  [2639] = {.count = 1, .reusable = false}, SHIFT(615),
  [2641] = {.count = 1, .reusable = true}, SHIFT(555),
  [2643] = {.count = 1, .reusable = false}, SHIFT(620),
  [2645] = {.count = 1, .reusable = true}, SHIFT(620),
  [2647] = {.count = 1, .reusable = true}, SHIFT(651),
  [2649] = {.count = 1, .reusable = true}, SHIFT(655),
  [2651] = {.count = 1, .reusable = true}, SHIFT(615),
  [2653] = {.count = 1, .reusable = true}, SHIFT(606),
  [2655] = {.count = 1, .reusable = true}, SHIFT(595),
  [2657] = {.count = 1, .reusable = true}, SHIFT(602),
  [2659] = {.count = 1, .reusable = false}, SHIFT(671),
  [2661] = {.count = 1, .reusable = true}, SHIFT(671),
  [2663] = {.count = 1, .reusable = true}, SHIFT(378),
  [2665] = {.count = 1, .reusable = true}, SHIFT(361),
  [2667] = {.count = 1, .reusable = false}, SHIFT(697),
  [2669] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 1),
  [2671] = {.count = 1, .reusable = true}, SHIFT(693),
  [2673] = {.count = 1, .reusable = false}, SHIFT(691),
  [2675] = {.count = 1, .reusable = false}, SHIFT(690),
  [2677] = {.count = 1, .reusable = true}, SHIFT(561),
  [2679] = {.count = 1, .reusable = false}, SHIFT(689),
  [2681] = {.count = 1, .reusable = true}, SHIFT(689),
  [2683] = {.count = 1, .reusable = true}, SHIFT(688),
  [2685] = {.count = 1, .reusable = true}, SHIFT(686),
  [2687] = {.count = 1, .reusable = true}, SHIFT(685),
  [2689] = {.count = 1, .reusable = true}, SHIFT(690),
  [2691] = {.count = 1, .reusable = true}, SHIFT(697),
  [2693] = {.count = 1, .reusable = true}, SHIFT(700),
  [2695] = {.count = 1, .reusable = true}, SHIFT(699),
  [2697] = {.count = 1, .reusable = false}, SHIFT(684),
  [2699] = {.count = 1, .reusable = true}, SHIFT(684),
  [2701] = {.count = 1, .reusable = true}, SHIFT(364),
  [2703] = {.count = 1, .reusable = true}, SHIFT(292),
  [2705] = {.count = 1, .reusable = true}, SHIFT(269),
  [2707] = {.count = 1, .reusable = false}, SHIFT(269),
  [2709] = {.count = 1, .reusable = true}, SHIFT(250),
  [2711] = {.count = 1, .reusable = false}, SHIFT(847),
  [2713] = {.count = 1, .reusable = true}, SHIFT(846),
  [2715] = {.count = 1, .reusable = false}, SHIFT(845),
  [2717] = {.count = 1, .reusable = false}, SHIFT(844),
  [2719] = {.count = 1, .reusable = true}, SHIFT(760),
  [2721] = {.count = 1, .reusable = false}, SHIFT(843),
  [2723] = {.count = 1, .reusable = true}, SHIFT(843),
  [2725] = {.count = 1, .reusable = true}, SHIFT(842),
  [2727] = {.count = 1, .reusable = true}, SHIFT(841),
  [2729] = {.count = 1, .reusable = true}, SHIFT(844),
  [2731] = {.count = 1, .reusable = true}, SHIFT(847),
  [2733] = {.count = 1, .reusable = true}, SHIFT(849),
  [2735] = {.count = 1, .reusable = true}, SHIFT(848),
  [2737] = {.count = 1, .reusable = false}, SHIFT(840),
  [2739] = {.count = 1, .reusable = true}, SHIFT(840),
  [2741] = {.count = 1, .reusable = true}, SHIFT(2195),
  [2743] = {.count = 1, .reusable = true}, SHIFT(2200),
  [2745] = {.count = 1, .reusable = false}, SHIFT(2200),
  [2747] = {.count = 1, .reusable = true}, SHIFT(249),
  [2749] = {.count = 1, .reusable = true}, SHIFT(325),
  [2751] = {.count = 1, .reusable = true}, SHIFT(320),
  [2753] = {.count = 1, .reusable = false}, SHIFT(320),
  [2755] = {.count = 1, .reusable = true}, SHIFT(236),
  [2757] = {.count = 1, .reusable = true}, SHIFT(329),
  [2759] = {.count = 1, .reusable = true}, SHIFT(352),
  [2761] = {.count = 1, .reusable = false}, SHIFT(352),
  [2763] = {.count = 1, .reusable = true}, SHIFT(230),
  [2765] = {.count = 1, .reusable = true}, SHIFT(891),
  [2767] = {.count = 1, .reusable = true}, SHIFT(887),
  [2769] = {.count = 1, .reusable = false}, SHIFT(887),
  [2771] = {.count = 1, .reusable = false}, SHIFT(391),
  [2773] = {.count = 1, .reusable = true}, SHIFT(402),
  [2775] = {.count = 1, .reusable = false}, SHIFT(403),
  [2777] = {.count = 1, .reusable = false}, SHIFT(410),
  [2779] = {.count = 1, .reusable = true}, SHIFT(572),
  [2781] = {.count = 1, .reusable = false}, SHIFT(412),
  [2783] = {.count = 1, .reusable = true}, SHIFT(412),
  [2785] = {.count = 1, .reusable = true}, SHIFT(426),
  [2787] = {.count = 1, .reusable = true}, SHIFT(439),
  [2789] = {.count = 1, .reusable = true}, SHIFT(410),
  [2791] = {.count = 1, .reusable = true}, SHIFT(391),
  [2793] = {.count = 1, .reusable = true}, SHIFT(526),
  [2795] = {.count = 1, .reusable = true}, SHIFT(443),
  [2797] = {.count = 1, .reusable = false}, SHIFT(440),
  [2799] = {.count = 1, .reusable = true}, SHIFT(440),
  [2801] = {.count = 1, .reusable = true}, SHIFT(360),
  [2803] = {.count = 1, .reusable = false}, SHIFT(539),
  [2805] = {.count = 1, .reusable = true}, SHIFT(538),
  [2807] = {.count = 1, .reusable = false}, SHIFT(528),
  [2809] = {.count = 1, .reusable = false}, SHIFT(518),
  [2811] = {.count = 1, .reusable = true}, SHIFT(570),
  [2813] = {.count = 1, .reusable = false}, SHIFT(517),
  [2815] = {.count = 1, .reusable = true}, SHIFT(517),
  [2817] = {.count = 1, .reusable = true}, SHIFT(516),
  [2819] = {.count = 1, .reusable = true}, SHIFT(509),
  [2821] = {.count = 1, .reusable = true}, SHIFT(518),
  [2823] = {.count = 1, .reusable = true}, SHIFT(539),
  [2825] = {.count = 1, .reusable = true}, SHIFT(543),
  [2827] = {.count = 1, .reusable = true}, SHIFT(541),
  [2829] = {.count = 1, .reusable = false}, SHIFT(507),
  [2831] = {.count = 1, .reusable = true}, SHIFT(507),
  [2833] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(367),
  [2836] = {.count = 1, .reusable = true}, SHIFT(2215),
  [2838] = {.count = 1, .reusable = true}, SHIFT(229),
  [2840] = {.count = 1, .reusable = true}, SHIFT(367),
  [2842] = {.count = 1, .reusable = false}, SHIFT(706),
  [2844] = {.count = 1, .reusable = true}, SHIFT(725),
  [2846] = {.count = 1, .reusable = false}, SHIFT(726),
  [2848] = {.count = 1, .reusable = false}, SHIFT(727),
  [2850] = {.count = 1, .reusable = true}, SHIFT(971),
  [2852] = {.count = 1, .reusable = true}, SHIFT(512),
  [2854] = {.count = 1, .reusable = false}, SHIFT(735),
  [2856] = {.count = 1, .reusable = true}, SHIFT(735),
  [2858] = {.count = 1, .reusable = true}, SHIFT(739),
  [2860] = {.count = 1, .reusable = true}, SHIFT(743),
  [2862] = {.count = 1, .reusable = true}, SHIFT(746),
  [2864] = {.count = 1, .reusable = true}, SHIFT(727),
  [2866] = {.count = 1, .reusable = true}, SHIFT(706),
  [2868] = {.count = 1, .reusable = true}, SHIFT(682),
  [2870] = {.count = 1, .reusable = true}, SHIFT(683),
  [2872] = {.count = 1, .reusable = false}, SHIFT(749),
  [2874] = {.count = 1, .reusable = true}, SHIFT(749),
  [2876] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(360),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2883] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2885] = {.count = 1, .reusable = true}, SHIFT(377),
  [2887] = {.count = 1, .reusable = false}, SHIFT(485),
  [2889] = {.count = 1, .reusable = true}, SHIFT(457),
  [2891] = {.count = 1, .reusable = false}, SHIFT(632),
  [2893] = {.count = 1, .reusable = false}, SHIFT(502),
  [2895] = {.count = 1, .reusable = true}, SHIFT(486),
  [2897] = {.count = 1, .reusable = false}, SHIFT(504),
  [2899] = {.count = 1, .reusable = true}, SHIFT(504),
  [2901] = {.count = 1, .reusable = true}, SHIFT(510),
  [2903] = {.count = 1, .reusable = true}, SHIFT(519),
  [2905] = {.count = 1, .reusable = true}, SHIFT(502),
  [2907] = {.count = 1, .reusable = true}, SHIFT(485),
  [2909] = {.count = 1, .reusable = true}, SHIFT(479),
  [2911] = {.count = 1, .reusable = true}, SHIFT(483),
  [2913] = {.count = 1, .reusable = false}, SHIFT(520),
  [2915] = {.count = 1, .reusable = true}, SHIFT(520),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2921] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2923] = {.count = 1, .reusable = true}, SHIFT(907),
  [2925] = {.count = 1, .reusable = true}, SHIFT(918),
  [2927] = {.count = 1, .reusable = false}, SHIFT(918),
  [2929] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(377),
  [2932] = {.count = 1, .reusable = true}, SHIFT(265),
  [2934] = {.count = 1, .reusable = true}, SHIFT(261),
  [2936] = {.count = 1, .reusable = false}, SHIFT(261),
  [2938] = {.count = 1, .reusable = true}, SHIFT(226),
  [2940] = {.count = 1, .reusable = true}, SHIFT(995),
  [2942] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2944] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2946] = {.count = 1, .reusable = true}, REDUCE(sym_pattern, 1),
  [2948] = {.count = 1, .reusable = true}, SHIFT(423),
  [2950] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2952] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2954] = {.count = 1, .reusable = false}, SHIFT(1021),
  [2956] = {.count = 1, .reusable = true}, SHIFT(649),
  [2958] = {.count = 1, .reusable = true}, SHIFT(449),
  [2960] = {.count = 1, .reusable = true}, SHIFT(418),
  [2962] = {.count = 1, .reusable = false}, SHIFT(418),
  [2964] = {.count = 1, .reusable = true}, SHIFT(264),
  [2966] = {.count = 1, .reusable = true}, SHIFT(363),
  [2968] = {.count = 1, .reusable = true}, SHIFT(505),
  [2970] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(363),
  [2973] = {.count = 1, .reusable = false}, SHIFT(612),
  [2975] = {.count = 1, .reusable = true}, SHIFT(617),
  [2977] = {.count = 1, .reusable = false}, SHIFT(618),
  [2979] = {.count = 1, .reusable = false}, SHIFT(619),
  [2981] = {.count = 1, .reusable = true}, SHIFT(585),
  [2983] = {.count = 1, .reusable = false}, SHIFT(621),
  [2985] = {.count = 1, .reusable = true}, SHIFT(621),
  [2987] = {.count = 1, .reusable = true}, SHIFT(626),
  [2989] = {.count = 1, .reusable = true}, SHIFT(638),
  [2991] = {.count = 1, .reusable = true}, SHIFT(619),
  [2993] = {.count = 1, .reusable = true}, SHIFT(612),
  [2995] = {.count = 1, .reusable = true}, SHIFT(600),
  [2997] = {.count = 1, .reusable = true}, SHIFT(604),
  [2999] = {.count = 1, .reusable = false}, SHIFT(647),
  [3001] = {.count = 1, .reusable = true}, SHIFT(647),
  [3003] = {.count = 1, .reusable = true}, SHIFT(774),
  [3005] = {.count = 1, .reusable = true}, SHIFT(853),
  [3007] = {.count = 1, .reusable = false}, SHIFT(853),
  [3009] = {.count = 1, .reusable = true}, SHIFT(266),
  [3011] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 3, .production_id = 46),
  [3013] = {.count = 1, .reusable = true}, SHIFT(622),
  [3015] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 46),
  [3017] = {.count = 1, .reusable = true}, SHIFT(371),
  [3019] = {.count = 1, .reusable = false}, SHIFT(469),
  [3021] = {.count = 1, .reusable = true}, SHIFT(408),
  [3023] = {.count = 1, .reusable = false}, SHIFT(738),
  [3025] = {.count = 1, .reusable = false}, SHIFT(506),
  [3027] = {.count = 1, .reusable = true}, SHIFT(458),
  [3029] = {.count = 1, .reusable = false}, SHIFT(613),
  [3031] = {.count = 1, .reusable = true}, SHIFT(613),
  [3033] = {.count = 1, .reusable = true}, SHIFT(614),
  [3035] = {.count = 1, .reusable = true}, SHIFT(616),
  [3037] = {.count = 1, .reusable = true}, SHIFT(698),
  [3039] = {.count = 1, .reusable = true}, SHIFT(506),
  [3041] = {.count = 1, .reusable = true}, SHIFT(469),
  [3043] = {.count = 1, .reusable = true}, SHIFT(489),
  [3045] = {.count = 1, .reusable = true}, SHIFT(476),
  [3047] = {.count = 1, .reusable = false}, SHIFT(705),
  [3049] = {.count = 1, .reusable = true}, SHIFT(705),
  [3051] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(371),
  [3054] = {.count = 1, .reusable = true}, REDUCE(sym_in, 2),
  [3056] = {.count = 1, .reusable = false}, SHIFT(395),
  [3058] = {.count = 1, .reusable = true}, SHIFT(398),
  [3060] = {.count = 1, .reusable = false}, SHIFT(634),
  [3062] = {.count = 1, .reusable = false}, SHIFT(405),
  [3064] = {.count = 1, .reusable = true}, SHIFT(588),
  [3066] = {.count = 1, .reusable = false}, SHIFT(419),
  [3068] = {.count = 1, .reusable = true}, SHIFT(419),
  [3070] = {.count = 1, .reusable = true}, SHIFT(420),
  [3072] = {.count = 1, .reusable = true}, SHIFT(428),
  [3074] = {.count = 1, .reusable = true}, SHIFT(405),
  [3076] = {.count = 1, .reusable = true}, SHIFT(395),
  [3078] = {.count = 1, .reusable = true}, SHIFT(390),
  [3080] = {.count = 1, .reusable = true}, SHIFT(394),
  [3082] = {.count = 1, .reusable = false}, SHIFT(430),
  [3084] = {.count = 1, .reusable = true}, SHIFT(430),
  [3086] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 3, .production_id = 46),
  [3088] = {.count = 1, .reusable = true}, REDUCE(sym_superclass, 2),
  [3090] = {.count = 1, .reusable = false}, REDUCE(sym_optional_parameter, 3, .production_id = 46),
  [3092] = {.count = 1, .reusable = true}, SHIFT(2775),
  [3094] = {.count = 1, .reusable = false}, SHIFT(657),
  [3096] = {.count = 1, .reusable = true}, SHIFT(660),
  [3098] = {.count = 1, .reusable = false}, SHIFT(661),
  [3100] = {.count = 1, .reusable = false}, SHIFT(662),
  [3102] = {.count = 1, .reusable = true}, SHIFT(556),
  [3104] = {.count = 1, .reusable = false}, SHIFT(663),
  [3106] = {.count = 1, .reusable = true}, SHIFT(663),
  [3108] = {.count = 1, .reusable = true}, SHIFT(674),
  [3110] = {.count = 1, .reusable = true}, SHIFT(679),
  [3112] = {.count = 1, .reusable = true}, SHIFT(680),
  [3114] = {.count = 1, .reusable = true}, SHIFT(662),
  [3116] = {.count = 1, .reusable = true}, SHIFT(657),
  [3118] = {.count = 1, .reusable = true}, SHIFT(571),
  [3120] = {.count = 1, .reusable = true}, SHIFT(580),
  [3122] = {.count = 1, .reusable = false}, SHIFT(695),
  [3124] = {.count = 1, .reusable = true}, SHIFT(695),
  [3126] = {.count = 1, .reusable = false}, SHIFT(710),
  [3128] = {.count = 1, .reusable = true}, SHIFT(711),
  [3130] = {.count = 1, .reusable = false}, SHIFT(712),
  [3132] = {.count = 1, .reusable = false}, SHIFT(713),
  [3134] = {.count = 1, .reusable = false}, SHIFT(715),
  [3136] = {.count = 1, .reusable = true}, SHIFT(715),
  [3138] = {.count = 1, .reusable = true}, SHIFT(717),
  [3140] = {.count = 1, .reusable = true}, SHIFT(718),
  [3142] = {.count = 1, .reusable = true}, SHIFT(713),
  [3144] = {.count = 1, .reusable = true}, SHIFT(710),
  [3146] = {.count = 1, .reusable = true}, SHIFT(708),
  [3148] = {.count = 1, .reusable = true}, SHIFT(709),
  [3150] = {.count = 1, .reusable = false}, SHIFT(719),
  [3152] = {.count = 1, .reusable = true}, SHIFT(719),
  [3154] = {.count = 1, .reusable = false}, SHIFT(736),
  [3156] = {.count = 1, .reusable = true}, SHIFT(733),
  [3158] = {.count = 1, .reusable = false}, SHIFT(731),
  [3160] = {.count = 1, .reusable = false}, SHIFT(659),
  [3162] = {.count = 1, .reusable = true}, SHIFT(562),
  [3164] = {.count = 1, .reusable = true}, SHIFT(460),
  [3166] = {.count = 1, .reusable = false}, SHIFT(497),
  [3168] = {.count = 1, .reusable = true}, SHIFT(497),
  [3170] = {.count = 1, .reusable = true}, SHIFT(544),
  [3172] = {.count = 1, .reusable = true}, SHIFT(514),
  [3174] = {.count = 1, .reusable = true}, SHIFT(623),
  [3176] = {.count = 1, .reusable = true}, SHIFT(659),
  [3178] = {.count = 1, .reusable = true}, SHIFT(736),
  [3180] = {.count = 1, .reusable = true}, SHIFT(575),
  [3182] = {.count = 1, .reusable = true}, SHIFT(587),
  [3184] = {.count = 1, .reusable = false}, SHIFT(590),
  [3186] = {.count = 1, .reusable = true}, SHIFT(590),
  [3188] = {.count = 1, .reusable = true}, SHIFT(2750),
  [3190] = {.count = 1, .reusable = true}, SHIFT(388),
  [3192] = {.count = 1, .reusable = true}, SHIFT(421),
  [3194] = {.count = 1, .reusable = true}, SHIFT(523),
  [3196] = {.count = 1, .reusable = true}, SHIFT(2774),
  [3198] = {.count = 1, .reusable = true}, SHIFT(696),
  [3200] = {.count = 1, .reusable = true}, SHIFT(748),
  [3202] = {.count = 1, .reusable = true}, SHIFT(747),
  [3204] = {.count = 1, .reusable = true}, SHIFT(741),
  [3206] = {.count = 1, .reusable = true}, SHIFT(484),
  [3208] = {.count = 1, .reusable = true}, SHIFT(627),
  [3210] = {.count = 1, .reusable = true}, SHIFT(716),
  [3212] = {.count = 1, .reusable = true}, SHIFT(650),
  [3214] = {.count = 1, .reusable = true}, SHIFT(658),
  [3216] = {.count = 1, .reusable = true}, SHIFT(567),
  [3218] = {.count = 1, .reusable = true}, SHIFT(422),
  [3220] = {.count = 1, .reusable = true}, SHIFT(397),
  [3222] = {.count = 1, .reusable = true}, SHIFT(750),
  [3224] = {.count = 1, .reusable = true}, SHIFT(396),
  [3226] = {.count = 1, .reusable = true}, SHIFT(589),
  [3228] = {.count = 1, .reusable = true}, SHIFT(466),
  [3230] = {.count = 1, .reusable = true}, SHIFT(756),
  [3232] = {.count = 1, .reusable = true}, SHIFT(851),
  [3234] = {.count = 1, .reusable = true}, SHIFT(808),
  [3236] = {.count = 1, .reusable = true}, SHIFT(832),
  [3238] = {.count = 1, .reusable = true}, SHIFT(2861),
  [3240] = {.count = 1, .reusable = true}, SHIFT(833),
  [3242] = {.count = 1, .reusable = true}, REDUCE(sym_command_call, 2, .production_id = 8),
  [3244] = {.count = 1, .reusable = true}, SHIFT(159),
  [3246] = {.count = 1, .reusable = true}, SHIFT(27),
  [3248] = {.count = 1, .reusable = true}, REDUCE(sym_command_argument_list, 1),
  [3250] = {.count = 1, .reusable = true}, SHIFT(275),
  [3252] = {.count = 1, .reusable = true}, REDUCE(sym_command_argument_list, 2),
  [3254] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2),
  [3256] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(275),
  [3259] = {.count = 1, .reusable = true}, REDUCE(sym_command_call, 3, .production_id = 27),
  [3261] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(273),
  [3264] = {.count = 1, .reusable = true}, SHIFT(273),
  [3266] = {.count = 1, .reusable = true}, REDUCE(sym_break_command, 2),
  [3268] = {.count = 1, .reusable = true}, REDUCE(sym_yield_command, 2),
  [3270] = {.count = 1, .reusable = true}, REDUCE(sym_command_binary, 3, .production_id = 23),
  [3272] = {.count = 1, .reusable = true}, REDUCE(sym_next_command, 2),
  [3274] = {.count = 1, .reusable = true}, REDUCE(sym_return_command, 2),
  [3276] = {.count = 1, .reusable = true}, REDUCE(sym_command_assignment, 3, .production_id = 28),
  [3278] = {.count = 1, .reusable = true}, REDUCE(sym_command_operator_assignment, 3),
  [3280] = {.count = 1, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2),
  [3282] = {.count = 1, .reusable = true}, REDUCE(sym_rescue_modifier, 3, .production_id = 22),
  [3284] = {.count = 1, .reusable = true}, SHIFT(293),
  [3286] = {.count = 1, .reusable = true}, REDUCE(sym_alias, 3, .production_id = 17),
  [3288] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 4),
  [3290] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 4),
  [3292] = {.count = 1, .reusable = true}, REDUCE(sym__statement, 1),
  [3294] = {.count = 1, .reusable = true}, REDUCE(sym_unless_modifier, 3, .production_id = 21),
  [3296] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 3),
  [3298] = {.count = 1, .reusable = false}, SHIFT(2539),
  [3300] = {.count = 1, .reusable = true}, SHIFT(162),
  [3302] = {.count = 1, .reusable = true}, SHIFT(2159),
  [3304] = {.count = 1, .reusable = false}, SHIFT(2358),
  [3306] = {.count = 1, .reusable = true}, SHIFT(2347),
  [3308] = {.count = 1, .reusable = true}, SHIFT(2893),
  [3310] = {.count = 1, .reusable = false}, SHIFT(25),
  [3312] = {.count = 1, .reusable = true}, SHIFT(166),
  [3314] = {.count = 1, .reusable = false}, SHIFT(24),
  [3316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1592),
  [3319] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 2),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3323] = {.count = 1, .reusable = true}, REDUCE(sym_if_modifier, 3, .production_id = 21),
  [3325] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 3),
  [3327] = {.count = 1, .reusable = true}, REDUCE(sym_until_modifier, 3, .production_id = 21),
  [3329] = {.count = 1, .reusable = true}, SHIFT(2105),
  [3331] = {.count = 1, .reusable = true}, SHIFT(163),
  [3333] = {.count = 1, .reusable = false}, SHIFT(26),
  [3335] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 3),
  [3337] = {.count = 1, .reusable = true}, REDUCE(sym_while_modifier, 3, .production_id = 21),
  [3339] = {.count = 1, .reusable = true}, SHIFT(2532),
  [3341] = {.count = 1, .reusable = true}, SHIFT(2749),
  [3343] = {.count = 1, .reusable = true}, SHIFT(964),
  [3345] = {.count = 1, .reusable = true}, SHIFT(2801),
  [3347] = {.count = 1, .reusable = true}, SHIFT(2504),
  [3349] = {.count = 1, .reusable = true}, SHIFT(2157),
  [3351] = {.count = 1, .reusable = false}, SHIFT(2630),
  [3353] = {.count = 1, .reusable = true}, SHIFT(2627),
  [3355] = {.count = 1, .reusable = true}, SHIFT(2819),
  [3357] = {.count = 1, .reusable = true}, SHIFT(2763),
  [3359] = {.count = 1, .reusable = true}, SHIFT(970),
  [3361] = {.count = 1, .reusable = true}, SHIFT(2825),
  [3363] = {.count = 1, .reusable = true}, SHIFT(169),
  [3365] = {.count = 1, .reusable = false}, SHIFT(33),
  [3367] = {.count = 1, .reusable = true}, SHIFT(463),
  [3369] = {.count = 1, .reusable = true}, SHIFT(26),
  [3371] = {.count = 1, .reusable = true}, SHIFT(975),
  [3373] = {.count = 1, .reusable = true}, SHIFT(2903),
  [3375] = {.count = 1, .reusable = true}, SHIFT(958),
  [3377] = {.count = 1, .reusable = true}, SHIFT(2807),
  [3379] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [3381] = {.count = 1, .reusable = true}, SHIFT(280),
  [3383] = {.count = 1, .reusable = true}, SHIFT(281),
  [3385] = {.count = 1, .reusable = true}, SHIFT(284),
  [3387] = {.count = 1, .reusable = true}, SHIFT(268),
  [3389] = {.count = 1, .reusable = true}, SHIFT(287),
  [3391] = {.count = 1, .reusable = true}, SHIFT(960),
  [3393] = {.count = 1, .reusable = true}, SHIFT(2808),
  [3395] = {.count = 1, .reusable = true}, SHIFT(978),
  [3397] = {.count = 1, .reusable = true}, SHIFT(2916),
  [3399] = {.count = 1, .reusable = true}, SHIFT(2578),
  [3401] = {.count = 1, .reusable = true}, SHIFT(2598),
  [3403] = {.count = 1, .reusable = true}, SHIFT(2734),
  [3405] = {.count = 1, .reusable = true}, SHIFT(957),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3409] = {.count = 1, .reusable = true}, SHIFT(2476),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1098),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3415] = {.count = 1, .reusable = true}, SHIFT(2539),
  [3417] = {.count = 1, .reusable = true}, SHIFT(2156),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3421] = {.count = 1, .reusable = true}, SHIFT(167),
  [3423] = {.count = 1, .reusable = true}, SHIFT(31),
  [3425] = {.count = 1, .reusable = true}, SHIFT(274),
  [3427] = {.count = 1, .reusable = true}, SHIFT(295),
  [3429] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1581),
  [3432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(295),
  [3435] = {.count = 1, .reusable = true}, SHIFT(2202),
  [3437] = {.count = 1, .reusable = true}, SHIFT(146),
  [3439] = {.count = 1, .reusable = true}, SHIFT(965),
  [3441] = {.count = 1, .reusable = true}, SHIFT(279),
  [3443] = {.count = 1, .reusable = true}, SHIFT(278),
  [3445] = {.count = 1, .reusable = true}, SHIFT(277),
  [3447] = {.count = 1, .reusable = true}, SHIFT(276),
  [3449] = {.count = 1, .reusable = true}, SHIFT(267),
  [3451] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(304),
  [3454] = {.count = 1, .reusable = true}, SHIFT(304),
  [3456] = {.count = 1, .reusable = true}, SHIFT(910),
  [3458] = {.count = 1, .reusable = true}, SHIFT(263),
  [3460] = {.count = 1, .reusable = true}, SHIFT(148),
  [3462] = {.count = 1, .reusable = true}, SHIFT(158),
  [3464] = {.count = 1, .reusable = true}, SHIFT(1065),
  [3466] = {.count = 1, .reusable = true}, SHIFT(2264),
  [3468] = {.count = 1, .reusable = false}, SHIFT(214),
  [3470] = {.count = 1, .reusable = false}, SHIFT(2422),
  [3472] = {.count = 1, .reusable = false}, SHIFT(2492),
  [3474] = {.count = 1, .reusable = true}, SHIFT(2492),
  [3476] = {.count = 1, .reusable = true}, SHIFT(1164),
  [3478] = {.count = 1, .reusable = true}, SHIFT(2568),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1194),
  [3482] = {.count = 1, .reusable = true}, SHIFT(357),
  [3484] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3486] = {.count = 1, .reusable = true}, SHIFT(938),
  [3488] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3490] = {.count = 1, .reusable = true}, SHIFT(1191),
  [3492] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3494] = {.count = 1, .reusable = true}, SHIFT(1185),
  [3496] = {.count = 1, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2),
  [3498] = {.count = 2, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2), SHIFT_REPEAT(263),
  [3501] = {.count = 2, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2), SHIFT_REPEAT(148),
  [3504] = {.count = 2, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2), SHIFT_REPEAT(158),
  [3507] = {.count = 1, .reusable = true}, SHIFT(934),
  [3509] = {.count = 1, .reusable = false}, SHIFT(2402),
  [3511] = {.count = 1, .reusable = true}, SHIFT(2575),
  [3513] = {.count = 1, .reusable = false}, SHIFT(2412),
  [3515] = {.count = 1, .reusable = true}, SHIFT(2587),
  [3517] = {.count = 1, .reusable = false}, SHIFT(2453),
  [3519] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3521] = {.count = 1, .reusable = true}, SHIFT(1206),
  [3523] = {.count = 1, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2),
  [3525] = {.count = 1, .reusable = false}, SHIFT(2404),
  [3527] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1222),
  [3531] = {.count = 1, .reusable = true}, SHIFT(2624),
  [3533] = {.count = 1, .reusable = true}, SHIFT(2632),
  [3535] = {.count = 1, .reusable = true}, SHIFT(2276),
  [3537] = {.count = 1, .reusable = false}, SHIFT(2397),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1118),
  [3541] = {.count = 1, .reusable = false}, SHIFT(2415),
  [3543] = {.count = 1, .reusable = true}, SHIFT(1103),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3547] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3549] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 2),
  [3551] = {.count = 1, .reusable = true}, SHIFT(2564),
  [3553] = {.count = 1, .reusable = true}, SHIFT(921),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1121),
  [3557] = {.count = 1, .reusable = true}, SHIFT(2084),
  [3559] = {.count = 1, .reusable = false}, SHIFT(2449),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3563] = {.count = 1, .reusable = false}, SHIFT(2448),
  [3565] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1122),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1062),
  [3571] = {.count = 1, .reusable = true}, SHIFT(2081),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1102),
  [3575] = {.count = 1, .reusable = false}, SHIFT(2461),
  [3577] = {.count = 1, .reusable = true}, SHIFT(2658),
  [3579] = {.count = 1, .reusable = false}, SHIFT(2429),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1152),
  [3583] = {.count = 1, .reusable = false}, SHIFT(2470),
  [3585] = {.count = 1, .reusable = true}, SHIFT(2656),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3589] = {.count = 1, .reusable = true}, SHIFT(2650),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1091),
  [3593] = {.count = 1, .reusable = true}, SHIFT(2233),
  [3595] = {.count = 1, .reusable = true}, SHIFT(2230),
  [3597] = {.count = 1, .reusable = true}, REDUCE(sym_exception_variable, 2),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3603] = {.count = 1, .reusable = true}, SHIFT(2391),
  [3605] = {.count = 1, .reusable = true}, SHIFT(302),
  [3607] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2390),
  [3610] = {.count = 1, .reusable = true}, SHIFT(336),
  [3612] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3614] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3616] = {.count = 1, .reusable = false}, SHIFT(2386),
  [3618] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3620] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3622] = {.count = 1, .reusable = false}, SHIFT(2376),
  [3624] = {.count = 1, .reusable = true}, SHIFT(1127),
  [3626] = {.count = 1, .reusable = true}, SHIFT(1066),
  [3628] = {.count = 1, .reusable = false}, SHIFT(2489),
  [3630] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3632] = {.count = 1, .reusable = false}, SHIFT(2527),
  [3634] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3636] = {.count = 1, .reusable = false}, REDUCE(aux_sym_symbol_array_repeat1, 2, .production_id = 35),
  [3638] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2, .production_id = 35),
  [3640] = {.count = 1, .reusable = false}, SHIFT(2377),
  [3642] = {.count = 1, .reusable = true}, SHIFT(1128),
  [3644] = {.count = 1, .reusable = false}, SHIFT(2467),
  [3646] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 1),
  [3648] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_parameter, 1),
  [3650] = {.count = 1, .reusable = true}, SHIFT(1026),
  [3652] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(214),
  [3655] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_contents, 2),
  [3657] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(2492),
  [3660] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(2492),
  [3663] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents, 2),
  [3665] = {.count = 1, .reusable = false}, SHIFT(2838),
  [3667] = {.count = 1, .reusable = true}, SHIFT(2657),
  [3669] = {.count = 1, .reusable = false}, SHIFT(2798),
  [3671] = {.count = 1, .reusable = true}, SHIFT(2654),
  [3673] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_array_repeat1, 2, .production_id = 32),
  [3675] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2, .production_id = 32),
  [3677] = {.count = 1, .reusable = true}, SHIFT(1030),
  [3679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1595),
  [3682] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3684] = {.count = 1, .reusable = false}, SHIFT(2469),
  [3686] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 1),
  [3688] = {.count = 1, .reusable = false}, REDUCE(sym_splat_parameter, 1),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3692] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 1),
  [3694] = {.count = 1, .reusable = false}, SHIFT(2880),
  [3696] = {.count = 1, .reusable = true}, SHIFT(1136),
  [3698] = {.count = 1, .reusable = false}, SHIFT(2783),
  [3700] = {.count = 1, .reusable = true}, SHIFT(1130),
  [3702] = {.count = 1, .reusable = false}, SHIFT(2515),
  [3704] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3706] = {.count = 1, .reusable = false}, SHIFT(2823),
  [3708] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3710] = {.count = 1, .reusable = false}, SHIFT(2351),
  [3712] = {.count = 1, .reusable = true}, SHIFT(2552),
  [3714] = {.count = 1, .reusable = false}, SHIFT(2352),
  [3716] = {.count = 1, .reusable = true}, SHIFT(2553),
  [3718] = {.count = 1, .reusable = false}, SHIFT(2512),
  [3720] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3722] = {.count = 1, .reusable = false}, SHIFT(2379),
  [3724] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3726] = {.count = 1, .reusable = false}, SHIFT(2836),
  [3728] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3730] = {.count = 1, .reusable = false}, SHIFT(208),
  [3732] = {.count = 1, .reusable = true}, SHIFT(2597),
  [3734] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3736] = {.count = 1, .reusable = true}, SHIFT(2665),
  [3738] = {.count = 1, .reusable = true}, SHIFT(1409),
  [3740] = {.count = 1, .reusable = true}, SHIFT(2529),
  [3742] = {.count = 1, .reusable = false}, SHIFT(2399),
  [3744] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3746] = {.count = 1, .reusable = false}, SHIFT(2401),
  [3748] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3750] = {.count = 1, .reusable = true}, SHIFT(2099),
  [3752] = {.count = 1, .reusable = true}, SHIFT(1159),
  [3754] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3756] = {.count = 1, .reusable = false}, SHIFT(2960),
  [3758] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3760] = {.count = 1, .reusable = true}, SHIFT(2554),
  [3762] = {.count = 1, .reusable = false}, SHIFT(2964),
  [3764] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3766] = {.count = 1, .reusable = true}, SHIFT(2634),
  [3768] = {.count = 1, .reusable = true}, REDUCE(sym_then, 2),
  [3770] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3772] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3774] = {.count = 1, .reusable = true}, SHIFT(2103),
  [3776] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3778] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1162),
  [3782] = {.count = 1, .reusable = true}, SHIFT(2635),
  [3784] = {.count = 1, .reusable = true}, SHIFT(2637),
  [3786] = {.count = 1, .reusable = true}, SHIFT(1151),
  [3788] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3790] = {.count = 1, .reusable = true}, SHIFT(1166),
  [3792] = {.count = 1, .reusable = true}, SHIFT(1160),
  [3794] = {.count = 1, .reusable = true}, SHIFT(1095),
  [3796] = {.count = 1, .reusable = true}, SHIFT(2499),
  [3798] = {.count = 1, .reusable = true}, SHIFT(1174),
  [3800] = {.count = 1, .reusable = true}, SHIFT(1045),
  [3802] = {.count = 1, .reusable = true}, SHIFT(2652),
  [3804] = {.count = 1, .reusable = true}, SHIFT(1177),
  [3806] = {.count = 1, .reusable = true}, SHIFT(2569),
  [3808] = {.count = 1, .reusable = true}, SHIFT(297),
  [3810] = {.count = 1, .reusable = true}, SHIFT(298),
  [3812] = {.count = 1, .reusable = true}, SHIFT(299),
  [3814] = {.count = 1, .reusable = true}, SHIFT(300),
  [3816] = {.count = 1, .reusable = true}, SHIFT(301),
  [3818] = {.count = 1, .reusable = true}, SHIFT(2653),
  [3820] = {.count = 1, .reusable = true}, SHIFT(1178),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3824] = {.count = 1, .reusable = true}, SHIFT(2210),
  [3826] = {.count = 1, .reusable = true}, SHIFT(1012),
  [3828] = {.count = 1, .reusable = true}, REDUCE(sym__simple_formal_parameter, 1),
  [3830] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3832] = {.count = 1, .reusable = true}, SHIFT(2203),
  [3834] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3836] = {.count = 1, .reusable = true}, SHIFT(2555),
  [3838] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3840] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(208),
  [3843] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(2597),
  [3846] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(361),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3851] = {.count = 1, .reusable = true}, SHIFT(2533),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1108),
  [3855] = {.count = 1, .reusable = true}, SHIFT(1126),
  [3857] = {.count = 1, .reusable = true}, SHIFT(2638),
  [3859] = {.count = 1, .reusable = true}, REDUCE(sym_then, 3),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3863] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3865] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameter, 2, .production_id = 6),
  [3867] = {.count = 1, .reusable = true}, SHIFT(2661),
  [3869] = {.count = 1, .reusable = true}, SHIFT(2660),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1384),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1111),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1112),
  [3879] = {.count = 1, .reusable = true}, SHIFT(2651),
  [3881] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2),
  [3883] = {.count = 1, .reusable = true}, SHIFT(2591),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3889] = {.count = 1, .reusable = true}, SHIFT(2667),
  [3891] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 2, .production_id = 6),
  [3893] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 2, .production_id = 6),
  [3895] = {.count = 1, .reusable = true}, SHIFT(2583),
  [3897] = {.count = 1, .reusable = true}, REDUCE(sym__formal_parameter, 1),
  [3899] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 2),
  [3901] = {.count = 1, .reusable = true}, REDUCE(sym__formal_parameter, 1, .production_id = 18),
  [3903] = {.count = 1, .reusable = true}, SHIFT(1125),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1124),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1120),
  [3909] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3911] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3913] = {.count = 1, .reusable = true}, SHIFT(2655),
  [3915] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3917] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3921] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3923] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_contents, 1),
  [3925] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents, 1),
  [3927] = {.count = 1, .reusable = true}, SHIFT(1379),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3931] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3939] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 3, .production_id = 40),
  [3941] = {.count = 1, .reusable = true}, SHIFT(213),
  [3943] = {.count = 2, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2), SHIFT_REPEAT(336),
  [3946] = {.count = 1, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2),
  [3948] = {.count = 1, .reusable = true}, SHIFT(344),
  [3950] = {.count = 1, .reusable = true}, SHIFT(578),
  [3952] = {.count = 1, .reusable = true}, SHIFT(2419),
  [3954] = {.count = 1, .reusable = true}, SHIFT(2416),
  [3956] = {.count = 1, .reusable = false}, SHIFT(215),
  [3958] = {.count = 1, .reusable = true}, SHIFT(2525),
  [3960] = {.count = 1, .reusable = true}, SHIFT(2939),
  [3962] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3964] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2),
  [3966] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2), SHIFT_REPEAT(357),
  [3969] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(2568),
  [3972] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2),
  [3974] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3976] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(866),
  [3979] = {.count = 1, .reusable = true}, SHIFT(2615),
  [3981] = {.count = 1, .reusable = true}, SHIFT(2614),
  [3983] = {.count = 1, .reusable = true}, SHIFT(2511),
  [3985] = {.count = 1, .reusable = true}, SHIFT(2948),
  [3987] = {.count = 1, .reusable = true}, SHIFT(2691),
  [3989] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(215),
  [3992] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(2525),
  [3995] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3997] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3999] = {.count = 1, .reusable = true}, SHIFT(1443),
  [4001] = {.count = 1, .reusable = true}, SHIFT(1186),
  [4003] = {.count = 1, .reusable = true}, SHIFT(2628),
  [4005] = {.count = 1, .reusable = true}, SHIFT(331),
  [4007] = {.count = 1, .reusable = true}, SHIFT(389),
  [4009] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [4011] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [4013] = {.count = 1, .reusable = true}, SHIFT(1460),
  [4015] = {.count = 1, .reusable = true}, SHIFT(1190),
  [4017] = {.count = 1, .reusable = true}, SHIFT(1410),
  [4019] = {.count = 1, .reusable = true}, SHIFT(368),
  [4021] = {.count = 1, .reusable = true}, SHIFT(534),
  [4023] = {.count = 1, .reusable = true}, SHIFT(1413),
  [4025] = {.count = 1, .reusable = true}, SHIFT(1414),
  [4027] = {.count = 1, .reusable = true}, SHIFT(1440),
  [4029] = {.count = 1, .reusable = true}, SHIFT(859),
  [4031] = {.count = 1, .reusable = true}, SHIFT(1477),
  [4033] = {.count = 1, .reusable = true}, SHIFT(1421),
  [4035] = {.count = 1, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 1),
  [4037] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4039] = {.count = 1, .reusable = true}, SHIFT(243),
  [4041] = {.count = 1, .reusable = true}, SHIFT(2765),
  [4043] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 1),
  [4045] = {.count = 1, .reusable = true}, SHIFT(240),
  [4047] = {.count = 1, .reusable = true}, SHIFT(24),
  [4049] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2166),
  [4052] = {.count = 1, .reusable = true}, REDUCE(sym_bare_parameters, 1),
  [4054] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4056] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(283),
  [4059] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 1),
  [4061] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 2, .production_id = 7),
  [4063] = {.count = 1, .reusable = true}, SHIFT(2166),
  [4065] = {.count = 1, .reusable = true}, REDUCE(sym_bare_parameters, 2),
  [4067] = {.count = 1, .reusable = true}, REDUCE(sym_else, 2),
  [4069] = {.count = 1, .reusable = true}, REDUCE(sym_ensure, 2),
  [4071] = {.count = 1, .reusable = true}, SHIFT(245),
  [4073] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_left_assignment, 3),
  [4075] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2168),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1458),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1469),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4084] = {.count = 1, .reusable = true}, SHIFT(238),
  [4086] = {.count = 1, .reusable = true}, SHIFT(2752),
  [4088] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4090] = {.count = 1, .reusable = true}, SHIFT(375),
  [4092] = {.count = 1, .reusable = true}, SHIFT(490),
  [4094] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3, .production_id = 42),
  [4096] = {.count = 1, .reusable = true}, SHIFT(2149),
  [4098] = {.count = 1, .reusable = true}, SHIFT(954),
  [4100] = {.count = 1, .reusable = true}, SHIFT(2806),
  [4102] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3, .production_id = 44),
  [4104] = {.count = 1, .reusable = true}, REDUCE(sym_else, 3, .production_id = 16),
  [4106] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4108] = {.count = 1, .reusable = true}, SHIFT(976),
  [4110] = {.count = 1, .reusable = true}, SHIFT(2864),
  [4112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2165),
  [4115] = {.count = 1, .reusable = true}, SHIFT(25),
  [4117] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 4, .production_id = 56),
  [4119] = {.count = 1, .reusable = true}, SHIFT(2729),
  [4121] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4123] = {.count = 1, .reusable = true}, SHIFT(2724),
  [4125] = {.count = 1, .reusable = true}, SHIFT(315),
  [4127] = {.count = 1, .reusable = true}, SHIFT(2452),
  [4129] = {.count = 1, .reusable = true}, REDUCE(aux_sym_hash_repeat1, 2),
  [4131] = {.count = 2, .reusable = true}, REDUCE(aux_sym_hash_repeat1, 2), SHIFT_REPEAT(322),
  [4134] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2164),
  [4137] = {.count = 1, .reusable = true}, SHIFT(2914),
  [4139] = {.count = 2, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2), SHIFT_REPEAT(2507),
  [4142] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2),
  [4144] = {.count = 1, .reusable = true}, SHIFT(2460),
  [4146] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4148] = {.count = 1, .reusable = true}, SHIFT(2455),
  [4150] = {.count = 1, .reusable = true}, SHIFT(2694),
  [4152] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2), SHIFT_REPEAT(2508),
  [4155] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2),
  [4157] = {.count = 1, .reusable = true}, SHIFT(963),
  [4159] = {.count = 1, .reusable = true}, SHIFT(962),
  [4161] = {.count = 1, .reusable = true}, SHIFT(961),
  [4163] = {.count = 1, .reusable = true}, SHIFT(2456),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1119),
  [4167] = {.count = 1, .reusable = true}, SHIFT(310),
  [4169] = {.count = 1, .reusable = true}, SHIFT(33),
  [4171] = {.count = 1, .reusable = true}, SHIFT(973),
  [4173] = {.count = 1, .reusable = true}, SHIFT(972),
  [4175] = {.count = 1, .reusable = true}, SHIFT(969),
  [4177] = {.count = 1, .reusable = true}, SHIFT(2393),
  [4179] = {.count = 1, .reusable = true}, SHIFT(2408),
  [4181] = {.count = 1, .reusable = true}, SHIFT(953),
  [4183] = {.count = 2, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2), SHIFT_REPEAT(2914),
  [4186] = {.count = 1, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2),
  [4188] = {.count = 1, .reusable = true}, SHIFT(306),
  [4190] = {.count = 1, .reusable = true}, SHIFT(2446),
  [4192] = {.count = 1, .reusable = true}, SHIFT(2675),
  [4194] = {.count = 1, .reusable = true}, SHIFT(2411),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1498),
  [4198] = {.count = 1, .reusable = true}, SHIFT(307),
  [4200] = {.count = 1, .reusable = true}, SHIFT(2430),
  [4202] = {.count = 1, .reusable = true}, REDUCE(sym_when, 4, .production_id = 62),
  [4204] = {.count = 1, .reusable = true}, SHIFT(2389),
  [4206] = {.count = 1, .reusable = true}, SHIFT(2662),
  [4208] = {.count = 1, .reusable = true}, SHIFT(308),
  [4210] = {.count = 1, .reusable = true}, SHIFT(2398),
  [4212] = {.count = 1, .reusable = true}, SHIFT(2426),
  [4214] = {.count = 1, .reusable = true}, SHIFT(955),
  [4216] = {.count = 1, .reusable = true}, SHIFT(2410),
  [4218] = {.count = 1, .reusable = true}, SHIFT(313),
  [4220] = {.count = 1, .reusable = true}, SHIFT(2451),
  [4222] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat2, 1),
  [4224] = {.count = 1, .reusable = true}, REDUCE(sym_when, 3, .production_id = 54),
  [4226] = {.count = 1, .reusable = true}, SHIFT(2542),
  [4228] = {.count = 1, .reusable = true}, SHIFT(254),
  [4230] = {.count = 1, .reusable = true}, SHIFT(2541),
  [4232] = {.count = 1, .reusable = true}, SHIFT(1020),
  [4234] = {.count = 1, .reusable = true}, SHIFT(359),
  [4236] = {.count = 1, .reusable = true}, SHIFT(1570),
  [4238] = {.count = 1, .reusable = true}, SHIFT(252),
  [4240] = {.count = 1, .reusable = true}, SHIFT(1117),
  [4242] = {.count = 1, .reusable = true}, SHIFT(905),
  [4244] = {.count = 1, .reusable = true}, SHIFT(1187),
  [4246] = {.count = 1, .reusable = true}, SHIFT(889),
  [4248] = {.count = 1, .reusable = true}, SHIFT(1017),
  [4250] = {.count = 1, .reusable = true}, SHIFT(441),
  [4252] = {.count = 1, .reusable = true}, SHIFT(1572),
  [4254] = {.count = 1, .reusable = true}, SHIFT(2196),
  [4256] = {.count = 1, .reusable = true}, SHIFT(888),
  [4258] = {.count = 1, .reusable = false}, SHIFT(2565),
  [4260] = {.count = 1, .reusable = true}, SHIFT(327),
  [4262] = {.count = 1, .reusable = true}, SHIFT(2580),
  [4264] = {.count = 1, .reusable = true}, REDUCE(sym_left_assignment_list, 1),
  [4266] = {.count = 1, .reusable = true}, SHIFT(1576),
  [4268] = {.count = 1, .reusable = true}, SHIFT(319),
  [4270] = {.count = 1, .reusable = true}, SHIFT(898),
  [4272] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4274] = {.count = 1, .reusable = true}, SHIFT(289),
  [4276] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [4278] = {.count = 1, .reusable = true}, SHIFT(2888),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1545),
  [4282] = {.count = 1, .reusable = true}, SHIFT(321),
  [4284] = {.count = 1, .reusable = true}, SHIFT(334),
  [4286] = {.count = 1, .reusable = true}, SHIFT(2174),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1568),
  [4290] = {.count = 1, .reusable = true}, SHIFT(1574),
  [4292] = {.count = 1, .reusable = true}, SHIFT(2490),
  [4294] = {.count = 1, .reusable = true}, SHIFT(271),
  [4296] = {.count = 1, .reusable = true}, SHIFT(2543),
  [4298] = {.count = 1, .reusable = true}, SHIFT(2190),
  [4300] = {.count = 1, .reusable = true}, SHIFT(317),
  [4302] = {.count = 1, .reusable = true}, SHIFT(1569),
  [4304] = {.count = 1, .reusable = true}, SHIFT(1161),
  [4306] = {.count = 1, .reusable = true}, SHIFT(223),
  [4308] = {.count = 1, .reusable = true}, SHIFT(353),
  [4310] = {.count = 1, .reusable = true}, SHIFT(1042),
  [4312] = {.count = 1, .reusable = true}, SHIFT(2645),
  [4314] = {.count = 1, .reusable = true}, SHIFT(2279),
  [4316] = {.count = 1, .reusable = true}, SHIFT(351),
  [4318] = {.count = 1, .reusable = true}, SHIFT(1132),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1143),
  [4322] = {.count = 1, .reusable = true}, SHIFT(2886),
  [4324] = {.count = 1, .reusable = true}, SHIFT(1153),
  [4326] = {.count = 1, .reusable = true}, SHIFT(1154),
  [4328] = {.count = 1, .reusable = true}, SHIFT(2573),
  [4330] = {.count = 1, .reusable = true}, SHIFT(318),
  [4332] = {.count = 1, .reusable = true}, SHIFT(2647),
  [4334] = {.count = 1, .reusable = true}, SHIFT(2689),
  [4336] = {.count = 1, .reusable = true}, SHIFT(218),
  [4338] = {.count = 1, .reusable = true}, SHIFT(1591),
  [4340] = {.count = 1, .reusable = true}, SHIFT(341),
  [4342] = {.count = 1, .reusable = true}, SHIFT(339),
  [4344] = {.count = 1, .reusable = true}, SHIFT(2687),
  [4346] = {.count = 1, .reusable = true}, SHIFT(2684),
  [4348] = {.count = 1, .reusable = true}, SHIFT(2682),
  [4350] = {.count = 1, .reusable = true}, SHIFT(1463),
  [4352] = {.count = 1, .reusable = true}, SHIFT(195),
  [4354] = {.count = 1, .reusable = true}, SHIFT(345),
  [4356] = {.count = 1, .reusable = true}, SHIFT(2648),
  [4358] = {.count = 1, .reusable = true}, SHIFT(188),
  [4360] = {.count = 1, .reusable = true}, SHIFT(338),
  [4362] = {.count = 1, .reusable = true}, SHIFT(332),
  [4364] = {.count = 1, .reusable = true}, SHIFT(803),
  [4366] = {.count = 1, .reusable = true}, SHIFT(2218),
  [4368] = {.count = 1, .reusable = true}, SHIFT(2735),
  [4370] = {.count = 1, .reusable = true}, SHIFT(328),
  [4372] = {.count = 1, .reusable = true}, SHIFT(256),
  [4374] = {.count = 1, .reusable = true}, SHIFT(1394),
  [4376] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [4378] = {.count = 1, .reusable = true}, SHIFT(2723),
  [4380] = {.count = 1, .reusable = true}, SHIFT(1039),
  [4382] = {.count = 1, .reusable = true}, SHIFT(926),
  [4384] = {.count = 1, .reusable = true}, SHIFT(220),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1528),
  [4388] = {.count = 1, .reusable = true}, SHIFT(343),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1114),
  [4392] = {.count = 1, .reusable = true}, SHIFT(2837),
  [4394] = {.count = 1, .reusable = true}, SHIFT(1501),
  [4396] = {.count = 1, .reusable = true}, SHIFT(219),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1506),
  [4400] = {.count = 1, .reusable = true}, REDUCE(sym_program, 4),
  [4402] = {.count = 1, .reusable = true}, SHIFT(2563),
  [4404] = {.count = 1, .reusable = true}, SHIFT(348),
  [4406] = {.count = 1, .reusable = true}, SHIFT(350),
  [4408] = {.count = 1, .reusable = true}, SHIFT(2197),
  [4410] = {.count = 1, .reusable = true}, SHIFT(221),
  [4412] = {.count = 1, .reusable = true}, SHIFT(294),
  [4414] = {.count = 1, .reusable = true}, SHIFT(2664),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1109),
  [4418] = {.count = 1, .reusable = true}, SHIFT(333),
  [4420] = {.count = 1, .reusable = true}, SHIFT(904),
  [4422] = {.count = 1, .reusable = true}, SHIFT(892),
  [4424] = {.count = 1, .reusable = true}, SHIFT(2666),
  [4426] = {.count = 1, .reusable = true}, SHIFT(1105),
  [4428] = {.count = 1, .reusable = true}, SHIFT(1068),
  [4430] = {.count = 1, .reusable = true}, SHIFT(2298),
  [4432] = {.count = 1, .reusable = true}, SHIFT(1058),
  [4434] = {.count = 1, .reusable = true}, SHIFT(1579),
  [4436] = {.count = 1, .reusable = true}, SHIFT(2643),
  [4438] = {.count = 1, .reusable = true}, SHIFT(1182),
  [4440] = {.count = 1, .reusable = true}, SHIFT(2673),
  [4442] = {.count = 1, .reusable = true}, SHIFT(1107),
  [4444] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4446] = {.count = 1, .reusable = true}, SHIFT(436),
  [4448] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4450] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [4452] = {.count = 1, .reusable = true}, SHIFT(1016),
  [4454] = {.count = 1, .reusable = true}, SHIFT(2360),
  [4456] = {.count = 1, .reusable = true}, SHIFT(2571),
  [4458] = {.count = 1, .reusable = true}, SHIFT(2646),
  [4460] = {.count = 1, .reusable = true}, SHIFT(925),
  [4462] = {.count = 1, .reusable = true}, SHIFT(1208),
  [4464] = {.count = 1, .reusable = true}, SHIFT(432),
  [4466] = {.count = 1, .reusable = true}, SHIFT(1142),
  [4468] = {.count = 1, .reusable = true}, SHIFT(2582),
  [4470] = {.count = 1, .reusable = true}, SHIFT(784),
  [4472] = {.count = 1, .reusable = true}, SHIFT(1424),
  [4474] = {.count = 1, .reusable = true}, SHIFT(337),
  [4476] = {.count = 1, .reusable = true}, SHIFT(2872),
  [4478] = {.count = 1, .reusable = true}, SHIFT(1476),
  [4480] = {.count = 1, .reusable = true}, SHIFT(2833),
  [4482] = {.count = 1, .reusable = true}, SHIFT(1094),
  [4484] = {.count = 1, .reusable = true}, SHIFT(346),
  [4486] = {.count = 1, .reusable = true}, SHIFT(2450),
  [4488] = {.count = 1, .reusable = true}, SHIFT(335),
  [4490] = {.count = 1, .reusable = true}, SHIFT(354),
  [4492] = {.count = 1, .reusable = true}, SHIFT(340),
  [4494] = {.count = 1, .reusable = true}, SHIFT(222),
  [4496] = {.count = 1, .reusable = true}, SHIFT(1395),
  [4498] = {.count = 1, .reusable = true}, SHIFT(1116),
  [4500] = {.count = 1, .reusable = true}, SHIFT(1565),
  [4502] = {.count = 1, .reusable = true}, SHIFT(1567),
  [4504] = {.count = 1, .reusable = true}, SHIFT(355),
  [4506] = {.count = 1, .reusable = true}, SHIFT(2695),
  [4508] = {.count = 1, .reusable = true}, SHIFT(1101),
  [4510] = {.count = 1, .reusable = true}, SHIFT(1511),
  [4512] = {.count = 1, .reusable = true}, SHIFT(1508),
  [4514] = {.count = 1, .reusable = true}, SHIFT(342),
  [4516] = {.count = 1, .reusable = true}, SHIFT(916),
  [4518] = {.count = 1, .reusable = true}, SHIFT(1418),
  [4520] = {.count = 1, .reusable = true}, SHIFT(2751),
  [4522] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2698),
  [4526] = {.count = 1, .reusable = true}, SHIFT(994),
  [4528] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 4, .production_id = 52),
  [4530] = {.count = 1, .reusable = true}, SHIFT(996),
  [4532] = {.count = 1, .reusable = true}, SHIFT(946),
  [4534] = {.count = 1, .reusable = true}, SHIFT(1205),
  [4536] = {.count = 1, .reusable = true}, SHIFT(1527),
  [4538] = {.count = 1, .reusable = true}, SHIFT(199),
  [4540] = {.count = 1, .reusable = true}, SHIFT(2226),
  [4542] = {.count = 1, .reusable = true}, SHIFT(804),
  [4544] = {.count = 1, .reusable = true}, SHIFT(414),
  [4546] = {.count = 1, .reusable = true}, SHIFT(1033),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1404),
  [4550] = {.count = 1, .reusable = true}, SHIFT(1060),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1411),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1433),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1537),
  [4558] = {.count = 1, .reusable = true}, SHIFT(997),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1428),
  [4562] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [4564] = {.count = 1, .reusable = true}, SHIFT(197),
  [4566] = {.count = 1, .reusable = true}, SHIFT(1429),
  [4568] = {.count = 1, .reusable = true}, SHIFT(248),
  [4570] = {.count = 1, .reusable = true}, SHIFT(374),
  [4572] = {.count = 1, .reusable = true}, SHIFT(379),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1407),
  [4576] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [4578] = {.count = 1, .reusable = true}, SHIFT(1078),
  [4580] = {.count = 1, .reusable = true}, SHIFT(362),
  [4582] = {.count = 1, .reusable = true}, SHIFT(1515),
  [4584] = {.count = 1, .reusable = true}, SHIFT(2537),
  [4586] = {.count = 1, .reusable = true}, SHIFT(373),
  [4588] = {.count = 1, .reusable = true}, SHIFT(234),
  [4590] = {.count = 1, .reusable = true}, SHIFT(1502),
  [4592] = {.count = 1, .reusable = true}, SHIFT(2540),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1541),
  [4596] = {.count = 1, .reusable = true}, SHIFT(366),
  [4598] = {.count = 1, .reusable = true}, SHIFT(1496),
  [4600] = {.count = 1, .reusable = true}, SHIFT(1048),
  [4602] = {.count = 1, .reusable = true}, SHIFT(1431),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1043),
};

void *tree_sitter_ruby_external_scanner_create(void);
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ruby(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
  };
  return &language;
}
